package com.wgmf.yxgj.module.bussiness.customtask.model

import com.wgmf.library.base.BaseResponse
import java.io.Serializable

/**
 *查询任务详情
 */
data class QueryCustomTaskDetailsEntity(val payload: CustomTaskDetailsPage) : BaseResponse() {

    data class CustomTaskDetailsPage(
        val data: List<CustomTaskDetailsBean>?,
        val page: Int,
        val pages: Int,
        val size: Int,
        val total: Int
    ) {
        data class CustomTaskDetailsBean(
            val id: Int, //任务id
            val taskName: String?, //任务名称
            val staffId: String?, //创建人工号
            val staffName: String?, //创建人名称
            val saleStartDate: String?, //查询销售开始时间
            val saleEndDate: String?, //	查询销售结束时间
            val areaId: Int?,   //大区id
            val officeId: Int?,  //	办事处id
            val shopIds: String?, //	门店id
            val areaOrShop: String?, //区域/办事处/门店
            val grade: String?, //会员等级：0-预备会员;1-谷谷卡;2-银谷卡;3-金谷卡;4-钻谷卡
            val cusType: Int?,  //会员类型：0-新会员; 1-老会员
            val orderType: String?, //	客单价:0-168(含)以上; 1-80-168; 2-80以下
            val consTimes: Int?,  //	消费(含)多少次数以上
            val overdue: Int?,  //	积分过期(含)多少天过期
            val usablePoints: Int?, //积分(含)多少可用
            val prodCodes: String?,  //产品列表，逗号隔开
            val activityIds: String?,  //参与促销活动，逗号隔开
            var taskState: Int, //	状态：0-待开始 1-进行中 2-已结束 3-已删除
            val careStartDate: String?, //回访开始时间
            val careEndDate: String?, //	回访结束时间
            val createDate: String?, //	创建时间
            val taskCustomerCount: Int?, //任务涉及人数
            val orderMin: String?, //客单价 最小值
            val orderMax: String?, //客单价 最大值
            val labelInfoIds: String?, //标签表主键ids集合，用逗号隔开（注意:与表内的label_id不一致）
            val notBoughtDay: Int?,  //间隔多少天未回头
            val marketId: Int, //商超系统
            val designatedShopId: String?, //	指定下放门店
            val referentialSpeechBean: ReferentialSpeechBean?  //参考话术
        ) : Serializable {
            data class ReferentialSpeechBean(
                val referentialSpeechContext: String?,  //	参考话术文本内容
                val activityId: Int,     //活动id
                val activityName: String?   //活动名称
            ) : Serializable
        }
    }
}