package com.wgmf.yxgj.module.bussiness.customtask.ui

import android.content.Intent
import android.os.Bundle
import android.support.v4.content.ContextCompat
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.*
import com.google.gson.Gson
import com.wgmf.library.base.ResultData
import com.wgmf.library.utils.DateUtil
import com.wgmf.yxgj.base.BaseParentAct
import com.wgmf.yxgj.config.BusinessID
import com.wgmf.yxgj.dialog.PublicSelectBottomDialog
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.bussiness.customtask.R
import com.wgmf.yxgj.module.bussiness.customtask.model.*
import com.wgmf.yxgj.module.bussiness.customtask.service.CustomTaskService
import com.wgmf.yxgj.module.bussiness.customtask.ui.adapter.OfficeInfoByOrgAndMarketListAdapter
import com.wgmf.yxgj.module.bussiness.customtask.ui.adapter.ProductOfflineListAdapter
import com.wgmf.yxgj.module.bussiness.customtask.ui.adapter.ShopInfoByOrgAndMarketListAdapter
import com.wgmf.yxgj.module.bussiness.customtask.ui.adapter.SuperMarketListAdapter
import com.wgmf.yxgj.module.bussiness.customtask.ui.view.ItemOptionLayout
import com.wgmf.yxgj.utils.MyToast
import com.wgmf.yxgj.utils.helper.DialogHelper
import com.wgmf.yxgj.utils.isNotNullOrSize
import com.wgmf.yxgj.utils.isNullOrEmpty
import com.wgmf.yxgj.utils.notNullAndEmpty
import com.wgmf.yxgj.widgets.decoration.DividerItemDecoration
import com.wgmf.yxgj.widgets.flowlayout.FlowLayout
import com.wgmf.yxgj.widgets.flowlayout.TagAdapter
import com.wgmf.yxgj.widgets.flowlayout.TagFlowLayout
import com.wgmf.yxgj.widgets.flowlayout.TagView
import xp.timepicker.com.widget.bean.DateType

/**
 *  自定义任务: 创建自定义任务
 * @author LW
 */
class CreateCustomTaskActivity : BaseParentAct() {

    private var mLastPurchaseTimeCard: ViewGroup? = null
    private var mLastPurchaseTimeChooseCb: CheckBox? = null
    private var mLastPurchaseTimeStartTimeEt: EditText? = null
    private var mLastPurchaseTimeEndTimeEt: EditText? = null

    private var mSuperSystemCard: ViewGroup? = null
    private var mSuperSystemChooseCb: CheckBox? = null
    private var mSuperSystemChooseSystemTv: TextView? = null

    private var mLastPurchaseStoreCard: ViewGroup? = null
    private var mLastPurchaseStoreChoseCb: CheckBox? = null
    private var mChooseOfficesLl: LinearLayout? = null
    private var mChooseStoreLl: LinearLayout? = null
    private var mChooseStoreAllStoreRb: RadioButton? = null
    private var mChooseStoreStoreRb: RadioButton? = null
    private var mChooseOfficesOptionLayout: ItemOptionLayout? = null
    private var mChooseStoreOptionLayout: ItemOptionLayout? = null

    private var mMemberRatingCard: ViewGroup? = null
    private var mMemberRatingChooseCb: CheckBox? = null
    private var mMemberRatingFlowChooseFl: TagFlowLayout? = null

    private var mNewAndOldMembersCard: ViewGroup? = null
    private var mNewAndOldMembersChooseCb: CheckBox? = null
    private var mNewAndOldMembersFlowChooseFl: TagFlowLayout? = null

    private var mCustomTaskAllLabelContainerLl: LinearLayout? = null

    private var mMemberUnitPriceCard: ViewGroup? = null
    private var mMemberUnitPriceChooseCb: CheckBox? = null
    private var mMemberUnitPriceStartEd: EditText? = null
    private var mMemberUnitPriceEndEd: EditText? = null

    private var mNoReturnIntervalCard: ViewGroup? = null
    private var mNoReturnIntervalChooseCb: CheckBox? = null
    private var mNoReturnIntervalEt: EditText? = null

    private var mConsumptionTimesCard: ViewGroup? = null
    private var mConsumptionTimesChooseCb: CheckBox? = null
    private var mConsumptionTimesEt: EditText? = null

    private var mPointsExpiredCard: ViewGroup? = null
    private var mPointsExpiredChooseCb: CheckBox? = null
    private var mPointsExpiredEt: EditText? = null

    private var mRemainingPointsCard: ViewGroup? = null
    private var mRemainingPointsChooseCb: CheckBox? = null
    private var mRemainingPointsEt: EditText? = null

    private var mBugProductCard: ViewGroup? = null
    private var mBugProductChooseCb: CheckBox? = null
    private var mBugProductChooseBugProductLl: LinearLayout? = null
    private var mChooseProductOptionLayout: ItemOptionLayout? = null

    private var mParticipatePromotionsCard: ViewGroup? = null
    private var mParticipatePromotionsChooseCb: CheckBox? = null
    private var mParticipatePromotionsEt: EditText? = null

    /**
     * 商超选择Id
     */
    private var mSuperSystemChooseId: Int = -1;

    /**
     * 办事处选择Id
     */
    private var mOfficeChooseId: String? = null

    /**
     * 选择门店
     */
    private var mStoreChooseList: MutableList<String> = mutableListOf()

    /**
     * 选择购买产品
     */
    private var mBugProductList: MutableList<String> = mutableListOf()

    /**
     * 线下产品
     */
    private var mProductOfflineList: MutableList<ProductOfflineEntity.ProductOfflineBean> =
        mutableListOf()

    /**
     * 商超
     */
    private var mSuperMarketList: MutableList<SuperMarketEntity.SuperMarketBean> =
        mutableListOf()

    /**
     * 办事处
     */
    private var mOfficeInfoByOrgAndMarketList: List<ShopSalesOrgEntity.ShopSalesOrgBean.OrgBean> =
        listOf()

    /**
     * 门店
     */
    private var mShopInfoByOrgAndMarketList: List<ShopSalesOrgEntity.ShopSalesOrgBean.OrgBean> =
        listOf()

    /**
     * 会员层级标签
     */
    private val mMemberRatingLabelList: MutableList<LabelInfoEntity.LabelInfoBean.LabelBean> =
        mutableListOf()

    /**
     * 新老会员标签
     */
    private val mNewOrOldMemberLabelList: MutableList<LabelInfoEntity.LabelInfoBean.LabelBean> =
        mutableListOf()

    /**
     * 所有标签数据
     */
    private var mLabelInfoList: List<LabelInfoEntity.LabelInfoBean> = listOf()

    private var mCreateCustomTaskBean: CreateCustomTaskBean? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_create_custom_task)
        initTitle()
        initData()
        initView()
    }

    override fun initTitle() {
        super.initTitle()
        homeTitleText.text = getString(R.string.custom_task_create_task)
        homeTitleBackLl.visibility = View.VISIBLE
    }

    private fun initData() {
        mMemberRatingLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(4, "钻谷卡"))
        mMemberRatingLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(3, "金谷卡"))
        mMemberRatingLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(2, "银谷卡"))
        mMemberRatingLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(1, "谷谷卡"))
        mMemberRatingLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(0, "预备会员"))

        mNewOrOldMemberLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(0, "新会员"))
        mNewOrOldMemberLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(1, "老会员"))
    }


    private fun initView() {
        //上次购买时间
        mLastPurchaseTimeCard = findViewById(R.id.custom_task_last_purchase_time_card)
        mLastPurchaseTimeChooseCb =
            mLastPurchaseTimeCard?.findViewById(R.id.custom_task_item_choose_cb)
        mLastPurchaseTimeStartTimeEt =
            mLastPurchaseTimeCard?.findViewById<EditText>(R.id.custom_task_item_start_time_et)
                ?.apply {
                    setText(
                        DateUtil.format(DateUtil.getCurrentFirstDayDate(), DateUtil.FORMATTIME)
                    )
                    setOnClickListener {
                        DialogHelper.showDatePickDialog(
                            this@CreateCustomTaskActivity,
                            DateType.TYPE_YMDHM,
                            this
                        )
                    }
                }

        mLastPurchaseTimeEndTimeEt =
            mLastPurchaseTimeCard?.findViewById<EditText>(R.id.custom_task_item_end_time_et)
                ?.apply {
                    setText(DateUtil.getFormatCurrentDate(DateUtil.FORMATTIME))
                    setOnClickListener {
                        DialogHelper.showDatePickDialog(
                            this@CreateCustomTaskActivity,
                            DateType.TYPE_YMDHM,
                            this
                        )
                    }
                }

        //商超系统
        mSuperSystemCard = findViewById(R.id.custom_task_super_system_card)
        mSuperSystemChooseCb = mSuperSystemCard?.findViewById(R.id.custom_task_item_choose_cb)
        mSuperSystemCard?.findViewById<RelativeLayout>(R.id.custom_task_item_choose_system_rl)
            ?.setOnClickListener {
                showSuperMarketDialog()
            }
        mSuperSystemChooseSystemTv =
            mSuperSystemCard?.findViewById(R.id.custom_task_item_choose_system_tv)

        //上次购买门店
        mLastPurchaseStoreCard = findViewById(R.id.custom_task_last_purchase_store_card)
        mLastPurchaseStoreChoseCb =
            mLastPurchaseStoreCard?.findViewById(R.id.custom_task_item_choose_cb)
        mLastPurchaseStoreCard?.findViewById<RadioButton>(R.id.custom_task_item_all_offices_rb)
            ?.setOnClickListener {
                mOfficeChooseId = null
                mChooseOfficesOptionLayout?.reset()

                mChooseStoreAllStoreRb?.performClick()

                queryShopInfoByOrgAndMarket(null)
            }
        mLastPurchaseStoreCard?.findViewById<RadioButton>(R.id.custom_task_item_choose_offices_rb)
            ?.setOnClickListener {
                mChooseStoreAllStoreRb?.performClick()

                showSingleOfficeseDialog()
            }
        mChooseOfficesLl =
            mLastPurchaseStoreCard?.findViewById(R.id.custom_task_item_choose_offices_ll)
        if (mChooseOfficesLl != null) {
            mChooseOfficesOptionLayout = ItemOptionLayout(mContext, mChooseOfficesLl!!)
        }

        mChooseStoreAllStoreRb =
            mLastPurchaseStoreCard?.findViewById<RadioButton>(R.id.custom_task_item_all_store_rb)
                ?.apply {
                    setOnClickListener {
                        for (storeId in mStoreChooseList) {
                            mShopInfoByOrgAndMarketList.forEach {
                                if (it.orgId == storeId) {
                                    it.isCheck = false
                                    return@forEach
                                }
                            }
                        }
                        mStoreChooseList.clear()
                        mChooseStoreOptionLayout?.reset()
                    }
                }

        mChooseStoreStoreRb =
            mLastPurchaseStoreCard?.findViewById<RadioButton>(R.id.custom_task_item_choose_store_rb)
                ?.apply {
                    setOnClickListener {
                        showMultipleStoreDialog()
                    }
                }
        mChooseStoreLl =
            mLastPurchaseStoreCard?.findViewById(R.id.custom_task_item_choose_store_ll)
        if (mChooseStoreLl != null) {
            mChooseStoreOptionLayout = ItemOptionLayout(mContext, mChooseStoreLl!!, false)
        }

        //会员等级、新老会员、用户特征、购买用途、养生功效
        mMemberRatingCard = findViewById(R.id.custom_task_member_rating_card)
        mMemberRatingChooseCb = mMemberRatingCard?.findViewById(R.id.custom_task_item_choose_cb)
        mMemberRatingCard?.findViewById<TextView>(R.id.custom_task_item_label_title_tv)?.text =
            getString(R.string.custom_task_member_rating)
        mMemberRatingFlowChooseFl =
            mMemberRatingCard?.findViewById(R.id.custom_task_item_label_data_fl)

        setFlowViewData(mMemberRatingFlowChooseFl, mMemberRatingLabelList)
        setFlowViewListener(mMemberRatingFlowChooseFl, mMemberRatingLabelList)

        mNewAndOldMembersCard = findViewById(R.id.custom_task_new_and_old_members_card)
        mNewAndOldMembersChooseCb =
            mNewAndOldMembersCard?.findViewById(R.id.custom_task_item_choose_cb)
        mNewAndOldMembersCard?.findViewById<TextView>(R.id.custom_task_item_label_title_tv)?.text =
            getString(R.string.custom_task_new_or_old_member)
        mNewAndOldMembersFlowChooseFl =
            mNewAndOldMembersCard?.findViewById(R.id.custom_task_item_label_data_fl)

        setFlowViewData(mNewAndOldMembersFlowChooseFl, mNewOrOldMemberLabelList)
        setFlowViewListener(mNewAndOldMembersFlowChooseFl, mNewOrOldMemberLabelList, true)

        mCustomTaskAllLabelContainerLl = findViewById(R.id.custom_task_all_label_container_ll)

        //会员单价
        mMemberUnitPriceCard = findViewById(R.id.custom_task_member_unit_price_card)
        mMemberUnitPriceChooseCb =
            mMemberUnitPriceCard?.findViewById(R.id.custom_task_item_choose_cb)
        mMemberUnitPriceStartEd =
            mMemberUnitPriceCard?.findViewById(R.id.custom_task_item_price_start_et)
        mMemberUnitPriceEndEd =
            mMemberUnitPriceCard?.findViewById(R.id.custom_task_item_price_end_et)

        //未回头间隔
        mNoReturnIntervalCard = findViewById(R.id.custom_task_no_return_interval_card)
        mNoReturnIntervalChooseCb =
            mNoReturnIntervalCard?.findViewById(R.id.custom_task_item_choose_cb)
        mNoReturnIntervalEt =
            mNoReturnIntervalCard?.findViewById(R.id.custom_task_item_no_return_interval_et)

        //消费次数
        mConsumptionTimesCard = findViewById(R.id.custom_task_consumption_times_card)
        mConsumptionTimesChooseCb =
            mConsumptionTimesCard?.findViewById(R.id.custom_task_item_choose_cb)
        mConsumptionTimesEt =
            mConsumptionTimesCard?.findViewById(R.id.custom_task_item_consumption_times_et)

        //积分过期
        mPointsExpiredCard = findViewById(R.id.custom_task_points_expired_card)
        mPointsExpiredChooseCb =
            mPointsExpiredCard?.findViewById(R.id.custom_task_item_choose_cb)
        mPointsExpiredEt =
            mPointsExpiredCard?.findViewById(R.id.custom_task_item_points_expired_et)

        //剩余积分
        mRemainingPointsCard = findViewById(R.id.custom_task_remaining_points_card)
        mRemainingPointsChooseCb =
            mRemainingPointsCard?.findViewById(R.id.custom_task_item_choose_cb)
        mRemainingPointsEt =
            mRemainingPointsCard?.findViewById(R.id.custom_task_item_remaining_points_et)

        //购买产品
        mBugProductCard = findViewById(R.id.custom_task_bug_product_card)
        mBugProductChooseCb = mBugProductCard?.findViewById(R.id.custom_task_item_choose_cb)
        mBugProductCard?.findViewById<RelativeLayout>(R.id.custom_task_item_choose_system_rl)
            ?.setOnClickListener {
                showBugProductDialog()
            }
        mBugProductChooseBugProductLl =
            mBugProductCard?.findViewById(R.id.custom_task_item_choose_bug_product_ll)
        if (mBugProductChooseBugProductLl != null) {
            mChooseProductOptionLayout =
                ItemOptionLayout(mContext, mBugProductChooseBugProductLl!!, false)
        }
        //参与促销活动
        mParticipatePromotionsCard = findViewById(R.id.custom_task_participate_promotions_card)
        mParticipatePromotionsChooseCb =
            mParticipatePromotionsCard?.findViewById(R.id.custom_task_item_choose_cb)
        mParticipatePromotionsEt =
            mParticipatePromotionsCard?.findViewById(R.id.custom_task_item_participate_promotions_et)

        findViewById<Button>(R.id.custom_task_confirm_btn).apply {
            setOnClickListener {
                clickConfirmLogic()
            }
        }

        queryAllMarkData()
    }

    /**
     * 点击确定逻辑处理
     */
    private fun clickConfirmLogic() {
        var chooseCount = 0
        mCreateCustomTaskBean = CreateCustomTaskBean()
        mCreateCustomTaskBean?.apply {
            userInfo.let {
                staffId = it.staffId
                areaId = it.regionId
            }

            //上次购买时间
            if (mLastPurchaseTimeChooseCb?.isChecked == true) {
                chooseCount += 1
                val startTime = mLastPurchaseTimeStartTimeEt?.text?.toString()
                if (startTime.notNullAndEmpty()) {
                    saleStartDate = "$startTime:59"
                } else {
                    MyToast.show(mContext.getString(R.string.custom_task_start_time_tip))
                    return
                }
                val endTime = mLastPurchaseTimeEndTimeEt?.text?.toString()
                if (endTime.notNullAndEmpty()) {
                    saleEndDate = "$endTime:59"
                } else {
                    MyToast.show(mContext.getString(R.string.custom_task_end_time_tip))
                    return
                }
            }

            //商超系统
            if (mSuperSystemChooseCb?.isChecked == true) {
                chooseCount += 1
                partnerId = mSuperSystemChooseId
            }

            //上次购买门店
            if (mLastPurchaseStoreChoseCb?.isChecked == true) {
                chooseCount += 1
                if (mOfficeChooseId.notNullAndEmpty()) {
                    officeId = mOfficeChooseId
                }
                if (listOf(mStoreChooseList).isNotNullOrSize()) {
                    shopIdList = mStoreChooseList.toList()
                }
            }

            val gradeList: MutableList<Int> = mutableListOf()
            //会员等级
            if (mMemberRatingChooseCb?.isChecked == true) {
                chooseCount += 1
                mMemberRatingLabelList.forEach {
                    if (it.isSelected) {
                        gradeList.add(it.labelId)
                    }

                }
                if (gradeList.isNotNullOrSize()) {
                    cusGradeList = gradeList
                } else {
                    MyToast.show(mContext.getString(R.string.custom_task_member_rating_tip))
                    return
                }
            }

            //新老会员
            if (mNewAndOldMembersChooseCb?.isChecked == true) {
                chooseCount += 1
                mNewOrOldMemberLabelList.forEach {
                    if (it.isSelected) {
                        cusType = it.labelId
                        return@forEach
                    }

                }
                if (cusType != null && cusType!! < 0) {
                    MyToast.show(mContext.getString(R.string.custom_task_new_or_old_member_tip))
                    return
                }
            }

            //用户画像
            val labelList: MutableList<Int> = mutableListOf()
            var isCheckedLabel = false
            for (index in 0..(mCustomTaskAllLabelContainerLl?.childCount ?: 0)) {
                val view = mCustomTaskAllLabelContainerLl?.getChildAt(index)
                view?.let {
                    if (it.tag != null) {
                        val labelInfoBean = it.tag as LabelInfoEntity.LabelInfoBean
                        if (labelInfoBean.isChecked) {
                            chooseCount += 1
                            isCheckedLabel = true
                            labelInfoBean.labels?.forEach {
                                if (it.isSelected) {
                                    labelList.add(it.id)
                                }
                            }
                        }
                    }
                }
            }
            if (isCheckedLabel) {
                if (labelList.isNotNullOrSize()) {
                    labelInfoIdList = labelList
                } else {
                    MyToast.show(mContext.getString(R.string.custom_task_label_tip))
                    return
                }
            }

            //会员单价
            if (mMemberUnitPriceChooseCb?.isChecked == true) {
                chooseCount += 1
                orderMin = mMemberUnitPriceStartEd?.text?.trim().toString()
                orderMax = mMemberUnitPriceEndEd?.text?.trim().toString()

                if (orderMin.isNullOrEmpty() || orderMax.isNullOrEmpty()) {
                    MyToast.show(mContext.getString(R.string.custom_task_member_unit_price_tip))
                    return
                }
            }

            //未回头间隔
            if (mNoReturnIntervalChooseCb?.isChecked == true) {
                chooseCount += 1
                notBoughtDay = mNoReturnIntervalEt?.text?.trim().toString()

                if (notBoughtDay.isNullOrEmpty()) {
                    MyToast.show(mContext.getString(R.string.custom_task_no_return_interval_tip))
                    return
                }
            }

            //消费次数
            if (mConsumptionTimesChooseCb?.isChecked == true) {
                chooseCount += 1
                consTimes = mConsumptionTimesEt?.text?.trim().toString()

                if (consTimes.isNullOrEmpty()) {
                    MyToast.show(mContext.getString(R.string.custom_task_consumption_times_tip))
                    return
                }
            }

            //积分过期
            if (mPointsExpiredChooseCb?.isChecked == true) {
                chooseCount += 1
                overdue = mPointsExpiredEt?.text?.trim().toString()

                if (overdue.isNullOrEmpty()) {
                    MyToast.show(mContext.getString(R.string.custom_task_points_expired_tip))
                    return
                }
            }

            //剩余积分
            if (mRemainingPointsChooseCb?.isChecked == true) {
                chooseCount += 1
                usablePoints = mRemainingPointsEt?.text?.trim().toString()

                if (usablePoints.isNullOrEmpty()) {
                    MyToast.show(mContext.getString(R.string.custom_task_remaining_points_tip))
                    return
                }
            }

            //购买产品
            if (mBugProductChooseCb?.isChecked == true) {
                chooseCount += 1
                prodCodeList = mBugProductList

                if (prodCodeList.isNullOrEmpty()) {
                    MyToast.show(mContext.getString(R.string.custom_task_bug_product_tip))
                    return
                }
            }

            //参与促销活动
            if (mParticipatePromotionsChooseCb?.isChecked == true) {
                chooseCount += 1
                activityIdList = mParticipatePromotionsEt?.text?.trim().toString().split(",")
                if (activityIdList.isNullOrEmpty()) {
                    MyToast.show(mContext.getString(R.string.custom_task_participate_promotions_tip))
                    return
                }
            }

            if (chooseCount == 0) {
                MyToast.show(mContext.getString(R.string.custom_task_choose_number_tip))
                return
            }
        }

        querySatisfyCustomTaskCount()
    }

    /**
     * 显示底部商超列表选择框(单选、多选列表)
     */
    private fun showSuperMarketDialog() {
        val builder = PublicSelectBottomDialog.Companion.Builder(this)
        builder.isDataEntry(mSuperMarketList.isNullOrEmpty())
        builder.setTitle(R.string.custom_task_dialog_choose_super_title)
        builder.setDialogListLoadDataListener(object :
            PublicSelectBottomDialog.OnDialogListLoadDataListener {
            override fun onListLoadData(dialog: PublicSelectBottomDialog, list: RecyclerView) {
                val superMarketListAdapter = SuperMarketListAdapter(mSuperMarketList)
                list.apply {
                    visibility = View.VISIBLE
                    layoutManager = LinearLayoutManager(mContext)
                    adapter = superMarketListAdapter
                    addItemDecoration(
                        DividerItemDecoration(
                            DividerItemDecoration.HORIZONTAL_LIST,
                            1,
                            ContextCompat.getColor(mContext, R.color.divider_line_deep)
                        )
                    )
                }
                superMarketListAdapter.setOnItemClickListener { baseQuickAdapter, view, position ->
                    val item =
                        baseQuickAdapter.getItem(position) as SuperMarketEntity.SuperMarketBean
                    mSuperSystemChooseId = item.id
                    mSuperSystemChooseSystemTv?.text = item.name

                    dialog.dismiss()
                }
            }
        })
        builder.create().show()
    }

    /**
     * 显示底部办事处列表选择框(单选、多选列表)
     */
    private fun showSingleOfficeseDialog() {
        val builder = PublicSelectBottomDialog.Companion.Builder(this)
        builder.isDataEntry(mOfficeInfoByOrgAndMarketList.isNullOrEmpty())
        builder.setTitle(R.string.custom_task_dialog_choose_offices_title)
        builder.setDialogListLoadDataListener(object :
            PublicSelectBottomDialog.OnDialogListLoadDataListener {
            override fun onListLoadData(dialog: PublicSelectBottomDialog, list: RecyclerView) {
                val officeInfoByOrgAndMarketListAdapter =
                    OfficeInfoByOrgAndMarketListAdapter(mOfficeInfoByOrgAndMarketList)
                list.apply {
                    visibility = View.VISIBLE
                    layoutManager = LinearLayoutManager(mContext)
                    adapter = officeInfoByOrgAndMarketListAdapter
                    addItemDecoration(
                        DividerItemDecoration(
                            DividerItemDecoration.HORIZONTAL_LIST,
                            1,
                            ContextCompat.getColor(mContext, R.color.divider_line_deep_two)
                        )
                    )
                }
                officeInfoByOrgAndMarketListAdapter.setOnItemClickListener { baseQuickAdapter, view, position ->
                    val item =
                        baseQuickAdapter.getItem(position) as ShopSalesOrgEntity.ShopSalesOrgBean.OrgBean
                    mOfficeChooseId = item.orgId
                    mChooseOfficesOptionLayout?.addView(
                        position,
                        item.orgName ?: "",
                        arrayOf(28, 2, 28, 0)
                    ) { pos ->
                        mOfficeChooseId = null
                        mChooseStoreAllStoreRb?.performClick()
                    }
                    dialog.dismiss()
                    //获取指定办事处下门店数据
                    queryShopInfoByOrgAndMarket(item.orgId)
                }
            }
        })
        builder.create().show()
    }

    /**
     * 显示底部门店列表选择框(单选、多选列表)
     */
    private fun showMultipleStoreDialog() {
        val builder = PublicSelectBottomDialog.Companion.Builder(this)
        builder.isDataEntry(mShopInfoByOrgAndMarketList.isNullOrEmpty())
        builder.setTitle(R.string.custom_task_dialog_choose_store_title)
        builder.setDialogListLoadDataListener(object :
            PublicSelectBottomDialog.OnDialogListLoadDataListener {
            override fun onListLoadData(dialog: PublicSelectBottomDialog, list: RecyclerView) {
                val shopInfoByOrgAndMarketListAdapter =
                    ShopInfoByOrgAndMarketListAdapter(mShopInfoByOrgAndMarketList)
                list.apply {
                    visibility = View.VISIBLE
                    layoutManager = LinearLayoutManager(mContext)
                    adapter = shopInfoByOrgAndMarketListAdapter
                    addItemDecoration(
                        DividerItemDecoration(
                            DividerItemDecoration.HORIZONTAL_LIST,
                            1,
                            ContextCompat.getColor(mContext, R.color.divider_line_deep_two)
                        )
                    )
                }
            }
        })
        builder.setConfirmListener(object : PublicSelectBottomDialog.OnConfirmClickListener {
            override fun onClick(dialog: PublicSelectBottomDialog) {
                mShopInfoByOrgAndMarketList.forEachIndexed { position, item ->
                    if (item.isCheck) {
                        if (item.orgId.notNullAndEmpty() && !mStoreChooseList.contains(item.orgId)) {
                            mStoreChooseList.add(item.orgId!!)
                            mChooseStoreOptionLayout?.addView(
                                position,
                                item.orgName ?: "",
                                arrayOf(28, 2, 28, 0)
                            ) { pos ->
                                if (pos < mShopInfoByOrgAndMarketList.size) {
                                    val shopInfoByOrgAndMarketBean =
                                        mShopInfoByOrgAndMarketList[pos]
                                    shopInfoByOrgAndMarketBean.isCheck = false
                                    mStoreChooseList.remove(shopInfoByOrgAndMarketBean.orgId)
                                }
                            }
                        }
                    }
                }
            }
        })
        builder.create().show()
    }

    /**
     * 显示底部商品列表选择框(单选、多选列表)
     */
    private fun showBugProductDialog() {
        val builder = PublicSelectBottomDialog.Companion.Builder(this)
        builder.isDataEntry(mProductOfflineList.isNullOrEmpty())
        builder.setTitle(R.string.custom_task_dialog_choose_bug_product_title)
        builder.setDialogListLoadDataListener(object :
            PublicSelectBottomDialog.OnDialogListLoadDataListener {
            override fun onListLoadData(dialog: PublicSelectBottomDialog, list: RecyclerView) {
                val productOfflineListAdapter =
                    ProductOfflineListAdapter(mProductOfflineList)
                list.apply {
                    visibility = View.VISIBLE
                    layoutManager = LinearLayoutManager(mContext)
                    adapter = productOfflineListAdapter
                    addItemDecoration(
                        DividerItemDecoration(
                            DividerItemDecoration.HORIZONTAL_LIST,
                            1,
                            ContextCompat.getColor(mContext, R.color.divider_line_deep_two)
                        )
                    )
                }
            }
        })
        builder.setConfirmListener(object : PublicSelectBottomDialog.OnConfirmClickListener {
            override fun onClick(dialog: PublicSelectBottomDialog) {
                mProductOfflineList.forEachIndexed { position, item ->
                    if (item.isCheck) {
                        if (item.code.notNullAndEmpty() && !mBugProductList.contains(item.code)) {
                            mBugProductList.add(item.code!!)
                            mChooseProductOptionLayout?.addView(
                                position,
                                item.name ?: "",
                                arrayOf(28, 2, 28, 0)
                            ) { pos ->
                                if (pos < mBugProductList.size) {
                                    val productOfflineBean = mProductOfflineList[pos]
                                    productOfflineBean.isCheck = false
                                    mBugProductList.remove(productOfflineBean.code)
                                }
                            }
                        }
                    }
                }
            }
        })
        builder.create().show()
    }

    /**
     * 设置FlowLayout事件
     */
    private fun setFlowViewListener(
        tagFlowLayout: TagFlowLayout?,
        labelList: List<LabelInfoEntity.LabelInfoBean.LabelBean>?,
        singleChoose: Boolean = false
    ) {
        labelList?.let {
            var selectPosition: Int = -1
            tagFlowLayout?.setOnTagClickListener { view, position, parent ->
                if (singleChoose && selectPosition >= 0 && selectPosition != position) {
                    parent.tag?.let {
                        val tagView = it as TextView
                        tagView.setBackgroundResource(R.drawable.shape_rect_round_5_fill_f5f5f5)
                        tagView.setTextColor(resources.getColor(R.color.common_txt_color))
                        parent.tag = null
                    }
                    it.get(selectPosition).isSelected = false
                }

                val labelInfo = it.get(position)
                labelInfo.let {
                    val tagView = (view as TagView).tagView as TextView
                    if (!it.isSelected) {
                        if (singleChoose) {
                            parent.tag = tagView
                            selectPosition = position
                        }
                        tagView.setBackgroundResource(R.drawable.shape_rect_round_5_fill_ffa019)
                        tagView.setTextColor(resources.getColor(R.color.important_txt_third_color))
                    } else {
                        if (singleChoose) {
                            parent.tag = null
                            selectPosition = -1
                        }
                        tagView.setBackgroundResource(R.drawable.shape_rect_round_5_fill_f5f5f5)
                        tagView.setTextColor(resources.getColor(R.color.common_txt_color))
                    }
                    it.isSelected = !it.isSelected
                }
                true
            }
        }
    }

    /**
     * 设置标签数据
     */
    private fun setFlowViewData(
        tagFlowLayout: TagFlowLayout?,
        labelList: List<LabelInfoEntity.LabelInfoBean.LabelBean>?
    ) {
        labelList?.let {
            val inflater = LayoutInflater.from(mContext)
            tagFlowLayout?.adapter = object :
                TagAdapter<LabelInfoEntity.LabelInfoBean.LabelBean>(it) {
                override fun getView(
                    parent: FlowLayout,
                    position: Int,
                    bean: LabelInfoEntity.LabelInfoBean.LabelBean
                ): View {
                    val tagView = inflater.inflate(
                        R.layout.item_custom_label_view,
                        tagFlowLayout, false
                    ) as TextView

                    if (bean.isSelected) {
                        tagView.setBackgroundResource(R.drawable.shape_rect_round_5_fill_ffa019)
                        tagView.setTextColor(resources.getColor(R.color.important_txt_third_color))
                    } else {
                        tagView.setBackgroundResource(R.drawable.shape_rect_round_5_fill_f5f5f5)
                        tagView.setTextColor(resources.getColor(R.color.common_txt_color))
                    }
                    tagView.text = bean.labelName
                    return tagView
                }
            }
        }
    }

    /**
     * 获取所有标签列表
     */
    private fun queryAllMarkData() {
        showDialog()
        //获取所有标签列表数据
        CustomTaskService.instance.requestQueryLabelOptionList(
            this@CreateCustomTaskActivity
        )
        //获取所有线下产品列表数据
        CustomTaskService.instance.requestProductOffline(this@CreateCustomTaskActivity)
        //获取所有商超列表数据
        CustomTaskService.instance.requestSuperMarketInfo("", this@CreateCustomTaskActivity)

        queryShopInfoByOrgAndMarket(null)
    }

    /**
     * 查询活跃的门店销售组织数据（有客户购买过的门店）
     */
    private fun queryShopInfoByOrgAndMarket(officeId: String?) {
        userInfo.let {
            showDialog()
            val json = Gson().toJson(ShopSalesOrgRequest(it.regionId, officeId))
            CustomTaskService.instance.requestQueryActiveOrgList(
                json,
                this@CreateCustomTaskActivity
            )
        }
    }

    /**
     * 查询满足条件的名单人数
     */
    private fun querySatisfyCustomTaskCount() {
        if (mCreateCustomTaskBean != null) {
            showDialog()
            val json = Gson().toJson(mCreateCustomTaskBean)
            CustomTaskService.instance.requestQuerySatisfyCustomTaskCount(
                json,
                this@CreateCustomTaskActivity
            )
        }
    }

    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)
        dismissDialog()
        result?.let {
            if (it.taskID == BusinessID.CustomTask.MSG_ON_PRODUCT_OFFLINE) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, ProductOfflineEntity::class.java)
                    Log.d(TAG, "ProductOfflineEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.msgCode) {
                        if (entity.resultInfo.isNotNullOrSize()) {
                            mProductOfflineList =
                                entity.resultInfo as MutableList<ProductOfflineEntity.ProductOfflineBean>
                        }
                    }
                } else {
                    MyToast.show(getString(R.string.request_data_fail))
                }
            } else if (it.taskID == BusinessID.CustomTask.MSG_ON_GET_SUPER_MARKET_INFO) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, SuperMarketEntity::class.java)
                    Log.d(TAG, "SuperMarketEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        if (entity.data.isNotNullOrSize()) {
                            mSuperMarketList =
                                entity.data as MutableList<SuperMarketEntity.SuperMarketBean>
                        }
                    }
                } else {
                    MyToast.show(getString(R.string.request_data_fail))
                }

            } else if (it.taskID == BusinessID.CustomTask.MSG_ON_QUERY_ACTIVE_ORG_LIST) {
                if (!isFinishing && it.isSuccessed) {
                    val entity =
                        Gson().fromJson(it.info, ShopSalesOrgEntity::class.java)
                    Log.d(TAG, "ShopSalesOrgEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        val shopSalesOrgBean = entity.payload
                        shopSalesOrgBean?.let {
                            if (mOfficeChooseId == null) {
                                mOfficeInfoByOrgAndMarketList = it.officeList ?: listOf()
                            }
                            mShopInfoByOrgAndMarketList = it.shopList ?: listOf()
                        }
                    }
                } else {
                    MyToast.show(getString(R.string.request_data_fail))
                }
            } else if (it.taskID == BusinessID.CustomTask.MSG_ON_QUERY_LABEL_OPTION_LIST) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, LabelInfoEntity::class.java)
                    Log.d(TAG, "LabelInfoEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        mLabelInfoList = entity.payload ?: listOf()
                        refreshLabelInfoToView()
                    }
                } else {
                    MyToast.show(getString(R.string.request_data_fail))
                }
            } else if (it.taskID == BusinessID.CustomTask.MSG_ON_QUERY_SATISFY_CUSTOM_TASK_COUNT) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, QueryTaskCusCountEntity::class.java)
                    Log.d(TAG, "QueryTaskCusCountEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        val taskCount = entity.payload  //获取名单个数
                        if (taskCount > 0 && mCreateCustomTaskBean != null) {
                            jumpCustomTaskConfirmActivity(mCreateCustomTaskBean!!, taskCount)
                        } else {
                            MyToast.show(mContext.getString(R.string.custom_task_list_number_zero_tip))
                        }
                    } else {
                        MyToast.show(entity.retInfo)
                    }
                } else {
                    MyToast.show(getString(R.string.request_data_fail))
                }
            }
        }
    }

    /**
     * 标签数据
     */
    private fun refreshLabelInfoToView() {
        if (mLabelInfoList.isNotNullOrSize()) {
            val inflater = LayoutInflater.from(mContext)
            mLabelInfoList.forEach {
                if (it.labels.isNotNullOrSize()) {
                    val itemView =
                        inflater.inflate(
                            R.layout.include_custom_task_label,
                            mCustomTaskAllLabelContainerLl,
                            false
                        )
                    itemView.findViewById<TextView>(R.id.custom_task_item_label_title_tv).text =
                        it.labelGroupName

                    itemView.findViewById<CheckBox>(R.id.custom_task_item_choose_cb)
                        .setOnCheckedChangeListener { buttonView, isChecked ->
                            it.isChecked = isChecked
                            itemView.tag = it
                        }
                    val customTasktemLabelDataFl =
                        itemView.findViewById<TagFlowLayout>(R.id.custom_task_item_label_data_fl)
                    setFlowViewData(customTasktemLabelDataFl, it.labels)
                    setFlowViewListener(
                        customTasktemLabelDataFl,
                        it.labels,
                        it.selectType == ConstantParams.CONSTANT_STARTS_2
                    )
                    mCustomTaskAllLabelContainerLl?.addView(itemView)
                }
            }
            mCustomTaskAllLabelContainerLl?.visibility = View.VISIBLE
        } else {
            mCustomTaskAllLabelContainerLl?.visibility = View.GONE
        }
    }

    /**
     * 跳转到 CustomTaskConfirmActivity
     */
    private fun jumpCustomTaskConfirmActivity(entity: CreateCustomTaskBean, taskCount: Int) {
        val intent = Intent(mContext, CustomTaskConfirmActivity::class.java)
        intent.putExtra(AppConstants.ExtraKeys.CUSTOM_TASK_DATA, entity)
        intent.putExtra(AppConstants.ExtraKeys.CUSTOM_TASK_COUNT, taskCount)
        startActivity(intent)
        this.finish()
    }
}