package com.wgmf.yxgj.module.bussiness.customtask.ui

import android.annotation.SuppressLint
import android.os.Bundle
import android.support.v4.content.ContextCompat
import android.support.v7.widget.CardView
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.*
import com.google.gson.Gson
import com.wgmf.library.base.BaseResponse
import com.wgmf.library.base.ResultData
import com.wgmf.yxgj.base.BaseParentAct
import com.wgmf.yxgj.config.BusinessID
import com.wgmf.yxgj.dialog.PublicSelectBottomDialog
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.bussiness.customtask.R
import com.wgmf.yxgj.module.bussiness.customtask.model.*
import com.wgmf.yxgj.module.bussiness.customtask.service.CustomTaskService
import com.wgmf.yxgj.module.bussiness.customtask.ui.adapter.ActivityListAdapter
import com.wgmf.yxgj.module.bussiness.customtask.ui.view.ItemOptionLayout
import com.wgmf.yxgj.utils.MyToast
import com.wgmf.yxgj.utils.isNotNullOrSize
import com.wgmf.yxgj.utils.isNullOrEmpty
import com.wgmf.yxgj.utils.notNullAndEmpty
import com.wgmf.yxgj.widgets.decoration.DividerItemDecoration
import com.wgmf.yxgj.widgets.flowlayout.FlowLayout
import com.wgmf.yxgj.widgets.flowlayout.TagAdapter
import com.wgmf.yxgj.widgets.flowlayout.TagFlowLayout

/**
 *  自定义任务: 自定义任务详情列表
 * @author LW
 */
class CustomTaskDetailsActivity : BaseParentAct() {

    private val mCustomTaskDetailsBean: QueryCustomTaskDetailsEntity.CustomTaskDetailsPage.CustomTaskDetailsBean? by lazy {
        intent.getSerializableExtra(AppConstants.ExtraKeys.CUSTOM_TASK_DETAILS) as QueryCustomTaskDetailsEntity.CustomTaskDetailsPage.CustomTaskDetailsBean?
    }

    /**
     * 会员层级标签
     */
    private val mMemberRatingLabelList: MutableList<LabelInfoEntity.LabelInfoBean.LabelBean> =
        mutableListOf()

    /**
     * 新老会员标签
     */
    private val mNewOrOldMemberLabelList: MutableList<LabelInfoEntity.LabelInfoBean.LabelBean> =
        mutableListOf()

    private var mCustomTaskAllLabelContainerLl: LinearLayout? = null

    private var mCustomTaskAutoIssueCouponsCard: ViewGroup? = null
    private var mCustomTaskItemChooseCb: CheckBox? = null
    private var mCustomTaskItemChooseActivityTv: TextView? = null

    private var mActivityId: Int = -1

    private var mActivityName: String = ""

    private var mCouponList: List<BasicCouponEntity.CouponBean> = listOf()

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_custom_task_details)
        initTitle()
        initData()
        initView()
    }

    override fun initTitle() {
        super.initTitle()
        homeTitleText.text = getString(R.string.custom_task_task_details)
        homeTitleBackLl.visibility = View.VISIBLE
    }

    private fun initData() {
        mMemberRatingLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(4, "钻谷卡"))
        mMemberRatingLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(3, "金谷卡"))
        mMemberRatingLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(2, "银谷卡"))
        mMemberRatingLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(1, "谷谷卡"))
        mMemberRatingLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(0, "预备会员"))

        mNewOrOldMemberLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(0, "新会员"))
        mNewOrOldMemberLabelList.add(LabelInfoEntity.LabelInfoBean.LabelBean(1, "老会员"))
    }

    @SuppressLint("SetTextI18n")
    private fun initView() {
        val customTaskItemReferentialSpeechEt: EditText? =
            findViewById(R.id.custom_task_item_referential_speech_et)

        mCustomTaskAutoIssueCouponsCard =
            findViewById<ViewGroup>(R.id.custom_task_auto_issue_coupons_card).apply {
                mCustomTaskItemChooseCb = findViewById(R.id.custom_task_item_choose_cb)
                mCustomTaskItemChooseActivityTv =
                    findViewById(R.id.custom_task_item_choose_activity_tv)
                findViewById<RelativeLayout>(R.id.custom_task_item_choose_activity_rl).setOnClickListener {
                    showActivityDialog()
                }
            }

        mCustomTaskDetailsBean?.apply {
            //上次购买时间
            if (saleStartDate.notNullAndEmpty() && saleEndDate.notNullAndEmpty()) {
                findViewById<TextView>(R.id.custom_task_item_last_purchase_time_tv).text =
                    "$saleStartDate 至 $saleEndDate"
            } else {
                findViewById<CardView>(R.id.custom_task_last_purchase_time_card).visibility =
                    View.GONE
            }

            //商超系统
            if (marketId <= 0) {
                findViewById<CardView>(R.id.custom_task_super_system_card).visibility = View.GONE
            }

            //上次购买门店
            if (areaOrShop.notNullAndEmpty()) {
                findViewById<TextView>(R.id.custom_task_item_super_sytem_area).text = areaOrShop
            } else {
                findViewById<CardView>(R.id.custom_task_last_purchase_store_card).visibility =
                    View.GONE
            }

            //会员等级
            val gradeIds = grade?.split(",")
            val gradeList: MutableList<LabelInfoEntity.LabelInfoBean.LabelBean> = mutableListOf()

            if (gradeIds.isNotNullOrSize()) {
                gradeIds?.forEach {
                    for (rating in mMemberRatingLabelList)
                        if (it == rating.labelId.toString()) {
                            gradeList.add(rating)
                            return@forEach
                        }
                }
            }
            if (gradeList.isNotNullOrSize()) {
                setFlowViewData(
                    findViewById(R.id.custom_task_member_rating_fl),
                    gradeList
                )
                findViewById<CardView>(R.id.custom_task_member_rating_card).visibility =
                    View.VISIBLE
            } else {
                findViewById<CardView>(R.id.custom_task_member_rating_card).visibility =
                    View.GONE
            }

            //新老用户
            if (cusType ?: -1 >= 0) {
                mNewOrOldMemberLabelList.forEach {
                    if (it.labelId == cusType) {
                        val labelList =
                            listOf(it)
                        setFlowViewData(
                            findViewById(R.id.custom_task_new_and_old_members_fl),
                            labelList
                        )
                        return@forEach
                    }
                }
            } else {
                findViewById<CardView>(R.id.custom_task_new_and_old_members_card).visibility =
                    View.GONE
            }

            //所有标签
            mCustomTaskAllLabelContainerLl =
                findViewById<LinearLayout>(R.id.custom_task_all_label_container_ll).apply {
                    visibility = View.GONE
                }

            //会员单价
            if ((orderMin.notNullAndEmpty() && !orderMin.equals("-1")) || orderMax.notNullAndEmpty() && !orderMax.equals(
                    "-1"
                )
            ) {
                findViewById<TextView>(R.id.custom_task_item_price_start_tv).text =
                    convertValue(orderMin)
                findViewById<TextView>(R.id.custom_task_item_price_end_tv).text =
                    convertValue(orderMax)
            } else {
                findViewById<CardView>(R.id.custom_task_member_unit_price_card).visibility =
                    View.GONE
            }

            //未回头间隔
            if (notBoughtDay?:-1 >= 0) {
                findViewById<TextView>(R.id.custom_task_item_no_return_interval_tv).text =
                    notBoughtDay.toString()
            } else {
                findViewById<CardView>(R.id.custom_task_no_return_interval_card).visibility =
                    View.GONE
            }

            //消费次数
            if (consTimes?:-1 >= 0) {
                findViewById<TextView>(R.id.custom_task_item_consumption_times_tv).text =
                    consTimes.toString()
            } else {
                findViewById<CardView>(R.id.custom_task_consumption_times_card).visibility =
                    View.GONE
            }

            //积分过期
            if (overdue?:-1 >= 0) {
                findViewById<TextView>(R.id.custom_task_item_points_expired_tv).text =
                    overdue.toString()
            } else {
                findViewById<CardView>(R.id.custom_task_points_expired_card).visibility = View.GONE
            }

            //剩余积分
            if (usablePoints?:-1 >= 0) {
                findViewById<TextView>(R.id.custom_task_item_remaining_points_tv).text =
                    usablePoints.toString()
            } else {
                findViewById<CardView>(R.id.custom_task_remaining_points_card).visibility =
                    View.GONE
            }

            //购买产品
            if (prodCodes.isNullOrEmpty()) {
                findViewById<CardView>(R.id.custom_task_bug_product_card).visibility =
                    View.GONE
            }

            //参与促销活动
            if (activityIds.notNullAndEmpty()) {
                findViewById<TextView>(R.id.custom_task_item_participate_promotions_tv).text =
                    activityIds
            } else {
                findViewById<CardView>(R.id.custom_task_participate_promotions_card).visibility =
                    View.GONE
            }

            //参考话术
            mActivityId = referentialSpeechBean?.activityId ?: -1
            mCustomTaskItemChooseCb?.isChecked = mActivityId > 0

            if (referentialSpeechBean?.referentialSpeechContext.notNullAndEmpty()) {
                customTaskItemReferentialSpeechEt?.setText(
                    referentialSpeechBean?.referentialSpeechContext
                )
            }

            if (referentialSpeechBean?.activityName.notNullAndEmpty()) {

                mActivityName = referentialSpeechBean?.activityName ?: ""
                mCustomTaskItemChooseActivityTv?.text = referentialSpeechBean?.activityName
            }
        }

        findViewById<Button>(R.id.custom_task_save_btn).apply {
            setOnClickListener {
                val referentialSpeech = customTaskItemReferentialSpeechEt?.text.toString()
                if (referentialSpeech.isNullOrEmpty()) {
                    showMsg(mContext.getString(R.string.custom_task_referential_speech_tip))
                    return@setOnClickListener
                }

                if (mCustomTaskItemChooseCb?.isChecked == true) {
                    if (mActivityId <= 0 || mActivityName.isNullOrEmpty()) {
                        showMsg(mContext.getString(R.string.custom_task_activity_tip))
                        return@setOnClickListener
                    }
                }
                updateReferentialSpeech(referentialSpeech)
            }
        }
        queryAllMarkData()
    }

    /**
     * 数据转换
     */
    private fun convertValue(value: String?): String? {
        return if ("-1".equals(value)) {
            ""
        } else {
            value
        }
    }

    /**
     * 获取所有标签列表
     */
    private fun queryAllMarkData() {
        showDialog()
        //获取标签列表数据
        CustomTaskService.instance.requestQueryLabelOptionList(
            this@CustomTaskDetailsActivity
        )
        //获取所有线下产品列表数据
        CustomTaskService.instance.requestProductOffline(this@CustomTaskDetailsActivity)

        //获取所有商超列表数据
        CustomTaskService.instance.requestSuperMarketInfo("", this@CustomTaskDetailsActivity)

        //获取所有门店
        CustomTaskService.instance.requestQueryActiveOrgList(
            Gson().toJson(ShopSalesOrgRequest()),
            this@CustomTaskDetailsActivity
        )

        //优惠券基础下拉列表
        CustomTaskService.instance.requestBasicCouponOptionList(
            Gson().toJson(BasicCouponRequest()),
            this@CustomTaskDetailsActivity
        )
    }

    /**
     * 修改参考话术
     */
    private fun updateReferentialSpeech(referentialSpeech: String) {
        mCustomTaskDetailsBean?.let {
            showDialog()
            val request = UpdateReferentialSpeechRequest().apply {
                taskId = it.id
                referentialSpeechContext = referentialSpeech
                if (mCustomTaskItemChooseCb?.isChecked == true) {
                    activityId = mActivityId
                    activityName = mActivityName
                }
            }
            val json = Gson().toJson(request)
            CustomTaskService.instance.requestUpdateReferentialSpeech(
                json,
                this@CustomTaskDetailsActivity
            )
        }
    }

    /**
     * 显示底部活动列表选择框(单选、多选列表)
     */
    private fun showActivityDialog() {
        val builder = PublicSelectBottomDialog.Companion.Builder(this)
        builder.isDataEntry(mCouponList.isNullOrEmpty())
        builder.setTitle(R.string.custom_task_choose_activity)
        builder.setDialogListLoadDataListener(object :
            PublicSelectBottomDialog.OnDialogListLoadDataListener {
            override fun onListLoadData(dialog: PublicSelectBottomDialog, list: RecyclerView) {
                val activityListAdapter = ActivityListAdapter(mCouponList)
                list.apply {
                    visibility = View.VISIBLE
                    layoutManager = LinearLayoutManager(mContext)
                    adapter = activityListAdapter
                    addItemDecoration(
                        DividerItemDecoration(
                            DividerItemDecoration.HORIZONTAL_LIST,
                            1,
                            ContextCompat.getColor(mContext, R.color.divider_line_deep)
                        )
                    )
                }
                activityListAdapter.setOnItemClickListener { baseQuickAdapter, view, position ->
                    val item =
                        baseQuickAdapter.getItem(position) as BasicCouponEntity.CouponBean
                    mActivityId = item.value
                    mActivityName = item.label
                    mCustomTaskItemChooseActivityTv?.text = item.label
                    dialog.dismiss()
                }
            }
        })
        builder.create().show()
    }


    /**
     * 设置标签数据
     */
    private fun setFlowViewData(
        tagFlowLayout: TagFlowLayout?,
        labelList: List<LabelInfoEntity.LabelInfoBean.LabelBean>?
    ) {
        labelList?.let {
            val inflater = LayoutInflater.from(mContext)
            tagFlowLayout?.adapter = object :
                TagAdapter<LabelInfoEntity.LabelInfoBean.LabelBean>(it) {
                override fun getView(
                    parent: FlowLayout,
                    position: Int,
                    bean: LabelInfoEntity.LabelInfoBean.LabelBean
                ): View {
                    val tagView = inflater.inflate(
                        R.layout.item_custom_label_view,
                        tagFlowLayout, false
                    ) as TextView
                    tagView.setBackgroundResource(R.drawable.shape_rect_round_5_fill_ffa019)
                    tagView.setTextColor(resources.getColor(R.color.important_txt_third_color))
                    tagView.text = bean.labelName
                    return tagView
                }
            }
        }
    }

    /**
     * 商超数据回显
     */
    private fun superMarketInfoToView(list: List<SuperMarketEntity.SuperMarketBean>) {
        val marketId = mCustomTaskDetailsBean?.marketId ?: -1
        if (marketId > 0) {
            list.forEach {
                if (it.id == marketId) {
                    findViewById<TextView>(R.id.custom_task_item_choose_system_tv).text = it.name
                    return@forEach
                }
            }
        }
    }

    /**
     * 大区，办事处，门店回显
     */
    private fun shopInfoToView(shopSalesOrgBean: ShopSalesOrgEntity.ShopSalesOrgBean?) {
        shopSalesOrgBean?.let {
            val areaList = it.areaList
            if (areaList.isNotNullOrSize()) {
                val areaId = mCustomTaskDetailsBean?.areaId
                areaList?.forEach {
                    if (it.orgId == areaId.toString()) {
                        if (it.orgName.notNullAndEmpty()) {
                            findViewById<TextView>(R.id.custom_task_item_super_sytem_area).text =
                                it.orgName
                            return@forEach
                        }
                    }
                }
            }

            val officeList = it.officeList
            if (officeList.isNotNullOrSize()) {
                val chooseOfficesOptionLayout = ItemOptionLayout(
                    mContext,
                    findViewById(R.id.custom_task_item_choose_offices_ll)
                )
                val officeId = mCustomTaskDetailsBean?.officeId

                for (bean in officeList!!) {
                    if (bean.orgId == officeId.toString()) {
                        if (bean.orgName.notNullAndEmpty()) {
                            chooseOfficesOptionLayout.addView(
                                0,
                                bean.orgName!!,
                                arrayOf(28, 2, 28, 0)
                            )
                        }
                        continue
                    }
                }
            }

            val shopList = it.shopList
            if (shopList.isNotNullOrSize()) {
                //门店
                val chooseStoreOptionLayout = ItemOptionLayout(
                    mContext,
                    findViewById(R.id.custom_task_item_choose_store_ll), false
                )
                val listShops = mCustomTaskDetailsBean?.shopIds?.split(",")
                listShops?.forEach {
                    for (bean in shopList!!) {
                        if (bean.orgId == it) {
                            if (bean.orgName.notNullAndEmpty()) {
                                chooseStoreOptionLayout.addView(
                                    0,
                                    bean.orgName!!,
                                    arrayOf(28, 2, 28, 0)
                                )
                            }
                            continue
                        }
                    }
                }
            }
        }
    }

    /**
     * 标签回显
     */
    private fun refreshlabelInfoToView(list: List<LabelInfoEntity.LabelInfoBean>) {
        val labelInfoIds = mCustomTaskDetailsBean?.labelInfoIds?.split(",")
        if (labelInfoIds.isNotNullOrSize()) {
            mCustomTaskAllLabelContainerLl?.visibility = View.VISIBLE
            val inflater = LayoutInflater.from(mContext)
            list.forEach {
                val itemView =
                    inflater.inflate(
                        R.layout.include_custom_task_label_data,
                        mCustomTaskAllLabelContainerLl,
                        false
                    )
                itemView.findViewById<TextView>(R.id.custom_task_item_label_title_tv).text =
                    it.labelGroupName

                val labelList = mutableListOf<LabelInfoEntity.LabelInfoBean.LabelBean>()
                if (it.labels.isNotNullOrSize()) {
                    labelInfoIds?.forEach { selectLabelId ->
                        it.labels?.forEach { label ->
                            if (selectLabelId == label.labelId.toString()) {
                                labelList.add(label)
                            }
                        }
                    }
                }

                val customTasktemLabelDataFl =
                    itemView.findViewById<TagFlowLayout>(R.id.custom_task_item_label_data_fl)
                setFlowViewData(customTasktemLabelDataFl, labelList)
                mCustomTaskAllLabelContainerLl?.addView(itemView)
            }
        }
    }

    /**
     * 产品回显
     */
    private fun productOfflineInfoToView(list: List<ProductOfflineEntity.ProductOfflineBean>) {
        val chooseProductOptionLayout = ItemOptionLayout(
            mContext,
            findViewById(R.id.custom_task_item_choose_bug_product_ll), false
        )
        val listProduct = mCustomTaskDetailsBean?.prodCodes?.split(",")
        listProduct?.forEach {
            for (bean in list) {
                if (bean.code == it) {
                    if (bean.name.notNullAndEmpty()) {
                        chooseProductOptionLayout.addView(
                            0,
                            bean.name!!,
                            arrayOf(28, 2, 28, 0)
                        )
                    }
                    continue
                }
            }
        }
    }

    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)
        dismissDialog()
        result?.let {
            if (it.taskID == BusinessID.CustomTask.MSG_ON_PRODUCT_OFFLINE) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, ProductOfflineEntity::class.java)
                    Log.d(TAG, "ProductOfflineEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.msgCode) {
                        if (entity.resultInfo.isNotNullOrSize()) {
                            val productOfflineList =
                                entity.resultInfo as MutableList<ProductOfflineEntity.ProductOfflineBean>
                            productOfflineInfoToView(productOfflineList)
                        }
                    }
                } else {
                    MyToast.show(getString(R.string.request_data_fail))
                }
            } else if (it.taskID == BusinessID.CustomTask.MSG_ON_GET_SUPER_MARKET_INFO) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, SuperMarketEntity::class.java)
                    Log.d(TAG, "SuperMarketEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        if (entity.data.isNotNullOrSize()) {
                            val superMarketList =
                                entity.data as MutableList<SuperMarketEntity.SuperMarketBean>
                            superMarketInfoToView(superMarketList)
                        }
                    }
                } else {
                    MyToast.show(getString(R.string.request_data_fail))
                }

            } else if (it.taskID == BusinessID.CustomTask.MSG_ON_QUERY_ACTIVE_ORG_LIST) {
                if (!isFinishing && it.isSuccessed) {
                    val entity =
                        Gson().fromJson(it.info, ShopSalesOrgEntity::class.java)
                    Log.d(TAG, "ShopSalesOrgEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        shopInfoToView(entity.payload)
                    }
                } else {
                    MyToast.show(getString(R.string.request_data_fail))
                }
            } else if (it.taskID == BusinessID.CustomTask.MSG_ON_QUERY_LABEL_OPTION_LIST) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, LabelInfoEntity::class.java)
                    Log.d(TAG, "LabelInfoEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        if (entity.payload.isNotNullOrSize()) {
                            val labelInfoList =
                                entity.payload as MutableList<LabelInfoEntity.LabelInfoBean>
                            refreshlabelInfoToView(labelInfoList)
                        }
                    }
                } else {
                    MyToast.show(getString(R.string.request_data_fail))
                }
            } else if (it.taskID == BusinessID.CustomTask.MSG_ON_UPDATE_REFERENTIAL_SPEECH) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, BaseResponse::class.java)
                    Log.d(TAG, "BaseResponse=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        showMsg(mContext.getString(R.string.custom_task_referential_speech_save_success))
                    } else {
                        showMsg(mContext.getString(R.string.custom_task_referential_speech_save_failed))
                    }
                } else {
                    MyToast.show(getString(R.string.request_data_fail))
                }
            } else if (it.taskID == BusinessID.CustomTask.MSG_ON_BASIC_COUPON_OPTION_LIST) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, BasicCouponEntity::class.java)
                    Log.d(TAG, "BasicCouponEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        if (entity.payload.isNotNullOrSize()) {
                            mCouponList = entity.payload ?: listOf()
                        }
                    }
                } else {
                    MyToast.show(getString(R.string.request_data_fail))
                }
            }
        }
    }
}