package com.wgmf.yxgj.module.bussiness.customtask.ui.adapter

import android.support.v4.content.ContextCompat
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.bussiness.customtask.R
import com.wgmf.yxgj.module.bussiness.customtask.model.QueryCustomTaskDetailsEntity
import com.wgmf.yxgj.utils.convertDefaultValue

/**
 * 自定义任务列表适配器
 * @author LW
 */
class CustomTaskListAdapter(
    entity: List<QueryCustomTaskDetailsEntity.CustomTaskDetailsPage.CustomTaskDetailsBean>
) : BaseQuickAdapter<QueryCustomTaskDetailsEntity.CustomTaskDetailsPage.CustomTaskDetailsBean, BaseViewHolder>(
    R.layout.item_custom_task_view,
    entity
) {

    override fun convert(
        helper: BaseViewHolder?,
        item: QueryCustomTaskDetailsEntity.CustomTaskDetailsPage.CustomTaskDetailsBean?
    ) {
        helper?.apply {
            item?.let {
                setText(
                    R.id.custom_task_item_create_time_tv, it.createDate
                )

                if (it.taskState == ConstantParams.CONSTANT_STARTS_0) {
                    setText(
                        R.id.custom_task_item_status_tv,
                        R.string.custom_task_status_to_be_started
                    )
                    setTextColor(
                        R.id.custom_task_item_status_tv,
                        ContextCompat.getColor(mContext, R.color.important_txt_second_color)
                    )
                } else if (it.taskState == ConstantParams.CONSTANT_STARTS_1) {
                    setText(
                        R.id.custom_task_item_status_tv,
                        R.string.custom_task_status_ongoing
                    )
                    setTextColor(
                        R.id.custom_task_item_status_tv,
                        ContextCompat.getColor(mContext, R.color.important_txt_four_color)
                    )
                } else if (it.taskState == ConstantParams.CONSTANT_STARTS_2) {
                    setText(
                        R.id.custom_task_item_status_tv,
                        R.string.custom_task_status_over
                    )
                    setTextColor(
                        R.id.custom_task_item_status_tv,
                        ContextCompat.getColor(mContext, R.color.common_txt_color)
                    )
                } else if (it.taskState == ConstantParams.CONSTANT_STARTS_3) {
                    setText(
                        R.id.custom_task_item_status_tv,
                        R.string.custom_task_status_delete
                    )
                    setTextColor(
                        R.id.custom_task_item_status_tv,
                        ContextCompat.getColor(mContext, R.color.important_txt_five_color)
                    )
                }

                setText(
                    R.id.custom_task_item_title_tv,
                    it.taskName.convertDefaultValue()
                )

                setText(
                    R.id.custom_task_item_return_time_tv,
                    mContext.getString(
                        R.string.custom_task_return_time,
                        it.careStartDate.convertDefaultValue(),
                        it.careEndDate.convertDefaultValue()
                    )
                )

                setText(
                    R.id.custom_task_item_regional_store_tv,
                    mContext.getString(
                        R.string.custom_task_regional_store,
                        it.areaOrShop.convertDefaultValue()
                    )
                )

                setText(
                    R.id.custom_task_item_list_number_tv,
                    mContext.getString(
                        R.string.custom_task_list_number,
                        it.taskCustomerCount.toString().convertDefaultValue()
                    )
                )

                setText(
                    R.id.custom_task_item_founder_tv,
                    mContext.getString(
                        R.string.custom_task_founder,
                        it.staffName.convertDefaultValue()
                    )
                )

                //状态 0：待开始1：进行中2：已结束
                if (it.taskState == ConstantParams.CONSTANT_STARTS_0 ||
                    it.taskState == ConstantParams.CONSTANT_STARTS_1
                ) {
                    setGone(R.id.custom_task_item_operate_tv, true)
                    setText(R.id.custom_task_item_operate_tv, R.string.cancel_btn_txt)
                    setBackgroundRes(
                        R.id.custom_task_item_operate_tv,
                        R.drawable.selector_blue_fill_round_btn
                    )
                } else if (it.taskState == ConstantParams.CONSTANT_STARTS_2) {
                    setGone(R.id.custom_task_item_operate_tv, true)
                    setText(R.id.custom_task_item_operate_tv, R.string.delete_btn_text)
                    setBackgroundRes(
                        R.id.custom_task_item_operate_tv,
                        R.drawable.selector_orange_fill_round_btn
                    )
                } else {
                    setGone(R.id.custom_task_item_operate_tv, false)
                }
                addOnClickListener(R.id.custom_task_item_operate_tv)
            }
        }
    }
}