package com.wgmf.yxgj.module.bussiness.customtask.ui.adapter

import android.widget.CheckBox
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.yxgj.module.bussiness.customtask.R
import com.wgmf.yxgj.module.bussiness.customtask.model.ShopSalesOrgEntity

/**
 * 门店列表适配器
 * @author LW
 */
class ShopInfoByOrgAndMarketListAdapter(
    entity: List<ShopSalesOrgEntity.ShopSalesOrgBean.OrgBean>
) : BaseQuickAdapter<ShopSalesOrgEntity.ShopSalesOrgBean.OrgBean, BaseViewHolder>(
    R.layout.item_dailog_select_view,
    entity
) {

    override fun convert(
        helper: BaseViewHolder?,
        item: ShopSalesOrgEntity.ShopSalesOrgBean.OrgBean?
    ) {
        helper?.apply {
            item?.let {
                setText(
                    R.id.dialog_select_choose_tv, it.orgName
                )
                setVisible(R.id.dialog_select_choose_cb, true)
                getView<CheckBox>(R.id.dialog_select_choose_cb).apply {
                    tag = it
                    isChecked = it.isCheck
                    setOnCheckedChangeListener { buttonView, isChecked ->
                        val bean =
                            buttonView.getTag() as ShopSalesOrgEntity.ShopSalesOrgBean.OrgBean
                        bean.isCheck = isChecked
                    }
                }
            }
        }
    }
}