package com.wgmf.yxgj.module.business.employability.evaluation.ui

import android.content.Context
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.wgmf.yxgj.module.business.employability.R
import com.wgmf.yxgj.module.business.employability.evaluation.model.EvaluationBean
import org.jetbrains.anko.find

class EvaluationPersonListAdapter(
    private val context: Context,
    private var evaluationBeanList: MutableList<EvaluationBean> = mutableListOf(),
    private val clickListener: OnEvaluationPersonClickListener
) : RecyclerView.Adapter<EvaluationPersonListAdapter.EvaluationPersonListHolder>() {

    /**
     * 修改列表数据
     * @param newList MutableList
     */
    fun refreshDataList(newList: MutableList<EvaluationBean>?) {
        if (newList?.isNotEmpty() == true) {
            evaluationBeanList = newList
            notifyDataSetChanged()
        }
    }

    override fun onCreateViewHolder(
        parent: ViewGroup,
        viewType: Int
    ): EvaluationPersonListHolder {
        return EvaluationPersonListHolder(
            LayoutInflater.from(context)
                .inflate(R.layout.public_content_text_ll, parent, false)
        )
    }

    override fun onBindViewHolder(holder: EvaluationPersonListHolder, pos: Int) {
        val item = evaluationBeanList[pos]
        holder.apply {
            itemTxt.text = item.workerStaffName
            itemView.setOnClickListener {
                clickListener.onPersonAdapterClick(item, pos)
            }
        }
    }

    override fun getItemCount(): Int = evaluationBeanList.size

    interface OnEvaluationPersonClickListener {
        fun onPersonAdapterClick(data: EvaluationBean?, postion: Int)
    }

    class EvaluationPersonListHolder(view: View) : RecyclerView.ViewHolder(view) {
        val itemTxt: TextView = view.find(R.id.tv_item_txt)
    }
}