package com.wgmf.yxgj.module.business.employability.newworkertrain.ui;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.support.v4.content.ContextCompat;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.NewWorkerTrainUserEntity;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.UserWeekListEntity;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.WeekItemListEntity;
import com.wgmf.yxgj.module.business.employability.newworkertrain.service.util.Constants;
import com.wgmf.yxgj.module.business.employability.newworkertrain.service.util.DateUtil;
import com.wgmf.yxgj.utils.helper.DialogHelper;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;
import com.wgmf.yxgj.widgets.TextView.MarqueeTextView;

import java.util.List;

@SuppressWarnings("all")
public class NewWorkerDistributionAdapter extends BaseAdapter implements NewWorkerTrainEditChildAdapter1.ClickListener, NewWorkerTrainEditChildAdapter2.ClickListener, DialogHelper.DialogResult {
    private Long branchID;
    private Context context;
    private String trainMentorStaffId;
    private NewWorkerTrainUserEntity reportModuleItemEntities = new NewWorkerTrainUserEntity();

    private ClickListener clickListener;
    private Drawable drawableDown;
    private Drawable drawableUp;
    private Drawable drawable;
    /**
     * 缓存选择培训开始日期TextView
     */
    private TextView selectDateView;

    @Override
    public void trainItemTimeClick(NewWorkerTrainUserEntity newWorkerTrainUserEntity) {
        clickListener.trainItemTimeClick(newWorkerTrainUserEntity);
    }

    @Override
    public void trainItemDateClick(NewWorkerTrainUserEntity newWorkerTrainUserEntity, int position) {
        clickListener.trainItemDateClick(newWorkerTrainUserEntity);
    }

    @Override
    public void onDialogResult(int tag) {
        String Date = selectDateView.getText().toString();
        clickListener.trainItemDateClick(reportModuleItemEntities);
        NewWorkerTrainUserEntity newWorkerTrainResultEntity = setFirstDate(Date, reportModuleItemEntities);
    }

    public interface ClickListener {
        void trainItemShopClick(int postion);

        void trainItemMentorClick(int postion);

        void trainItemDateClick(NewWorkerTrainUserEntity newWorkerTrainUserEntity);

        void trainItemTimeClick(NewWorkerTrainUserEntity newWorkerTrainUserEntity);
    }

    public NewWorkerDistributionAdapter(Context context, ClickListener clickListener, Long branchID, String trainMentorStaffId, NewWorkerTrainUserEntity abilityItemsListEntity) {
        this.branchID = branchID;
        this.trainMentorStaffId = trainMentorStaffId;
        this.context = context;
        this.clickListener = clickListener;
        this.reportModuleItemEntities = abilityItemsListEntity;

        drawableDown = ContextCompat.getDrawable(context, R.drawable.row_down);
        drawableDown.setBounds(0, 0, drawableDown.getMinimumWidth(), drawableDown.getMinimumHeight());
        drawableUp = ContextCompat.getDrawable(context, R.drawable.row_up);
        drawableUp.setBounds(0, 0, drawableUp.getMinimumWidth(), drawableUp.getMinimumHeight());

        drawable = ContextCompat.getDrawable(context, R.mipmap.btn_edit_1);
        //必须设置图片大小，否则不显示
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        selectDateView = new TextView(context);
    }

    public void setData(NewWorkerTrainUserEntity reportModuleItemEntities) {
        this.reportModuleItemEntities = reportModuleItemEntities;
    }

    public List<UserWeekListEntity> getUploadData() {
        return reportModuleItemEntities.getUserWeekList();
    }

    @Override
    public int getCount() {
        return reportModuleItemEntities == null ? 0 : reportModuleItemEntities.getUserWeekList().size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        LinearLayout newWorkerTrainItemItemContentLl;
        LinearLayout newWorkerTrainItemManageRevaluationLl;
        LinearLayout newWorkerTrainItemLl;
        LinearLayout newWorkerTrainItemShopLl;
        TextView newWorkerTrainItemTv;
        TextView newWorkerTrainItemTimeTv;
        MarqueeTextView newWorkerTrainItemShopTv;
        MarqueeTextView newWorkerTrainItemMentorTv;
        TextView newWorkerTrainItemQueryTv;
        TextView newWorkerTrainItemTipTv;
        TextView newWorkerTrainItemRow;
        TextView newWorkerTrainItemItemContent;
        EditText newWorkerTrainItemManageRevaluation;
        ListViewForScrollView newWorkerTrainEditLv1;
        ListViewForScrollView newWorkerTrainEditLv2;
        ListViewForScrollView newWorkerTrainEditLv3;
        ListViewForScrollView newWorkerTrainEditLv4;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder = new ViewHolder();
        convertView = LayoutInflater.from(context).inflate(R.layout.new_worker_train_edit_item, null);
        holder.newWorkerTrainItemItemContentLl = (LinearLayout) convertView.findViewById(R.id.new_worker_train_item_item_content_ll);
        holder.newWorkerTrainItemManageRevaluationLl = (LinearLayout) convertView.findViewById(R.id.new_worker_train_item_manage_revaluation_ll);
        holder.newWorkerTrainItemLl = (LinearLayout) convertView.findViewById(R.id.new_worker_train_item_ll);
        holder.newWorkerTrainItemShopLl = (LinearLayout) convertView.findViewById(R.id.new_worker_train_item_shop_ll);
        holder.newWorkerTrainItemTv = (TextView) convertView.findViewById(R.id.new_worker_train_item_tv);
        holder.newWorkerTrainItemTimeTv = (TextView) convertView.findViewById(R.id.new_worker_train_item_time_tv);
        holder.newWorkerTrainItemShopTv = (MarqueeTextView) convertView.findViewById(R.id.new_worker_train_item_shop_tv);
        holder.newWorkerTrainItemMentorTv = (MarqueeTextView) convertView.findViewById(R.id.new_worker_train_item_mentor_tv);
        holder.newWorkerTrainItemQueryTv = (TextView) convertView.findViewById(R.id.new_worker_train_item_query_tv);
        holder.newWorkerTrainItemTipTv = (TextView) convertView.findViewById(R.id.new_worker_train_item_tip_tv);
        holder.newWorkerTrainItemItemContent = (TextView) convertView.findViewById(R.id.new_worker_train_item_item_content);
        holder.newWorkerTrainItemManageRevaluation = (EditText) convertView.findViewById(R.id.new_worker_train_item_manage_revaluation);
        holder.newWorkerTrainItemRow = (TextView) convertView.findViewById(R.id.new_worker_train_item_row);
        holder.newWorkerTrainEditLv1 = (ListViewForScrollView) convertView.findViewById(R.id.new_worker_train_edit_lv1);
        holder.newWorkerTrainEditLv2 = (ListViewForScrollView) convertView.findViewById(R.id.new_worker_train_edit_lv2);
        holder.newWorkerTrainEditLv3 = (ListViewForScrollView) convertView.findViewById(R.id.new_worker_train_edit_lv3);
        holder.newWorkerTrainEditLv4 = (ListViewForScrollView) convertView.findViewById(R.id.new_worker_train_edit_lv4);
        holder.newWorkerTrainEditLv1.setFocusable(false);
        holder.newWorkerTrainEditLv2.setFocusable(false);
        holder.newWorkerTrainEditLv3.setFocusable(false);
        holder.newWorkerTrainEditLv4.setFocusable(false);
        convertView.setTag(holder);
        final UserWeekListEntity data = reportModuleItemEntities.getUserWeekList().get(position);
        //项目类别
        holder.newWorkerTrainItemTv.setText(data.getTrainWeekName());
        holder.newWorkerTrainItemTimeTv.setText(data.getTrainItemTime());
        if (!TextUtils.isEmpty(data.getItemTrainShopName())) {
            holder.newWorkerTrainItemShopTv.setText(data.getItemTrainShopName());
        }
        if (!TextUtils.isEmpty(data.getTrainMentorStaffName())) {
            holder.newWorkerTrainItemMentorTv.setText(data.getTrainMentorStaffName());
        }
        setView(holder, position);
        setContentView(position, holder);
        if (data.isChoice()) {
            holder.newWorkerTrainEditLv1.setVisibility(View.GONE);
            holder.newWorkerTrainEditLv2.setVisibility(View.GONE);
            holder.newWorkerTrainEditLv4.setVisibility(View.GONE);
            holder.newWorkerTrainItemRow.setCompoundDrawables(null, null, drawableDown, null);
        } else {
            setView(holder, position);
            holder.newWorkerTrainItemRow.setCompoundDrawables(null, null, drawableUp, null);
        }
        holder.newWorkerTrainItemLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (data.isChoice()) {
                    setView(holder, position);
                    holder.newWorkerTrainItemRow.setCompoundDrawables(null, null, drawableUp, null);
                } else {
                    holder.newWorkerTrainEditLv1.setVisibility(View.GONE);
                    holder.newWorkerTrainEditLv2.setVisibility(View.GONE);
                    holder.newWorkerTrainEditLv4.setVisibility(View.GONE);
                    holder.newWorkerTrainItemRow.setCompoundDrawables(null, null, drawableDown, null);
                }
                data.setChoice(!data.isChoice());
            }
        });
        holder.newWorkerTrainItemShopTv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickListener.trainItemShopClick(position);
                holder.newWorkerTrainItemShopTv.setTextColor(ContextCompat.getColor(context, R.color.important_txt_color));
            }
        });
        holder.newWorkerTrainItemMentorTv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickListener.trainItemMentorClick(position);
                holder.newWorkerTrainItemShopTv.setTextColor(ContextCompat.getColor(context, R.color.important_txt_color));
            }
        });
        if (null != reportModuleItemEntities.getUserWeekList() && !reportModuleItemEntities.getUserWeekList().isEmpty()) {
            if (null != reportModuleItemEntities.getUserWeekList().get(position).getWeekItemList() && !reportModuleItemEntities.getUserWeekList().get(position).getWeekItemList().isEmpty()) {
                NewWorkerTrainEditChildAdapter1 mAdapter1 = new NewWorkerTrainEditChildAdapter1(context, this, reportModuleItemEntities);
                mAdapter1.setData(reportModuleItemEntities, position);
                mAdapter1.setListener(this);
                holder.newWorkerTrainEditLv1.setAdapter(mAdapter1);
            } else {
                holder.newWorkerTrainEditLv1.setVisibility(View.GONE);
            }
            if (null != reportModuleItemEntities.getUserWeekList().get(position).getWeekTitleList() && !reportModuleItemEntities.getUserWeekList().get(position).getWeekTitleList().isEmpty()) {
                NewWorkerTrainEditChildAdapter2 mAdapter2 = new NewWorkerTrainEditChildAdapter2(context, this, reportModuleItemEntities);
                mAdapter2.setData(reportModuleItemEntities, position);
                mAdapter2.setListener(this);
                holder.newWorkerTrainEditLv2.setAdapter(mAdapter2);
            } else {
                holder.newWorkerTrainEditLv2.setVisibility(View.GONE);
            }
            if (null != reportModuleItemEntities.getUserWeekList().get(position).getWorkerTrainTaskWirte()) {
                NewWorkerTrainEditChildAdapter4 mAdapter4 = new NewWorkerTrainEditChildAdapter4(context, trainMentorStaffId, reportModuleItemEntities);
                mAdapter4.setData(reportModuleItemEntities, position);
                holder.newWorkerTrainEditLv4.setAdapter(mAdapter4);
            } else {
                holder.newWorkerTrainEditLv4.setVisibility(View.GONE);
            }
        }
        return convertView;
    }

    private void setContentView(int position, ViewHolder holder) {
        if (position == 0) {
            holder.newWorkerTrainItemMentorTv.setVisibility(View.VISIBLE);
            holder.newWorkerTrainItemTimeTv.setCompoundDrawables(null, null, drawable, null);
            holder.newWorkerTrainItemTimeTv.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    //自动批量修改时间
                    DialogHelper.AlertDatePicker(context, NewWorkerDistributionAdapter.this, selectDateView);
                }
            });
        } else {
            holder.newWorkerTrainItemMentorTv.setVisibility(View.GONE);
            holder.newWorkerTrainItemTimeTv.setCompoundDrawables(null, null, null, null);
        }
    }

    private void setView(ViewHolder holder, int position) {
        holder.newWorkerTrainEditLv1.setVisibility(View.VISIBLE);
        holder.newWorkerTrainEditLv2.setVisibility(View.VISIBLE);
        holder.newWorkerTrainEditLv3.setVisibility(View.GONE);
        holder.newWorkerTrainEditLv4.setVisibility(View.VISIBLE);
    }


    /**
     * @param firstDate 第一天培训日期
     * @param msg       培训内容
     * @return 修改第一天培训日期后的培训内容
     */
    private NewWorkerTrainUserEntity setFirstDate(String firstDate, NewWorkerTrainUserEntity newWorkerTrainResultEntity) {
        String trainItemTime = firstDate;
        String startTrainItemmTime = firstDate;
        List<UserWeekListEntity> userWeekList = newWorkerTrainResultEntity.getUserWeekList();
        for (UserWeekListEntity userWeek : userWeekList) {
            List<WeekItemListEntity> weekItemList = userWeek.getWeekItemList();
            trainItemTime = DateUtil.addOrDelTime(Constants.DATE_FORMAT_YYYY_MM_DD, trainItemTime, "z", Constants.NUM_SIX);
            userWeek.setTrainItemTime(startTrainItemmTime + "~" + trainItemTime);
            startTrainItemmTime = DateUtil.addOrDelTime(Constants.DATE_FORMAT_YYYY_MM_DD, trainItemTime, "z", Constants.NUM_ONE);
        }
        String content = new Gson().toJson(newWorkerTrainResultEntity);
        Log.d("setFirstDate", content);
        return newWorkerTrainResultEntity;
    }
}