package com.wgmf.yxgj.module.business.employability.newworkertrain.ui;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.support.v4.content.ContextCompat;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.NewWorkerTrainUserEntity;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.UserWeekListEntity;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;
import com.wgmf.yxgj.widgets.TextView.MarqueeTextView;

import java.util.List;

@SuppressWarnings("all")
public class NewWorkerEvaluateAdapter extends BaseAdapter {
    private Long branchID;
    private Context context;
    private String trainMentorStaffId;
    private String userPostLevel;
    private NewWorkerTrainUserEntity reportModuleItemEntities = new NewWorkerTrainUserEntity();
    private Drawable drawableDown;
    private Drawable drawableUp;


    public NewWorkerEvaluateAdapter(Context context, Long branchID, String trainMentorStaffId, String userPostLevel, NewWorkerTrainUserEntity abilityItemsListEntity) {
        this.branchID = branchID;
        this.trainMentorStaffId = trainMentorStaffId;
        this.userPostLevel = userPostLevel;
        this.context = context;
        this.reportModuleItemEntities = abilityItemsListEntity;

        drawableDown = ContextCompat.getDrawable(context, R.drawable.row_down);
        drawableDown.setBounds(0, 0, drawableDown.getMinimumWidth(), drawableDown.getMinimumHeight());
        drawableUp = ContextCompat.getDrawable(context, R.drawable.row_up);
        drawableUp.setBounds(0, 0, drawableUp.getMinimumWidth(), drawableUp.getMinimumHeight());
    }

    public void setData(NewWorkerTrainUserEntity reportModuleItemEntities) {
        this.reportModuleItemEntities = reportModuleItemEntities;
    }

    public List<UserWeekListEntity> getUploadData() {
        return reportModuleItemEntities.getUserWeekList();
    }

    @Override
    public int getCount() {
        return reportModuleItemEntities == null ? 0 : reportModuleItemEntities.getUserWeekList().size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        LinearLayout newWorkerTrainItemItemContentLl;
        LinearLayout newWorkerTrainItemManageRevaluationLl;
        LinearLayout newWorkerTrainItemLl;
        LinearLayout newWorkerTrainItemShopLl;
        TextView newWorkerTrainItemTv;
        TextView newWorkerTrainItemTimeTv;
        MarqueeTextView newWorkerTrainItemShopTv;
        MarqueeTextView newWorkerTrainItemMentorTv;
        TextView newWorkerTrainItemQueryTv;
        TextView newWorkerTrainItemTipTv;
        TextView newWorkerTrainItemRow;
        TextView newWorkerTrainItemItemContent;
        EditText newWorkerTrainItemManageRevaluation;
        ListViewForScrollView newWorkerTrainEditLv1;
        ListViewForScrollView newWorkerTrainEditLv2;
        ListViewForScrollView newWorkerTrainEditLv3;
        ListViewForScrollView newWorkerTrainEditLv4;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder = new ViewHolder();
        convertView = LayoutInflater.from(context).inflate(R.layout.new_worker_train_edit_item, null);
        holder.newWorkerTrainItemItemContentLl = (LinearLayout) convertView.findViewById(R.id.new_worker_train_item_item_content_ll);
        holder.newWorkerTrainItemManageRevaluationLl = (LinearLayout) convertView.findViewById(R.id.new_worker_train_item_manage_revaluation_ll);
        holder.newWorkerTrainItemLl = (LinearLayout) convertView.findViewById(R.id.new_worker_train_item_ll);
        holder.newWorkerTrainItemShopLl = (LinearLayout) convertView.findViewById(R.id.new_worker_train_item_shop_ll);
        holder.newWorkerTrainItemTv = (TextView) convertView.findViewById(R.id.new_worker_train_item_tv);
        holder.newWorkerTrainItemTimeTv = (TextView) convertView.findViewById(R.id.new_worker_train_item_time_tv);
        holder.newWorkerTrainItemShopTv = (MarqueeTextView) convertView.findViewById(R.id.new_worker_train_item_shop_tv);
        holder.newWorkerTrainItemMentorTv = (MarqueeTextView) convertView.findViewById(R.id.new_worker_train_item_mentor_tv);
        holder.newWorkerTrainItemQueryTv = (TextView) convertView.findViewById(R.id.new_worker_train_item_query_tv);
        holder.newWorkerTrainItemTipTv = (TextView) convertView.findViewById(R.id.new_worker_train_item_tip_tv);
        holder.newWorkerTrainItemItemContent = (TextView) convertView.findViewById(R.id.new_worker_train_item_item_content);
        holder.newWorkerTrainItemManageRevaluation = (EditText) convertView.findViewById(R.id.new_worker_train_item_manage_revaluation);
        holder.newWorkerTrainItemRow = (TextView) convertView.findViewById(R.id.new_worker_train_item_row);
        holder.newWorkerTrainEditLv1 = (ListViewForScrollView) convertView.findViewById(R.id.new_worker_train_edit_lv1);
        holder.newWorkerTrainEditLv2 = (ListViewForScrollView) convertView.findViewById(R.id.new_worker_train_edit_lv2);
        holder.newWorkerTrainEditLv3 = (ListViewForScrollView) convertView.findViewById(R.id.new_worker_train_edit_lv3);
        holder.newWorkerTrainEditLv4 = (ListViewForScrollView) convertView.findViewById(R.id.new_worker_train_edit_lv4);
        convertView.setTag(holder);
        final UserWeekListEntity data = reportModuleItemEntities.getUserWeekList().get(position);
        //项目类别
        holder.newWorkerTrainItemTv.setText(data.getTrainWeekName());
        holder.newWorkerTrainItemTimeTv.setText(data.getTrainItemTime());
        if (!TextUtils.isEmpty(data.getItemTrainShopName())) {
            holder.newWorkerTrainItemShopTv.setText(data.getItemTrainShopName());
        }
        if (!TextUtils.isEmpty(data.getTrainMentorStaffName())) {
            holder.newWorkerTrainItemMentorTv.setText(data.getTrainMentorStaffName());
        }
        setView(holder, position);
        setContentView(position, holder);
        if (data.isChoice()) {
            holder.newWorkerTrainEditLv3.setVisibility(View.GONE);
            holder.newWorkerTrainEditLv4.setVisibility(View.GONE);
            holder.newWorkerTrainItemRow.setCompoundDrawables(null, null, drawableDown, null);
        } else {
            setView(holder, position);
            holder.newWorkerTrainItemRow.setCompoundDrawables(null, null, drawableUp, null);
        }
        holder.newWorkerTrainItemLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (data.isChoice()) {
                    setView(holder, position);
                    holder.newWorkerTrainItemRow.setCompoundDrawables(null, null, drawableUp, null);
                } else {
                    holder.newWorkerTrainEditLv3.setVisibility(View.GONE);
                    holder.newWorkerTrainEditLv4.setVisibility(View.GONE);
                    holder.newWorkerTrainItemRow.setCompoundDrawables(null, null, drawableDown, null);
                }
                data.setChoice(!data.isChoice());
            }
        });
        if (null != reportModuleItemEntities.getUserWeekList() && !reportModuleItemEntities.getUserWeekList().isEmpty()) {
            if (null != reportModuleItemEntities.getUserWeekList().get(position).getWeekItemList() && !reportModuleItemEntities.getUserWeekList().get(position).getWeekItemList().isEmpty()) {
                NewWorkerTrainEditChildAdapter3 mAdapter3 = new NewWorkerTrainEditChildAdapter3(context, trainMentorStaffId, reportModuleItemEntities);
                mAdapter3.setData(reportModuleItemEntities, position);
                holder.newWorkerTrainEditLv3.setAdapter(mAdapter3);
            } else {
                holder.newWorkerTrainEditLv3.setVisibility(View.GONE);
            }
            if (null != reportModuleItemEntities.getUserWeekList().get(position).getWorkerTrainTaskWirte()) {
                NewWorkerTrainEditChildAdapter5 mAdapter5 = new NewWorkerTrainEditChildAdapter5(context, trainMentorStaffId, reportModuleItemEntities);
                mAdapter5.setData(reportModuleItemEntities, position);
                holder.newWorkerTrainEditLv4.setAdapter(mAdapter5);
            } else {
                holder.newWorkerTrainEditLv4.setVisibility(View.GONE);
            }
        }
        return convertView;
    }

    private void setContentView(int position, ViewHolder holder) {
        if (null != reportModuleItemEntities.getUserWeekList() && !reportModuleItemEntities.getUserWeekList().isEmpty()) {
            String staffName = "";
            String shopName = "";
            if (StringUtil.isNotNullAndNotEmpty(reportModuleItemEntities.getUserWeekList().get(position).getItemTrainShopName())) {
                holder.newWorkerTrainItemQueryTv.setVisibility(View.VISIBLE);
                shopName = reportModuleItemEntities.getUserWeekList().get(position).getItemTrainShopName();
            }
            if (StringUtil.isNotNullAndNotEmpty(reportModuleItemEntities.getUserWeekList().get(position).getTrainMentorStaffName())) {
                holder.newWorkerTrainItemQueryTv.setVisibility(View.VISIBLE);
                staffName = "导师：" + reportModuleItemEntities.getUserWeekList().get(position).getTrainMentorStaffName();
            }
            holder.newWorkerTrainItemQueryTv.setText(staffName + "\n" + shopName);
        }
        if (position == 0) {
            if (userPostLevel.equals(ConstantParams.CONSTANT_PARAMS_5)) {
                // 主管身份才可填写主管评价
                holder.newWorkerTrainItemManageRevaluation.addTextChangedListener(new TextWatcher() {
                    @Override
                    public void beforeTextChanged(CharSequence s, int start, int count, int after) {

                    }

                    @Override
                    public void onTextChanged(CharSequence s, int start, int before, int count) {

                    }

                    @Override
                    public void afterTextChanged(Editable s) {
                        if (!TextUtils.isEmpty(s))
                            //将主管评估填充到数据列表中
                            reportModuleItemEntities.setManagerEvaluation(s.toString());
                    }
                });
            } else {
                holder.newWorkerTrainItemManageRevaluation.addTextChangedListener(null);
                holder.newWorkerTrainItemManageRevaluation.setFocusable(false);
                if (!StringUtil.isNotNullAndNotEmpty(reportModuleItemEntities.getManagerEvaluation())) {//如果主管未评价，
                    holder.newWorkerTrainItemManageRevaluation.setHint("主管未评价");
                }
            }
            holder.newWorkerTrainItemTipTv.setVisibility(View.VISIBLE);
            holder.newWorkerTrainItemManageRevaluationLl.setVisibility(View.VISIBLE);
            if (StringUtil.isNotNullAndNotEmpty(reportModuleItemEntities.getItemContent())) {//有导师评价则显示
                holder.newWorkerTrainItemItemContentLl.setVisibility(View.VISIBLE);
                holder.newWorkerTrainItemItemContent.setText(reportModuleItemEntities.getItemContent());
            }
            if (StringUtil.isNotNullAndNotEmpty(reportModuleItemEntities.getManagerEvaluation())) {//有主管评价则显示
                holder.newWorkerTrainItemManageRevaluationLl.setVisibility(View.VISIBLE);
                holder.newWorkerTrainItemManageRevaluation.setHint(reportModuleItemEntities.getManagerEvaluation());
            }
        } else {
            holder.newWorkerTrainItemTipTv.setVisibility(View.GONE);
            holder.newWorkerTrainItemItemContentLl.setVisibility(View.GONE);
            holder.newWorkerTrainItemManageRevaluationLl.setVisibility(View.GONE);
        }
    }

    private void setView(ViewHolder holder, int position) {
        holder.newWorkerTrainItemShopLl.setVisibility(View.GONE);
        holder.newWorkerTrainItemTimeTv.setOnClickListener(null);
        holder.newWorkerTrainItemTimeTv.setCompoundDrawables(null, null, null, null);
        holder.newWorkerTrainEditLv1.setVisibility(View.GONE);
        holder.newWorkerTrainEditLv2.setVisibility(View.GONE);
        holder.newWorkerTrainEditLv3.setVisibility(View.VISIBLE);
        holder.newWorkerTrainEditLv4.setVisibility(View.VISIBLE);
    }
}