package com.wgmf.yxgj.module.business.employability.newworkertrain.ui;

import android.os.Bundle;
import android.support.v4.app.FragmentTransaction;
import android.view.View;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.wgmf.yxgj.base.BackHandledInterface;
import com.wgmf.yxgj.base.BaseBackHandledFragment;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.module.business.employability.R;
import com.xp.arouter.RouterParams;

@Route(path = RouterParams.URL_NEW_WORKER_LIST_ACTIVITY)
public class NewWorkerListActivity extends BaseParentAct implements BackHandledInterface {
    private BaseBackHandledFragment mBackHandedFragment;
    String branchTitle;
    Long branchID;

    @Override
    protected void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        branchID = getIntent().getLongExtra("branchID", 0);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText(branchTitle);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_report_module_list);
        initTitle();
        initFragment();
    }

    private void initFragment() {
        NewWorkerListFragment newWorkerListFragment = new NewWorkerListFragment();
        Bundle bundle = new Bundle();
        bundle.putString("branchTitle", branchTitle);
        bundle.putLong("branchID", branchID);
        newWorkerListFragment.setArguments(bundle);
        loadFragment("newWorkerListFragment", newWorkerListFragment);
    }

    /**
     * 加载内容
     *
     * @param tag      标签
     * @param fragment 内容
     */
    public void loadFragment(String tag, BaseBackHandledFragment fragment) {
        FragmentTransaction ft = getSupportFragmentManager().beginTransaction();
        ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_OPEN);
        ft.replace(R.id.report_module_list_fl, fragment);
        ft.addToBackStack(tag);
        ft.commit();
    }


    @Override
    public void setSelectedFragment(BaseBackHandledFragment selectedFragment) {
        this.mBackHandedFragment = selectedFragment;
    }

    @Override
    public void onBackPressed() {
        if (mBackHandedFragment == null || !mBackHandedFragment.onBackPressed()) {
            if (getFragmentManager().getBackStackEntryCount() == 0) {
                this.finish();
            } else {
                getFragmentManager().popBackStack();
            }
        }
    }

    @Override
    protected void back() {
        //使Fragment界面一级级返回
        onBackPressed();
    }
}