package com.wgmf.yxgj.module.business.employability.newworkertrain.ui;

import android.app.DatePickerDialog;
import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.DatePicker;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.NewWorkerTrainUserEntity;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.WeekTitleListEntity;
import com.wgmf.yxgj.utils.helper.DialogHelper;

import java.util.Calendar;

@SuppressWarnings("all")
public class NewWorkerTrainEditChildAdapter2 extends BaseAdapter implements DialogHelper.DialogResult {
    private int index;
    private Context context;
    private NewWorkerTrainUserEntity weekItemListEntities = new NewWorkerTrainUserEntity();

    ClickListener clickListener;
    /**
     * 缓存选择培训时间TextView
     */
    private TextView selectTimeView;

    @Override
    public void onDialogResult(int tag) {
        clickListener.trainItemTimeClick(weekItemListEntities);
    }

    public interface ClickListener {
        void trainItemTimeClick(NewWorkerTrainUserEntity newWorkerTrainUserEntity);
    }

    public void setListener(ClickListener listener) {
        this.clickListener = listener;
    }

    public void setData(NewWorkerTrainUserEntity newWorkerTrainUserEntity, int index) {
        this.index = index;
        this.weekItemListEntities = newWorkerTrainUserEntity;
    }

    public NewWorkerTrainEditChildAdapter2(Context context, ClickListener clickListener, NewWorkerTrainUserEntity weekItemListEntities) {
        this.context = context;
        this.clickListener = clickListener;
        this.weekItemListEntities = weekItemListEntities;
        selectTimeView = new TextView(context);
    }

    @Override
    public int getCount() {
        return weekItemListEntities.getUserWeekList().get(index).getWeekTitleList() == null ? 0 : weekItemListEntities.getUserWeekList().get(index).getWeekTitleList().size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        TextView titleNameTv;
        TextView titleTimeTv;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder = new ViewHolder();
        convertView = LayoutInflater.from(context).inflate(R.layout.new_worker_train_edit_title_item, null);
        holder.titleNameTv = (TextView) convertView.findViewById(R.id.title_name_tv);
        holder.titleTimeTv = (TextView) convertView.findViewById(R.id.title_time_tv);
        convertView.setTag(holder);
        final WeekTitleListEntity data = weekItemListEntities.getUserWeekList().get(index).getWeekTitleList().get(position);
        //项目名称
        holder.titleNameTv.setText(data.getTitleName());
        if (!TextUtils.isEmpty(weekItemListEntities.getManagerWithTrainTime())) {
            holder.titleTimeTv.setText(weekItemListEntities.getManagerWithTrainTime());
            holder.titleTimeTv.setTextColor(ContextCompat.getColor(context, R.color.important_txt_color));
        }
        holder.titleTimeTv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                AlertDatePicker(weekItemListEntities, data, context, NewWorkerTrainEditChildAdapter2.this, holder.titleTimeTv);
                holder.titleTimeTv.setTextColor(ContextCompat.getColor(context, R.color.important_txt_color));
            }
        });
        return convertView;
    }

    /**
     * 日期选择控件
     *
     * @param context
     * @param textView 回显控件
     */
    public static void AlertDatePicker(final NewWorkerTrainUserEntity weekItemListEntities, final WeekTitleListEntity data, final Context context, final DialogHelper.DialogResult dialog, final TextView textView) {
        Calendar c = Calendar.getInstance();
        DatePickerDialog.OnDateSetListener dateListener = new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {

                String month;
                String day;
                if (monthOfYear + 1 < 10) {
                    month = "0" + (monthOfYear + 1);
                } else {
                    month = "" + (monthOfYear + 1);
                }
                if (dayOfMonth < 10) {
                    day = "0" + dayOfMonth;
                } else {
                    day = "" + dayOfMonth;
                }
                textView.setText(year + "-" + month + "-" + day);
                //将选择的日期填充到数据列表中
                weekItemListEntities.setManagerWithTrainTime(textView.getText().toString());
                data.setTitleTime(textView.getText().toString());
                dialog.onDialogResult(6);
            }
        };
        DatePickerDialog datePickerDialog = new DatePickerDialog(context, android.R.style.Theme_Holo_Light_Panel,
                dateListener, c.get(Calendar.YEAR), c.get(Calendar.MONTH),
                c.get(Calendar.DAY_OF_MONTH));
        // 对话框周围不可点击
        datePickerDialog.setCanceledOnTouchOutside(false);
        datePickerDialog.show();
    }
}