package com.wgmf.yxgj.module.business.employability.newworkertrain.ui;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoEntity;

import java.util.List;

@SuppressWarnings("all")
public class NewWorkerTrainListAdapter extends BaseAdapter {
    private int type;
    private Context context;
    private List<UserInfoEntity> reportModuleItemEntities;

    private ClickListener clickListener;

    public interface ClickListener {
        void newWorkerTrainAdapterClick(UserInfoEntity data, int postion);
    }

    public NewWorkerTrainListAdapter(Context context, ClickListener clickListener, int type, List<UserInfoEntity> reportModuleItemEntities) {
        this.type = type;
        this.context = context;
        this.clickListener = clickListener;
        this.reportModuleItemEntities = reportModuleItemEntities;
    }

    public List<UserInfoEntity> getUploadData() {
        return reportModuleItemEntities;
    }

    @Override
    public int getCount() {
        return reportModuleItemEntities == null ? 0 : reportModuleItemEntities.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        LinearLayout reportModuleListItemLl;
        TextView reportModuleListItemTitle;
        TextView reportModuleListItemNecessary;
        TextView reportModuleItemStatus;
        TextView reportModuleItemStatusRow;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.report_module_list_item, null);
            holder.reportModuleListItemLl = (LinearLayout) convertView.findViewById(R.id.report_module_list_item_ll);
            holder.reportModuleListItemTitle = (TextView) convertView.findViewById(R.id.report_module_list_item_title);
            holder.reportModuleListItemNecessary = (TextView) convertView.findViewById(R.id.report_module_list_item_necessary);
            holder.reportModuleItemStatus = (TextView) convertView.findViewById(R.id.report_module_item_status);
            holder.reportModuleItemStatusRow = (TextView) convertView.findViewById(R.id.report_module_item_status_row);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final UserInfoEntity data = reportModuleItemEntities.get(position);
        holder.reportModuleListItemTitle.setText(data.getName());

        if (type == 0) {
            holder.reportModuleItemStatus.setVisibility(View.VISIBLE);
            //新顾问标识（顾问能力评估使用）：0表示是新顾问；1表示不是 ,不是新顾问可评估，否则不能
            if ("0".equals(data.getIsNewWorkerFlag())) {
                holder.reportModuleItemStatusRow.setVisibility(View.VISIBLE);
                //assignedMentorFlag (string, optional):导师分配标识：0表示已分配；1未分配 ,
                if ("0".equals(data.getAssignedMentorFlag())) {
                    holder.reportModuleItemStatus.setText("已分配");
                    holder.reportModuleItemStatus.setTextColor(ContextCompat.getColor(context, R.color.green));
                } else if ("1".equals(data.getAssignedMentorFlag())) {
                    holder.reportModuleItemStatus.setText("未分配");
                    holder.reportModuleItemStatus.setTextColor(ContextCompat.getColor(context, R.color.red));
                }
                holder.reportModuleListItemLl.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        clickListener.newWorkerTrainAdapterClick(data, position);
                    }
                });
            } else if ("1".equals(data.getIsNewWorkerFlag())) {
                holder.reportModuleListItemLl.setOnClickListener(null);
                holder.reportModuleItemStatusRow.setVisibility(View.GONE);
                holder.reportModuleItemStatus.setText("该顾问不是新入职顾问");
                holder.reportModuleItemStatus.setTextColor(ContextCompat.getColor(context, R.color.red));
            }
        } else if (type == 1) {
            holder.reportModuleItemStatus.setVisibility(View.INVISIBLE);
            holder.reportModuleListItemLl.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    clickListener.newWorkerTrainAdapterClick(data, position);
                }
            });
        }
        return convertView;
    }
}