package com.wgmf.yxgj.module.business.employability.newworkertrain.ui;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseBackHandledFragment;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.newworkertrain.service.NewWorkerTrainService;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoListEntity;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;

import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.List;

public class NewWorkerTrainListFragment extends BaseBackHandledFragment implements NewWorkerTrainListAdapter.ClickListener {
    String branchTitle;
    Long branchID;
    /**
     * 0:导师分配/1:入职评估
     */
    int type;
    private ClearEditText storeNameEt;
    private ListView mListView;
    private LinearLayout reportContentConfirmLl;
    private NewWorkerTrainListAdapter newWorkerTrainListAdapter;
    private List<UserInfoEntity> reportModuleProjectListResultEntities;
    private List<UserInfoEntity> reportModuleProjectListResultEntitiesShow;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        branchTitle = getArguments().getString("branchTitle");
        branchID = getArguments().getLong("branchID", 0);
    }


    @Override
    public View onCreateView(@NotNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_new_worker_train_list, container, false);
        // 防止点击穿透，底层的fragment响应上层点击触摸事件
        view.setClickable(true);
        initView(view);
        return view;
    }

    @Override
    public void onResume() {
        super.onResume();
        getData();
    }

    public void getData() {
        if (null != userInfo) {
            if (branchID == 702L) {//导师分配
                type = 0;
                showDialog();
                NewWorkerTrainService.getInstance().requestQueryWorkerTrainMain(userInfo.getStaffId(), userInfo.getOrganizationId(), userInfo.getOrganizationCode(), userInfo.getUserPostLevel(), this);

            } else if (branchID == 703L) {//入职评估
                type = 1;
                showDialog();
                reportContentConfirmLl.setVisibility(View.GONE);
                NewWorkerTrainService.getInstance().requestQueryNotEvaluatedUser(userInfo.getStaffId(), this);
            }
        }
    }

    private void initView(View view) {
        mListView = (ListView) view.findViewById(R.id.public_list_view_lv);
        storeNameEt = (ClearEditText) view.findViewById(R.id.store_name_et);
        TextView dataEmpty = (TextView) view.findViewById(R.id.public_list_view_empty_tv);
        reportContentConfirmLl = (LinearLayout) view.findViewById(R.id.report_content_confirm_ll);
        Button reportContentConfirmBtn = (Button) view.findViewById(R.id.report_content_confirm_btn);
        reportContentConfirmBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent();
                intent.setClass(getActivity(), NewWorkerDistributionActivity.class);
                intent.putExtra("branchTitle", branchTitle);
                intent.putExtra("branchID", branchID);
                startActivity(intent);
            }
        });
        reportContentConfirmBtn.setText(getString(R.string.add_new_worker_name));
        storeNameEt.setHint(getString(R.string.query_new_worker_name));
        mListView.setEmptyView(dataEmpty);
        mListView.setVisibility(View.VISIBLE);
        storeNameEt.setVisibility(View.VISIBLE);
        reportContentConfirmLl.setVisibility(View.VISIBLE);
        setListener();
    }

    protected void setListener() {
        storeNameEt.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                textChanged();
            }
        });
    }


    public void textChanged() {
        if (null == reportModuleProjectListResultEntitiesShow) {
            reportModuleProjectListResultEntitiesShow = new ArrayList<>();
        }
        String itemId = storeNameEt.getText().toString().trim();
        if (TextUtils.isEmpty(itemId)) {
            reportModuleProjectListResultEntitiesShow.clear();
            if (null != reportModuleProjectListResultEntities) {
                reportModuleProjectListResultEntitiesShow.addAll(reportModuleProjectListResultEntities);
            }

        } else {
            reportModuleProjectListResultEntitiesShow.clear();
            if (null != reportModuleProjectListResultEntities) {
                for (UserInfoEntity p : reportModuleProjectListResultEntities) {
                    if (null != p.getName()) {
                        if (p.getName().contains(itemId)) {
                            reportModuleProjectListResultEntitiesShow.add(p);
                        }
                    }
                }
            }
        }
        newWorkerTrainListAdapter = new NewWorkerTrainListAdapter(getActivity(), this, type, reportModuleProjectListResultEntitiesShow);
        mListView.setAdapter(newWorkerTrainListAdapter);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.EmployAbility.MSG_ON_QUERY_WORKER_TRAIN_MAIN
                    || id == BusinessID.EmployAbility.MSG_ON_QUERY_NOT_EVALUATED_USER) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    UserInfoListEntity reportModuleProjectListResultEntity = new Gson().fromJson(msg, UserInfoListEntity.class);
                    Log.d(TAG, "reportModuleProjectListResultEntity" + reportModuleProjectListResultEntity);
                    if (null != reportModuleProjectListResultEntity && null != reportModuleProjectListResultEntity.getResultList() && ConstantParams.CONSTANT_PARAMS_0.equals(reportModuleProjectListResultEntity.retCode)) {
                        reportModuleProjectListResultEntities = reportModuleProjectListResultEntity.getResultList();
                        newWorkerTrainListAdapter = new NewWorkerTrainListAdapter(getActivity(), this, type, reportModuleProjectListResultEntities);
                        mListView.setAdapter(newWorkerTrainListAdapter);
                    }
                }
            }
        }
    }

    @Override
    public boolean onBackPressed() {
        return false;
    }

    @Override
    public void newWorkerTrainAdapterClick(UserInfoEntity data, int position) {
        Intent intent = new Intent();
        if (branchID == 702L) {//导师分配
            intent.setClass(getActivity(), NewWorkerDistributionActivity.class);
        } else if (branchID == 703L) {//入职评估
            intent.setClass(getActivity(), NewWorkerEvaluateActivity.class);
        }
        intent.putExtra("branchTitle", branchTitle);
        intent.putExtra("branchID", branchID);
        intent.putExtra("ids", data.getEntryIds());
        intent.putExtra("staffId", data.getStaffId());
        intent.putExtra("staffName", data.getName());
        intent.putExtra("wgmfWorkDate", data.getWgmfWorkDate());
        startActivity(intent);
    }
}