package com.wgmf.yxgj.module.business.employability.newworkertrain.ui;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.NewWorkerTrainPopEntity;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;

import java.util.List;

/**
 * 培训内容弹窗
 * 作者：xiep on 2019/10/14 10:37
 * 邮箱：2975837870@qq.com
 */

public class NewWorkerTrainPop {

    private PopupWindow popupWindow;

    private View viewParent;

    NewWorkerTrainPop(final Context context, List<NewWorkerTrainPopEntity> shopProductHistorySaleEntitys) {
        this(context, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, shopProductHistorySaleEntitys);
    }

    private NewWorkerTrainPop(final Context context, final int width, final int height, List<NewWorkerTrainPopEntity> newWorkerTrainPopEntities) {

        LayoutInflater inflater = LayoutInflater.from(context);
        viewParent = inflater.inflate(R.layout.employ_ability_pop, null);

        ListViewForScrollView publicListViewLv = (ListViewForScrollView) viewParent.findViewById(R.id.public_list_view_lv);
        LinearLayout reportContentConfirmLl = (LinearLayout) viewParent.findViewById(R.id.report_content_confirm_ll);
        TextView reportContentModifyBtn = (TextView) viewParent.findViewById(R.id.report_content_modify_btn);
        TextView reportContentConfirmBtn = (TextView) viewParent.findViewById(R.id.report_content_confirm_btn);
        TextView employAbilityPopHeader = (TextView) viewParent.findViewById(R.id.employ_ability_pop_header);
        employAbilityPopHeader.setVisibility(View.GONE);

        reportContentModifyBtn.setTextColor(ContextCompat.getColor(context, R.color.important_txt_color));
        reportContentModifyBtn.setBackground(ContextCompat.getDrawable(context, R.drawable.btn_photo_cancel_sharp_selector));
        reportContentConfirmLl.setVisibility(View.VISIBLE);
        reportContentConfirmBtn.setTextColor(ContextCompat.getColor(context, R.color.important_txt_color));
        reportContentConfirmBtn.setBackground(ContextCompat.getDrawable(context, R.drawable.btn_photo_cancel_sharp_selector));
        reportContentConfirmBtn.setText("关闭");

        //为列表添加空布局
        View emptyView = viewParent.findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) viewParent.findViewById(R.id.public_list_view_empty_iv);
        Glide.with(context).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        publicListViewLv.setEmptyView(emptyView);
        if (null != newWorkerTrainPopEntities && !newWorkerTrainPopEntities.isEmpty()) {
            NewWorkerTrainPopAdapter typeAdapter = new NewWorkerTrainPopAdapter(newWorkerTrainPopEntities, context);
            publicListViewLv.setAdapter(typeAdapter);
            popupWindow = new PopupWindow(viewParent, width, height, true);
        }
        reportContentConfirmLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                popupWindow.dismiss();
            }
        });
        reportContentModifyBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                popupWindow.dismiss();
            }
        });
        reportContentConfirmBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                popupWindow.dismiss();
            }
        });
    }

    boolean isShowing() {
        return null != popupWindow && popupWindow.isShowing();
    }

    void show(View parent) {
        if (null == parent) {
            throw new IllegalArgumentException("showAtLocation parent is null");
        }
        viewParent = parent;
        popupWindow.showAtLocation(parent, Gravity.CENTER, 0, 0);
    }
}