package com.wgmf.yxgj.module.business.employability.newworkertrain.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.NewWorkerTrainPopContentEntity;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.NewWorkerTrainPopEntity;

import java.util.List;

/**
 * 培训内容弹窗适配器
 * 作者：xiep on 2019/10/14 10:42
 * 邮箱：2975837870@qq.com
 */
public class NewWorkerTrainPopAdapter extends BaseAdapter {
    private Context context;
    private List<NewWorkerTrainPopEntity> list;

    NewWorkerTrainPopAdapter(List<NewWorkerTrainPopEntity> list, Context context) {
        super();
        this.list = list;
        this.context = context;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {
        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.new_worker_train_pop_item, null);
            viewHolder = new ViewHolder();
            viewHolder.newWorkerTrainTitle = (TextView) convertView.findViewById(R.id.new_worker_train_title);
            viewHolder.newWorkerTrainContent = (TextView) convertView.findViewById(R.id.new_worker_train_content);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        if (list != null && !list.isEmpty()) {
            viewHolder.newWorkerTrainTitle.setText(list.get(position).getTrainContentTitle());
            List<NewWorkerTrainPopContentEntity> newWorkerTrainPopContentEntities = list.get(position).getTrainTitleContent();
            String content = "";
            for (NewWorkerTrainPopContentEntity newWorkerTrainPopContentEntity : newWorkerTrainPopContentEntities) {
                content += newWorkerTrainPopContentEntity.getTrainTitleContent() + "\n";
            }
            viewHolder.newWorkerTrainContent.setText(content);
        }
        return convertView;
    }

    class ViewHolder {
        TextView newWorkerTrainTitle;
        TextView newWorkerTrainContent;
    }
}