package com.wgmf.yxgj.module.business.employability.newworkertrain.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoListEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.service.EmployAbilityService;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;

/**
 * 员工培训导师分配：选择导师
 */
@SuppressWarnings("all")
public class SelectorMentorStaffActivity extends SelectorBaseActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getShopList();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText("选择导师");
    }

    @Override
    public void initContent() {
        super.initContent();
        mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                mAdapter.notifyDataSetChanged();
                Long branchID = getIntent().getLongExtra("branchID", 0);
                Bundle mBundle = new Bundle();
                mBundle.putLong("branchID", branchID);
                mBundle.putString("branchTitle", branchTitle);
                mBundle.putString("mentorStaffId", listShow.get(position).getSelectorId());
                mBundle.putString("mentorStaffName", listShow.get(position).getSelectorName());
                Intent intent = new Intent();
                intent.putExtras(mBundle);
                setResult(RESULTCODE, intent);
                SelectorMentorStaffActivity.this.finish();
            }
        });
    }

    private void getShopList() {
        if (null != userInfo) {
            showDialog();
            storeNameEt.setHint(getString(R.string.report_module_by_person_search));
            EmployAbilityService.getInstance().requestFindUserList(userInfo.getOrganizationId(), userInfo.getOrganizationCode(), userInfo.getUserPostLevel(), this);

        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.EmployAbility.MSG_ON_FIND_USER_LIST) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    UserInfoListEntity userInfoListEntity = new Gson().fromJson(msg, UserInfoListEntity.class);
                    Log.d(TAG, "userInfoListEntity" + userInfoListEntity);
                    if (null != userInfoListEntity && null != userInfoListEntity.getResultList() && ConstantParams.CONSTANT_PARAMS_0.equals(userInfoListEntity.retCode)) {
                        listShow.clear();
                        //先添加本人
                        BaseSelectorEntity baseSelectorEntity = new BaseSelectorEntity();
                        baseSelectorEntity.setSelectorId(userInfo.getStaffId());
                        baseSelectorEntity.setSelectorName(userInfo.getName());
                        listShow.add(baseSelectorEntity);
                        //再添加老顾问
                        for (UserInfoEntity userInfoEntity : userInfoListEntity.getResultList()) {
                            //如果是老顾问则添加，否则不添加
                            //sNewWorkerFlag (string, optional):是新顾问标识（顾问能力评估使用）：0表示是新顾问；1表示不是
                            if ("1".equals(userInfoEntity.getIsNewWorkerFlag())) {
                                BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
                                mBaseSelectorEntity.setSelectorId(userInfoEntity.getStaffId());
                                mBaseSelectorEntity.setSelectorName(userInfoEntity.getName());
                                listShow.add(mBaseSelectorEntity);
                            }
                        }
                        mAdapter.notifyDataSetChanged();
                        search();
                    }
                }
            }
        }
    }
}