package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.global.LocationParams;
import com.wgmf.library.utils.LocationUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.AbilityItemsEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.AbilityItemsListEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.AbilityItemsResponse;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.EmployItemsTrainRecordsResponse;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.service.EmployAbilityRankUtil;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.service.EmployAbilityService;
import com.wgmf.yxgj.pop.PublicSelectPop;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;

import java.util.ArrayList;
import java.util.List;

/**
 * 员工能力评估填写页面
 */
public class EmployAbilityEditActivity extends BaseParentAct implements EmployAbilityEditAdapter.ClickListener, PublicSelectPop.ReportQuerySelectPopListener, NumSelectPop.ReportQuerySelectPopListener {
    String branchTitle;
    Long branchID;
    String titleId;
    String titleName;
    String staffId;
    String staffName;
    ListView mListView;
    EmployAbilityEditAdapter employAbilityEditAdapter;
    AbilityItemsListEntity abilityItemsListEntity;
    TextView employAbilityHeaderStaffName;
    TextView employAbilityHeaderStaffRank;
    LinearLayout reportContentConfirmLl;
    Button reportContentModifyBtn;
    Button reportContentConfirmBtn;
    PublicSelectPop publicSelectPop;
    private List<BaseSelectorEntity> dataRanges = new ArrayList<>();
    /**
     * dataRange: 顾问等级：初级-1；中级-2；高级-3
     */
    private String[] dataRange = new String[]{"初级", "中级", "高级"};

    private String storeLatitudes;
    private String storeLongitudes;

    /**
     * 给Spinner提供的数据源
     */
    private String[] dataRange2 = new String[]{"1", "2", "3"};

    private List<BaseSelectorEntity> dataRanges2 = new ArrayList<>();

    @Override
    protected void initTitle() {
        super.initTitle();
        staffId = getIntent().getStringExtra("staffId");
        staffName = getIntent().getStringExtra("staffName");
        branchTitle = getIntent().getStringExtra("branchTitle");
        branchID = getIntent().getLongExtra("branchID", 0);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText(branchTitle);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.employ_ability_edit_activity);
        initTitle();
        initData();
        initView();
        findEmployAbility("staffId=" + staffId + "&titleId=" + titleId);
    }

    private void initData() {
        storeLatitudes = getIntent().getStringExtra("storeLatitudes");
        storeLongitudes = getIntent().getStringExtra("storeLongitudes");
        titleId = getIntent().getStringExtra("titleId");
        titleName = getIntent().getStringExtra("titleName");
    }

    private void initView() {
        reportContentConfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentModifyBtn = (Button) findViewById(R.id.report_content_modify_btn);
        reportContentConfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        employAbilityHeaderStaffName = (TextView) findViewById(R.id.employ_ability_header_staff_name);
        employAbilityHeaderStaffRank = (TextView) findViewById(R.id.employ_ability_header_staff_rank);
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        abilityItemsListEntity = new AbilityItemsListEntity();
        employAbilityEditAdapter = new EmployAbilityEditAdapter(this, this, abilityItemsListEntity);
        mListView.setAdapter(employAbilityEditAdapter);
        mListView.setVisibility(View.VISIBLE);
        reportContentModifyBtn.setVisibility(View.VISIBLE);
        reportContentConfirmBtn.setVisibility(View.VISIBLE);
        employAbilityHeaderStaffName.setText(staffName);
        reportContentModifyBtn.setText(R.string.save_btn_txt);
        reportContentConfirmBtn.setText(R.string.cancel_btn_txt);
        reportContentModifyBtn.setTextColor(ContextCompat.getColor(this, R.color.white));
        reportContentConfirmBtn.setTextColor(ContextCompat.getColor(this, R.color.important_txt_color));
        reportContentModifyBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.selector_orange_fill_round_btn));
        reportContentConfirmBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_photo_cancel_sharp_selector));
        if (branchID == 706L) {
            //如果是顾问能力查询，不显示保存和取消按钮
            reportContentModifyBtn.setVisibility(View.GONE);
            reportContentConfirmBtn.setVisibility(View.GONE);
        }
        reportContentConfirmBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                EmployAbilityEditActivity.this.finish();
            }
        });
        reportContentModifyBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //判断当前位置是否在所选门店的范围内，如果不是，提示“你当前位置不在门店内，是否确定提交”。
                //先计算距离，只有当所在位置在门店范围内（3000米）才允许进行意见审批
                if (!TextUtils.isEmpty(storeLatitudes) && !TextUtils.isEmpty(storeLongitudes)) {
                    if (!checkRange()) {//检查位置不通过
                        showTipDialog();
                    } else {//检查位置通过
                        updateData(1);//培训是否在店内：0无法确定，1在店内，2不在店内
                    }
                } else {
                    updateData(0);//位置判断正常假设为1
                }
            }
        });
        employAbilityHeaderStaffName.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                EmployAbilityEditActivity.this.finish();
            }
        });
        employAbilityHeaderStaffRank.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //点击弹出等级选择对话框
                if (null == publicSelectPop) {
                    publicSelectPop = new PublicSelectPop(EmployAbilityEditActivity.this, EmployAbilityEditActivity.this, getDataRange());
                }
                if (!publicSelectPop.isShowing()) {
                    publicSelectPop.show(EmployAbilityEditActivity.this.findViewById(R.id.title));
                }
            }
        });
    }

    /**
     * 培训是否在店内
     *
     * @param flag 0无法确定，1在店内，2不在店内
     */
    private void updateData(int flag) {
        showDialog();
        List<AbilityItemsEntity> reportModuleItemEntities = employAbilityEditAdapter.getUploadData();
        AbilityItemsListEntity uploadEntity = new AbilityItemsListEntity();
        uploadEntity.setAbilityItemsList(reportModuleItemEntities);
        uploadEntity.setTitleId(titleId);
        uploadEntity.setTitleName(titleName);
        uploadEntity.setEmployStaffName(staffName);
        uploadEntity.setCreateEmployStaffId(userInfo.getStaffId());
        uploadEntity.setEmployStaffId(abilityItemsListEntity.getEmployStaffId());
        uploadEntity.setTrainigInStore(flag);
        uploadEntity.setEmployAbilityLevel(EmployAbilityRankUtil.setEmployAbilityLevel(employAbilityHeaderStaffRank.getText().toString()));

        String content = new Gson().toJson(uploadEntity);
        Log.d(TAG, content);
        EmployAbilityService.getInstance().requestSaveEmployAbilityBean(content, EmployAbilityEditActivity.this);
    }

    List<BaseSelectorEntity> getDataRange() {
        for (int i = 0; i < dataRange.length; i++) {
            BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
            mBaseSelectorEntity.setSelectorName(dataRange[i]);
            mBaseSelectorEntity.setSelectorId(i + 1 + "");
            dataRanges.add(mBaseSelectorEntity);
        }
        return dataRanges;
    }

    /**
     * @param : "staffId=" + staffId + "&abilityLevel=" + level 顾问等级：默认初级
     *          <p>
     *          private void findEmployAbility(String params) {
     */
    private void findEmployAbility(String params) {
        if (null != userInfo) {
            showDialog();
            EmployAbilityService.getInstance().requestFindEmployAbility(params, this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.EmployAbility.MSG_ON_FIND_EMPLOY_ABILITY: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        AbilityItemsResponse abilityItemsResponse = new Gson().fromJson(msg, AbilityItemsResponse.class);
                        Log.d(TAG, "abilityItemsResponse" + abilityItemsResponse);
                        if (null != abilityItemsResponse && null != abilityItemsResponse.getResult() && ConstantParams.CONSTANT_PARAMS_0.equals(abilityItemsResponse.retCode)) {
                            //员工能力评估
                            abilityItemsListEntity = abilityItemsResponse.getResult();
                            employAbilityEditAdapter = new EmployAbilityEditAdapter(this, this, abilityItemsListEntity);
                            mListView.setAdapter(employAbilityEditAdapter);
                            reportContentConfirmLl.setVisibility(View.VISIBLE);
                            reportContentConfirmBtn.setTextColor(ContextCompat.getColor(this, R.color.important_txt_color));
                            reportContentConfirmBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_photo_cancel_sharp_selector));
                            employAbilityHeaderStaffRank.setText(EmployAbilityRankUtil.getEmployAbilityLevel(abilityItemsListEntity.getEmployAbilityLevel()));
                        }
                    }
                }
                break;
                case BusinessID.EmployAbility.MSG_ON_SAVE_EMPLOY_ABILITY_BEAN: {
                    if (result.isSuccessed()) {
                        final String msg = result.getInfo();
                        if (result.isSuccessed()) {
                            BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                            Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                            showMsg(mBaseResponse.retInfo);
                            if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                                EmployAbilityEditActivity.this.finish();
                            }
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    }
                }
                break;
                case BusinessID.EmployAbility.MSG_ON_FIND_EMPLOY_ITEMS_TRAIN_RECORDS: {
                    if (result.isSuccessed()) {
                        final String msg = result.getInfo();
                        if (result.isSuccessed()) {
                            EmployItemsTrainRecordsResponse employItemsTrainRecordsResponse = new Gson().fromJson(msg, EmployItemsTrainRecordsResponse.class);
                            Log.d(TAG, "employItemsTrainRecordsResponse=" + employItemsTrainRecordsResponse.toString());
                            if (ConstantParams.CONSTANT_PARAMS_0.equals(employItemsTrainRecordsResponse.retCode)) {
                                if (null != employItemsTrainRecordsResponse.getResultList() && !employItemsTrainRecordsResponse.getResultList().isEmpty()) {
                                    //显示培训记录
                                    EmployAbilityPop employAbilityPop = new EmployAbilityPop(this, employItemsTrainRecordsResponse.getResultList());
                                    if (!employAbilityPop.isShowing()) {
                                        employAbilityPop.show(this.findViewById(R.id.title));
                                    }
                                } else {
                                    showMsg("未查询到此类培训记录！");
                                }
                            }
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    /**
     * 只有当所在位置在门店范围内（3000米）才允许进行意见审批（之前是500米）
     *
     * @return 是否在门店范围内（3000米）true:是
     */
    private boolean checkRange() {
        double distance = LocationUtil.getDistance
                (StringUtil.toDouble(storeLatitudes),
                        StringUtil.toDouble(storeLongitudes),
                        StringUtil.toDouble(LocationParams.Latitude),
                        StringUtil.toDouble(LocationParams.Longitude));

        if (distance <= 3000) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 显示不在范围内提示框
     */
    private void showTipDialog() {
        String dialogShowTip;
        try {
            double distance = LocationUtil.getDistance
                    (StringUtil.toDouble(storeLatitudes),
                            StringUtil.toDouble(storeLongitudes),
                            StringUtil.toDouble(LocationParams.Latitude),
                            StringUtil.toDouble(LocationParams.Longitude));
            //（OE返回的经纬度XX和XX，本机定位的经纬度XX和XX，相距XXX米）
            dialogShowTip = "(OE返回的经纬度" + storeLongitudes + "和" + storeLatitudes + ",本机定位的经纬度" + LocationParams.Longitude + "和" + LocationParams.Latitude + "相距" + StringUtil.formatDouble(distance, "0.0") + "米)";
        } catch (Exception e) {
            dialogShowTip = "获取定位失败，请重新定位！";
        }

        new AlertDialog.Builder(this).setTitle("提示")
                .setTitle("你当前位置不在门店内，是否确定提交?")
                .setNegativeButton("取消", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                })
                .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        updateData(2);
                        dialog.dismiss();
                    }
                }).show();
    }

    NumSelectPop selectPop;

    private void setSelectPop(int postion) {
        selectPop = new NumSelectPop(this, this, getDataRange2(), postion);
        if (!selectPop.isShowing()) {
            selectPop.show(this.findViewById(R.id.title));
        }
    }

    private List<BaseSelectorEntity> getDataRange2() {
        dataRanges2.clear();
        for (int i = 0; i < dataRange2.length; i++) {
            BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
            mBaseSelectorEntity.setSelectorName(dataRange2[i]);
            mBaseSelectorEntity.setSelectorId(i + 1 + "");
            dataRanges2.add(mBaseSelectorEntity);
        }
        return dataRanges2;
    }

    @Override
    public void onAdapterItemClick(int position, List<BaseSelectorEntity> reportQuerys) {
        showDialog();
        findEmployAbility("staffId=" + staffId + "&titleId=" + titleId + "&abilityLevel=" + EmployAbilityRankUtil.setEmployAbilityLevel(reportQuerys.get(position).getSelectorName()));
    }

    @Override
    public void employAbilityItemQueryClick(AbilityItemsEntity data, int postion) {
        showDialog();
        EmployAbilityService.getInstance().requestFindEmployItemsTrainRecords(staffId, data.getItemsId(), titleName,this);
    }

    @Override
    public void employAbilityItemNumClick(AbilityItemsEntity data, int position) {
        setSelectPop(position);
    }

    @Override
    public void onAdapterNumClick(int selectPos, int position, List<BaseSelectorEntity> reportQuerys) {
        //刷新培训次数
        abilityItemsListEntity.getAbilityItemsList().get(selectPos).setTrainigNum(reportQuerys.get(position).getSelectorName());
        employAbilityEditAdapter = new EmployAbilityEditAdapter(this, this, abilityItemsListEntity);
        mListView.setAdapter(employAbilityEditAdapter);
    }
}