package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Context;
import android.support.annotation.NonNull;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;

import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.AbilityItemsEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.AbilityItemsListEntity;
import com.wgmf.yxgj.pop.PublicSelectPop;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;

import java.util.ArrayList;
import java.util.List;

@SuppressWarnings("all")
public class EmployAbilityEditAdapter extends BaseAdapter {
    private Context context;
    private List<AbilityItemsEntity> reportModuleItemEntities;
    /**
     * 给Spinner提供的数据源
     */
    private String[] dataRange = new String[]{"0", "1", "2", "3"};

    private List<BaseSelectorEntity> dataRanges = new ArrayList<>();

    private ClickListener clickListener;

    public interface ClickListener {
        void employAbilityItemQueryClick(AbilityItemsEntity data, int postion);

        void employAbilityItemNumClick(AbilityItemsEntity data, int postion);
    }

    public EmployAbilityEditAdapter(Context context, ClickListener clickListener, AbilityItemsListEntity abilityItemsListEntity) {
        this.context = context;
        this.clickListener = clickListener;
        this.reportModuleItemEntities = abilityItemsListEntity.getAbilityItemsList();
    }

    public List<AbilityItemsEntity> getUploadData() {
        //将选择的培训次数数据填充到提交数据中
        return reportModuleItemEntities;
    }

    @Override
    public int getCount() {
        return reportModuleItemEntities == null ? 0 : reportModuleItemEntities.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class Holder {
        LinearLayout employAbilityItemTypeLl;
        TextView employAbilityItemType;
        TextView employAbilityItemRow;
        TextView employAbilityItemContent;
        TextView employAbilityItemRecord;
        TextView employAbilityItemStatus;
        TextView employAbilityItemNum;
        Spinner employAbilityItemCounts;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final Holder holder;
        if (convertView == null) {
            holder = new Holder();
            convertView = LayoutInflater.from(context).inflate(R.layout.employ_ability_edit_type_item, null);
            holder.employAbilityItemTypeLl = (LinearLayout) convertView.findViewById(R.id.employ_ability_item_type_ll);
            holder.employAbilityItemType = (TextView) convertView.findViewById(R.id.employ_ability_item_type);
//            holder.employAbilityItemRow = (TextView) convertView.findViewById(R.id.employ_ability_item_row);
            holder.employAbilityItemContent = (TextView) convertView.findViewById(R.id.employ_ability_item_content);
            holder.employAbilityItemStatus = (TextView) convertView.findViewById(R.id.employ_ability_item_status);
            holder.employAbilityItemNum = (TextView) convertView.findViewById(R.id.employ_ability_item_num);
            holder.employAbilityItemRecord = (TextView) convertView.findViewById(R.id.employ_ability_item_record);
            holder.employAbilityItemCounts = (Spinner) convertView.findViewById(R.id.employ_ability_item_counts);
            convertView.setTag(holder);
        } else {
            holder = (Holder) convertView.getTag();
        }
        final AbilityItemsEntity data = reportModuleItemEntities.get(position);
        holder.employAbilityItemTypeLl.setVisibility(View.VISIBLE);
        //如果是项目类型，合并并显示第一条，可点击收起和折叠项目名称
        // 如果当前项目名称与前一项目名称相同则不显示，即所有子项目只允许第一个子项目出现产品名称
        if (position >= 1 && null != data.getItemsType()) {
            if (data.getItemsType().equals(reportModuleItemEntities.get(position - 1).getItemsType())) {
                holder.employAbilityItemTypeLl.setVisibility(View.GONE);
            } else {
                holder.employAbilityItemTypeLl.setVisibility(View.VISIBLE);
            }
        }
        //项目类别
        holder.employAbilityItemType.setText(data.getItemsType());
        //项目名称
        holder.employAbilityItemContent.setText(data.getItemsName());
        //查看按钮
        if (data.getItemsTrainRecordsFlag().equals("0")) {
            holder.employAbilityItemRecord.setVisibility(View.INVISIBLE);
        } else if (data.getItemsTrainRecordsFlag().equals("1")) {
            holder.employAbilityItemRecord.setVisibility(View.VISIBLE);
        }
        //合格状态
        if (data.getInfoItemsQualified().equals("1")) {
            holder.employAbilityItemStatus.setBackgroundResource(R.drawable.circle_gray);
        } else if (data.getInfoItemsQualified().equals("0")) {
            holder.employAbilityItemStatus.setBackgroundResource(R.drawable.circle_orange);
        }

        holder.employAbilityItemRecord.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickListener.employAbilityItemQueryClick(data, position);
            }
        });
        holder.employAbilityItemStatus.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                checkStatus(data.getInfoItemsQualified(), holder, data, position);
            }
        });
//        data.setTrainigNum((holder.employAbilityItemCounts.getSelectedItemPosition()));
        holder.employAbilityItemCounts.setAdapter(setSpinnerData(dataRange));
        holder.employAbilityItemNum.setText(data.getTrainigNum());
        holder.employAbilityItemNum.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickListener.employAbilityItemNumClick(data, position);
            }
        });
        return convertView;
    }


    /**
     * @param isChecked 项目是否合格：0合格；1不合格
     * @param holder
     * @param item
     * @param position
     */
    private void checkStatus(String isChecked, Holder holder, AbilityItemsEntity item, int position) {
        if (isChecked.equals("1")) {
            holder.employAbilityItemStatus.setBackgroundResource(R.drawable.circle_orange);
            item.setInfoItemsQualified("0");
        } else if (isChecked.equals("0")) {
            holder.employAbilityItemStatus.setBackgroundResource(R.drawable.circle_gray);
            item.setInfoItemsQualified("1");
        }
    }

    @NonNull
    private BaseCommonAdapter<BaseSelectorEntity> setSpinnerData(String[] array) {
        List<BaseSelectorEntity> damageGroup = new ArrayList<>();
        for (int i = 0; i < array.length; i++) {
            BaseSelectorEntity baseSelectorEntity = new BaseSelectorEntity();
            baseSelectorEntity.setSelectorName(array[i]);
            baseSelectorEntity.setSelectorId(i + "");
            damageGroup.add(baseSelectorEntity);
        }
        return new BaseCommonAdapter<BaseSelectorEntity>(context, damageGroup) {
            @Override
            public void convert(ViewHolder helper, BaseSelectorEntity item) {
                helper.setText(item.getSelectorName());
                helper.setRightGone(View.GONE);
            }
        };
    }
}