package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoEntity;

import java.util.List;

@SuppressWarnings("all")
public class EmployAbilityPersonListAdapter extends BaseAdapter {
    private Context context;
    private Long branchID;
    private List<UserInfoEntity> reportModuleItemEntities;

    private ClickListener clickListener;

    public interface ClickListener {
        void employAbilityPersonAdapterClick(UserInfoEntity data,int postion);
    }

    public EmployAbilityPersonListAdapter(Context context, ClickListener clickListener, List<UserInfoEntity> reportModuleItemEntities,Long branchID) {
        this.context = context;
        this.branchID = branchID;
        this.clickListener = clickListener;
        this.reportModuleItemEntities = reportModuleItemEntities;
    }

    public List<UserInfoEntity> getUploadData() {
        return reportModuleItemEntities;
    }

    @Override
    public int getCount() {
        return reportModuleItemEntities == null ? 0 : reportModuleItemEntities.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        LinearLayout reportModuleListItemLl;
        TextView reportModuleListItemTitle;
        TextView reportModuleListItemNecessary;
        TextView reportModuleItemStatus;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.report_module_list_item, null);
            holder.reportModuleListItemLl = (LinearLayout) convertView.findViewById(R.id.report_module_list_item_ll);
            holder.reportModuleListItemTitle = (TextView) convertView.findViewById(R.id.report_module_list_item_title);
            holder.reportModuleListItemNecessary = (TextView) convertView.findViewById(R.id.report_module_list_item_necessary);
            holder.reportModuleItemStatus = (TextView) convertView.findViewById(R.id.report_module_item_status);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final UserInfoEntity data = reportModuleItemEntities.get(position);
        holder.reportModuleListItemTitle.setText(data.getName());
        if(branchID != 706L) {
            holder.reportModuleListItemNecessary.setVisibility(View.VISIBLE);
        }
        //新顾问标识（顾问能力评估使用）：0表示是新顾问；1表示不是 ,不是新顾问可评估，否则不能
        if("0".equals(data.getIsNewWorkerFlag())){
            holder.reportModuleListItemNecessary.setText("不可评估");
        }else{
            holder.reportModuleListItemNecessary.setText("可评估");
            holder.reportModuleListItemLl.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    clickListener.employAbilityPersonAdapterClick(data,position);
                }
            });
        }
        return convertView;
    }
}