package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseBackHandledFragment;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoListEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.service.EmployAbilityService;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;

import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.List;

public class EmployAbilityPersonListFragment extends BaseBackHandledFragment implements EmployAbilityPersonListAdapter.ClickListener {
    String branchTitle;
    Long branchID;
    private TextView farAddHeaderTv;
    private LinearLayout farAddHeaderLl;
    private ClearEditText storeNameEt;
    private ListView mListView;
    private EmployAbilityPersonListAdapter employAbilityPersonListAdapter;
    private List<UserInfoEntity> reportModuleProjectListResultEntities;
    private List<UserInfoEntity> reportModuleProjectListResultEntitiesShow;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        branchTitle = getArguments().getString("branchTitle");
        branchID = getArguments().getLong("branchID", 0);
    }

    private void getPersonData() {
        if (null != userInfo) {
            showDialog();
            farAddHeaderTv.setHint(getString(R.string.employ_ability_by_person_title));
            storeNameEt.setHint(getString(R.string.report_module_by_person_search));
            EmployAbilityService.getInstance().requestFindUserList(userInfo.getOrganizationId(), userInfo.getOrganizationCode(), userInfo.getUserPostLevel(), this);
        }
    }

    @Override
    public View onCreateView(@NotNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_report_module_project_list, container, false);
        // 防止点击穿透，底层的fragment响应上层点击触摸事件
        view.setClickable(true);
        initView(view);
        getPersonData();
        return view;
    }

    private void initView(View view) {
        mListView = (ListView) view.findViewById(R.id.public_list_view_lv);
        farAddHeaderLl = (LinearLayout) view.findViewById(R.id.far_add_header_ll);
        farAddHeaderTv = (TextView) view.findViewById(R.id.far_add_header_tv);
        storeNameEt = (ClearEditText) view.findViewById(R.id.store_name_et);
        TextView dataEmpty = (TextView) view.findViewById(R.id.public_list_view_empty_tv);
        mListView.setEmptyView(dataEmpty);
        mListView.setVisibility(View.VISIBLE);
        storeNameEt.setVisibility(View.VISIBLE);
        farAddHeaderLl.setVisibility(View.VISIBLE);
        setListener();
    }

    protected void setListener() {
        storeNameEt.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                textChanged();
            }
        });
    }

    public void textChanged() {
        if (null == reportModuleProjectListResultEntitiesShow) {
            reportModuleProjectListResultEntitiesShow = new ArrayList<>();
        }
        String itemId = storeNameEt.getText().toString().trim();
        if (TextUtils.isEmpty(itemId)) {
            reportModuleProjectListResultEntitiesShow.clear();
            if (null != reportModuleProjectListResultEntities) {
                reportModuleProjectListResultEntitiesShow.addAll(reportModuleProjectListResultEntities);
            }

        } else {
            reportModuleProjectListResultEntitiesShow.clear();
            if (null != reportModuleProjectListResultEntities) {
                for (UserInfoEntity p : reportModuleProjectListResultEntities) {
                    if (null != p.getName()) {
                        if (p.getName().contains(itemId)) {
                            reportModuleProjectListResultEntitiesShow.add(p);
                        }
                    }
                }
            }
        }
        employAbilityPersonListAdapter = new EmployAbilityPersonListAdapter(getActivity(), this, reportModuleProjectListResultEntitiesShow, branchID);
        mListView.setAdapter(employAbilityPersonListAdapter);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.EmployAbility.MSG_ON_FIND_USER_LIST) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    UserInfoListEntity reportModuleProjectListResultEntity = new Gson().fromJson(msg, UserInfoListEntity.class);
                    Log.d(TAG, "reportModuleProjectListResultEntity" + reportModuleProjectListResultEntity);
                    if (null != reportModuleProjectListResultEntity && null != reportModuleProjectListResultEntity.getResultList() && ConstantParams.CONSTANT_PARAMS_0.equals(reportModuleProjectListResultEntity.retCode)) {
                        reportModuleProjectListResultEntities = reportModuleProjectListResultEntity.getResultList();
                        employAbilityPersonListAdapter = new EmployAbilityPersonListAdapter(getActivity(), this, reportModuleProjectListResultEntities, branchID);
                        mListView.setAdapter(employAbilityPersonListAdapter);
                    }
                }
            }
        }
    }

    @Override
    public boolean onBackPressed() {
        return false;
    }

    @Override
    public void employAbilityPersonAdapterClick(UserInfoEntity data, int position) {
        Intent intent = new Intent();
        intent.setClass(getActivity(), EmployAbilityTitleListActivity.class);
        intent.putExtra("branchTitle", branchTitle);
        intent.putExtra("branchID", branchID);
        intent.putExtra("staffId", data.getStaffId());
        intent.putExtra("staffName", data.getName());
        startActivity(intent);
    }
}