package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.EmployItemsTrainRecordsEntity;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;

import java.util.List;

/**
 * 培训记录弹窗
 * 作者：xiep on 2019/9/12 13:37
 * 邮箱：2975837870@qq.com
 */

public class EmployAbilityPop {

    private PopupWindow shopProductHistorySalePw;

    private View viewParent;

    EmployAbilityPop(final Context context, List<EmployItemsTrainRecordsEntity> shopProductHistorySaleEntitys) {
        this(context, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, shopProductHistorySaleEntitys);
    }

    private EmployAbilityPop(final Context context, final int width, final int height, List<EmployItemsTrainRecordsEntity> shopProductHistorySaleEntitys) {

        LayoutInflater inflater = LayoutInflater.from(context);
        viewParent = inflater.inflate(R.layout.employ_ability_pop, null);

        ListViewForScrollView shopProductHistoryLv = (ListViewForScrollView) viewParent.findViewById(R.id.public_list_view_lv);
        LinearLayout reportContentConfirmLl = (LinearLayout) viewParent.findViewById(R.id.report_content_confirm_ll);
        TextView reportContentModifyBtn = (TextView) viewParent.findViewById(R.id.report_content_modify_btn);
        TextView reportContentConfirmBtn = (TextView) viewParent.findViewById(R.id.report_content_confirm_btn);

        reportContentModifyBtn.setTextColor(ContextCompat.getColor(context, R.color.important_txt_color));
        reportContentModifyBtn.setBackground(ContextCompat.getDrawable(context, R.drawable.btn_photo_cancel_sharp_selector));
        reportContentConfirmLl.setVisibility(View.VISIBLE);
        reportContentConfirmBtn.setTextColor(ContextCompat.getColor(context, R.color.important_txt_color));
        reportContentConfirmBtn.setBackground(ContextCompat.getDrawable(context, R.drawable.btn_photo_cancel_sharp_selector));
        reportContentConfirmBtn.setText("关闭");

        //为列表添加空布局
        View emptyView = viewParent.findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) viewParent.findViewById(R.id.public_list_view_empty_iv);
        Glide.with(context).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        shopProductHistoryLv.setEmptyView(emptyView);
        if (null != shopProductHistorySaleEntitys && !shopProductHistorySaleEntitys.isEmpty()) {
            EmployAbilityPopAdapter typeAdapter = new EmployAbilityPopAdapter(shopProductHistorySaleEntitys, context);
            shopProductHistoryLv.setAdapter(typeAdapter);
            shopProductHistorySalePw = new PopupWindow(viewParent, width, height, true);
        }
        reportContentConfirmLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                shopProductHistorySalePw.dismiss();
            }
        });
        reportContentModifyBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                shopProductHistorySalePw.dismiss();
            }
        });
        reportContentConfirmBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                shopProductHistorySalePw.dismiss();
            }
        });
    }

    boolean isShowing() {
        return null != shopProductHistorySalePw && shopProductHistorySalePw.isShowing();
    }

    void show(View parent) {
        if (null == parent) {
            throw new IllegalArgumentException("StoreDateSelectorPop.showAtLocation parent is null");
        }
        viewParent = parent;
        shopProductHistorySalePw.showAtLocation(parent, Gravity.CENTER, 0, 0);
    }
}