package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.EmployItemsTrainRecordsEntity;

import java.util.List;

/**
 * 培训记录弹窗适配器
 * 作者：xiep on 2017/3/16 13:42
 * 邮箱：2975837870@qq.com
 */
public class EmployAbilityPopAdapter extends BaseAdapter {
    private Context context;
    private List<EmployItemsTrainRecordsEntity> list;

    EmployAbilityPopAdapter(List<EmployItemsTrainRecordsEntity> list,
                            Context context) {
        super();
        this.list = list;
        this.context = context;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {
        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.employ_ability_pop_item, null);
            viewHolder = new ViewHolder();
            viewHolder.employAbilityTime = (TextView) convertView.findViewById(R.id.employ_ability_time);
            viewHolder.employAbilityTeacher = (TextView) convertView.findViewById(R.id.employ_ability_teacher);
            viewHolder.employAbilityAssess = (TextView) convertView.findViewById(R.id.employ_ability_assess);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }

        if (list != null && !list.isEmpty()) {
            viewHolder.employAbilityTime.setText(list.get(position).getTrainTime());
            viewHolder.employAbilityTeacher.setText(list.get(position).getTrainStaffName());
            viewHolder.employAbilityAssess.setText(list.get(position).getAssessmentContent());
        }
        return convertView;
    }

    class ViewHolder {
        TextView employAbilityTime;
        TextView employAbilityTeacher;
        TextView employAbilityAssess;
    }
}