package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.AbilityItemsEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.AbilityItemsListEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.AbilityItemsResponse;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.service.EmployAbilityRankUtil;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.service.EmployAbilityService;

/**
 * 员工培训记录查看页面
 */
public class EmployAbilityQualifyEditActivity extends BaseParentAct implements EmployAbilityQualityEditAdapter.ClickListener {
    String branchTitle;
    Long branchID;
    String titleName;
    String titleId;
    String staffId;
    String staffName;
    ListView mListView;
    EmployAbilityQualityEditAdapter employAbilityEditAdapter;
    AbilityItemsListEntity abilityItemsListEntity;
    TextView employAbilityHeaderStaffName;
    TextView employAbilityHeaderStaffRank;

    @Override
    protected void initTitle() {
        super.initTitle();
        titleName = getIntent().getStringExtra("titleName");
        titleId = getIntent().getStringExtra("titleId");
        staffId = getIntent().getStringExtra("staffId");
        staffName = getIntent().getStringExtra("staffName");
        branchTitle = getIntent().getStringExtra("branchTitle");
        branchID = getIntent().getLongExtra("branchID", 0);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText(branchTitle);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.employ_ability_qualify_edit_activity);
        initTitle();
        initView();
    }

    @Override
    protected void onResume() {
        super.onResume();
        findEmployAbilityQualified();
    }

    private void initView() {
        employAbilityHeaderStaffName = (TextView) findViewById(R.id.employ_ability_header_staff_name);
        employAbilityHeaderStaffRank = (TextView) findViewById(R.id.employ_ability_header_staff_rank);
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        abilityItemsListEntity = new AbilityItemsListEntity();
        employAbilityEditAdapter = new EmployAbilityQualityEditAdapter(this, this, abilityItemsListEntity);
        mListView.setAdapter(employAbilityEditAdapter);
        mListView.setVisibility(View.VISIBLE);
        employAbilityHeaderStaffName.setText(staffName);
        employAbilityHeaderStaffName.setBackground(null);
        employAbilityHeaderStaffRank.setBackground(null);
    }

    private void findEmployAbilityQualified() {
        if (null != userInfo) {
            showDialog();
            EmployAbilityService.getInstance().requestFindEmpAbilityQualifiedAndUn(staffId, titleName,this);
        }
    }


    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.EmployAbility.MSG_ON_FIND_EMPABILITY_QUALIFIED_ANDUN: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        AbilityItemsResponse abilityItemsResponse = new Gson().fromJson(msg, AbilityItemsResponse.class);
                        Log.d(TAG, "abilityItemsResponse" + abilityItemsResponse);
                        if (null != abilityItemsResponse && null != abilityItemsResponse.getResult() && ConstantParams.CONSTANT_PARAMS_0.equals(abilityItemsResponse.retCode)) {
                            abilityItemsListEntity = abilityItemsResponse.getResult();
                            //顾问等级
                            employAbilityHeaderStaffRank.setText(EmployAbilityRankUtil.getEmployAbilityLevel(abilityItemsListEntity.getEmployAbilityLevel()));
                            // 员工能力评估合格及不合格项
                            employAbilityEditAdapter = new EmployAbilityQualityEditAdapter(this, this, abilityItemsListEntity);
                            mListView.setAdapter(employAbilityEditAdapter);
                        }
                    }
                }
                break;
                case BusinessID.EmployAbility.MSG_ON_SAVE_EMPLOY_ITEMS_TRAIN_RECORDS: {
                    if (result.isSuccessed()) {
                        final String msg = result.getInfo();
                        if (result.isSuccessed()) {
                            BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                            Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                            showMsg(mBaseResponse.retInfo);
                            if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                                EmployAbilityQualifyEditActivity.this.finish();
                            }
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    @Override
    public void employAbilityItemClick(AbilityItemsEntity data, int postion) {
        Intent intent = new Intent();
        intent.setClass(this, EmployAbilityRecordEditActivity.class);
        intent.putExtra("branchTitle", branchTitle);
        intent.putExtra("branchID", branchID);
        intent.putExtra("staffId", staffId);
        intent.putExtra("titleId", titleId);
        intent.putExtra("titleName", titleName);
        intent.putExtra("staffName", staffName);
        intent.putExtra("level", employAbilityHeaderStaffRank.getText().toString());
        intent.putExtra("itemsId", data.getItemsId());
        intent.putExtra("infoItemsType", data.getItemsType());
        intent.putExtra("trainRecordsItmesName", data.getItemsName());
        intent.putExtra("infoItemsQualified", data.getInfoItemsQualified());
        intent.putExtra("itemsTypeNo", data.getItemsTypeNo());
        startActivity(intent);
    }
}