package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.AbilityItemsEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.AbilityItemsListEntity;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;

import java.util.ArrayList;
import java.util.List;

@SuppressWarnings("all")
public class EmployAbilityQualityEditAdapter extends BaseAdapter implements EmployAbilityQualityEditChildAdapter.ClickListener {
    private Context context;
    private ClickListener clickListener;
    private AbilityItemsListEntity abilityItemsListEntity;
    private List<BaseSelectorEntity> baseSelectorEntity = new ArrayList<>();
    Drawable drawableDown;
    Drawable drawableUp;

    @Override
    public void employAbilityItemClick(AbilityItemsEntity data, int postion) {
        clickListener.employAbilityItemClick(data, postion);
    }

    public interface ClickListener {
        void employAbilityItemClick(AbilityItemsEntity data, int postion);
    }

    public EmployAbilityQualityEditAdapter(Context context, ClickListener clickListener, AbilityItemsListEntity abilityItemsListEntity) {
        this.context = context;
        this.clickListener = clickListener;
        this.abilityItemsListEntity = abilityItemsListEntity;

        BaseSelectorEntity baseSelectorEntity1 = new BaseSelectorEntity();
        baseSelectorEntity1.setSelectorName("待发展项");
        baseSelectorEntity1.setSelectorId("1");
        BaseSelectorEntity baseSelectorEntity2 = new BaseSelectorEntity();
        baseSelectorEntity2.setSelectorName("合格项");
        baseSelectorEntity2.setSelectorId("2");
        baseSelectorEntity2.setChoice(true);
        baseSelectorEntity.add(baseSelectorEntity1);
        baseSelectorEntity.add(baseSelectorEntity2);

        drawableDown = ContextCompat.getDrawable(context, R.drawable.row_down);
        drawableDown.setBounds(0, 0, drawableDown.getMinimumWidth(), drawableDown.getMinimumHeight());
        drawableUp = ContextCompat.getDrawable(context, R.drawable.row_up);
        drawableUp.setBounds(0, 0, drawableUp.getMinimumWidth(), drawableUp.getMinimumHeight());
    }

    @Override
    public int getCount() {
        return baseSelectorEntity == null ? 0 : baseSelectorEntity.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        LinearLayout employAbilityItemTypeLl;
        TextView employAbilityItemType;
        TextView employAbilityItemRow;
        ListViewForScrollView employAbilityQualityEditLv;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.employ_ability_quality_edit_type_item, null);
            holder.employAbilityItemTypeLl = (LinearLayout) convertView.findViewById(R.id.employ_ability_item_type_ll);
            holder.employAbilityItemType = (TextView) convertView.findViewById(R.id.employ_ability_item_type);
            holder.employAbilityItemRow = (TextView) convertView.findViewById(R.id.employ_ability_item_row);
            holder.employAbilityQualityEditLv = (ListViewForScrollView) convertView.findViewById(R.id.employ_ability_quality_edit_lv);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final BaseSelectorEntity data = baseSelectorEntity.get(position);

        //项目名称
        holder.employAbilityItemType.setText(data.getSelectorName());

        EmployAbilityQualityEditChildAdapter mAdapter = new EmployAbilityQualityEditChildAdapter(data.getSelectorId(),context, this, abilityItemsListEntity);
        mAdapter.setData(data.getSelectorId(),abilityItemsListEntity);
        mAdapter.setListener(this);
        holder.employAbilityQualityEditLv.setAdapter(mAdapter);

        if (data.isChoice()) {
            holder.employAbilityQualityEditLv.setVisibility(View.GONE);
            holder.employAbilityItemRow.setCompoundDrawables(null, null, drawableDown, null);
        } else {
            holder.employAbilityQualityEditLv.setVisibility(View.VISIBLE);
            holder.employAbilityItemRow.setCompoundDrawables(null, null, drawableUp, null);
        }
        holder.employAbilityItemTypeLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (data.isChoice()) {
                    holder.employAbilityQualityEditLv.setVisibility(View.VISIBLE);
                    holder.employAbilityItemRow.setCompoundDrawables(null, null, drawableUp, null);
                } else {
                    holder.employAbilityQualityEditLv.setVisibility(View.GONE);
                    holder.employAbilityItemRow.setCompoundDrawables(null, null, drawableDown, null);
                }
                data.setChoice(!data.isChoice());
            }
        });
        return convertView;
    }
}