package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Context;
import android.support.annotation.NonNull;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Spinner;
import android.widget.TextView;

import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.AbilityItemsEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.AbilityItemsListEntity;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;

import java.util.ArrayList;
import java.util.List;

@SuppressWarnings("all")
public class EmployAbilityQualityEditChildAdapter extends BaseAdapter {
    private Context context;
    private List<AbilityItemsEntity> abilityItemsEntities = new ArrayList<>();

    private ClickListener clickListener;

    public interface ClickListener {
        void employAbilityItemClick(AbilityItemsEntity data, int postion);
    }

    public void setListener(ClickListener listener) {
        this.clickListener = listener;
    }

    public void setData(String id, AbilityItemsListEntity abilityItemsListEntity) {
        if ("1".equals(id)) {
            //将不合格项全部加入集合中
            if (null != abilityItemsListEntity.getUnqualifiedItemsList() && !abilityItemsListEntity.getUnqualifiedItemsList().isEmpty()) {
                abilityItemsEntities.addAll(abilityItemsListEntity.getUnqualifiedItemsList());
            }
        } else if ("2".equals(id)) {
            //将合格项全部加入集合中
            if (null != abilityItemsListEntity.getQualifiedItemsList() && !abilityItemsListEntity.getQualifiedItemsList().isEmpty()) {
                abilityItemsEntities.addAll(abilityItemsListEntity.getQualifiedItemsList());
            }
        }
        this.abilityItemsEntities = abilityItemsEntities;
    }

    public EmployAbilityQualityEditChildAdapter(String id, Context context, ClickListener clickListener, AbilityItemsListEntity abilityItemsListEntity) {
        this.context = context;
        this.clickListener = clickListener;
        this.abilityItemsEntities = abilityItemsEntities;
    }

    public List<AbilityItemsEntity> getUploadData() {
        return abilityItemsEntities;
    }

    @Override
    public int getCount() {
        return abilityItemsEntities == null ? 0 : abilityItemsEntities.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class Holder {
        TextView employAbilityItemContent;
        TextView employAbilityItemRecord;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final Holder holder;
        if (convertView == null) {
            holder = new Holder();
            convertView = LayoutInflater.from(context).inflate(R.layout.employ_ability_edit_name_item, null);
            holder.employAbilityItemContent = (TextView) convertView.findViewById(R.id.employ_ability_item_content);
            holder.employAbilityItemRecord = (TextView) convertView.findViewById(R.id.employ_ability_item_record);
            convertView.setTag(holder);
        } else {
            holder = (Holder) convertView.getTag();
        }
        final AbilityItemsEntity data = abilityItemsEntities.get(position);
        //项目名称
        holder.employAbilityItemContent.setText(data.getItemsType() + ":" + data.getItemsName());

        holder.employAbilityItemRecord.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickListener.employAbilityItemClick(data, position);
            }
        });
        return convertView;
    }
}