package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.global.LocationParams;
import com.wgmf.library.utils.LocationUtil;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoListEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.service.EmployAbilityService;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.model.ShopDataEntity;
import com.wgmf.yxgj.publics.model.ShopDataListEntity;
import com.wgmf.yxgj.publics.service.PublicService;
import com.wgmf.yxgj.publics.service.ToFunctionByResId;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.xp.arouter.RouterCommonUtil;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.List;

/**
 * 员工能力查询门店分页页面
 */
@Route(path = RouterParams.URL_EMPLOY_ABILITY_QUERY_PERSON_ACTIVITY)
public class EmployAbilityQueryPersonActivity extends SelectorBaseActivity implements EmployAbilityPersonListAdapter.ClickListener {
    /**
     * 0:门店查询/1:顾问查询
     */
    int type;
    Long branchID;
    String shopId;
    private List<UserInfoEntity> userInfoEntitiesShow;
    private List<UserInfoEntity> userInfoEntities;
    private EmployAbilityPersonListAdapter employAbilityPersonListAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        initData();
        // 查询驻店营养顾问信息
        getPersonData(shopId);
        // 默认不弹出软键盘
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
    }

    private void initData() {
        shopId = getIntent().getStringExtra("shopId");
        branchID = getIntent().getLongExtra("branchID", 0);
    }

    /**
     * get /employAbility/findUserList 查询营养顾问信息
     */
    private void getPersonData(String shopId) {
        if (null != userInfo) {
            type = 1;
            showDialog();
            EmployAbilityService.getInstance().requestFindInStoreUserList(shopId, this);
        }
    }

    public void textChanged() {
            if (null == userInfoEntitiesShow) {
                userInfoEntitiesShow = new ArrayList<>();
            }
            String itemId = storeNameEt.getText().toString().trim();
            if (TextUtils.isEmpty(itemId)) {
                userInfoEntitiesShow.clear();
                if (null != userInfoEntities) {
                    userInfoEntitiesShow.addAll(userInfoEntities);
                }

            } else {
                userInfoEntitiesShow.clear();
                if (null != userInfoEntities) {
                    for (UserInfoEntity p : userInfoEntities) {
                        if (null != p.getName()) {
                            if (p.getName().contains(itemId)) {
                                userInfoEntitiesShow.add(p);
                            }
                        }
                    }
                }
            }
            employAbilityPersonListAdapter = new EmployAbilityPersonListAdapter(this, this, userInfoEntitiesShow,branchID);
            mListView.setAdapter(employAbilityPersonListAdapter);
    }
    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.EmployAbility.MSG_ON_FIND_INSTORE_USER_LIST) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    UserInfoListEntity reportModuleProjectListResultEntity = new Gson().fromJson(msg, UserInfoListEntity.class);
                    Log.d(TAG, "reportModuleProjectListResultEntity" + reportModuleProjectListResultEntity);
                    if (null != reportModuleProjectListResultEntity && null != reportModuleProjectListResultEntity.getResultList() && ConstantParams.CONSTANT_PARAMS_0.equals(reportModuleProjectListResultEntity.retCode)) {
                        storeNameEt.setHint(getString(R.string.report_module_by_person_search));
                        userInfoEntities = reportModuleProjectListResultEntity.getResultList();
                        employAbilityPersonListAdapter = new EmployAbilityPersonListAdapter(EmployAbilityQueryPersonActivity.this, EmployAbilityQueryPersonActivity.this, userInfoEntities,branchID);
                        mListView.setAdapter(employAbilityPersonListAdapter);
                    }
                }
            }
        }
    }

    @Override
    public void employAbilityPersonAdapterClick(UserInfoEntity data, int postion) {
        Intent intent = new Intent();
        intent.setClass(this, EmployAbilityTitleListActivity.class);
        intent.putExtra("staffId", data.getStaffId());
        intent.putExtra("staffName", data.getName());
        intent.putExtra("branchID", branchID);
        intent.putExtra("branchTitle", branchTitle);
        startActivity(intent);
    }
}