package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.global.LocationParams;
import com.wgmf.library.utils.LocationUtil;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.model.ShopDataEntity;
import com.wgmf.yxgj.publics.model.ShopDataListEntity;
import com.wgmf.yxgj.publics.service.PublicService;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;
import com.wgmf.yxgj.widgets.PullToRefresh.PullToRefreshBase;
import com.wgmf.yxgj.widgets.PullToRefresh.PullToRefreshListView;
import com.xp.arouter.RouterParams;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

/**
 * 员工能力查询门店分页页面
 */
@Route(path = RouterParams.URL_EMPLOY_ABILITY_QUERY_SHOP_ACTIVITY)
public class EmployAbilityQueryShopActivity extends BaseParentAct {
    public final static int DEFAULT_TIME_OUT = 1000 * 15;
    protected BaseCommonAdapter<BaseSelectorEntity> mAdapter;
    protected List<BaseSelectorEntity> mListStore;
    protected List<BaseSelectorEntity> listShow;
    protected ClearEditText storeNameEt;
    protected Button storeNameQueryBtn;
    protected String branchTitle;

    public PullToRefreshListView pullList;
    public TextView netErrorText;
    public TextView noDataText;
    public ProgressBar loading;
    Timer timer;
    public ListView mListView;
    public boolean isDone;//已刷新成功

    int  pageNum = 1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.abilty_query_shop_activity);
        initTitle();
        initContent();
        setListener();
        getShopList(pageNum);
        // 默认不弹出软键盘
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
    }

    private void getShopList(int pageNum) {
        if (null != userInfo) {
            showDialog();
            String url = NetworkParams.URL_SHOP_GET_NEAREST;
            String keyWords = storeNameEt.getText().toString().trim();
            String orgCode = userInfo.getOrganizationCode();
            String currentPage = pageNum + "";
            String pageSize = "10";
            String lat = LocationParams.Latitude;
            String lng = LocationParams.Longitude;
            // 发送管理门店数据请求
            PublicService.getInstance().requestgetNearestShop(url, keyWords, orgCode, currentPage, pageSize, lng, lat, EmployAbilityQueryShopActivity.this);
        }
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    protected void initContent() {
        mListStore = new ArrayList<>();
        listShow = new ArrayList<>();
        storeNameEt = (ClearEditText) findViewById(R.id.store_name_et);
        storeNameQueryBtn = (Button) findViewById(R.id.store_name_query_btn);
        storeNameEt.setVisibility(View.VISIBLE);
        storeNameQueryBtn.setVisibility(View.VISIBLE);
        pullList = (PullToRefreshListView) findViewById(R.id.public_list_view_lv);
        netErrorText = (TextView)findViewById(R.id.net_error_text);
        noDataText = (TextView)findViewById(R.id.no_data_text);
        loading = (ProgressBar)findViewById(R.id.loading);
        pullList.setPullRefreshEnabled(true);//启用下拉刷新
        pullList.setPullLoadEnabled(true);//启用上拉加载
        mListView = pullList.getRefreshableView();
        mListView.setDividerHeight(0);
        setRefreshListener();//挂双监听

        mAdapter = new BaseCommonAdapter<BaseSelectorEntity>(this, listShow) {
            @Override
            public void convert(ViewHolder helper, BaseSelectorEntity item) {
                helper.setText(item.getSelectorName() + "");
                helper.setRightText("距您" + LocationUtil.setDistanceUint(item.getDistance()));
                helper.setRightGone(View.VISIBLE);
            }
        };
        mListView.setAdapter(mAdapter);
        mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                mAdapter.notifyDataSetChanged();
                Intent intent = new Intent();
                Long branchID = getIntent().getLongExtra("branchID", 0);
                intent.setClass(EmployAbilityQueryShopActivity.this, EmployAbilityQueryPersonActivity.class);
                intent.putExtra("branchTitle", branchTitle);
                intent.putExtra("branchID", branchID);
                intent.putExtra("shopId", listShow.get(position).getSelectorId());
                intent.putExtra("shopName", listShow.get(position).getSelectorName());
                startActivity(intent);
            }
        });
    }

    public void refreshAll(){
        listShow.clear();
        getShopList(1);
    }
    public void loadMore(){
        getShopList(++pageNum);
    }

    public void setRefreshListener(){
        pullList.setOnRefreshListener(new PullToRefreshBase.OnRefreshListener<ListView>() {
            @Override
            public void onPullDownToRefresh(PullToRefreshBase<ListView> refreshView) {
                isDone = false;//刷新中，未成功状态
                refreshAll();
                timer.schedule(new TimerTask() {
                    @Override
                    public void run() {
                        if(!isDone){
                            completeRefresh(false);
                        }
                    }
                }, DEFAULT_TIME_OUT);
            }

            @Override
            public void onPullUpToRefresh(PullToRefreshBase<ListView> refreshView) {
                isDone = false;//刷新中，未成功状态
                loadMore();//获取某页详情
                timer.schedule(new TimerTask() {
                    @Override
                    public void run() {
                        if(!isDone){
                            completeRefresh(false);
                        }
                    }
                },DEFAULT_TIME_OUT);
            }
        });
    }

    public void completeRefresh(final boolean isSuccessed){
        runOnUiThread(new Runnable() {//没办法，Timer不肯跑
            @Override
            public void run() {
                pullList.onPullDownRefreshComplete();//停止下拉刷新
                pullList.onPullUpRefreshComplete();//停止上拉加载
                if(isSuccessed){
                    String now = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());
                    pullList.setLastUpdatedLabel(now);//显示上次刷新时间（其实就是这次）
                }else{
                    showMsg("请求超时，请重试");
                    showNetError();
                }
                isDone = true;//刷新完了就标记一下
            }
        });

    }

    public void showNoData(){
        noDataText.setVisibility(View.VISIBLE);
        netErrorText.setVisibility(View.GONE);
        loading.setVisibility(View.GONE);
    }

    public void showNetError(){
        if(pullList.getRefreshableView().getAdapter().getCount() <= 0) {//只有在
            noDataText.setVisibility(View.GONE);
            netErrorText.setVisibility(View.VISIBLE);
            loading.setVisibility(View.GONE);
        }
    }

    /**
     * 用来给外部修改提示内容
     * @param text 可以改成“没有找到”啦（适用搜索），或“暂无数据”啦（默认就是显示这个）
     */
    public void setShowText(String text){
        if(noDataText != null){
            noDataText.setText(text);
        }
    }

    public void hideErrorText(){
        noDataText.setVisibility(View.GONE);
        netErrorText.setVisibility(View.GONE);
        loading.setVisibility(View.GONE);
    }

    @Override
    public void onResume() {
        timer = new Timer();
        super.onResume();
    }

    @Override
    public void onPause() {
        timer.cancel();
        super.onPause();
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
    }

    protected void setListener() {
        storeNameQueryBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                listShow.clear();
                getShopList(1);
            }
        });
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.Publics.MSG_ON_SHOP_GET_NEAREST: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        ShopDataListEntity mGetNearestShopDataListEntity = new Gson().fromJson(msg, ShopDataListEntity.class);
                        Log.d(TAG, "mGetNearestShopDataListEntity=" + mGetNearestShopDataListEntity.toString());
                        if (!mGetNearestShopDataListEntity.getData().isEmpty()) {
//
                            for (ShopDataEntity mGetNearestShopDataEntity : mGetNearestShopDataListEntity.getData()) {
                                BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
                                mBaseSelectorEntity.setSelectorId(mGetNearestShopDataEntity.getStoreId());
                                mBaseSelectorEntity.setSelectorName(mGetNearestShopDataEntity.getStoreName());
                                mBaseSelectorEntity.setAddress(mGetNearestShopDataEntity.getAddress() + "");
                                mBaseSelectorEntity.setDistance(mGetNearestShopDataEntity.getDistance());
                                mBaseSelectorEntity.setLng(mGetNearestShopDataEntity.getLng());
                                mBaseSelectorEntity.setLat(mGetNearestShopDataEntity.getLat());
                                mBaseSelectorEntity.setSelectorCode("");
                                listShow.add(mBaseSelectorEntity);
                            }
                            hideErrorText();
                            mAdapter.notifyDataSetChanged();
                        }else{
                            showNoData();
                        }
                        completeRefresh(true);
                    }
                }
                break;
                default:
                    break;
            }
        }
    }
}