package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.publics.model.ShopDataEntity;

import java.util.List;

public class EmployAbilityShopListAdapter extends BaseAdapter {
    private Context context;
    private List<ShopDataEntity> reportModuleItemEntities;

    private ClickListener clickListener;

    public interface ClickListener {
        void employAbilityAdapterClick(ShopDataEntity reportShopListEntity, int position);
    }

    public EmployAbilityShopListAdapter(Context context, ClickListener clickListener, List<ShopDataEntity> reportModuleItemEntities) {
        this.context = context;
        this.clickListener = clickListener;
        this.reportModuleItemEntities = reportModuleItemEntities;
    }

    @Override
    public int getCount() {
        return reportModuleItemEntities == null ? 0 : reportModuleItemEntities.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        LinearLayout reportModuleListItemLl;
        TextView reportModuleListItemTitle;
        TextView reportModuleListItemNecessary;
        TextView reportModuleItemStatus;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.report_module_list_item, null);
            holder.reportModuleListItemLl = (LinearLayout) convertView.findViewById(R.id.report_module_list_item_ll);
            holder.reportModuleListItemTitle = (TextView) convertView.findViewById(R.id.report_module_list_item_title);
            holder.reportModuleListItemNecessary = (TextView) convertView.findViewById(R.id.report_module_list_item_necessary);
            holder.reportModuleItemStatus = (TextView) convertView.findViewById(R.id.report_module_item_status);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final ShopDataEntity data = reportModuleItemEntities.get(position);
        holder.reportModuleListItemTitle.setText(data.getStoreName());
        holder.reportModuleItemStatus.setText(setDistanceUint(data.getDistance()));
        holder.reportModuleItemStatus.setVisibility(View.VISIBLE);
        holder.reportModuleListItemLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickListener.employAbilityAdapterClick(data, position);
            }
        });
        return convertView;
    }


    /**
     * @param distance 距离单位米
     * @return 大于1千米显示单位为千米，否则单位为米
     */
    public static String setDistanceUint(double distance) {
        if (distance >= 1000) {
            return  distance / 1000 + "千米";
        } else {
            return distance + "米";
        }
    }
}