package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ImageView;
import android.widget.ListView;

import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.base.R;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.model.CommonResourcesBean;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.EmployAbilityEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.EmployAbilityTitle;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.service.EmployAbilityService;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;

import java.util.ArrayList;
import java.util.List;

/**
 * 培训项目选择页面
 *
 * @author xiep
 */
@SuppressWarnings("all")
public class EmployAbilityTitleListActivity extends BaseParentAct {
    private ListView mListView;
    private List<BaseSelectorEntity> listShow = new ArrayList<>();
    private String staffId;
    private String staffName;
    private String branchTitle;
    private Long branchID;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.public_list_view);
        initTitle();
        initData();
        initContent();
        getList();
    }

    private void initData() {
        branchID = getIntent().getLongExtra("branchID", 0);
        staffId = getIntent().getStringExtra("staffId");
        staffName = getIntent().getStringExtra("staffName");
    }

    private void initContent() {
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
    }

    @Override
    public void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private OnItemClickListener mItemClick = new OnItemClickListener() {
        @Override
        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
            Intent intent = new Intent();
            if (branchID == 700L) {
                intent.setClass(EmployAbilityTitleListActivity.this, EmployAbilityEditActivity.class);
            } else if (branchID == 701L) {
                intent.setClass(EmployAbilityTitleListActivity.this, EmployAbilityQualifyEditActivity.class);
            } else if (branchID == 706L) {
                intent.setClass(EmployAbilityTitleListActivity.this, EmployAbilityEditActivity.class);
            }
            intent.putExtra("branchTitle", branchTitle);
            intent.putExtra("branchID", branchID);
            intent.putExtra("staffId", staffId);
            intent.putExtra("staffName", staffName);
            intent.putExtra("titleId", listShow.get(position).getSelectorId());
            intent.putExtra("titleName", listShow.get(position).getSelectorName());
            startActivity(intent);
        }
    };

    private void getList() {
        if (null != userInfo) {
            showDialog();
            EmployAbilityService.getInstance().requestFindEmployAbilityTitle(staffId, EmployAbilityTitleListActivity.this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.EmployAbility.MSG_ON_FIND_EMPLOY_ABILITY_TITLE: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        EmployAbilityEntity mEmployAbilityEntity = new Gson().fromJson(msg, EmployAbilityEntity.class);
                        Log.d(TAG, "mEmployAbilityEntity=" + mEmployAbilityEntity.toString());
                        if (!mEmployAbilityEntity.getResultList().isEmpty()) {
                            for (EmployAbilityTitle mEmployAbilityTitle : mEmployAbilityEntity.getResultList()) {
                                BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
                                mBaseSelectorEntity.setSelectorId(mEmployAbilityTitle.getIds());
                                mBaseSelectorEntity.setSelectorName(mEmployAbilityTitle.getAbilityTitleName());
                                listShow.add(mBaseSelectorEntity);
                            }
                            BaseCommonAdapter<BaseSelectorEntity> mAdapter = new BaseCommonAdapter<BaseSelectorEntity>(this, listShow) {
                                @Override
                                public void convert(ViewHolder helper, BaseSelectorEntity item) {
                                    helper.setText(item.getSelectorName());
                                }
                            };
                            mListView.setAdapter(mAdapter);
                            mListView.setOnItemClickListener(mItemClick);
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }
}