package com.wgmf.yxgj.module.business.employability.starslights.ui;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.starslights.model.StarsLightsBean;

import java.util.List;

@SuppressWarnings("all")
public class StarsLightsPersonListAdapter extends BaseAdapter {
    private Context context;
    private Long branchID;
    private List<StarsLightsBean> reportModuleItemEntities;

    private ClickListener clickListener;

    public interface ClickListener {
        void employTalentsPersonAdapterClick(StarsLightsBean data, int postion);
    }

    public StarsLightsPersonListAdapter(Context context, ClickListener clickListener, List<StarsLightsBean> reportModuleItemEntities, Long branchID) {
        this.context = context;
        this.branchID = branchID;
        this.clickListener = clickListener;
        this.reportModuleItemEntities = reportModuleItemEntities;
    }

    public List<StarsLightsBean> getUploadData() {
        return reportModuleItemEntities;
    }

    @Override
    public int getCount() {
        return reportModuleItemEntities == null ? 0 : reportModuleItemEntities.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        LinearLayout starsLightsPersonListItemLl;
        TextView starsLightsPersonListItemTitle;
        TextView starsLightsPersonListItemNecessary;
        ImageView light1;
        ImageView light2;
        ImageView light3;
        ImageView light4;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        holder = new ViewHolder();
        convertView = LayoutInflater.from(context).inflate(R.layout.stars_lights_person_list_item, null);
        holder.starsLightsPersonListItemLl = (LinearLayout) convertView.findViewById(R.id.stars_lights_person_list_item_ll);
        holder.starsLightsPersonListItemTitle = (TextView) convertView.findViewById(R.id.stars_lights_person_list_item_title);
        holder.starsLightsPersonListItemNecessary = (TextView) convertView.findViewById(R.id.stars_lights_person_list_item_necessary);
        holder.light1 = (ImageView) convertView.findViewById(R.id.light_1);
        holder.light2 = (ImageView) convertView.findViewById(R.id.light_2);
        holder.light3 = (ImageView) convertView.findViewById(R.id.light_3);
        holder.light4 = (ImageView) convertView.findViewById(R.id.light_4);
        convertView.setTag(holder);
        final StarsLightsBean data = reportModuleItemEntities.get(position);
        holder.starsLightsPersonListItemTitle.setText(data.getWorkerName());
        holder.starsLightsPersonListItemNecessary.setText(data.getWgmfStatus() == 1 ? "已离职" : "");
        if (data.getLightNumTotal() == 1) {
            holder.light1.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_1));
        } else if (data.getLightNumTotal() == 2) {
            holder.light1.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_1));
            holder.light2.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_1));
        } else if (data.getLightNumTotal() == 3) {
            holder.light1.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_1));
            holder.light2.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_1));
            holder.light3.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_1));
        } else if (data.getLightNumTotal() == 4) {
            holder.light1.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_1));
            holder.light2.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_1));
            holder.light3.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_1));
            holder.light4.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_1));
        } else {
            holder.light1.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_2));
            holder.light2.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_2));
            holder.light3.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_2));
            holder.light4.setImageDrawable(ContextCompat.getDrawable(context, R.mipmap.icon_star_light_2));
        }
        holder.starsLightsPersonListItemLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickListener.employTalentsPersonAdapterClick(data, position);
            }
        });
        return convertView;
    }
}