package com.wgmf.yxgj.module.business.employability.starslights.ui;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.global.LocationParams;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.base.BaseBackHandledFragment;
import com.wgmf.yxgj.basewebview.ui.HtmlActivity;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.starslights.model.StarsLightsBean;
import com.wgmf.yxgj.module.business.employability.starslights.model.StarsLightsResponse;
import com.wgmf.yxgj.module.business.employability.starslights.service.StarsLightsService;
import com.wgmf.yxgj.publics.model.ShopDataEntity;
import com.wgmf.yxgj.publics.model.ShopDataListEntity;
import com.wgmf.yxgj.publics.service.PublicService;
import com.wgmf.yxgj.widgets.Dialog.DatePickerYearMonthDialog;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;

import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class StarsLightsShopListFragment extends BaseBackHandledFragment implements StarsLightsShopListAdapter.ClickListener, StarsLightsPersonListAdapter.ClickListener, View.OnClickListener {
    String branchTitle;
    Long branchID;
    String yearMonth;
    LinearLayout dateQueryHeaderLl;
    TextView dateQueryHeaderCenterTv;
    TextView dateQueryHeaderLeftTv;
    TextView dateQueryHeaderRightTv;
    /**
     * 0:门店查询/1:顾问查询
     */
    int type;
    private LinearLayout reportContentConfirmLl;
    private TextView farAddHeaderTv;
    private LinearLayout farAddHeaderLl;
    private ClearEditText storeNameEt;
    private ListView mListView;
    private StarsLightsShopListAdapter employTalentsShopListAdapter;
    private StarsLightsPersonListAdapter employTalentsPersonListAdapter;
    private List<ShopDataEntity> shopDataEntities;
    private List<ShopDataEntity> shopDataEntitiesShow;
    private List<StarsLightsBean> userInfoEntities;
    private List<StarsLightsBean> userInfoEntitiesShow;

    private String storeLatitudes;
    private String storeLongitudes;
    private String storeId;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        branchTitle = getArguments().getString("branchTitle");
        branchID = getArguments().getLong("branchID", 0);
        yearMonth = DateUtil.getFormatCurrentDate("yyyyMM");
    }

    /**
     * 经理查询直属门店标识：1表示查询直属；不传表示全部
     */
    private void getData() {
        if (null != userInfo) {
            if ("4".equals(userInfo.getUserPostLevel())) {
                getShopData("", "1");
            } else {
                getShopData("", "");
            }
        }
    }

    /**
     * @param keyWords
     * @param zsShopFlag
     */
    private void getShopData(String keyWords, String zsShopFlag) {
        type = 0;
        showDialog();
        farAddHeaderTv.setHint(getString(R.string.employ_ability_by_shop_title));
        storeNameEt.setHint(getString(R.string.report_module_by_shop_search));
        String url = NetworkParams.URL_SHOP_GET_NEAREST;
        String orgCode = userInfo.getOrganizationCode();
        String currentPage = "1";
        String pageSize = "10000";
        String lat = LocationParams.Latitude;
        String lng = LocationParams.Longitude;

        // 发送管理门店数据请求
        PublicService.getInstance().requestgetNearestShopByZSFlag(url, zsShopFlag, "", keyWords, orgCode, currentPage, pageSize, lng, lat, this);
    }

    /**
     * get /employAbility/findUserList 查询营养顾问信息
     */
    private void getPersonData(String yearMonth, String shopId) {
        if (null != userInfo) {
            type = 1;
            showDialog();
            StarsLightsService.getInstance().requestFindInStoreUserList(yearMonth, shopId, this);
        }
    }

    @Override
    public View onCreateView(@NotNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_report_module_project_list, container, false);
        // 防止点击穿透，底层的fragment响应上层点击触摸事件
        view.setClickable(true);
        initView(view);
        getData();
        return view;
    }

    private void initView(View view) {
        reportContentConfirmLl = (LinearLayout) view.findViewById(R.id.report_content_confirm_ll);
        mListView = (ListView) view.findViewById(R.id.public_list_view_lv);
        farAddHeaderLl = (LinearLayout) view.findViewById(R.id.far_add_header_ll);
        farAddHeaderTv = (TextView) view.findViewById(R.id.far_add_header_tv);
        storeNameEt = (ClearEditText) view.findViewById(R.id.store_name_et);
        TextView dataEmpty = (TextView) view.findViewById(R.id.public_list_view_empty_tv);
        dateQueryHeaderLl = (LinearLayout) view.findViewById(R.id.date_query_header_ll);
        dateQueryHeaderCenterTv = (TextView) view.findViewById(R.id.date_query_header_center_tv);
        dateQueryHeaderLeftTv = (TextView) view.findViewById(R.id.date_query_header_left_tv);
        dateQueryHeaderRightTv = (TextView) view.findViewById(R.id.date_query_header_right_tv);
        dateQueryHeaderCenterTv.setText(yearMonth);
        dateQueryHeaderCenterTv.setOnClickListener(this);
        dateQueryHeaderLeftTv.setOnClickListener(this);
        dateQueryHeaderRightTv.setOnClickListener(this);
        mListView.setEmptyView(dataEmpty);
        mListView.setVisibility(View.VISIBLE);
        storeNameEt.setVisibility(View.VISIBLE);
        farAddHeaderLl.setVisibility(View.VISIBLE);
        reportContentConfirmLl.setVisibility(View.GONE);
        setListener();
    }

    protected void setListener() {
        storeNameEt.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                textChanged();
            }
        });
    }

    public void textChanged() {
        if (type == 0) {
            if (null == shopDataEntitiesShow) {
                shopDataEntitiesShow = new ArrayList<>();
            }
            String itemId = storeNameEt.getText().toString().trim();
            if (TextUtils.isEmpty(itemId)) {
                shopDataEntitiesShow.clear();
                if (null != shopDataEntities) {
                    shopDataEntitiesShow.addAll(shopDataEntities);
                }

            } else {
                shopDataEntitiesShow.clear();
                if (null != shopDataEntities) {
                    for (ShopDataEntity p : shopDataEntities) {
                        if (null != p.getStoreName()) {
                            if (p.getStoreName().contains(itemId)) {
                                shopDataEntitiesShow.add(p);
                            }
                        }
                    }
                }
            }
            employTalentsShopListAdapter = new StarsLightsShopListAdapter(getActivity(), this, shopDataEntitiesShow);
            mListView.setAdapter(employTalentsShopListAdapter);
        } else if (type == 1) {
            if (null == userInfoEntitiesShow) {
                userInfoEntitiesShow = new ArrayList<>();
            }
            String itemId = storeNameEt.getText().toString().trim();
            if (TextUtils.isEmpty(itemId)) {
                userInfoEntitiesShow.clear();
                if (null != userInfoEntities) {
                    userInfoEntitiesShow.addAll(userInfoEntities);
                }

            } else {
                userInfoEntitiesShow.clear();
                if (null != userInfoEntities) {
                    for (StarsLightsBean p : userInfoEntities) {
                        if (null != p.getWorkerName()) {
                            if (p.getWorkerName().contains(itemId)) {
                                userInfoEntitiesShow.add(p);
                            }
                        }
                    }
                }
            }
            employTalentsPersonListAdapter = new StarsLightsPersonListAdapter(getActivity(), this, userInfoEntitiesShow, branchID);
            mListView.setAdapter(employTalentsPersonListAdapter);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.Publics.MSG_ON_SHOP_GET_NEAREST) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    dateQueryHeaderLl.setVisibility(View.GONE);
                    ShopDataListEntity reportModuleShopResultEntity = new Gson().fromJson(msg, ShopDataListEntity.class);
                    Log.d(TAG, "reportModuleShopResultEntity" + reportModuleShopResultEntity);
                    if (null != reportModuleShopResultEntity && null != reportModuleShopResultEntity.getData() && ConstantParams.CONSTANT_PARAMS_0.equals(reportModuleShopResultEntity.retCode)) {
                        shopDataEntities = reportModuleShopResultEntity.getData();
                        employTalentsShopListAdapter = new StarsLightsShopListAdapter(getActivity(), this, shopDataEntities);
                        mListView.setAdapter(employTalentsShopListAdapter);
                    }
                }
            } else if (id == BusinessID.StarsLights.MSG_ON_FIND_SHOP_WORKERS_STARS_LIGHTS) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    dateQueryHeaderLl.setVisibility(View.VISIBLE);
                    StarsLightsResponse starsLightsResponse = new Gson().fromJson(msg, StarsLightsResponse.class);
                    Log.d(TAG, "starsLightsResponse" + starsLightsResponse);
                    if (null != starsLightsResponse && null != starsLightsResponse.getResultList() && ConstantParams.CONSTANT_PARAMS_0.equals(starsLightsResponse.retCode)) {
                        farAddHeaderTv.setHint(getString(R.string.employ_ability_by_person_title));
                        storeNameEt.setHint(getString(R.string.report_module_by_person_search));
                        userInfoEntities = starsLightsResponse.getResultList();
                        employTalentsPersonListAdapter = new StarsLightsPersonListAdapter(getActivity(), this, userInfoEntities, branchID);
                        mListView.setAdapter(employTalentsPersonListAdapter);
                    }
                }
            }
        }
    }

    @Override
    public boolean onBackPressed() {
        return false;
    }

    @Override
    public void employTalentsAdapterClick(ShopDataEntity reportShopListEntity, int position) {
        storeLatitudes = reportShopListEntity.getLat() + "";
        storeLongitudes = reportShopListEntity.getLng() + "";
        storeId = reportShopListEntity.getStoreId();
        // 查询驻店营养顾问信息
        getPersonData(yearMonth, storeId);
    }

    @Override
    public void employTalentsPersonAdapterClick(StarsLightsBean data, int position) {
        //进入顾问亮灯详情
        //test.wgmf.com/mkt-front/html/reportForms/adviserLightStatus.html?yearMonth=202102&staffId=79109552&workerName=蔡晓娜&lightNumTotal=3
        String branchUrl = "/mkt-front/html/reportForms/adviserLightStatus.html?"
                + "yearMonth=" + data.getYearMonth()
                + "&staffId=" + data.getStaffId()
                + "&workerName=" + data.getWorkerName()
                + "&lightNumTotal=" + data.getLightNumTotal();
        Intent intent = new Intent(getActivity(), HtmlActivity.class);
        intent.putExtra("branchTitle", branchTitle);
        intent.putExtra("branchUrl", branchUrl);
        startActivity(intent);
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.date_query_header_left_tv) {
            //上一月
            int year = Integer.parseInt(yearMonth.substring(0, 4));
            int monthOfYear = Integer.parseInt(yearMonth.substring(4, 6));
            queryDataByMonth(year, monthOfYear, -1);
        } else if (v.getId() == R.id.date_query_header_right_tv) {
            //下一月
            int year = Integer.parseInt(yearMonth.substring(0, 4));
            int monthOfYear = Integer.parseInt(yearMonth.substring(4, 6));
            queryDataByMonth(year, monthOfYear, +1);
        } else if (v.getId() == R.id.date_query_header_center_tv) {
            new DatePickerYearMonthDialog(getActivity(), new DatePickerYearMonthDialog.OnDateSetListener() {
                @Override
                public void onDateSet(int year, int monthOfYear) {
                    queryDataByMonth(year, monthOfYear, +1);
                }
            }).show();
        }
    }

    private void queryDataByMonth(int year, int monthOfYear, int diff) {
        yearMonth = String.valueOf(year) + String.valueOf(monthOfYear + diff);
        Date yearMonthNow = DateUtil.string2Date(yearMonth, "yyyyM");
        yearMonth = DateUtil.format(yearMonthNow, "yyyyMM");
        dateQueryHeaderCenterTv.setText(yearMonth);
        getPersonData(yearMonth, storeId);
    }
}