package com.wgmf.yxgj.module.business.employability.talentstrain.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoEntity;

import java.util.List;

@SuppressWarnings("all")
public class EmployTalentsPersonListAdapter extends BaseAdapter {
    private Context context;
    private Long branchID;
    private List<UserInfoEntity> reportModuleItemEntities;

    private ClickListener clickListener;

    public interface ClickListener {
        void employTalentsPersonAdapterClick(UserInfoEntity data, int postion);
    }

    public EmployTalentsPersonListAdapter(Context context, ClickListener clickListener, List<UserInfoEntity> reportModuleItemEntities, Long branchID) {
        this.context = context;
        this.branchID = branchID;
        this.clickListener = clickListener;
        this.reportModuleItemEntities = reportModuleItemEntities;
    }

    public List<UserInfoEntity> getUploadData() {
        return reportModuleItemEntities;
    }

    @Override
    public int getCount() {
        return reportModuleItemEntities == null ? 0 : reportModuleItemEntities.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        LinearLayout reportModuleListItemLl;
        TextView reportModuleListItemTitle;
        TextView reportModuleListItemNecessary;
        TextView reportModuleItemStatus;
        TextView reportModuleItemStatusRow;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.report_module_list_item, null);
            holder.reportModuleListItemLl = (LinearLayout) convertView.findViewById(R.id.report_module_list_item_ll);
            holder.reportModuleListItemTitle = (TextView) convertView.findViewById(R.id.report_module_list_item_title);
            holder.reportModuleListItemNecessary = (TextView) convertView.findViewById(R.id.report_module_list_item_necessary);
            holder.reportModuleItemStatus = (TextView) convertView.findViewById(R.id.report_module_item_status);
            holder.reportModuleItemStatusRow = (TextView) convertView.findViewById(R.id.report_module_item_status_row);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final UserInfoEntity data = reportModuleItemEntities.get(position);
        holder.reportModuleListItemTitle.setText(data.getName());
        if (branchID != 706L) {
            holder.reportModuleListItemNecessary.setVisibility(View.VISIBLE);
        }
        holder.reportModuleItemStatusRow.setVisibility(View.GONE);
        //assessmentFlag (string, optional): 顾问评估标签：0待评估，1战狼，2小太阳，3小绵羊，4大白兔 ,
        if ("0".equals(data.getAssessmentFlag())) {
            holder.reportModuleListItemNecessary.setText("待评估");
        } else if ("1".equals(data.getAssessmentFlag())) {
            holder.reportModuleListItemNecessary.setText("战狼");
        } else if ("2".equals(data.getAssessmentFlag())) {
            holder.reportModuleListItemNecessary.setText("小太阳");
        } else if ("3".equals(data.getAssessmentFlag())) {
            holder.reportModuleListItemNecessary.setText("小绵羊");
        } else if ("4".equals(data.getAssessmentFlag())) {
            holder.reportModuleListItemNecessary.setText("大白兔");
        }
        holder.reportModuleListItemLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickListener.employTalentsPersonAdapterClick(data, position);
            }
        });
        return convertView;
    }
}