package com.wgmf.yxgj.module.business.managecapital.model

import com.wgmf.library.base.BaseResponse

/**
 * 资产收货实体类
 *
 * ReturnInfo«ZcshResponse» {
 * msgCode (integer, optional): 0 操作成功，1 操作失败 ,
 * msgContent (string, optional): 操作错误信息提示 ,
 * result (ZcshResponse, optional): 返回的数据对象 ,
 * resultList (Array[ZcshResponse], optional): 返回的数据集合 ,
 * sysCode (integer, optional): 0 系统正常，1系统异常 ,
 * sysContent (string, optional): 服务器异常错误信息提示
 * }
 * ZcshResponse {
 * createUserName (string, optional): 创建人名字 ,
 * isNotOeDBFlag (string, optional): isNotOeDBFlag = 'oeDB' 表示oe调拨的单；isNotOeDBFlag = ‘other’ 其它配送收货 ,
 * source (string, optional): 来源:工厂,总部,供应商,调拨 ,
 * storeName (string, optional): 门店名称 ,
 * storeNo (string, optional): 门店编号 ,
 * zcshBillCode (string, optional): 配送单号 ,
 * zcshDate (string, optional): 配送日期 ,
 * zcshQty (integer, optional): 配送数量 ,
 * zcshid (integer, optional): 资产收货id
 * }
 */
class CapitalReceiptsListEntity(var resultList: List<CapitalReceiptsBean>?) : BaseResponse() {

    data class CapitalReceiptsBean(
        var groupTitle:String?,
        var createUserName: String?,
        var isNotOeDBFlag: String?,
        var source: String?,
        var storeName: String?,
        var storeNo: String?,
        var zcshBillCode: String?,
        var zcshDate: String?,
        var zcshQty: Int,
        var zcshid: Int
    )


}