package com.wgmf.yxgj.module.business.managecapital.ui.adapter

import android.content.Context
import android.view.View
import android.widget.ImageButton
import android.widget.TextView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.library.utils.ToastUtil
import com.wgmf.yxgj.module.business.managecapital.R
import com.wgmf.yxgj.module.business.managecapital.model.CapitalReceiptsDetailsEntity

/**
 * @author LW
 * 资产管理-资产收获详情列表
 */
class CapitalReceiptsDetailsAdapter(
    val context: Context,
    val source: String,
    dataList: MutableList<CapitalReceiptsDetailsEntity.CapitalReceiptsDetailsBean>?
) : BaseQuickAdapter<CapitalReceiptsDetailsEntity.CapitalReceiptsDetailsBean, BaseViewHolder>(
    R.layout.item_capital_receipts_details_list, dataList
) {

    override fun convert(
        holder: BaseViewHolder?,
        item: CapitalReceiptsDetailsEntity.CapitalReceiptsDetailsBean?
    ) {
        holder?.let {
            item?.apply {

                it.setText(
                    R.id.capital_receipts_details_title_tv,
                    "[ " + proNo + " ] " + proName
                )
                val capitalReceiptsDetailsValueTv =
                    it.getView<TextView>(R.id.capital_receipts_details_value_tv)
                capitalReceiptsDetailsValueTv.text = proQty.toString()
                capitalReceiptsDetailsValueTv.tag = holder.layoutPosition

                val capitalReceiptsDetailsDecreaseoIb =
                    it.getView<ImageButton>(R.id.capital_receipts_details_decrease_ib)
                val capitalReceiptsDetailsPlusIb =
                    it.getView<ImageButton>(R.id.capital_receipts_details_plus_ib)

                //来源是“供应商”的资产，可以修改数量，修改的时候不能大于可收货数量，其它来源不可修改数量
                if (mContext.getString(R.string.supplier) == source) {
                    val proQtyMax = proQty

                    capitalReceiptsDetailsDecreaseoIb.visibility = View.VISIBLE
                    capitalReceiptsDetailsPlusIb.visibility = View.VISIBLE

                    //加号点击监听================================
                    capitalReceiptsDetailsPlusIb.setOnClickListener {
                        val d = proQty + 1

                        if (d > proQtyMax) {
                            ToastUtil.show(
                                context,
                                context.getString(R.string.quantity_not_big, proQtyMax.toString())
                            )
                            return@setOnClickListener
                        }

                        proQty = d
                        capitalReceiptsDetailsValueTv.text = proQty.toString()
                    }

                    //减号点击监听================================
                    capitalReceiptsDetailsDecreaseoIb.setOnClickListener {
                        val d = proQty - 1

                        if (d < 1) {
                            ToastUtil.show(
                                context,
                                context.getString(R.string.quantity_not_small, "1")
                            )
                            return@setOnClickListener
                        }

                        proQty = d
                        capitalReceiptsDetailsValueTv.text = proQty.toString()
                    }
                } else {
                    capitalReceiptsDetailsDecreaseoIb.visibility = View.INVISIBLE
                    capitalReceiptsDetailsPlusIb.visibility = View.INVISIBLE
                }
            }
        }
    }

}