package com.wgmf.yxgj.module.business.managecapital.ui.adapter

import android.content.Context
import android.support.v4.content.ContextCompat
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import android.widget.TextView
import com.wgmf.yxgj.module.business.managecapital.R
import com.wgmf.yxgj.module.business.managecapital.model.CapitalReceiptsListEntity


/**
 * @author LW
 * 资产管理-资产收获列表
 */
class CapitalReceiptsListAdapter(
    val context: Context,
    private var dataList: List<CapitalReceiptsListEntity.CapitalReceiptsBean>?,
    private val itemListener: OnAdapterItemListener
) : RecyclerView.Adapter<CapitalReceiptsListAdapter.CapitalReceiptsListViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): CapitalReceiptsListViewHolder {
        return CapitalReceiptsListViewHolder(
            LayoutInflater.from(context).inflate(R.layout.item_capital_receipts_list, parent, false)
        )
    }

    override fun getItemCount(): Int {
        return this.dataList?.size ?: 0
    }

    interface OnAdapterItemListener {
        fun onAdapterItemClick(bean: CapitalReceiptsListEntity.CapitalReceiptsBean?)
    }

    /**
     * 刷新列表数据
     * @param list List<CapitalReceiptsBean>
     */
    fun refreshData(list: List<CapitalReceiptsListEntity.CapitalReceiptsBean>) {
        dataList = list
        notifyDataSetChanged()
    }

    override fun onBindViewHolder(holder: CapitalReceiptsListViewHolder, position: Int) {
        val item = dataList?.get(position)
        item?.let {
            holder.apply {
                if (it.isNotOeDBFlag == "other") {
                    store.text = String.format(
                        context.getString(R.string.goods_receipts_list_item_dispatch_shop),
                        it.storeName ?: "--"
                    )
                    dispatchSource.text = String.format(
                        context.getString(R.string.goods_receipts_list_item_allot_source),
                        it.source ?: "--"
                    )
                    dispatchSource.setVisibility(View.VISIBLE)
                    dispatchNo.text = String.format(
                        context.getString(R.string.goods_receipts_list_item_dispatch_no),
                        it.zcshBillCode ?: "--"
                    )
                    dispatchDate.text = String.format(
                        context.getString(R.string.goods_receipts_list_item_dispatch_date),
                        it.zcshDate ?: "--"
                    )
                    dispatchNum.text = String.format(
                        context.getString(R.string.goods_receipts_list_item_dispatch_number),
                        it.zcshQty
                    )
                } else {
                    store.text = String.format(
                        context.getString(R.string.goods_receipts_list_item_dispatch_shop),
                        it.storeName ?: "--"
                    )
                    dispatchSource.visibility = View.GONE
                    dispatchNo.text = String.format(
                        context.getString(R.string.goods_receipts_list_item_allot_no),
                        it.zcshBillCode ?: "--"
                    )
                    dispatchDate.text = String.format(
                        context.getString(R.string.goods_receipts_list_item_allot_date),
                        it.zcshDate ?: "--"
                    )
                    dispatchNum.text = String.format(
                        context.getString(R.string.goods_receipts_list_item_allot_number),
                        it.zcshQty
                    )
                }
                isExamine.text = "收货"
                isExamine.setTextColor(ContextCompat.getColor(context, R.color.normal_color))
                receiptsListLl.setOnClickListener {
                    itemListener.onAdapterItemClick(item)
                }
            }
        }
    }

    class CapitalReceiptsListViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val receiptsListLl = view.findViewById<LinearLayout>(R.id.goods_receipts_list_item_ll)
        val store = view.findViewById<TextView>(R.id.goods_receipts_list_item_store_txt)
        val dispatchSource =
            view.findViewById<TextView>(R.id.goods_receipts_list_item_dispatch_source)
        val dispatchNo = view.findViewById<TextView>(R.id.goods_receipts_list_item_dispatch_no)
        val dispatchDate = view.findViewById<TextView>(R.id.goods_receipts_list_item_dispatchdate)
        val dispatchNum = view.findViewById<TextView>(R.id.goods_receipts_list_item_dispatchnum)
        val isExamine = view.findViewById<TextView>(R.id.is_examine)
    }
}