package com.wgmf.yxgj.module.business.managecapital.ui.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.base.BaseActivity;
import com.wgmf.yxgj.module.business.managecapital.R;
import com.wgmf.yxgj.module.business.managecapital.model.CapitalStockDetailsEntity;

import java.util.List;

public class CapitalStockDetailsAdapter extends BaseAdapter {
    private List<CapitalStockDetailsEntity> list;
    private BaseActivity context;

    public CapitalStockDetailsAdapter(List<CapitalStockDetailsEntity> list, BaseActivity context) {
        this.list = list;
        this.context = context;
    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @SuppressWarnings("all")
    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.item_capital_stock_details_list, null);
            viewHolder = new ViewHolder();
            viewHolder.store = (TextView) convertView.findViewById(R.id.list_item_title_txt);
            viewHolder.code = (TextView) convertView.findViewById(R.id.list_item_time_txt);
            viewHolder.itemCount = (TextView) convertView.findViewById(R.id.list_item_type_txt);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        CapitalStockDetailsEntity ent = list.get(position);
        viewHolder.code.setVisibility(View.GONE);
        viewHolder.store.setText("[" + ent.getFixedProduct().getProductCode() + "]" + ent.getFixedProduct().getProductName());
        viewHolder.itemCount.setText("" + ent.getProductNum() + "");
        viewHolder.itemCount.setCompoundDrawables(null, null, null, null);
        return convertView;
    }

    class ViewHolder {
        TextView store;
        TextView code;
        TextView itemCount;
    }
}
