package com.wgmf.yxgj.module.business.managecapital.ui.adapter;

import android.content.DialogInterface;
import android.graphics.Color;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnFocusChangeListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.library.utils.Arith;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.base.BaseActivity;
import com.wgmf.yxgj.dialog.PublicConformTipDialog;
import com.wgmf.yxgj.module.business.managecapital.R;
import com.wgmf.yxgj.module.business.managecapital.model.CapitalStockDetailsEntity;
import com.wgmf.yxgj.widgets.EditText.EditTextDecimal;

import java.util.List;

/**
 * 资产调入调出添加产品
 */
public class CapitalTransferredInOrOutAdapter extends BaseAdapter {
    private List<CapitalStockDetailsEntity> list;
    private BaseActivity context;

    public CapitalTransferredInOrOutAdapter(
            List<CapitalStockDetailsEntity> list, BaseActivity context) {
        this.list = list;
        this.context = context;
    }

    public void setNewData(List<CapitalStockDetailsEntity> list) {
        this.list = list;
        notifyDataSetChanged();
    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @SuppressWarnings("all")
    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final CapitalStockDetailsEntity data = list.get(position);
        final ViewHolder holder;
        convertView = null;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.goods_transferred_in_or_out_item, null);
            holder = new ViewHolder(convertView);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        holder.count.setTag(data);

        holder.name.setText(data.getFixedProduct().getProductName());
        holder.code.setVisibility(View.VISIBLE);
        holder.code.setText(data.getCapitalReceiptProductBillCode());
        String text = "库存：" + data.getProductNum();
        holder.kcNum.setText(text);

        String str = "" + data.getOrderNum();
        if (!TextUtils.isEmpty(str)) {
            holder.count.setText(str);
        } else {
            //因为count为数值型，所以默认值设为0
            holder.count.setText("0.0");
        }
        if (holder.count.getText().length() == 0) {
            holder.reduce.setEnabled(false);
        } else {
            holder.reduce.setEnabled(true);
        }
        if (data.getProductNum() > 0 && Double.valueOf(holder.count.getText().toString()) >= data.getProductNum()) {
            holder.add.setEnabled(false);
        } else {
            holder.add.setEnabled(true);
        }
        holder.count.setSelectAllOnFocus(true);
        holder.count.setDecimal(1);
        holder.count.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                holder.count.setText(holder.count.getText().toString());
                holder.count.selectAll();
                CapitalStockDetailsEntity info = (CapitalStockDetailsEntity) holder.count.getTag();
                info.setOrderNum(StringUtil.toDouble(holder.count.getText().toString()));
            }
        });
        holder.count.setOnFocusChangeListener(new OnFocusChangeListener() {
            @Override
            public void onFocusChange(final View v, boolean hasFocus) {
                if (!hasFocus && null != list && list.size() > position) {
                    String input = holder.count.getText().toString();
                    double d;
                    try {
                        d = Double.parseDouble(input);
                    } catch (NumberFormatException e) {
                        d = 0;
                    }
                    data.setOrderNum(d);
                    holder.count.setText(StringUtil.formatDouble(d, "0.0"));
                    String temp = "";
                    if (d < 0) {
                        temp = "必须输入有效的数字！";
                        holder.reduce.setEnabled(false);
                    }

                    if (!TextUtils.isEmpty(temp)) {
                        PublicConformTipDialog.Builder builder = new PublicConformTipDialog.Builder(context);
                        builder.setTitle("提示");
                        builder.setMessage(temp);
                        builder.setNegativeButton("知道了并重新输入", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                            }
                        });
                        builder.create().show();
                        data.setInvalid(true);
                        holder.count.setTextColor(Color.RED);
                    } else {
                        data.setInvalid(false);
                        holder.add.setEnabled(true);
                        holder.reduce.setEnabled(true);
                        holder.count.setTextColor(Color.BLACK);
                    }
                }
                CapitalStockDetailsEntity info = (CapitalStockDetailsEntity) holder.count.getTag();
                info.setOrderNum(StringUtil.toDouble(holder.count.getText().toString()));
            }
        });


        holder.add.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                double pDHPack = 1;
                double d = Arith.add(data.getOrderNum(), pDHPack);
                data.setOrderNum(d);
                String temp = "";
                holder.count.setText(StringUtil.formatDouble(d, "0.0"));
                if (d < 0) {
                    temp = "必须输入有效的数字！";
                }
                if (d < 0 || d > data.getProductNum()) {
                    temp = "调拨数量不能超过库存！";
                }
                if (!TextUtils.isEmpty(temp)) {
                    PublicConformTipDialog.Builder builder = new PublicConformTipDialog.Builder(context);
                    builder.setTitle("提示");
                    builder.setMessage(temp);
                    builder.setNegativeButton("知道了并重新输入", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                        }
                    });
                    builder.create().show();
                    data.setInvalid(true);
                    holder.count.setTextColor(Color.RED);
                    holder.add.setEnabled(false);
                } else {
                    data.setInvalid(false);
                    holder.count.setTextColor(Color.BLACK);
                }
                if (d > 0) {
                    holder.reduce.setEnabled(true);
                }
                CapitalStockDetailsEntity info = (CapitalStockDetailsEntity) holder.count.getTag();
                info.setOrderNum(StringUtil.toDouble(holder.count.getText().toString()));
            }
        });
        holder.reduce.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                double pDHPack = 1;
                double d = Arith.sub(data.getOrderNum(), pDHPack);
                data.setOrderNum(d);
                holder.count.setText(StringUtil.formatDouble(d, "0.0"));
                if (d <= 0) {
                    holder.reduce.setEnabled(false);
                    data.setInvalid(true);
                    holder.count.setTextColor(Color.RED);
                } else {
                    data.setInvalid(false);
                    holder.add.setEnabled(true);
                    holder.count.setTextColor(Color.BLACK);
                }
                CapitalStockDetailsEntity info = (CapitalStockDetailsEntity) holder.count.getTag();
                info.setOrderNum(StringUtil.toDouble(holder.count.getText().toString()));
            }
        });
        return convertView;
    }

    class ViewHolder {
        TextView name;
        TextView code;
        TextView kcNum;
        EditTextDecimal count;
        ImageButton add;
        ImageButton reduce;
        LinearLayout llShowDetail;

        public ViewHolder(View convertView) {
            name = (TextView) convertView.findViewById(R.id.goods_name);
            code = (TextView) convertView.findViewById(R.id.goods_code);
            kcNum = (TextView) convertView.findViewById(R.id.goods_price);
            llShowDetail = (LinearLayout) convertView.findViewById(R.id.ll_show_detail);
            count = (EditTextDecimal) convertView.findViewById(R.id.et_check_goods_count);
            add = (ImageButton) convertView.findViewById(R.id.goods_plus);
            reduce = (ImageButton) convertView.findViewById(R.id.goods_decrease);
        }
    }
}