package com.wgmf.yxgj.module.business.managecapital.ui.adapter;

import android.content.Context;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.managecapital.R;
import com.wgmf.yxgj.module.business.managecapital.model.CapitalStockDetailsEntity;

import java.util.List;

@SuppressWarnings("all")
public class CapitalTransferredInOrOutAddAdapter extends BaseAdapter {
    private final Context context;
    private final List<CapitalStockDetailsEntity> itemData;
    private OnAdapterClick onAdapterClick;

    public interface OnAdapterClick {
        void onItemClick(List<CapitalStockDetailsEntity> itemData, int position);
    }

    public CapitalTransferredInOrOutAddAdapter(Context context, OnAdapterClick onAdapterClick, List<CapitalStockDetailsEntity> tdlist) {
        this.itemData = tdlist;
        this.context = context;
        this.onAdapterClick = onAdapterClick;
    }

    @Override
    public int getCount() {
        return itemData.size();
    }

    @Override
    public Object getItem(int position) {
        return itemData.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        convertView = null;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.list_item_add_chioce_view, null);
        }
        final CapitalStockDetailsEntity item = itemData.get(position);
        final ListHolder holder = new ListHolder();
        if (item.getProductNum() > 0) {
            //如果库存>0则显示
            holder.des = (TextView) convertView.findViewById(R.id.content_text);
            holder.desCode = (TextView) convertView.findViewById(R.id.content_text_code);
            holder.choice = (TextView) convertView.findViewById(R.id.content_choice);
            holder.des.setText(item.getFixedProduct().getProductName());
            if (!TextUtils.isEmpty(item.getCapitalReceiptProductBillCode())) {
                holder.desCode.setText(item.getCapitalReceiptProductBillCode());
                holder.desCode.setVisibility(View.VISIBLE);
            } else {
                holder.desCode.setVisibility(View.GONE);
            }
            setCheckViewStatus(item, holder);
            holder.choice.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    item.setChoice(!item.isChoice());
                    onAdapterClick.onItemClick(itemData, position);
                }
            });
            convertView.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    item.setChoice(!item.isChoice());
                    onAdapterClick.onItemClick(itemData, position);
                }
            });
        }
        return convertView;
    }

    private void setCheckViewStatus(CapitalStockDetailsEntity item, ListHolder holder) {
        if (item.isChoice()) {
            holder.choice.setBackgroundResource(R.drawable.square_orange);
        } else {
            holder.choice.setBackgroundResource(R.drawable.square_gray);
        }
    }

    class ListHolder {
        TextView des;
        TextView desCode;
        TextView choice;
    }
}