package com.wgmf.yxgj.module.business.manageka.ui;

import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.View;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.yxgj.widgets.Dialog.DatePickerYearMonthDialog;
import com.wgmf.yxgj.widgets.TextView.MarqueeTextView;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.module.business.manageka.R;
import com.wgmf.yxgj.module.business.manageka.model.CustomerVisitEntity;
import com.wgmf.yxgj.module.business.manageka.model.CustomerVisitList;
import com.wgmf.yxgj.module.business.manageka.service.KAManagerService;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 客户拜访查询
 *
 * @author XiePing on 2017/7/26 10:29
 *         邮箱：2975837870@qq.com
 */
@Route(path = RouterParams.URL_CUSTOMERVISITQUERYACTIVITY)
public class CustomerVisitQueryActivity extends BaseParentAct implements View.OnClickListener {

    TextView customerVisitQueryHeaderLeftTv;
    TextView customerVisitQueryHeaderCenterTv;
    TextView customerVisitQueryHeaderRightTv;
    ListView customerVisitQueryContentLv;
    CustomerVisitQueryAdapter mCustomerVisitQueryAdapter;

    MarqueeTextView visitTime;
    MarqueeTextView visitCusName;
    MarqueeTextView visitCusPosition;
    MarqueeTextView visitSupermarketName;

    String yearMonth;
    List<CustomerVisitEntity> mCustomerVisitEntitys;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.customer_visit_query_activity);
        initTitle();
        initContent();
        getData(yearMonth);
    }

    private void initContent() {
        yearMonth = DateUtil.getFormatCurrentDate("yyyy-MM");

        customerVisitQueryHeaderLeftTv = (TextView) findViewById(R.id.customer_visit_query_header_left_tv);
        customerVisitQueryHeaderCenterTv = (TextView) findViewById(R.id.customer_visit_query_header_center_tv);
        customerVisitQueryHeaderRightTv = (TextView) findViewById(R.id.customer_visit_query_header_right_tv);
        customerVisitQueryHeaderCenterTv.setText(yearMonth);
        customerVisitQueryHeaderLeftTv.setOnClickListener(this);
        customerVisitQueryHeaderCenterTv.setOnClickListener(this);
        customerVisitQueryHeaderRightTv.setOnClickListener(this);

        TextView customerVisitQueryContentEmptyTv = (TextView) findViewById(R.id.customer_visit_query_content_empty_tv);
        customerVisitQueryContentLv = (ListView) findViewById(R.id.customer_visit_query_content_lv);
        customerVisitQueryContentLv.setEmptyView(customerVisitQueryContentEmptyTv);

        View headerView = getLayoutInflater().inflate(
                R.layout.customer_visit_query_content_list_item, null);
        customerVisitQueryContentLv.addHeaderView(headerView);

        mCustomerVisitEntitys = new ArrayList<>();
        mCustomerVisitQueryAdapter = new CustomerVisitQueryAdapter(mCustomerVisitEntitys, this);
        customerVisitQueryContentLv.setAdapter(mCustomerVisitQueryAdapter);

        visitTime = (MarqueeTextView) findViewById(R.id.customer_visit_query_content_visittime);
        visitCusName = (MarqueeTextView) findViewById(R.id.customer_visit_query_content_visitcusname);
        visitCusPosition = (MarqueeTextView) findViewById(R.id.customer_visit_query_content_visitcusposition);
        visitSupermarketName = (MarqueeTextView) findViewById(R.id.customer_visit_query_content_visitsupermarketname);
        visitTime.setTextColor(ContextCompat.getColor(this, R.color.secondary_txt_color));
        visitCusName.setTextColor(ContextCompat.getColor(this, R.color.secondary_txt_color));
        visitCusPosition.setTextColor(ContextCompat.getColor(this, R.color.secondary_txt_color));
        visitSupermarketName.setTextColor(ContextCompat.getColor(this, R.color.secondary_txt_color));
    }

    private void getData(String yearMonth) {
        if (null != userInfo) {
            mCustomerVisitEntitys.clear();
            mCustomerVisitQueryAdapter.notifyDataSetChanged();
            showDialog();
            String staffId = userInfo.getStaffId();
            KAManagerService.getInstance().requestFindCustomerVisit(staffId, yearMonth, this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("客户拜访查询");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
           if(id==BusinessID.KAManager.MSG_ON_FIND_CUSTOMER_VISIT){
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        CustomerVisitList mCustomerVisitList = new Gson().fromJson(msg, CustomerVisitList.class);
                        Log.d(TAG, "mCustomerVisitList=" + mCustomerVisitList.toString());
                        if (!mCustomerVisitList.getResultList().isEmpty()) {
                            mCustomerVisitEntitys = mCustomerVisitList.getResultList();
                            mCustomerVisitQueryAdapter = new CustomerVisitQueryAdapter(mCustomerVisitEntitys, this);
                            customerVisitQueryContentLv.setAdapter(mCustomerVisitQueryAdapter);
                            ListViewUtil.setListViewHeight(customerVisitQueryContentLv);
                        }
                    }
            }
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.customer_visit_query_header_left_tv) {
            //上一月
            int year = Integer.parseInt(yearMonth.substring(0, 4));
            int monthOfYear = Integer.parseInt(yearMonth.substring(5, 7));
            queryDataByMonth(year, monthOfYear, -1);
        } else if (v.getId() == R.id.customer_visit_query_header_right_tv) {
            //下一月
            int year = Integer.parseInt(yearMonth.substring(0, 4));
            int monthOfYear = Integer.parseInt(yearMonth.substring(5, 7));
            queryDataByMonth(year, monthOfYear, +1);
        } else if (v.getId() == R.id.customer_visit_query_header_center_tv) {
            new DatePickerYearMonthDialog(this, new DatePickerYearMonthDialog.OnDateSetListener() {
                @Override
                public void onDateSet(int year, int monthOfYear) {
                    queryDataByMonth(year, monthOfYear, +1);
                }
            }).show();
        }
    }

    private void queryDataByMonth(int year, int monthOfYear, int diff) {
        yearMonth = String.valueOf(year) + String.valueOf(monthOfYear + diff);
        Date yearMonthNow = DateUtil.string2Date(yearMonth, "yyyyM");
        yearMonth = DateUtil.format(yearMonthNow, "yyyy-MM");
        customerVisitQueryHeaderCenterTv.setText(yearMonth);
        getData(yearMonth);
    }
}