package com.wgmf.yxgj.module.business.manageka.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;

import com.wgmf.yxgj.module.business.manageka.R;
import com.wgmf.yxgj.module.business.manageka.model.CustomerVisitEntity;
import com.wgmf.yxgj.widgets.TextView.MarqueeTextView;

import java.util.List;

/**
 * @author XiePing on 2017/7/21 13:49
 * 邮箱：2975837870@qq.com
 */

class CustomerVisitQueryAdapter extends BaseAdapter {

    private Context context;
    private List<CustomerVisitEntity> mCustomerVisitEntity;

    CustomerVisitQueryAdapter(List<CustomerVisitEntity> mlist, Context context) {
        this.mCustomerVisitEntity = mlist;
        this.context = context;
    }

    @Override
    public int getCount() {
        return mCustomerVisitEntity == null ? 0 : mCustomerVisitEntity.size();
    }

    @Override
    public Object getItem(int position) {
        return mCustomerVisitEntity == null ? null : mCustomerVisitEntity.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.customer_visit_query_content_list_item, null);
            viewHolder = new ViewHolder(convertView);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        CustomerVisitEntity ent = mCustomerVisitEntity.get(position);
        viewHolder.visitTime.setText(ent.getVisitTime());
        viewHolder.visitCusName.setText(ent.getVisitCusName());
        viewHolder.visitCusPosition.setText(ent.getVisitCusPosition());
        viewHolder.visitSupermarketName.setText(ent.getVisitSupermarketName());
        return convertView;
    }

    class ViewHolder {
        MarqueeTextView visitTime;
        MarqueeTextView visitCusName;
        MarqueeTextView visitCusPosition;
        MarqueeTextView visitSupermarketName;

        ViewHolder(View convertView) {
            visitTime = (MarqueeTextView) convertView.findViewById(R.id.customer_visit_query_content_visittime);
            visitCusName = (MarqueeTextView) convertView.findViewById(R.id.customer_visit_query_content_visitcusname);
            visitCusPosition = (MarqueeTextView) convertView.findViewById(R.id.customer_visit_query_content_visitcusposition);
            visitSupermarketName = (MarqueeTextView) convertView.findViewById(R.id.customer_visit_query_content_visitsupermarketname);
        }
    }
}