package com.wgmf.yxgj.module.business.manageka.ui.customerVisit;

import android.os.Bundle;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.github.yoojia.inputs.ValueScheme;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.module.business.manageka.R;
import com.wgmf.yxgj.module.business.manageka.graph.CustomerVisitModule;
import com.wgmf.yxgj.module.business.manageka.graph.DaggerCustomerVisitComponent;
import com.wgmf.yxgj.module.business.manageka.model.CustomerVisitEntity;
import com.wgmf.yxgj.pop.PublicSelectPop;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.utils.helper.DialogHelper;
import com.xp.arouter.RouterParams;

import java.util.List;

import javax.inject.Inject;

/**
 * 客户拜访
 *
 * @author XiePing on 2017/7/26 10:29
 * 邮箱：2975837870@qq.com
 */
@Route(path = RouterParams.URL_CUSTOMERVISITACTIVITY)
public class CustomerVisitActivity extends BaseParentAct implements CustomerVisitView, PublicSelectPop.ReportQuerySelectPopListener, View.OnClickListener {

    TextView visitSupermarketNameTv;
    TextView visitCusPositionTv;
    TextView visitTimeTv;

    EditText visitCusNameTv;
    EditText salereView;
    EditText businessPlan;
    EditText placeImprove;
    EditText newOldStoreSnatch;
    EditText otherThing;
    EditText reportEdit;

    Button reportContentComfirmBtn;
    LinearLayout reportContentComfirmLl;

    PublicSelectPop customerVisitSelectPop1;
    PublicSelectPop customerVisitSelectPop2;
    /**
     * 1,商超系统 2,职位类型
     */
    int popType;

    @Inject
    CustomerVisitPresenter customerVisitPresenter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.customer_visit_activity);
        initTitle();
        initContent();
        initInjector();
        customerVisitPresenter.getData(userInfo);
    }

    private void initInjector() {
        DaggerCustomerVisitComponent.builder()
                .customerVisitModule(new CustomerVisitModule(this))
                .build()
                .inject(this);
    }

    private void initContent() {
        reportContentComfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        reportContentComfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        visitSupermarketNameTv = (TextView) findViewById(R.id.visit_supermarket_name_tv);
        visitCusPositionTv = (TextView) findViewById(R.id.visit_cus_position_tv);
        visitTimeTv = (TextView) findViewById(R.id.visit_time_tv);
        visitCusNameTv = (EditText) findViewById(R.id.visit_cus_name_tv);
        salereView = (EditText) findViewById(R.id.salere_view);
        businessPlan = (EditText) findViewById(R.id.business_plan);
        placeImprove = (EditText) findViewById(R.id.place_improve);
        newOldStoreSnatch = (EditText) findViewById(R.id.new_old_store_snatch);
        otherThing = (EditText) findViewById(R.id.other_thing);
        reportEdit = (EditText) findViewById(R.id.report_edit);
        reportEdit.setHint(getString(R.string.visit_result_or_reach_hint));
        reportContentComfirmLl.setVisibility(View.VISIBLE);
        reportContentComfirmBtn.setText(R.string.submit_btn_txt);
        visitTimeTv.setText(DateUtil.getFormatCurrentDate("yyyy-MM-dd"));
        reportContentComfirmBtn.setOnClickListener(this);
        visitSupermarketNameTv.setOnClickListener(this);
        visitCusPositionTv.setOnClickListener(this);
        visitTimeTv.setOnClickListener(this);
        // 默认不弹出软键盘
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("客户拜访");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        customerVisitPresenter.switchService(result);
    }

    @Override
    public void onAdapterItemClick(int position, List<BaseSelectorEntity> reportQuerys) {
        if (popType == 1) {
            //商超系统
            visitSupermarketNameTv.setText(reportQuerys.get(position).getSelectorName());
        } else if (popType == 2) {
            visitCusPositionTv.setText(reportQuerys.get(position).getSelectorName());
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.visit_supermarket_name_tv) {
            //商超系统
            popType = 1;
            if (null == customerVisitSelectPop1) {
                customerVisitSelectPop1 = new PublicSelectPop(this, this, customerVisitPresenter.getSupermarketNames());
            }
            if (!customerVisitSelectPop1.isShowing()) {
                customerVisitSelectPop1.show(this.findViewById(R.id.title));
            }
        } else if (v.getId() == R.id.visit_cus_position_tv) {
            //职位类型
            popType = 2;
            if (null == customerVisitSelectPop2) {
                customerVisitSelectPop2 = new PublicSelectPop(this, this, customerVisitPresenter.getCusPositions());
            }
            if (!customerVisitSelectPop2.isShowing()) {
                customerVisitSelectPop2.show(this.findViewById(R.id.title));
            }
        } else if (v.getId() == R.id.visit_time_tv) {
            DialogHelper.AlertDatePicker(this,this, visitTimeTv);
        } else if (v.getId() == R.id.report_content_confirm_btn && checkUploadData()) {
            uploadData();
        }
    }

    private void uploadData() {
        showDialog();
        CustomerVisitEntity mCustomerVisitEntity = new CustomerVisitEntity();
        if (null != userInfo) {
            mCustomerVisitEntity.setVisitPersonId(userInfo.getStaffId());
        }
        mCustomerVisitEntity.setVisitSupermarketName(visitSupermarketNameTv.getText().toString());
        mCustomerVisitEntity.setVisitCusName(visitCusNameTv.getText().toString());
        mCustomerVisitEntity.setVisitCusPosition(visitCusPositionTv.getText().toString());
        mCustomerVisitEntity.setVisitTime(visitTimeTv.getText().toString());
        mCustomerVisitEntity.setSaleReview(salereView.getText().toString());
        mCustomerVisitEntity.setBusinessPlan(businessPlan.getText().toString());
        mCustomerVisitEntity.setPlaceImprove(placeImprove.getText().toString());
        mCustomerVisitEntity.setNewOldStoreSnatch(newOldStoreSnatch.getText().toString());
        mCustomerVisitEntity.setOtherThing(otherThing.getText().toString());
        mCustomerVisitEntity.setVisitResultOrReach(reportEdit.getText().toString());
        customerVisitPresenter.uploadData(mCustomerVisitEntity);
    }

    private boolean checkUploadData() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        inputs.add(visitSupermarketNameTv, StaticScheme.Required(), ValueScheme.NotEquals(getString(R.string.empty_etb_hint_select_txt)).msgOnFail("未选择商超系统"));
        inputs.add(visitCusNameTv, StaticScheme.Required());
        inputs.add(visitCusPositionTv, StaticScheme.Required(), ValueScheme.NotEquals(getString(R.string.empty_etb_hint_select_txt)).msgOnFail("未选择客户职位"));
        inputs.add(visitTimeTv, StaticScheme.Required());
        inputs.add(salereView, StaticScheme.Required());
        inputs.add(businessPlan, StaticScheme.Required());
        inputs.add(placeImprove, StaticScheme.Required());
        inputs.add(newOldStoreSnatch, StaticScheme.Required());

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            showMsg("填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    @Override
    public void saveSuccessed(String mag) {
        showMsg(mag);
        this.finish();
    }
}