package com.wgmf.yxgj.module.business.manageproduct.model;

import android.text.TextUtils;

import com.wgmf.library.base.BaseResponse;

import java.io.Serializable;
import java.util.List;

import kotlin.jvm.Transient;
import pro.xp.com.indexbar.IndexBar.bean.BaseIndexPinyinBean;

/**
 * 调拨查询数据展示实体类
 *
 * @author Administrator
 */
public class DingHuoOplQtyEntity extends BaseResponse implements Serializable {
    public ResultInfo result;
    public class ResultInfo{
        public List<DinghuoDetail> list;//详情列表
        public List<Label> col;//分类标签
        public List<BrandPage> brandPage;//顶部品牌标签
        public String reason;   //加单原因
        public boolean firstOrder;//是否定货周期里第一次订货，是，则对五谷磨房产品进行金额2000+要求的提交限制。
        public boolean isfirstOrder;//是否定货周期里第一次订货，是，则对五谷磨房产品进行金额2000+要求的提交限制。
        public double mainBrandLimit;//磨粉订货金额限制
        public double maxStockLimit;//最大库存天数（现为60天）
    }

    public class BrandPage{
        public String title;//品牌标签标题
        public int type;//品牌类型码，8、15
    }

    public class DinghuoDetail extends BaseIndexPinyinBean implements Comparable<DinghuoDetail> {
        @Override
        public String getTarget() {
            return itemName;//以产品名称作为索引
        }

        @Transient
        public boolean isShowImageTv = false;//自建字段：是否显示“查看图片”文字，如果图片链接无效，则不显示，反之显示。

        public int type;//对应上面的分类标签Label

        public int brandId;//品牌id

        public boolean accessory;//是不是辅料

        public boolean isStockout;//是否缺货

        public String oe_pro_mode;//产品分类

        public double oe_pro_dh_qty;//近30天已订货数量

        public double officeProduct30DSaleNum; //办事处该产品近30天销售数量

        public String remark;//超过最大订货量时，继续添加时的提示说明。

        @Transient
        public boolean isShowAlert = true;//是否提示500
        /**
         * 订货最大数量（订货是需要用到）
         */
        public double max_opl_qty = 0;
        /**
         * 产品剩余订货量
         */
        public double sy_opl_qty = 0;
        /**
         * 订货建议数量
         */
        public double opl_qty = 0.0;

        /**
         * 商品编码
         */
        public String itemid;
        /**
         * 上月用量数
         */
        public String lastMonth_qty;
        /**
         * 库存数量
         */
        public String stock_Qty;
        /**
         * 已提交数量
         */
        public String pro_today_dhqty;
        /**
         * 产品名称
         */
        public String itemName;
        /**
         * 价格
         */
        public double itemPrice;
        /**
         * 规格:如-包灌
         */
        public String itemUOM;

        public boolean isInvalid = false;
        /**
         * 产品数量
         */
        private double TQTY = 0;
        /**
         * 金额
         */
        private double Amount = 0;
        /**
         * 本地计算库存率
         */
        private double cyl = 0.0;
        private double box_qty = 0;

        /**
         * 每次操作订购多少
         */
        private double pack = 0;

        /**
         * 产品包装 用于操作加减处理逻辑用
         */
        private double DHPack = 0;

        public String picUrl;
        public int oe_pro_id;
        public int itemUOM_id;

        public String getRemark() {
            return remark;
        }

        public double getMax_opl_qty() {
            return max_opl_qty;
        }

        public int getItemUOM_id() {
            return itemUOM_id;
        }

        public void setItemUOM_id(int itemUOM_id) {
            this.itemUOM_id = itemUOM_id;
        }

        public String getPicUrl() {
            return picUrl;
        }

        public void setPicUrl(String picUrl) {
            this.picUrl = picUrl;
        }

        public int getOe_pro_id() {
            return oe_pro_id;
        }

        public void setOe_pro_id(int oe_pro_id) {
            this.oe_pro_id = oe_pro_id;
        }

        public double getCyl() {
            return cyl;
        }

        public void setCyl(double cyl) {
            this.cyl = cyl;
        }

        public double getBox_qty() {
            return box_qty;
        }

        public void setBox_qty(double box_qty) {
            this.box_qty = box_qty;
        }

        public double getTQTY() {
            return TQTY;
        }

        public void setTQTY(double TQTY) {
            this.TQTY = TQTY;
        }

        public double getAmount() {
            return Amount;
        }

        public void setAmount(double amount) {
            Amount = amount;
        }

        public double getDHPack() {
            return DHPack;
        }

        public void setDHPack(double DHPack) {
            this.DHPack = DHPack;
        }

        public double getPack() {
            return pack;
        }

        public void setPack(double pack) {
            this.pack = pack;
        }

        @Override
        public int compareTo(DingHuoOplQtyEntity.DinghuoDetail another) {
            if (this.itemid.startsWith("2.4") || another.itemid.startsWith("2.4")) {
                if (this.itemid.startsWith("2.4") && another.itemid.startsWith("2.4")) {
                    return TextUtils.isEmpty(this.itemid) ? 1 : this.itemid.compareTo(another.itemid);
                } else if (this.itemid.startsWith("2.4")) {
                    return -1;
                } else {
                    return 1;
                }
            } else {
                return TextUtils.isEmpty(this.itemid) ? 1 : this.itemid.compareTo(another.itemid);
            }
        }

    }

    public static class Label{
        public Label(String title, int type) {
            this.title = title;
            this.type = type;
        }

        public String title;//标题
        public int type;//类型（对应上面Detail元素的type字段
    }

}
