package com.wgmf.yxgj.module.business.manageproduct.model

import com.wgmf.library.base.BaseResponse
import java.io.Serializable

/**
 * 订货审核
 *
 *  * orderBrandId (integer, optional):订货单的品牌： 8 表示磨粉，15食补，0表示食补和磨粉单 ,
 * orderGoodsAuditAmount (number, optional): 订货金额 ,
 * orderGoodsAuditId (integer, optional): 订货审核Id ,
 * orderGoodsAuditState (string, optional): 订货审核单状态 ,
 * orderGoodsBillCode (string, optional): 订货审核单号 ,
 * orderGoodsCycle (integer, optional): 订货周期 ,
 * orderGoodsWeekDay (integer, optional): 订货星期 ,
 * saleAmount (number, optional): 近30天销售金额 ,
 * setOrderDate (string, optional): 制单日期 ,
 * storeName (string, optional): 门店名称 ,
 * storeNo (string, optional): 门店编号 ,
 * submitFlag (boolean, optional): true 表示按钮显示， false 表示按钮隐藏 ,
 * typeNum (integer, optional): 品项数
 */
data class OrderGoodsAuditOrderReviewListEntity(
    val resultList: List<OrderGoodsAuditOrderReviewEntity>?
) : BaseResponse()

data class OrderGoodsAuditOrderReviewEntity(
    val isFirstOrder: Boolean,
    val orderBrandId: Int,
    val orderGoodsAuditAmount: Double,
    val orderGoodsAuditId: Int,
    val orderGoodsAuditState: String,
    val orderGoodsBillCode: String,
    val orderGoodsCycle: Int,
    val orderGoodsWeekDay: Int,
    val orderStateType: String,
    val orderstate: Int,
    val saleAmount: Double,
    val setOrderDate: String,
    val storeName: String,
    val storeNo: String,
    val submitFlag: Boolean=false,
    val typeNum: Int
) : Serializable

