package com.wgmf.yxgj.module.business.manageproduct.model

import com.wgmf.library.base.BaseResponse

/**
 * OrderGoodsAuditStoreBean {
alreadyOrderStoreNum (integer, optional): 已经提交订货门店数 ,
noOrderStoreNum (integer, optional): 未提交订货门店数 ,
notCanOrderStoreNum (integer, optional): 不可订货门店数 ,
notOrderGoodsAuditStoreList (Array[OrderGoodsStore], optional): 未提交订货审核的 ,
notOrderStoreList (Array[Shop], optional): 当前不可订货门店 ,
orderGoodsAuditStoreList (Array[OrderGoodsStore], optional): 已经提交订货审核的 ,
orderStoreNum (integer, optional): 当前应订货门店数 ,
sumStoreNum (integer, optional): 总门店数
}
OrderGoodsStore {
auditFlag (string, optional): 1表示已审核，2表示未审核,3表示未提交 ,
isFzsjd (boolean, optional): true 是 非直属加单门店，false ,
lastTDaySaleAmount (number, optional): 近30天销售金额 ,
orderAddAmount (number, optional): 订货加单金额 ,
orderAmount (number, optional): 订单金额 ,
shop (Shop, optional): 门店 ,
stockAmount (number, optional): 库存金额 ,
stockDayNum (integer, optional): 库存天数
}
Shop {
id (integer, optional),
isLDSR (integer, optional): 两店三人标识： 0是；1不是 ,
lDSRCode (string, optional): 门店两店三人编码 （编码相同，则属于同一组） ,
latitudes (number, optional): 纬度 ,
longitudes (number, optional): 经度 ,
saleOrganization (integer, optional): 销售组织id ,
shopCityCountryId (integer, optional): 门店销售城市id ,
shopId (string, optional): 门店shopid ,
shopIsCanOrder (boolean, optional): 门店是否可以订货：true 表示可以订货，false 不可以订货 ,
shopName (string, optional): 门店名称 ,
shopStatusType (integer, optional): 7024 : 单一磨粉7025 : 单一食补7026 : 兼岗门店7027 : 专岗门店 ,
shopType (string, optional): 类型 :DZD 五谷事业部 ,
usable (string, optional)
}
 */
data class OrderGoodsAuditStoreGroupListEntity (
    var result: OrderGoodsAuditStoreGroupEntity?
): BaseResponse()

data class OrderGoodsAuditStoreGroupEntity(
    var sumStoreNum: Int,
    var orderStoreNum: Int,
    val noOrderStoreNum: Int,
    val alreadyOrderStoreNum: Int,
    val notCanOrderStoreNum: Int,
    var orderGoodsAuditStoreList: List<OrderStoreList>?,
    var notOrderGoodsAuditStoreList: List<OrderStoreList>?,
    var notOrderStoreList: List<NotOrderStoreList>?
)

data class OrderStoreList(
    var shop: Shop,
    var orderAmount: Double,
    var orderAddAmount: Double,
    var stockAmount: Double,
    var lastTDaySaleAmount: Double,
    var stockDayNum: Int,
    var auditFlag: String,
    var isFzsjd:Boolean
)

data class NotOrderStoreList(var shopId: String, var shopName: String, var shopIsCanOrder: Boolean)

data class Shop(var shopId: String, var shopName: String, var shopIsCanOrder: Boolean)