package com.wgmf.yxgj.module.business.manageproduct.model

import com.wgmf.library.base.BaseResponse
import java.io.Serializable

class StockGoodsCheckDetailsListEntity(val resultList: List<StockGoodsDetailsGroup>?) :
    BaseResponse()

/**
 * proBrandName (string, optional):品牌名称 ,
 * stockGoodsCheckDetailsList (Array[StockGoodsCheckDetails], optional):存货盘点明细
 * inventoryImages (string, optional):盘点单照片，多张用英文 ',' 隔开 ,
 * onlyUpdatePdImages (boolean, optional):只修改图片true,flase都修改 ,
 * pdBillCode (string, optional):盘点单号 ,
 * pdId (integer, optional):盘点Id ,
 * type (string, optional):类型 :UPDATE =0 或 INSERT =1
 */
data class StockGoodsDetailsGroup(
    var proBrandName: String,
    var inventoryImages: String,
    var onlyUpdatePdImages: Boolean,
    var pdId: Int,
    var pdBillCode: String,
    var type: String,
    var pdUpdateReson: String,
    var stockGoodsCheckDetailsList: List<StockGoodsCheckDetailsList>
) : Serializable {

    constructor() : this(
        "", "", false,
        -1, "", "", "", mutableListOf()
    )
}

/**
 * locationId (integer, optional): 库位ID ,
 * pdAlterNum (number, optional): 修改盘点数量后的数量 ,
 * pdAmount (number, optional): 盘点金额 ,
 * pdBillCode (string, optional): 盘点单号 ,
 * pdDiffAmount (number, optional): 差异金额 ,
 * pdDiffNum (number, optional): 差异数量 ,
 * pdId (integer, optional): 盘点Id ,
 * pdNum (number, optional): 盘点数量 ,
 * pdStatus (string, optional): 盘点单状态 ('草稿', '待审核','生效') ,
 * proCode (string, optional): 产品编号 ,
 * proId (integer, optional): 产品id ,
 * proName (string, optional): 产品名字 ,
 * proPrice (number, optional): 产品价格 ,
 * proUnit (string, optional): 产品单位 ,
 * proUnitId (integer, optional): 产品单位Id ,
 * stockNum (number, optional): 库存数量 ,
 * storeId (integer, optional): 门店id ,
 * type (string, optional): 类型 :UPDATE =0 或 INSERT =1 ,
 * userNo (string, optional): 操作用户工号 ,
 * yearMonth (string, optional): 盘点单的年月yyyyMM
 * pdUpdateReson (string, optional):盘点修改原因
 *
 * @author XiePing on 2016/10/14 14:13
 */
data class StockGoodsCheckDetailsList(
    val inventoryImages: String,
    val pdFrontNum: Double,
    val locationId: Int,
    val pdBillCode: String,
    var pdAlterNum: String?,
    var pdDiffAmount: Double,
    var pdDiffNum: Double,
    var pdDiffAmountOld: Double,
    var pdDiffNumOld: Double,
    val pdId: Int,
    val pdNum: Double,
    val proCode: String,
    val proId: Int,
    val proName: String,
    val proUnit: String,
    val proUnitId: Int,
    val proPrice: Double,
    val stockNum: Double,
    var pdAmount: Double,
    val storeId: Int,
    val type: String,
    var pdStatus: String,
    var userNo: String,
    var yearMonth: String
) : Serializable