package com.wgmf.yxgj.module.business.manageproduct.ui

import android.os.Bundle
import android.support.v4.app.Fragment
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.wgmf.yxgj.dialog.LoadWaitDominator
import com.wgmf.yxgj.module.business.manageproduct.R
import com.wgmf.yxgj.module.business.manageproduct.model.ProductAndSuggestOrderGoodsList
import com.wgmf.yxgj.utils.isNotNullOrSize
import com.wgmf.yxgj.utils.notNullAndEmpty
import pro.xp.com.indexbar.IndexBar.widget.IndexBar
import pro.xp.com.indexbar.IndexbarConfig

/**
 * 订货审核添加产品分页
 *
 * @author LW
 */
class AddProductsTabLayoutListFragment : Fragment() {
    private var mIndexBar: IndexBar? = null
    private var mTvSideBarHint: TextView? = null
    private var mRlProductView: RecyclerView? = null
    private var mProductType: String? = null

    lateinit var mLoadWait: LoadWaitDominator

    private var mGoodsAuditingAddProductsAdapter: GoodsAuditingAddProductsAdapter? = null
    private var mProductAndSuggestOrderGoodsList: List<ProductAndSuggestOrderGoodsList> =
        ArrayList()

    private var mProductAndSuggestOrderGoodsFilterList: MutableList<ProductAndSuggestOrderGoodsList> =
        mutableListOf()

    fun setData(bundle: Bundle) {
        mProductAndSuggestOrderGoodsList =
            bundle.getSerializable("productAndSuggestOrderGoodsList") as List<ProductAndSuggestOrderGoodsList>

        mProductType = bundle.getString("productType")
    }

    /**
     * 过滤条件
     */
    fun setDataFilterCondition(
        keyword: String
    ) {
        mLoadWait.dismissAll()
        if (keyword.notNullAndEmpty()) {
            mProductAndSuggestOrderGoodsFilterList.clear()
            mProductAndSuggestOrderGoodsList.forEach {
                if (it.fixedProduct.productName.contains(keyword)) {
                    mProductAndSuggestOrderGoodsFilterList.add(it)
                }
            }
            if (mProductAndSuggestOrderGoodsFilterList.isNotNullOrSize()) {
                mGoodsAuditingAddProductsAdapter =
                    GoodsAuditingAddProductsAdapter(
                        activity,
                        mProductAndSuggestOrderGoodsFilterList
                    )
            }else{
                mLoadWait.showNoData()
                return
            }
        } else {
            if(mProductAndSuggestOrderGoodsList.isNotNullOrSize()) {
                mGoodsAuditingAddProductsAdapter =
                    GoodsAuditingAddProductsAdapter(activity, mProductAndSuggestOrderGoodsList)
            }else{
                mLoadWait.showNoData()
                return
            }
        }
        mRlProductView?.adapter = mGoodsAuditingAddProductsAdapter
    }

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        val view: View = inflater.inflate(R.layout.list_add_products_tab, null)
        mLoadWait = LoadWaitDominator(inflater.context, view.findViewById(R.id.public_container_fl))
        mLoadWait.dismissAll()
        if (mProductAndSuggestOrderGoodsList.isNotNullOrSize()) {
            mIndexBar = view.findViewById(R.id.product_index_bar)
            mTvSideBarHint = view.findViewById(R.id.product_view_tv)
            mGoodsAuditingAddProductsAdapter =
                GoodsAuditingAddProductsAdapter(activity, mProductAndSuggestOrderGoodsList)
            view.findViewById<RecyclerView>(R.id.product_view_rv).apply {
                layoutManager = LinearLayoutManager(activity)
                adapter = mGoodsAuditingAddProductsAdapter
            }.also { mRlProductView = it }
            val type: Int = if ("全部" == mProductType) {
                -1
            } else {
                0
            }
            refreshRvByLabel(type)
        } else {
            mLoadWait.showNoData()
        }
        return view
    }

    /**
     * 根据上面的标签分类来过滤显示对应的列表
     */
    private fun refreshRvByLabel(type: Int) {
        //刷新数据
        mGoodsAuditingAddProductsAdapter?.notifyDataSetChanged() //这里对list做过滤处理后会赋给showList
        val indexBarConfig = IndexbarConfig(
            activity!!,
            mIndexBar!!,
            mTvSideBarHint!!,
            mRlProductView!!,
            mProductAndSuggestOrderGoodsList
        ).configDefault()
        indexBarConfig.toggleShowIndexBar(type == -1) //-1表示“全部”标签
    }
}