package com.wgmf.yxgj.module.business.manageproduct.ui

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import android.widget.TextView
import com.wgmf.yxgj.module.business.manageproduct.R
import com.wgmf.yxgj.module.business.manageproduct.model.GoodsAddOrderStoreListEntity


/**
 * @author Sasuke on 2020-4-28 0028.
 * 货品管理-订货加单门店列表适配器
 */
class GoodsAddOrderEntryAdapter(val context: Context, val dataList: List<GoodsAddOrderStoreListEntity.ShopInfo>?) : RecyclerView.Adapter<GoodsAddOrderEntryAdapter.AddOrderHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): AddOrderHolder {
        return AddOrderHolder(LayoutInflater.from(context).inflate(R.layout.add_order_goods_shop_item, parent, false))
    }

    override fun getItemCount(): Int {
        return dataList?.size ?:0
    }

    override fun onBindViewHolder(holder: AddOrderHolder, position: Int) {
        val item = dataList?.get(position)
        holder.apply {
            storeName.text = item?.shopName
            root.setOnClickListener {
//                ARouter.getInstance().build(RouterParams.URL_ORDERGOODSSUBMITACT)
//                        .with(Bundle().apply {
//                            putString("shopId", item?.shopId)
//                            putString("shopName", item?.shopName)
//                        })
//                        .navigation()
                (context as Activity).startActivityForResult(Intent(context,OrderGoodsSubmitAct::class.java).apply {
                    putExtra("shopId", item?.shopId)
                    putExtra("shopName", item?.shopName)
                },0)
            }
        }
    }

    class AddOrderHolder(view: View) : RecyclerView.ViewHolder(view) {
        val root = view.findViewById<LinearLayout>(R.id.addOrderItemLayout)
        val storeName = view.findViewById<TextView>(R.id.addOrderStoreTv)
    }
}