package com.wgmf.yxgj.module.business.manageproduct.ui

import android.content.Context
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.Gravity
import android.view.LayoutInflater
import android.view.View
import android.view.WindowManager
import android.widget.Button
import android.widget.FrameLayout
import android.widget.PopupWindow
import android.widget.TextView
import com.wgmf.yxgj.dialog.LoadWaitDominator
import com.wgmf.yxgj.model.BatchOrderAuditBillCode
import com.wgmf.yxgj.model.OrderGoodsAuditBatchDetail
import com.wgmf.yxgj.module.business.manageproduct.R

/**
 * @author LW on 2021-9-26 0026.
 * 批量审核选择框
 */
class GoodsAuditingBatchPop(
    private val context: Context,
    private val width: Int = WindowManager.LayoutParams.MATCH_PARENT,
    private val height: Int = WindowManager.LayoutParams.MATCH_PARENT,
    private val auditBatchDetail: OrderGoodsAuditBatchDetail,
    private val position: Int,
    private val listener: OnAdapterConfirmClickListener?
) {

    private var mViewParent: View? = null

    private var mGoodsAuditingBatchEditPw: PopupWindow? = null

    private lateinit var mLoadWait: LoadWaitDominator

    private val mAuditBatchList = mutableListOf<BatchOrderAuditBillCode>()

    interface OnAdapterConfirmClickListener {
        fun onConfirmClick(position: Int, auditBatchDetail: OrderGoodsAuditBatchDetail)
    }

    init {
        val inflater = LayoutInflater.from(context)
        mViewParent = inflater.inflate(R.layout.pop_auditing_goods_batch, null)
        mViewParent?.let {
            mLoadWait =
                LoadWaitDominator(context, it.findViewById<FrameLayout>(R.id.fl_auditing_pop_root))
            mLoadWait.show(LoadWaitDominator.LOADING)
            val tvTitle = it.findViewById<TextView>(R.id.tv_auditing_pop_title)
            val rlBatchList =
                it.findViewById<RecyclerView>(R.id.rl_auditing_pop_batch)

            tvTitle.text = auditBatchDetail.productName
            if (auditBatchDetail.batchOrderAuditBillCodeList.isNotEmpty()) {
                mLoadWait.dismissAll()
                auditBatchDetail.batchOrderAuditBillCodeList.forEach {
                    val batchOrderAuditBillCode = BatchOrderAuditBillCode(
                        it.orderGoodsBillCode,
                        it.orderGoodsAuditId,
                        it.orderGoodsNum,
                        it.orderGoodsAuditNum,
                        it.orderGoodsBrand
                    )
                    mAuditBatchList.add(batchOrderAuditBillCode)
                }
                val popAdapter =
                    GoodsAuditingBatchPopAdapter(context, auditBatchDetail, mAuditBatchList)
                rlBatchList.apply {
                    layoutManager = LinearLayoutManager(context)
                    adapter = popAdapter
                }
            } else {
                mLoadWait.show(LoadWaitDominator.NO_DATA)
            }

            val btnCancel = it.findViewById<View>(R.id.btn_auditing_pop_cancel) as Button
            val btnConfirm = it.findViewById<View>(R.id.btn_auditing_pop_confirm) as Button
            mGoodsAuditingBatchEditPw = PopupWindow(mViewParent, width, height, true)
            btnCancel.setOnClickListener {
                mGoodsAuditingBatchEditPw!!.dismiss()
            }
            btnConfirm.setOnClickListener {
                mGoodsAuditingBatchEditPw!!.dismiss()
                auditBatchDetail.batchOrderAuditBillCodeList = mAuditBatchList
                listener?.onConfirmClick(position, auditBatchDetail)
            }
        }
    }

    fun isShowing(): Boolean {
        return null != mGoodsAuditingBatchEditPw && mGoodsAuditingBatchEditPw!!.isShowing
    }

    fun show(parent: View?) {
        requireNotNull(parent) { "StoreDateSelectorPop.showAtLocation parent is null" }
        mViewParent = parent
        mGoodsAuditingBatchEditPw!!.showAtLocation(parent, Gravity.CENTER, 0, 0)
    }

    fun dismiss() {
        if (null != mGoodsAuditingBatchEditPw && mGoodsAuditingBatchEditPw!!.isShowing) {
            mGoodsAuditingBatchEditPw!!.dismiss()
        }
    }
}