package com.wgmf.yxgj.module.business.manageproduct.ui

import android.content.Context
import android.graphics.Color
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageButton
import android.widget.TextView
import com.wgmf.library.utils.Arith
import com.wgmf.yxgj.model.BatchOrderAuditBillCode
import com.wgmf.yxgj.model.OrderGoodsAuditBatchDetail
import com.wgmf.yxgj.module.business.manageproduct.R
import com.wgmf.yxgj.utils.StringUtils

/**
 * @author LW on 2021-9-26 0026.
 * 批量审核选择框适配器
 */
class GoodsAuditingBatchPopAdapter(
    private val context: Context,
    private val auditBatchDetail: OrderGoodsAuditBatchDetail,
    private val auditBatchList: MutableList<BatchOrderAuditBillCode>
) : RecyclerView.Adapter<GoodsAuditingBatchPopAdapter.GoodsAuditingBatchPopViewHolder>() {

    override fun onCreateViewHolder(
        parent: ViewGroup,
        viewType: Int
    ): GoodsAuditingBatchPopViewHolder {
        return GoodsAuditingBatchPopViewHolder(
            LayoutInflater.from(context)
                .inflate(R.layout.pop_auditing_goods_batch_item, parent, false)
        )
    }

    override fun getItemCount(): Int {
        return auditBatchList.size
    }

    override fun onBindViewHolder(
        holder: GoodsAuditingBatchPopViewHolder,
        pos: Int
    ) {
        val data = auditBatchList[pos]
        holder.apply {
            tvOrderNumber.text = data.orderGoodsBillCode
            tvGoodsCount.tag = pos
            tvGoodsCount.setTextColor(if (auditBatchDetail.invalid) Color.RED else Color.BLACK)

            //if (auditBatchDetail.productIsNotStock) {
            //    tvGoodsCount.setText(R.string.factory_out_stock)
            //    tvGoodsCount.setTextColor(Color.RED)
            //    tvGoodsCount.setBackgroundResource(R.drawable.shape_transparent)
            //    ibGoodsDecrease.visibility = View.INVISIBLE
            //    ibGoodsPlus.visibility = View.INVISIBLE
            //} else {
                tvGoodsCount.setTextColor(Color.BLACK)
                tvGoodsCount.setBackgroundResource(R.drawable.shape_solid_f5f5f5_round_3)
                ibGoodsDecrease.visibility = View.VISIBLE
                ibGoodsPlus.visibility = View.VISIBLE
                tvGoodsCount.text = StringUtils.formatDouble(data.orderGoodsAuditNum, "0.00")
            //}

            //减号逻辑===============
            if (data.orderGoodsAuditNum == 0.0) {
                ibGoodsDecrease.isEnabled = false
                ibGoodsDecrease.setImageResource(R.mipmap.icon_shop_order_subtract)
            } else {
                ibGoodsDecrease.isEnabled = true
                ibGoodsDecrease.setImageResource(R.mipmap.icon_shop_order_subtract)
            }
            //加号逻辑===============
            ibGoodsPlus.isEnabled = true
            ibGoodsPlus.setImageResource(R.mipmap.icon_shop_order_add)

            //加号点击监听================================
            ibGoodsPlus.setOnClickListener {
                val cell: BatchOrderAuditBillCode = auditBatchList[pos]
                val pDHPack = auditBatchDetail.productBoxNum
                val d = Arith.add(cell.orderGoodsAuditNum, pDHPack)
                cell.orderGoodsAuditNum = d
                tvGoodsCount.setText(StringUtils.formatDouble(d, "0.00"))

                if (d < 0.0) {
                    tvGoodsCount.setTextColor(Color.RED)
                } else {
                    tvGoodsCount.setTextColor(Color.BLACK)
                }

                if (d > 0.0) {
                    ibGoodsDecrease.isEnabled = true
                }
                if (d <= 0.0) {
                    ibGoodsDecrease.isEnabled = false
                }
            }

            //减号点击监听================================
            ibGoodsDecrease.setOnClickListener {
                val cell: BatchOrderAuditBillCode = auditBatchList[pos]
                val pDHPack = auditBatchDetail.productBoxNum
                val d = Arith.sub(cell.orderGoodsAuditNum, pDHPack)
                cell.orderGoodsAuditNum = d
                tvGoodsCount.text = StringUtils.formatDouble(d, "0.00")

                if (d < 0.0) {
                    tvGoodsCount.setTextColor(Color.RED)
                } else {
                    tvGoodsCount.setTextColor(Color.BLACK)
                }

                if (d > 0.0) {
                    ibGoodsDecrease.isEnabled = true
                }
                if (d <= 0.0) {
                    ibGoodsDecrease.isEnabled = false
                }
            }
        }
    }

    class GoodsAuditingBatchPopViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val tvOrderNumber: TextView = view.findViewById(R.id.tv_goods_order_number)
        val ibGoodsDecrease: ImageButton =
            view.findViewById(R.id.ib_goods_decrease)
        val ibGoodsPlus: ImageButton =
            view.findViewById(R.id.ib_goods_plus)
        val tvGoodsCount: TextView = view.findViewById(R.id.tv_goods_count)
    }
}