package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;
import com.jakewharton.rxbinding.view.RxView;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.model.SelectImageGroupList;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsCheckDetailsList;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsDetailsGroup;
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsManagerService;
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsStockInfoCheck;
import com.wgmf.yxgj.pop.PublicThreeSecondsPop;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.global.Params;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

import rx.functions.Action1;

/**
 * 货品管理--存货盘点：（第三页）盘点图片选择
 */
@SuppressWarnings("all")
public class GoodsStockCheckPicturesActivity extends ReportWithPhotoBaseActivity implements GoodsStockCheckSelectImageAdapter.LvListener, PublicThreeSecondsPop.ThreeSecondsPopListener {
    private List<StockGoodsDetailsGroup> stockGoodsDetailsGroups;
    private GoodsStockCheckSelectImageAdapter mAdapter;
    private TextView submitModifyTv;
    private TextView submitConformTv;
    private TextView pdAmountTv;
    private TextView pdDiffNumTv;
    private LinearLayout submitLl;

    private List<BaseSelectorEntity> baseSelectorEntitys;
    /**
     * 查询的月份
     */
    private String yearMonth;

    private String storeName;
    private String pdState;
    private int pdId;
    private String pdBillCode;
    private String mPdAmount;
    private String mPdDiffAmount;
    private String inventoryImages;

    private PublicThreeSecondsPop publicThreeSecondsPop;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText("门店盘点明细");
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
    }

    @Override
    protected void initData() {
        super.initData();
        reportType = "PD";
        storeName = getIntent().getStringExtra("storeName");
        yearMonth = getIntent().getStringExtra("yearMonth");
        mPdAmount = getIntent().getStringExtra("mPdAmount");
        mPdDiffAmount = getIntent().getStringExtra("mPdDiffAmount");
        pdState = getIntent().getStringExtra("pdState");
        pdId = getIntent().getIntExtra("pdId", 0);
        pdBillCode = getIntent().getStringExtra("pdBillCode");
        inventoryImages = getIntent().getStringExtra("inventoryImages");
        stockGoodsDetailsGroups = (List<StockGoodsDetailsGroup>) getIntent().getSerializableExtra("stockGoodsDetailsGroups");
    }

    /**
     * 设置列表头和尾布局
     */
    @Override
    protected void setListHeadAndFootView() {
        super.setListHeadAndFootView();
    }

    @Override
    protected void parseHeadData() {
        super.parseHeadData();
        LinearLayout titleMoreLl = (LinearLayout) findViewById(R.id.title_more_ll);
        TextView reportDetailTitle = (TextView) findViewById(R.id.report_detail_title);
        TextView reportDetailDate = (TextView) findViewById(R.id.report_detail_date);
        titleMoreLl.setVisibility(View.VISIBLE);
        reportDetailTitle.setVisibility(View.VISIBLE);
        reportDetailDate.setVisibility(View.VISIBLE);
        reportDetailTitle.setText(storeName);
        reportDetailDate.setText(yearMonth);
    }

    @Override
    protected void parseFootData() {
        super.parseFootData();
        submitLl = (LinearLayout) findViewById(R.id.submit_ll);
        submitModifyTv = (TextView) findViewById(R.id.submit_modify_tv);
        submitConformTv = (TextView) findViewById(R.id.submit_conform_tv);
        pdAmountTv = (TextView) findViewById(R.id.pd_amount_tv);
        pdDiffNumTv = (TextView) findViewById(R.id.pd_diff_num_tv);
        pdAmountTv.setText(mPdAmount);
        pdDiffNumTv.setText(mPdDiffAmount);
        submitLl.setVisibility(View.VISIBLE);
        submitModifyTv.setVisibility(View.VISIBLE);
        submitConformTv.setVisibility(View.GONE);
        reportContentConfirmLl.setVisibility(View.GONE);
        submitModifyTv.setText(R.string.submit_btn_txt);

        //3秒钟之内只取一个点击事件，防抖操作
        RxView.clicks(submitModifyTv).throttleFirst(3, TimeUnit.SECONDS).subscribe(new Action1<Void>() {
            @Override
            public void call(Void aVoid) {
                setUploadData();
            }
        });
    }

    @Override
    protected void setListAdapter() {
        super.setListAdapter();
        List<SelectImageGroupList> selectImageGroupList = new ArrayList<>();
        selectImageGroupList = GoodsStockInfoCheck.getSubjectItems(this);
        if (!StringUtil.isNullString(inventoryImages)) {
            if (inventoryImages.contains(",")) {
                String[] personalidImgs = inventoryImages.split(",");//中文或英文字符？
                for (int i = 0; i < personalidImgs.length; i++) {
                    if (!"null".equals(personalidImgs[i])) {
                        ImageItem item = new ImageItem();
                        item.setImgneturl(personalidImgs[i]);
                        item.setImagePath(personalidImgs[i]);
                        item.setImageId(personalidImgs[i]);
                        item.setUri(Uri.fromFile(new File(personalidImgs[i])));
                        item.setType(1);
                        item.setSingleModify(true);
                        mImageselectList.add(item);
                    }
                }
            } else {
                ImageItem item = new ImageItem();
                item.setImgneturl(inventoryImages);
                item.setImagePath(inventoryImages);
                item.setImageId(inventoryImages);
                item.setUri(Uri.fromFile(new File(inventoryImages)));
                item.setType(1);
                item.setSingleModify(true);
                mImageselectList.add(item);
            }
            selectImageGroupList.get(0).setStoreImageselectList(mImageselectList);
        }
        mAdapter = new GoodsStockCheckSelectImageAdapter(selectImageGroupList, this, this);
        publicListViewLv.setAdapter(mAdapter);
    }

    @Override
    protected void setUploadData() {
        //设置图片
        if (null != idImagePickerContainer) {
            mImageselectList = idImagePickerContainer.getmImageselectList();
            if (null != mImageselectList && !mImageselectList.isEmpty()) {
                super.setUploadData();
                return;
            }
        }
        uploadData();
    }

    @Override
    protected void uploadData() {
        super.uploadData();
        String images = null;//图片字段
        StockGoodsDetailsGroup mStockGoodsDetailsGroup = new StockGoodsDetailsGroup();
        List<StockGoodsCheckDetailsList> mUpdataStockGoodsCheckDetailsList = new ArrayList<>();
        List<StockGoodsCheckDetailsList> mStockGoodsCheckDetailsList = new ArrayList<>();

        images = inventoryImages;//已上传图片

        if (null != stockGoodsDetailsGroups && !stockGoodsDetailsGroups.isEmpty()) {
            for (int i = 0; i < stockGoodsDetailsGroups.size(); i++) {
                mStockGoodsCheckDetailsList.addAll(stockGoodsDetailsGroups.get(i).getStockGoodsCheckDetailsList());
            }
        }
        for (int i = 0; i < mStockGoodsCheckDetailsList.size(); i++) {
            if (!TextUtils.isEmpty(mStockGoodsCheckDetailsList.get(i).getPdAlterNum())) {
                mStockGoodsCheckDetailsList.get(i).setUserNo(userInfo.getStaffId());
                mStockGoodsCheckDetailsList.get(i).setPdStatus(pdState);
                mUpdataStockGoodsCheckDetailsList.add(mStockGoodsCheckDetailsList.get(i));
            }
        }
        //图片和盘点数据不能同时为空，至少需修改一项
        if (qiniuUrlLists.isEmpty() && (null == mUpdataStockGoodsCheckDetailsList || mUpdataStockGoodsCheckDetailsList.isEmpty())) {
            Toast.makeText(GoodsStockCheckPicturesActivity.this, "您没有修改内容哦!", Toast.LENGTH_LONG).show();
            dismissDialog();
            return;
        }
        mStockGoodsDetailsGroup.setPdUpdateReson(stockGoodsDetailsGroups.get(0).getPdUpdateReson());
        mStockGoodsDetailsGroup.setPdId(pdId);
        mStockGoodsDetailsGroup.setPdBillCode(pdBillCode);

        //是否只修改图片:如果盘点集合为空则为true,否则为false
        if (mUpdataStockGoodsCheckDetailsList.isEmpty()) {
            mStockGoodsDetailsGroup.setOnlyUpdatePdImages(true);
        } else {
            mStockGoodsDetailsGroup.setOnlyUpdatePdImages(false);
        }
        //是否是更新图片，原来集合中有图片，则是更新 UPDATE =0 ，否则为插入 INSERT =1
        if (StringUtil.isNotNullAndNotEmpty(images)) {
            mStockGoodsDetailsGroup.setType("0");
        } else {
            mStockGoodsDetailsGroup.setType("1");
        }
        //添加图片
        if (!urlLists.isEmpty()) {//图片上传集合不为空
            if (StringUtil.isNotNullAndNotEmpty(images)) {//已经上传过图片，先加入，号分割
                images += ",";
            }
            for (int i = 0; i < urlLists.size(); i++) {
                if (StringUtil.isNotNullAndNotEmpty(urlLists.get(i))) {//已经上传过图片，先加入，号分割
                    if (i < urlLists.size() - 1) {
                        images += urlLists.get(i) + ",";
                    } else {
                        images += urlLists.get(i);
                    }
                }
            }
        }
        mStockGoodsDetailsGroup.setInventoryImages(images);
        mStockGoodsDetailsGroup.setStockGoodsCheckDetailsList(mUpdataStockGoodsCheckDetailsList);
        String content = new Gson().toJson(mStockGoodsDetailsGroup);
        showDialog();
        Log.d(TAG, content);
        GoodsManagerService.getInstance().requestUpdateStockGoodsCheck(content, GoodsStockCheckPicturesActivity.this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.GoodsManager.MSG_ON_UPDATE_STOCKGOODS_CHECK: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (!ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                            Toast.makeText(GoodsStockCheckPicturesActivity.this, mBaseResponse.retInfo, Toast.LENGTH_LONG).show();
                            //提交失败，清空图片
                            urlLists.clear();
                            qiniuUrlLists.clear();
                        } else {
                            //提交成功，跳转到门店列表页
                            Intent intent = new Intent(this, GoodsStockCheckShopListActivity.class);
                            intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                            startActivity(intent);
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    /**
     * 弹出延时窗
     */
    private void showPopwindow(String tips) {
        if (null == publicThreeSecondsPop) {
            publicThreeSecondsPop = new PublicThreeSecondsPop(this, this);
            publicThreeSecondsPop.setTips(tips);
        }
        if (!publicThreeSecondsPop.isShowing()) {
            publicThreeSecondsPop.show(this.findViewById(R.id.title));
        }
    }

    @Override
    public void onTimingFinish() {

        this.finish();
    }

    @Override
    public void setSelectDialog(int selectType, View imagePickerView) {
        idImagePickerContainer = (ImagePickerLayout) imagePickerView;
        setSelectDialogListeners(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //拍照处理
                takePhoto(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //相片处理
                getPictrue(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                hideSelectDialog();
            }
        });
        showSelectDialog("选择图片", null, "相机拍照", "本地相册", "取消");
    }

    @Override
    public void toPhotoPreview(int index, ArrayList<ImageItem> mImageselectList) {
        toPhotoPreviewFragment(index, mImageselectList);//大图显示
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, Params.TAKE_PICTURE);
    }
}