package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentTransaction;
import android.text.Editable;
import android.text.TextUtils;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsCheckList;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsCheckListEntity;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsCheckshopListEntity;
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsManagerService;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.wgmf.yxgj.widgets.Dialog.DatePickerYearMonthDialog;
import com.xp.arouter.RouterParams;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.photoview.LocalFloatPhotoPreview;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * 货品管理--存货盘点（第一页）：门店列表
 */
@Route(path = RouterParams.URL_GOODSSTOCKCHECKSHOPLISTACTIVITY)
public class GoodsStockCheckShopListActivity extends SelectorBaseActivity implements View.OnClickListener, GoodsStockCheckShopListAdapter.PhotoPreview {
    private List<StockGoodsCheckList> mTempLists, mStockGoodsCheckLists;
    private GoodsStockCheckShopListAdapter mAdapter;

    private TextView mAudingGoodsTitle, mOnclickTitle;

    /**
     * 用来显示选择月份
     */
    private String mYearMonth;

    @Override
    protected void onResume() {
        super.onResume();
        getShopData(mYearMonth);
    }

    /**
     * 查询指定日期的盘点门店数据
     *
     * @param date 待查询的日期
     */
    private void getShopData(String date) {
        mAudingGoodsTitle.setText("");
        showDialog();
        if (null != userInfo) {
            String url = NetworkParams.URL_FIND_STOCKGOODS_CHECK_STORE;
            String staffId = userInfo.getStaffId();
            String saleOrgId = userInfo.getOrganizationId();
            //将显示"yyyy年M月"日期格式转化为请求接口需要的"yyyyMM"格式
            mYearMonth = date;
            GoodsManagerService.getInstance().requestFindStockGoodsCheckStore(url, staffId, mYearMonth, saleOrgId, GoodsStockCheckShopListActivity.this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("盘点查询");
    }

    @Override
    protected void initContent() {
        EventBus.getDefault().register(this);
        mListView = findViewById(R.id.public_list_view_lv);
        storeNameEt = findViewById(R.id.store_name_et);
        mAudingGoodsTitle = findViewById(R.id.onclick_name);
        mAudingGoodsTitle.setGravity(Gravity.CENTER);
        LinearLayout titleMoreLl = findViewById(R.id.title_more_ll);
        TextView onclickName = findViewById(R.id.report_detail_title);
        mOnclickTitle = findViewById(R.id.report_detail_date);
        LinearLayout onclickTitleLl = findViewById(R.id.onclick_title_ll);

        storeNameEt.setVisibility(View.VISIBLE);
        titleMoreLl.setVisibility(View.VISIBLE);
        onclickName.setVisibility(View.VISIBLE);
        mOnclickTitle.setVisibility(View.VISIBLE);
        mAudingGoodsTitle.setVisibility(View.VISIBLE);
        onclickTitleLl.setVisibility(View.VISIBLE);

        if (null != userInfo) {
            onclickName.setText("" + userInfo.getName() + "|全部门店|");
        }
        mYearMonth = DateUtil.getFormatMonth("yyyyMM", -1);
        String mDate = (mYearMonth.substring(0, 4) + "年" + mYearMonth.substring(4, 6)) + "月";
        //默认条件查上个月的
        mOnclickTitle.setText(mDate);
        titleMoreLl.setOnClickListener(this);

        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);

        mTempLists = new ArrayList<>();
        mStockGoodsCheckLists = new ArrayList<>();
        mAdapter = new GoodsStockCheckShopListAdapter(mStockGoodsCheckLists, this, this);
        mListView.setAdapter(mAdapter);
        mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                //盘点状态
                StockGoodsCheckList stockGoodsCheckList = mStockGoodsCheckLists.get(position);
                Intent intent = new Intent(GoodsStockCheckShopListActivity.this, GoodsStockCheckDetailsActivity.class);
                intent.putExtra("pdId", stockGoodsCheckList.getPdId());
                intent.putExtra("pdBillCode", stockGoodsCheckList.getPdBillCode());
                intent.putExtra("storeName", stockGoodsCheckList.getStoreName());
                intent.putExtra("storeNo", stockGoodsCheckList.getStoreNo());
                intent.putExtra("pdState", stockGoodsCheckList.getPdState());
                intent.putExtra("isOrNotUpdateFlag", stockGoodsCheckList.getIsOrNotUpdateFlag());
                intent.putExtra("isOrNotUpdateDesc", stockGoodsCheckList.getNotUpdateReasonDesc());
                intent.putExtra("inventoryImages", stockGoodsCheckList.getInventoryImages());
                intent.putExtra("checkFlag", stockGoodsCheckList.getCheckFlag());
                intent.putExtra("yearMonth", mYearMonth);
                startActivity(intent);
            }
        });
    }

    @Override
    public void textChanged() {
        Editable editable = storeNameEt.getText();
        if (editable != null) {
            String storeName = editable.toString().trim();
            mStockGoodsCheckLists.clear();
            if (TextUtils.isEmpty(storeName)) {
                mStockGoodsCheckLists.addAll(mTempLists);
            } else {
                if (null != mTempLists) {
                    for (StockGoodsCheckList list : mTempLists) {
                        if (null != list.getStoreName() && list.getStoreName().contains(storeName)) {
                            mStockGoodsCheckLists.add(list);
                        }
                    }
                }
            }
            mAdapter.notifyDataSetChanged();
        }
    }

    @Override
    protected void search() {
        if (null != mStockGoodsCheckLists) {
            mTempLists.clear();
            mTempLists.addAll(mStockGoodsCheckLists);
            mAdapter.notifyDataSetChanged();
        }
    }

    @Subscribe
    public void onEventMainThread(StockGoodsCheckListEntity item) {
        if (item != null && !item.getResultList().isEmpty()) {
            StockGoodsCheckshopListEntity resultData = item.getResultList().get(0);
            //总门店数
            int sumStoreNum = resultData.getSumStoreNum();
            //已经盘点门店数
            int alreadyStoreNum = resultData.getAlreadyStoreNum();
            //未盘点门店数
            int noTStoreNum = resultData.getNoTStoreNum();
            mAudingGoodsTitle.setText("总门店数:" + sumStoreNum + "  " + "已盘点:" + alreadyStoreNum + "  " + "未盘点:" + noTStoreNum + "  ");

            mStockGoodsCheckLists.clear();
            List<StockGoodsCheckList> stockGoodsCheckList = resultData.getStockGoodsCheckList();
            Collections.sort(stockGoodsCheckList, (s1, s2) -> s1.getCheckFlag() - s2.getCheckFlag());
            mStockGoodsCheckLists.addAll(stockGoodsCheckList);
            search();
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.GoodsManager.MSG_ON_FIND_STOCKGOODS_CHECK_STORE) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    StockGoodsCheckListEntity mStockGoodsCheckListEntity = new Gson().fromJson(msg, StockGoodsCheckListEntity.class);
                    Log.d(TAG, "mStockGoodsCheckListEntity=" + mStockGoodsCheckListEntity.toString());
                    if (ConstantParams.CONSTANT_PARAMS_0.equals(mStockGoodsCheckListEntity.retCode)) {
                        if (!mStockGoodsCheckListEntity.getResultList().isEmpty()) {
                            EventBus.getDefault().post(mStockGoodsCheckListEntity);
                        }
                    } else {
                        showMsg(mStockGoodsCheckListEntity.retInfo);
                    }
                } else {
                    showMsg(result.getResultInfo());
                }
            }
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.title_more_ll) {
            //选择日期
            orderDatePickFrom();
        }
    }

    /**
     * 选择日期
     */
    public void orderDatePickFrom() {
        new DatePickerYearMonthDialog(this, new DatePickerYearMonthDialog.OnDateSetListener() {
            @Override
            public void onDateSet(int year, int monthOfYear) {
                //这里月份要发送出去的，格式上要2位数
                mYearMonth = StringUtil.formatString("%04d%02d", year, monthOfYear + 1);
                String mDate = (mYearMonth.substring(0, 4) + "年" + mYearMonth.substring(4, 6)) + "月";
                mOnclickTitle.setText(mDate);
                //当用户选择完年月之后，进行查询操作
                getShopData(mYearMonth);
            }
        }).show();
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }

    private LocalFloatPhotoPreview mLocalFloatPhotoPreview;

    @Override
    public void toPhotoPreviewFragment(final int index, final List<ImageItem> images) {
        if (null == mLocalFloatPhotoPreview) {
            mLocalFloatPhotoPreview = new LocalFloatPhotoPreview();
            mLocalFloatPhotoPreview.setCurIndex(index);
            mLocalFloatPhotoPreview.setAllImages(images);
            final FragmentManager fragmentManager = getSupportFragmentManager();
            final FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.setCustomAnimations(R.anim.qz_comm_scale_in, 0);
            transaction.add(android.R.id.content, mLocalFloatPhotoPreview);
            transaction.commitAllowingStateLoss();
        } else {
            removePhotoPreviewFragment();
        }
    }

    /**
     * 移除大图浮层
     */
    public boolean removePhotoPreviewFragment() {
        if (null != mLocalFloatPhotoPreview) {
            final FragmentManager fragmentManager = getSupportFragmentManager();
            final FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.setCustomAnimations(0, R.anim.qz_comm_scale_out);
            transaction.remove(mLocalFloatPhotoPreview);
            transaction.commitAllowingStateLoss();
            mLocalFloatPhotoPreview = null;
            return true;
        }
        return false;
    }

    @Override
    public void onBackPressed() {
        if (!isFinishing()) {
            if (!removePhotoPreviewFragment()) {
                super.onBackPressed();
            }
        }
    }
}
