package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.Context;
import android.net.Uri;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.library.utils.StringUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsCheckList;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
/**
 * 货品管理--存货盘点（第一页）：门店列表适配器
 */
class GoodsStockCheckShopListAdapter extends BaseAdapter implements ImagePickerLayout.ImagePicker {

    private List<StockGoodsCheckList> list;
    private Context context;
    private PhotoPreview photoPreview;

    interface PhotoPreview {
        void toPhotoPreviewFragment(int index, List<ImageItem> images);
    }

    GoodsStockCheckShopListAdapter(List<StockGoodsCheckList> mlist, Context context, PhotoPreview photoPreview) {
        this.list = mlist;
        this.context = context;
        this.photoPreview = photoPreview;
    }

    @Override
    public void setSelectDialog(int selectType, View view) {

    }

    @Override
    public void toPhotoPreview(int i, ArrayList<ImageItem> arrayList) {
        photoPreview.toPhotoPreviewFragment(i, arrayList);//大图显示
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @SuppressWarnings("all")
    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        View item = null;
        final ViewHolder viewHolder;
        item = LayoutInflater.from(context).inflate(R.layout.stock_goods_shop_item, null);
        viewHolder = new ViewHolder(item);
        final StockGoodsCheckList ent = list.get(position);
        viewHolder.store.setText(ent.getStoreName());

        //CheckFlag标志：1,未盘点;2,待审核;3,生效;4,不可盘点
        //PdState状态：草稿、待审核、生效
        if (ConstantParams.CONSTANT_STARTS_1 == ent.getCheckFlag()) {
            viewHolder.examine.setText("未盘点");
            viewHolder.row.setVisibility(View.INVISIBLE);
            viewHolder.stockgoodsCheckDeitailsLl1.setVisibility(View.GONE);
            viewHolder.stockgoodsCheckDeitailsLl2.setVisibility(View.GONE);
            viewHolder.examine.setTextColor(ContextCompat.getColor(context, R.color.red));
        } else {
            if (ConstantParams.CONSTANT_STARTS_2 == ent.getCheckFlag()) {
                viewHolder.examine.setText("待审核");
                viewHolder.examine.setTextColor(ContextCompat.getColor(context, R.color.normal_color));
            } else if (ConstantParams.CONSTANT_STARTS_3 == ent.getCheckFlag()) {
                viewHolder.examine.setText("生效");
                viewHolder.examine.setTextColor(ContextCompat.getColor(context, R.color.normal_color));
            } else if (ConstantParams.CONSTANT_STARTS_4 == ent.getCheckFlag()) {
                viewHolder.examine.setText("不可盘点");
                viewHolder.examine.setTextColor(ContextCompat.getColor(context, R.color.important_txt_color));
            }
            viewHolder.stockgoodsCheckDeitailsLl1.setVisibility(View.VISIBLE);
            viewHolder.stockgoodsCheckDeitailsLl2.setVisibility(View.VISIBLE);
            viewHolder.row.setVisibility(View.VISIBLE);
            viewHolder.pdAmount.setText("实盘总金额:" + ent.getPdAmount() + "");
            viewHolder.pdNum.setText("实盘总数量:" + ent.getPdNum() + "");
            viewHolder.diffamount.setText("本期盈亏金额:" + ent.getDiffAmount() + "");
            viewHolder.deductmarks.setText("扣分:" + ent.getDeductMarks() + "");
        }
        setImageUrl(viewHolder, ent);
        list.get(position).setOpen(false);
        viewHolder.showImg.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (StringUtil.isNullString(ent.getInventoryImages())) {
                    ToastUtil.show(context, "没有图片可查看哦~");
                    return;
                }
                if (!ent.isOpen()) {
                    viewHolder.idImagePickerContainerImg.setVisibility(View.VISIBLE);
                    viewHolder.showImg.setText("收起盘点图片");
                } else {
                    viewHolder.idImagePickerContainerImg.setVisibility(View.GONE);
                    viewHolder.showImg.setText("查看盘点图片");
                }
                list.get(position).setOpen(!list.get(position).isOpen());
            }
        });
        return item;
    }

    private void setImageUrl(ViewHolder viewHolder, StockGoodsCheckList ent) {
        if (StringUtil.isNotNullAndNotEmpty(ent.getInventoryImages())) {
            //如果图片集合大于0，图片数量大于1张
            ArrayList<ImageItem> mImageselectList = new ArrayList<>();
            if (ent.getInventoryImages().contains(",")) {
                String[] personalidImgs = ent.getInventoryImages().split(",");//中文或英文字符？
                for (String inventoryImages : personalidImgs) {
                    if (StringUtil.isNotNullAndNotEmpty(inventoryImages)) {
                        ImageItem item1 = new ImageItem();
                        item1.setImgneturl(inventoryImages);
                        item1.setImagePath(inventoryImages);
                        item1.setImageId(inventoryImages);
                        item1.setUri(Uri.fromFile(new File(inventoryImages)));
                        item1.setType(1);
                        mImageselectList.add(item1);
                    }
                }
            } else {
                ImageItem item1 = new ImageItem();
                item1.setImgneturl(ent.getInventoryImages());
                item1.setImagePath(ent.getInventoryImages());
                item1.setImageId(ent.getInventoryImages());
                item1.setUri(Uri.fromFile(new File(ent.getInventoryImages())));
                item1.setType(1);
                mImageselectList.add(item1);
            }
            ent.setStoreImageselectList(mImageselectList);
            viewHolder.idImagePickerContainerImg.setOlnyViewMode(true);
            viewHolder.idImagePickerContainerImg.setImagePickerView(viewHolder.idImagePickerContainerImg);
            viewHolder.idImagePickerContainerImg.setmImageselectList(mImageselectList);
            viewHolder.idImagePickerContainerImg.refreshPhotoContentView(mImageselectList);
        } else {
            viewHolder.idImagePickerContainerImg.setVisibility(View.GONE);
        }
    }

    class ViewHolder {
        ImageView row;
        TextView store;
        TextView showImg;
        /**
         * 盘点状态
         */
        TextView examine;
        /**
         * 实盘总金额
         */
        TextView pdAmount;
        /**
         * 实盘总数量
         */
        TextView pdNum;
        /**
         * 本期盈亏金额
         */
        TextView diffamount;
        /**
         * 扣分
         */
        TextView deductmarks;
        LinearLayout stockgoodsCheckDeitailsLl1;
        LinearLayout stockgoodsCheckDeitailsLl2;

        ImagePickerLayout idImagePickerContainerImg;

        ViewHolder(View convertView) {
            store = (TextView) convertView.findViewById(R.id.stockgoods_check_store);
            examine = (TextView) convertView.findViewById(R.id.stockgoods_check_is_examine);
            pdAmount = (TextView) convertView.findViewById(R.id.stockgoods_check_pdbillcode);
            pdNum = (TextView) convertView.findViewById(R.id.stockgoods_check_pdamount);
            diffamount = (TextView) convertView.findViewById(R.id.stockgoods_check_diffamount);
            deductmarks = (TextView) convertView.findViewById(R.id.stockgoods_check_deductmarks);
            row = (ImageView) convertView.findViewById(R.id.stockgoods_check_row);
            showImg = (TextView) convertView.findViewById(R.id.show_img);

            stockgoodsCheckDeitailsLl1 = (LinearLayout) convertView.findViewById(R.id.stockgoods_check_deitails_ll1);
            stockgoodsCheckDeitailsLl2 = (LinearLayout) convertView.findViewById(R.id.stockgoods_check_deitails_ll2);
            idImagePickerContainerImg = (ImagePickerLayout) convertView.findViewById(R.id.id_image_picker_container_img);
            ArrayList<ImageItem> mImageselectList = new ArrayList();
            idImagePickerContainerImg.setmImageselectList(mImageselectList);
            idImagePickerContainerImg.setTitleVisibility(View.GONE);
            idImagePickerContainerImg.setTipVisibility(View.GONE);
            idImagePickerContainerImg.setOlnyViewMode(true);
            idImagePickerContainerImg.setImagePicker(GoodsStockCheckShopListAdapter.this);
            idImagePickerContainerImg.setMaxPhotoNum(9);
            idImagePickerContainerImg.setSizePhotoNum(3);
            idImagePickerContainerImg.setImagePickerView(idImagePickerContainerImg);
        }
    }
}
