package com.wgmf.yxgj.module.business.manageproduct.ui

import android.os.Bundle
import android.support.v4.app.Fragment
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.wgmf.yxgj.module.business.manageproduct.R
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsDetailsGroup
import com.wgmf.yxgj.module.business.manageproduct.ui.GoodsStockCheckDetailsListAdapter.ModifyNumClickListener
import com.wgmf.yxgj.widgets.decoration.SpacesItemDecoration
import org.jetbrains.anko.find

class GoodsStockCheckTabLayoutListFragment : Fragment(), ModifyNumClickListener {
    private var mRvCheckGoodsList: RecyclerView? = null

    private var goodsStockCheckDetailsListAdapter: GoodsStockCheckDetailsListAdapter? = null

    private var stockGoodsDetailsGroups: List<StockGoodsDetailsGroup> = mutableListOf()

    private val yearMonth by lazy { arguments?.get("yearMonth") as String }

    private val editMode by lazy { arguments?.get("editMode") as Int }

    private val flag by lazy { arguments?.get("flag") as Int }

    private var mCallback: OnTestListener? = null

    override fun onActivityCreated(savedInstanceState: Bundle?) {
        super.onActivityCreated(savedInstanceState)
        mCallback = activity as OnTestListener
    }

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        val view: View = inflater.inflate(R.layout.list_stock_goods_tab, null)
        goodsStockCheckDetailsListAdapter = GoodsStockCheckDetailsListAdapter(
            activity,
            stockGoodsDetailsGroups, this, yearMonth
        )

        mRvCheckGoodsList = view.find<RecyclerView>(R.id.rv_check_goods_list).apply {
            layoutManager = LinearLayoutManager(activity)
            adapter = goodsStockCheckDetailsListAdapter
            addItemDecoration(SpacesItemDecoration(20, adapter!!.itemCount, true))
        }
        goodsStockCheckDetailsListAdapter?.setAdapterMode(editMode)
        goodsStockCheckDetailsListAdapter?.setAdapterData(stockGoodsDetailsGroups, flag)
        return view
    }

    override fun onModifyNumClickListener(list: List<StockGoodsDetailsGroup>?) {
        mCallback?.countTotal(list)
    }

    override fun onModifyNumClickListener(error: String?) {
        mCallback?.showError(error)
    }

    fun setAllData(stockGoodsDetailsGroups: List<StockGoodsDetailsGroup>) {
        this.stockGoodsDetailsGroups = stockGoodsDetailsGroups
    }

    fun refreash(editMode: Int) {
        goodsStockCheckDetailsListAdapter?.setAdapterMode(editMode)

        if (goodsStockCheckDetailsListAdapter == null) {
            goodsStockCheckDetailsListAdapter = GoodsStockCheckDetailsListAdapter(
                activity,
                stockGoodsDetailsGroups,
                this, yearMonth
            )
            mRvCheckGoodsList?.apply {
                layoutManager = LinearLayoutManager(activity)
                adapter = goodsStockCheckDetailsListAdapter
                addItemDecoration(SpacesItemDecoration(20, adapter!!.itemCount))
            }
            goodsStockCheckDetailsListAdapter?.setAdapterData(stockGoodsDetailsGroups, flag)
        } else {
            goodsStockCheckDetailsListAdapter?.notifyDataSetChanged()
        }
    }

    interface OnTestListener {
        fun showError(error: String?)
        fun countTotal(list: List<StockGoodsDetailsGroup>?)
    }
}