package com.wgmf.yxgj.module.business.manageproduct.ui

import android.annotation.SuppressLint
import android.content.Intent
import android.os.Bundle
import android.support.v4.content.ContextCompat
import android.util.Log
import android.view.View
import android.widget.Button
import android.widget.LinearLayout
import android.widget.TextView
import com.alibaba.android.arouter.facade.annotation.Route
import com.google.gson.Gson
import com.jakewharton.rxbinding.view.RxView
import com.wgmf.library.base.BaseResponse
import com.wgmf.library.base.ResultData
import com.wgmf.library.utils.DateUtil
import com.wgmf.library.utils.StringUtil
import com.wgmf.library.utils.ThreadManager
import com.wgmf.yxgj.base.BaseActivity
import com.wgmf.yxgj.base.BaseParentAct
import com.wgmf.yxgj.config.BusinessID
import com.wgmf.yxgj.db.GreenDaoManager
import com.wgmf.yxgj.db.OrderGoodsAuditDetailDao
import com.wgmf.yxgj.dialog.LoadWaitDominator
import com.wgmf.yxgj.dialog.PublicConformTipDialog
import com.wgmf.yxgj.dialog.PublicTipDialog
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.model.FixedProductListEntity
import com.wgmf.yxgj.model.OrderGoodsAuditDetail
import com.wgmf.yxgj.module.business.manageproduct.R
import com.wgmf.yxgj.module.business.manageproduct.model.*
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsManagerService
import com.wgmf.yxgj.pop.PublicThreeSecondsPop
import com.wgmf.yxgj.pop.PublicThreeSecondsPop.ThreeSecondsPopListener
import com.wgmf.yxgj.publics.ui.SelectorStoreGetNearestActivity
import com.wgmf.yxgj.utils.MyToast
import com.wgmf.yxgj.utils.helper.DialogHelper
import com.wgmf.yxgj.utils.isNotNullOrSize
import com.wgmf.yxgj.utils.isNullOrEmpty
import com.wgmf.yxgj.utils.notNullAndEmpty
import com.wgmf.yxgj.widgets.LinearLayout.InterceptEventLinearLayout
import com.wgmf.yxgj.widgets.ListView.SlideDeleteListView
import com.xp.arouter.RouterParams
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import xp.timepicker.com.widget.bean.DateType
import java.text.SimpleDateFormat
import java.util.*
import java.util.concurrent.TimeUnit

/**
 * 货品调入调出
 * @author LW
 */
@Route(path = RouterParams.URL_GOODSTRANSFERREDINOROUTACTIVITY)
class GoodsTransferredInOrOutActivity : BaseParentAct(), ThreeSecondsPopListener {

    private val mProductTransferredInAndOutNumLists by lazy {
        intent.getSerializableExtra("productTransferredInAndOutNumLists") as ProductTransferredInAndOutNumLists?
    }

    private val mBranchID by lazy {
        intent.getLongExtra("branchID", 0)
    }

    private val mIsUpdate by lazy {
        intent.getBooleanExtra("isUpdate", false)  //true 编辑修改
    }

    private var mStoreIdOut: String? = null
    private var mStoreIdIn: String? = null
    private var mReason: String? = null

    private var mTransferOutShopNameTv: TextView? = null
    private var mTransferInShopNameTv: TextView? = null
    private var mTransferDistanceTv: TextView? = null

    private var mTransferGoodsTimeTv: TextView? = null
    private var mTransferGoodsReasonTv: TextView? = null
    private var mTransferGoodsReasonInfoTv: TextView? = null

    private var mTransferGoodsTimeLl: LinearLayout? = null
    private var mTransferGoodsReasonLl: LinearLayout? = null

    private var mSlideDeleteListView: SlideDeleteListView? = null
    private var mTransferGoodsSubmitBtn: Button? = null

    private var mOrderGoodsAuditDetailList: MutableList<OrderGoodsAuditDetail> = mutableListOf()
    private var mGoodsTransferredInOrOutAdapter: GoodsTransferredInOrOutAdapter? = null

    private var mOrderGoodsAuditDetailDao: OrderGoodsAuditDetailDao? = null

    private lateinit var mLoadWait: LoadWaitDominator

    companion object {
        /**
         * 调拨原因
         */
        private const val TRANSEFR_CAUSE = 0

        /**
         * 调入门店
         */
        private const val TRANSFER_OUT_SHOP = 1

        /**
         * 调出门店
         */
        private const val TRANSFER_IN_SHOP = 2

    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_transfer_goods)
        initTitle()
        initView()
        initContent()

    }

    private fun initContent() {
        //将需要审核的信息存入数据库
        mOrderGoodsAuditDetailDao =
            GreenDaoManager.getInstance().getDaoSession(this).orderGoodsAuditDetailDao.apply {
                deleteAll() // 删除审核信息表
                if (mIsUpdate) {
                    mProductTransferredInAndOutNumLists?.productTransferredInAndOutNumList?.forEach {
                        val fixedProduct = it.fixedProduct
                        val orderGoodsAuditDetail = OrderGoodsAuditDetail().apply {
                            orderGoodsAuditNum = it.transferredInAndOutNum
                            produceDate = it.produceDate
                            productName = fixedProduct.productName
                            productId = fixedProduct.proId
                            productBigType = fixedProduct.productBigType
                            productBoxNum = fixedProduct.productBoxNum
                            productCode = fixedProduct.productCode
                            productName = fixedProduct.productName
                            productPack = fixedProduct.productPack
                            productPrice = fixedProduct.productPrice
                            productType = fixedProduct.productType
                            productUnit = fixedProduct.productUnit
                            productUnitId = fixedProduct.productUnitId
                        }
                        insertOrReplaceInTx(orderGoodsAuditDetail)
                    }
                }
            }
        mSlideDeleteListView =
            findViewById<SlideDeleteListView>(R.id.transfer_goods_list_lv).apply {
                mGoodsTransferredInOrOutAdapter = GoodsTransferredInOrOutAdapter(
                    mOrderGoodsAuditDetailList,
                    mIsUpdate,
                    this@GoodsTransferredInOrOutActivity
                )
                mGoodsTransferredInOrOutAdapter?.setOnListDataUpdateListener {
                    //列表每次修改数据，直接把数据库中数据替换
                    ThreadManager.runOnThread {
                        if (it != null) {
                            mOrderGoodsAuditDetailDao?.insertOrReplaceInTx(it)
                        }
                    }
                }

                adapter = mGoodsTransferredInOrOutAdapter
                if (!mIsUpdate) {
                    setOnRemovedListener { position ->
                        try {
                            if (mOrderGoodsAuditDetailList[position].type == 0) {
                                showMsg("不能删除该条数据！")
                            } else {
                                mOrderGoodsAuditDetailDao?.deleteByKey(mOrderGoodsAuditDetailList[position].productId)
                            }
                        } catch (e: Exception) {
                            Log.e(TAG, "数据库出错")
                        }
                        mOrderGoodsAuditDetailList =
                            mOrderGoodsAuditDetailDao?.loadAll() ?: mutableListOf()
                        mGoodsTransferredInOrOutAdapter?.setNewData(mOrderGoodsAuditDetailList)
                    }
                }
            }

        //5秒钟之内只取一个点击事件，防抖操作
        RxView.clicks(findViewById<Button>(R.id.transfer_goods_submit_btn))
            .throttleFirst(2, TimeUnit.SECONDS).subscribe {
                if (mStoreIdOut.isNullOrEmpty()) {
                    showMsg("请选择调出门店")
                } else if (mStoreIdIn.isNullOrEmpty()) {
                    showMsg("请先选择调入门店")
                } else if (mStoreIdIn == mStoreIdOut) {
                    showMsg("调入调出门店不能相同")
                } else if (checkDate(mTransferGoodsTimeTv?.text.toString()) == 1) {
                    showMsg("日期选择有误，请重新选择")
                } else if (mReason.isNullOrEmpty()) {
                    showMsg("请选择调拨原因")
                } else {
                    submitGoodsData() //提交数据
                    mTransferGoodsSubmitBtn?.text = "正在提交"
                    mTransferGoodsSubmitBtn?.setBackgroundColor(
                        ContextCompat.getColor(
                            this@GoodsTransferredInOrOutActivity,
                            R.color.common_txt_color
                        )
                    )
                }
            }
        if (mIsUpdate) {
            refreshDataToView()
        }
    }

    override fun initTitle() {
        super.initTitle()
        homeTitleText.text = intent.getStringExtra("branchTitle")
        homeTitleBackLl.visibility = View.VISIBLE
    }

    private fun initView() {
        EventBus.getDefault().register(this)

        mLoadWait = LoadWaitDominator(mContext, findViewById(R.id.transfer_goods_container_fl))
        findViewById<InterceptEventLinearLayout>(R.id.transfer_goods_header_container_ll).apply {
            setIsInterceptEvent(mIsUpdate)
        }

        mTransferOutShopNameTv = findViewById(R.id.transfer_out_shop_name_tv)
        mTransferInShopNameTv = findViewById(R.id.transfer_in_shop_name_tv)
        mTransferDistanceTv = findViewById(R.id.transfer_distance_tv)
        mTransferGoodsTimeTv = findViewById(R.id.transfer_goods_time_tv)
        mTransferGoodsReasonTv = findViewById(R.id.transfer_goods_reason_tv)

        mTransferGoodsTimeLl = findViewById(R.id.transfer_goods_time_ll)
        mTransferGoodsReasonLl = findViewById(R.id.transfer_goods_reason_ll)

        if (mIsUpdate) {
            mProductTransferredInAndOutNumLists?.let {
                //调出门店
                mStoreIdOut = it.transferredOutStoreId
                mTransferOutShopNameTv?.text = it.transferredOutStoreName
                //调入门店
                mStoreIdIn = it.transferredInStoreId
                mTransferInShopNameTv?.text = it.transferredInStoreName
                //距离
                if (it.distance.notNullAndEmpty()) {
                    mTransferDistanceTv?.visibility = View.VISIBLE
                    mTransferDistanceTv?.text = StringUtil.formatString(
                        mContext.getString(R.string.transfer_goods_store_distance),
                        it.distance
                    )
                } else {
                    mTransferDistanceTv?.visibility = View.GONE
                }
                //调拨时间
                if (it.transferredInAndOutDate.notNullAndEmpty()) {
                    mTransferGoodsTimeLl?.visibility = View.VISIBLE
                    mTransferGoodsTimeTv?.text = it.transferredInAndOutDate
                }
                //调拨原因
                if (it.dbReason.notNullAndEmpty()) {
                    mTransferGoodsReasonLl?.visibility = View.VISIBLE
                    mTransferGoodsReasonTv?.text = it.dbReason
                    mReason = it.dbReason
                }
            }
        } else {
            findViewById<LinearLayout>(R.id.transfer_out_shop_name_ll).apply {
                //调出门店
                setOnClickListener {
                    startActivityForResult(Intent().apply {
                        //调出门店
                        setClass(
                            this@GoodsTransferredInOrOutActivity,
                            SelectorStoreGetNearestActivity::class.java
                        )
                        putExtra("branchTitle", "选择门店")
                        putExtra("branchID", mBranchID)
                    }, TRANSFER_OUT_SHOP)
                }
            }
            findViewById<LinearLayout>(R.id.transfer_in_shop_name_ll).apply {
                //调入门店
                setOnClickListener {
                    startActivityForResult(Intent().apply {
                        setClass(
                            this@GoodsTransferredInOrOutActivity,
                            SelectorStoreGetNearestActivity::class.java
                        )
                        putExtra("branchTitle", "选择门店")
                        putExtra("branchID", mBranchID)
                    }, TRANSFER_IN_SHOP)
                }
            }


            findViewById<TextView>(R.id.transfer_goods_products_tv).apply {
                setOnClickListener {
                    //选择产品
                    if (mStoreIdOut.isNullOrEmpty()) {
                        showMsg("请先选择调出门店")
                    } else if (mStoreIdIn.isNullOrEmpty()) {
                        showMsg("请先选择调入门店")
                    } else {
                        startActivity(Intent().apply {
                            setClass(
                                this@GoodsTransferredInOrOutActivity,
                                GoodsAuditingAddProductsActivity::class.java
                            )
                            putExtra("orderGoodsAuditId", 1)
                            putExtra("outStoreNo", mStoreIdOut)
                            putExtra("inStoreNo", mStoreIdIn)
                            putExtra("type", GoodsAuditingAddProductsActivity.FIXED_ASSETS)
                        })
                    }
                }
            }

            mTransferGoodsTimeTv?.text = DateUtil.getDate(Date())
            mTransferGoodsTimeLl?.apply {
                visibility = View.VISIBLE
                setOnClickListener {
                    val dialog = DialogHelper.showDatePickDialog(
                        this@GoodsTransferredInOrOutActivity, DateType.TYPE_YMD
                    )
                    dialog.setStartDate(DateUtil.getCurrentFirstDayDate())
                    dialog.setEndDate(Date())
                    dialog.setOnSureLisener { date ->
                        val selectStatus = DateUtil.selectCurrentMonth(date)
                        if (selectStatus) {
                            var messge: String? = ""
                            try {
                                messge = DateUtil.format(date, DateType.TYPE_YMD.format)
                                mTransferGoodsTimeTv?.text = messge
                            } catch (e: Exception) {
                                e.printStackTrace()
                            }
                        } else {
                            MyToast.show(getString(R.string.transfer_goods_select_time_tip))
                            //showInfoTipDialog()
                        }
                    }
                    dialog.show()
                }
            }

            mTransferGoodsReasonLl?.apply {
                visibility = View.VISIBLE
                setOnClickListener {
                    //选择调拨原因
                    startActivityForResult(Intent().apply {
                        //调出门店
                        setClass(
                            this@GoodsTransferredInOrOutActivity,
                            GoodsTransferredReasonActivity::class.java
                        )
                    }, TRANSEFR_CAUSE)
                }
            }
        }
        mTransferGoodsReasonInfoTv = findViewById(R.id.transfer_goods_reason_info_tv)

        mTransferGoodsSubmitBtn = findViewById(R.id.transfer_goods_submit_btn)
    }

    /**
     * 图片提示框
     */
    private fun showInfoTipDialog() {
        PublicTipDialog.Builder(this).apply {
            setTitle(R.string.tip)
            setMessage(R.string.transfer_goods_select_time_tip)
            setNegativeButton(
                R.string.confirm_btn_txt
            ) { dialog, which -> dialog.dismiss() }

        }.create().show()
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        data?.let {
            when (requestCode) {
                TRANSFER_OUT_SHOP -> {
                    try {
                        mStoreIdOut = it.getStringExtra("shopId")
                        val shopNameOut = it.getStringExtra("shopName")
                        mTransferOutShopNameTv?.text = shopNameOut
                        //删除所有选择产品
                        mOrderGoodsAuditDetailDao?.deleteAll()
                    } catch (e: Exception) {
                        Log.e(TAG, "onActivityResult: data.getStringExtra error ")
                    }

                    queryStoreDistance()
                    refreshDataToView()
                }
                TRANSFER_IN_SHOP -> {
                    try {
                        mStoreIdIn = it.getStringExtra("shopId")
                        val shopNameIn = it.getStringExtra("shopName")
                        mTransferInShopNameTv?.text = shopNameIn
                        //删除所有选择产品
                        mOrderGoodsAuditDetailDao?.deleteAll()

                    } catch (e: Exception) {
                        Log.e(TAG, "onActivityResult: data.getStringExtra error ")
                    }
                    queryStoreDistance()
                    refreshDataToView()
                }
                TRANSEFR_CAUSE -> {
                    mReason = it.getStringExtra(AppConstants.ExtraKeys.TRANSFER_REASON)
                    mTransferGoodsReasonTv?.text = mReason
                    val reasonReplenish =
                        it.getStringExtra(AppConstants.ExtraKeys.TRANSFER_REASON_REPLENISH)
                    if (reasonReplenish.notNullAndEmpty()) {
                        mReason = reasonReplenish
                        mTransferGoodsReasonInfoTv?.visibility = View.VISIBLE
                        mTransferGoodsReasonInfoTv?.text = reasonReplenish
                    } else {
                        mTransferGoodsReasonInfoTv?.visibility = View.GONE
                    }
                }
                else -> {
                }
            }
        }
    }

    /**
     * 继续添加订货后返回的明细实体
     *
     * @param item 产品明细
     */
    @Subscribe
    fun onEventMainThread(item: List<ProductAndSuggestOrderGoodsList>?) {
        refreshDataToView()
    }

    private fun refreshDataToView() {
        mOrderGoodsAuditDetailList =
            mOrderGoodsAuditDetailDao?.loadAll() ?: mutableListOf()
        mGoodsTransferredInOrOutAdapter?.setNewData(mOrderGoodsAuditDetailList)
        if (mOrderGoodsAuditDetailList.isNotNullOrSize()) {
            if (mOrderGoodsAuditDetailList.isNotNullOrSize()) {
                mTransferGoodsSubmitBtn?.visibility = View.VISIBLE
            } else {
                mTransferGoodsSubmitBtn?.visibility = View.GONE
            }
            mLoadWait.dismissAll()
        } else {
            mLoadWait.show(LoadWaitDominator.NO_DATA)
        }
    }

    /**
     * 获取两个门店距离
     */
    private fun queryStoreDistance() {
        if (mStoreIdOut.notNullAndEmpty() && mStoreIdOut.notNullAndEmpty()) {
            showDialog()
            GoodsManagerService.getInstance()
                .requestQueryDistance(
                    mStoreIdIn,
                    mStoreIdOut,
                    this@GoodsTransferredInOrOutActivity
                )
        }
    }

    /**
     * 上传订货审核数据
     */
    private fun submitGoodsData() {
        showDialog()
        setDialogCancel(false, false)

        val productTransferredInAndOutNumListEntity =
            mutableListOf<ProductTransferredInAndOutNumListEntity>()
        val storeAllotUpdateEntity = mutableListOf<StoreAllotUpdateEntity>()

        val productStr = StringBuilder()
        mOrderGoodsAuditDetailList.forEach {
            if (mIsUpdate) {
                //updateType(1取回状态修改调拨数量 2修改收货数量)
                storeAllotUpdateEntity.add(
                    StoreAllotUpdateEntity(
                        mProductTransferredInAndOutNumLists?.dbBillCode,
                        mProductTransferredInAndOutNumLists?.dbId,
                        it.productCode,
                        it.orderGoodsAuditNum,
                        userInfo.staffId,
                        ConstantParams.CONSTANT_STARTS_1,
                        it.produceDate
                    )
                ).apply {
                    if (it.productCode.startsWith("2")) {
                        if (it.produceDate.isNullOrEmpty()) {
                            productStr.append(it.productName).append("、")
                        }
                    }
                }
            } else {
                productTransferredInAndOutNumListEntity.add(
                    ProductTransferredInAndOutNumListEntity().apply {
                        transferredInAndOutNum = it.orderGoodsAuditNum

                        if (it.productCode.startsWith("2")) {
                            if (it.produceDate.notNullAndEmpty()) {
                                produceDate = it.produceDate
                            } else {
                                productStr.append(it.productName).append("、")
                            }
                        }

                        val fixedProductListEntity = FixedProductListEntity().apply {
                            //产品ID
                            proId = it.productId
                            //产品大类
                            productBigType = it.productBigType
                            //产品箱装数量
                            productBoxNum = it.productBoxNum
                            //产品编码
                            productCode = it.productCode
                            //产品名称
                            productName = it.productName
                            //产品规格
                            productPack = it.productPack
                            //产品价格
                            productPrice = it.productPrice
                            //产品类别
                            productType = it.productType
                            //产品单位
                            productUnit = it.productUnit
                            //产品单位id
                            productUnitId = it.productUnitId
                        }
                        fixedProduct = fixedProductListEntity
                    }
                )
            }
        }

        if (productStr.toString().notNullAndEmpty()) {
            dismissDialog()
            val tip =
                StringUtil.formatString(
                    getString(R.string.transfer_goods_production_date_empty_tip),
                    productStr.toString()
                )
            showConformTipDialog(tip)
            return
        }

        if (mIsUpdate) {
            val content = Gson().toJson(storeAllotUpdateEntity)
            Log.d(TAG, content)
            GoodsManagerService.getInstance()
                .requestUpdateStoreAllot(content, this@GoodsTransferredInOrOutActivity)
        } else {
            val productTransferredInAndOutNumList = ProductTransferredInAndOutNumLists().apply {
                transferredInOrOutDate = mTransferGoodsTimeTv?.text.toString()
                userInfo = BaseParentAct.userInfo
                transferredReason = mReason
                transferredInStoreId = mStoreIdIn
                transferredOutStoreId = mStoreIdOut
                productTransferredInAndOutNumList = productTransferredInAndOutNumListEntity
            }

            val content = Gson().toJson(productTransferredInAndOutNumList)
            Log.d(TAG, content)
            GoodsManagerService.getInstance()
                .requestSaveTransferredInOrOut(content, this@GoodsTransferredInOrOutActivity)
        }
    }

    /**
     * 确认提示框
     */
    private fun showConformTipDialog(message: String) {
        val dialog = PublicConformTipDialog.Builder(this).apply {
            setLayoutId(R.layout.view_textview_dialog2)
            setTitle(R.string.transfer_goods_submit_failed)
            setMessage(message)
            setNegativeButton(R.string.confirm_btn_txt) { dialog, which ->
                mTransferGoodsSubmitBtn?.setText(R.string.submit_btn_txt)
                mTransferGoodsSubmitBtn?.setBackgroundColor(
                    ContextCompat.getColor(
                        this@GoodsTransferredInOrOutActivity,
                        R.color.normal_color
                    )
                )
                dialog.dismiss()
            }

        }.create()
        dialog.setCanceledOnTouchOutside(false)
        dialog.show()

    }

    @SuppressLint("SimpleDateFormat")
    private fun checkDate(date: String): Int {
        if (!mIsUpdate) {
            val newDate = Date()
            val formatter = SimpleDateFormat("yyyy-MM-dd")
            return try {
                val date0 = DateUtil.getFirstDayOfMonth(DateUtil.string2Date(date, "yyyy-MM"))
                // 选中的日期
                val date1 = formatter.parse(formatter.format(date0))
                // 今天
                val date2 = formatter.parse(formatter.format(newDate))
                // 下月1日
                val date3 = formatter.parse(
                    formatter.format(
                        DateUtil.getDayOfMonth(
                            DateUtil.string2Date(
                                date,
                                "yyyy-MM"
                            ), 1, 1
                        )
                    )
                )
                //本月和下月1号之前可修改，其余时间不可修改
                if (DateUtil.getMonthForDate(date1) == DateUtil.getMonthForDate(date2) || DateUtil.daysBetween(
                        date2,
                        date3
                    ) <= 1 && DateUtil.daysBetween(date2, date3) >= 0
                ) {
                    //可修改
                    0
                } else {
                    //不修改
                    1
                }
            } catch (e: Exception) {
                //可修改
                0
            }
        } else {
            return 0
        }
    }

    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)
        dismissDialog()
        result?.let {
            if (it.taskID == BusinessID.GoodsManager.MSG_ON_SAVE_TRANSFERRED_INOROUT
                || it.taskID == BusinessID.GoodsManager.MSG_ON_UPDATE_STORE_ALLOT
            ) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, BaseResponse::class.java)
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode ||
                        ConstantParams.CONSTANT_PARAMS_0 == entity.msgCode
                    ) {
                        //弹出提示进度条,等待OE返回
                        showPublicThreeSecondsPop()
                    } else {
                        showMsg(entity.retInfo)
                    }
                } else {
                    showMsg(getString(R.string.request_data_fail))
                }
                mTransferGoodsSubmitBtn?.setText(R.string.submit_btn_txt)
                mTransferGoodsSubmitBtn?.setBackgroundColor(
                    ContextCompat.getColor(
                        this@GoodsTransferredInOrOutActivity,
                        R.color.normal_color
                    )
                )
            } else if (it.taskID == BusinessID.GoodsManager.MSG_ON_QUERY_DISTANCE) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, TransferredDistanceEntity::class.java)
                    Log.d(TAG, "TransferredDistanceEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.msgCode) {
                        if (entity.result.notNullAndEmpty()) {
                            mTransferDistanceTv?.visibility = View.VISIBLE
                            mTransferDistanceTv?.text = StringUtil.formatString(
                                mContext.getString(R.string.transfer_goods_store_distance),
                                entity.result
                            )
                        } else {
                            mTransferDistanceTv?.visibility = View.GONE
                        }
                    } else {
                        showMsg(entity.retInfo)
                    }
                } else {
                    showMsg(getString(R.string.request_data_fail))
                }
            } else {

            }
        }
    }

    /**
     * 弹出延时窗
     */
    private fun showPublicThreeSecondsPop() {
        val publicThreeSecondsPop = PublicThreeSecondsPop(mContext, this)
        if (!publicThreeSecondsPop.isShowing) {
            publicThreeSecondsPop.show(findViewById(R.id.title))
        }
    }

    override fun onTimingFinish() {
        this@GoodsTransferredInOrOutActivity.finish()
    }

    override fun onDestroy() {
        super.onDestroy()
        EventBus.getDefault().unregister(this)
    }
}