package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.View;
import android.widget.ExpandableListView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.PublicTipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.manageproduct.model.ProductTransferredInAndOutNumLists;
import com.wgmf.yxgj.module.business.manageproduct.model.ProductTransferredInAndOutNumResultList;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsManagerService;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;
import com.xp.arouter.RouterCommonUtil;
import com.xp.arouter.RouterParams;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.util.ArrayList;
import java.util.List;

/**
 * 调入调出明细
 */
public class GoodsTransferredInOrOutDetailsActivity extends BaseParentAct {

    private List<ProductTransferredInAndOutNumLists> list;
    private GoodsTransferredInOrOutDetailsAdapter mGoodsTransferredInOrOutDetailsAdapter;
    private ExpandableListView publicListViewElv;
    private String storeNo;
    private String startDate;
    private String endDate;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.public_list_view);
        initTitle();
        initContent();
        findTransferredInAndOutDetail();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        String branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void onResume() {
        super.onResume();
        findTransferredInAndOutDetail();
    }

    private void initContent() {
        EventBus.getDefault().register(this);
        String storeName = getIntent().getStringExtra("storeName");
        storeNo = getIntent().getStringExtra("storeNo");
        startDate = getIntent().getStringExtra("startDate");
        endDate = getIntent().getStringExtra("endDate");
        list = new ArrayList<>();
        ListView mListView = (ListView) findViewById(R.id.public_list_view_lv);
        mListView.setVisibility(View.GONE);
        publicListViewElv = (ExpandableListView) findViewById(R.id.public_list_view_elv);
        publicListViewElv.setVisibility(View.VISIBLE);
        View dataEmpty = findViewById(R.id.public_list_view_empty_ll);
        publicListViewElv.setEmptyView(dataEmpty);
        ClearEditText storeNameEt = (ClearEditText) findViewById(R.id.store_name_et);
        storeNameEt.setVisibility(View.GONE);
        LinearLayout onclickTitleLl = (LinearLayout) findViewById(R.id.public_top_content_ll);
        TextView onclickName = (TextView) findViewById(R.id.store_name_tv);
        TextView onclickTitle = (TextView) findViewById(R.id.store_rank_tv);
        onclickName.setText(storeName);
        String text = startDate + "至" + endDate;
        onclickTitle.setText(text);
        onclickTitleLl.setVisibility(View.VISIBLE);
        onclickName.setTextColor(ContextCompat.getColor(this, R.color.white));
        onclickTitle.setTextColor(ContextCompat.getColor(this, R.color.white));
        onclickTitleLl.setBackgroundResource(R.color.normal_color);

        mGoodsTransferredInOrOutDetailsAdapter = new GoodsTransferredInOrOutDetailsAdapter(mContext, list);
        mGoodsTransferredInOrOutDetailsAdapter.setOnStatusClickListener(new GoodsTransferredInOrOutDetailsAdapter.OnStatusClickListener() {

            public void onStatusClick(int type, ProductTransferredInAndOutNumLists groupEntity) {
                if (type == ConstantParams.CONSTANT_STARTS_3) {  //3取回，
                    confirmStoreAllot(type, groupEntity);
                } else if (type == ConstantParams.CONSTANT_STARTS_4) { //4作废
                    showVoidTipDialog(type, groupEntity);
                } else if (type == ConstantParams.CONSTANT_STARTS_5) {  //5编辑
                    jumpGoodsTransferredInOrOutActivity(groupEntity);
                }
            }
        });

        publicListViewElv.setAdapter(mGoodsTransferredInOrOutDetailsAdapter);
    }

    /**
     * 跳转到GoodsTransferredInOrOutActivity
     */
    private void jumpGoodsTransferredInOrOutActivity(ProductTransferredInAndOutNumLists groupEntity) {
        Bundle bundle = new Bundle();
        bundle.putString("branchTitle", "产品调入调出");
        bundle.putLong("branchID", 548L);
        bundle.putBoolean("isUpdate", true);
        bundle.putSerializable("productTransferredInAndOutNumLists", groupEntity);
        RouterCommonUtil.startFunctionActivity(mContext, RouterParams.URL_GOODSTRANSFERREDINOROUTACTIVITY, bundle);
    }

    /**
     * 作废提示框
     */
    private void showVoidTipDialog(final int type, final ProductTransferredInAndOutNumLists entity) {
        final PublicTipDialog.Builder builder = new PublicTipDialog.Builder(this);
        builder.setTitle(R.string.transfer_goods_dialog_void_tip);
        builder.setMessage(R.string.transfer_goods_dialog_void_content);
        builder.setNegativeButton(R.string.confirm_btn_txt, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
                confirmStoreAllot(type, entity);

            }
        });
        builder.setPositiveButton(R.string.cancel_btn_txt,new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();

            }
        });
        builder.create().show();
    }

    /**
     * 调入调出查询明细
     */
    private void findTransferredInAndOutDetail() {
        showDialog();
        GoodsManagerService.getInstance().requestFindTransferredInAndOutDetail(storeNo, startDate,
                endDate, GoodsTransferredInOrOutDetailsActivity.this);
    }

    /**
     * 确认收货
     */
    private void confirmStoreAllot(int type, ProductTransferredInAndOutNumLists entity) {
        if (userInfo != null) {
            showDialog();
            GoodsManagerService.getInstance().requestConfirmStoreAllot(entity.getDbBillCode(), entity.getDbId(), userInfo.getStaffId()
                    , type, GoodsTransferredInOrOutDetailsActivity.this);
        }
    }

    /**
     * @param item ProductTransferredInAndOutNumResultList
     */
    @Subscribe
    public void onEventMainThread(ProductTransferredInAndOutNumResultList item) {
        if (item != null && !item.getResultList().isEmpty()) {
            list = item.getResultList();
            mGoodsTransferredInOrOutDetailsAdapter.setNewList(list);
            for (int i = 0; i < list.size(); i++) {
                publicListViewElv.expandGroup(i);
            }
            //2、不能点击收缩：
            publicListViewElv.setOnGroupClickListener(new ExpandableListView.OnGroupClickListener() {

                @Override
                public boolean onGroupClick(ExpandableListView parent, View v,
                                            int groupPosition, long id) {
                    return true;
                }
            });
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.GoodsManager.MSG_ON_FIND_TRANSFERRED_INANDOUT_DETAIL: {
                    final String msg = result.getInfo();
                    if (!isFinishing() && result.isSuccessed()) {
                        ProductTransferredInAndOutNumResultList mProductTransferredInAndOutNumResultList =
                                new Gson().fromJson(msg, ProductTransferredInAndOutNumResultList.class);
                        Log.d(TAG, "mProductTransferredInAndOutNumResultList=" + mProductTransferredInAndOutNumResultList.toString());
                        if (!mProductTransferredInAndOutNumResultList.getResultList().isEmpty()) {
                            EventBus.getDefault().post(mProductTransferredInAndOutNumResultList);
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    }
                    break;
                }
                case BusinessID.GoodsManager.MSG_ON_CONFIRM_STORE_ALLOT: {
                    if (!isFinishing() && result.isSuccessed()) {
                        BaseResponse entity = new Gson().fromJson(result.getInfo(), BaseResponse.class);
                        Log.d(TAG, "BaseResponse=$entity");
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(entity.msgCode)) {
                            findTransferredInAndOutDetail();
                        } else {
                            showMsg(entity.retInfo);
                        }
                    } else {
                        showMsg(getString(R.string.request_data_fail));
                    }
                    break;
                }
                default:
                    break;
            }
        }

    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }
}