package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.ProductTransferredInAndOutShopEntity;

import java.util.Collections;
import java.util.Comparator;
import java.util.List;

class GoodsTransferredInOrOutShopLisAdapter extends BaseAdapter {
    /**
     * 0,有调入调出;1,无调入调出
     */
    private static final int STATUS_YES = 0;
    private static final int STATUS_NO = 1;

    private List<ProductTransferredInAndOutShopEntity> list;
    private Context context;

    GoodsTransferredInOrOutShopLisAdapter(List<ProductTransferredInAndOutShopEntity> mlist, Context context) {
        this.list = mlist;
        this.context = context;
        /*0,有调入调出;1,无调入调出*/
        Collections.sort(mlist, new Comparator<ProductTransferredInAndOutShopEntity>() {

            @Override
            public int compare(ProductTransferredInAndOutShopEntity lhs, ProductTransferredInAndOutShopEntity rhs) {
                if (lhs.getTransferredInOutFlag() > rhs.getTransferredInOutFlag()) {
                    return 1;
                } else if (lhs.getTransferredInOutFlag().equals(rhs.getTransferredInOutFlag())) {
                    return 0;
                } else {
                    return -1;
                }
            }
        });
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {
        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.stockgoods_shop_item, null);
            viewHolder = new ViewHolder();
            viewHolder.store = (TextView) convertView.findViewById(R.id.stockgoods_check_store);
            viewHolder.examine = (TextView) convertView.findViewById(R.id.stockgoods_check_is_examine);
            viewHolder.pdAmount = (TextView) convertView.findViewById(R.id.stockgoods_check_pdbillcode);
            viewHolder.pdNum = (TextView) convertView.findViewById(R.id.stockgoods_check_pdamount);
            viewHolder.diffamount = (TextView) convertView.findViewById(R.id.stockgoods_check_diffamount);
            viewHolder.deductmarks = (TextView) convertView.findViewById(R.id.stockgoods_check_deductmarks);
            viewHolder.row = (ImageView) convertView.findViewById(R.id.stockgoods_check_row);

            viewHolder.stockgoodsCheckDeitailsLl1 = (LinearLayout) convertView.findViewById(R.id.stockgoods_check_deitails_ll1);
            viewHolder.stockgoodsCheckDeitailsLl2 = (LinearLayout) convertView.findViewById(R.id.stockgoods_check_deitails_ll2);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        ProductTransferredInAndOutShopEntity ent = list.get(position);
        viewHolder.store.setText(ent.getShop().getShopName());

        if (STATUS_NO == ent.getTransferredInOutFlag()) {
            viewHolder.examine.setText("无调入调出");
            viewHolder.row.setVisibility(View.INVISIBLE);
            viewHolder.stockgoodsCheckDeitailsLl1.setVisibility(View.GONE);
            viewHolder.stockgoodsCheckDeitailsLl2.setVisibility(View.GONE);
            viewHolder.examine.setTextColor(convertView.getResources().getColor(R.color.common_txt_color));
        } else {
            if (STATUS_YES == ent.getTransferredInOutFlag()) {
                viewHolder.examine.setText("查看明细");
                viewHolder.examine.setTextColor(convertView.getResources().getColor(R.color.assist_green_txt));
            }
            viewHolder.stockgoodsCheckDeitailsLl1.setVisibility(View.VISIBLE);
            viewHolder.stockgoodsCheckDeitailsLl2.setVisibility(View.VISIBLE);
            viewHolder.row.setVisibility(View.VISIBLE);
            viewHolder.pdAmount.setText("调入数量:" + ent.getTransferredInNum() + "");
            viewHolder.pdNum.setText("调出数量:" + ent.getTransferredOutNum() + "");
            viewHolder.diffamount.setText("调入金额:" + ent.getTransferredInAmount() + "");
            viewHolder.deductmarks.setText("调出金额:" + ent.getTransferredOutAmount() + "");
        }
        return convertView;
    }

    class ViewHolder {
        ImageView row;
        TextView store;
        TextView examine;
        TextView pdAmount;
        TextView pdNum;
        TextView diffamount;
        TextView deductmarks;
        LinearLayout stockgoodsCheckDeitailsLl1;
        LinearLayout stockgoodsCheckDeitailsLl2;
    }
}
