package com.wgmf.yxgj.module.business.manageproduct.ui

import android.content.Intent
import android.os.Bundle
import android.view.View
import android.widget.TextView
import com.wgmf.yxgj.base.BaseParentAct
import com.wgmf.yxgj.dialog.PublicEditDialog
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.module.business.manageproduct.R
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity
import com.wgmf.yxgj.utils.notNullAndEmpty

/**
 * 商品调拨原因
 */
class GoodsTransferredReasonActivity : BaseParentAct() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_transfer_goods_reason)
        initTitle()
        initView()
    }

    private fun initView() {
        findViewById<TextView>(R.id.transfer_goods_underorder_tv).apply {
            setOnClickListener {
                val reason = text.toString()
                returnSelectReasonData(reason)
            }
        }

        findViewById<TextView>(R.id.transfer_goods_new_store_not_opened_tv).apply {
            setOnClickListener {
                val reason = text.toString()
                returnSelectReasonData(reason)
            }
        }

        findViewById<TextView>(R.id.transfer_goods_empty_posts_tv).apply {
            setOnClickListener {
                val reason = text.toString()
                returnSelectReasonData(reason)
            }
        }

        findViewById<TextView>(R.id.transfer_goods_extended_closure_tv).apply {
            setOnClickListener {
                val reason = text.toString()
                returnSelectReasonData(reason)
            }
        }

        findViewById<TextView>(R.id.transfer_goods_product_advent_tv).apply {
            setOnClickListener {
                val reason = text.toString()
                returnSelectReasonData(reason)
            }
        }

        val transferGoodsInfoTv = findViewById<TextView>(R.id.transfer_goods_info_tv)
        transferGoodsInfoTv.setOnClickListener {
            val reason = transferGoodsInfoTv.text.toString()
            showProEdtDialog(reason)
        }
    }

    /**
     * 输入调拨原因
     */
    private fun showProEdtDialog(reason: String) {
        val builder = PublicEditDialog.Builder(mContext)
        builder.apply {
            setTitle(getString(R.string.transfer_goods_cause_title))
            setPositiveButton { dialog, _ -> dialog.dismiss() }
            setNegativeButton { dialog, _ ->
                val replenishReason = builder.editContent
                if (replenishReason.notNullAndEmpty()) {
                    returnSelectReasonData(reason, replenishReason)
                } else {
                    showMsg(getString(R.string.transfer_goods_input_reason_tip))
                }
                dialog.dismiss()
            }
        }.create().show()

    }

    private fun returnSelectReasonData(reason: String, replenishReason: String = "") {
        val intent = Intent().apply {
            putExtra(AppConstants.ExtraKeys.TRANSFER_REASON, reason)
            putExtra(AppConstants.ExtraKeys.TRANSFER_REASON_REPLENISH, replenishReason)
        }
        setResult(SelectorBaseActivity.RESULTCODE, intent)
        this@GoodsTransferredReasonActivity.finish()
    }

    override fun initTitle() {
        super.initTitle()
        homeTitleText.text = mContext.getString(R.string.transfer_goods_cause_title)
        homeTitleBackLl.visibility = View.VISIBLE
    }
}