package com.wgmf.yxgj.module.business.managesales.service;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;

import com.wgmf.library.utils.CastingNumbers;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.module.business.managesales.model.EqualTypeSaleForecastProductList;
import com.wgmf.yxgj.module.business.managesales.model.SaleForecast;
import com.wgmf.yxgj.module.business.managesales.model.SaleForecastGroupEntity;
import com.wgmf.yxgj.module.business.managesales.model.SaleForecastGroupResultlist;
import com.wgmf.yxgj.module.business.managesales.ui.SaleForecastProductsFragment;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 作者：xiep on 2017/3/28 09:04
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")
public class SaleForecastManager {
    /**
     * 预测填写状态，1为已填写，0为未填写
     */
    public static String forecastFlag;
    /**
     * 销售预测显示月份 M
     */
    public static int currentMonth;
    /**
     * 销售预测总金额
     */
    private static double forecastAmount;

    /**
     * 填充到ViewPager中的Fragment
     */
    private static List<Fragment> mFragments = new ArrayList<>();
    /**
     * 网络请求回的数据
     */
    private static SaleForecastGroupEntity saleForecastGroupEntity = new SaleForecastGroupEntity();
    private static List<SaleForecastGroupResultlist> saleForecastGroupResultlists = new ArrayList<>();
    private static List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList = new ArrayList<>();
    private static SaleForecast saleForecast = new SaleForecast();

    /**
     * 清除数据
     */
    private static void clearData() {
        forecastAmount = 0;
        mFragments.clear();
        saleForecast = null;
        saleForecastGroupEntity = null;
        saleForecast = new SaleForecast();
        saleForecastGroupEntity = new SaleForecastGroupEntity();
        saleForecastGroupResultlists.clear();
        equalTypeSaleForecastProductList.clear();
    }

    public static double getForecastAmount() {
        return forecastAmount;
    }

    public static void setForecastAmount(double forecastAmount) {
        SaleForecastManager.forecastAmount = forecastAmount;
    }

    public static List<Fragment> getmFragments() {
        return mFragments;
    }

    public static void setSaleForecastGroupEntity(SaleForecastGroupEntity saleForecastGroupEntity) {
        SaleForecastManager.saleForecastGroupEntity = saleForecastGroupEntity;
    }

    public static List<SaleForecastGroupResultlist> getSaleForecastGroupResultlists() {
        return saleForecastGroupResultlists;
    }

    public static void setEqualTypeSaleForecastProductList(List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList) {
        SaleForecastManager.equalTypeSaleForecastProductList = equalTypeSaleForecastProductList;
    }

    public static List<EqualTypeSaleForecastProductList> getEqualTypeSaleForecastProductList() {
        return equalTypeSaleForecastProductList;
    }

    public static SaleForecast getSaleForecast() {
        return saleForecast;
    }


    /**
     * 网络请求返回数据处理
     */
    public static void getData(SaleForecastGroupEntity saleForecastGroupEntity, int isModify) {
        clearData();
        saleForecastGroupResultlists = saleForecastGroupEntity.getResultlist();
        if (saleForecastGroupResultlists != null && !saleForecastGroupResultlists.isEmpty()) {
            for (int i = 0; i < saleForecastGroupResultlists.size(); i++) {
                saleForecast = saleForecastGroupResultlists.get(i).getSaleForecast();
                if (null != saleForecast.getSaleForecastAmount() && !"".equals(saleForecast.getSaleForecastAmount())) {
                    forecastAmount = StringUtil.toDouble(saleForecast.getSaleForecastAmount());
                }
                //是否填写过都会查询到产品类型数据
                equalTypeSaleForecastProductList = saleForecastGroupResultlists.get(i).getSaleForecastProductList();
                Bundle mBundle = new Bundle();
                mBundle.putInt("isModify", isModify);
                mBundle.putInt("currentMonth", currentMonth);
                mBundle.putString("forecastFlag", forecastFlag);
                mBundle.putDouble("forecastAmount", forecastAmount);
                mBundle.putSerializable("equalTypeSaleForecastProductList", (Serializable) equalTypeSaleForecastProductList);
                SaleForecastProductsFragment mFragment = new SaleForecastProductsFragment();
                mFragment.setArguments(mBundle);
                mFragments.add(mFragment);
            }
        }
    }

    /**
     * （一）填写总销售预测总金额
     * 1，单个产品预销金额=总销售预测金额*单个产品预销占比
     * 2，单个产品预销数量=单个产品预销金额/单价
     * <p>
     */
    public static String fillForecastAmount(double forecastAmount, boolean isFirstRadio) {
        //合计预销总占比
        double forecastTotalRadio = 0;
        if (saleForecastGroupResultlists != null && !saleForecastGroupResultlists.isEmpty()) {
            for (int j = 0; j < saleForecastGroupResultlists.size(); j++) {
                equalTypeSaleForecastProductList = saleForecastGroupResultlists.get(j).getSaleForecastProductList();
                forecastTotalRadio = getForecastTotalRadio(true, isFirstRadio, equalTypeSaleForecastProductList, forecastTotalRadio);
                ((SaleForecastProductsFragment) (mFragments.get(j))).updataAll(forecastAmount, equalTypeSaleForecastProductList);
            }
        }
        return StringUtil.formatDouble(forecastTotalRadio * 100, "0.00");
    }

    /**
     * （二）微调产品预销占比
     * 1，单个产品预销金额=总销售预测金额*单个产品预销占比
     * 2，单个产品预销数量=单个产品预销金额/单价
     * 4，合计预销总占比=所有产品预销占比总和（合计比例必须大于等于100%才允许提交）
     * 5，预测总金额不变
     * 6，预销占比改变
     */
    public static String adjustForecastRadio(List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList, int pageFlag, int position) {
        //更新fragment
        ((SaleForecastProductsFragment) (mFragments.get(pageFlag))).updataItem(equalTypeSaleForecastProductList, position);
        //合计预销总占比
        double forecastTotalRadio = 0;
        if (saleForecastGroupResultlists != null && !saleForecastGroupResultlists.isEmpty()) {
            for (int j = 0; j < saleForecastGroupResultlists.size(); j++) {
                equalTypeSaleForecastProductList = saleForecastGroupResultlists.get(j).getSaleForecastProductList();
                forecastTotalRadio = getForecastTotalRadio(false, false, equalTypeSaleForecastProductList, forecastTotalRadio);
            }
        }
        return StringUtil.formatDouble(forecastTotalRadio * 100, "0.00");
    }

    /**
     * 更新预测数据
     *
     * @param isUpdateAll                      是否更新全部数据
     * @param isFirstRadio                     是否是第一次调整
     * @param equalTypeSaleForecastProductList 产品列表数据
     * @param forecastTotalRadio               总占比
     * @return 总占比
     */
    private static double getForecastTotalRadio(boolean isUpdateAll, boolean isFirstRadio, List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList, double forecastTotalRadio) {
        double forecastRadio;//参考预测占比/用户输入的预测占比
        double productCounts;//单个产品预销数量
        double productPrice;//单个产品预销单价
        double productAmount;//单个产品预销金额
        if (equalTypeSaleForecastProductList != null && !equalTypeSaleForecastProductList.isEmpty()) {
            for (int k = 0; k < equalTypeSaleForecastProductList.size(); k++) {
                if (isUpdateAll) {
                    //如果是第一次进入，并且已填写，则使用新占比，否则使用老占比
                    if (!isFirstRadio && "1".equals(forecastFlag)) {
                        //已填写总调都使用新占比
                        forecastRadio = equalTypeSaleForecastProductList.get(k).getProductSaleAccounting();
                    } else {
                        //未填写总调都使用默认老占比
                        forecastRadio = equalTypeSaleForecastProductList.get(k).getProductOldSaleAccounting();
                    }
                } else {
                    //每次微调都使用当前占比
                    forecastRadio = equalTypeSaleForecastProductList.get(k).getProductSaleAccounting();
                }
                productPrice = equalTypeSaleForecastProductList.get(k).getSaleFcProductPrice();
                productAmount = Math.ceil(forecastAmount * forecastRadio);
                try {
                    //将产品数量四舍五入取整
                    productCounts = productAmount / productPrice;
                    productCounts = CastingNumbers.doRound(productCounts, 0);
                } catch (Exception e) {
                    productCounts = 0;
                }
                equalTypeSaleForecastProductList.get(k).setProductSaleForecastNumber(productCounts);
                equalTypeSaleForecastProductList.get(k).setProductSaleForecastAmount(productAmount);
                equalTypeSaleForecastProductList.get(k).setProductSaleAccounting(forecastRadio);
                forecastTotalRadio += forecastRadio;
            }
        }
        return forecastTotalRadio;
    }

    /**
     * 本月20至26日之间可修改，其余时间不可修改
     * 19 <=今天-本月第一天<=25
     *
     * @return 返回编辑模式
     */
    public static int checkMode() {
        //是否为可修改状态,0为否只能查询，1为是
        int isModify;
        try {
            // 今天
            Date today = new Date();
            // 本月第一天
            Date firstDay = DateUtil.getFirstDayOfMonth(new Date());
            if (((DateUtil.daysBetween(firstDay, today) <= 25) && (DateUtil.daysBetween(firstDay, today) >= 19))) {
                //可修改
                isModify = 1;
                Log.d("checkMode: ", "可修改");
            } else {
                //不可修改
                isModify = 0;
                Log.d("checkMode: ", "不可修改");
            }
        } catch (Exception e) {
            //查询
            isModify = 0;
            Log.d("checkMode: ", "查询");
        }
        return isModify;
    }
}