package com.wgmf.yxgj.module.business.managesales.ui;

import android.os.Bundle;
import android.support.design.widget.AppBarLayout;
import android.support.v4.view.ViewPager;
import android.support.v4.widget.NestedScrollView;
import android.support.v7.widget.Toolbar;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.CastingNumbers;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.module.business.managesales.R;
import com.wgmf.yxgj.module.business.managesales.model.EqualTypeSaleForecastProductList;
import com.wgmf.yxgj.module.business.managesales.model.SaleForecast;
import com.wgmf.yxgj.module.business.managesales.model.SaleForecastGroupEntity;
import com.wgmf.yxgj.module.business.managesales.model.SaleForecastGroupResultlist;
import com.wgmf.yxgj.module.business.managesales.model.ShopHistorySaleEntity;
import com.wgmf.yxgj.module.business.managesales.model.ShopHistorySaleGroupEntity;
import com.wgmf.yxgj.module.business.managesales.model.ShopProductHistorySaleEntity;
import com.wgmf.yxgj.module.business.managesales.model.ShopProductHistorySaleGroupEntity;
import com.wgmf.yxgj.module.business.managesales.service.SaleForecastManager;
import com.wgmf.yxgj.module.business.managesales.service.SalesManagerService;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;
import com.wgmf.yxgj.widgets.MMessageDisplay;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.util.ArrayList;
import java.util.List;

@Route(path = "/managesales/ui/SaleForecastActivity")
public class SaleForecastActivity extends BaseParentAct implements SaleForecastProductsAdapter.OnAdjustForecastRadioListener {

    ClearEditText saleForeastHeaderPriceValueEt;

    TextView saleForeastHeaderTaskPriceTv;
    /**
     * 门店编号
     */
    String storeNo;
    String storeName;
    /**
     * 查询接口使用当前月份 yyyyMM
     */
    String currentYearMonth;
    /**
     * 当前界面显示年月为下个月(保存数据使用下个月) yyyyMM
     */
    String nextYearMonth;

    ShopProductHistorySalePop shopProductHistorySalePop;

    List<ShopHistorySaleEntity> shopHistorySaleEntities = new ArrayList<>();
    SaleForecastHistoryShopAdapter typeAdapter;
    ListView shopHistoryLv;
    /**
     * 点击的产品位置;
     */
    int position;
    /**
     * 如果是第一次进入，并且已填写，则使用新占比，否则使用老占比
     */
    boolean isFirstRadio = false;

    Toolbar saleForecastTb;

    AppBarLayout saleForecastAppBar;

    ViewPager saleForecastVp;

    NestedScrollView saleForecastNsv;

    Button publicComfirmBtnTotalLeftBtn;

    TextView publicComfirmTxtTotalLeftBtn;

    Button publicComfirmBtnTotalRightBtn;

    LinearLayout publicComfirmBtnTotalLl;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EventBus.getDefault().register(this);
        setContentView(R.layout.sale_forecast_activity);
        initData();
        initTitle();
        initView();
        getSaleForecastShop();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText(storeName);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initView() {

        publicComfirmBtnTotalLeftBtn = (Button) findViewById(R.id.public_comfirm_btn_total_left_btn);
        publicComfirmTxtTotalLeftBtn = (TextView) findViewById(R.id.public_comfirm_txt_total_left_btn);
        publicComfirmBtnTotalRightBtn = (Button) findViewById(R.id.public_comfirm_btn_total_right_btn);
        publicComfirmBtnTotalLl = (LinearLayout) findViewById(R.id.public_comfirm_btn_total_ll);

        saleForecastTb = (Toolbar) findViewById(R.id.sale_forecast_tb);

        setSupportActionBar(saleForecastTb);

        saleForecastAppBar = (AppBarLayout) findViewById(R.id.sale_forecast_app_bar);
        saleForecastVp = (ViewPager) findViewById(R.id.sale_forecast_vp);
        saleForecastNsv = (NestedScrollView) findViewById(R.id.sale_forecast_nsv);
        //设置 NestedScrollView 的内容是否拉伸填充整个视图，
        //这个设置是必须的，否者我们在里面设置的ViewPager会不可见
        saleForecastNsv.setFillViewport(true);

        TextView saleForeastHeaderTaskTv = (TextView) findViewById(R.id.sale_foreast_header_task_tv);
        saleForeastHeaderTaskPriceTv = (TextView) findViewById(R.id.sale_foreast_header_task_price_tv);
        TextView saleForeastHeaderPriceTitleTv = (TextView) findViewById(R.id.sale_foreast_header_price_title_tv);
        saleForeastHeaderPriceValueEt = (ClearEditText) findViewById(R.id.sale_foreast_header_price_value_et);

        saleForeastHeaderTaskTv.setText("" + (SaleForecastManager.currentMonth) + "月销售任务");
        saleForeastHeaderPriceTitleTv.setText("" + (SaleForecastManager.currentMonth) + "月总销售额预测");
        saleForeastHeaderTaskPriceTv.setText("--");

        publicComfirmBtnTotalLeftBtn.setText("合计：");
        publicComfirmTxtTotalLeftBtn.setText(" -- ");
        publicComfirmBtnTotalRightBtn.setText("提交");
        publicComfirmBtnTotalLl.setVisibility(View.VISIBLE);
        publicComfirmBtnTotalRightBtn.setVisibility(View.INVISIBLE);
        publicComfirmBtnTotalRightBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!checkReportForeast()) {
                    return;
                }
                //去掉合计占比的%
                String saleForecastProportion = publicComfirmTxtTotalLeftBtn.getText().toString().trim();
                saleForecastProportion = saleForecastProportion.substring(0, saleForecastProportion.length() - 1);

                double saleForecastRate = StringUtil.toDouble(saleForecastProportion);

                try {
                    saleForecastRate = saleForecastRate / 100;
                    //四舍五入取整
                    saleForecastRate = CastingNumbers.doRound(saleForecastRate, 4);
                } catch (Exception e) {
                    saleForecastRate = 0;
                }
                //占比提交条件控制大于等于100%
                if (saleForecastRate < 1d || saleForecastRate > 1.0016d) {
                    showMsg("预销占比等于100%-100.16%才能提交！");
                    return;
                }
                SaleForecast saleForecast = SaleForecastManager.getSaleForecast();
                showDialog();
                if (userInfo != null) {
                    //添加预测人
                    saleForecast.setSaleFCUserId(userInfo.getStaffId());
                }
                //门店id
                saleForecast.setSaleForeCastShopId(storeNo);
                //销售预测年月
                saleForecast.setSaleFcYearMonth(nextYearMonth);
                // 销售预测金额
                saleForecast.setSaleForecastAmount(saleForeastHeaderPriceValueEt.getText().toString());
                //销售预测产品的总占比（合计）
                saleForecast.setSaleForecastProportion(saleForecastRate);

                SaleForecastGroupResultlist saleForecastGroupResultlist = SaleForecastManager.getSaleForecastGroupResultlists().get(0);
                saleForecastGroupResultlist.setSaleForecast(saleForecast);
                String content = new Gson().toJson(saleForecastGroupResultlist);
                Log.d(TAG, content);
                SalesManagerService.getInstance().requestSaveSaleForecast(content, SaleForecastActivity.this);
            }
        });
        //返回按钮
        findViewById(R.id.main_title_back_ll).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SaleForecastActivity.this.finish();
            }
        });
        saleForeastHeaderPriceValueEt.addTextChangedListener(totalTextWatcher);
        saleForeastHeaderPriceValueEt.setSelection(saleForeastHeaderPriceValueEt.getText().length());
        //查看以往销售
        SalesManagerService.getInstance().requestGetShopHistorySale(storeNo, SaleForecastActivity.this);
        // 默认不弹出软键盘
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
    }

    TextWatcher totalTextWatcher = new TextWatcher() {
        @Override
        public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {

        }

        @Override
        public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {

        }

        @Override
        public void afterTextChanged(Editable editable) {
            if (!TextUtils.isEmpty(editable.toString())) {
                String forecastAmountValue = editable.toString().trim();
                double forecastAmount = StringUtil.toDouble(forecastAmountValue);
                SaleForecastManager.setForecastAmount(forecastAmount);
            } else {
                SaleForecastManager.setForecastAmount(0);
            }
            fillForecastAmount(SaleForecastManager.getForecastAmount(), isFirstRadio);
        }
    };

    private void initData() {
        storeNo = getIntent().getStringExtra("storeNo");
        storeName = getIntent().getStringExtra("storeName");
        SaleForecastManager.forecastFlag = getIntent().getStringExtra("forecastFlag");
        nextYearMonth = getIntent().getStringExtra("nextYearMonth");
        currentYearMonth = getIntent().getStringExtra("currentYearMonth");
        SaleForecastManager.currentMonth = getIntent().getIntExtra("currentMonth", 0);
    }

    private void getSaleForecastShop() {
        showDialog();
        SalesManagerService.getInstance().requestGetSaleForecastProductInfo(currentYearMonth, storeNo, SaleForecastManager.forecastFlag, this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.SalesManager.MSG_ON_GET_SALEFORECAST_PRODUCT_INFO: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        SaleForecastGroupEntity saleForecastGroupEntitys = new Gson().fromJson(msg, SaleForecastGroupEntity.class);
                        SaleForecastManager.setSaleForecastGroupEntity(saleForecastGroupEntitys);
                        Log.d(TAG, "saleForecastGroupEntitys=" + saleForecastGroupEntitys.toString());
                        setContet(saleForecastGroupEntitys);
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.SalesManager.MSG_ON_GET_SHOP_HISTORY_SALE: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        ShopHistorySaleGroupEntity shopHistorySaleGroupEntity = new Gson().fromJson(msg, ShopHistorySaleGroupEntity.class);
                        Log.d(TAG, "shopHistorySaleGroupEntity=" + shopHistorySaleGroupEntity.toString());
                        if (shopHistorySaleGroupEntity.getResultlist() != null && !shopHistorySaleGroupEntity.getResultlist().isEmpty()) {
                            shopHistorySaleEntities = shopHistorySaleGroupEntity.getResultlist();
                            shopHistoryLv = (ListView) findViewById(R.id.shop_history_lv);
                            typeAdapter = new SaleForecastHistoryShopAdapter(shopHistorySaleEntities, this);
                            shopHistoryLv.setAdapter(typeAdapter);
                            ListViewUtil.setListViewHeight(shopHistoryLv);
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.SalesManager.MSG_ON_GET_SHOP_PRODUCT_HISTORY_SALE: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        ShopProductHistorySaleGroupEntity shopProductHistorySaleGroupEntity = new Gson().fromJson(msg, ShopProductHistorySaleGroupEntity.class);
                        Log.d(TAG, "shopProductHistorySaleGroupEntity=" + shopProductHistorySaleGroupEntity.toString());
                        EventBus.getDefault().post(shopProductHistorySaleGroupEntity);
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.SalesManager.MSG_ON_SAVE_SALEFORECAST: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        try {
                            BaseResponse mBaseResponse = new Gson().fromJson(msg,
                                    BaseResponse.class);
                            Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                            showMsg(result.getResultInfo());
                            SaleForecastActivity.this.finish();
                        } catch (Exception e) {
                            showMsg(getString(R.string.request_data_fail));
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    /**
     * 单品以往销售详情
     *
     * @param shopProductHistorySaleGroupEntity 单品以往销售实体
     */
    @Subscribe
    public void onEventMainThread(ShopProductHistorySaleGroupEntity shopProductHistorySaleGroupEntity) {
        if (shopProductHistorySaleGroupEntity != null) {
            List<ShopProductHistorySaleEntity> shopProductHistorySaleEntitys = shopProductHistorySaleGroupEntity.getResultlist();
            if (shopProductHistorySaleEntitys != null && !shopProductHistorySaleEntitys.isEmpty()) {
                showProductHistoryContetType(shopProductHistorySaleEntitys, SaleForecastManager.getEqualTypeSaleForecastProductList(), position);
            } else {
                showMsg("无此类数据");
            }
        }
    }

    /**
     * 填充内容
     */
    private void setContet(SaleForecastGroupEntity saleForecastGroupEntity) {
        SaleForecastManager.getData(saleForecastGroupEntity, SaleForecastManager.checkMode());
        //销售任务
        try {
            List<SaleForecastGroupResultlist> saleForecastGroupResultlist = SaleForecastManager.getSaleForecastGroupResultlists();
            if (saleForecastGroupResultlist != null && !saleForecastGroupResultlist.isEmpty()) {
                List<EqualTypeSaleForecastProductList> saleForecastProductList = SaleForecastManager.getSaleForecastGroupResultlists().get(0).getSaleForecastProductList();
                if (saleForecastProductList == null || saleForecastProductList.isEmpty()) {
                    showMsg("没有产品数据");
                    return;
                }
                String price = SaleForecastManager.getSaleForecastGroupResultlists().get(0).getSaleForecastSaleTask();
                if (price != null && !"".equals(price)) {
                    double tempPrice = StringUtil.toDouble(price);
                    price = StringUtil.formatDouble(tempPrice, "0");
                    saleForeastHeaderTaskPriceTv.setText("￥" + price);
                }
            }
        } catch (Exception e) {
            Log.e(TAG, "getSaleForecastSaleTask():" + e);
        }
        //预测总金额
        saleForeastHeaderPriceValueEt.setText("" + StringUtil.formatDouble(SaleForecastManager.getForecastAmount(), "0") + "");
        saleForeastHeaderPriceValueEt.setSelection(saleForeastHeaderPriceValueEt.getText().length());

        //销售预测产品的总占比（合计）
        publicComfirmTxtTotalLeftBtn.setText("" + StringUtil.formatDouble(SaleForecastManager.getSaleForecast().getSaleForecastProportion() * 100, "0.00") + "%");
        if (SaleForecastManager.checkMode() == 0) {
            //如果是查询模式
            publicComfirmBtnTotalRightBtn.setVisibility(View.INVISIBLE);
            saleForeastHeaderPriceValueEt.setFocusable(false);
        } else {
            publicComfirmBtnTotalRightBtn.setVisibility(View.VISIBLE);
        }
        configViews();
    }

    /**
     * 对各种控件进行设置、适配、填充数据
     */
    private void configViews() {
        SaleForecastAdapter adapter = new SaleForecastAdapter(getSupportFragmentManager(), SaleForecastManager.getmFragments());
        saleForecastVp.setAdapter(adapter);
        // 设置ViewPager最大缓存的页面个数
        saleForecastVp.setOffscreenPageLimit(1);
    }

    /**
     * 显示产品历史记录
     *
     * @param shopProductHistorySaleEntitys 产品历史记录
     */
    private void showProductHistoryContetType(List<ShopProductHistorySaleEntity> shopProductHistorySaleEntitys, List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList, int position) {
        shopProductHistorySalePop = new ShopProductHistorySalePop(this, shopProductHistorySaleEntitys, equalTypeSaleForecastProductList, position);
        if (!shopProductHistorySalePop.isShowing()) {
            shopProductHistorySalePop.show(this.findViewById(R.id.title));
        }
    }

    private void fillForecastAmount(double forecastAmount, boolean isNewRadio) {
        String resultModel = SaleForecastManager.fillForecastAmount(forecastAmount, isNewRadio);
        //经过第一次调整占比后，使用老占比
        isFirstRadio = true;
        //销售预测产品的总占比（合计）
        publicComfirmTxtTotalLeftBtn.setText("" + resultModel + " % ");
    }

    @Override
    public void onAdjustForecastRadioOnclik(List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList, int pageFlag, int pos) {
        String resultModel = SaleForecastManager.adjustForecastRadio(equalTypeSaleForecastProductList, pageFlag, position);
        //销售预测产品的总占比（合计）
        publicComfirmTxtTotalLeftBtn.setText("" + resultModel + "%");
    }

    @Override
    public void getShopProductHistorySale(List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList, int pos) {
        position = pos;
        showDialog();
        SalesManagerService.getInstance().requestGetShopProductHistorySale(storeNo, equalTypeSaleForecastProductList.get(pos).getSaleFcProductNo(), SaleForecastActivity.this);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }

    /**
     * 销售预测数据提交校验
     *
     * @return 是否通过
     */
    private boolean checkReportForeast() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        inputs.add(saleForeastHeaderPriceValueEt, StaticScheme.Required(), StaticScheme.Numeric());

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            showMsg("预测总销售额填写有误，请检查");
            inputs.clear();
            return false;
        }
    }
}