package com.wgmf.yxgj.module.business.managesales.ui;

import android.content.Context;
import android.content.DialogInterface;
import android.support.v7.widget.RecyclerView;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.TextView;

import com.wgmf.library.utils.CastingNumbers;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.dialog.SaleForecastProductsEdtDialog;
import com.wgmf.yxgj.module.business.managesales.R;
import com.wgmf.yxgj.module.business.managesales.model.EqualTypeSaleForecastProductList;
import com.wgmf.yxgj.module.business.managesales.service.SaleForecastManager;

import java.util.List;

/**
 * 作者：xiep on 2017/3/16 14:55
 * 邮箱：2975837870@qq.com
 */
class SaleForecastProductsAdapter extends RecyclerView.Adapter<SaleForecastProductsAdapter.MyListViewHolder> {
    private Context context;
    private List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList;
    private int pageFlag;
    private int isModify;
    private double forecastAmount;

    private OnAdjustForecastRadioListener adjustForecastRadiotListener;

    interface OnAdjustForecastRadioListener {

        void onAdjustForecastRadioOnclik(List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList, int pageFlag, int position);

        void getShopProductHistorySale(List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList, int position);
    }

    SaleForecastProductsAdapter(Context context, OnAdjustForecastRadioListener myListener, List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList, int pageFlag, double forecastAmount, int isModify) {
        this.context = context;
        this.adjustForecastRadiotListener = myListener;
        this.equalTypeSaleForecastProductList = equalTypeSaleForecastProductList;
        this.pageFlag = pageFlag;
        this.isModify = isModify;
        this.forecastAmount = forecastAmount;
    }

    @Override
    public MyListViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        return new MyListViewHolder(LayoutInflater.from(context).inflate(R.layout.sale_forecast_item, parent, false));
    }

    @Override
    public void onBindViewHolder(final MyListViewHolder myListViewHolder, final int position) {
        //强行关闭复用
        myListViewHolder.setIsRecyclable(false);
        // 若产品单价不为0，销售产品金额使用：总预测销售额*预测占比
        if (equalTypeSaleForecastProductList.get(position).getSaleFcProductPrice() != 0) {
            equalTypeSaleForecastProductList.get(position).setProductSaleForecastAmount(forecastAmount * equalTypeSaleForecastProductList.get(position).getProductSaleAccounting());
        }
        //四舍五入取整
        double forecastAccounting = equalTypeSaleForecastProductList.get(position).getProductSaleAccounting() * 100;
        double productNumber = equalTypeSaleForecastProductList.get(position).getProductSaleForecastNumber();
        double productAmount = equalTypeSaleForecastProductList.get(position).getProductSaleForecastAmount();
        //四舍五入取整
        forecastAccounting = CastingNumbers.doRound(forecastAccounting, 2);
        productNumber = CastingNumbers.doRound(productNumber, 0);
        productAmount = CastingNumbers.doRound(productAmount, 2);

        myListViewHolder.saleForecastItemNumberTv.setText("" + StringUtil.formatDouble(productNumber, "0") + "");
        myListViewHolder.saleForecastItemAmountTv.setText("￥" + productAmount + "");
        myListViewHolder.saleForecastItemAccountingEt.setText("" + forecastAccounting + "");

        myListViewHolder.saleForecastItemNameTv.setText(equalTypeSaleForecastProductList.get(position).getSaleFcProductName());
        myListViewHolder.saleForecastItemPriceTv.setText("￥" + equalTypeSaleForecastProductList.get(position).getSaleFcProductPrice() + "/" + equalTypeSaleForecastProductList.get(position).getSaleFcProductUnit());

        if (isModify == 0) {
            //如果是查询模式
            myListViewHolder.saleForecastItemAccountingEt.setOnClickListener(null);
            myListViewHolder.saleForecastItemDecrease.setEnabled(false);
            myListViewHolder.saleForecastItemPlus.setEnabled(false);
        } else {
            myListViewHolder.saleForecastItemAccountingEt.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    showProEdtDialog(myListViewHolder, position);
                }
            });
        }
        myListViewHolder.saleForecastItemDetailTv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                SaleForecastManager.setEqualTypeSaleForecastProductList(equalTypeSaleForecastProductList);
                adjustForecastRadiotListener.getShopProductHistorySale(equalTypeSaleForecastProductList, position);
            }
        });
        //通过设置tag，防止position紊乱
        myListViewHolder.saleForecastItemAccountingEt.setTag(position);

        checkDecrease(myListViewHolder, forecastAccounting);

        myListViewHolder.saleForecastItemDecrease.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                adajustRadio(myListViewHolder, position, -0.01);
            }
        });
        myListViewHolder.saleForecastItemPlus.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                adajustRadio(myListViewHolder, position, 0.01);
            }
        });

    }

    /**
     * 是否可减
     *
     * @param myListViewHolder   当前ListViewHolder
     * @param forecastAccounting 当前占比
     */
    private void checkDecrease(MyListViewHolder myListViewHolder, double forecastAccounting) {
        if (isModify != 0 && forecastAccounting > 0d) {
            myListViewHolder.saleForecastItemDecrease.setEnabled(true);
        } else {
            myListViewHolder.saleForecastItemDecrease.setEnabled(false);
        }
    }

    /**
     * 占比调整对话框
     *
     * @param myListViewHolder 当前ListViewHolder
     * @param position         当前ListViewHolder位置
     */
    private void showProEdtDialog(final MyListViewHolder myListViewHolder, final int position) {
        final SaleForecastProductsEdtDialog.Builder builder = new SaleForecastProductsEdtDialog.Builder(context);
        builder.setTitle(myListViewHolder.saleForecastItemNameTv.getText().toString() + myListViewHolder.saleForecastItemPriceTv.getText().toString());
        builder.setProRadioOld("修改前预销出库占比：" + myListViewHolder.saleForecastItemAccountingEt.getText().toString() + "%");
        builder.setPositiveButton(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.setNegativeButton(
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        myListViewHolder.saleForecastItemAccountingEt.setText("" + builder.getProNum() + "");
                        if (position == ((int) myListViewHolder.saleForecastItemAccountingEt.getTag())) {
                            adajustRadio(myListViewHolder, position, 0);
                        }
                        dialog.dismiss();
                    }
                });
        builder.create().show();
    }

    /**
     * 占比调整计算
     *
     * @param myListViewHolder 当前ListViewHolder
     * @param position         当前ListViewHolder位置
     * @param foot             调整步长
     */
    private void adajustRadio(MyListViewHolder myListViewHolder, int position, double foot) {
        double forecastAccounting = 0;
        if (!TextUtils.isEmpty(myListViewHolder.saleForecastItemAccountingEt.getText().toString())) {
            String forecastAccountingValue = myListViewHolder.saleForecastItemAccountingEt.getText().toString().trim();
            forecastAccounting = StringUtil.toDouble(forecastAccountingValue);
            forecastAccounting = (forecastAccounting + foot);
        }
        double productAmount = forecastAccounting * forecastAmount / 100.0;
        double productNumber;
        try {
            productNumber = productAmount / equalTypeSaleForecastProductList.get(position).getSaleFcProductPrice();
        } catch (Exception e) {
            productNumber = 0;
        }

        //四舍五入取整
        forecastAccounting = CastingNumbers.doRound(forecastAccounting, 2);
        productNumber = CastingNumbers.doRound(productNumber, 0);
        productAmount = CastingNumbers.doRound(productAmount, 2);

        //将修改后的占比填充进数据集合
        equalTypeSaleForecastProductList.get(position).setProductSaleAccounting(forecastAccounting / 100.0);
        equalTypeSaleForecastProductList.get(position).setProductSaleForecastNumber(productNumber);
        myListViewHolder.saleForecastItemAccountingEt.setText("" + forecastAccounting + "");
        myListViewHolder.saleForecastItemAmountTv.setText("￥" + productAmount + "");
        if (equalTypeSaleForecastProductList.get(position).getSaleFcProductPrice() != 0) {
            equalTypeSaleForecastProductList.get(position).setProductSaleForecastAmount(productAmount);
            myListViewHolder.saleForecastItemNumberTv.setText("" + StringUtil.formatDouble(productNumber, "0") + "");
        }
        checkDecrease(myListViewHolder, forecastAccounting);

        adjustForecastRadiotListener.onAdjustForecastRadioOnclik(equalTypeSaleForecastProductList, pageFlag, position);
    }

    @Override
    public long getItemId(int i) {
        return i;
    }

    @Override
    public int getItemCount() {
        return equalTypeSaleForecastProductList.size();
    }

    class MyListViewHolder extends RecyclerView.ViewHolder {
        TextView saleForecastItemAccountingEt;
        TextView saleForecastItemNameTv;
        TextView saleForecastItemPriceTv;
        TextView saleForecastItemNumberTv;
        TextView saleForecastItemAmountTv;
        TextView saleForecastItemDetailTv;
        ImageButton saleForecastItemDecrease;
        ImageButton saleForecastItemPlus;

        MyListViewHolder(View itemView) {
            super(itemView);
            saleForecastItemNameTv = (TextView) itemView.findViewById(R.id.sale_forecast_item_name_tv);
            saleForecastItemPriceTv = (TextView) itemView.findViewById(R.id.sale_forecast_item_price_tv);
            saleForecastItemAccountingEt = (TextView) itemView.findViewById(R.id.sale_forecast_item_accounting_tv);
            saleForecastItemNumberTv = (TextView) itemView.findViewById(R.id.sale_forecast_item_number_tv);
            saleForecastItemAmountTv = (TextView) itemView.findViewById(R.id.sale_forecast_item_amount_tv);
            saleForecastItemDetailTv = (TextView) itemView.findViewById(R.id.sale_forecast_item_detail_tv);
            saleForecastItemDecrease = (ImageButton) itemView.findViewById(R.id.sale_forecast_item_decrease);
            saleForecastItemPlus = (ImageButton) itemView.findViewById(R.id.sale_forecast_item_plus);
        }
    }
}
