package com.wgmf.yxgj.module.business.managesales.ui;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.wgmf.yxgj.base.BaseParentFra;
import com.wgmf.yxgj.module.business.managesales.R;
import com.wgmf.yxgj.module.business.managesales.model.EqualTypeSaleForecastProductList;

import org.jetbrains.annotations.NotNull;

import java.util.List;

/**
 * 作者：xiep on 2017/3/9 11:25
 * 邮箱：2975837870@qq.com
 */

public class SaleForecastProductsFragment extends BaseParentFra {

    SaleForecastProductsAdapter myListAdapter;

    String storeNo;
    String forecastFlag;
    int pageFlag;
    int isModify;
    int currentMonth;
    double forecastAmount;
    List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList;

    TextView saleForeastSaleAccountingTv;
    TextView saleForeastSaleNumberTv;
    RecyclerView saleForeastRv;


    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        pageFlag = getArguments().getInt("pageFlag");
        currentMonth = getArguments().getInt("currentMonth");
        forecastFlag = getArguments().getString("forecastFlag");
        storeNo = getArguments().getString("storeNo");
        forecastAmount = getArguments().getDouble("forecastAmount");
        isModify = getArguments().getInt("isModify");
    }

    @Nullable
    @Override
    public View onCreateView(@NotNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {

        View view = inflater.inflate(R.layout.sale_forecast_fragment, container, false);
        saleForeastSaleAccountingTv = (TextView) view.findViewById(R.id.sale_foreast_sale_accounting_tv);
        saleForeastSaleNumberTv = (TextView) view.findViewById(R.id.sale_foreast_sale_number_tv);
        saleForeastRv = (RecyclerView) view.findViewById(R.id.sale_foreast_rv);

        saleForeastSaleAccountingTv.setText("" + (currentMonth) + "月预销出库占比");
        saleForeastSaleNumberTv.setText("" + (currentMonth) + "月预销数量");

        equalTypeSaleForecastProductList = (List<EqualTypeSaleForecastProductList>) getArguments().getSerializable("equalTypeSaleForecastProductList");
        myListAdapter = new SaleForecastProductsAdapter(getActivity(), (SaleForecastActivity) getActivity(), equalTypeSaleForecastProductList, pageFlag, forecastAmount, isModify);
        saleForeastRv.setLayoutManager(new LinearLayoutManager(getActivity()));
        saleForeastRv.setAdapter(myListAdapter);
        return view;
    }

    /**
     * 填写预测总金额时：更新所有item数据
     */
    public void updataAll(double newForecastAmount, List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList) {
        forecastAmount = newForecastAmount;
        if (null != saleForeastRv) {
//            myListAdapter.notifyDataSetChanged();
            myListAdapter = new SaleForecastProductsAdapter(getActivity(), (SaleForecastActivity) getActivity(), equalTypeSaleForecastProductList, pageFlag, forecastAmount, isModify);
            saleForeastRv.setLayoutManager(new LinearLayoutManager(getActivity()));
            saleForeastRv.setAdapter(myListAdapter);
        }
    }

    /**
     * 微调单个产品占比时：更新单个item数据
     *
     * @param equalTypeSaleForecastProductLists 预测数据
     */

    public void updataItem(List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductLists, final int position) {
//        equalTypeSaleForecastProductList = equalTypeSaleForecastProductLists;
//        myListAdapter.notifyItemChanged(position);
    }
}