package com.wgmf.yxgj.module.business.managesales.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.module.business.managesales.R;
import com.wgmf.yxgj.module.business.managesales.model.SaleForecastShopGroupEntity;
import com.wgmf.yxgj.module.business.managesales.model.SaleForecastShopsEntity;
import com.wgmf.yxgj.module.business.managesales.service.SalesManagerService;
import com.xp.arouter.RouterParams;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.util.Date;
import java.util.List;


@Route(path = RouterParams.URL_SALEFORECASTSHOPACTIVITY)
public class SaleForecastShopActivity extends BaseParentAct implements AdapterView.OnItemClickListener {

    List<SaleForecastShopsEntity> saleForecastShopsEntity;
    /**
     * 销售预测显示月份 M
     */
    int currentMonth;
    /**
     * 查询接口使用当前月份 yyyyMM
     */
    String currentYearMonth;
    /**
     * 当前界面显示年月为下个月 yyyyMM
     */
    String nextYearMonth;

    TextView onclickName;
    LinearLayout onclickTitleLl;
    ListView publicListViewLv;
    TextView publicListViewEmptyTv;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.public_list_view);
        EventBus.getDefault().register(this);
        initTitle();
        initView();
    }

    @Override
    protected void onResume() {
        super.onResume();
        getSaleForecastShop();
    }

    private void initView() {
        onclickName = (TextView) findViewById(R.id.onclick_name);
        onclickTitleLl = (LinearLayout) findViewById(R.id.onclick_title_ll);
        publicListViewLv = (ListView) findViewById(R.id.public_list_view_lv);
        publicListViewEmptyTv = (TextView) findViewById(R.id.public_list_view_empty_tv);


        publicListViewLv.setEmptyView(publicListViewEmptyTv);
        publicListViewLv.setOnItemClickListener(this);
        onclickTitleLl.setVisibility(View.VISIBLE);
        onclickName.setVisibility(View.VISIBLE);
        currentMonth = DateUtil.getMonthForDate(new Date());
        currentYearMonth = DateUtil.getFormatMonth("yyyyMM", 0);
        nextYearMonth = DateUtil.getFormatMonth("yyyyMM", 1);
        if (currentMonth >= 12) {
            currentMonth = currentMonth - 12 + 1;
        } else {
            currentMonth = currentMonth + 1;
        }
        onclickName.setText("设置" + currentMonth + "月销售预测");
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText("销售预测");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void getSaleForecastShop() {
        if (userInfo != null) {
            showDialog();
            String saleOrgId = userInfo.getOrganizationId();
            SalesManagerService.getInstance().requestGetSaleForecastShop(currentYearMonth, saleOrgId, this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.SalesManager.MSG_ON_GET_SALEFORECAST_SHOP: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        SaleForecastShopGroupEntity saleForecastShopGroupEntity = new Gson().fromJson(msg, SaleForecastShopGroupEntity.class);
                        Log.d(TAG, "saleForecastShopGroupEntity=" + saleForecastShopGroupEntity.toString());
                        EventBus.getDefault().post(saleForecastShopGroupEntity);
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    @Subscribe
    public void onEventMainThread(SaleForecastShopGroupEntity saleForecastShopGroupEntity) {

        if (saleForecastShopGroupEntity != null) {
            saleForecastShopsEntity = saleForecastShopGroupEntity.getResultlist();
            if (saleForecastShopsEntity != null && !saleForecastShopsEntity.isEmpty()) {
                SaleForecastShopAdapter saleForecastShopAdapter = new SaleForecastShopAdapter(saleForecastShopsEntity, this);
                publicListViewLv.setAdapter(saleForecastShopAdapter);
            }
        }
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        Intent intent = new Intent(this, SaleForecastActivity.class);
        intent.putExtra("storeNo", saleForecastShopsEntity.get(position).getShop().getShopId());
        intent.putExtra("storeName", saleForecastShopsEntity.get(position).getShop().getShopName());
        intent.putExtra("organization", saleForecastShopsEntity.get(position).getShop().getSaleOrganization());
        intent.putExtra("forecastFlag", saleForecastShopsEntity.get(position).getSaleForecastFlag());
        intent.putExtra("currentMonth", currentMonth);
        intent.putExtra("nextYearMonth", nextYearMonth);
        intent.putExtra("currentYearMonth", currentYearMonth);
        startActivity(intent);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }
}