package com.wgmf.yxgj.module.business.managesales.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.managesales.R;
import com.wgmf.yxgj.module.business.managesales.model.SaleForecastShopsEntity;

import java.util.List;

class SaleForecastShopAdapter extends BaseAdapter {
    /**
     * 是否填写销售预测标识 ：'0'表示未填写；‘1表示已经填写’
     */
    private static final String SALE_FORECAST_FLAG = "1";

    private List<SaleForecastShopsEntity> list;
    private Context context;

    SaleForecastShopAdapter(List<SaleForecastShopsEntity> mlist, Context context) {
        this.list = mlist;
        this.context = context;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.stockgoods_shop_item, null);
            viewHolder = new ViewHolder(convertView);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        SaleForecastShopsEntity ent = list.get(position);
        viewHolder.store.setText(ent.getShop().getShopName());
        viewHolder.stockgoodsCheckDeitailsLl1.setVisibility(View.GONE);
        viewHolder.stockgoodsCheckDeitailsLl2.setVisibility(View.GONE);

        if (SALE_FORECAST_FLAG.equals(ent.getSaleForecastFlag())) {
            viewHolder.examine.setText("已设置");
            viewHolder.examine.setTextColor(convertView.getResources().getColor(R.color.common_txt_color));
        }
        return convertView;
    }

    class ViewHolder {
        ImageView row;
        TextView store;
        TextView examine;
        TextView pdAmount;
        TextView pdNum;
        TextView diffamount;
        TextView deductmarks;
        LinearLayout stockgoodsCheckDeitailsLl1;
        LinearLayout stockgoodsCheckDeitailsLl2;

        ViewHolder(View convertView) {
            store = (TextView) convertView.findViewById(R.id.stockgoods_check_store);
            examine = (TextView) convertView.findViewById(R.id.stockgoods_check_is_examine);
            pdAmount = (TextView) convertView.findViewById(R.id.stockgoods_check_pdbillcode);
            pdNum = (TextView) convertView.findViewById(R.id.stockgoods_check_pdamount);
            diffamount = (TextView) convertView.findViewById(R.id.stockgoods_check_diffamount);
            deductmarks = (TextView) convertView.findViewById(R.id.stockgoods_check_deductmarks);
            row = (ImageView) convertView.findViewById(R.id.stockgoods_check_row);

            stockgoodsCheckDeitailsLl1 = (LinearLayout) convertView.findViewById(R.id.stockgoods_check_deitails_ll1);
            stockgoodsCheckDeitailsLl2 = (LinearLayout) convertView.findViewById(R.id.stockgoods_check_deitails_ll2);
        }
    }
}