package com.wgmf.yxgj.module.business.managesales.ui;

import android.content.Context;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.module.business.managesales.R;
import com.wgmf.yxgj.module.business.managesales.model.EqualTypeSaleForecastProductList;
import com.wgmf.yxgj.module.business.managesales.model.ShopProductHistorySaleEntity;

import java.util.List;

/**
 * 销售预测单品销售
 * 作者：xiep on 2017/3/1 09:37
 * 邮箱：2975837870@qq.com
 */

public class ShopProductHistorySalePop {

    private PopupWindow shopProductHistorySalePw;

    private View viewParent;

    ShopProductHistorySalePop(final Context context, List<ShopProductHistorySaleEntity> shopProductHistorySaleEntitys, List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductList, int position) {
        this(context, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, shopProductHistorySaleEntitys, equalTypeSaleForecastProductList, position);
    }

    private ShopProductHistorySalePop(final Context context, final int width, final int height, List<ShopProductHistorySaleEntity> shopProductHistorySaleEntitys, List<EqualTypeSaleForecastProductList> equalTypeSaleForecastProductLists, int position) {

        LayoutInflater inflater = LayoutInflater.from(context);
        viewParent = inflater.inflate(R.layout.view_shop_product_history_dialog, null);

        ListView shopProductHistoryLv = (ListView) viewParent.findViewById(R.id.shop_product_history_lv);

        TextView shopProductHistoryTitleTv = (TextView) viewParent.findViewById(R.id.shop_product_history_title_tv);
        TextView shopProductHistoryTitleMoreTv = (TextView) viewParent.findViewById(R.id.shop_product_history_title_more_tv);
        if (null != equalTypeSaleForecastProductLists && !equalTypeSaleForecastProductLists.isEmpty()) {
            shopProductHistoryTitleTv.setText(equalTypeSaleForecastProductLists.get(position).getSaleFcProductName());
            shopProductHistoryTitleMoreTv.setText(equalTypeSaleForecastProductLists.get(position).getSaleFcProductNo() + " ￥" + equalTypeSaleForecastProductLists.get(position).getSaleFcProductPrice() + "/" + equalTypeSaleForecastProductLists.get(position).getSaleFcProductUnit());

            ShopProductHistorySaleEntity shopProductHistorySaleEntity = new ShopProductHistorySaleEntity();
            shopProductHistorySaleEntity.setShopProductSaleMonth(DateUtil.getFormatMonth("yyyyMM", 1));
            shopProductHistorySaleEntity.setShopProductSaleNum(equalTypeSaleForecastProductLists.get(position).getProductSaleForecastNumber() + "");
            shopProductHistorySaleEntitys.add(0, shopProductHistorySaleEntity);
        }

        LinearLayout shopProductHistoryDialogCancelBtn = (LinearLayout) viewParent.findViewById(R.id.shop_product_history_ll);
        ImageView shopHistoryDialogCancelIv = (ImageView) viewParent.findViewById(R.id.shop_product_history_dialog_cancel_iv);

        SaleForecastHistoryProductsAdapter typeAdapter = new SaleForecastHistoryProductsAdapter(shopProductHistorySaleEntitys, context);
        shopProductHistoryLv.setAdapter(typeAdapter);
        shopProductHistorySalePw = new PopupWindow(viewParent, width, height, true);
        shopProductHistoryDialogCancelBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                shopProductHistorySalePw.dismiss();
            }
        });
        shopHistoryDialogCancelIv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                shopProductHistorySalePw.dismiss();
            }
        });
        setListViewHeight(shopProductHistoryLv);
    }

    boolean isShowing() {
        return null != shopProductHistorySalePw && shopProductHistorySalePw.isShowing();
    }

    void show(View parent) {
        if (null == parent) {
            throw new IllegalArgumentException("StoreDateSelectorPop.showAtLocation parent is null");
        }
        viewParent = parent;
        shopProductHistorySalePw.showAtLocation(parent, Gravity.CENTER, 0, 0);
    }

    public void dismiss() {
        if (null != shopProductHistorySalePw && shopProductHistorySalePw.isShowing()) {
            shopProductHistorySalePw.dismiss();
        }
    }


    private void setListViewHeight(ListView listView) {

        ListAdapter listAdapter = listView.getAdapter();

        if (listAdapter == null) {
            return;
        }
        int totalHeight = 0;
        for (int i = 0, len = listAdapter.getCount(); i < len; i++) {
            View listItem = listAdapter.getView(i, null, listView);
            listItem.measure(0, 0);
            totalHeight += listItem.getMeasuredHeight();
        }
        ViewGroup.LayoutParams params = listView.getLayoutParams();
        params.height = totalHeight
                + (listView.getDividerHeight() * (listAdapter.getCount() - 1));
        listView.setLayoutParams(params);
    }
}