package com.wgmf.yxgj.module.business.managestaff.model

import com.wgmf.library.base.BaseResponse

/**
 * 员工离职
 */
data class EmployeeDissmissEntityRequest(
    val id: Int?,
    val approvalPerson: String?,  //操作人工号
    val approvalPersonLevel: String?,  //	操作人等级，1-总部，3-大区，4-办事处（区域经理），5-主管
    val dimissionAllocationType: String?,//	离职分配类型;1-指定分配人员, 2-自动分配 3,不分配
    val lzDate: String,   //	离职日期 格式:yyyy-MM-dd
    val lzUrlList: List<String>?,    //	离职图片url
    val lzreason: String?,   //	离职原因
    val lztype: String?,   //	离职类型：'01','主动离职'),('02','被动离职'),('03','自离')
    val operName: String?,  //	员工姓名
    val operatorId: String?,   //员工编号
    val receiverStaffId: String?,    //离职分配接收人工号
    val saleOrganization: String?    //	组织机构ID
)



data class EmployeeDissmissEntity(
    val payload: EmployeeDissmissBean
) : BaseResponse() {

    data class EmployeeDissmissBean(
        val allocationType: Int,   //离职分配类型;1-指定分配人员, 2-自动分配 3,不分配
        val approvalStaffId: String?,  //操作人工号
        val attachmentUrl: String?,   //离职附件url,多个用逗号分开
        val auditStaffId: String?,   //	审核人工号
        val auditStatus: Int,    //审核状态：1-待审核,2-审核通过,3-审核驳回
        val createTime: String?,   //创建时间
        val customerNum: Int,   //客户数量
        val dimissionTime: String?,   //离职时间
        val groupNum: Int,   //	群数量
        val id: Int,
        val reason: String?,  //	离职原因
        val receiverStaffId: String?,  //分配离职接收人工号
        val rejectReason: String?,  //驳回原因
        val shopId: Int, //门店id
        val shopName: String?,  //门店名称
        val staffId: String?,  //离职员工工号
        val staffName: String?,  //离职员工名称
        val type: String?,   //离职类型：01-主动离职,02-被动离职,03-自离
        val updateTime: String?  //	修改时间
    )
}

