package com.wgmf.yxgj.module.business.managestaff.model

import com.wgmf.library.base.BaseResponse
import com.wgmf.yxgj.global.ConstantParams
import java.io.Serializable

/**
 * 分页查询员工好友列表请求
 */
data class UserAndCustomerRelationRequest(
    val userId: String?,
    val page: Int = ConstantParams.CONSTANT_STARTS_1,
    val size: Int = ConstantParams.CONSTANT_STARTS_20
)

/**
 * 分页查询员工好友列表结果
 */
data class UserAndCustomerRelationEntity(val payload: UserAndCustomerRelationPage) :
    BaseResponse() {

    data class UserAndCustomerRelationPage(
        val data: List<UserAndCustomerRelationBean>?,
        val page: Int,
        val pages: Int,
        val size: Int,
        val total: Int
    ) {
        data class UserAndCustomerRelationBean(
            val externalUserId: String?,   //外部联系人id
            val headImgUrl: String?,   //头像
            val nickname: String?,   //昵称
            val addRelationTime: String?  //添加好友时间
        ) : Serializable
    }
}

data class CanApplyRequest(val consultantStaffId: String?)

data class CanApplyEntity(val payload: CanApplyBean) : BaseResponse() {

    data class CanApplyBean(
        val whetherCanApply: Int,  //	是否可以申请:1-是 2-否
        val nextCanApplyTime: Int?  //	下一次可以分配顾问客户天数（审核中就没值）
    )
}

/**
 * 保存员工客户分配申请
 */
class CustomerAllocationSaveRequest {
    var id: Int? = null         //	主键id,(带id默认为重新发起保存)
    var staffId: String? = null   //原承接员工工号
    var staffName: String? = null  //原承接员工名称
    var staffStatus: Int? = null    //	原承接员工类型: 0-在职员工,1-离职员工
    var receiverStaffId: String? = null   //分配接收人工号
    var receiverStaffName: String? = null  //分配接收人名称
    var approvalStaffId: String? = null   //操作人工号
    var approvalUserLevel: Int? = null   //操作人用户等级:1-总部 3-大区 4-办事（区域经理） 5-主管
    var allocationNumType: Int? = null   //	分配数量类型：1- 全部,2- 一半,3- 1/3

}

data class OrganizationUserStaffStatusRequest(val staffId: String?)

data class OrganizationUserStaffStatusEntity(val payload: Int) : BaseResponse()