package com.wgmf.yxgj.module.business.managestaff.model

import com.wgmf.library.base.BaseResponse
import com.wgmf.yxgj.global.ConstantParams
import java.io.Serializable

/**
 * 分页查询顾问列表请求
 */
data class QiWeiCustomersAssignmentRequest(
    val approvalStaffId: String?,   //操作人工号
    val userLevel: String?,     //	用户层级:1-总部 3-大区 4-办事（区域经理） 5-主管
    val staffStatus: Int,   //	顾问在职状态：0-在职，1-离职
    val page: Int = ConstantParams.CONSTANT_STARTS_1,
    val size: Int = ConstantParams.CONSTANT_STARTS_20
)

/**
 * 分页查询顾问列表结果
 */
data class QiWeiCustomersAssignmentEntity(val payload: QiWeiCustomersAssignmentPage) :
    BaseResponse() {

    data class QiWeiCustomersAssignmentPage(
        val data: List<QiWeiCustomersAssignmentBean>?,
        val page: Int,
        val pages: Int,
        val size: Int,
        val total: Int
    ) {
        data class QiWeiCustomersAssignmentBean(
            val staffId: String?,   //顾问工号
            val staffName: String?,   //顾问名称
            val customerNum: Int   //顾问好友数量
        ) : Serializable
    }
}

/**
 * 查询员工的顾问汇总信息
 */
data class QiWeiCustomersAssignmentTotalEntity(val payload: QiWeiCustomersAssignmentTotalBean) :
    BaseResponse() {

    data class QiWeiCustomersAssignmentTotalBean(
        val consultantSum: String,  //顾问总数
        val customerSum: String   //顾问好友总数
    )
}