package com.wgmf.yxgj.module.business.managestaff.model

import com.wgmf.library.base.BaseResponse
import com.wgmf.yxgj.global.ConstantParams
import java.io.Serializable

/**
 * 分页查询客户分配申请记录请求
 */
data class QiWeiCustomersAssignmentRecordsRequest(
    val approvalStaffId: String?,   //操作人工号
    val page: Int = ConstantParams.CONSTANT_STARTS_1,
    val size: Int = ConstantParams.CONSTANT_STARTS_20
)

/**
 * 分页查询客户分配申请记录
 */
data class QiWeiCustomersAssignmentRecordsEntity(val payload: QiWeiCustomersAssignmentRecordsPage) :
    BaseResponse() {

    data class QiWeiCustomersAssignmentRecordsPage(
        val data: List<QiWeiCustomersAssignmentRecordsBean>?,
        val page: Int,
        val pages: Int,
        val size: Int,
        val total: Int
    ) {
        data class QiWeiCustomersAssignmentRecordsBean(
            val id: Int,
            val staffId: String?,   //	员工工号
            val staffName: String?,   //员工名称
            val auditStatus: Int,    //审核状态：1-待审核,2-审核通过,3-审核驳回
            val receiverStaffName: String?,   //分配接收人名称
            val customerNum: Int,   //分配客户数量
            val rejectReason: String?,   //驳回原因
            val createTime: String?,  //创建时间
            val allocationCustomerList: List<AllocationCustomerBean>?  //分配的客户列表
        ) : Serializable {

            data class AllocationCustomerBean(
                val headImgUrl: String?,  //头像
                val nickname: String?,   //	昵称
                val status: Int,     //	分配状态: 1-确认中,2-已分配,3-已拒绝,4-待审核,5-分配失败
                val allocationMsg: String?  //	分配信息
            ) : Serializable
        }
    }
}