package com.wgmf.yxgj.module.business.managestaff.model

import com.wgmf.library.base.BaseResponse
import com.wgmf.yxgj.global.ConstantParams
import java.io.Serializable

/**
 * 指定分配人
 */
data class SpecifyAllocationEmployeeRequesst(
    val approvalPerson: String?,
    val id: Int,
    val receiverStaffId: String?
)

/**
 * 员工离职分配请求数据
 */
data class ResignDistributeRecordsRequest(val approvalStaffId:String, val page:Int, val size:Int= ConstantParams.CONSTANT_STARTS_10)

/**
 * 离职分配记录实体类
 */
data class EmployeeDissmissInfoEntity(val payload: EmployeeDissmissPage) : BaseResponse() {

    data class EmployeeDissmissPage(
        val data: List<EmployeeDissmissBean>?,
        val page: Int,
        val pages: Int,
        val size: Int,
        val total: Int
    ) {
        data class EmployeeDissmissBean(
            val allocationType: Int,  //	离职分配类型;1-指定分配人员, 2-自动分配 3,不分配
            val approvalStaffId: String?,  //	操作人工号
            val attachmentUrl: String?,   //离职附件url,多个用逗号分开
            val auditStaffId: String?,   //审核人工号
            val auditStatus: Int,    //审核状态：1-待审核,2-审核通过,3-审核驳回
            val auditTime: String?, //审核时间
            val createTime: String?,  //创建时间
            val customerNum: Int,   //客户数量
            val dimissionTime: String?,  //离职时间
            val groupNum: String?,   //群数量
            val id: Int,
            val reason: String?,  //离职原因
            val receiverStaffId: String?,  //分配离职接收人工号
            val receiverName: String?,  //分配离职接收人姓名
            val rejectReason: String?,   //驳回原因
            val shopIds: String?,   //门店id集合，多个用','分开
            val shopNames: String?,   //门店名称集合，多个用','分开
            val staffId: String?,   //离职员工工号
            val staffName: String?,   //离职员工名称
            val type: String?,    //离职类型：01-主动离职,02-被动离职,03-自离
            val updateTime: String?   //修改时间
        ) : Serializable
    }
}
