package com.wgmf.yxgj.module.business.managestaff.ui;

import android.content.Context;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.yxgj.base.R;
import com.wgmf.yxgj.model.BrandList;

import java.util.List;

/**
 * 公共选择结果查询PopWindow
 *
 * @author xiep on 2017/3/1 09:37
 */
@SuppressWarnings("all")
public class BrandSelectPop implements AdapterView.OnItemClickListener {

    private View viewParent;

    private PopupWindow reportQuerySelectPw;

    private ReportQuerySelectPopListener reportQuerySelectPopListener;

    private List<BrandList> brandLists;

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        dismiss();
        reportQuerySelectPopListener.onBrandPickClick(brandLists.get(position));
    }

    public interface ReportQuerySelectPopListener {
        void onBrandPickClick(BrandList brandList);
    }

    public BrandSelectPop(final Context context, ReportQuerySelectPopListener reportQuerySelectPopListener, List<BrandList> brandLists) {
        this(context, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, reportQuerySelectPopListener, brandLists);
    }

    private BrandSelectPop(final Context context, final int width, final int height, final ReportQuerySelectPopListener reportQuerySelectPopListener, final List<BrandList> brandLists) {
        this.reportQuerySelectPopListener = reportQuerySelectPopListener;
        this.brandLists = brandLists;

        LayoutInflater inflater = LayoutInflater.from(context);
        viewParent = inflater.inflate(R.layout.select_brand_view, null);

        ListView brandSelectPopLv = (ListView) viewParent.findViewById(R.id.brand_select_pop_lv);
        TextView brandSelectPopEmptyTv = (TextView) viewParent.findViewById(R.id.brand_select_pop_empty_tv);
        brandSelectPopLv.setEmptyView(brandSelectPopEmptyTv);
        LinearLayout brandSelectPopLl = (LinearLayout) viewParent.findViewById(R.id.brand_select_pop_ll);
        ImageView publicSelectPopCancelIv = (ImageView) viewParent.findViewById(R.id.public_select_pop_cancel_iv);

        BrandSelectAdapter typeAdapter = new BrandSelectAdapter(context, brandLists);
        brandSelectPopLv.setAdapter(typeAdapter);

        reportQuerySelectPw = new PopupWindow(viewParent, width, height, true);
        brandSelectPopLv.setOnItemClickListener(this);
        publicSelectPopCancelIv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                reportQuerySelectPw.dismiss();
            }
        });
        ListViewUtil.setListViewHeight(brandSelectPopLv);
    }

    public boolean isShowing() {
        return null != reportQuerySelectPw && reportQuerySelectPw.isShowing();
    }

    public void show(View parent) {
        if (null == parent) {
            throw new IllegalArgumentException("StoreDateSelectorPop.showAtLocation parent is null");
        }
        viewParent = parent;
        reportQuerySelectPw.showAtLocation(parent, Gravity.CENTER, 0, 0);
    }

    public void dismiss() {
        if (null != reportQuerySelectPw && reportQuerySelectPw.isShowing()) {
            reportQuerySelectPw.dismiss();
        }
    }
}