package com.wgmf.yxgj.module.business.managestaff.ui;

import android.os.Bundle;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.model.InChargeStaffEntity;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.service.PublicService;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;

import java.lang.reflect.Type;
import java.util.List;

/**
 * 员工入职：选择上级主管列表
 */
@SuppressWarnings("all")
public class SelectorChargeStaffActivity extends SelectorBaseActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getShopList();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText("选择上级");
    }

    private void getShopList() {
        if (null != userInfo) {
            String code1 = userInfo.getOrganizationCode();
            String url = "";
            // 发送主管数据请求
            storeNameEt.setHint(R.string.search_up_hint_txt);
            showDialog();
            url = NetworkParams.URL_CHARGE_STAFF_LIST;
            PublicService.getInstance().requestManagerInfo(url, code1, SelectorChargeStaffActivity.this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.Publics.MSG_ON_MANAGER_INFO) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    Type listType = new TypeToken<List<InChargeStaffEntity>>() {
                    }.getType();
                    List<InChargeStaffEntity> resources = new Gson().fromJson(msg, listType);
                    if (null != resources) {
                        listShow.clear();
                        for (InChargeStaffEntity mInChargeStaffEntity : resources) {
                            BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
                            //员工入职选择上级主管时，需使用SaleOragnization字段
                            mBaseSelectorEntity.setSelectorCode(mInChargeStaffEntity.getOrganizationId() + "");
                            mBaseSelectorEntity.setSelectorName(mInChargeStaffEntity.getName());
                            listShow.add(mBaseSelectorEntity);
                        }
                        mAdapter.notifyDataSetChanged();
                        search();
                    }
                }
            }
        }
    }
}