package com.wgmf.yxgj.module.business.managestaff.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.module.business.managestaff.model.NutrSalaryProCityEntity;
import com.wgmf.yxgj.module.business.managestaff.model.NutrSalaryProCityResultEntity;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;

import java.util.List;

/**
 * 员工入职：流动营养顾问需要进入选择城市页面，选择底薪标准所在城市
 */
@SuppressWarnings("all")
public class SelectorSalaryCityActivity extends SelectorBaseActivity implements AdapterView.OnItemClickListener {
    private BaseCommonAdapter mAdapter;
    private List<NutrSalaryProCityEntity> nutrSalaryProCityEntitys;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getData();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText("选择所在城市");
    }

    @Override
    protected void initContent() {
        super.initContent();
        storeNameEt.setVisibility(View.GONE);
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        Intent intent = new Intent();
        intent.putExtra(STORE_TAG, nutrSalaryProCityEntitys.get(position));
        setResult(RESULTCODE, intent);
        SelectorSalaryCityActivity.this.finish();
    }

    /**
     * staffId 登人工号(工号必填)query 	string
     * shopCityCountryId 门店所属城市区域id(驻店顾问需要次id来确定唯一底薪)query 	integer
     * entryNutrConBrand 入职顾问的品牌query 	string
     * inShopOrFlow 入职顾问是流动还是驻店: 1/驻店，2/流动query 	string
     */
    private void getData() {
        //请求顾问底薪接口
        showDialog();
        Integer entryNutrConBrand = getIntent().getIntExtra("entryNutrConBrand",0);
        String url = NetworkParams.URL_GET_NUTR_CONSULTANT_SALARY + "?staffId=" + userInfo.getStaffId()
                + "&entryNutrConBrand=" + entryNutrConBrand + "&inShopOrFlow=2";
        StaffManageService.getInstance().requestGetNutrConsultantSalary(url, this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.StaffManage.MSG_ON_GET_NUTRCONSULTANT_SALARY) {
                final String msg = result.getInfo();
                if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                    NutrSalaryProCityResultEntity mNutrSalaryProCityResultEntity = new Gson().fromJson(msg, NutrSalaryProCityResultEntity.class);
                    Log.d(TAG, "mNutrSalaryProCityResultEntity=" + mNutrSalaryProCityResultEntity.toString());
                    setData(mNutrSalaryProCityResultEntity);
                } else {
                    showMsg(result.getResultInfo());
                }
            }
        }
    }

    private void setData(NutrSalaryProCityResultEntity mNutrSalaryProCityResultEntity) {
        if (mNutrSalaryProCityResultEntity != null && mNutrSalaryProCityResultEntity.getResultList() != null && !mNutrSalaryProCityResultEntity.getResultList().isEmpty()) {
            nutrSalaryProCityEntitys = mNutrSalaryProCityResultEntity.getResultList();
            mAdapter = new BaseCommonAdapter<NutrSalaryProCityEntity>(this, nutrSalaryProCityEntitys) {
                @Override
                public void convert(ViewHolder helper, NutrSalaryProCityEntity item) {
                    helper.setText(item.getProvinceName() + item.getCityName() + item.getCountyName());
                }
            };
            mListView.setAdapter(mAdapter);
            mListView.setOnItemClickListener(this);
        }
    }
}