package com.wgmf.yxgj.module.business.managestaff.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.global.LocationParams;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.model.ShopDataEntity;
import com.wgmf.yxgj.publics.model.ShopDataListEntity;
import com.wgmf.yxgj.publics.service.PublicService;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;

/**
 * 员工入职：选择所属门店(包含2店3人门店)
 */
@SuppressWarnings("all")
public class SelectorStoreActivity extends SelectorBaseActivity implements SelectorStoreAdapter.DataOnClickListener {
    private SelectorStoreAdapter mAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getShopList();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText("选择门店");
    }

    @Override
    protected void initContent() {
        super.initContent();
        storeNameEt.setVisibility(View.GONE);
    }

    private void getShopList() {
        if (null != userInfo) {
            String code1 = userInfo.getOrganizationCode();
            String url = "";
            if (null != userInfo) {
                showDialog();
                url = NetworkParams.URL_SHOP_GET_NEAREST;
                String keyWords = storeNameEt.getText().toString().trim();
                String orgCode = userInfo.getOrganizationCode();
                String currentPage = "1";
                String pageSize = "10000";
                String lat = LocationParams.Latitude;
                String lng = LocationParams.Longitude;
                // 发送管理门店数据请求
                PublicService.getInstance().requestgetNearestShop(url, keyWords, orgCode, currentPage, pageSize, lng, lat, SelectorStoreActivity.this);
            }
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.Publics.MSG_ON_SHOP_GET_NEAREST) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    ShopDataListEntity mGetNearestShopDataListEntity = new Gson().fromJson(msg, ShopDataListEntity.class);
                    Log.d(TAG, "mGetNearestShopDataListEntity=" + mGetNearestShopDataListEntity.toString());
                    if (!mGetNearestShopDataListEntity.getData().isEmpty()) {
                        listShow.clear();
                        for (ShopDataEntity mGetNearestShopDataEntity : mGetNearestShopDataListEntity.getData()) {
                            BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
                            mBaseSelectorEntity.setSelectorId(mGetNearestShopDataEntity.getStoreId());
                            mBaseSelectorEntity.setSelectorName(mGetNearestShopDataEntity.getStoreName());
                            mBaseSelectorEntity.setAddress(mGetNearestShopDataEntity.getAddress() + "");
                            mBaseSelectorEntity.setDistance(mGetNearestShopDataEntity.getDistance());
                            mBaseSelectorEntity.setLng(mGetNearestShopDataEntity.getLng());
                            mBaseSelectorEntity.setShopCityCountryID(mGetNearestShopDataEntity.getShopCityCountryID());
                            mBaseSelectorEntity.setIsLDSR(mGetNearestShopDataEntity.getIsLDSR());
                            mBaseSelectorEntity.setlDSRCode(mGetNearestShopDataEntity.getlDSRCode());
                            mBaseSelectorEntity.setSelectorCode("");
                            listShow.add(mBaseSelectorEntity);
                        }
                        mAdapter = new SelectorStoreAdapter(this, this);
                        mAdapter.setData(listShow);
                        mListView.setAdapter(mAdapter);
                        mListView.setOnItemClickListener(null);
                        mAdapter.notifyDataSetChanged();
                    }
                }
            }
        }
    }

    @Override
    public void choice(BaseSelectorEntity baseSelectorEntities) {
        Intent intent = new Intent();
        intent.putExtra(STORE_TAG, baseSelectorEntities);
        setResult(RESULTCODE, intent);
        SelectorStoreActivity.this.finish();
    }
}