package com.wgmf.yxgj.module.business.managestaff.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.publics.service.StaffInfoCheck;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;

import java.util.ArrayList;
import java.util.List;

@SuppressWarnings("all")
public class SelectorStoreAdapter extends BaseAdapter {
    private Context context;
    private List<BaseSelectorEntity> baseSelectorEntities = new ArrayList<>();
    private DataOnClickListener mDataOnClickListener;

    public interface DataOnClickListener {
        void choice(BaseSelectorEntity baseSelectorEntities);
    }

    SelectorStoreAdapter(Context context, DataOnClickListener mDataOnClickListener) {
        this.context = context;
        this.mDataOnClickListener = mDataOnClickListener;
    }

    public void setData(List<BaseSelectorEntity> beforeBaseSelectorEntities) {
        //按需求整合数据
        baseSelectorEntities = StaffInfoCheck.initSelectorStoreData(beforeBaseSelectorEntities);
    }

    @Override
    public int getCount() {
        return baseSelectorEntities.isEmpty() ? 0 : baseSelectorEntities.size();
    }

    @Override
    public Object getItem(int position) {
        return baseSelectorEntities.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        convertView = null;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.list_item_store_chioce_view, null);
            viewHolder = new ViewHolder();
            viewHolder.addItemRl = (LinearLayout) convertView.findViewById(R.id.list_item_check_ll);
            viewHolder.name = (TextView) convertView.findViewById(R.id.content_text);
            viewHolder.choice = (TextView) convertView.findViewById(R.id.content_choice);
            viewHolder.code = (TextView) convertView.findViewById(R.id.content_text_code);
            viewHolder.margin = (View) convertView.findViewById(R.id.content_text_margin);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        final BaseSelectorEntity item = baseSelectorEntities.get(position);
        if (item.isChoice()) {
            viewHolder.choice.setBackgroundResource(R.drawable.circle_orange);
        } else {
            viewHolder.choice.setBackgroundResource(R.drawable.circle_gray);
        }
        // 两店三人标识： 0是；1不是
        if (null != item.getIsLDSR() && item.getIsLDSR() == 0) {
            viewHolder.margin.setVisibility(View.VISIBLE);
            viewHolder.code.setVisibility(View.VISIBLE);
        } else {
            viewHolder.margin.setVisibility(View.GONE);
            viewHolder.code.setVisibility(View.GONE);
        }
        viewHolder.name.setText(StaffInfoCheck.getShopName(item.getShopList()));
        viewHolder.addItemRl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                checkStatus(!item.isChoice(), viewHolder, item);
                mDataOnClickListener.choice(item);
            }
        });
        return convertView;
    }

    private void checkStatus(boolean isChecked, ViewHolder holder, BaseSelectorEntity item) {
        if (isChecked) {
            holder.choice.setBackgroundResource(R.drawable.circle_orange);
            item.setChoice(true);
        } else {
            holder.choice.setBackgroundResource(R.drawable.circle_gray);
            item.setChoice(false);
        }
    }

    class ViewHolder {
        View margin;
        TextView name;
        TextView choice;
        TextView code;
        LinearLayout addItemRl;
    }
}