package com.wgmf.yxgj.module.business.managestaff.ui.interview;

import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RatingBar;
import android.widget.Spinner;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.dialog.PublicConformTipDialog;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.graph.DaggerInterviewComponent;
import com.wgmf.yxgj.module.business.managestaff.graph.InterviewModule;
import com.wgmf.yxgj.module.business.managestaff.model.InterviewAssessmentEntity;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.widgets.MMessageDisplay;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;

/**
 * 面试评估
 * 作者：xiep on 2017/10/9 16:58
 * 邮箱：2975837870@qq.com
 */
@Route(path = RouterParams.URL_INTERVIEWASSESSMENTACTIVITY)
public class InterviewAssessmentActivity extends BaseParentAct implements InterviewAssessmentView {
    /**
     * 给Spinner提供的数据源
     */
    private String[] postArray = new String[]{"驻店营养顾问", "流动营养顾问"};
    private String[] offerArray = new String[]{"是", "否"};

    private float[] scoreArray = new float[]{0, 0, 0, 0, 0, 0};

    EditText interviewAssessmentContentNameEt;
    EditText interviewAssessmentContentIdcardEt;
    Spinner interviewAssessmentContentPostSpinner;
    Spinner interviewAssessmentContentOfferSpinner;
    RatingBar interviewAssessmentContentLearnRb;
    RatingBar interviewAssessmentContentConmmunicateRb;
    RatingBar interviewAssessmentContentSaleRb;
    RatingBar interviewAssessmentContentActiveRb;
    RatingBar interviewAssessmentContentCompressionRb;
    RatingBar interviewAssessmentContentAdaptiveRb;

    Button reportContentComfirmBtn;
    LinearLayout reportContentComfirmLl;

    @Inject
    InterviewAssessmentPresenter interviewAssessmentPresenter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.interview_assessment_activity);
        initTitle();
        initContent();
        initInjector();
        initData();
    }

    private void initData() {
        String name = getIntent().getStringExtra("name");
        String idCard = getIntent().getStringExtra("idCard");
        if (StringUtil.isNotNullAndNotEmpty(name)) {
            interviewAssessmentContentNameEt.setText(name);
        }
        if (StringUtil.isNotNullAndNotEmpty(idCard)) {
            interviewAssessmentContentIdcardEt.setText(idCard);
        }
    }

    private void initInjector() {
        DaggerInterviewComponent.builder()
                .interviewModule(new InterviewModule(this))
                .build()
                .inject(this);
    }

    private void initContent() {
        reportContentComfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        reportContentComfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentComfirmLl.setVisibility(View.VISIBLE);
        reportContentComfirmBtn.setText(R.string.submit_btn_txt);
        reportContentComfirmBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                uploadData();
            }
        });

        interviewAssessmentContentNameEt = (EditText) findViewById(R.id.interview_assessment_content_name_et);
        interviewAssessmentContentIdcardEt = (EditText) findViewById(R.id.interview_assessment_content_idcard_et);

        interviewAssessmentContentPostSpinner = (Spinner) findViewById(R.id.interview_assessment_content_post_spinner);
        interviewAssessmentContentOfferSpinner = (Spinner) findViewById(R.id.interview_assessment_content_offer_spinner);
        //Spinner区
        interviewAssessmentContentPostSpinner.setAdapter(setSpinnerData(postArray));
        interviewAssessmentContentOfferSpinner.setAdapter(setSpinnerData(offerArray));

        TextView interviewAssessmentContentDeclare = (TextView) findViewById(R.id.interview_assessment_content_declare);
        interviewAssessmentContentDeclare.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                showDeclareDialog();
            }
        });
        interviewAssessmentContentLearnRb = (RatingBar) findViewById(R.id.interview_assessment_content_learn_rb);
        interviewAssessmentContentConmmunicateRb = (RatingBar) findViewById(R.id.interview_assessment_content_conmmunicate_rb);
        interviewAssessmentContentSaleRb = (RatingBar) findViewById(R.id.interview_assessment_content_sale_rb);
        interviewAssessmentContentActiveRb = (RatingBar) findViewById(R.id.interview_assessment_content_active_rb);
        interviewAssessmentContentCompressionRb = (RatingBar) findViewById(R.id.interview_assessment_content_compression_rb);
        interviewAssessmentContentAdaptiveRb = (RatingBar) findViewById(R.id.interview_assessment_content_adaptive_rb);

        int scroeHeight = getScroeHeight();
        setRatingBar(0, scroeHeight, interviewAssessmentContentLearnRb);
        setRatingBar(1, scroeHeight, interviewAssessmentContentConmmunicateRb);
        setRatingBar(2, scroeHeight, interviewAssessmentContentSaleRb);
        setRatingBar(3, scroeHeight, interviewAssessmentContentActiveRb);
        setRatingBar(4, scroeHeight, interviewAssessmentContentCompressionRb);
        setRatingBar(5, scroeHeight, interviewAssessmentContentAdaptiveRb);
    }

    @SuppressWarnings("all")
    private int getScroeHeight() {
        int scroeHeight = 0;
        try {
            Bitmap bmp = BitmapFactory.decodeResource(this.getResources(), R.drawable.ic_interview_star_1);
            scroeHeight = bmp.getHeight();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return scroeHeight;
    }

    private void setRatingBar(final int positon, int scroeHeight, RatingBar mRatingBar) {
        //在需要的地方设置LayoutParams  记得图片只需要初始化一次就可以了。
        if (scroeHeight != 0) {
            LinearLayout.LayoutParams llp = (LinearLayout.LayoutParams) mRatingBar.getLayoutParams();
            llp.width = -2;// 包裹内容
            llp.height = scroeHeight;
            mRatingBar.setLayoutParams(llp);
        }
        mRatingBar.setOnRatingBarChangeListener(new RatingBar.OnRatingBarChangeListener() {
            @Override
            public void onRatingChanged(RatingBar ratingBar, float rating, boolean fromUser) {
                scoreArray[positon] = (int) rating;
            }
        });
    }

    private void showDeclareDialog() {
        PublicConformTipDialog.Builder builder = new PublicConformTipDialog.Builder(this);
        builder.setTitle(getString(R.string.interview_assessment_content_declare));
        builder.setMessage(getString(R.string.interview_assessment_content_tips));
        builder.setNegativeButton("知道了", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.create().show();
    }

    @NonNull
    private BaseCommonAdapter<BaseSelectorEntity> setSpinnerData(String[] array) {
        List<BaseSelectorEntity> damageGroup = new ArrayList<>();
        for (int i = 0; i < array.length; i++) {
            BaseSelectorEntity baseSelectorEntity = new BaseSelectorEntity();
            baseSelectorEntity.setSelectorName(array[i]);
            baseSelectorEntity.setSelectorId(i + "");
            damageGroup.add(baseSelectorEntity);
        }
        return new BaseCommonAdapter<BaseSelectorEntity>(
                this, damageGroup) {
            @Override
            public void convert(ViewHolder helper, BaseSelectorEntity item) {
                helper.setText(item.getSelectorName());
                helper.setRightGone(View.GONE);
            }
        };
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("人员面试评估");
        homeTitleMore.setText("查询");
        homeTitleMoreLl.setVisibility(View.VISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void more() {
        super.more();
        Intent intent = new Intent();
        intent.setClass(this, InterviewAssessmentQueryActivity.class);
        startActivity(intent);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        interviewAssessmentPresenter.switchService(result);
    }

    private void uploadData() {
        for (float scoreArrayvale : scoreArray) {
            if (scoreArrayvale == 0) {
                showMsg("请将内容填写完整！");
                return;
            }
        }
        if (checkUploadData()) {
            showDialog();
            setUploadData();
        }
    }

    private void setUploadData() {
        InterviewAssessmentEntity mInterviewAssessmentEntity = new InterviewAssessmentEntity();
        mInterviewAssessmentEntity.setAuditionAddPersonId(userInfo.getStaffId());
        mInterviewAssessmentEntity.setAuditionStaffName(interviewAssessmentContentNameEt.getText().toString());
        mInterviewAssessmentEntity.setAuditionStaffIdentityCard(interviewAssessmentContentIdcardEt.getText().toString());
        mInterviewAssessmentEntity.setAuditionPost(interviewAssessmentContentPostSpinner.getSelectedItemPosition() + 1 + "");
        mInterviewAssessmentEntity.setEmployFlag(interviewAssessmentContentOfferSpinner.getSelectedItemPosition() + 1 + "");
        mInterviewAssessmentEntity.setStudyAbilityScore(scoreArray[0]);
        mInterviewAssessmentEntity.setCommunicateAbilityScore(scoreArray[1]);
        mInterviewAssessmentEntity.setSaleAbilityScore(scoreArray[2]);
        mInterviewAssessmentEntity.setPositiveActiveScore(scoreArray[3]);
        mInterviewAssessmentEntity.setPressureAbilityScore(scoreArray[4]);
        mInterviewAssessmentEntity.setDynamicAdaptabilityScore(scoreArray[5]);
        interviewAssessmentPresenter.uploadData(mInterviewAssessmentEntity);
    }

    private boolean checkUploadData() {
        //校验框架
        final AndroidNextInputs inputs = new AndroidNextInputs();
        inputs.add(interviewAssessmentContentNameEt, StaticScheme.Required());
        //身份证校验
        inputs.add(interviewAssessmentContentIdcardEt, StaticScheme.Required(), StaticScheme.ChineseIDCard());

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            showMsg("填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    @Override
    public void showTip(String msg) {
        showMsg(msg);
    }

    @Override
    public void saveIsSuccessed() {
        this.finish();
    }
}