package com.wgmf.yxgj.module.business.managestaff.ui.interview;

import android.support.annotation.NonNull;
import android.util.Log;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.managestaff.model.InterviewAssessmentEntity;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;

/**
 * 作者：xiep on 2017/9/4 17:13
 * 邮箱：2975837870@qq.com
 */

public class InterviewAssessmentPresenter {
    private static final String TAG = "InterviewPresenter";

    private InterviewAssessmentView interviewAssessmentView;

    public InterviewAssessmentPresenter(@NonNull InterviewAssessmentView interviewAssessmentView) {
        this.interviewAssessmentView = interviewAssessmentView;
    }

    void uploadData(InterviewAssessmentEntity mInterviewAssessmentEntity) {
        String content = new Gson().toJson(mInterviewAssessmentEntity);
        Log.d(TAG, content);
        StaffManageService.getInstance().requestSaveStaffAuditionAppraise(content, (BaseParentAct) interviewAssessmentView);
    }

    /**
     * 根据接口返回数据进行服务切换
     *
     * @param result 服务器返回数据
     */
    void switchService(ResultData result) {
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.StaffManage.MSG_ON_SAVE_STAFF_AUDITION_APPRAISE) {
                if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                    interviewAssessmentView.saveIsSuccessed();
                }
                interviewAssessmentView.showTip(result.getResultInfo());
            }
        }
    }
}