package com.wgmf.yxgj.module.business.managestaff.ui.interview;

import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.View;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.model.InterviewAssementList;
import com.wgmf.yxgj.module.business.managestaff.model.InterviewAssessmentEntity;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.wgmf.yxgj.widgets.Dialog.DatePickerYearMonthDialog;
import com.wgmf.yxgj.widgets.TextView.MarqueeTextView;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 面试评估查询
 * 作者：xiep on 2017/10/10 8:51
 * 邮箱：2975837870@qq.com
 */

public class InterviewAssessmentQueryActivity extends BaseParentAct implements View.OnClickListener {

    TextView interviewAssessmentQueryHeaderLeftTv;
    TextView interviewAssessmentQueryHeaderCenterTv;
    TextView interviewAssessmentQueryHeaderRightTv;
    ListView interviewAssessmentQueryContentLv;
    InterviewAssessmentQueryAdapter mInterviewAssessmentQueryAdapter;

    MarqueeTextView visitTime;
    MarqueeTextView visitCusName;
    MarqueeTextView visitCusPosition;
    MarqueeTextView visitSupermarketName;

    String yearMonth;

    List<InterviewAssessmentEntity> mIntermviewAssementEntitys;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.interview_assessment_query_activity);
        initTitle();
        initContent();
        getData(yearMonth);
    }

    private void initContent() {
        yearMonth = DateUtil.format(new Date(), "yyyyMM");

        interviewAssessmentQueryHeaderLeftTv = (TextView) findViewById(R.id.interview_assessment_query_header_left_tv);
        interviewAssessmentQueryHeaderCenterTv = (TextView) findViewById(R.id.interview_assessment_query_header_center_tv);
        interviewAssessmentQueryHeaderRightTv = (TextView) findViewById(R.id.interview_assessment_query_header_right_tv);
        interviewAssessmentQueryHeaderCenterTv.setText(yearMonth);
        interviewAssessmentQueryHeaderLeftTv.setOnClickListener(this);
        interviewAssessmentQueryHeaderCenterTv.setOnClickListener(this);
        interviewAssessmentQueryHeaderRightTv.setOnClickListener(this);

        TextView customerVisitQueryContentEmptyTv = (TextView) findViewById(R.id.interview_assessment_query_content_empty_tv);
        interviewAssessmentQueryContentLv = (ListView) findViewById(R.id.interview_assessment_query_content_lv);
        interviewAssessmentQueryContentLv.setEmptyView(customerVisitQueryContentEmptyTv);

        View headerView = getLayoutInflater().inflate(R.layout.interview_assessment_query_content_list_item, null);
        interviewAssessmentQueryContentLv.addHeaderView(headerView);

        mIntermviewAssementEntitys = new ArrayList<>();
        mInterviewAssessmentQueryAdapter = new InterviewAssessmentQueryAdapter(mIntermviewAssementEntitys, this);
        interviewAssessmentQueryContentLv.setAdapter(mInterviewAssessmentQueryAdapter);

        visitTime = (MarqueeTextView) findViewById(R.id.interview_assessment_query_content_time);
        visitCusName = (MarqueeTextView) findViewById(R.id.interview_assessment_query_content_name);
        visitCusPosition = (MarqueeTextView) findViewById(R.id.interview_assessment_query_content_post);
        visitSupermarketName = (MarqueeTextView) findViewById(R.id.interview_assessment_query_content_offer);
        visitTime.setTextColor(ContextCompat.getColor(this, R.color.secondary_txt_color));
        visitCusName.setTextColor(ContextCompat.getColor(this, R.color.secondary_txt_color));
        visitCusPosition.setTextColor(ContextCompat.getColor(this, R.color.secondary_txt_color));
        visitSupermarketName.setTextColor(ContextCompat.getColor(this, R.color.secondary_txt_color));
    }

    private void getData(String yearMonth) {
        if (null != userInfo) {
            mIntermviewAssementEntitys.clear();
            mInterviewAssessmentQueryAdapter.notifyDataSetChanged();
            showDialog();
            String staffId = userInfo.getStaffId();
            StaffManageService.getInstance().requestFindStaffAuditionAppraiseList(staffId, yearMonth, this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("人员面试记录");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.StaffManage.MSG_ON_FIND_STAFF_AUDITION_APPRAISELIST) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    InterviewAssementList mIntermviewAssementList = new Gson().fromJson(msg, InterviewAssementList.class);
                    Log.d(TAG, "mIntermviewAssementList=" + mIntermviewAssementList.toString());
                    if (!mIntermviewAssementList.getResultList().isEmpty()) {
                        mIntermviewAssementEntitys = mIntermviewAssementList.getResultList();
                        mInterviewAssessmentQueryAdapter = new InterviewAssessmentQueryAdapter(mIntermviewAssementEntitys, this);
                        interviewAssessmentQueryContentLv.setAdapter(mInterviewAssessmentQueryAdapter);
                        ListViewUtil.setListViewHeight(interviewAssessmentQueryContentLv);
                    }
                }
            }
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.interview_assessment_query_header_left_tv) {//上一月
            int year = Integer.parseInt(yearMonth.substring(0, 4));
            int monthOfYear = Integer.parseInt(yearMonth.substring(4, 6));
            queryDataByMonth(year, monthOfYear, -1);
        } else if (v.getId() == R.id.interview_assessment_query_header_right_tv) {//下一月
            int year = Integer.parseInt(yearMonth.substring(0, 4));
            int monthOfYear = Integer.parseInt(yearMonth.substring(4, 6));
            queryDataByMonth(year, monthOfYear, +1);
        } else if (v.getId() == R.id.interview_assessment_query_header_center_tv) {
            new DatePickerYearMonthDialog(this, new DatePickerYearMonthDialog.OnDateSetListener() {
                @Override
                public void onDateSet(int year, int monthOfYear) {
                    queryDataByMonth(year, monthOfYear, +1);
                }
            }).show();
        }
    }

    private void queryDataByMonth(int year, int monthOfYear, int diff) {
        yearMonth = String.valueOf(year) + String.valueOf(monthOfYear + diff);
        Date yearMonthNow = DateUtil.string2Date(yearMonth, "yyyyM");
        yearMonth = DateUtil.format(yearMonthNow, "yyyyMM");
        interviewAssessmentQueryHeaderCenterTv.setText(yearMonth);
        getData(yearMonth);
    }
}