package com.wgmf.yxgj.module.business.managestaff.ui.interview;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.RatingBar;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.model.InterviewAssessmentEntity;
import com.wgmf.yxgj.widgets.TextView.MarqueeTextView;

import java.util.List;

/**
 * 作者：xiep on 2017/10/10 8:51
 * 邮箱：2975837870@qq.com
 */

class InterviewAssessmentQueryAdapter extends BaseAdapter {

    private Context context;
    private List<InterviewAssessmentEntity> mInterviewAssessmentEntity;
    private int scroeHeight;

    InterviewAssessmentQueryAdapter(List<InterviewAssessmentEntity> mlist, Context context) {
        this.mInterviewAssessmentEntity = mlist;
        this.context = context;
        scroeHeight = getScroeHeight();
    }

    @Override
    public int getCount() {
        return mInterviewAssessmentEntity == null ? 0 : mInterviewAssessmentEntity.size();
    }

    @Override
    public Object getItem(int position) {
        return mInterviewAssessmentEntity == null ? null : mInterviewAssessmentEntity.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.interview_assessment_query_content_list_item, null);
            viewHolder = new ViewHolder();
            viewHolder.parentLl = (LinearLayout) convertView.findViewById(R.id.interview_assessment_query_parent_ll);
            viewHolder.childrenLl = (LinearLayout) convertView.findViewById(R.id.interview_assessment_query_children_ll);
            viewHolder.rowTv = (TextView) convertView.findViewById(R.id.interview_assessment_query_content_row_tv);
            viewHolder.time = (MarqueeTextView) convertView.findViewById(R.id.interview_assessment_query_content_time);
            viewHolder.name = (MarqueeTextView) convertView.findViewById(R.id.interview_assessment_query_content_name);
            viewHolder.post = (MarqueeTextView) convertView.findViewById(R.id.interview_assessment_query_content_post);
            viewHolder.offer = (MarqueeTextView) convertView.findViewById(R.id.interview_assessment_query_content_offer);

            viewHolder.interviewAssessmentContentLearnQueryRb = (RatingBar) convertView.findViewById(R.id.interview_assessment_content_learn_query_rb);
            viewHolder.interviewAssessmentContentConmmunicateQueryRb = (RatingBar) convertView.findViewById(R.id.interview_assessment_content_conmmunicate_query_rb);
            viewHolder.interviewAssessmentContentSaleQueryRb = (RatingBar) convertView.findViewById(R.id.interview_assessment_content_sale_query_rb);
            viewHolder.interviewAssessmentContentActiveQueryRb = (RatingBar) convertView.findViewById(R.id.interview_assessment_content_active_query_rb);
            viewHolder.interviewAssessmentContentCompressionQueryRb = (RatingBar) convertView.findViewById(R.id.interview_assessment_content_compression_query_rb);
            viewHolder.interviewAssessmentContentAdaptiveQueryRb = (RatingBar) convertView.findViewById(R.id.interview_assessment_content_adaptive_query_rb);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        final InterviewAssessmentEntity ent = mInterviewAssessmentEntity.get(position);
        viewHolder.time.setText(ent.getAddYearMonth());
        viewHolder.name.setText(ent.getAuditionStaffName());
        //面试岗位：‘1’ 驻店营养顾问；‘2’ 流动营养顾问 ,
        if ("1".equals(ent.getAuditionPost())) {
            viewHolder.post.setText("驻店营养顾问");
        } else {
            viewHolder.post.setText("流动营养顾问");
        }
        //录用标识：‘1’ 录用；‘2’ 不录用 ,
        if ("1".equals(ent.getEmployFlag())) {
            viewHolder.offer.setText("录用");
        } else {
            viewHolder.offer.setText("不录用");
        }

        viewHolder.rowTv.setVisibility(View.VISIBLE);
        viewHolder.parentLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!ent.isOpen()) {
                    viewHolder.childrenLl.setVisibility(View.VISIBLE);
                } else {
                    viewHolder.childrenLl.setVisibility(View.GONE);
                }
                ent.setOpen(!ent.isOpen());
            }
        });
        viewHolder.interviewAssessmentContentLearnQueryRb.setRating(ent.getStudyAbilityScore());
        viewHolder.interviewAssessmentContentConmmunicateQueryRb.setRating(ent.getCommunicateAbilityScore());
        viewHolder.interviewAssessmentContentSaleQueryRb.setRating(ent.getSaleAbilityScore());
        viewHolder.interviewAssessmentContentActiveQueryRb.setRating(ent.getPositiveActiveScore());
        viewHolder.interviewAssessmentContentCompressionQueryRb.setRating(ent.getPressureAbilityScore());
        viewHolder.interviewAssessmentContentAdaptiveQueryRb.setRating(ent.getDynamicAdaptabilityScore());
        setRatingBar(scroeHeight, viewHolder.interviewAssessmentContentLearnQueryRb);
        setRatingBar(scroeHeight, viewHolder.interviewAssessmentContentConmmunicateQueryRb);
        setRatingBar(scroeHeight, viewHolder.interviewAssessmentContentSaleQueryRb);
        setRatingBar(scroeHeight, viewHolder.interviewAssessmentContentActiveQueryRb);
        setRatingBar(scroeHeight, viewHolder.interviewAssessmentContentCompressionQueryRb);
        setRatingBar(scroeHeight, viewHolder.interviewAssessmentContentAdaptiveQueryRb);
        return convertView;
    }

    @SuppressWarnings("all")
    private int getScroeHeight() {
        int scroe = 0;
        try {
            Bitmap bmp = BitmapFactory.decodeResource(context.getResources(), R.drawable.ic_interview_star_1);
            scroe = bmp.getHeight();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return scroe;
    }

    private void setRatingBar(int scroeHeight, RatingBar mRatingBar) {
        //在需要的地方设置LayoutParams  记得图片只需要初始化一次就可以了。
        if (scroeHeight != 0) {
            LinearLayout.LayoutParams llp = (LinearLayout.LayoutParams) mRatingBar.getLayoutParams();
            llp.width = -2;// 包裹内容
            llp.height = scroeHeight;
            mRatingBar.setLayoutParams(llp);
        }
    }

    class ViewHolder {
        TextView rowTv;
        LinearLayout parentLl;
        LinearLayout childrenLl;
        MarqueeTextView time;
        MarqueeTextView name;
        MarqueeTextView post;
        MarqueeTextView offer;

        RatingBar interviewAssessmentContentLearnQueryRb;
        RatingBar interviewAssessmentContentConmmunicateQueryRb;
        RatingBar interviewAssessmentContentSaleQueryRb;
        RatingBar interviewAssessmentContentActiveQueryRb;
        RatingBar interviewAssessmentContentCompressionQueryRb;
        RatingBar interviewAssessmentContentAdaptiveQueryRb;
    }
}