package com.wgmf.yxgj.module.business.managestaff.ui.scheduling;

import android.content.Intent;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.managestaff.model.CurrentDayNutConScheduling;
import com.wgmf.yxgj.module.business.managestaff.model.CurrentDayNutConSchedulingList;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.xp.arouter.RouterParams;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.util.ArrayList;
import java.util.List;

/**
 * 作者：xiep on 2017/7/21 13:11
 * 邮箱：2975837870@qq.com
 */
@Route(path = RouterParams.URL_NUTCONSULTANT_SCHEDULING_ACTIVITY)
public class SchedulingNutConsultantActivity extends SelectorBaseActivity {
    List<CurrentDayNutConScheduling> mCurrentDayNutConSchedulingList;
    SchedulingNutConsultantListAdapter mNutConsultantSchedulingListAdapter;

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("流动营养顾问排班");
    }

    @Override
    protected void initContent() {
        super.initContent();
        EventBus.getDefault().register(this);
        storeNameEt.setVisibility(View.GONE);
        mCurrentDayNutConSchedulingList = new ArrayList<>();
        mNutConsultantSchedulingListAdapter = new SchedulingNutConsultantListAdapter(mCurrentDayNutConSchedulingList, this);
        mListView.setAdapter(mNutConsultantSchedulingListAdapter);
        mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Intent intent = new Intent();
                intent.putExtra("staffName", mCurrentDayNutConSchedulingList.get(position).getUserInfo().getName());
                intent.putExtra("staffId", mCurrentDayNutConSchedulingList.get(position).getUserInfo().getStaffId());
                intent.setClass(SchedulingNutConsultantActivity.this, SchedulingThreeAndCurrentDayActivity.class);
                startActivity(intent);
            }
        });
    }

    @Override
    protected void onResume() {
        super.onResume();
        getData();
    }

    /**
     * GET /nutritionConsultant/findNutConsultantScheduling 流动营养顾问排班查询
     */
    private void getData() {
        if (null != userInfo) {
            showDialog();
            String orgId = userInfo.getOrganizationId();
            String orgCode1 = userInfo.getOrganizationCode();
            StaffManageService.getInstance().requestFindNutConsultantScheduling(orgId, orgCode1, SchedulingNutConsultantActivity.this);
        }
    }

    @Subscribe
    public void onEventMainThread(CurrentDayNutConSchedulingList item) {
        if (item != null && !item.getResultList().isEmpty()) {
            mCurrentDayNutConSchedulingList = item.getResultList();
            mNutConsultantSchedulingListAdapter = new SchedulingNutConsultantListAdapter(mCurrentDayNutConSchedulingList, this);
            mListView.setAdapter(mNutConsultantSchedulingListAdapter);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.StaffManage.MSG_ON_FIND_NUTCONSULTANT_SCHEDULING) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    CurrentDayNutConSchedulingList mCurrentDayNutConSchedulingLists = new Gson().fromJson(msg, CurrentDayNutConSchedulingList.class);
                    Log.d(TAG, "mCurrentDayNutConSchedulingLists=" + mCurrentDayNutConSchedulingLists.toString());
                    if (ConstantParams.CONSTANT_PARAMS_0.equals(mCurrentDayNutConSchedulingLists.retCode)) {
                        if (!mCurrentDayNutConSchedulingLists.getResultList().isEmpty()) {
                            EventBus.getDefault().post(mCurrentDayNutConSchedulingLists);
                        }
                    } else {
                        showMsg(mCurrentDayNutConSchedulingLists.retInfo);
                    }
                } else {
                    showMsg(result.getResultInfo());
                }
            }
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }
}
