package com.wgmf.yxgj.module.business.managestaff.ui.scheduling;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.model.CurrentDayNutConScheduling;

import java.util.List;

/**
 * 作者：xiep on 2017/7/21 13:49
 * 邮箱：2975837870@qq.com
 */

class SchedulingNutConsultantListAdapter extends BaseAdapter {

    private List<CurrentDayNutConScheduling> list;
    private Context context;

    SchedulingNutConsultantListAdapter(List<CurrentDayNutConScheduling> mlist, Context context) {
        this.list = mlist;
        this.context = context;
    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.nutconsultant_scheduling_list_item, null);
            viewHolder = new ViewHolder();
            viewHolder.nutconsultantSchedulingName = (TextView) convertView.findViewById(R.id.nutconsultant_scheduling_name);
            viewHolder.todaySchedulingFlag = (TextView) convertView.findViewById(R.id.today_scheduling_flag);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        CurrentDayNutConScheduling ent = list.get(position);
        viewHolder.nutconsultantSchedulingName.setText(ent.getUserInfo().getName());
        if("noScheduling".equals(ent.getToDaySchedulingFlag())){
            viewHolder.todaySchedulingFlag.setText("今日未排班");
            viewHolder.todaySchedulingFlag.setTextColor(ContextCompat.getColor(context,R.color.assist_red_txt));
        }else{
            viewHolder.todaySchedulingFlag.setText("今日已排班");
        }
        return convertView;
    }

    class ViewHolder {
        TextView nutconsultantSchedulingName;
        TextView todaySchedulingFlag;
    }
}
