package com.wgmf.yxgj.module.business.managestaff.ui.scheduling;

import android.content.Intent;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.model.NutConsultantScheduling;
import com.wgmf.yxgj.module.business.managestaff.model.NutConsultantSchedulingList;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.List;

/**
 * 作者：xiep on 2017/7/21 13:11
 * 邮箱：2975837870@qq.com
 */
@Route(path = RouterParams.URL_NUTCONSULTANT_SCHEDULING_ACTIVITY)
public class SchedulingThreeAndCurrentDayActivity extends BaseParentAct implements View.OnClickListener {
    ListView nutconsultantSchedulingLv;
    SchedulingThreeAndCurrentDayAdapter mSchedulingThreeAndCurrentDayAdapter;

    TextView nutconsultantSchedulingSchedulingdayValue;
    TextView nutconsultantSchedulingSchedulingshopnameValue;
    TextView nutconsultantSchedulingPersonalsaletargetValue;
    TextView nutconsultantSchedulingWorkshiftValue;

    TextView nutconsultantSchedulingTodayEmptyTv;
    TextView nutconsultantSchedulingEmptyTv1;
    LinearLayout nutconsultantSchedulingTodayTv;

    Button comfirmBtn;

    String staffId;
    String staffName;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.nutconsultant_scheduling_activity);
        initTitle();
        initContent();
    }

    @Override
    protected void onResume() {
        super.onResume();
        getData();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        staffId = getIntent().getStringExtra("staffId");
        staffName = getIntent().getStringExtra("staffName");
        homeTitleText.setText(staffName);
    }

    protected void initContent() {
        nutconsultantSchedulingTodayTv = (LinearLayout) findViewById(R.id.nutconsultant_scheduling_today_tv);
        nutconsultantSchedulingTodayTv.setVisibility(View.GONE);
        nutconsultantSchedulingTodayEmptyTv = (TextView) findViewById(R.id.nutconsultant_scheduling_today_empty_tv);
        nutconsultantSchedulingSchedulingdayValue = (TextView) findViewById(R.id.nutconsultant_scheduling_schedulingday_value);
        nutconsultantSchedulingSchedulingshopnameValue = (TextView) findViewById(R.id.nutconsultant_scheduling_schedulingshopname_value);
        nutconsultantSchedulingPersonalsaletargetValue = (TextView) findViewById(R.id.nutconsultant_scheduling_personalsaletarget_value);
        nutconsultantSchedulingWorkshiftValue = (TextView) findViewById(R.id.nutconsultant_scheduling_workshift_value);
        TextView nutconsultantSchedulingHeaderTv = (TextView) findViewById(R.id.nutconsultant_scheduling_header_tv);
        nutconsultantSchedulingHeaderTv.setText("今日排班");


        nutconsultantSchedulingEmptyTv1 = (TextView) findViewById(R.id.nutconsultant_scheduling_empty_tv1);
        TextView nutconsultantSchedulingHeaderTv1 = (TextView) findViewById(R.id.nutconsultant_scheduling_header_tv1);
        nutconsultantSchedulingHeaderTv1.setText("未来3天排班");

        LinearLayout comfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        comfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        comfirmBtn.setBackgroundResource(R.drawable.selector_orange_stroke_round_btn);
        comfirmBtn.setTextColor(ContextCompat.getColor(this, R.color.normal_color));
        comfirmLl.setVisibility(View.VISIBLE);
        comfirmBtn.setOnClickListener(this);
        comfirmBtn.setText("排班设置");

        List<NutConsultantScheduling> mNutConsultantSchedulingList = new ArrayList<>();
        mSchedulingThreeAndCurrentDayAdapter = new SchedulingThreeAndCurrentDayAdapter(mNutConsultantSchedulingList, this);
        nutconsultantSchedulingLv = (ListView) findViewById(R.id.nutconsultant_scheduling_lv);
        nutconsultantSchedulingLv.setAdapter(mSchedulingThreeAndCurrentDayAdapter);
        nutconsultantSchedulingLv.setDividerHeight(0);
        nutconsultantSchedulingLv.setOnItemClickListener(null);
    }


    /**
     * GET /nutritionConsultant/findNutConsultantScheduling 流动营养顾问排班查询
     */
    private void getData() {
        showDialog();
        StaffManageService.getInstance().requestFindThreeAndCurrentDayScheduling(staffId, SchedulingThreeAndCurrentDayActivity.this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.StaffManage.MSG_ON_FIND_THREEANDCURRENTDAY_SCHEDULING) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    NutConsultantSchedulingList mNutConsultantSchedulingLists = new Gson().fromJson(msg, NutConsultantSchedulingList.class);
                    Log.d(TAG, "mNutConsultantSchedulingLists=" + mNutConsultantSchedulingLists.toString());
                    if (ConstantParams.CONSTANT_PARAMS_0.equals(mNutConsultantSchedulingLists.retCode)) {
                        if (!mNutConsultantSchedulingLists.getResultList().isEmpty()) {
                            List<NutConsultantScheduling> mNutConsultantSchedulingList = mNutConsultantSchedulingLists.getResultList();
                            setData(mNutConsultantSchedulingList);
                        }
                    } else {
                        showMsg(mNutConsultantSchedulingLists.retInfo);
                    }
                } else {
                    showMsg(result.getResultInfo());
                }
            }
        }

    }

    private void setData(List<NutConsultantScheduling> mNutConsultantSchedulingLists) {
        List<NutConsultantScheduling> mNewNutConsultantSchedulingLists = new ArrayList<>();
        for (NutConsultantScheduling mNutConsultantSchedulingList : mNutConsultantSchedulingLists) {
            if (mNutConsultantSchedulingList.getSchedulingDay().equals(DateUtil.getFormatCurrentDate("yyyy-MM-dd"))) {//今天
                nutconsultantSchedulingTodayTv.setVisibility(View.VISIBLE);
                nutconsultantSchedulingTodayEmptyTv.setVisibility(View.GONE);
                nutconsultantSchedulingSchedulingdayValue.setText(mNutConsultantSchedulingList.getSchedulingDay());
                nutconsultantSchedulingSchedulingshopnameValue.setText(mNutConsultantSchedulingList.getSchedulingShopName());
                nutconsultantSchedulingPersonalsaletargetValue.setText("￥" + mNutConsultantSchedulingList.getPersonalSaleTarget() + "");
                nutconsultantSchedulingWorkshiftValue.setText(mNutConsultantSchedulingList.getWorkShift());
            } else {
                mNewNutConsultantSchedulingLists.add(mNutConsultantSchedulingList);
            }
        }
        if (!mNewNutConsultantSchedulingLists.isEmpty()) {
            nutconsultantSchedulingLv.setVisibility(View.VISIBLE);
            nutconsultantSchedulingEmptyTv1.setVisibility(View.GONE);
            mSchedulingThreeAndCurrentDayAdapter = new SchedulingThreeAndCurrentDayAdapter(mNewNutConsultantSchedulingLists, this);
            nutconsultantSchedulingLv.setAdapter(mSchedulingThreeAndCurrentDayAdapter);
            ListViewUtil.setListViewHeight(nutconsultantSchedulingLv);
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.report_content_confirm_btn) {
            Intent intent = new Intent();
            intent.setClass(this, SchedulingOneMonthActivity.class);
            intent.putExtra("staffName", staffName);
            intent.putExtra("staffId", staffId);
            startActivity(intent);
        }
    }
}
