package com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute

import android.os.Bundle
import android.support.design.widget.TabLayout
import android.support.v4.app.Fragment
import android.support.v4.content.ContextCompat
import android.support.v4.view.ViewPager
import android.view.Gravity
import android.view.View
import com.alibaba.android.arouter.facade.annotation.Route
import com.wgmf.library.base.ResultData
import com.wgmf.yxgj.base.BaseParentAct
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.business.managestaff.R
import com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.adapter.ResignOrWorkingTabLayoutViewPagerAdapter
import com.xp.arouter.RouterParams

/**
 * 离职审核/在职分配审核/离职分配审核
 * @author LW
 */
@Route(path = RouterParams.URL_RESIGNORWORKINGASSIGNMENTREVIEWACTIVITY)
class ResignOrWorkingAssignmentReviewActivity : BaseParentAct(), ViewPager.OnPageChangeListener {

    private var mViewPagerAdapter: ResignOrWorkingTabLayoutViewPagerAdapter? = null

    private var mResignOrWorkingTabLayout: TabLayout? = null
    private var mResignOrWorkingViewpager: ViewPager? = null

    /**
     * TabLayout中的tab标题
     */
    private val mTitles: MutableList<String> = mutableListOf()

    /**
     * 填充到ViewPager中的Fragment
     */
    private val mFragmentLists: MutableList<Fragment> = mutableListOf()

    /**
     * tablayout选择角标
     */
    private var mTabSelectPostion = 0

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_resign_or_working_assignment_review)
        initTitle()
        initView()
    }

    override fun initTitle() {
        super.initTitle()
        homeTitleText.text = intent.getStringExtra("branchTitle")
        homeTitleBackLl.visibility = View.VISIBLE
    }

    private fun initView() {
        mResignOrWorkingTabLayout = findViewById(R.id.resign_or_working_tab_layout)
        mResignOrWorkingViewpager = findViewById(R.id.resign_or_working_viewpager)

        mTitles.add(getString(R.string.qiwei_customers_assignment_review_resign_review, 0))
        mTitles.add(getString(R.string.qiwei_customers_assignment_review_working_assignment, 0))
        mTitles.add(getString(R.string.qiwei_customers_assignment_review_resign_assignment, 0))

        val resignReviewFragment = ResignReviewFragment()
        mFragmentLists.add(0, resignReviewFragment)
        val workingAssignmentReviewFragment = ResignOrWorkingAssignmentReviewFragment()
        workingAssignmentReviewFragment.arguments =
            Bundle().apply {
                putInt(
                    AppConstants.ExtraKeys.RESIGN_OR_WORKING_STAFF_STATUS,
                    ConstantParams.CONSTANT_STARTS_0
                )
            }
        mFragmentLists.add(1, workingAssignmentReviewFragment)
        val resignAssignmentReviewFragment = ResignOrWorkingAssignmentReviewFragment()
        resignAssignmentReviewFragment.arguments =
            Bundle().apply {
                putInt(
                    AppConstants.ExtraKeys.RESIGN_OR_WORKING_STAFF_STATUS,
                    ConstantParams.CONSTANT_STARTS_1
                )
            }
        mFragmentLists.add(2, resignAssignmentReviewFragment)

        // 初始化ViewPager的适配器，并设置给它
        mViewPagerAdapter = ResignOrWorkingTabLayoutViewPagerAdapter(
            supportFragmentManager, mTitles, mFragmentLists
        )
        if (mViewPagerAdapter != null) {
            mResignOrWorkingViewpager?.adapter = mViewPagerAdapter
            // 设置ViewPager最大缓存的页面个数
            mResignOrWorkingViewpager?.offscreenPageLimit = 3
            // 给ViewPager添加页面动态监听器（为了让Toolbar中的Title可以变化相应的Tab的标题）
            mResignOrWorkingViewpager?.addOnPageChangeListener(this@ResignOrWorkingAssignmentReviewActivity)
//            mResignOrWorkingTabLayout?.tabMode = TabLayout.MODE_FIXED
//            mResignOrWorkingTabLayout?.tabGravity = Gravity.FILL
            // 设置TabLayout的指示器高度为0，即达到了隐藏Indicator的目的
            //mResignOrWorkingTabLayout?.setSelectedTabIndicatorHeight(0)
            mResignOrWorkingTabLayout?.setBackgroundColor(
                ContextCompat.getColor(
                    mContext,
                    R.color.normal_bg
                )
            )
            // 将TabLayout和ViewPager进行关联，让两者联动起来
            mResignOrWorkingTabLayout?.setupWithViewPager(mResignOrWorkingViewpager)
            // 设置Tablayout的Tab显示ViewPager的适配器中的getPageTitle函数获取到的标题
            mResignOrWorkingTabLayout?.setTabsFromPagerAdapter(mViewPagerAdapter)
        }
    }

    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)
    }

    /**
     * 修改TabLayout标题
     */
    fun updateTitle(pos: Int, num: Int) {
        when (pos) {
            ConstantParams.CONSTANT_STARTS_0 -> {
                mTitles.set(
                    pos,
                    getString(R.string.qiwei_customers_assignment_review_resign_review, num)
                )
            }
            ConstantParams.CONSTANT_STARTS_1 -> {
                mTitles.set(
                    pos,
                    getString(R.string.qiwei_customers_assignment_review_working_assignment, num)
                )
            }
            ConstantParams.CONSTANT_STARTS_2 -> {
                mTitles.set(
                    pos,
                    getString(R.string.qiwei_customers_assignment_review_resign_assignment, num)
                )
            }
        }
        mResignOrWorkingTabLayout?.getTabAt(pos)?.text = mTitles[pos]
    }

    override fun onPageSelected(position: Int) {
        this.mTabSelectPostion = position
        if (mTitles.isNotEmpty()) {
            mResignOrWorkingTabLayout?.newTab()?.text = mTitles[position]
        }
    }

    override fun onPageScrolled(
        position: Int,
        positionOffset: Float,
        positionOffsetPixels: Int
    ) {
    }

    override fun onPageScrollStateChanged(state: Int) {}
}