package com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.adapter

import android.view.View
import android.widget.TextView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.library.utils.ImageUtils
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.business.managestaff.R
import com.wgmf.yxgj.module.business.managestaff.model.QiWeiCustomersAssignmentRecordsEntity
import com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.working.QiWeiCustomersAssignmentInfoActivity
import com.wgmf.yxgj.utils.convertDefaultValue
import com.wgmf.yxgj.utils.notNullAndEmpty

/**
 * 分配记录
 * @author LW
 */
class QiWeiCustomersAssignmentInfoListAdapter(
    entity: List<QiWeiCustomersAssignmentRecordsEntity.QiWeiCustomersAssignmentRecordsPage.QiWeiCustomersAssignmentRecordsBean.AllocationCustomerBean>,
    val mQiWeiCustomersAssignmentInfoType: Int
) : BaseQuickAdapter<QiWeiCustomersAssignmentRecordsEntity.QiWeiCustomersAssignmentRecordsPage
.QiWeiCustomersAssignmentRecordsBean.AllocationCustomerBean, BaseViewHolder>(
    R.layout.item_qiwei_customers_assignment_info_view,
    entity
) {

    override fun convert(
        helper: BaseViewHolder?,
        item: QiWeiCustomersAssignmentRecordsEntity.QiWeiCustomersAssignmentRecordsPage
        .QiWeiCustomersAssignmentRecordsBean.AllocationCustomerBean?
    ) {
        helper?.apply {
            item?.let {
                ImageUtils.loadCircleImage(
                    mContext,
                    it.headImgUrl,
                    getView(R.id.customers_assignment_item_avatar_iv),
                    R.drawable.icon_avatar_circle,
                    R.drawable.icon_avatar_circle
                )
                setText(
                    R.id.customers_assignment_item_title_tv,
                    it.nickname.convertDefaultValue()

                )
                getView<TextView>(R.id.customers_assignment_item_tag_info_tv).visibility =
                    View.GONE
                if (mQiWeiCustomersAssignmentInfoType != QiWeiCustomersAssignmentInfoActivity.WORKING_ASSIGNMENT_REVIEW_CONFIRM) {
                    val statusId = when (it.status) {   //1-确认中,2-已分配,3-已拒绝,4-待审核,5-分配失败
                        ConstantParams.CONSTANT_STARTS_1 -> R.string.qiwei_customers_assignment_info_confirming
                        ConstantParams.CONSTANT_STARTS_2 -> R.string.qiwei_customers_assignment_info_assigned
                        ConstantParams.CONSTANT_STARTS_3 -> R.string.qiwei_customers_assignment_info_rejected
                        ConstantParams.CONSTANT_STARTS_4 -> R.string.qiwei_customers_assignment_info_reviewed
                        ConstantParams.CONSTANT_STARTS_5 -> {
                            if (it.allocationMsg.notNullAndEmpty()) {
                                getView<TextView>(R.id.customers_assignment_item_tag_info_tv).apply {
                                    visibility = View.VISIBLE
                                    text = mContext.getString(
                                        R.string.qiwei_customers_assignment_info_reason,
                                        it.allocationMsg
                                    )
                                }
                            }
                            R.string.qiwei_customers_assignment_info_allocation_failed
                        }
                        else -> -1
                    }
                    if (statusId > 0) {
                        setText(
                            R.id.customers_assignment_item_tag_tv,
                            mContext.getString(statusId)
                        )
                        getView<TextView>(R.id.customers_assignment_item_tag_tv).visibility =
                            View.VISIBLE
                    }
                } else {
                    getView<TextView>(R.id.customers_assignment_item_tag_tv).visibility = View.GONE
                }
            }
        }
    }
}