package com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.adapter

import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.yxgj.module.business.managestaff.R
import com.wgmf.yxgj.module.business.managestaff.model.QiWeiCustomersAssignmentEntity
import com.wgmf.yxgj.utils.convertDefaultValue

/**
 * 离职分配审核
 * @author LW
 */
class QiWeiCustomersAssignmentListAdapter(
    entity: List<QiWeiCustomersAssignmentEntity.QiWeiCustomersAssignmentPage.QiWeiCustomersAssignmentBean>
) : BaseQuickAdapter<QiWeiCustomersAssignmentEntity.QiWeiCustomersAssignmentPage.QiWeiCustomersAssignmentBean, BaseViewHolder>(
    R.layout.item_qiwei_customers_assignment_view,
    entity
) {

    override fun convert(
        helper: BaseViewHolder?,
        item: QiWeiCustomersAssignmentEntity.QiWeiCustomersAssignmentPage.QiWeiCustomersAssignmentBean?
    ) {
        helper?.apply {
            item?.let {
                setText(
                    R.id.customers_assignment_item_name_staffId_tv,
                    mContext.getString(
                        R.string.qiwei_customers_assignment_name_staffId,
                        it.staffName.convertDefaultValue(), it.staffId.convertDefaultValue()
                    )
                )

                setText(
                    R.id.customers_assignment_item_qiwei_friends_num_tv,
                    mContext.getString(
                        R.string.qiwei_customers_assignment_qiwei_friends_num,
                        it.customerNum.toString().convertDefaultValue()
                    )
                )
            }
        }
    }
}