package com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.adapter

import android.support.v4.content.ContextCompat
import android.view.View
import android.widget.RelativeLayout
import android.widget.TextView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.business.managestaff.R
import com.wgmf.yxgj.module.business.managestaff.model.EmployeeDissmissInfoEntity
import com.wgmf.yxgj.utils.convertDefaultValue

/**
 * 离职分配记录适配器
 * @author LW
 */
class ResignAssignmentRecordsListAdapter(
    entity: List<EmployeeDissmissInfoEntity.EmployeeDissmissPage.EmployeeDissmissBean>
) : BaseQuickAdapter<EmployeeDissmissInfoEntity.EmployeeDissmissPage.EmployeeDissmissBean, BaseViewHolder>(
    R.layout.item_resign_records_view,
    entity
) {

    override fun convert(
        helper: BaseViewHolder?,
        item: EmployeeDissmissInfoEntity.EmployeeDissmissPage.EmployeeDissmissBean?
    ) {
        helper?.apply {
            item?.let {
                setText(
                    R.id.resign_records_item_create_time_tv, it.createTime
                )
                if (it.auditStatus == ConstantParams.CONSTANT_STARTS_1) {  //1-待审核,2-审核通过,3-审核驳回
                    setText(
                        R.id.resign_records_item_status_tv,
                        R.string.resign_records_treat_review
                    )
                    setTextColor(
                        R.id.resign_records_item_status_tv,
                        ContextCompat.getColor(mContext, R.color.important_txt_four_color)
                    )
                    getView<RelativeLayout>(R.id.resign_records_item_bottom_rl).visibility =
                        View.GONE
                } else if (it.auditStatus == ConstantParams.CONSTANT_STARTS_2) {
                    setText(
                        R.id.resign_records_item_status_tv,
                        R.string.resign_records_review_pass
                    )
                    setTextColor(
                        R.id.resign_records_item_status_tv,
                        ContextCompat.getColor(mContext, R.color.important_txt_second_color)
                    )
//                            && DateUtil.daysBetween(
//                        DateUtil.String2Date(it.auditTime, DateUtil.FORMATDEFAULT)
//                    ) <= 7 && it.receiverName.isNullOrEmpty()
                    if (it.allocationType == ConstantParams.CONSTANT_STARTS_3) {
                        getView<RelativeLayout>(R.id.resign_records_item_bottom_rl).visibility =
                            View.VISIBLE
                        getView<TextView>(R.id.resign_records_item_status_info_tv).visibility =
                            View.GONE
                        getView<TextView>(R.id.resign_records_item_jump_target_tv).visibility =
                            View.VISIBLE
                        setText(
                            R.id.resign_records_item_jump_target_tv,
                            R.string.resign_records_designate_assignee
                        )
                        //指定分配人员
                        addOnClickListener(R.id.resign_records_item_jump_target_tv)
                    } else {
                        getView<RelativeLayout>(R.id.resign_records_item_bottom_rl).visibility =
                            View.GONE
                    }

                } else if (it.auditStatus == ConstantParams.CONSTANT_STARTS_3) {
                    setText(
                        R.id.resign_records_item_status_tv,
                        R.string.resign_records_turn_down_apply
                    )
                    setTextColor(
                        R.id.resign_records_item_status_tv,
                        ContextCompat.getColor(mContext, R.color.important_txt_five_color)
                    )

                    getView<RelativeLayout>(R.id.resign_records_item_bottom_rl).visibility =
                        View.VISIBLE
                    getView<TextView>(R.id.resign_records_item_status_info_tv).visibility =
                        View.VISIBLE
                    setText(
                        R.id.resign_records_item_status_info_tv, mContext.getString(
                            R.string.employee_reason,
                            it.rejectReason
                        )
                    )
                    setTextColor(
                        R.id.resign_records_item_status_info_tv,
                        ContextCompat.getColor(mContext, R.color.important_txt_six_color)
                    )
                    getView<TextView>(R.id.resign_records_item_jump_target_tv).visibility =
                        View.VISIBLE
                    setText(
                        R.id.resign_records_item_jump_target_tv,
                        R.string.resign_records_again_apply
                    )
                    //重新申请
                    addOnClickListener(R.id.resign_records_item_jump_target_tv)
                } else {
                    getView<TextView>(R.id.resign_records_item_status_tv).visibility = View.GONE
                }

                setText(
                    R.id.resign_records_item_title_tv,
                    R.string.resign_records_exit_consultant
                )

                setText(
                    R.id.resign_records_item_name_tv, mContext.getString(
                        R.string.resign_records_consultant_name,
                        it.staffName.convertDefaultValue()
                    )
                )

                setText(
                    R.id.resign_records_item_store_tv,
                    mContext.getString(
                        R.string.resign_records_store,
                        it.shopNames.convertDefaultValue()
                    )
                )

                setText(
                    R.id.resign_records_item_client_number_tv,
                    mContext.getString(
                        R.string.employee_dissmiss_clients_number,
                        it.customerNum.toString()
                    )
                )


                //1-指定分配人员, 2-自动分配 3,不分配
                if (it.allocationType == ConstantParams.CONSTANT_STARTS_1) {
                    setText(
                        R.id.resign_records_item_distribute_type_tv,
                        mContext.getString(R.string.resign_records_type_designated_assignee)
                    )
                } else if (it.allocationType == ConstantParams.CONSTANT_STARTS_2) {
                    setText(
                        R.id.resign_records_item_distribute_type_tv,
                        mContext.getString(R.string.resign_records_type_automatic_allocation)
                    )

                } else if (it.allocationType == ConstantParams.CONSTANT_STARTS_3) {
                    setText(
                        R.id.resign_records_item_distribute_type_tv,
                        mContext.getString(R.string.resign_records_type_not_assigned)
                    )
                } else {
                    getView<TextView>(R.id.resign_records_item_distribute_type_tv).visibility =
                        View.GONE
                }
                if (it.allocationType != ConstantParams.CONSTANT_STARTS_3) {
                    getView<TextView>(R.id.resign_records_item_distribute_target_tv).visibility=View.VISIBLE
                    setText(
                        R.id.resign_records_item_distribute_target_tv,
                        mContext.getString(
                            R.string.resign_records_distribute_target,
                            it.receiverName.convertDefaultValue()
                        )
                    )
                }else{
                    getView<TextView>(R.id.resign_records_item_distribute_target_tv).visibility=View.GONE
                }
            }
        }
    }

}