package com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.adapter

import android.support.v4.content.ContextCompat
import android.view.View
import android.widget.TextView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.business.managestaff.R
import com.wgmf.yxgj.module.business.managestaff.model.QiWeiCustomersAssignmentRecordsEntity
import com.wgmf.yxgj.utils.convertDefaultValue

/**
 * 在职/离职分配审核适配器
 * @author LW
 */
class ResignOrWorkingAssignmentReviewListAdapter(
    entity: List<QiWeiCustomersAssignmentRecordsEntity
    .QiWeiCustomersAssignmentRecordsPage.QiWeiCustomersAssignmentRecordsBean>
) : BaseQuickAdapter<QiWeiCustomersAssignmentRecordsEntity
.QiWeiCustomersAssignmentRecordsPage.QiWeiCustomersAssignmentRecordsBean, BaseViewHolder>(
    R.layout.item_qiwei_customers_assignment_records_view,
    entity
) {

    override fun convert(
        helper: BaseViewHolder?,
        item: QiWeiCustomersAssignmentRecordsEntity
        .QiWeiCustomersAssignmentRecordsPage.QiWeiCustomersAssignmentRecordsBean?
    ) {
        helper?.apply {
            item?.let {
                setText(
                    R.id.qiwei_customers_records_item_create_time_tv, it.createTime
                )
                getView<TextView>(R.id.qiwei_customers_records_item_review_tv).visibility =
                    View.GONE
                getView<TextView>(R.id.qiwei_customers_records_item_reason_rejection_tv).visibility =
                    View.GONE
                if (it.auditStatus == ConstantParams.CONSTANT_STARTS_1) {  //1-待审核,2-审核通过,3-审核驳回
                    setText(
                        R.id.qiwei_customers_records_item_status_tv,
                        R.string.qiwei_customers_assignment_records_to_be_reviewed
                    )
                    setTextColor(
                        R.id.qiwei_customers_records_item_status_tv,
                        ContextCompat.getColor(mContext, R.color.important_txt_four_color)
                    )

                    getView<TextView>(R.id.qiwei_customers_records_item_review_tv).visibility =
                        View.VISIBLE
                    addOnClickListener(R.id.qiwei_customers_records_item_review_tv)
                } else if (it.auditStatus == ConstantParams.CONSTANT_STARTS_2) {
                    setText(
                        R.id.qiwei_customers_records_item_status_tv,
                        R.string.qiwei_customers_assignment_records_examination_passed
                    )
                    setTextColor(
                        R.id.qiwei_customers_records_item_status_tv,
                        ContextCompat.getColor(mContext, R.color.important_txt_second_color)
                    )

                } else if (it.auditStatus == ConstantParams.CONSTANT_STARTS_3) {
                    setText(
                        R.id.qiwei_customers_records_item_status_tv,
                        R.string.qiwei_customers_assignment_records_turn_down
                    )
                    setTextColor(
                        R.id.qiwei_customers_records_item_status_tv,
                        ContextCompat.getColor(mContext, R.color.important_txt_five_color)
                    )
                    getView<TextView>(R.id.qiwei_customers_records_item_reason_rejection_tv).apply {
                        visibility = View.VISIBLE
                        text = mContext.getString(
                            R.string.qiwei_customers_assignment_records_reason_rejection,
                            it.rejectReason.convertDefaultValue()
                        )
                    }
                }

                setText(
                    R.id.qiwei_customers_records_item_transfer_advisor_tv,
                    it.staffName
                )

                setText(
                    R.id.qiwei_customers_records_item_succession_consultant_tv,
                    it.receiverStaffName
                )

                setText(
                    R.id.qiwei_customers_records_item_transfer_friends_tv, mContext.getString(
                        R.string.qiwei_customers_assignment_records_transfer_friends,
                        it.customerNum
                    )
                )

                //查看分配信息
                addOnClickListener(R.id.qiwei_customers_records_item_look_assignment_info_tv)
            }
        }
    }

}