package com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.adapter

import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.library.utils.ImageUtils
import com.wgmf.yxgj.module.business.managestaff.R
import com.wgmf.yxgj.module.business.managestaff.model.UserAndCustomerRelationEntity
import com.wgmf.yxgj.utils.convertDefaultValue
import com.wgmf.yxgj.utils.notNullAndEmpty


/**
 * 员工好友列表
 * @author LW
 */
class UserAndCustomerRelationListAdapter(
    entity: List<UserAndCustomerRelationEntity.UserAndCustomerRelationPage.UserAndCustomerRelationBean>
) : BaseQuickAdapter<UserAndCustomerRelationEntity.UserAndCustomerRelationPage.UserAndCustomerRelationBean, BaseViewHolder>(
    R.layout.item_qiwei_customers_assignment_info_view,
    entity
) {

    override fun convert(
        helper: BaseViewHolder?,
        item: UserAndCustomerRelationEntity.UserAndCustomerRelationPage.UserAndCustomerRelationBean?
    ) {
        helper?.apply {
            item?.let {
                ImageUtils.loadCircleImage(
                    mContext,
                    it.headImgUrl,
                    getView(R.id.customers_assignment_item_avatar_iv),
                    R.drawable.icon_avatar_circle,
                    R.drawable.icon_avatar_circle
                )
                setText(
                    R.id.customers_assignment_item_title_tv,
                    it.nickname.convertDefaultValue()

                )

                if (it.addRelationTime.notNullAndEmpty()) {
                    setText(
                        R.id.customers_assignment_item_tag_tv,
                        mContext.getString(
                            R.string.qiwei_customers_assignment_detail_add,
                            it.addRelationTime
                        )
                    )
                }
            }
        }
    }
}