package com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.resign

import android.content.Intent
import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.util.Log
import android.view.View
import android.widget.*
import com.chad.library.adapter.base.BaseQuickAdapter
import com.google.gson.Gson
import com.scwang.smartrefresh.layout.SmartRefreshLayout
import com.wgmf.library.base.BaseResponse
import com.wgmf.library.base.ResultData
import com.wgmf.yxgj.base.BaseParentAct
import com.wgmf.yxgj.config.BusinessID
import com.wgmf.yxgj.dialog.LoadWaitDominator
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.business.managestaff.R
import com.wgmf.yxgj.module.business.managestaff.model.EmployeeDissmissInfoEntity
import com.wgmf.yxgj.module.business.managestaff.model.ResignDistributeRecordsRequest
import com.wgmf.yxgj.module.business.managestaff.model.SpecifyAllocationEmployeeRequesst
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService
import com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.adapter.ResignAssignmentRecordsListAdapter
import com.wgmf.yxgj.module.business.managestaff.ui.staffinfo.SelectorConsultantActivity
import com.wgmf.yxgj.module.business.managestaff.ui.staffinfo.StaffDissimissDetailActivity
import com.wgmf.yxgj.utils.DensityUtil
import com.wgmf.yxgj.utils.isNotNullOrSize
import com.wgmf.yxgj.widgets.decoration.SpacesItemDecoration

/**
 *  离职分配记录
 * @author LW
 */
class ResignAssignmentRecordsActivity : BaseParentAct() {

    private var mPublicListViewRv: RecyclerView? = null

    private var mPublicRefreshView: SmartRefreshLayout? = null

    private var mResignDistributeRecordsListAdapter: ResignAssignmentRecordsListAdapter? = null

    private var mResignDistributeList: MutableList<EmployeeDissmissInfoEntity.EmployeeDissmissPage.EmployeeDissmissBean> =
        mutableListOf()

    /**
     * 当前页码
     */
    private var mNextPage: Int = 1

    lateinit var mLoadWait: LoadWaitDominator

    private var mEmployeeDissmissId: Int = -1

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.public_page_list_view)
        initTitle()
        initView()
    }

    override fun initTitle() {
        super.initTitle()
        homeTitleText.text = getString(R.string.resign_distribute_records)
        homeTitleBackLl.visibility = View.VISIBLE
    }


    private fun initView() {
        mLoadWait = LoadWaitDominator(this, findViewById(R.id.public_container_fl)).apply {
//            setBackgroundColor(R.color.region_two_bg)
            setStatusImg(R.drawable.ic_msg_empty_common)
        }
        mPublicRefreshView = findViewById<SmartRefreshLayout>(R.id.public_refresh_view).apply {
            //刷新
            setOnRefreshListener {
                queryEmployeeDimissionPageList(1)
            }
            //加载更多
            setOnLoadmoreListener {
                queryEmployeeDimissionPageList(mNextPage)
            }
        }

        mResignDistributeRecordsListAdapter =
            ResignAssignmentRecordsListAdapter(mResignDistributeList)
        mPublicListViewRv = findViewById<RecyclerView>(R.id.public_list_view_rv).apply {
            layoutManager = LinearLayoutManager(mContext)
            adapter = mResignDistributeRecordsListAdapter
            addItemDecoration(
                SpacesItemDecoration(
                    DensityUtil.dip2px(mContext, 15f),
                    adapter!!.itemCount,
                    true
                )
            )

        }

        BaseQuickAdapter.OnItemChildClickListener { adapter, view, pos -> //跳转到任务列表详情
            val bean =
                adapter?.getItem(pos) as EmployeeDissmissInfoEntity.EmployeeDissmissPage.EmployeeDissmissBean
            if (bean.auditStatus == ConstantParams.CONSTANT_STARTS_2 && bean.allocationType == ConstantParams.CONSTANT_STARTS_3) {  //指定分配人员
                jumpSelectorConsultantActivity(bean)
            } else if (bean.auditStatus == ConstantParams.CONSTANT_STARTS_3) {      //重新申请
                jumpStaffDissmissDetailActivity(bean)
            }
        }.also { mResignDistributeRecordsListAdapter?.onItemChildClickListener = it }

    }

    override fun onResume() {
        super.onResume()
        mPublicRefreshView?.autoRefresh()
    }

    /**
     * 分页查询员工离职记录列表
     */
    private fun queryEmployeeDimissionPageList(page: Int) {
        userInfo?.let {
            //if (page == ConstantParams.CONSTANT_STARTS_1) {
            //mLoadWait.show(LoadWaitDominator.LOADING)
            //showDialog()
            //}
            val json = Gson().toJson(ResignDistributeRecordsRequest(it.staffId, page))
            StaffManageService.getInstance()
                .requestEmployeeDimissionPageList(json, this@ResignAssignmentRecordsActivity)
        }
    }

    /**
     * 指定分配人
     */
    private fun queryEmployeeDimissionSpecifyalLocationEmployee(receiverStaffId: String?) {
        userInfo?.let {
            showDialog()
            val json =
                Gson().toJson(
                    SpecifyAllocationEmployeeRequesst(
                        it.staffId,
                        mEmployeeDissmissId,
                        receiverStaffId
                    )
                )
            StaffManageService.getInstance()
                .requestEmployeeDimissionSpecifyalLocationEmployee(
                    json,
                    this@ResignAssignmentRecordsActivity
                )
        }
    }

    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)
        dismissDialog()
        mLoadWait.dismissAll()

        mPublicRefreshView?.finishRefresh()
        mPublicRefreshView?.finishLoadmore()
        result?.let {
            if (it.taskID == BusinessID.StaffManage.MSG_ON_EMPLOYEE_DIMISSION_PAGE_LIST) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, EmployeeDissmissInfoEntity::class.java)
                    Log.d(TAG, "ResignDistributeEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        val pageData = entity.payload
                        if (pageData.pages == ConstantParams.CONSTANT_STARTS_0) {
                            mLoadWait.showNoData(R.string.no_record)
                            return
                        }
                        if (pageData.page <= pageData.pages) {
                            if (pageData.page == ConstantParams.CONSTANT_STARTS_1) {
                                refreshDataToView(pageData.data)
                            } else {
                                loadMoreDateToView(pageData.data)
                            }
                            this.mNextPage = pageData.page + 1
                        } else {
                            mPublicRefreshView?.resetNoMoreData()
                        }
                    } else {
                        mLoadWait.show(entity.retInfo)
                    }
                } else {
                    mLoadWait.showNetError()
                }
            } else if (it.taskID == BusinessID.StaffManage.MSG_ON_EMPLOYEE_DIMISSION_SPECIFYAL_LOCATION_EMPLOYEE) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, BaseResponse::class.java)
                    Log.d(TAG, "BaseResponse=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.msgCode) {
                        mPublicRefreshView?.autoRefresh()
                    } else {
                        showMsg(entity.retInfo)
                    }
                } else {
                    showMsg(getString(R.string.request_data_fail))
                }
            } else {

            }
        }
    }

    /**
     * 刷新数据更新到View
     */
    private fun refreshDataToView(list: List<EmployeeDissmissInfoEntity.EmployeeDissmissPage.EmployeeDissmissBean>?) {
        if (list.isNotNullOrSize()) {
            mResignDistributeList.clear()
            mResignDistributeList.addAll(list!!)
            mResignDistributeRecordsListAdapter?.notifyDataSetChanged()
        } else {
            mLoadWait.showNoData(R.string.no_record)
        }
    }

    /**
     * 读取更多数据更新到View
     */
    private fun loadMoreDateToView(list: List<EmployeeDissmissInfoEntity.EmployeeDissmissPage.EmployeeDissmissBean>?) {
        if (list.isNotNullOrSize()) {
            val position = mResignDistributeList.size
            mResignDistributeList.addAll(list!!)
            mResignDistributeRecordsListAdapter?.notifyItemInserted(position)
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, intent: Intent?) {
        super.onActivityResult(requestCode, resultCode, intent)
        intent?.let {
            if (requestCode == ConstantParams.CONSTANT_STARTS_0 && resultCode == ConstantParams.CONSTANT_STARTS_0) {
                val operatorId = it.getStringExtra(AppConstants.ExtraKeys.STAFF_ID) as String
                queryEmployeeDimissionSpecifyalLocationEmployee(operatorId)
            }
        }
    }

    /**
     * 跳转到 StaffDissimissDetailActivity
     */
    private fun jumpStaffDissmissDetailActivity(bean: EmployeeDissmissInfoEntity.EmployeeDissmissPage.EmployeeDissmissBean) {
        startActivity(Intent(this, StaffDissimissDetailActivity::class.java).apply {
            putExtra(
                AppConstants.ExtraKeys.TURNOVER_EMPLOYEE_NAME,
                bean.staffName
            )
            putExtra(AppConstants.ExtraKeys.TURNOVER_EMPLOYEE_ID, bean.staffId)
            putExtra(AppConstants.ExtraKeys.EMPLOYEE_DISSMISS_RECORDS, bean)
        })
    }

    /**
     * 跳转到 SelectorConsultantActivity
     */
    private fun jumpSelectorConsultantActivity(bean: EmployeeDissmissInfoEntity.EmployeeDissmissPage.EmployeeDissmissBean) {
        userInfo?.let {
            mEmployeeDissmissId = bean.id
            startActivityForResult(
                Intent(this, SelectorConsultantActivity::class.java).apply {
                    putExtra(AppConstants.ExtraKeys.STAFF_NAME, it.name)
                    putExtra(AppConstants.ExtraKeys.STAFF_ID, it.staffId)
                },
                ConstantParams.CONSTANT_STARTS_0
            )
        }
    }
}