package com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.working

import android.content.Intent
import android.os.Bundle
import android.support.v4.content.ContextCompat
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.util.Log
import android.view.View
import android.widget.TextView
import com.alibaba.android.arouter.facade.annotation.Route
import com.google.gson.Gson
import com.scwang.smartrefresh.layout.SmartRefreshLayout
import com.wgmf.library.base.ResultData
import com.wgmf.yxgj.base.BaseParentAct
import com.wgmf.yxgj.config.BusinessID
import com.wgmf.yxgj.dialog.LoadWaitDominator
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.business.managestaff.R
import com.wgmf.yxgj.module.business.managestaff.model.QiWeiCustomersAssignmentEntity
import com.wgmf.yxgj.module.business.managestaff.model.QiWeiCustomersAssignmentRequest
import com.wgmf.yxgj.module.business.managestaff.model.QiWeiCustomersAssignmentTotalEntity
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService
import com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.adapter.QiWeiCustomersAssignmentListAdapter
import com.wgmf.yxgj.utils.convertDefaultValue
import com.wgmf.yxgj.utils.isNotNullOrSize
import com.wgmf.yxgj.widgets.decoration.DividerItemDecoration
import com.xp.arouter.RouterParams

/**
 * 企微顾客分配
 * @author LW
 */
@Route(path = RouterParams.URL_QIWEICUSTOMERSASSIGNMENTACTIVITY)
class QiWeiCustomersAssignmentActivity : BaseParentAct() {

    private var mStaffStatus: Int = ConstantParams.CONSTANT_STARTS_1   //顾问在职状态：0-在职，1-离职

    private var mPublicListViewRv: RecyclerView? = null

    private var mPublicRefreshView: SmartRefreshLayout? = null

    private var mCustomersAssignmentConsultantNumTv: TextView? = null
    private var mCustomersAssignmentConsultantFriendsNumTv: TextView? = null

    private var mCustomersAssignmentResignTv: TextView? = null
    private var mCustomersAssignmentWorkingTv: TextView? = null

    private var mQiWeiCustomersAssignmentListAdapter: QiWeiCustomersAssignmentListAdapter? = null

    private var mQiWeiCustomersAssignmentList: MutableList<QiWeiCustomersAssignmentEntity.QiWeiCustomersAssignmentPage.QiWeiCustomersAssignmentBean> =
        mutableListOf()

    /**
     * 当前页码
     */
    private var mNextPage: Int = 1

    lateinit var mLoadWait: LoadWaitDominator

    private val mBranchTitle: String by lazy {
        intent.getStringExtra("branchTitle")
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_qiwei_customers_assignment)
        initTitle()
        initView()
    }

    override fun initTitle() {
        super.initTitle()
        homeTitleText.text = mBranchTitle
        homeTitleBackLl.visibility = View.VISIBLE
    }

    private fun initView() {
        mLoadWait = LoadWaitDominator(mContext, findViewById(R.id.public_container_fl)).apply {
            setStatusImg(R.drawable.ic_msg_empty_common)
        }
        mCustomersAssignmentConsultantNumTv =
            findViewById(R.id.customers_assignment_consultant_num_tv)
        mCustomersAssignmentConsultantFriendsNumTv =
            findViewById(R.id.customers_assignment_consultant_friends_num_tv)

        findViewById<TextView>(R.id.customers_assignment_records_tv).setOnClickListener {
            jumpQiWeiCustomersDistributeRecordsActivity()
        }

        mPublicRefreshView = findViewById<SmartRefreshLayout>(R.id.public_refresh_view).apply {
            //刷新
            setOnRefreshListener {
                queryEmployeeCustomerAllocationConsultantPageList(1)
            }
            //加载更多
            setOnLoadmoreListener {
                queryEmployeeCustomerAllocationConsultantPageList(mNextPage)
            }
        }

        mQiWeiCustomersAssignmentListAdapter =
            QiWeiCustomersAssignmentListAdapter(mQiWeiCustomersAssignmentList)
        mPublicListViewRv = findViewById<RecyclerView>(R.id.public_list_view_rv).apply {
            visibility = View.VISIBLE
            layoutManager = LinearLayoutManager(mContext)
            adapter = mQiWeiCustomersAssignmentListAdapter
            addItemDecoration(
                DividerItemDecoration(
                    DividerItemDecoration.HORIZONTAL_LIST,
                    1,
                    ContextCompat.getColor(mContext, R.color.divider_line)
                )
            )
        }

        mQiWeiCustomersAssignmentListAdapter?.setOnItemClickListener { adapter, view, pos ->
            val bean =
                adapter?.getItem(pos) as QiWeiCustomersAssignmentEntity.QiWeiCustomersAssignmentPage.QiWeiCustomersAssignmentBean
            jumpQiWeiCustomersAssignmentDetailActivity(bean)
        }
        mCustomersAssignmentResignTv =
            findViewById<TextView>(R.id.customers_assignment_resign_tv).apply {
                setOnClickListener {
                    mCustomersAssignmentResignTv?.setTextColor(
                        ContextCompat.getColor(
                            mContext,
                            R.color.important_txt_four_color
                        )
                    )
                    mCustomersAssignmentWorkingTv?.setTextColor(
                        ContextCompat.getColor(
                            mContext,
                            R.color.important_txt_color
                        )
                    )

                    mStaffStatus = ConstantParams.CONSTANT_STARTS_1
                    queryEmployeeCustomerAllocationTotal()
                    queryEmployeeCustomerAllocationConsultantPageList(1)
                }
            }
        mCustomersAssignmentWorkingTv =
            findViewById<TextView>(R.id.customers_assignment_working_tv).apply {
                setOnClickListener {
                    mCustomersAssignmentWorkingTv?.setTextColor(
                        ContextCompat.getColor(
                            mContext,
                            R.color.important_txt_four_color
                        )
                    )
                    mCustomersAssignmentResignTv?.setTextColor(
                        ContextCompat.getColor(
                            mContext,
                            R.color.important_txt_color
                        )
                    )

                    mStaffStatus = ConstantParams.CONSTANT_STARTS_0
                    queryEmployeeCustomerAllocationTotal()
                    queryEmployeeCustomerAllocationConsultantPageList(1)
                }
            }

        mCustomersAssignmentResignTv?.performClick()
    }


    /**
     * 跳转到 QiWeiCustomersAssignmentDetailActivity
     */
    private fun jumpQiWeiCustomersAssignmentDetailActivity(bean: QiWeiCustomersAssignmentEntity.QiWeiCustomersAssignmentPage.QiWeiCustomersAssignmentBean) {
        startActivity(Intent(mContext, QiWeiCustomersAssignmentDetailActivity::class.java).apply {
            putExtra(AppConstants.ExtraKeys.QIWEI_CUSTOMERS_ASSIGNMENT, bean)
            putExtra(AppConstants.ExtraKeys.CONSULTANT_WORKING_STATUS, mStaffStatus)
        })
    }

    /**
     * 查询员工的顾问汇总信息
     */
    private fun queryEmployeeCustomerAllocationTotal() {
        userInfo?.let {
            val json = Gson().toJson(
                QiWeiCustomersAssignmentRequest(
                    it.staffId, it.level,
                    mStaffStatus
                )
            )
            StaffManageService.getInstance()
                .requestEmployeeCustomerAllocationTotal(
                    json,
                    this@QiWeiCustomersAssignmentActivity
                )
        }
    }

    /**
     * 分页查询顾问列表
     */
    private fun queryEmployeeCustomerAllocationConsultantPageList(page: Int) {
        userInfo?.let {
            val json = Gson().toJson(
                QiWeiCustomersAssignmentRequest(
                    it.staffId,
                    it.level,
                    mStaffStatus,
                    page
                )
            )
            StaffManageService.getInstance()
                .requestEmployeeCustomerAllocationConsultantPageList(
                    json,
                    this@QiWeiCustomersAssignmentActivity
                )
        }
    }

    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)
        mLoadWait.dismissAll()
        mPublicRefreshView?.finishRefresh()
        mPublicRefreshView?.finishLoadmore()
        result?.let {
            if (it.taskID == BusinessID.StaffManage.MSG_ON_EMPLOYEE_CUSTOMER_ALLOCATION_CONSULTANT_PAGE_LIST) {
                if (!isFinishing && it.isSuccessed) {
                    val entity =
                        Gson().fromJson(it.info, QiWeiCustomersAssignmentEntity::class.java)
                    Log.d(TAG, "QiWeiCustomersAssignmentEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        val pageData = entity.payload
                        if (pageData.pages == ConstantParams.CONSTANT_STARTS_0) {
                            mLoadWait.showNoData(R.string.no_record)
                            return
                        }
                        if (pageData.page <= pageData.pages) {
                            if (pageData.page == ConstantParams.CONSTANT_STARTS_1) {
                                refreshDataToView(pageData.data)
                            } else {
                                loadMoreDateToView(pageData.data)
                            }
                            this.mNextPage = pageData.page + 1
                        } else {
                            mPublicRefreshView?.resetNoMoreData()
                        }
                    } else {
                        mLoadWait.show(entity.retInfo)
                    }
                } else {
                    mLoadWait.showNetError()
                }
            } else if (it.taskID == BusinessID.StaffManage.MSG_ON_EMPLOYEE_CUSTOMER_ALLOCATION_TOTAL) {
                if (!isFinishing && it.isSuccessed) {
                    val entity =
                        Gson().fromJson(it.info, QiWeiCustomersAssignmentTotalEntity::class.java)
                    Log.d(TAG, "QiWeiCustomersAssignmentTotalEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        val pageData = entity.payload
                        customersAssignmentNumToView(pageData)
                    } else {
                        showMsg(entity.retInfo)
                    }
                } else {
                    showMsg(getString(R.string.request_data_fail))
                }
            } else {
            }
        }
    }

    /**
     * 查询员工的顾问汇总信息
     */
    private fun customersAssignmentNumToView(bean: QiWeiCustomersAssignmentTotalEntity.QiWeiCustomersAssignmentTotalBean?) {
        bean?.let {
            mCustomersAssignmentConsultantNumTv?.text = it.consultantSum.convertDefaultValue()
            mCustomersAssignmentConsultantFriendsNumTv?.text = it.customerSum.convertDefaultValue()
        }
    }

    /**
     * 刷新数据更新到View
     */
    private fun refreshDataToView(list: List<QiWeiCustomersAssignmentEntity.QiWeiCustomersAssignmentPage.QiWeiCustomersAssignmentBean>?) {
        mLoadWait.dismissAll()
        if (list.isNotNullOrSize()) {
            mQiWeiCustomersAssignmentList.clear()
            mQiWeiCustomersAssignmentList.addAll(list!!)
            mQiWeiCustomersAssignmentListAdapter?.notifyDataSetChanged()
        } else {
            mLoadWait.showNoData(R.string.no_record)
        }
    }

    /**
     * 读取更多数据更新到View
     */
    private fun loadMoreDateToView(list: List<QiWeiCustomersAssignmentEntity.QiWeiCustomersAssignmentPage.QiWeiCustomersAssignmentBean>?) {
        if (list.isNotNullOrSize()) {
            val position = mQiWeiCustomersAssignmentList.size
            mQiWeiCustomersAssignmentList.addAll(list!!)
            mQiWeiCustomersAssignmentListAdapter?.notifyItemInserted(position)
        }
    }

    /**
     * 跳转到QiWeiCustomersDistributeRecordsActivity
     */
    private fun jumpQiWeiCustomersDistributeRecordsActivity() {
        startActivity(Intent(this, QiWeiCustomersAssignmentRecordsActivity::class.java))
    }
}