package com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.working

import android.content.Intent
import android.os.Bundle
import android.support.v4.content.ContextCompat
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.util.Log
import android.view.View
import android.widget.Button
import android.widget.FrameLayout
import android.widget.RelativeLayout
import android.widget.TextView
import com.google.gson.Gson
import com.scwang.smartrefresh.layout.SmartRefreshLayout
import com.wgmf.library.base.BaseResponse
import com.wgmf.library.base.ResultData
import com.wgmf.yxgj.base.BaseParentAct
import com.wgmf.yxgj.config.BusinessID
import com.wgmf.yxgj.dialog.LoadWaitDominator
import com.wgmf.yxgj.dialog.PublicTipDialog
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.business.managestaff.R
import com.wgmf.yxgj.module.business.managestaff.model.*
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService
import com.wgmf.yxgj.module.business.managestaff.ui.staffdistribute.adapter.UserAndCustomerRelationListAdapter
import com.wgmf.yxgj.module.business.managestaff.ui.staffinfo.SelectorConsultantActivity
import com.wgmf.yxgj.utils.convertDefaultValue
import com.wgmf.yxgj.utils.isNotNullOrSize
import com.wgmf.yxgj.utils.isNullOrEmpty
import com.wgmf.yxgj.utils.notNullAndEmpty
import com.wgmf.yxgj.widgets.decoration.DividerItemDecoration

/**
 * 企微顾客分配详情
 * @author LW
 */
class QiWeiCustomersAssignmentDetailActivity : BaseParentAct() {


    private var mPublicListViewRv: RecyclerView? = null
    private var mPublicRefreshView: SmartRefreshLayout? = null
    private var mCustomersAssignmentDetailConfirmFl: FrameLayout? = null
    private var mCustomersAssignmentdetailConfirmBtn: Button? = null

    private var mCustomersAssignmentDetailTotalTv: TextView? = null
    private var mCustomersAssignmentDetailSelectedTv: TextView? = null
    private var mCustomersAssignmentDetailInfoTv: TextView? = null
    private var mCustomersAssignmentDetailConsultantTv: TextView? = null

    private var mCustomersAssignmentDetailAllocateTv: TextView? = null
    private var mCustomersAssignmentDetailSplitInHalfTv: TextView? = null
    private var mCustomersAssignmentDetailMin13Tv: TextView? = null

    private var mUserAndCustomerRelationListAdapter: UserAndCustomerRelationListAdapter? = null

    private var mUserAndCustomerRelationList: MutableList<UserAndCustomerRelationEntity.UserAndCustomerRelationPage.UserAndCustomerRelationBean> =
        mutableListOf()

    /**
     * 当前页码
     */
    private var mNextPage: Int = 1

    /**
     * 好友个数
     */
    private var mFriendTotalNum: Int = 0

    /**
     *好友数类型
     */
    private var mChooseFriendNumType: Int = ConstantParams.CONSTANT_STARTS_1

    /**
     * 	是否可以申请:1-是 2-否
     */
    private var mWhetherCanApply: Int = ConstantParams.CONSTANT_STARTS_2

    lateinit var mLoadWait: LoadWaitDominator

    private var mReceiverStaffId: String = ""  //	分配接收人工号

    private var mReceiverStaffName: String = ""   //	分配接收人名称

    private val mQiWeiCustomersAssignmentBean: QiWeiCustomersAssignmentEntity.QiWeiCustomersAssignmentPage.QiWeiCustomersAssignmentBean? by lazy {
        val bean =
            intent.getSerializableExtra(AppConstants.ExtraKeys.QIWEI_CUSTOMERS_ASSIGNMENT)
        if (bean != null) {
            return@lazy bean as QiWeiCustomersAssignmentEntity.QiWeiCustomersAssignmentPage.QiWeiCustomersAssignmentBean?
        }
        return@lazy null
    }

    private val mId: Int by lazy {
        intent.getIntExtra(AppConstants.ExtraKeys.QIWEI_CUSTOMERS_ASSIGNMENT_ID, -1)
    }

    private var mStaffStatus: Int? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_qiwei_customers_assignment_detail)
        initTitle()
        initView()
    }

    override fun initTitle() {
        super.initTitle()
        homeTitleText.text = mContext.getString(R.string.qiwei_customers_assignment)
        homeTitleBackLl.visibility = View.VISIBLE
    }

    private fun initView() {
        mLoadWait = LoadWaitDominator(mContext, findViewById(R.id.public_container_fl)).apply {
            setStatusImg(R.drawable.ic_msg_empty_common)
        }
        mQiWeiCustomersAssignmentBean?.let {
            findViewById<TextView>(R.id.customers_assignment_consultant_detail_title_tv).text =
                mContext.getString(
                    R.string.qiwei_customers_assignment_detail_nutrition_consultant,
                    it.staffName.convertDefaultValue()
                )
        }

        mCustomersAssignmentDetailConsultantTv =
            findViewById(R.id.customers_assignment_consultant_detail_consultant_tv)

        mCustomersAssignmentDetailInfoTv =
            findViewById(R.id.customers_assignment_consultant_detail_info_tv)

        mCustomersAssignmentDetailTotalTv =
            findViewById<TextView>(R.id.customers_assignment_consultant_detail_total_tv).apply {
                text = mContext.getString(
                    R.string.qiwei_customers_assignment_detail_total,
                    0
                )
            }
        mCustomersAssignmentDetailSelectedTv =
            findViewById(R.id.customers_assignment_consultant_detail_selected_tv)

        mPublicRefreshView = findViewById<SmartRefreshLayout>(R.id.public_refresh_view).apply {
            //刷新
            setOnRefreshListener {
                queryEmployeeCustomerAllocationUserCustomerRelationPageList(1)
            }
            //加载更多
            setOnLoadmoreListener {
                queryEmployeeCustomerAllocationUserCustomerRelationPageList(mNextPage)
            }
        }

        mUserAndCustomerRelationListAdapter =
            UserAndCustomerRelationListAdapter(mUserAndCustomerRelationList)
        mPublicListViewRv = findViewById<RecyclerView>(R.id.public_list_view_rv).apply {
            visibility = View.VISIBLE
            layoutManager = LinearLayoutManager(mContext)
            adapter = mUserAndCustomerRelationListAdapter
            addItemDecoration(
                DividerItemDecoration(
                    DividerItemDecoration.HORIZONTAL_LIST,
                    1,
                    ContextCompat.getColor(mContext, R.color.divider_line)
                )
            )
        }

        mUserAndCustomerRelationListAdapter?.setOnItemClickListener { adapter, view, pos ->
        }

        mCustomersAssignmentDetailAllocateTv =
            findViewById<TextView>(R.id.customers_assignment_consultant_detail_allocate_tv).apply {
                setOnClickListener {
                    mCustomersAssignmentDetailSelectedTv?.text = mContext.getString(
                        R.string.qiwei_customers_assignment_detail_selected,
                        mFriendTotalNum
                    )
                    mChooseFriendNumType = ConstantParams.CONSTANT_STARTS_1

                    mCustomersAssignmentDetailAllocateTv?.isSelected = true
                    mCustomersAssignmentDetailSplitInHalfTv?.isSelected = false
                    mCustomersAssignmentDetailMin13Tv?.isSelected = false
                }
            }

        mCustomersAssignmentDetailSplitInHalfTv =
            findViewById<TextView>(R.id.customers_assignment_consultant_detail_split_in_half_tv).apply {
                setOnClickListener {
                    mCustomersAssignmentDetailSelectedTv?.text = mContext.getString(
                        R.string.qiwei_customers_assignment_detail_selected,
                        mFriendTotalNum / 2
                    )
                    mChooseFriendNumType = ConstantParams.CONSTANT_STARTS_2
                    mCustomersAssignmentDetailSplitInHalfTv?.isSelected = true
                    mCustomersAssignmentDetailAllocateTv?.isSelected = false
                    mCustomersAssignmentDetailMin13Tv?.isSelected = false
                }
            }

        mCustomersAssignmentDetailMin13Tv =
            findViewById<TextView>(R.id.customers_assignment_consultant_detail_min_1_3_tv).apply {
                setOnClickListener {
                    mCustomersAssignmentDetailSelectedTv?.text = mContext.getString(
                        R.string.qiwei_customers_assignment_detail_selected,
                        mFriendTotalNum / 3
                    )
                    mChooseFriendNumType = ConstantParams.CONSTANT_STARTS_3
                    mCustomersAssignmentDetailMin13Tv?.isSelected = true
                    mCustomersAssignmentDetailAllocateTv?.isSelected = false
                    mCustomersAssignmentDetailSplitInHalfTv?.isSelected = false
                }
            }


        findViewById<RelativeLayout>(R.id.customers_assignment_consultant_detail_assigned_to_rl).setOnClickListener {
            //指定分配
            jumpSelectorConsultantActivity()
        }
        mCustomersAssignmentDetailConfirmFl =
            findViewById(R.id.customers_assignment_consultant_detail_confirm_fl)
        mCustomersAssignmentdetailConfirmBtn =
            findViewById<Button>(R.id.customers_assignment_consultant_detail_confirm_btn).apply {
                setOnClickListener {
                    if (mStaffStatus == ConstantParams.CONSTANT_STARTS_0) {
                        //确认分配
                        showConfirmDistributeTipDialog()
                    } else {
                        saveEmployeeCustomerAllocation()
                    }
                }
            }
        mCustomersAssignmentDetailAllocateTv?.performClick()
        //查询在职状态
        queryOrganizationUserStaffStatus()
        //下拉刷新
        mPublicRefreshView?.autoRefresh()
    }

    /**
     *  保存员工客户分配申请
     */
    private fun saveEmployeeCustomerAllocation() {
        if (mReceiverStaffId.isNullOrEmpty()) {
            showMsg(getString(R.string.qiwei_customers_assignment_detail_assigned_to_tip))
            return
        }
        userInfo?.let {
            showDialog()
            val json = Gson().toJson(
                CustomerAllocationSaveRequest().apply {
                    if (mId > 0) {
                        id = mId
                    }
                    staffId = mQiWeiCustomersAssignmentBean?.staffId
                    staffName = mQiWeiCustomersAssignmentBean?.staffName
                    staffStatus = mStaffStatus
                    receiverStaffId = mReceiverStaffId
                    receiverStaffName = mReceiverStaffName
                    approvalStaffId = it.staffId
                    approvalUserLevel = it.level.toInt()
                    allocationNumType = mChooseFriendNumType
                }
            )

            StaffManageService.getInstance()
                .requestEmployeeCustomerAllocationSave(
                    json,
                    this@QiWeiCustomersAssignmentDetailActivity
                )
        }
    }


    /**
     * 查询是否可以分配当前顾问客户
     */
    private fun queryEmployeeCustomerAllocationCanApplyInfo() {
        mQiWeiCustomersAssignmentBean?.let {
            val json = Gson().toJson(
                CanApplyRequest(
                    it.staffId
                )
            )
            StaffManageService.getInstance()
                .requestEmployeeCustomerAllocationCanApplyInfo(
                    json,
                    this@QiWeiCustomersAssignmentDetailActivity
                )
        }
    }

    /**
     * 查询员工在职状态
     */
    private fun queryOrganizationUserStaffStatus() {
        mQiWeiCustomersAssignmentBean?.let {
            val json = Gson().toJson(
                OrganizationUserStaffStatusRequest(
                    it.staffId
                )
            )
            StaffManageService.getInstance()
                .requestOrganizationUserStaffStatus(
                    json,
                    this@QiWeiCustomersAssignmentDetailActivity
                )
        }
    }

    /**
     * 分页查询员工好友列表
     */
    private fun queryEmployeeCustomerAllocationUserCustomerRelationPageList(page: Int) {
        mQiWeiCustomersAssignmentBean?.let {
            val json = Gson().toJson(
                UserAndCustomerRelationRequest(
                    it.staffId,
                    page
                )
            )

            StaffManageService.getInstance()
                .requestEmployeeCustomerAllocationUserCustomerRelationPageList(
                    json,
                    this@QiWeiCustomersAssignmentDetailActivity
                )
        }
    }

    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)
        mLoadWait.dismissAll()
        dismissDialog()
        mPublicRefreshView?.finishRefresh()
        mPublicRefreshView?.finishLoadmore()
        result?.let {
            if (it.taskID == BusinessID.StaffManage.MSG_ON_EMPLOYEE_CUSTOMER_ALLOCATION_USER_CUSTOMER_RELATION_PAGE_LIST) {
                if (!isFinishing && it.isSuccessed) {
                    val entity =
                        Gson().fromJson(it.info, UserAndCustomerRelationEntity::class.java)
                    Log.d(TAG, "UserAndCustomerRelationEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        val pageData = entity.payload
                        if (pageData.pages == ConstantParams.CONSTANT_STARTS_0) {
                            mLoadWait.showNoData(R.string.no_record)
                            return
                        }
                        if (pageData.page <= pageData.pages) {
                            if (pageData.page == ConstantParams.CONSTANT_STARTS_1) {
                                refreshDataToView(pageData.data)
                                customersAssignmentNumToView(pageData)
                            } else {
                                loadMoreDateToView(pageData.data)
                            }
                            this.mNextPage = pageData.page + 1
                        } else {
                            mPublicRefreshView?.resetNoMoreData()
                        }
                    } else {
                        mLoadWait.show(entity.retInfo)
                    }
                } else {
                    mLoadWait.showNetError()
                }
            } else if (it.taskID == BusinessID.StaffManage.MSG_ON_EMPLOYEE_CUSTOMER_ALLOCATION_CAN_APPLY_INFO) {
                if (!isFinishing && it.isSuccessed) {
                    val entity =
                        Gson().fromJson(it.info, CanApplyEntity::class.java)
                    Log.d(TAG, "CanApplyEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        val bean = entity.payload
                        canApplyToView(bean)
                    } else {
                        showMsg(entity.retInfo)
                    }
                } else {
                    showMsg(getString(R.string.request_data_fail))
                }
            } else if (it.taskID == BusinessID.StaffManage.MSG_ON_EMPLOYEE_CUSTOMER_ALLOCATION_SAVE) {
                if (!isFinishing && it.isSuccessed) {
                    val entity =
                        Gson().fromJson(it.info, BaseResponse::class.java)
                    Log.d(TAG, "BaseResponse=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        finish()
                    } else {
                        showMsg(entity.retInfo)
                    }
                } else {
                    showMsg(getString(R.string.request_data_fail))
                }
            } else if (it.taskID == BusinessID.StaffManage.MSG_ON_ORGANIZATION_USER_STAFF_STATUS) {
                if (!isFinishing && it.isSuccessed) {
                    val entity =
                        Gson().fromJson(it.info, OrganizationUserStaffStatusEntity::class.java)
                    Log.d(TAG, "CanApplyEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        mStaffStatus = entity.payload
                        //查询是否可以申请
                        queryEmployeeCustomerAllocationCanApplyInfo()
                    } else {
                        showMsg(entity.retInfo)
                    }
                } else {
                    showMsg(getString(R.string.request_data_fail))
                }
            } else {

            }
        }
    }

    /**
     * 是否可以分配当前顾问客户
     */
    private fun canApplyToView(bean: CanApplyEntity.CanApplyBean?) {
        bean?.let {
            this.mWhetherCanApply = it.whetherCanApply
            if (it.whetherCanApply == ConstantParams.CONSTANT_STARTS_1) { //可以申请
                if (mStaffStatus == ConstantParams.CONSTANT_STARTS_0) {
                    mCustomersAssignmentDetailInfoTv?.text =
                        mContext.getString(R.string.qiwei_customers_assignment_detail_apply_one_tip)
                }
                mCustomersAssignmentdetailConfirmBtn?.isEnabled = true
            } else {
                if (mStaffStatus == ConstantParams.CONSTANT_STARTS_0) {
                    mCustomersAssignmentDetailInfoTv?.text =
                        mContext.getString(
                            R.string.qiwei_customers_assignment_detail_apply_two_tip,
                            it.nextCanApplyTime ?: "".convertDefaultValue()
                        )
                }
                mCustomersAssignmentdetailConfirmBtn?.isEnabled = false
            }

        }

    }

    private fun customersAssignmentNumToView(page: UserAndCustomerRelationEntity.UserAndCustomerRelationPage?) {
        page?.let {
            this.mFriendTotalNum = it.total
            mCustomersAssignmentDetailTotalTv?.text =
                mContext.getString(
                    R.string.qiwei_customers_assignment_detail_total,
                    it.total
                )

            mCustomersAssignmentDetailSelectedTv?.text = mContext.getString(
                R.string.qiwei_customers_assignment_detail_selected,
                mFriendTotalNum
            )
        }
    }

    /**
     * 刷新数据更新到View
     */
    private fun refreshDataToView(list: List<UserAndCustomerRelationEntity.UserAndCustomerRelationPage.UserAndCustomerRelationBean>?) {
        if (list.isNotNullOrSize()) {
            mUserAndCustomerRelationList.clear()
            mUserAndCustomerRelationList.addAll(list!!)
            mUserAndCustomerRelationListAdapter?.notifyDataSetChanged()
            mCustomersAssignmentDetailConfirmFl?.visibility = View.VISIBLE
        } else {
            mLoadWait.showNoData(R.string.no_record)
            mCustomersAssignmentDetailConfirmFl?.visibility = View.GONE
        }
    }

    /**
     * 读取更多数据更新到View
     */
    private fun loadMoreDateToView(list: List<UserAndCustomerRelationEntity.UserAndCustomerRelationPage.UserAndCustomerRelationBean>?) {
        if (list.isNotNullOrSize()) {
            val position = mUserAndCustomerRelationList.size
            mUserAndCustomerRelationList.addAll(list!!)
            mUserAndCustomerRelationListAdapter?.notifyItemInserted(position)
        }
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, intent: Intent?) {
        super.onActivityResult(requestCode, resultCode, intent)
        intent?.let {
            if (requestCode == ConstantParams.CONSTANT_STARTS_0 && resultCode == ConstantParams.CONSTANT_STARTS_0) {
                mReceiverStaffId = it.getStringExtra(AppConstants.ExtraKeys.STAFF_ID) as String
                mReceiverStaffName = it.getStringExtra(AppConstants.ExtraKeys.STAFF_NAME) as String
                mCustomersAssignmentDetailConsultantTv?.text = mReceiverStaffName
            }
        }
    }

    /**
     * 跳转到 SelectorConsultantActivity
     */
    private fun jumpSelectorConsultantActivity() {
        userInfo?.let {
            startActivityForResult(
                Intent(this, SelectorConsultantActivity::class.java).apply {
                    putExtra(AppConstants.ExtraKeys.STAFF_NAME, it.name)
                    putExtra(AppConstants.ExtraKeys.STAFF_ID, it.staffId)
                },
                ConstantParams.CONSTANT_STARTS_0
            )
        }
    }

    /**
     * 确认分配提示框
     */
    private fun showConfirmDistributeTipDialog() {
        val builder = PublicTipDialog.Builder(this)
        builder.setTitle(R.string.tip)
        builder.setMessage(R.string.qiwei_customers_assignment_detail_apply_one_tip)
        builder.setNegativeButton(
            R.string.confirm_btn_txt
        ) { dialog, which ->
            dialog.dismiss()
            //确认分配提交数据
            saveEmployeeCustomerAllocation()
        }
        builder.setPositiveButton(
            R.string.cancel_btn_txt
        ) { dialog, _ -> dialog.dismiss() }
        builder.create().show()
    }

}