package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo;


import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.google.gson.Gson;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.expand.StaticSchemeExpand;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.publics.service.StaffInfoCheck;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.wgmf.yxgj.widgets.MMessageDisplay;
import com.xp.arouter.RouterParams;

/**
 * 员工信息修改
 */
@Route(path = RouterParams.URL_STAFFAMENDACTIVITY)
public class StaffAmendActivity extends StaffBaseActivity {

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (personalId != null && !personalId.equals("")) {
            queryInfo(personalId);
        }
    }

    @Override
    protected void initLayout() {
        super.initLayout();
        temporarySave = false;
        editFlag = false;
        setItemLayout(0);
        staffInfoLl.setVisibility(View.GONE);
        //有无亲属修改时不显示
        ifRelativesSelectorLl.setVisibility(View.GONE);
        relativesLl.setVisibility(View.GONE);
        relativespostLl.setVisibility(View.GONE);
        //是否外包修改时不显示
        ifOutsourcingSelectorLl.setVisibility(View.GONE);
        outsourcingLl.setVisibility(View.GONE);
        submitRightBtn.setText("修改");
    }

    @Override
    protected void fillData(NutritionConsultant item) {
        super.fillData(item);
        operatorId = item.getOperatorId();
        staffStatusTxt.setText(StaffInfoCheck.getStatus(item.getStatus()));
        if (!(ConstantParams.CONSTANT_PARAMS_1.equals(item.getRoleStatus()) || ConstantParams.CONSTANT_PARAMS_15.equals(item.getRoleStatus()))) {
            //非驻店或店长，上级不显示
            storePickLl.setVisibility(View.GONE);
        }
    }

    @Override
    protected void onFindNutritionConsultant(NutritionConsultant nutritionConsultant) {
        this.nutritionConsultant = nutritionConsultant;
        if (null != nutritionConsultant) {
            staffInfoLl.setVisibility(View.VISIBLE);
            submitLl.setVisibility(View.VISIBLE);

            staffidLl.setVisibility(View.VISIBLE);
            submitLeftBrn.setOnClickListener(this);
            submitLeftBrn.setText("修改");
            submitLeftBrn.setVisibility(View.VISIBLE);
            submitRightBtn.setVisibility(View.GONE);
            fillData(nutritionConsultant);
        }
    }

    protected void submitRightBtnUpdata() {
        if ("去返聘".equals(submitRightBtn.getText().toString())) {
            staffEntryTipLl.setVisibility(View.GONE);
            homeTitleText.setText("员工返聘");
            submitRightBtn.setText("提交");
            submitRightBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.selector_orange_stroke_round_btn));
            submitRightBtn.setTextColor(getResources().getColor(R.color.normal_color));
            //进入返聘流程
            entryRehire(nutritionConsultant);
        } else if ("提交".equals(submitRightBtn.getText().toString())) {
            setUploadData();
        }
        if ("保存".equals(submitRightBtn.getText().toString())) {
            setUploadData();
        }
    }

    @Override
    public void onClick(View v) {
        super.onClick(v);
        if (v.getId() == R.id.submit_left_btn) {
            if ("修改".equals(submitLeftBrn.getText().toString())) {
                setItemLayout(2);
                submitRightBtn.setText("保存");
                submitLeftBrn.setVisibility(View.GONE);
                submitRightBtn.setVisibility(View.VISIBLE);
                editFlag = !editFlag;
            }
        }
    }

    @Override
    protected void setUploadData() {
        //检查必填项
        if (!checkUploadData()) {
            return;
        }

        if (TextUtils.isEmpty(name.getText().toString().trim())) {
            ToastUtil.show(this, "请输入员工姓名!");
            return;
        }
        if (("店长".equals(jobTv.getText().toString()) || "驻店营养顾问".equals(jobTv.getText().toString())) && TextUtils.isEmpty(store.getText().toString().trim())) {
            ToastUtil.show(this, "请选择所属门店!");
            return;
        }
        final String id = idCard.getText().toString().trim();
        if (id.length() == 15) {
            String date = birthday.getText().toString().replace("-", "")
                    .substring(2, 8);
            if (!date.equals(id.substring(6, 12))) {
                ToastUtil.show(this, "身份证号或出生日期录入错误!");
                return;
            }
        } else if (id.length() == 18) {
            String date = birthday.getText().toString().replace("-", "");
            if (!date.equals(id.substring(6, 14))) {
                ToastUtil.show(this, "身份证号或出生日期录入错误!");
                return;
            }
        } else {
            ToastUtil.show(this, "身份证号码长度应该为15或18位!");
            return;
        }

        //返聘需要选择入职时间，入职时间必须在当前时间的前两天到当前时间的后两天这之间
        if (homeTitleText.getText().toString().contains("员工返聘")) {
            String entryDate = entrydate.getText().toString();
            if (!DateUtil.isTimeBeforeAndAfterTwoDays(entryDate)) {
                ToastUtil.show(this, "您输入的入职日期有误，请输入当天前后两天的日期!");
                return;
            }
        }

        if (!man.isChecked() && !women.isChecked()) {
            ToastUtil.show(this, "请选择性别!");
            return;
        }
        if (phone.getText().toString().trim().equals(urgencyPhone.getText().toString().trim())) {
            ToastUtil.show(this, "联系电话和紧急电话不能一样!");
            return;
        }
        if (phone.getText().toString().trim().length() != 11 || !phone.getText().toString().startsWith("1")) {
            dismissDialog();
            ToastUtil.show(this, "联系电话填写有误，请检查！");
            return;
        }
        if (urgencyPhone.getText().toString().trim().length() != 11 || !urgencyPhone.getText().toString().startsWith("1")) {
            dismissDialog();
            ToastUtil.show(this, "紧急电话填写有误，请检查！");
            return;
        }
        //返聘需要选择通讯补贴，修改不需要选择通讯补贴
        if (homeTitleText.getText().toString().contains("员工返聘")) {
            if (getString(R.string.empty_etb_hint_select_txt).equals(communicationAllowance.getText().toString().trim())
                    || TextUtils.isEmpty(communicationAllowance.getText().toString().trim())) {
                dismissDialog();
                ToastUtil.show(this, "请选择通讯补贴!");
                return;
            }
        }
        super.setUploadData();
    }

    @Override
    protected void uploadData() {
        super.uploadData();
        if (homeTitleText.getText().toString().contains("员工返聘")) {
            doUploadRehire();
        } else if (homeTitleText.getText().toString().contains("修改")) {
            doModifyStaffDataUpload();//提交员工信息修改数据
        }
    }

    private void doUploadRehire() {
        showDialog();
        NutritionConsultant mNutritionConsultant = setStaffDataUpload();
        String content = new Gson().toJson(mNutritionConsultant);
        Log.d("doUploadRehire:", content);
        StaffManageService.getInstance().requestUpdateUserRehire(content, this);
    }

    /**
     * 提交员工信息修改数据
     */
    private void doModifyStaffDataUpload() {
        showDialog();
        NutritionConsultant mNutritionConsultant = setStaffDataUpload();
        String content = new Gson().toJson(mNutritionConsultant);
        Log.d("StaffAmendActivity:", content);
        StaffManageService.getInstance().requestUpdateNutritionConsultant(content, this);
    }


    private boolean checkUploadData() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        //姓名校验
        inputs.add(name, StaticScheme.Required());
        //身份证校验
        inputs.add(idCard, StaticScheme.Required(), StaticScheme.ChineseIDCard());
        //出生日期校验
        inputs.add(birthday, StaticSchemeExpand.Required(birthday, ""));
        //入职日期校验
        inputs.add(entrydate, StaticSchemeExpand.Required(entrydate, ""));
        //学历校验
        inputs.add(education, StaticSchemeExpand.Required(education, ""));
        //籍贯校验
        inputs.add(province, StaticSchemeExpand.Required(province, ""));
        //现住址
        inputs.add(address, StaticScheme.Required());
        //联系电话校验
        inputs.add(phone, StaticScheme.Required());
        //紧急联系人校验
        inputs.add(urgencyPerson, StaticScheme.Required());
        //紧急电话校验
        inputs.add(urgencyPhone, StaticScheme.Required());
        //招聘来源校验
        inputs.add(recuitmentChannel, StaticSchemeExpand.Required(recuitmentChannel, ""));

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            ToastUtil.show(this, "填写有误，请检查");
            dismissDialog();
            inputs.clear();
            return false;
        }
    }
}