package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo;


import android.os.Bundle;
import android.view.View;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.xp.arouter.RouterParams;

/**
 * 入职审批
 */
@Route(path = RouterParams.URL_STAFFAPPROVEACTIVITY)
public class StaffApproveActivity extends StaffBaseActivity {
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (operatorId != null && !operatorId.equals("")) {
            queryInfo(operatorId);
        } else {
            ToastUtil.show(this, "抱歉，该消息中数据不完整，请核实！");
            this.finish();
        }
    }

    @Override
    protected void initLayout() {
        super.initLayout();
        editFlag = false;
        setItemLayout(0);
        submitRightBtn.setText("通过");
        submitLeftBrn.setText("不通过");
    }


    @Override
    protected void fillData(NutritionConsultant item) {
        super.fillData(item);
        //1-待审核，2-审批不通过，3-待入职，4-入职")
        if ("1".equals(item.getEntrystatus())) {
            submitLl.setVisibility(View.VISIBLE);
        } else {
            submitLl.setVisibility(View.GONE);
        }
    }

    @Override
    protected void onFindNutritionConsultant(NutritionConsultant ent) {
        if (null != ent) {
            //查询的员工存在
            staffInfoLl.setVisibility(View.VISIBLE);
            submitLl.setVisibility(View.VISIBLE);
            submitRightBtn.setVisibility(View.VISIBLE);
            submitLeftBrn.setVisibility(View.VISIBLE);
            //状态
            staffStatusLl.setVisibility(View.GONE);
            //支行信息
            bankProvinceDetailLl.setVisibility(View.GONE);
            //招聘来源
            recuitmentChannelLl.setVisibility(View.GONE);
            //有无亲属
            ifRelativesSelectorLl.setVisibility(View.GONE);
            //是否外包
            ifOutsourcingSelectorLl.setVisibility(View.GONE);
            submitRightBtn.setText("通过");
            submitLeftBrn.setText("不通过");
            fillData(ent);
        }
    }

    protected void submitRightBtnUpdata() {
        operatorId = staffid.getText().toString();
        if (StringUtil.isNullOrEmpty(operatorId)) {
            ToastUtil.show(this, "该员工工号缺失，无法进行审批操作");
            dismissDialog();
            return;
        }
        //"3"审批通过
        showDialog();
        staffInfoPersenter.approveStaffDataUpload(userInfo, operatorId, ConstantParams.CONSTANT_PARAMS_3);
    }

    @Override
    public void onClick(View v) {
        super.onClick(v);
        operatorId = staffid.getText().toString();
        if (v.getId() == R.id.submit_left_btn) {
            if (StringUtil.isNullOrEmpty(operatorId)) {
                ToastUtil.show(this, "该员工工号缺失，无法进行审批操作");
                dismissDialog();
                return;
            }
            //"2"审批不通过
            showDialog();
            staffInfoPersenter.approveStaffDataUpload(userInfo, operatorId, ConstantParams.CONSTANT_PARAMS_2);
        }
    }
}