package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo;

import android.content.DialogInterface;
import android.content.Intent;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.View;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.PublicTipDialog;
import com.wgmf.yxgj.global.AppConstants;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.model.EmployeeDimissionIsUnAuditStatusRequest;
import com.wgmf.yxgj.module.business.managestaff.model.EmployeeDimissionIsUnAuditStatusEntity;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.wgmf.yxgj.publics.service.StaffInfoCheck;
import com.wgmf.yxgj.utils.MyToast;
import com.xp.arouter.RouterParams;

/**
 * 离职办理
 */
@Route(path = RouterParams.URL_STAFFDIMISSIONACTIVITY)
public class StaffDissmissActivity extends StaffBaseActivity {

    /**
     * 离职待审核状态
     */
    private Boolean mDimissionReviewedStatus = false;

    @Override
    protected void onResume() {
        super.onResume();
        if (null != operatorId) {
            queryInfo(operatorId);
        }
        queryEmplIsHaveDimissionApply();
    }

    protected void submitRightBtnUpdata() {
        if (nutritionConsultant == null) {
            ToastUtil.show(this, "请先获取离职员工信息!");
            return;
        }
        if ("1".equals(nutritionConsultant.getStatus())) {
            ToastUtil.show(this, "该员工处于离职状态!\r\n无法继续操作!");
            return;
        }
        if (!mDimissionReviewedStatus) {
            jumpStaffDissmissDetailActivity();
        }
    }

    /**
     * 根据员工工号查询是否处于离职待审核状态
     */
    private void queryEmplIsHaveDimissionApply() {
        showDialog();
        String json = new Gson().toJson(new EmployeeDimissionIsUnAuditStatusRequest(operatorId));
        StaffManageService.getInstance().requestEmplIsHaveDimissionApply(json, this);
    }

    @Override
    protected void onFindNutritionConsultant(NutritionConsultant ent) {
        this.nutritionConsultant = ent;
        if (null != ent) {
//            fillData(ent);
//            staffInfoLl.setVisibility(View.VISIBLE);
            //查询的员工存在但已离职则不可离职
            staffInfoLl.setVisibility(View.GONE);
            dimissionInfoTv.setVisibility(View.VISIBLE);
            dimissionInfoTv.setText(staffInfoPersenter.getDimissionInfo(ent));
            //如果非已离职状态，可离职
            if (!"1".equals(ent.getStatus())) {
                submitLl.setVisibility(View.VISIBLE);
                submitLeftBrn.setVisibility(View.GONE);
                submitRightBtn.setVisibility(View.VISIBLE);
                submitRightBtn.setText("填写离职信息");
            } else {
                submitLl.setVisibility(View.VISIBLE);
                submitLeftBrn.setVisibility(View.GONE);
                submitRightBtn.setVisibility(View.VISIBLE);
                submitRightBtn.setText("不可操作");
                submitRightBtn.setOnClickListener(null);
                submitRightBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_week_normal_style));
                submitRightBtn.setTextColor(ContextCompat.getColor(this, R.color.common_txt_color));
            }
        }
    }


    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        if (null != result) {
            final int id = result.taskID;
            if (BusinessID.StaffManage.MSG_ON_EMPL_IS_HAVE_DIMISSION_APPLY == id) {
                final String msg = result.getInfo();
                if (!isFinishing() && result.isSuccessed()) {
                    EmployeeDimissionIsUnAuditStatusEntity entity = new Gson().fromJson(msg, EmployeeDimissionIsUnAuditStatusEntity.class);
                    Log.d(TAG, "EmployeeDimissionIsUnAuditStatusEntity=" + entity);
                    if (ConstantParams.CONSTANT_PARAMS_0.equals(entity.retCode)) {
                        this.mDimissionReviewedStatus = entity.getPayload();
                    } else {
                        showHttpTipDialog(entity.retInfo);
                    }
                } else {
                    MyToast.show(getString(R.string.request_data_fail));
                }
            }
        }
    }

    /**
     * 接口请求信息提示
     */
    private void showHttpTipDialog(String message) {
        final PublicTipDialog.Builder builder = new PublicTipDialog.Builder(this);
        builder.setTitle(R.string.tip);
        builder.setMessage(message);
        builder.setNegativeButton(R.string.confirm_btn_txt, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
                finish();
            }
        });
        builder.create().show();
    }


    @Override
    protected void fillData(NutritionConsultant item) {
        super.fillData(item);
        staffStatusTxt.setText(StaffInfoCheck.getStatus(item.getStatus()));
    }

    /**
     * 跳转到 StaffDissimissDetailActivity
     */
    private void jumpStaffDissmissDetailActivity() {
        Intent intent = new Intent(this, StaffDissimissDetailActivity.class);
        intent.putExtra(AppConstants.ExtraKeys.TURNOVER_EMPLOYEE_NAME, nutritionConsultant.getOperName());
        intent.putExtra(AppConstants.ExtraKeys.TURNOVER_EMPLOYEE_ID, operatorId);
        startActivity(intent);
        this.finish();
    }
}