package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.github.yoojia.inputs.ValueScheme;
import com.google.gson.Gson;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.dialog.PublicConformTipDialog;
import com.wgmf.yxgj.expand.StaticSchemeExpand;
import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.model.InterviewAssessmentEntity;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.wgmf.yxgj.module.business.managestaff.ui.interview.InterviewAssessmentActivity;
import com.wgmf.yxgj.widgets.MMessageDisplay;
import com.xp.arouter.RouterParams;

import java.util.List;

/**
 * 入职办理
 *
 * @author xiep
 */
@SuppressWarnings("all")
@Route(path = RouterParams.URL_STAFFENTRYACTIVITY)
public class StaffEntryActivity extends StaffBaseActivity {
    /**
     * 待上传用户信息
     */
    private NutritionConsultant uploadEnt;

    @Override
    protected void initLayout() {
        super.initLayout();
        editFlag = true;
        staffidLl.setVisibility(View.GONE);
        staffStatusLl.setVisibility(View.GONE);
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getDBStaffData();
        checkNutritionConsultant();
    }

    /**
     * 从数据库中获取人员信息
     */
    private void getDBStaffData() {
        String falg = getIntent().getStringExtra("falg");
        staffDbId = getIntent().getLongExtra("staffDbId", 0);
        if (StringUtil.isNotNullAndNotEmpty(falg) && "continueData".equals(falg)) {
            NutritionConsultant mNutritionConsultant = mNutritionConsultantDao.loadByRowId(staffDbId);
            Log.d("mNutritionConsultant=", mNutritionConsultant.toString());
            fillData(mNutritionConsultant);
        }
    }

    /**
     * 通过费销比检验营养顾问是否可以入职
     */
    private void checkNutritionConsultant() {
        if (userInfo != null) {
            showDialog();
            String staffid = userInfo.getStaffId();
            StaffManageService.getInstance().requestCheckNutritionConsultant(staffid, this);
        }
    }

    /**
     * 费销比检验结果
     *
     * @param isSuccessed true 通过；false 不通过
     */
    @Override
    public void checkNutritionConsultant(boolean isSuccessed) {
        if (isSuccessed) {
            isEntry();
        }
    }

    /**
     * 允许营养顾问入职
     */
    private void isEntry() {
        setItemLayout(1);
        bankProvinceDetailLl.setVisibility(View.VISIBLE);
        staffInfoLl.setVisibility(View.VISIBLE);
        submitLl.setVisibility(View.VISIBLE);
        submitLeftBrn.setVisibility(View.VISIBLE);
        submitLeftBrn.setText("暂存");
        submitRightBtn.setVisibility(View.VISIBLE);
        //入职办理不显示社保信息
        //是否购买社保
        isSocialSecurityLl.setVisibility(View.GONE);
        socialSecurityCityLl.setVisibility(View.GONE);
        oaCodeLl.setVisibility(View.GONE);
        //劳动合同开始时间
        beginDateContractLl.setVisibility(View.GONE);
        //劳动合同结束时间
        endDateContractLl.setVisibility(View.GONE);
        //劳动合同期限
        termContractLl.setVisibility(View.GONE);
    }

    /**
     * 检验面试评估信息
     *
     * @param mInterviewAssessmentEntity 面试评估数据
     */
    @Override
    public void checkInterviewAssemnet(InterviewAssessmentEntity mInterviewAssessmentEntity) {
        //如果入职人员没有面试评估信息，弹出对话框进入面试评估页面
        if (null == mInterviewAssessmentEntity) {
            mInterviewAssessmentEntity = new InterviewAssessmentEntity();
            if (StringUtil.isNotNullAndNotEmpty(name.getText().toString())) {
                mInterviewAssessmentEntity.setAuditionStaffName(name.getText().toString());
            }
            if (StringUtil.isNotNullAndNotEmpty(idCard.getText().toString())) {
                mInterviewAssessmentEntity.setAuditionStaffIdentityCard(idCard.getText().toString());
            }
            showTemporaryDialog(mInterviewAssessmentEntity);
        }
    }

    /**
     * 先填写面试评估
     */
    private void showTemporaryDialog(final InterviewAssessmentEntity mInterviewAssessmentEntity) {
        PublicConformTipDialog.Builder builder = new PublicConformTipDialog.Builder(this);
        builder.setTitle("提示");
        builder.setMessage(getString(R.string.interview_assessment_entry_tips));
        builder.setNegativeButton("确定", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                Intent intent = new Intent();
                intent.putExtra("name", mInterviewAssessmentEntity.getAuditionStaffName());
                intent.putExtra("idCard", mInterviewAssessmentEntity.getAuditionStaffIdentityCard());
                intent.setClass(StaffEntryActivity.this, InterviewAssessmentActivity.class);
                startActivity(intent);
                dialog.dismiss();
            }
        });
        builder.create().show();
    }

    protected void submitRightBtnUpdata() {
        temporarySave = false;
        if ("去返聘".equals(submitRightBtn.getText().toString())) {
            staffEntryTipLl.setVisibility(View.GONE);
            homeTitleText.setText("员工返聘");
            submitRightBtn.setText("提交");
            submitRightBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.selector_orange_stroke_round_btn));
            submitRightBtn.setTextColor(getResources().getColor(R.color.normal_color));
        } else if ("员工返聘".equals(homeTitleText.getText().toString())) {
            setUploadData();
        } else if ("入职办理".equals(homeTitleText.getText().toString()) && checkUploadData()) {
            //如果入职人员有面试评估信息，提交入职数据
            setUploadData();
        }
    }

    @Override
    public void onClick(View v) {
        super.onClick(v);
        if (v.getId() == R.id.submit_left_btn) {
            temporarySave = true;
            urlLists.clear();
            qiniuUrlLists.clear();
            setUploadData();
        }
    }

    /**
     * 员工返聘数据提交
     */
    private void doUploadRehire() {
        NutritionConsultant mNutritionConsultant = setStaffDataUpload();
        String content = new Gson().toJson(mNutritionConsultant);
        Log.d("doUploadRehire:", content);
        showDialog();
        StaffManageService.getInstance().requestUpdateUserRehire(content, this);
    }

    @Override
    protected void queryNutritionConsultan(String idCard) {
        super.queryNutritionConsultan(idCard);
        if (StringUtil.isNotNullAndNotEmpty(this.idCard.getText().toString())) {
            showDialog();
            StaffManageService.getInstance().requestQueryNutritionConsultant(idCard, userInfo.getOrganizationId(), this);
        } else {
            ToastUtil.show(this, "请输入身份证号码");
        }
    }

    @Override
    protected void getStaffAuditionAppraise(String idCard) {
        super.getStaffAuditionAppraise(idCard);
        if (StringUtil.isNotNullAndNotEmpty(name.getText().toString())) {
            if (StringUtil.isNotNullAndNotEmpty(this.idCard.getText().toString())) {
                showDialog();
                StaffManageService.getInstance().requestFindStaffAuditionAppraise(idCard, this);
            } else {
                dismissDialog();
                ToastUtil.show(this, "请输入身份证号码");
            }
        } else {
            dismissDialog();
            ToastUtil.show(this, "请输入姓名");
        }
    }

    /**
     * 将已填写入职信息存入数据库
     */
    private void temporarySaveDB() {
        NutritionConsultant ent = setStaffDataUpload();
        if (StringUtil.isNotNullAndNotEmpty(ent.getOperName())) {
            boolean updateFlag = false;
            List<NutritionConsultant> newEnt = mNutritionConsultantDao.loadAll();
            for (int i = 0; i < newEnt.size(); i++) {
                if (newEnt.get(i).getOperName().equals(name.getText().toString())) {
                    updateFlag = true;
                }
            }
            try {
                if (updateFlag) {
                    mNutritionConsultantDao.update(ent);
                } else {
                    mNutritionConsultantDao.insert(ent);
                }
            } catch (Exception e) {
                //已存在则更新数据
                mNutritionConsultantDao.insertOrReplaceInTx(ent);
                Log.d(TAG, ent.getOperName() + ":此条数据已存在。");
            }
            ToastUtil.show(this, "入职信息暂存成功！");
            this.finish();
        } else {
            ToastUtil.show(this, "请填写姓名！");
        }
        dismissDialog();
    }

    private void clearImageData() {
        urlLists.clear();
        qiniuUrlLists.clear();
    }

    /**
     * 入职信息暂存
     * 1,检查是否填写姓名
     * 2,将已填写信息存入数据库
     */
    @Override
    protected void setUploadData() {
        showDialog();
        //检查必填项(暂存不检查)
        if (!temporarySave) {
            if (!checkUploadData()) {
                dismissDialog();
                return;
            }
            if (TextUtils.isEmpty(name.getText().toString().trim())) {
                ToastUtil.show(this, "请输入员工姓名!");
                dismissDialog();
                return;
            }
            final String id = idCard.getText().toString().trim();
            if (id.length() == 15) {
                String date = birthday.getText().toString().replace("-", "")
                        .substring(2, 8);
                if (!date.equals(id.substring(6, 12))) {
                    ToastUtil.show(this, "身份证号或出生日期录入错误!");
                    dismissDialog();
                    return;
                }
            } else if (id.length() == 18) {
                String date = birthday.getText().toString().replace("-", "");
                if (!date.equals(id.substring(6, 14))) {
                    ToastUtil.show(this, "身份证号或出生日期录入错误!");
                    dismissDialog();
                    return;
                }
            } else {
                ToastUtil.show(this, "身份证号码长度应该为15或18位!");
                dismissDialog();
                return;
            }

            //返聘需要选择入职时间，入职时间必须在当前时间的前两天到当前时间的后两天这之间
            String entryDate = entrydate.getText().toString();
            if (!DateUtil.isTimeBeforeAndAfterTwoDays(entryDate)) {
                ToastUtil.show(this, "您输入的入职日期有误，请输入当天前后两天的日期!");
                dismissDialog();
                return;
            }

            if (!man.isChecked() && !women.isChecked()) {
                ToastUtil.show(this, "请选择性别!");
                dismissDialog();
                return;
            }
            if (!relativesYes.isChecked() && !relativesNo.isChecked()) {
                ToastUtil.show(this, "请选择有无亲属在本公司!");
                dismissDialog();
                return;
            }
            if (phone.getText().toString().trim().equals(urgencyPhone.getText().toString().trim())) {
                ToastUtil.show(this, "联系电话和紧急电话不能一样!");
                dismissDialog();
                return;
            }
            if (phone.getText().toString().trim().length() != 11 || !phone.getText().toString().startsWith("1")) {
                dismissDialog();
                ToastUtil.show(this, "联系电话填写有误，请检查！");
                return;
            }
            if (urgencyPhone.getText().toString().trim().length() != 11 || !urgencyPhone.getText().toString().startsWith("1")) {
                dismissDialog();
                ToastUtil.show(this, "紧急电话填写有误，请检查！");
                return;
            }

            if (getString(R.string.empty_etb_hint_select_txt).equals(store.getText().toString().trim())) {
                if ("流动营养顾问".equals(jobTv.getText().toString())) {
                    ToastUtil.show(this, "请选择主管!");
                } else {
                    ToastUtil.show(this, "请选择门店!");
                }
                dismissDialog();
                clearImageData();
                return;
            }
            if (getString(R.string.empty_etb_hint_select_txt).equals(communicationAllowance.getText().toString().trim())
                    || TextUtils.isEmpty(communicationAllowance.getText().toString().trim())) {
                ToastUtil.show(this, "请选择通讯补贴!");
                dismissDialog();
                clearImageData();
                return;
            }
        }
        dismissDialog();
        super.setUploadData();
    }

    @Override
    public void uploadData() {
        if (homeTitleText.getText().toString().contains("返聘")) {
            doUploadRehire();
            return;
        }
        if (!temporarySave) {
            //如果入职人员有面试评估信息，提交入职数据
            uploadEntyData();
        } else {
            //暂存
            temporarySaveDB();
        }
    }

    private void uploadEntyData() {
        showDialog();
        uploadEnt = setStaffDataUpload();
        String content = new Gson().toJson(uploadEnt);
        Log.d(TAG, content);
        StaffManageService.getInstance().requestEntryNutritionConsultant(content, this);
    }

    private boolean checkUploadData() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        //姓名校验
        inputs.add(name, StaticScheme.Required());
        //身份证校验
        inputs.add(idCard, StaticScheme.Required(), StaticScheme.ChineseIDCard());
        //出生日期校验
        inputs.add(birthday, StaticSchemeExpand.Required(birthday,""));
        //顾问品牌
        inputs.add(brandPick, StaticScheme.Required(), ValueScheme.NotEquals(getString(R.string.empty_etb_hint_select_txt)).msgOnFail("未选择顾问品牌"));
        //所属门店校验
        inputs.add(store, StaticSchemeExpand.Required(store,getString(R.string.empty_etb_hint_select_txt)));
        //入职日期校验
        inputs.add(entrydate, StaticSchemeExpand.Required(entrydate,""));
        //学历校验
        inputs.add(education, StaticSchemeExpand.Required(education,""));
        //籍贯校验
        inputs.add(province, StaticSchemeExpand.Required(province,""));
        //现住址
        inputs.add(address, StaticScheme.Required());
        //联系电话校验
        inputs.add(phone, StaticScheme.Required());
        //紧急联系人校验
        inputs.add(urgencyPerson, StaticScheme.Required());
        //紧急电话校验
        inputs.add(urgencyPhone, StaticScheme.Required());
        //招聘来源校验
        inputs.add(recuitmentChannel, StaticSchemeExpand.Required(recuitmentChannel,""));
        //开户银行校验
        //inputs.add(bankTv, StaticSchemeExpand.Required(bankTv,""));
        //银行账号校验
        //inputs.add(bankNo, StaticScheme.Required(), StaticScheme.Numeric());
        //开户省市校验
        //inputs.add(bankProvince, StaticSchemeExpand.Required(bankProvince,""));
        //开户行信息校验
        //inputs.add(bankProvinceDetail, StaticScheme.Required());
        //所在城市
        inputs.add(liveCity, StaticSchemeExpand.Required(liveCity,""));
        //基本工资校验
        inputs.add(salary, StaticSchemeExpand.Required(salary,""));
        if ("流动营养顾问".equals(jobTv.getText().toString().trim())) {
            //底薪增加值
            inputs.add(basicSalaryAdd, StaticSchemeExpand.Required(basicSalaryAdd,""));
        }
        //爱心工资校验
        inputs.add(loveSalary, StaticScheme.Required());
        //通讯补贴校验
        inputs.add(communicationAllowance, StaticSchemeExpand.Required(communicationAllowance,""));
        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);
        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            ToastUtil.show(this, "填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    @Override
    public void sendMessageToJPush(String operatorId) {
        //推送入职消息
        staffInfoPersenter.sendMessageToJPush(userInfo, operatorId);
    }

    /**
     * 提交入职人员信息成功后删除相应人员入职信息
     */
    public void deleteData(Long id) {
        mNutritionConsultantDao.deleteByKey(id);
    }

    @Override
    public void destoryView() {
        try {
            deleteData(uploadEnt.getId());
        } catch (Exception e) {
            Log.e(TAG, "destoryView: deleteData error");
        }
        super.destoryView();
    }

    @Override
    protected void onFindNutritionConsultant(NutritionConsultant nutritionConsultant) {
        this.nutritionConsultant = nutritionConsultant;
        if (null != nutritionConsultant) {
            //查询的员工存在
            staffInfoLl.setVisibility(View.VISIBLE);
            submitLl.setVisibility(View.VISIBLE);
            staffidLl.setVisibility(View.VISIBLE);
            fillData(nutritionConsultant);
        }
    }
}