package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.db.GreenDaoManager;
import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.ui.staffinfo.adapter.StaffInductionAdapter;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.List;

/**
 * 新员工入职办理
 * 作者：xiep on 2017/10/10 13:20
 * 邮箱：2975837870@qq.com
 */
@Route(path = RouterParams.URL_NEWSTAFFINDUCTIONACTIVITY)
public class StaffInductionActivity extends BaseParentAct implements StaffInductionAdapter.DataOnClickListener {

    LinearLayout newStaffInductionLl;
    ListView newStaffInductionLv;
    StaffInductionAdapter mSchedulingThreeAndCurrentDayAdapter;
    List<NutritionConsultant> mNutConsultantSchedulingList;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.new_staff_induction_activity);
        initTitle();
        initView();
        initData();
    }

    private void initData() {
        mNutConsultantSchedulingList = new ArrayList<>();
        mNutritionConsultantDao = GreenDaoManager.getInstance().getDaoSession(this).getNutritionConsultantDao();
    }

    private void initView() {
        newStaffInductionLv = (ListView) findViewById(R.id.new_staff_induction_lv);
        View headerView = getLayoutInflater().inflate(R.layout.new_staff_induction_header_view, null);
        newStaffInductionLv.addHeaderView(headerView);
        TextView nutconsultantSchedulingHeaderTv = (TextView) findViewById(R.id.new_staff_induction_header_tv);
        nutconsultantSchedulingHeaderTv.setText(R.string.continue_last_save_txt);

        newStaffInductionLl = (LinearLayout) findViewById(R.id.new_staff_induction_ll);
        newStaffInductionLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent();
                intent.putExtra("branchID", 535L);
                intent.putExtra("branchTitle", "入职办理");
                intent.setClass(StaffInductionActivity.this, StaffEntryActivity.class);
                startActivity(intent);
            }
        });
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("员工入职");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void onResume() {
        super.onResume();
        getDBdata();
    }

    public void getDBdata() {
        mNutConsultantSchedulingList.clear();
        mNutConsultantSchedulingList = mNutritionConsultantDao.loadAll();
        mSchedulingThreeAndCurrentDayAdapter = new StaffInductionAdapter(mNutConsultantSchedulingList, this, this);
        newStaffInductionLv.setAdapter(mSchedulingThreeAndCurrentDayAdapter);
    }

    /**
     * 继续编辑入职信息
     */
    @Override
    public void continueData(Long staffDbId) {
        Intent intent = new Intent();
        intent.putExtra("branchID", 535L);
        intent.putExtra("branchTitle", "入职办理");
        intent.putExtra("falg", "continueData");
        intent.putExtra("staffDbId", staffDbId);
        intent.setClass(StaffInductionActivity.this, StaffEntryActivity.class);
        startActivity(intent);
    }

    /**
     * 删除入职信息
     */
    @Override
    public void deleteData(Long staffDbId) {
        mNutritionConsultantDao.deleteByKey(staffDbId);
        getDBdata();
    }
}