package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo;

import android.content.DialogInterface;
import android.content.Intent;
import android.support.annotation.NonNull;
import android.util.Log;
import android.widget.EditText;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.PublicConformTipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.OeRoleParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.model.CommonUserinfoBean;
import com.wgmf.yxgj.model.MessageExtraEntity;
import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.model.InterviewAssementEntity;
import com.wgmf.yxgj.module.business.managestaff.model.NutrSalaryProCityEntity;
import com.wgmf.yxgj.module.business.managestaff.model.NutrSalaryProCityResultEntity;
import com.wgmf.yxgj.module.business.managestaff.model.NutritionConsultanEntryResponse;
import com.wgmf.yxgj.module.business.managestaff.model.NutritionConsultantQueryResponse;
import com.wgmf.yxgj.module.business.managestaff.model.Outsourced;
import com.wgmf.yxgj.module.business.managestaff.model.OutsourcedList;
import com.wgmf.yxgj.module.business.managestaff.model.StaffAuditionAppraiseList;
import com.wgmf.yxgj.module.business.managestaff.model.TrainTutorEntity;
import com.wgmf.yxgj.module.business.managestaff.model.TrainTutorList;
import com.wgmf.yxgj.publics.service.StaffInfoCheck;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.service.MainService;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;

import java.util.ArrayList;
import java.util.List;

/**
 * 作者：xiep on 2017/9/11 13:10
 * 邮箱：2975837870@qq.com
 */
public class StaffInfoPersenter {
    private static final String TAG = "StaffInfoPersenter";
    private StaffInfoView staffInfoView;

    public StaffInfoPersenter(@NonNull StaffInfoView staffInfoView) {
        this.staffInfoView = staffInfoView;
    }

    /**
     * 外包公司数据转化
     *
     * @param mOutsourced 外包公司数据
     * @return 公共列表数据
     */
    List<BaseSelectorEntity> getOutsourced(List<Outsourced> mOutsourced) {
        List<BaseSelectorEntity> mBaseSelectorEntitys = new ArrayList<>();
        for (Outsourced outsourced : mOutsourced) {
            BaseSelectorEntity mModel = new BaseSelectorEntity();
            mModel.setSelectorName(outsourced.getOutsourcedNanme());
            mModel.setSelectorId(outsourced.getOutsourcedNo());
            mBaseSelectorEntitys.add(mModel);
        }
        return mBaseSelectorEntitys;
    }

    /**
     * 员工离职信息加工
     *
     * @param ent 员工信息
     * @return 员工离职显示信息
     */
    @SuppressWarnings("all")
    String getDimissionInfo(NutritionConsultant ent) {
        String status = "0".equals(ent.getStatus()) ? "在职" : "离职";
        String job = "1".equals(ent.getRoleStatus()) ?
                " 所属门店:" + StaffInfoCheck.getShopName(ent.getShopList())
                : " 上级主管:" + ent.getOrgName();
        return " 姓        名:" + ent.getOperName() + "\r\n"
                + " 性        别:" + StaffInfoCheck.getSex(ent.getSex()) + "\r\n"
                + " 职        位:" + StaffInfoCheck.getPosition(ent.getRoleStatus()) + "\r\n"
                + job + "\r\n"
                + " 顾问品牌:" + StaffInfoCheck.getBrandName(ent.getBrandList()) + "\r\n"
                + " 学        历:" + StaffInfoCheck.getDegree(ent.getXlId()) + "\r\n"
                + " 身份证号:" + ent.getPersonalId() + "\r\n"
                + " 出生日期:" + ent.getBirthday() + "\r\n"
                + " 籍        贯:" + ent.getRyjg() + "\r\n"
                + " 入职日期:" + ent.getWorkDate() + "\r\n"
                + " 状        态:" + status + "\r\n"
                + " 联系电话:" + ent.getMobilePhone() + "\r\n"
                + StaffInfoCheck.getValue(" 紧急联系人:", ent.getEmergencyName())
                + StaffInfoCheck.getValue(" 紧急电话", ent.getPhone())
                + " 开户银行:" + ent.getBankName() + "\r\n"
                + " 银行账号:" + ent.getAccountId() + "\r\n"
                + " 开户省市:" + ent.getBankCity() + "\r\n"
                + " 所在城市:" + ent.getShopSlaryAdress() + "\r\n"
                + " 底薪标准:" + ent.getJbNet() + "元" + "\r\n"
                + StaffInfoCheck.getValue(" 通讯补贴:", ent.getCommSubsidy())
                + " 爱心工资:" + ent.getAxNet() + "元" + "\r\n";
    }

    /**
     * 校验薪资及补贴
     *
     * @param type    工资类型
     * @param max     上限
     * @param massage 出错提示
     */
    boolean checkSaraly(EditText type, int max, String massage) {
        try {
            double x = Double.parseDouble(type.getText().toString().trim());
            if (x > max) {
                staffInfoView.showTip(massage);
                return false;
            }

        } catch (NumberFormatException e) {
            staffInfoView.showTip("录入错误!\r\n只能输入数字!");
            return false;
        }
        return true;
    }

    /**
     * 入职审批实体
     *
     * @author XiePing
     */
    private class ApprovalEntity {
        // 1-待审核，2-审批不通过，3-待入职，4-入职
        String entrystatus;
        // 组织机构ID
        String approvalPerson;
        // 入职员工工号
        String operatorId;
    }

    /**
     * 提交入职审批信息
     */
    void approveStaffDataUpload(CommonUserinfoBean userInfo, String operatorId, String status) {
        ApprovalEntity ent = new ApprovalEntity();
        ent.approvalPerson = userInfo.getStaffId();
        ent.operatorId = operatorId;
        ent.entrystatus = status;
        String content = new Gson().toJson(ent);
        Log.d(TAG, content);
        StaffManageService.getInstance().requestApproveNutritionConsultant(content, (StaffBaseActivity) staffInfoView);
    }

    /**
     * 推送JPush消息
     */
    void sendMessageToJPush(CommonUserinfoBean userInfo, String operatorId) {
        if (OeRoleParams.OE_ROLE_PARAMS_7.equals(userInfo.getOrganizationCode())) {
            //区域经理入职不用推送审核消息
            return;
        }
        MessageExtraEntity mMessageExtraEntity = new MessageExtraEntity();
        mMessageExtraEntity.setOperatorId(operatorId);
        mMessageExtraEntity.setType(ConstantParams.CONSTANT_PARAMS_1);
        String sendStaffId = PrefTool.getStringPerferences((StaffBaseActivity) staffInfoView, Prefs.PRE_USER_STAFFID);
        String recieverStaffId = PrefTool.getStringPerferences((StaffBaseActivity) staffInfoView, Prefs.PRE_USER_STAFF_LEADERID);
        // 接收者类型 （2 指定的 tag ，3 指定的alias，4 广播：对 app_key下的所有用户推送消息）
        String receiverType = ConstantParams.CONSTANT_PARAMS_3;
        String extra = new Gson().toJson(mMessageExtraEntity);
        String type = ConstantParams.CONSTANT_PARAMS_1;
        String msgTitle = "入职审批";
        String msgContent = userInfo.getName() + "主管提交营养顾问入职申请，请进行审批。";
        MainService.getInstance().requestSendMessage(sendStaffId, recieverStaffId, receiverType, extra, type, msgTitle, msgContent, (StaffBaseActivity) staffInfoView);
    }

    /**
     * 显示错误信息对话框
     *
     * @param resultInfo 服务器返回错误信息
     */
    private void showErrorDialog(String resultInfo) {
        final PublicConformTipDialog.Builder builder = new PublicConformTipDialog.Builder((StaffBaseActivity) staffInfoView);
        builder.setTitle("提示");
        builder.setMessage(resultInfo);
        builder.setNegativeButton("我知道了", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
                staffInfoView.destoryView();
            }
        });
        builder.create().show();
    }

    /**
     * 根据接口返回数据进行服务切换
     *
     * @param result 服务器返回数据
     */
    void switchService(ResultData result) {
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.StaffManage.MSG_ON_QUERY_NUTRITION_CONSULTANT: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        NutritionConsultantQueryResponse mNutritionConsultantQueryResponse = new Gson().fromJson(msg, NutritionConsultantQueryResponse.class);
                        Log.d(TAG, "mNutritionConsultantQueryResponse=" + mNutritionConsultantQueryResponse);
                        if (null != mNutritionConsultantQueryResponse && ConstantParams.CONSTANT_PARAMS_0.equals(mNutritionConsultantQueryResponse.msgCode)) {
                            List<NutritionConsultant> mNutritionConsultants = mNutritionConsultantQueryResponse.getResult();
                            if (null != mNutritionConsultants && !mNutritionConsultants.isEmpty()) {
                                NutritionConsultant mNutritionConsultant = mNutritionConsultants.get(0);
                                //如果查询该员工存在，首先填充员工信息数据
                                staffInfoView.findNutritionConsultant(mNutritionConsultant);
                                if (ConstantParams.CONSTANT_PARAMS_1.equals(mNutritionConsultant.getStatus())) {
                                    //如果该员工离职，进入返聘流程,使用身份证查询员工数据
                                    staffInfoView.reEmployNutritionConsultant(mNutritionConsultant);
                                } else {
                                    //如果该员工在职，不在组织内，进入不可操作流程
//                                    if(mNutritionConsultant.getSaleOrganization())
                                    staffInfoView.modifyNutritionConsultant(mNutritionConsultant);
                                }
                            }
                        } else {
                            //如果该员工不存在，询问进入面试评估流程
                            staffInfoView.enterInterview();
                        }
                    }
                    staffInfoView.showTip(result.getResultInfo());
                }
                break;
                case BusinessID.StaffManage.MSG_ON_UPDATE_USER_REHIRE:
                case BusinessID.StaffManage.MSG_ON_UPDATE_NUTRITION_CONSULTANT:
                case BusinessID.StaffManage.MSG_ON_APPROVE_NUTRITIONCONSULTANT:
                case BusinessID.StaffManage.MSG_ON_RESIGN_NUTRITIONCONSULTANT: {
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        staffInfoView.destoryView();
                    }
                    staffInfoView.showTip(result.getResultInfo());
                }
                break;
                case BusinessID.StaffManage.MSG_ON_ENTRY_NUTRITIONCONSULTANT: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        NutritionConsultanEntryResponse mNutritionConsultanEntryResponse = new Gson().fromJson(msg, NutritionConsultanEntryResponse.class);
                        Log.d(TAG, "mNutritionConsultanEntryResponse=" + mNutritionConsultanEntryResponse);
                        if (null != mNutritionConsultanEntryResponse && null != mNutritionConsultanEntryResponse.getResult()) {
                            staffInfoView.sendMessageToJPush(mNutritionConsultanEntryResponse.getResult().getOperatorId());
                        }
                        staffInfoView.destoryView();
                    }
                    staffInfoView.showTip(result.getResultInfo());
                }
                break;
                case BusinessID.StaffManage.MSG_ON_CHECK_NUTRITION_CONSULTANT: {
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        staffInfoView.checkNutritionConsultant(true);
                    } else {
                        staffInfoView.checkNutritionConsultant(false);
                        showErrorDialog(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.StaffManage.MSG_ON_FIND_TRAIN_TUTOR: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        TrainTutorList mTrainTutorList = new Gson().fromJson(msg, TrainTutorList.class);
                        if (null != mTrainTutorList.getResult()) {
                            TrainTutorEntity mTrainTutorEntitys = mTrainTutorList.getResult();
                            if (null != mTrainTutorEntitys) {
                                staffInfoView.findTrainTutor(mTrainTutorEntitys);
                            }
                        }
                    } else {
                        staffInfoView.showTip("未查询到带培导师信息");
                    }
                }
                break;
                case BusinessID.StaffManage.MSG_ON_FIND_OUT_SOURCED: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        OutsourcedList mOutsourcedList = new Gson().fromJson(msg, OutsourcedList.class);
                        if (null != mOutsourcedList.getResultList()) {
                            List<Outsourced> mOutsourced = mOutsourcedList.getResultList();
                            if (!mOutsourced.isEmpty()) {
                                staffInfoView.findOutsourced(mOutsourced);
                            }
                        }
                    } else {
                        staffInfoView.showTip(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.StaffManage.MSG_ON_FIND_STAFF_AUDITION_APPRAISE: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        InterviewAssementEntity mIntermviewAssementList = new Gson().fromJson(msg, InterviewAssementEntity.class);
                        Log.d(TAG, "mIntermviewAssementList=" + mIntermviewAssementList.toString());
                        if (null != mIntermviewAssementList.getResult()) {
                            StaffAuditionAppraiseList mStaffAuditionAppraiseList = mIntermviewAssementList.getResult();
                            //营养顾问面试评估校验开关： ‘1’ 开启；‘2’关闭
                            if ("1".equals(mStaffAuditionAppraiseList.getOpenFlag())) {
                                staffInfoView.interviewIsSuccessed(true);
                                if (mStaffAuditionAppraiseList.getStaffAuditionAppraiseList().isEmpty()) {
                                    //未提交面试评估
                                    staffInfoView.checkInterviewAssemnet(null);
                                } else {
                                    staffInfoView.checkInterviewAssemnet(mStaffAuditionAppraiseList.getStaffAuditionAppraiseList().get(0));
                                }
                            } else {
                                staffInfoView.interviewIsSuccessed(false);
                            }
                        }
                    }
                }
                break;
                case BusinessID.StaffManage.MSG_ON_GET_NUTRCONSULTANT_SALARY:
                    final String msg = result.getInfo();
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        NutrSalaryProCityResultEntity mNutrSalaryProCityResultEntity = new Gson().fromJson(msg, NutrSalaryProCityResultEntity.class);
                        Log.d(TAG, "mNutrSalaryProCityResultEntity=" + mNutrSalaryProCityResultEntity.toString());
                        //选择底薪所在城市弹框
                        if (mNutrSalaryProCityResultEntity.getResultList() != null && !mNutrSalaryProCityResultEntity.getResultList().isEmpty()) {
                            staffInfoView.showNutrSalaryProCity(mNutrSalaryProCityResultEntity.getResultList());
                        }
                    } else {
                        staffInfoView.showTip(result.getResultInfo());
                    }
                    break;
                default:
                    break;
            }
        }
    }

    void selectorStore(Intent data) {
        BaseSelectorEntity mBaseSelectorEntity = (BaseSelectorEntity) data.getSerializableExtra(SelectorBaseActivity.STORE_TAG);
        staffInfoView.selectorStore(mBaseSelectorEntity);
    }

    void selectorProvince(Intent data) {
        String mProvince = data.getStringExtra("province");
        String mCity = data.getStringExtra("city");
        staffInfoView.selectorProvince(mProvince, mCity);
    }

    void selectorBankprovince(Intent data) {
        String mProvince = data.getStringExtra("province");
        String mCity = data.getStringExtra("city");
        staffInfoView.selectorBankprovince(mProvince, mCity);
    }

    void selectorSalaryCity(Intent data) {
        NutrSalaryProCityEntity mNutrSalaryProCityEntity = (NutrSalaryProCityEntity) data.getSerializableExtra(SelectorBaseActivity.STORE_TAG);
        staffInfoView.selectorSalaryCity(mNutrSalaryProCityEntity);
    }
}