package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo.adapter

import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.yxgj.model.NutritionConsultant
import com.wgmf.yxgj.module.business.managestaff.R

/**
 * 顾问列表适配器
 * @author LW
 */
class SelectorConsultantAdapter(
    entity: List<NutritionConsultant>,
    private val staffId: String
) : BaseQuickAdapter<NutritionConsultant, BaseViewHolder>(
    R.layout.selector_staff_list_item,
    entity
) {

    override fun convert(
        helper: BaseViewHolder?,
        item: NutritionConsultant?
    ) {
        helper?.apply {
            item?.let {
                if (it.operatorId.equals(staffId)) {
                    setText(
                        R.id.selector_staff_name_tv,
                        mContext.getString(R.string.selector_consultant_my, it.operName)
                    )
                } else {
                    setText(
                        R.id.selector_staff_name_tv, it.operName
                    )
                }

                setText(
                    R.id.selector_staff_id_tv,
                    it.operatorId
                )
            }
        }
    }
}