package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.publics.service.StaffInfoCheck;

import java.util.List;

/**
 * 作者：xiep on 2017/10/10 13:48
 * 邮箱：2975837870@qq.com
 */

public class SelectorStaffAdapter extends BaseAdapter {

    private List<NutritionConsultant> list;
    private Context context;
    private DataOnClickListener mDataOnClickListener;

    public interface DataOnClickListener {
        void getNutritionConsultant(NutritionConsultant mNutritionConsultant);
    }

    public SelectorStaffAdapter(List<NutritionConsultant> mlist, Context context, DataOnClickListener mDataOnClickListener) {
        this.list = mlist;
        this.context = context;
        this.mDataOnClickListener = mDataOnClickListener;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.selector_staff_list_item, null);
            viewHolder = new ViewHolder();
            viewHolder.selectorStaffNameTv = convertView.findViewById(R.id.selector_staff_name_tv);
            viewHolder.selectorStaffIdTv = convertView.findViewById(R.id.selector_staff_id_tv);
            viewHolder.selectorStaffSexTv = convertView.findViewById(R.id.selector_staff_sex_tv);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        final NutritionConsultant ent = list.get(position);
        viewHolder.selectorStaffNameTv.setText(ent.getOperName());
        viewHolder.selectorStaffIdTv.setText(ent.getOperatorId());
        viewHolder.selectorStaffSexTv.setText(StaffInfoCheck.getStatus(ent.getStatus()));
        convertView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                mDataOnClickListener.getNutritionConsultant(ent);
            }
        });
        return convertView;
    }

    class ViewHolder {
        TextView selectorStaffNameTv;
        TextView selectorStaffIdTv;
        TextView selectorStaffSexTv;
    }
}