package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.widgets.TextView.MarqueeTextView;

import java.util.List;

/**
 * 作者：xiep on 2017/10/10 13:48
 * 邮箱：2975837870@qq.com
 */

public class StaffInductionAdapter extends BaseAdapter {

    private List<NutritionConsultant> list;
    private Context context;
    private DataOnClickListener mDataOnClickListener;

    public interface DataOnClickListener {
        void continueData(Long staffDbId);

        void deleteData(Long staffDbId);
    }

    public StaffInductionAdapter(List<NutritionConsultant> mlist, Context context, DataOnClickListener mDataOnClickListener) {
        this.list = mlist;
        this.context = context;
        this.mDataOnClickListener = mDataOnClickListener;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.new_staff_induction_list_item, null);
            viewHolder = new ViewHolder();
            viewHolder.newStaffInductionName = (MarqueeTextView) convertView.findViewById(R.id.new_staff_induction_name);
            viewHolder.newStaffInductionTime = (MarqueeTextView) convertView.findViewById(R.id.new_staff_induction_time);
            viewHolder.continueBtnTv = (TextView) convertView.findViewById(R.id.continue_btn_tv);
            viewHolder.deleteBtnTv = (TextView) convertView.findViewById(R.id.delete_btn_tv);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        final NutritionConsultant ent = list.get(position);
        viewHolder.newStaffInductionName.setText(ent.getOperName());
        viewHolder.newStaffInductionTime.setText(ent.getNewStaffInductionTime());
        viewHolder.continueBtnTv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                mDataOnClickListener.continueData(ent.getId());
            }
        });
        viewHolder.deleteBtnTv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                mDataOnClickListener.deleteData(ent.getId());
            }
        });
        return convertView;
    }

    class ViewHolder {
        TextView continueBtnTv;
        TextView deleteBtnTv;
        MarqueeTextView newStaffInductionName;
        MarqueeTextView newStaffInductionTime;
    }
}