package com.wgmf.yxgj.module.business.memberday.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.global.LocationParams;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.module.business.memberday.R;
import com.wgmf.yxgj.module.business.memberday.model.SearchStoreByStaffIdListEntity;
import com.wgmf.yxgj.module.business.memberday.service.MemberDayService;
import com.wgmf.yxgj.publics.model.ShopDataEntity;
import com.wgmf.yxgj.publics.model.ShopDataListEntity;
import com.wgmf.yxgj.publics.service.PublicService;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 会员日下店签到签退
 *
 * @author XiePing
 */
@Route(path = RouterParams.URL_MENBERDAYACTIVITY)
public class MemberDayActivity extends BaseParentAct implements MemberDayShopListAdapter.ClickListener {

    protected String branchTitle;
    private ClearEditText clearEditText;
    private TextView menberDayCheckTipsTv;
    private LinearLayout menberDayCheckTipsLl;

    private ListView memberDayListViewLv1;
    private ListView memberDayListViewLv2;
    private List<ShopDataEntity> menberDayShopLists1 = new ArrayList<>();
    private List<ShopDataEntity> menberDayShopLists2 = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_menber_day);
        initTitle();
        initContent();
        checkCusDay();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initContent() {
        initView();
        initListView1();
        initListView2();
    }

    private void initView() {
        menberDayCheckTipsTv = (TextView) findViewById(R.id.menber_day_check_tips_tv);
        menberDayCheckTipsLl = (LinearLayout) findViewById(R.id.menber_day_check_tips_ll);
        clearEditText = (ClearEditText) findViewById(R.id.menber_day_query_cet);
        clearEditText.setVisibility(View.VISIBLE);
        Button menberDayQueryBtn = (Button) findViewById(R.id.menber_day_query_btn);
        menberDayQueryBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //模糊查询
                String queryStore = clearEditText.getText().toString().trim();
                if (queryStore.length() > 0) {
                    getShopList("5000", queryStore);
                } else {
                    showMsg("请输入门店搜索！");
                }
            }
        });
        // 默认不弹出软键盘
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
    }

    /**
     * 初始化历史记录门店列表
     */
    private void initListView1() {
        memberDayListViewLv1 = (ListView) findViewById(R.id.member_day_list_view_lv1);
        View headerView1 = getLayoutInflater().inflate(R.layout.member_day_header_view1, null);
        memberDayListViewLv1.addHeaderView(headerView1);
        headerView1.setOnClickListener(null);
        TextView memberDayHeaderTv1 = (TextView) findViewById(R.id.member_day_header_tv1);
        memberDayHeaderTv1.setText(R.string.member_day_header_tv1);
    }

    /**
     * 初始化附近门店列表
     */
    private void initListView2() {
        memberDayListViewLv2 = (ListView) findViewById(R.id.member_day_list_view_lv2);
        View headerView2 = getLayoutInflater().inflate(R.layout.member_day_header_view2, null);
        memberDayListViewLv2.addHeaderView(headerView2);
        headerView2.setOnClickListener(null);
        TextView memberDayHeaderTv2 = (TextView) findViewById(R.id.member_day_header_tv2);
        memberDayHeaderTv2.setText(R.string.member_day_header_tv2);
    }

    /**
     * 刷新列表数据
     */
    private void refreshListView() {
        MemberDayShopListAdapter menberDayShopListAdapter1 = new MemberDayShopListAdapter(menberDayShopLists1, this, this);
        MemberDayShopListAdapter menberDayShopListAdapter2 = new MemberDayShopListAdapter(menberDayShopLists2, this, this);
        memberDayListViewLv1.setAdapter(menberDayShopListAdapter1);
        memberDayListViewLv2.setAdapter(menberDayShopListAdapter2);
        ListViewUtil.setListViewHeight(memberDayListViewLv1);
        ListViewUtil.setListViewHeight(memberDayListViewLv2);
    }

    /**
     * 判断是否为会员日
     */
    private void checkCusDay() {
        showDialog();
        Date date1 = DateUtil.string2Date(DateUtil.getFormatCurrentDate("yyyy-MM-dd"), "yyyy-MM-dd");
        String ymd = DateUtil.format(date1, "yyyyMMdd");
        MemberDayService.getInstance().requestCheckCusDay(ymd, this);
    }

    /**
     * 根据工号获取该员工最近搜索的4家门店
     */
    private void getSearchStoreByStaffId() {
        showDialog();
        String staffId = userInfo.getStaffId();
        MemberDayService.getInstance().requestGetSearchStoreByStaffId(staffId, this);
    }

    /**
     * 获取附近门店数据
     */
    private void getShopList(String pageSize, String keyWords) {
        if (null != userInfo) {
            String url = NetworkParams.URL_SHOP_GET_NEAREST;
            String orgCode = userInfo.getOrganizationCode();
            String currentPage = ConstantParams.CONSTANT_PARAMS_1;
            String lat = LocationParams.Latitude;
            String lng = LocationParams.Longitude;
            // 发送管理门店数据请求
            showDialog();
            PublicService.getInstance().requestgetNearestShop(url, keyWords, orgCode, currentPage, pageSize, lng, lat, this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.MemberDay.MSG_ON_CHECK_CUS_DAY:
                case BusinessID.MemberDay.MSG_ON_SAVE_SEARCH_STORE: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        if (!ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.msgCode)) {
                            menberDayCheckTipsLl.setVisibility(View.VISIBLE);
                            menberDayCheckTipsTv.setText(mBaseResponse.retInfo);
                        } else {
                            //最近搜索的4家门店
                            getSearchStoreByStaffId();
                            getShopList(ConstantParams.CONSTANT_PARAMS_4, "");
                        }
                    } else {
                        showMsg(getString(R.string.request_data_fail));
                    }
                }
                break;
                case BusinessID.MemberDay.MSG_ON_GET_SEARCH_STORE_BY_STAFFID: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        SearchStoreByStaffIdListEntity searchStoreByStaffIdListEntity = new Gson().fromJson(msg, SearchStoreByStaffIdListEntity.class);
                        Log.d(TAG, "searchStoreByStaffIdListEntity=" + searchStoreByStaffIdListEntity.toString());
                        if (null != searchStoreByStaffIdListEntity.getResult() && !searchStoreByStaffIdListEntity.getResult().isEmpty()) {
                            menberDayShopLists1 = searchStoreByStaffIdListEntity.getResult();
                            refreshListView();
                        }
                    } else {
                        showMsg(getString(R.string.request_data_fail));
                    }
                }
                break;
                case BusinessID.Publics.MSG_ON_SHOP_GET_NEAREST: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        ShopDataListEntity mGetNearestShopDataListEntity = new Gson().fromJson(msg, ShopDataListEntity.class);
                        Log.d(TAG, "mGetNearestShopDataListEntity=" + mGetNearestShopDataListEntity.toString());
                        menberDayShopLists2.clear();
                        if (!mGetNearestShopDataListEntity.getData().isEmpty()) {
                            menberDayShopLists2 = mGetNearestShopDataListEntity.getData();
                            refreshListView();
                        } else {
                            getShopList(ConstantParams.CONSTANT_PARAMS_4, "");
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    @Override
    public void menberDayAdapterClick(ShopDataEntity shopDataEntity) {
        updateHistory(shopDataEntity);
        Intent intent = new Intent(MemberDayActivity.this, MemberDayDetailActivity.class);
        intent.putExtra("shopId", shopDataEntity.getStoreId());
        intent.putExtra("shopName", shopDataEntity.getStoreName());
        intent.putExtra("longitude", shopDataEntity.getLng());
        intent.putExtra("latitude", shopDataEntity.getLat());
        intent.putExtra("branchTitle", branchTitle);
        startActivity(intent);
    }

    private void updateHistory(ShopDataEntity shopDataEntity) {
        showDialog();
        shopDataEntity.setStaff(userInfo.getStaffId());
        String memDaySignSercahStore = new Gson().toJson(shopDataEntity);
        Log.d(TAG, "保存搜索记录:" + memDaySignSercahStore);
        MemberDayService.getInstance().requestSaveSearchStore(memDaySignSercahStore, this);
    }
}