package com.wgmf.yxgj.module.business.memberday.ui;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.global.LocationParams;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.LocationUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.basewebview.ui.HtmlFragment;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.model.CommonResourcesBean;
import com.wgmf.yxgj.module.business.memberday.R;
import com.wgmf.yxgj.module.business.memberday.model.MemDaySignImgListEntity;
import com.wgmf.yxgj.module.business.memberday.model.MemDaySignShowListEntity;
import com.wgmf.yxgj.module.business.memberday.model.MemDaySignVoEntity;
import com.wgmf.yxgj.module.business.memberday.model.ShopCusDaySaleAmountListEntity;
import com.wgmf.yxgj.module.business.memberday.service.MemberDayService;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.io.File;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @author XiePing
 */
@SuppressWarnings("all")
public class MemberDayDetailActivity extends ReportWithPhotoBaseActivity implements ImagePickerLayout.ImagePicker, View.OnClickListener , HtmlFragment.OnChangeTitleListener {
    String branchTitle;

    TextView listItemSignInTimeTxt;

    LinearLayout listItemSignInTxtLl;

    LinearLayout listItemSignInLl;

    TextView listItemSignOutTimeTxt;

    LinearLayout listItemSignOutTxtLl;

    ImagePickerLayout idImagePickerSignIn;

    ImagePickerLayout idImagePickerSignOut;

    LinearLayout listItemSignOutLl;

    LinearLayout listItemSignLl;

    private MemDaySignVoEntity memDaySignVoEntity = new MemDaySignVoEntity();

    private double storeLatitudes;
    private double storeLongitudes;
    /**
     * 当前年月日
     */
    private String ymd;

    private ShopCusDaySaleAmountListEntity shopCusDaySaleAmountListEntity;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getMemDaySignShow();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleBackLl.setVisibility(View.VISIBLE);
        branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
    }

    @Override
    protected void initData() {
        super.initData();
        //会员日下店
        reportType = "XD";
        shopId = getIntent().getStringExtra("shopId");
        shopName = getIntent().getStringExtra("shopName");
        ymd = DateUtil.getFormatMonth("yyyyMMdd", 0);
    }

    @Override
    protected void setListHeadAndFootView() {
        super.setListHeadAndFootView();
        View headerView = getLayoutInflater().inflate(R.layout.activity_menber_day_heared_view, null);
        publicListViewLv.addHeaderView(headerView);
        BaseCommonAdapter<CommonResourcesBean> mAdapter = new BaseCommonAdapter<CommonResourcesBean>(
                this, new ArrayList<CommonResourcesBean>()) {
            @Override
            public void convert(ViewHolder helper, CommonResourcesBean item) {
                helper.setText(item.getName());
            }
        };
        publicListViewLv.setAdapter(mAdapter);

        if (findViewById(R.id.activity_webview_content_frg) != null) {
            HtmlFragment htmlFragment = new HtmlFragment();
            Bundle htmlBundle = new Bundle();
            htmlBundle.putString("shopId", shopId);
            htmlBundle.putString("shopName", shopName);
            htmlBundle.putString("ymd", ymd);
            htmlBundle.putString("branchUrl", "/mkt-front/html/nativePages/memberDayChart.html");
            htmlFragment.setArguments(htmlBundle);
            getSupportFragmentManager().beginTransaction().add(R.id.activity_webview_content_frg, htmlFragment).commit();
        }
    }

    @Override
    protected void parseHeadData() {
        super.parseHeadData();
        listItemSignLl = (LinearLayout) findViewById(R.id.list_item_sign_ll);
        listItemSignInLl = (LinearLayout) findViewById(R.id.list_item_sign_in_ll);
        listItemSignInTxtLl = (LinearLayout) findViewById(R.id.list_item_sign_in_txt_ll);
        listItemSignOutLl = (LinearLayout) findViewById(R.id.list_item_sign_out_ll);
        listItemSignOutTxtLl = (LinearLayout) findViewById(R.id.list_item_sign_out_txt_ll);
        listItemSignInTimeTxt = (TextView) findViewById(R.id.list_item_sign_in_time_txt);
        listItemSignOutTimeTxt = (TextView) findViewById(R.id.list_item_sign_out_time_txt);
        initSignInDisplayView();
        initSignOutDisplayView();
    }

    private void initSignInDisplayView() {
        idImagePickerSignIn = (ImagePickerLayout) findViewById(R.id.id_image_picker_sign_in);
        idImagePickerSignIn.setTitle("签到拍照");
        idImagePickerSignIn.setTip("（最多可添加3张图片）");
        idImagePickerSignIn.setImagePicker(this);
        idImagePickerSignIn.setSizePhotoNum(3);
        idImagePickerSignIn.setMaxPhotoNum(3);
        idImagePickerSignIn.setmImageselectList(mImageselectList);
        idImagePickerSignIn.setImagePickerView(idImagePickerSignIn);
        idImagePickerSignIn.setOlnyViewMode(false);
    }

    private void initSignOutDisplayView() {
        idImagePickerSignOut = (ImagePickerLayout) findViewById(R.id.id_image_picker_sign_out);
        idImagePickerSignOut.setTitle("签退拍照");
        idImagePickerSignOut.setTip("（最多可添加3张图片）");
        idImagePickerSignOut.setImagePicker(this);
        idImagePickerSignOut.setSizePhotoNum(3);
        idImagePickerSignOut.setMaxPhotoNum(3);
        idImagePickerSignOut.setmImageselectList(mImageselectList);
        idImagePickerSignOut.setImagePickerView(idImagePickerSignOut);
        idImagePickerSignOut.setOlnyViewMode(false);
    }

    @Override
    protected void parseFootData() {
        super.parseFootData();
        tvSummary.setVisibility(View.GONE);
        reportEdit.setVisibility(View.GONE);
        reportContentConfirmLl.setVisibility(View.GONE);
    }

    /**
     * 会员日下店签到签退(销售金额,签到状态)
     */
    private void getMemDaySignShow() {
        showDialog();
        storeLatitudes = getIntent().getDoubleExtra("latitude", 0);
        storeLongitudes = getIntent().getDoubleExtra("longitude", 0);
        String staffId = userInfo.getStaffId();
        MemberDayService.getInstance().requestGetMemDaySignShow(staffId, shopId, ymd, this);
    }

    /**
     * 提交会员日全员下店签到数据
     */
    private void saveSignIn() {
        showDialog();
        if (urlLists == null || urlLists.isEmpty()) {
            ToastUtil.show(this, "请选择上传图片");
            dismissDialog();
            return;
        }
        //设置签到数据
        List<MemDaySignImgListEntity> memDaySignImgLists = new ArrayList<>();
        for (int i = 0; i < urlLists.size(); i++) {
            MemDaySignImgListEntity memDaySignImgList = new MemDaySignImgListEntity();
            memDaySignImgList.setFlag(0);
            memDaySignImgList.setImgUrl(urlLists.get(i));
            memDaySignImgLists.add(memDaySignImgList);
        }
        memDaySignVoEntity.setMemDaySignImgList(memDaySignImgLists);
        memDaySignVoEntity.setShopId(shopId);
        memDaySignVoEntity.setShopName(shopName);
        memDaySignVoEntity.setStaffId(userInfo.getStaffId());
        memDaySignVoEntity.setYmd(ymd);
        String memDaySign = new Gson().toJson(memDaySignVoEntity);
        Log.d(TAG, "签到:" + memDaySign);
        MemberDayService.getInstance().requestMemDaySign(memDaySign, this);
    }

    /**
     * 提交会员日全员下店签退数据
     */
    private void saveSignOut() {
        if (urlLists == null || urlLists.isEmpty()) {
            ToastUtil.show(this, "请选择上传图片");
            dismissDialog();
            return;
        }
        //设置签退数据
        List<MemDaySignImgListEntity> memDaySignImgLists = new ArrayList<>();
        for (int i = 0; i < urlLists.size(); i++) {
            MemDaySignImgListEntity memDaySignImgList = new MemDaySignImgListEntity();
            memDaySignImgList.setFlag(1);
            memDaySignImgList.setImgUrl(urlLists.get(i));
            memDaySignImgLists.add(memDaySignImgList);
        }
        memDaySignVoEntity.setMemDaySignImgList(memDaySignImgLists);
        memDaySignVoEntity.setShopId(shopId);
        memDaySignVoEntity.setShopName(shopName);
        memDaySignVoEntity.setStaffId(userInfo.getStaffId());
        memDaySignVoEntity.setYmd(ymd);
        String memDaySign = new Gson().toJson(memDaySignVoEntity);
        Log.d(TAG, "签退:" + memDaySign);
        MemberDayService.getInstance().requestSaveSignOut(memDaySign, this);
    }


    @Override
    protected void uploadData() {
        super.uploadData();
        if (signStatus == 0) {
            //签到
            saveSignIn();
        } else if (signStatus == 1) {
            //签退
            saveSignOut();
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.MemberDay.MSG_ON_MEM_DAY_SIGN_SHOW: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        MemDaySignShowListEntity memDaySignShowListEntity = new Gson().fromJson(msg, MemDaySignShowListEntity.class);
                        if (null != memDaySignShowListEntity.getResult()) {
                            shopCusDaySaleAmountListEntity = memDaySignShowListEntity.getResult();
                            setSignImage();
                            setSignStatus();
                        }
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                }
                break;
                case BusinessID.MemberDay.MSG_ON_MEM_DAY_SIGN: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.msgCode)) {
                            MemberDayDetailActivity.this.finish();
                        }
                        ToastUtil.show(this, mBaseResponse.retInfo);
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                }
                break;
                case BusinessID.MemberDay.MSG_ON_SAVE_SIGN_OUT: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.msgCode)) {
                            MemberDayDetailActivity.this.finish();
                        }
                        ToastUtil.show(this, mBaseResponse.retInfo);
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    private void setSignImage() {
        listItemSignLl.setVisibility(View.VISIBLE);
        listItemSignInLl.setVisibility(View.VISIBLE);
        MemDaySignVoEntity memDaySign = shopCusDaySaleAmountListEntity.getMemDaySign();
        if (null != memDaySign) {
            List<MemDaySignImgListEntity> memDaySignImgListEntitys = memDaySign.getMemDaySignImgList();
            if (null != memDaySignImgListEntitys && !memDaySignImgListEntitys.isEmpty()) {
                memDaySignInImgListEntitys.clear();
                memDaySignOutImgListEntitys.clear();
                for (int i = 0; i < memDaySignImgListEntitys.size(); i++) {
                    if (memDaySignImgListEntitys.get(i).getFlag() == 0) {
                        //签到图片
                        listItemSignInLl.setVisibility(View.VISIBLE);
                        idImagePickerSignIn.setVisibility(View.VISIBLE);
                        listItemSignInTxtLl.setVisibility(View.VISIBLE);
                        listItemSignInTimeTxt.setVisibility(View.VISIBLE);
                        listItemSignInTimeTxt.setText(memDaySignImgListEntitys.get(i).getCreateTime());
                        String path = memDaySignImgListEntitys.get(i).getImgUrl();
                        ImageItem imageItem = new ImageItem();
                        imageItem.setImgneturl(path);
                        imageItem.setImagePath(path);
                        imageItem.setUri(Uri.fromFile(new File(path)));
                        imageItem.setType(1);
                        memDaySignInImgListEntitys.add(imageItem);
                    } else if (memDaySignImgListEntitys.get(i).getFlag() == 1) {
                        //签退图片
                        listItemSignOutLl.setVisibility(View.VISIBLE);
                        idImagePickerSignOut.setVisibility(View.VISIBLE);
                        listItemSignOutTxtLl.setVisibility(View.VISIBLE);
                        listItemSignOutTimeTxt.setVisibility(View.VISIBLE);
                        listItemSignOutTimeTxt.setText(memDaySignImgListEntitys.get(i).getCreateTime());
                        String path = memDaySignImgListEntitys.get(i).getImgUrl();
                        ImageItem imageItem = new ImageItem();
                        imageItem.setImgneturl(path);
                        imageItem.setImagePath(path);
                        imageItem.setUri(Uri.fromFile(new File(path)));
                        imageItem.setType(1);
                        memDaySignOutImgListEntitys.add(imageItem);
                    }
                }
            }
            showSignInImage();
            showSignOutImage();
        }
    }

    private void showSignInImage() {
        if (!memDaySignInImgListEntitys.isEmpty()) {
            listItemSignInTxtLl.setVisibility(View.VISIBLE);
            listItemSignInTimeTxt.setVisibility(View.VISIBLE);
            listItemSignInLl.setVisibility(View.VISIBLE);
            setImagePickerSigin(idImagePickerSignIn, memDaySignInImgListEntitys);
        }
    }

    private void showSignOutImage() {
        if (!memDaySignOutImgListEntitys.isEmpty()) {
            listItemSignOutTxtLl.setVisibility(View.VISIBLE);
            listItemSignOutTimeTxt.setVisibility(View.VISIBLE);
            listItemSignOutLl.setVisibility(View.VISIBLE);
            setImagePickerSigin(idImagePickerSignOut, memDaySignOutImgListEntitys);
        }
    }

    private void setImagePickerSigin(ImagePickerLayout idImagePickerSign, ArrayList<ImageItem> memDaySignInImgListEntitys) {
        idImagePickerSign.setTitleVisibility(View.GONE);
        idImagePickerSign.setTipVisibility(View.GONE);
        idImagePickerSign.setImagePicker(this);
        idImagePickerSign.setSizePhotoNum(3);
        idImagePickerSign.setMaxPhotoNum(3);
        idImagePickerSign.setmImageselectList(memDaySignInImgListEntitys);
        idImagePickerSign.setImagePickerView(idImagePickerSign);
        idImagePickerSign.setOlnyViewMode(true);
        idImagePickerSign.setImagePickerView(idImagePickerSign);
        idImagePickerSign.setmImageselectList(memDaySignInImgListEntitys);
        idImagePickerSign.refreshPhotoContentView(memDaySignInImgListEntitys);
    }

    ArrayList<ImageItem> memDaySignInImgListEntitys = new ArrayList<>();
    ArrayList<ImageItem> memDaySignOutImgListEntitys = new ArrayList<>();

    /**
     * 检查是否在签到范围内（1000米）
     *
     * @return 是否在门店范围内（1000米）true:是
     */
    private boolean checkSignPosition() {
        double distance = LocationUtil.getDistance
                (storeLatitudes, storeLongitudes,
                        StringUtil.toDouble(LocationParams.Latitude),
                        StringUtil.toDouble(LocationParams.Longitude));
        return distance <= 1000;
    }

    /**
     * 检查是否上传图片
     *
     * @return true:已上传图片
     */
    private boolean checkSignImg() {
        if (null != idImagePickerContainer && null != idImagePickerContainer.getmImageselectList()) {
            return !idImagePickerContainer.getmImageselectList().isEmpty();
        }
        return false;
    }

    /**
     * 签到签退状态：0：签到 1：签退
     */
    private int signStatus;

    /**
     * 设置签到状态
     * <p>
     * 按钮文案及状态
     * 场景                           按钮文案                   操作
     * 在门店1km附近未签到              签到                     签到
     * 未拍照上传未签到                 签到                     不可签到
     * 不在门店1km附近未签到            签到                      签到
     * 无法获取当前地理位置             签到                      签到
     * 未拍照上传未签退                 签退                      不可签退
     * 在门店1km附近签到满8小时         签退                      签退
     * 未在门店1km附近签到满8小时        签退                     签退
     * 无法获取当前位置签到满8小时       签退                     签退
     * 签到未满8小时                    签退                    不可签退
     * 签到签退已完成                   打卡完成                 不可点击
     */
    private void setSignStatus() {
        if (null != shopCusDaySaleAmountListEntity.getMemDaySign() && null != shopCusDaySaleAmountListEntity.getMemDaySign().getSignInTime()) {
            setSignOutView();
        } else {
            setSignInView();
        }
    }

    /**
     * 签退
     */
    private void setSignOutView() {
        //2，签退
        signStatus = 1;
        idImagePickerSignOut.setVisibility(View.VISIBLE);
        listItemSignOutLl.setVisibility(View.VISIBLE);
        reportContentConfirmBtn.setText("签退");
        reportContentConfirmLl.setVisibility(View.VISIBLE);
        reportContentComfirmTipTxt.setVisibility(View.VISIBLE);
        reportContentConfirmBtn.setOnClickListener(this);
        reportContentConfirmBtn.setBackgroundColor(ContextCompat.getColor(this, R.color.normal_color));
        MemDaySignVoEntity memDaySign = shopCusDaySaleAmountListEntity.getMemDaySign();
        // 0:已签到 1:打卡完成
        if (memDaySign.getStatus() == 0) {
            //接口获取的签到时间
            signInDate = memDaySign.getSignInTime();
            if (null != signInDate) {
                if (checkSignInTime()) {
                    //2.5 签到时间足8小时，允许签退
                    reportContentComfirmTipTxt.setText("上班时间已满8小时，可正常签退");
                } else {
                    //2.6 签到时间不足8小时，不允许签退；（2.6.0版本不足8小时允许签退）
                    handler.postDelayed(runnable, 100);
                    reportContentComfirmTipTxt.setText(checkSignInTimeStr);
                }
            }
            if (checkSignPosition()) {
                //2.1 当前位置在门店附近，允许签退
                reportContentComfirmTipTxt.setText("当前位置在门店附近");
            } else {
                //2.2 当前位置未在门店附近，允许签退
                reportContentComfirmTipTxt.setText("当前位置未在门店附近");
            }
            setSignImg(!checkSignImg(), "请拍照后再签退");
        } else if (memDaySign.getStatus() == 1) {
            //3，打卡完成
            //图片选择不可见
            publicTakePhotoLl.setVisibility(View.GONE);
            reportContentComfirmTipTxt.setVisibility(View.GONE);
            reportContentConfirmBtn.setOnClickListener(null);
            reportContentConfirmBtn.setBackgroundColor(ContextCompat.getColor(this, R.color.common_txt_color));
            reportContentConfirmBtn.setText("打卡完成");
        }
    }

    private void setSignImg(boolean b, String s) {
        if (b) {
            //2.3,未拍照上传未签到,不可签到
            reportContentComfirmTipTxt.setText(s);
            reportContentConfirmBtn.setOnClickListener(null);
            reportContentConfirmBtn.setBackgroundColor(ContextCompat.getColor(this, R.color.common_txt_color));
        } else {
            //2.4,已拍照上传未签到,可签到
            reportContentConfirmBtn.setOnClickListener(this);
            reportContentConfirmBtn.setBackgroundColor(ContextCompat.getColor(this, R.color.normal_color));
        }
    }

    /**
     * 签到
     */
    private void setSignInView() {
        //1，签到
        signStatus = 0;
        listItemSignInLl.setVisibility(View.VISIBLE);
        idImagePickerSignIn.setVisibility(View.VISIBLE);
        reportContentConfirmBtn.setText("签到");
        reportContentConfirmLl.setVisibility(View.VISIBLE);
        reportContentComfirmTipTxt.setVisibility(View.VISIBLE);
        reportContentConfirmBtn.setOnClickListener(this);
        reportContentConfirmBtn.setBackgroundColor(ContextCompat.getColor(this, R.color.normal_color));
        if (checkSignPosition()) {
            //1.1，在门店1km附近未签到，可签到
            reportContentComfirmTipTxt.setText("当前位置在门店附近");
        } else {
            //1.2，不在门店1km附近未签到，可签到
            reportContentComfirmTipTxt.setText("当前位置不在门店附近");
        }
        setSignImg(null != signInDate && !checkSignImg(), "请拍照后再签到请拍照后再签到");
    }

    @Override
    protected void onResume() {
        super.onResume();
        try {
            setSignStatus();
        } catch (Exception e) {
            setSignInView();
        }
    }

    private String checkSignInTimeStr = "未获取到签到时间！";
    /**
     * 签到时间
     */
    private String signInDate = "2018-01-01 00:00:00";

    /**
     * 检查签到时间是否已满8小时
     *
     * @return true：满8小时
     */
    private boolean checkSignInTime() {
        SimpleDateFormat dfs = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date signInTime;
        try {
            //当前时间
            Date currentDate = dfs.parse(dfs.format(new Date()));
            signInTime = dfs.parse(signInDate);
            //签退时间=签到时间+8个小时
            long between = ((signInTime.getTime() + 8 * (60 * 60 * 1000)) - currentDate.getTime()) / 1000;
            long hour = between % (24 * 60 * 60) / (60 * 60);
            long minute = between % (60 * 60) / 60;
            long second = between % 60;
            checkSignInTimeStr = "距离签到满8小时时间还有： " + hour + "时:" + minute + "分:" + second + "秒";
            //(签退时间-当前时间)<=0为true,已达到签退时间，可签退
            return between <= 0;
        } catch (ParseException e) {
            e.printStackTrace();
            return false;
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.report_content_confirm_btn) {
            showDialog();
            imgType = true;
            setUploadData();
        }
    }

    private Handler handler = new Handler();
    private Runnable runnable = new Runnable() {
        @Override
        public void run() {
            this.update();
            // 间隔1秒
            handler.postDelayed(this, 1000);
        }

        void update() {
            //刷新msg的内容
            if (!checkSignInTime()) {
                reportContentComfirmTipTxt.setText(checkSignInTimeStr);
            }
            //如果已拍照，而未到签到时间可签退
            setSignImg(!checkSignImg(), "请拍照后再签退");
        }
    };

    @Override
    public void setSelectDialog(int selectType,View view) {
        idImagePickerContainer = (ImagePickerLayout) view;
        setSelectDialogListeners(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //拍照处理
                takePhoto(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                hideSelectDialog();
            }
        });
        showSelectDialog("选择图片", null, "相机拍照", "取消");
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, com.xp.pro.imagepickerlib.global.Params.TAKE_PICTURE);
    }

    @Override
    public void toPhotoPreview(int i, ArrayList<ImageItem> arrayList) {
        toPhotoPreviewFragment(i, arrayList);//大图显示
    }

    @Override
    public void changeTitle(String title) {

    }
}