package com.wgmf.yxgj.module.business.memberday.ui;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.memberday.R;
import com.wgmf.yxgj.module.business.memberday.model.MemDaySignListEntity;
import com.wgmf.yxgj.module.business.memberday.model.MemDaySignVoEntity;
import com.wgmf.yxgj.module.business.memberday.service.MemberDayService;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.xp.arouter.RouterParams;

/**
 * 会员日下店情况报表
 *
 * @author XiePing
 */
@Route(path = RouterParams.URL_MENBERDAYLISTACTIVITY)
public class MemberDayListActivity extends SelectorBaseActivity implements MemberDayListAdapter.ClickListener {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getData();
    }

    private void getData() {
        if (null != userInfo) {
            showDialog();
            String staffId = userInfo.getStaffId();
            MemberDayService.getInstance().requestGetMemDaySign(staffId, this);
        }
    }


    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleBackLl.setVisibility(View.VISIBLE);
        branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
    }

    @Override
    public void initContent() {
        super.initContent();
        storeNameEt.setVisibility(View.GONE);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if(id==BusinessID.MemberDay.MSG_ON_GET_MEM_DAY_SIGN){
                    final String msg = result.getInfo();
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        MemDaySignListEntity memDaySignListEntity = new Gson().fromJson(msg, MemDaySignListEntity.class);
                        if (null != memDaySignListEntity&&null != memDaySignListEntity.getResult() && !memDaySignListEntity.getResult().isEmpty()) {
                                MemberDayListAdapter menberDayListAdapter = new MemberDayListAdapter(memDaySignListEntity.getResult(), this, this);
                                mListView.setAdapter(menberDayListAdapter);
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
            }
        }
    }

    @Override
    public void menberDayAdapterClick(MemDaySignVoEntity shopDataEntity) {
        Intent intent = new Intent();
        intent.putExtra("ymd", shopDataEntity.getYmd());
        intent.putExtra("shopId", shopDataEntity.getShopId());
        intent.putExtra("shopName", shopDataEntity.getShopName());
        intent.putExtra("signId", shopDataEntity.getId());
        intent.putExtra("branchTitle", branchTitle);
        intent.setClass(MemberDayListActivity.this, MemberDayQueryActivity.class);
        startActivity(intent);
    }
}