package com.wgmf.yxgj.module.business.memberday.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.module.business.memberday.R;
import com.wgmf.yxgj.module.business.memberday.model.MemDaySignVoEntity;

import java.util.Date;
import java.util.List;

/**
 * @author XiePing
 */

public class MemberDayListAdapter extends BaseAdapter {

    private Context context;
    private List<MemDaySignVoEntity> memDaySignVoEntity;

    private ClickListener clickListener;

    public interface ClickListener {
        void menberDayAdapterClick(MemDaySignVoEntity shopDataEntity);
    }

    MemberDayListAdapter(List<MemDaySignVoEntity> memDaySignVoEntity, Context context, ClickListener clickListener) {
        this.memDaySignVoEntity = memDaySignVoEntity;
        this.clickListener = clickListener;
        this.context = context;
    }

    @Override
    public int getCount() {
        return memDaySignVoEntity == null ? 0 : memDaySignVoEntity.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.list_item_menber_day, null);
            holder.ym = (TextView) convertView.findViewById(R.id.list_item_menber_day_ym);
            holder.shopName = (TextView) convertView.findViewById(R.id.list_item_menber_day_shopname);
            holder.saleaCount = (TextView) convertView.findViewById(R.id.list_item_menber_day_saleacount);
            holder.status = (TextView) convertView.findViewById(R.id.list_item_menber_day_status);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final MemDaySignVoEntity memDaySignEntity = memDaySignVoEntity.get(position);
        holder.shopName.setText(memDaySignEntity.getShopName());
        holder.saleaCount.setText(memDaySignVoEntity.get(position).getSaleaCount() + "元");
        holder.status.setText(getStatus(memDaySignEntity.getStatus()));
        if (memDaySignEntity.getYmd().length() > 7) {
            int years = Integer.parseInt(memDaySignEntity.getYmd().substring(0, 4));
            int months = Integer.parseInt(memDaySignEntity.getYmd().substring(4, 6));
            int days = Integer.parseInt(memDaySignEntity.getYmd().substring(6, 8));
            holder.ym.setText(years + "年" + months + "月" + days + "日");
        }
        convertView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickListener.menberDayAdapterClick(memDaySignEntity);
            }
        });
        return convertView;
    }

    private String getStatus(int status) {
        if (status == 0) {
            return "已签到";
        } else {
            return "打卡完成";
        }
    }

    class ViewHolder {
        /**
         * 会员日年月
         */
        TextView ym;
        /**
         * 门店名称
         */
        TextView shopName;
        /**
         * 会员日销售金额
         */
        TextView saleaCount;
        /**
         * 状态 0:已签到 1:打卡完成
         */
        TextView status;
    }
}