package com.wgmf.yxgj.module.business.memberday.ui;

import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentTransaction;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.basewebview.ui.HtmlFragment;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.memberday.R;
import com.wgmf.yxgj.module.business.memberday.model.MemDaySignImgListEntity;
import com.wgmf.yxgj.module.business.memberday.model.MemDaySignShowListEntity;
import com.wgmf.yxgj.module.business.memberday.model.ShopCusDaySaleAmountListEntity;
import com.wgmf.yxgj.module.business.memberday.service.MemberDayService;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;
import com.xp.pro.imagepickerlib.widgets.photoview.LocalFloatPhotoPreview;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

/**
 * @author XiePing
 */
public class MemberDayQueryActivity extends BaseParentAct implements ImagePickerLayout.ImagePicker , HtmlFragment.OnChangeTitleListener{

    TextView listItemSignInTimeTxt;

    TextView listItemSignOutTimeTxt;

    LinearLayout listItemSignInLl;

    LinearLayout listItemSignOutLl;

    LinearLayout listItemSignInTxtLl;

    LinearLayout listItemSignOutTxtLl;

    ImagePickerLayout idImagePickerSignIn;

    ImagePickerLayout idImagePickerSignOut;

    LinearLayout listItemSignLl;

    private String shopId;

    private String shopName;

    private String staffId;

    private String signId;

    private String ymd;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        initData();
        initView();
        initTitle();
        getMemDaySignImgAndSaleCount();
    }

    private void initData() {
        staffId = userInfo.getStaffId();
        shopId = getIntent().getStringExtra("shopId");
        shopName = getIntent().getStringExtra("shopName");
        signId = getIntent().getStringExtra("signId");
        ymd = getIntent().getStringExtra("ymd");
    }

    private void initView() {
        setContentView(R.layout.activity_menber_day_query_detail);
        listItemSignLl = (LinearLayout) findViewById(R.id.list_item_sign_ll);
        listItemSignInLl = (LinearLayout) findViewById(R.id.list_item_sign_in_ll);
        listItemSignInTxtLl = (LinearLayout) findViewById(R.id.list_item_sign_in_txt_ll);
        listItemSignOutLl = (LinearLayout) findViewById(R.id.list_item_sign_out_ll);
        listItemSignOutTxtLl = (LinearLayout) findViewById(R.id.list_item_sign_out_txt_ll);
        listItemSignInTimeTxt = (TextView) findViewById(R.id.list_item_sign_in_time_txt);
        listItemSignOutTimeTxt = (TextView) findViewById(R.id.list_item_sign_out_time_txt);
        idImagePickerSignIn = (ImagePickerLayout) findViewById(R.id.id_image_picker_sign_in);
        idImagePickerSignOut = (ImagePickerLayout) findViewById(R.id.id_image_picker_sign_out);
        if (findViewById(R.id.activity_webview_content_frg) != null) {
            HtmlFragment htmlFragment = new HtmlFragment();
            Bundle htmlBundle = new Bundle();
            htmlBundle.putString("shopId", shopId);
            htmlBundle.putString("shopName", shopName);
            htmlBundle.putString("ymd", ymd);
            htmlBundle.putString("branchUrl", "/mkt-front/html/nativePages/memberDayChart.html");
            htmlFragment.setArguments(htmlBundle);
            getSupportFragmentManager().beginTransaction().add(R.id.activity_webview_content_frg, htmlFragment).commit();
        }
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleBackLl.setVisibility(View.VISIBLE);
        String branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
    }

    public void getMemDaySignImgAndSaleCount() {
        showDialog();
        MemberDayService.getInstance().requestGetShopCusDaySaleAmount(signId, staffId, shopId, ymd, this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.MemberDay.MSG_ON_GET_SHOP_CUS_DAY_SALE_AMOUNT) {
                final String msg = result.getInfo();
                if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                    MemDaySignShowListEntity memDaySignShowListEntity = new Gson().fromJson(msg, MemDaySignShowListEntity.class);
                    if (null != memDaySignShowListEntity.getResult()) {
                        ShopCusDaySaleAmountListEntity shopCusDaySaleAmountListEntity = memDaySignShowListEntity.getResult();
                        setSignImage(shopCusDaySaleAmountListEntity);
                    }
                } else {
                    showMsg(result.getResultInfo());
                }
            }
        }
    }

    ArrayList<ImageItem> memDaySignInImgListEntitys = new ArrayList<>();
    ArrayList<ImageItem> memDaySignOutImgListEntitys = new ArrayList<>();

    private void setSignImage(ShopCusDaySaleAmountListEntity shopCusDaySaleAmountListEntity) {
        List<MemDaySignImgListEntity> memDaySignImgListEntitys = shopCusDaySaleAmountListEntity.getMemDaySignImgList();
        if (!memDaySignImgListEntitys.isEmpty()) {
            memDaySignInImgListEntitys.clear();
            memDaySignOutImgListEntitys.clear();
            listItemSignLl.setVisibility(View.VISIBLE);
            for (int i = 0; i < memDaySignImgListEntitys.size(); i++) {
                if (memDaySignImgListEntitys.get(i).getFlag() == 0) {
                    //签到图片
                    listItemSignInTimeTxt.setText(memDaySignImgListEntitys.get(i).getCreateTime());
                    String path = memDaySignImgListEntitys.get(i).getImgUrl();
                    ImageItem imageItem = new ImageItem();
                    imageItem.setImgneturl(path);
                    imageItem.setImagePath(path);
                    imageItem.setUri(Uri.fromFile(new File(path)));
                    imageItem.setType(1);
                    memDaySignInImgListEntitys.add(imageItem);
                } else if (memDaySignImgListEntitys.get(i).getFlag() == 1) {
                    //签退图片
                    listItemSignOutTimeTxt.setText(memDaySignImgListEntitys.get(i).getCreateTime());
                    String path = memDaySignImgListEntitys.get(i).getImgUrl();
                    ImageItem imageItem = new ImageItem();
                    imageItem.setImgneturl(path);
                    imageItem.setImagePath(path);
                    imageItem.setUri(Uri.fromFile(new File(path)));
                    imageItem.setType(1);
                    memDaySignOutImgListEntitys.add(imageItem);
                }
            }
        }
        showSignInImage();
        showSignOutImage();
    }

    private void showSignInImage() {
        if (!memDaySignInImgListEntitys.isEmpty()) {
            listItemSignInTxtLl.setVisibility(View.VISIBLE);
            listItemSignInTimeTxt.setVisibility(View.VISIBLE);
            listItemSignInLl.setVisibility(View.VISIBLE);
            setImagePickerSigin(idImagePickerSignIn, memDaySignInImgListEntitys);
        } else {
            idImagePickerSignIn.setVisibility(View.GONE);
            listItemSignInLl.setVisibility(View.GONE);
        }
    }

    private void showSignOutImage() {
        if (!memDaySignOutImgListEntitys.isEmpty()) {
            listItemSignOutTxtLl.setVisibility(View.VISIBLE);
            listItemSignOutTimeTxt.setVisibility(View.VISIBLE);
            listItemSignOutLl.setVisibility(View.VISIBLE);
            setImagePickerSigin(idImagePickerSignOut, memDaySignOutImgListEntitys);
        } else {
            idImagePickerSignOut.setVisibility(View.GONE);
            listItemSignOutLl.setVisibility(View.GONE);
        }
    }

    private void setImagePickerSigin(ImagePickerLayout idImagePickerSign, ArrayList<ImageItem> memDaySignInImgListEntitys) {
        idImagePickerSign.setTitleVisibility(View.GONE);
        idImagePickerSign.setTipVisibility(View.GONE);
        idImagePickerSign.setImagePicker(this);
        idImagePickerSign.setSizePhotoNum(3);
        idImagePickerSign.setMaxPhotoNum(3);
        idImagePickerSign.setmImageselectList(memDaySignInImgListEntitys);
        idImagePickerSign.setImagePickerView(idImagePickerSign);
        idImagePickerSign.setOlnyViewMode(true);
        idImagePickerSign.setImagePickerView(idImagePickerSign);
        idImagePickerSign.setmImageselectList(memDaySignInImgListEntitys);
        idImagePickerSign.refreshPhotoContentView(memDaySignInImgListEntitys);
    }

    @Override
    public void setSelectDialog(int selectType,View view) {
    }

    private LocalFloatPhotoPreview mLocalFloatPhotoPreview;

    @Override
    public void toPhotoPreview(int i, ArrayList<ImageItem> arrayList) {
        if (null == mLocalFloatPhotoPreview) {
            mLocalFloatPhotoPreview = new LocalFloatPhotoPreview();
            mLocalFloatPhotoPreview.setCurIndex(i);
            mLocalFloatPhotoPreview.setAllImages(arrayList);
            final FragmentManager fragmentManager = getSupportFragmentManager();
            final FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.setCustomAnimations(R.anim.qz_comm_scale_in, 0);
            transaction.add(android.R.id.content, mLocalFloatPhotoPreview);
            transaction.commitAllowingStateLoss();
        } else {
            removePhotoPreviewFragment();
        }
    }

    /**
     * 移除大图浮层
     *
     * @return
     */
    public boolean removePhotoPreviewFragment() {
        if (null != mLocalFloatPhotoPreview) {
            final FragmentManager fragmentManager = getSupportFragmentManager();
            final FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.setCustomAnimations(0, R.anim.qz_comm_scale_out);
            transaction.remove(mLocalFloatPhotoPreview);
            transaction.commitAllowingStateLoss();
            mLocalFloatPhotoPreview = null;
            return true;
        }
        return false;
    }

    @Override
    public void onBackPressed() {
        if (!isFinishing()) {
            if (!removePhotoPreviewFragment()) {
                super.onBackPressed();
            }
        }
    }

    @Override
    public void changeTitle(String title) {

    }
}