package com.wgmf.yxgj.module.business.memberday.ui;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.base.BaseActivity;
import com.wgmf.yxgj.module.business.memberday.R;
import com.wgmf.yxgj.publics.model.ShopDataEntity;

import java.util.List;

class MemberDayShopListAdapter extends BaseAdapter {

    private List<ShopDataEntity> list;
    private BaseActivity context;

    private ClickListener clickListener;

    public interface ClickListener {
        void menberDayAdapterClick(ShopDataEntity shopDataEntity);
    }

    MemberDayShopListAdapter(List<ShopDataEntity> mlist, BaseActivity context, ClickListener clickListener) {
        this.list = mlist;
        this.context = context;
        this.clickListener = clickListener;
    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.member_day_list_view, null);
            viewHolder = new ViewHolder();
            viewHolder.store = (TextView) convertView.findViewById(R.id.member_day_list_tv);
            viewHolder.storeLl = (LinearLayout) convertView.findViewById(R.id.member_day_list_ll);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        final ShopDataEntity shopDataEntity = list.get(position);
        viewHolder.store.setText(shopDataEntity.getStoreName());
        viewHolder.storeLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickListener.menberDayAdapterClick(shopDataEntity);
            }
        });
        return convertView;
    }

    class ViewHolder {
        TextView store;
        LinearLayout storeLl;
    }
}