package com.wgmf.yxgj.db;

import android.database.Cursor;
import android.database.sqlite.SQLiteStatement;

import org.greenrobot.greendao.AbstractDao;
import org.greenrobot.greendao.Property;
import org.greenrobot.greendao.internal.DaoConfig;
import org.greenrobot.greendao.database.Database;
import org.greenrobot.greendao.database.DatabaseStatement;

import com.wgmf.yxgj.model.CommonResourcesBean;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "COMMON_RESOURCES_BEAN".
*/
public class CommonResourcesBeanDao extends AbstractDao<CommonResourcesBean, Long> {

    public static final String TABLENAME = "COMMON_RESOURCES_BEAN";

    /**
     * Properties of entity CommonResourcesBean.<br/>
     * Can be used for QueryBuilder and for referencing column names.
     */
    public static class Properties {
        public final static Property Id = new Property(0, Long.class, "Id", true, "_id");
        public final static Property ResourceId = new Property(1, Long.class, "resourceId", false, "RESOURCE_ID");
        public final static Property IsDefaultMenu = new Property(2, int.class, "isDefaultMenu", false, "IS_DEFAULT_MENU");
        public final static Property Name = new Property(3, String.class, "name", false, "NAME");
        public final static Property ParentId = new Property(4, Long.class, "parentId", false, "PARENT_ID");
        public final static Property ResUrl = new Property(5, String.class, "resUrl", false, "RES_URL");
        public final static Property Type = new Property(6, int.class, "type", false, "TYPE");
        public final static Property Description = new Property(7, String.class, "description", false, "DESCRIPTION");
        public final static Property IsChoice = new Property(8, boolean.class, "isChoice", false, "IS_CHOICE");
        public final static Property IsExist = new Property(9, boolean.class, "isExist", false, "IS_EXIST");
    }


    public CommonResourcesBeanDao(DaoConfig config) {
        super(config);
    }
    
    public CommonResourcesBeanDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(Database db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"COMMON_RESOURCES_BEAN\" (" + //
                "\"_id\" INTEGER PRIMARY KEY ," + // 0: Id
                "\"RESOURCE_ID\" INTEGER," + // 1: resourceId
                "\"IS_DEFAULT_MENU\" INTEGER NOT NULL ," + // 2: isDefaultMenu
                "\"NAME\" TEXT," + // 3: name
                "\"PARENT_ID\" INTEGER," + // 4: parentId
                "\"RES_URL\" TEXT," + // 5: resUrl
                "\"TYPE\" INTEGER NOT NULL ," + // 6: type
                "\"DESCRIPTION\" TEXT," + // 7: description
                "\"IS_CHOICE\" INTEGER NOT NULL ," + // 8: isChoice
                "\"IS_EXIST\" INTEGER NOT NULL );"); // 9: isExist
    }

    /** Drops the underlying database table. */
    public static void dropTable(Database db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"COMMON_RESOURCES_BEAN\"";
        db.execSQL(sql);
    }

    @Override
    protected final void bindValues(DatabaseStatement stmt, CommonResourcesBean entity) {
        stmt.clearBindings();
 
        Long Id = entity.getId();
        if (Id != null) {
            stmt.bindLong(1, Id);
        }
 
        Long resourceId = entity.getResourceId();
        if (resourceId != null) {
            stmt.bindLong(2, resourceId);
        }
        stmt.bindLong(3, entity.getIsDefaultMenu());
 
        String name = entity.getName();
        if (name != null) {
            stmt.bindString(4, name);
        }
 
        Long parentId = entity.getParentId();
        if (parentId != null) {
            stmt.bindLong(5, parentId);
        }
 
        String resUrl = entity.getResUrl();
        if (resUrl != null) {
            stmt.bindString(6, resUrl);
        }
        stmt.bindLong(7, entity.getType());
 
        String description = entity.getDescription();
        if (description != null) {
            stmt.bindString(8, description);
        }
        stmt.bindLong(9, entity.getIsChoice() ? 1L: 0L);
        stmt.bindLong(10, entity.getIsExist() ? 1L: 0L);
    }

    @Override
    protected final void bindValues(SQLiteStatement stmt, CommonResourcesBean entity) {
        stmt.clearBindings();
 
        Long Id = entity.getId();
        if (Id != null) {
            stmt.bindLong(1, Id);
        }
 
        Long resourceId = entity.getResourceId();
        if (resourceId != null) {
            stmt.bindLong(2, resourceId);
        }
        stmt.bindLong(3, entity.getIsDefaultMenu());
 
        String name = entity.getName();
        if (name != null) {
            stmt.bindString(4, name);
        }
 
        Long parentId = entity.getParentId();
        if (parentId != null) {
            stmt.bindLong(5, parentId);
        }
 
        String resUrl = entity.getResUrl();
        if (resUrl != null) {
            stmt.bindString(6, resUrl);
        }
        stmt.bindLong(7, entity.getType());
 
        String description = entity.getDescription();
        if (description != null) {
            stmt.bindString(8, description);
        }
        stmt.bindLong(9, entity.getIsChoice() ? 1L: 0L);
        stmt.bindLong(10, entity.getIsExist() ? 1L: 0L);
    }

    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    @Override
    public CommonResourcesBean readEntity(Cursor cursor, int offset) {
        CommonResourcesBean entity = new CommonResourcesBean( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // Id
            cursor.isNull(offset + 1) ? null : cursor.getLong(offset + 1), // resourceId
            cursor.getInt(offset + 2), // isDefaultMenu
            cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3), // name
            cursor.isNull(offset + 4) ? null : cursor.getLong(offset + 4), // parentId
            cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5), // resUrl
            cursor.getInt(offset + 6), // type
            cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7), // description
            cursor.getShort(offset + 8) != 0, // isChoice
            cursor.getShort(offset + 9) != 0 // isExist
        );
        return entity;
    }
     
    @Override
    public void readEntity(Cursor cursor, CommonResourcesBean entity, int offset) {
        entity.setId(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setResourceId(cursor.isNull(offset + 1) ? null : cursor.getLong(offset + 1));
        entity.setIsDefaultMenu(cursor.getInt(offset + 2));
        entity.setName(cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3));
        entity.setParentId(cursor.isNull(offset + 4) ? null : cursor.getLong(offset + 4));
        entity.setResUrl(cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5));
        entity.setType(cursor.getInt(offset + 6));
        entity.setDescription(cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7));
        entity.setIsChoice(cursor.getShort(offset + 8) != 0);
        entity.setIsExist(cursor.getShort(offset + 9) != 0);
     }
    
    @Override
    protected final Long updateKeyAfterInsert(CommonResourcesBean entity, long rowId) {
        entity.setId(rowId);
        return rowId;
    }
    
    @Override
    public Long getKey(CommonResourcesBean entity) {
        if(entity != null) {
            return entity.getId();
        } else {
            return null;
        }
    }

    @Override
    public boolean hasKey(CommonResourcesBean entity) {
        return entity.getId() != null;
    }

    @Override
    protected final boolean isEntityUpdateable() {
        return true;
    }
    
}
