package com.wgmf.yxgj.db;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;

import com.wgmf.library.utils.BaseSingleton;

public class GreenDaoManager {

    private static BaseSingleton<GreenDaoManager, Void> mInstance = new BaseSingleton<GreenDaoManager, Void>() {
        @Override
        protected GreenDaoManager create(Void var1) {
            return new GreenDaoManager();
        }
    };

    public static GreenDaoManager getInstance() {
        return mInstance.get(null);
    }

    private GreenDaoManager() {

    }

    public DaoSession getDaoSession(Context context) {
        mDbHelper = getInstance(context);
        SQLiteDatabase mDb = mDbHelper.getWritableDatabase();
        DaoMaster mDaoMaster = new DaoMaster(mDb);
        return mDaoMaster.newSession();
    }

    private static DaoMaster.DevOpenHelper mDbHelper = null;

    public synchronized static DaoMaster.DevOpenHelper getInstance(Context context) {
        if (mDbHelper == null) {
            mDbHelper = new DaoMaster.DevOpenHelper(context, "db-name", null);
        }
        return mDbHelper;
    }
}