package com.wgmf.yxgj.dialog;

import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.base.R;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;

/**
 * @author xiep
 */
public class SaleForecastProductsEdtDialog extends Dialog {

    private SaleForecastProductsEdtDialog(Context context) {
        super(context, R.style.textview_dialog);
    }

    public static class Builder {
        private Context context;
        private String title;
        private String proRadioOld;
        private String positiveButtonText;
        private String negativeButtonText;
        private View contentView;
        private OnClickListener positiveButtonClickListener;
        private OnClickListener negativeButtonClickListener;
        private ClearEditText proNumEt;

        public Builder(Context context) {
            this.context = context;
        }

        public Builder setTitle(int title) {
            this.title = (String) context.getText(title);
            return this;
        }

        public Builder setTitle(String title) {
            this.title = title;
            return this;
        }

        public void setProRadioOld(String proRadioOld) {
            this.proRadioOld = proRadioOld;
        }

        public String getProNum() {
            return proNumEt.getText().toString();
        }

        public Builder setContentView(View v) {
            this.contentView = v;
            return this;
        }

        public Builder setPositiveButton(int positiveButtonText,
                                         OnClickListener listener) {
            this.positiveButtonText = (String) context
                    .getText(positiveButtonText);
            this.positiveButtonClickListener = listener;
            return this;
        }

        public Builder setPositiveButton(OnClickListener listener) {
            this.positiveButtonText = "取消";
            this.positiveButtonClickListener = listener;
            return this;
        }

        public Builder setNegativeButton(int negativeButtonText,
                                         OnClickListener listener) {
            this.negativeButtonText = (String) context
                    .getText(negativeButtonText);
            this.negativeButtonClickListener = listener;
            return this;
        }

        public Builder setNegativeButton(OnClickListener listener) {
            this.negativeButtonText = "确定";
            this.negativeButtonClickListener = listener;
            return this;
        }
        @SuppressWarnings("all")
        public SaleForecastProductsEdtDialog create() {
            final SaleForecastProductsEdtDialog dialog = new SaleForecastProductsEdtDialog(context);
            View layout = LayoutInflater.from(context).inflate(R.layout.saleforecast_product_dialog, null);
            dialog.addContentView(layout, new LayoutParams(
                    LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
            ((TextView) layout.findViewById(R.id.sale_foreast_dialog_title_tv))
                    .setText(title);
            proNumEt = ((ClearEditText) layout
                    .findViewById(R.id.sale_foreast_item_count));

            if (positiveButtonText != null) {
                ((Button) layout.findViewById(R.id.sale_foreast_item_cancel))
                        .setText(positiveButtonText);
                if (positiveButtonClickListener != null) {
                    layout.findViewById(R.id.sale_foreast_item_cancel)
                            .setOnClickListener(new View.OnClickListener() {
                                @Override
                                public void onClick(View v) {
                                    positiveButtonClickListener.onClick(dialog,
                                            DialogInterface.BUTTON_POSITIVE);

                                }
                            });
                }
            } else {
                layout.findViewById(R.id.sale_foreast_item_cancel).setVisibility(
                        View.GONE);
            }
            if (negativeButtonText != null) {
                ((Button) layout.findViewById(R.id.sale_foreast_item_confirm))
                        .setText(negativeButtonText);
                if (negativeButtonClickListener != null) {
                    layout.findViewById(R.id.sale_foreast_item_confirm)
                            .setOnClickListener(new View.OnClickListener() {
                                @Override
                                public void onClick(View v) {
                                    negativeButtonClickListener.onClick(dialog,
                                            DialogInterface.BUTTON_NEGATIVE);
                                }
                            });
                }
            } else {
                layout.findViewById(R.id.sale_foreast_item_confirm).setVisibility(View.GONE);
            }
            if (proRadioOld != null) {
                ((TextView) layout.findViewById(R.id.sale_foreast_item_goodsUnit)).setText(proRadioOld);
            } else if (contentView != null) {
                ((LinearLayout) layout.findViewById(R.id.sale_foreast_dialog_content_ll)).removeAllViews();
                ((LinearLayout) layout.findViewById(R.id.sale_foreast_dialog_content_ll))
                        .addView(contentView, new LayoutParams(
                                LayoutParams.WRAP_CONTENT,
                                LayoutParams.WRAP_CONTENT));
            }
            dialog.setContentView(layout);
            return dialog;
        }
    }
}