package com.wgmf.yxgj.expand

import android.text.TextUtils
import android.widget.TextView
import com.github.yoojia.inputs.verifiers.NotEmptyVerifier

/**
 * 扩展NotEmptyVerifier类,处理数据不为空的情况，把错误提示图标，文字信息隐藏
 */
class NotEmptyVerifierExpand(val view: TextView, val defaultHint: String) : NotEmptyVerifier() {
    override fun perform(rawInput: String?): Boolean {
        val isEmpty = TextUtils.isEmpty(rawInput)
        if (!isEmpty) {
            if (defaultHint != rawInput) {
                view.setError(null, null)
                return true
            }else{
                return false
            }
        }
        return !isEmpty
    }
}