package com.wgmf.yxgj.global;

import android.util.Log;

import com.wgmf.library.utils.BaseSingleton;

/**
 * 作者：xiep on 2016/9/20 13:48
 * 邮箱：2975837870@qq.com
 */
class GlobalApi {

    private static BaseSingleton<GlobalApi, Void> mMainService = new BaseSingleton<GlobalApi, Void>() {
        @Override
        protected GlobalApi create(Void var1) {
            return new GlobalApi();
        }
    };

    public static GlobalApi getInstance() {
        return mMainService.get(null);
    }

    private GlobalApi() {
    }

    /**
     * 测试环境
     */
    private static final String URL_HOST_TEST = "https://test.wgmf.com";
    private static final String URL_API_HOST_TEST = "http://newapitest.wgmf.com";

    /**
     * 正式环境
     */
    private static final String URL_HOST = "https://app.wgmf.com";
    private static final String URL_WX_HOST= "http://wx.wgmf.com";
    private static final String URL_API_HOST= "http://newapi.wgmf.com";

    /**
     * 新域名 环境切换
     *
     * @param envStatus 0：正式环境，1：测试环境
     * @return 主机地址
     */
    String getEnvApiServer(int envStatus) {
        String tempEnvServer = null;
        switch (envStatus) {
            case 0:
                tempEnvServer = URL_API_HOST;
                break;
            case 1:
                tempEnvServer = URL_API_HOST_TEST;
                break;
            default:
                break;
        }
        Log.d("服务器地址：", tempEnvServer);
        return tempEnvServer;
    }

    /**
     * 精准域名 环境切换
     *
     * @param envStatus 0：正式环境，1：测试环境
     * @return 主机地址
     */
    String getEnvWxServer(int envStatus) {
        String tempEnvServer = null;
        switch (envStatus) {
            case 0:
                tempEnvServer = URL_WX_HOST;
                break;
            case 1:
                tempEnvServer = URL_HOST_TEST;
                break;
            default:
                break;
        }
        Log.d("服务器地址：", tempEnvServer);
        return tempEnvServer;
    }
    /**
     *旧域名环境切换
     *
     * @param envStatus 0：正式环境，1：测试环境
     * @return 主机地址
     */
    String getEnvServer(int envStatus) {
        String tempEnvServer = null;
        switch (envStatus) {
            case 0:
                tempEnvServer = URL_HOST;
                break;
            case 1:
                tempEnvServer = URL_HOST_TEST;
                break;
            default:
                break;
        }
        Log.d("服务器地址：", tempEnvServer);
        return tempEnvServer;
    }
}