package com.wgmf.yxgj.global;

import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.app.LibGroupContext;

/**
 * 资源URL
 *
 * @author xiep
 */
public class NetworkParams {
    /**
     * 主机地址  0：正式环境，1：测试环境
     */
    public static final String URL_HOST = GlobalApi.getInstance().getEnvServer(PrefTool.getIntPreferences(LibGroupContext.getApplication(), Prefs.PRE_ENVIRONMENT_STATUS, 0));
    public static final String URL_API_HOST = GlobalApi.getInstance().getEnvApiServer(PrefTool.getIntPreferences(LibGroupContext.getApplication(), Prefs.PRE_ENVIRONMENT_STATUS, 0));
    public static final String URL_WX_HOST = GlobalApi.getInstance().getEnvWxServer(PrefTool.getIntPreferences(LibGroupContext.getApplication(), Prefs.PRE_ENVIRONMENT_STATUS, 0));

    /**
     * 服务器基址
     */
    private static final String URL_BACK_SERVER = "/mkt-back";
    /**
     * html前端基址
     */
    private static final String URL_FRONT_HTML = "/mkt-front";
    /**
     * 基础服务全局基址
     */
    private static final String URL_BASE_BACK_SERVER = "/base-data-service";
    /**
     * 消息推送全局基址
     */
    private static final String URL_MSG_SERVER = "/msg-service";
    /**
     * 陈正销售服务基址
     */
    private static final String URL_APP_SALER = "/app-saler";
    /**
     * 陈正APP基址
     */
    private static final String URL_BASE_APP = "/app";
    /**
     * crm 服务基址
     */
    private static final String URL_CRM_SERVER = "/crm-api";
    /**
     * /jz-business-oprations-management 服务地址
     */
    private static final String URL_BUSINESS_OPRATIONS_MANAGEMENT_SERVER = "/jz-business-oprations-management";
    /**
     * jz-markting-activities-management 服务地址
     */
    private static final String URL_MARKTING_ACTIVITIES_MANAGEMENT_SERVER = "/jz-markting-activities-management";
    /**
     * /base-data-service 服务地址
     */
    private static final String URL_BASE_DATA_SERVICE = "/base-data-service";
    /**
     * 七牛图片存储基址
     */
    public static final String QINIU_BASE = "http://img.wgmf.com/";
    /**
     * 登录接口地址
     */
    public static final String URL_LOGIN = URL_HOST + URL_BASE_BACK_SERVER
            + "/user/loginCheckNew";
    /**
     * get /user/loginInfo 获取用户登录后相关信息(New)
     */
    public static final String URL_LOGIN_INFO = URL_HOST + URL_BASE_BACK_SERVER
            + "/user/loginInfo";
    /**
     * get /user/getSaleOrgInfo 切换组织-获取用户最新销售组织信息(New)
     */
    public static final String URL_GET_SALE_ORG_INFO = URL_HOST + URL_BASE_BACK_SERVER
            + "/user/getSaleOrgInfo";
    /**
     * 获取版本信息、升级接口地址
     */
    public static final String URL_CHECK_UPDATA = URL_HOST
            + URL_BASE_BACK_SERVER + "/information/getAppVersionInfo";
    /**
     * 获取附近门店
     */
    public static final String URL_SHOP_GET_NEAREST = URL_HOST + URL_BASE_BACK_SERVER
            + "/shop/getNearest";
    /**
     * 上报员工相关的jpush的信息
     */
    public static final String URL_UPLOAD_MESSAGEUSER_INFORMATION = URL_HOST
            + URL_MSG_SERVER + "/message/uploadMessageUserInformation";
    /**
     * 发送推送消息
     */
    public static final String URL_SENDMESSAGE = URL_HOST + URL_MSG_SERVER + "/message/sendMessage";
    /**
     * 前端显示登录页面
     * get /frontDisplay/loginImage
     */
    public static final String URL_LOGIN_IMAGE = URL_HOST + URL_BASE_APP + "/frontDisplay/loginImage";
    /**
     * get /frontDisplay/adPage 前端显示首页弹出广告列表
     */
    public static final String URL_AD_PAGE = URL_HOST + URL_BASE_APP + "/frontDisplay/adPage";
    /**
     * get /homePage/popWindowShow 首页弹窗查询
     */
    public static final String URL_POP_WINDOW_SHOW = URL_HOST + URL_APP_SALER + "/homePage/popWindowShow";
    /**
     * get /protocol/getProtocol 获取协议
     */
    public static final String URL_GET_PROTOCOL = URL_HOST + URL_BACK_SERVER + "/protocol/getProtocol";
    /**
     * post /protocol/saveProtocolRecord 保存用户协议记录
     */
    public static final String URL_SAVE_PROTOCOL_RECORD = URL_HOST + URL_BACK_SERVER + "/protocol/saveProtocolRecord";
    /**
     * 获取消息列表
     */
    public static final String URL_GETMESSAGE = URL_HOST + URL_MSG_SERVER + "/message/getMessage";
    /**
     * 更新消息已读状态
     */
    public static final String URL_UPDATE_MESSAGE = URL_HOST + URL_MSG_SERVER + "/message/updateMessage";
    /**
     * 获取上报门店列表地址
     */
    public static final String URL_SHOP_LIST = URL_HOST + URL_BACK_SERVER + "/patrol/shops";
    /**
     * 获取同级主管列表地址
     */
    public static final String URL_CHARGE_STAFF_LIST = URL_HOST
            + URL_BACK_SERVER + "/userInfoManagement/getEntryNutriongSaleOrg";
    /**
     * GET /userInfoManagement/queryWorkers 根据门店编号查找下面营养顾问
     */
    public static final String URL_QUERY_WORKERS_LIST = URL_HOST
            + URL_BACK_SERVER + "/userInfoManagement/queryWorkers";
    /**
     * 问题上报查询物流处理人员信息
     * GET /streamDealPerson/queryStreamDealPersonInfo
     */
    public static final String URL_STREAM_DEALPERSON = URL_HOST
            + URL_BACK_SERVER + "/streamDealPerson/queryStreamDealPersonInfo";
    /**
     * 获取问题上报选择列表地址
     */
    public static final String URL_PRODUCT_LIST = URL_HOST + URL_BACK_SERVER
            + "/question/product";
    /**
     * 问题上报保存地址
     */
    public static final String URL_PRODUCT_SAVE = URL_HOST + URL_BACK_SERVER
            + "/question/saveQuestion";

    /**
     * 到货误差配送单号产品
     * GET  /storeDispatch/getDispatchProduct
     */
    public static final String URL_GET_DISPATCH_PRODUCT = URL_HOST
            + URL_BASE_APP + "/storeDispatch/getDispatchProduct";

    /**
     * 门店确认收货
     * POST  /storeAllot/confirmStoreAllot
     */
    public static final String URL_CONFIRM_STORE_ALLOT = URL_HOST
            + URL_BASE_APP + "/storeAllot/confirmStoreAllot";

    /**
     * 质量问题反馈流程提交
     * POST /OAworkflow/createQualityFBWorkFlow
     */
    public static final String URL_CREATE_QUALITY_FB_WORKFLOW = URL_HOST
            + URL_APP_SALER + "/OAworkflow/createQualityFBWorkFlow";
    /**
     * 柜子流程提交
     * POST /OAworkflow/createCabinetWorkFlow
     */
    public static final String URL_CREATE_CABINET_WORKFLOW = URL_HOST
            + URL_APP_SALER + "/OAworkflow/createCabinetWorkFlow";

    /**
     * 物流派送问题投诉提交
     * POST /logisticsDelivery/saveLogisticsDeliveryBean
     */
    public static final String URL_SAVE_LOGISTICS_DELIVERY_BEAN = URL_HOST
            + URL_BACK_SERVER + "/logisticsDelivery/saveLogisticsDeliveryBean";

    /**
     * 我要找督察，内部人员投诉流程
     * POST /OAworkflow/createComplaintWorkFlow
     */
    public static final String URL_CREATE_COMPLAINT_WORKFLOW = URL_HOST
            + URL_APP_SALER + "/OAworkflow/createComplaintWorkFlow";
    /**
     * 建议与意见流程
     * POST /OAworkflow/createFeedbackWorkFlow
     */
    public static final String URL_CCREATE_FEEDBACK_WORKFLOW = URL_HOST
            + URL_APP_SALER + "/OAworkflow/createFeedbackWorkFlow";
    /**
     * 到货误差流程提交
     * POST /OAworkflow/CreateAOGErrWorkFlow
     */
    public static final String URL_CREATE_AOGERR_WORKFLOW = URL_HOST
            + URL_APP_SALER + "/OAworkflow/CreateAOGErrWorkFlow";
    /**
     * 流程查询
     * GET /OAworkflow/getAOGWorkFlowInfo /OAworkflow/getWorkFlowInfo
     */
    public static final String URL_GET_AOGWORKFLOW_INFO = URL_HOST
            + URL_APP_SALER + "/OAworkflow/getWorkFlowInfo";
    /**
     * 流程查询
     * post /OAworkflow/submitPj
     */
    public static final String URL_SUBMIT_PJ = URL_HOST + URL_APP_SALER + "/OAworkflow/submitPj";
    /**
     * get /machineOrder/findMachineRepairOper 查找机修人员信息
     */
    public static final String URL_FIND_MACHINE_REPAIR_OPER = URL_HOST + URL_BACK_SERVER + "/machineOrder/findMachineRepairOper";
    /**
     * get /machineOrder/findMachineOrderList 查找机修工单信息
     */
    public static final String URL_FIND_MACHINE_ORDER_LIST = URL_HOST + URL_BACK_SERVER + "/machineOrder/findMachineOrderList";
    /**
     * get /machineOrder/findMachineOrderDetail 查找机修工单信息明细
     */
    public static final String URL_FIND_MACHINE_ORDER_DETAIL = URL_HOST + URL_BACK_SERVER + "/machineOrder/findMachineOrderDetail";
    /**
     * post /machineOrder/saveOrUpdateMachineOrder 创建机修工单
     */
    public static final String URL_SAVE_OR_UPDATE_MACHINE_ORDER = URL_HOST + URL_BACK_SERVER + "/machineOrder/saveOrUpdateMachineOrder";
    /**
     * post /machineOrder/updateMachineOrderMaintenance 评价机修工单维修
     */
    public static final String URL_UPDATE_MACHINE_ORDER_MAINTENANCE = URL_HOST + URL_BACK_SERVER + "/machineOrder/updateMachineOrderMaintenance";
    /**
     * 紧急突发事件处理
     */
    public static final String PROBLEM_CALL = "/crmserver-front/html/problemCall.html";

    /**
     * 紧急问题处理
     **/
    public static final String EMERGENCY_CALL = "/crmserver-front/html/emergencyCall.html";

    /**
     * 电话投诉
     */
    public static final String TELEPHONE_COMPLAINT = "/crmserver-front/html/callReport.html";

    /**
     * 微信投诉
     */
    public static final String WEBCHAT_COMPLAINT = "/crmserver-front/html/wechatReport.html";
    /**
     * 获取上报token地址
     */
    public static final String URL_PRODUCT_TOKEN = URL_HOST + "/qiniu/getUploadToken?content=";
    /**
     * 特殊活动上报查询地址
     */
    public static final String URL_QUERYSPECIALACTIVITY = URL_HOST
            + URL_BACK_SERVER + "/specialactivity/querySpecialActivity";
    /**
     * 特殊活动上报保存地址
     */
    public static final String URL_SAVESPECIALACTIVITY = URL_HOST
            + URL_BACK_SERVER + "/specialactivity/saveSpecialActivity";
    /**
     * 评级上报审核
     * POST /RatingsReport/approveRatingsReport
     */
    public static final String URL_APPROVE_RATINGS_REPORT = URL_HOST
            + URL_BACK_SERVER + "/RatingsReport/approveRatingsReport";
    /**
     * 评级上报保存地址
     */
    public static final String URL_SAVE_RATINGS_REPORT = URL_HOST
            + URL_BACK_SERVER + "/RatingsReport/saveRatingsReport";
    /**
     * 评级上报门店列表查询地址
     */
    public static final String URL_QUERY_RATINGS_REPORT_LIST = URL_HOST
            + URL_BACK_SERVER + "/RatingsReport/queryShopRatingsRank";
    /**
     * 评级上报门店详情查询地址
     */
    public static final String URL_QUERY_RATINGS_REPORT_DETAIL = URL_HOST
            + URL_BACK_SERVER + "/RatingsReport/queryRatingsReport";
    /**
     * GET /ibeacon/getIbeacon ibeacon上报查询
     */
    public static final String URL_GET_IBEACON = URL_HOST
            + URL_BACK_SERVER + "/ibeacon/getIbeacon";
    /**
     * GET /ibeacon/getIbeaconShop 门店ibeacon和上报时间查询
     */
    public static final String URL_GET_IBEACON_SHOP = URL_HOST
            + URL_BACK_SERVER + "/ibeacon/getIbeaconShop";
    /**
     * POST /ibeacon/saveIbeacon ibeacon上报
     */
    public static final String URL_SAVE_IBEACON = URL_HOST
            + URL_BACK_SERVER + "/ibeacon/saveIbeacon";
    /**
     * GET /newcusactitycontroller/getNewCusActityType 查询新客拉新活动类型
     */
    public static final String URL_GET_NEWCUS_ACTITY_TYPE = URL_HOST
            + URL_BACK_SERVER + "/newcusactitycontroller/getNewCusActityType";
    /**
     * GET /newcusactitycontroller/getNewCusActitySubject 查询新客拉新活动主题
     */
    public static final String URL_GET_NEWCUS_SUBJECT = URL_HOST
            + URL_BACK_SERVER + "/newcusactitycontroller/getNewCusActitySubject";
    /**
     * /newcusactitycontroller/getNewCusActPromoProps 查询新客拉新活动推广道具
     */
    public static final String URL_GET_NEWCUS_ACT_PROMO_PROPS = URL_HOST
            + URL_BACK_SERVER + "/newcusactitycontroller/getNewCusActPromoProps";
    /**
     * POST /newcusactitycontroller/saveNewCusActityService 新客拉新活动上报
     */
    public static final String URL_SAVE_NEWCUS_ACTITY_SERVICE = URL_HOST
            + URL_BACK_SERVER + "/newcusactitycontroller/saveNewCusActityService";
    /**
     * GET /tourShop/findTourShop 从入口进入时显示界面调用
     */
    public static final String URL_FIND_TOURSHOP = URL_HOST
            + URL_BACK_SERVER + "/tourShop/findTourShop";
    /**
     * GET /tourShop/findTourShopType 查询巡店辅导类型
     */
    public static final String URL_FIND_TOURSHOP_TYPE = URL_HOST
            + URL_BACK_SERVER + "/tourShop/findTourShopType";
    /**
     * POST /tourShop/saveTourShop 保存巡店上报
     */
    public static final String URL_SAVE_TOURSHOP = URL_HOST
            + URL_BACK_SERVER + "/tourShop/saveTourShop";
    /**
     * post /nutritionConsultant/entryNutritionConsultantV2 营养顾问入职(新增健康证编号等属性)
     */
    public static final String URL_STAFF_ENTRY = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/entryNutritionConsultantV2";
    /**
     * post /nutritionConsultant/resignNutritionConsultantV2 营养顾问离职V2
     */
    public static final String URL_STAFF_EXIT = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/resignNutritionConsultantV2";
    /**
     * get /nutritionConsultant/queryNutritionConsultantV2 查询营养顾问
     */
    public static final String URL_STAFF_QUERY = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/queryNutritionConsultantV2";
    /**
     * get /nutritionConsultant/queryNeedUpdateWorkersList 查询没有合同图片的顾问信息
     */
    public static final String URL_NEED_UPDATE_WORKERS_LIST = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/queryNeedUpdateWorkersList";
    /**
     * post /nutritionConsultant/approveNutritionConsultantV2 营养顾问入职审批
     */
    public static final String URL_STAFF_APPROVE = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/approveNutritionConsultantV2";
    /**
     * post /nutritionConsultant/updateNutritionConsultantV2 营养顾问信息修改
     */
    public static final String URL_UPDATE_NUTRITION_CONSULTANT = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/updateNutritionConsultantV2";
    /**
     * post /nutritionConsultant/updateUserRehire 营养顾问返聘
     */
    public static final String URL_UPDATE_USER_REHIRE = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/updateUserRehire";
    /**
     * GET /nutritionConsultant/checkNutritionConsultant 检验营养顾问是否可以入职
     */
    public static final String URL_CHECK_NUTRITION_CONSULTANT = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/checkNutritionConsultant";
    /**
     * GET /nutritionConsultant/getNutrConsultantSalary 获取顾问底薪
     */
    public static final String URL_GET_NUTR_CONSULTANT_SALARY = URL_HOST
            + URL_BACK_SERVER + "/nutritionConsultant/getNutrConsultantSalary";
    /**
     * GET /nutritionConsultant/findNutConsultantScheduling 流动营养顾问排班查询
     */
    public static final String URL_FIND_NUTCONSULTANT_SCHEDULING = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/findNutConsultantScheduling";
    /**
     * GET /nutritionConsultant/findThreeAndCurrentDayScheduling 流动营养顾问排班查询-当天和前三天
     */
    public static final String URL_FIND_THREEANDCURRENTDAY_SCHEDULING = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/findThreeAndCurrentDayScheduling";
    /**
     * GET /nutritionConsultant/findOneMonthScheduling 查询一个月的流动营养顾问排班查询
     */
    public static final String URL_FIND_ONEMONTH_SCHEDULING = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/findOneMonthScheduling";
    /**
     * POST /nutritionConsultant/saveOrUpdateScheduling 新增或者更新流动营养顾问排班
     */
    public static final String URL_SAVEORUPDATE_SCHEDULING = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/saveOrUpdateScheduling";
    /**
     * GET /nutritionConsultant/findTrainTutor 查询门店的督导或店长 又或营养顾问
     */
    public static final String URL_FIND_TRAIN_TUTOR = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/findTrainTutor";
    /**
     * GET /nutritionConsultant/findOutsourced 外包公司查询
     */
    public static final String URL_FIND_OUT_SOURCED = URL_HOST + URL_BACK_SERVER
            + "/nutritionConsultant/findOutsourced";
    /**
     * 首页大区全面绩效接口地址
     */
    public static final String URL_SEARCH_AREA = URL_HOST + URL_BACK_SERVER
            + "/performance/searchArea";
    /**
     * 首页办事处全面绩效接口地址
     */
    public static final String URL_SEARCH_OFFICE = URL_HOST + URL_BACK_SERVER
            + "/performance/searchOffice";
    /**
     * 首页主管全面绩效接口地址
     */
    public static final String URL_SEARCH_MANAGER = URL_HOST + URL_BACK_SERVER
            + "/performance/searchManager";
    /**
     * 特殊活动明细地址
     */
    public static final String URL_SPECIAL_ACTIVITY = URL_HOST + URL_FRONT_HTML
            + "/html/specialActivity.html";
    /**
     * 404错误页面地址
     */
    public static final String URL_ERROR = "file:///android_asset/loadFail.html";
    /**
     * 新增月报前查询地址
     */
    public static final String URL_GETPERFORMACE_MONTHLYREPORT = URL_HOST
            + URL_BACK_SERVER + "/monthlyWeekReport/getPerformaceMonthlyReport";
    /**
     * 新增/修改月报地址
     */
    public static final String URL_SAVE_MONTHLYREPORT = URL_HOST
            + URL_BACK_SERVER + "/monthlyWeekReport/saveMonthlyReport";
    /**
     * 月报周报下级人员信息查询
     */
    public static final String URL_QUERY_USERINFO = URL_HOST
            + URL_BACK_SERVER + "/monthlyWeekReport/queryUserInfo";
    /**
     * 月报周报批复
     */
    public static final String URL_APPRIASE_MONTHLYREPORT = URL_HOST
            + URL_BACK_SERVER + "/monthlyWeekReport/appriaseMonthlyReport";
    /**
     * 月报周报批复
     * POST /monthlyWeekReport/saveMonthlyReportSummaly
     */
    public static final String URL_SAVE_MONTHLYREPORT_SUMMALY = URL_HOST
            + URL_BACK_SERVER + "/monthlyWeekReport/saveMonthlyReportSummaly";

    /**
     * 订货审核门店
     * GET /productManagement/findOrderGoodsAuditStore
     */
    @Deprecated
    public static final String URL_FIND_ORDERGOODS_AUDITSTORE = URL_HOST
            + URL_BACK_SERVER + "/productManagement/findOrderGoodsAuditStore";


    /**
     * 订货审核门店
     * GET /productManagement/findOrderGoodsAuditStoreNew
     */
    public static final String URL_FIND_ORDERGOODS_AUDITSTORE_NEW = URL_HOST
            + URL_BACK_SERVER + "/productManagement/findOrderGoodsAuditStoreNew";

    /**
     * 订货加单门店
     * GET  /productManagement/findAddOrderStore
     */
    public static final String URL_FIND_ADD_ORDER_STORE = URL_HOST
            + URL_BACK_SERVER + "/productManagement/findAddOrderStore";

    /**
     * 订货加单门店
     * GET  /productManagement/findAddOrderProductList
     */
    public static final String URL_FIND_ADD_ORDER_PRODUCT_LIST = URL_HOST
            + URL_BACK_SERVER + "/productManagement/findAddOrderProductList";

    /**
     * 订货加单 - 提交订货
     * POST  /productManagement/saveOrderGoodsAuditions
     */
    public static final String URL_SAVE_ADD_ORDER_PRODUCT_LIST = URL_HOST
            + URL_BACK_SERVER + "/productManagement/saveOrderGoodsAuditions";

    /**
     * 到家业务 - 查询产品
     * GET  /homeBusinessController/findProduct
     */
    public static final String URL_FINDPRODUCT = URL_HOST
            + URL_BACK_SERVER + "/homeBusinessController/findProduct";

    /**
     * 到家业务 - 查询商超
     * GET  /homeBusinessController/findMarkeName
     */
    public static final String URL_FINDMARKE = URL_HOST
            + URL_BACK_SERVER + "/homeBusinessController/findMarkeName";

    /**
     * 到家业务 - 查询库存明细
     * GET  /homeBusinessController/findHomeBusStockList
     */
    public static final String URL_FINDSTOCKLIST = URL_HOST
            + URL_BACK_SERVER + "/homeBusinessController/findHomeBusStockList";

    /**
     * 订货审核
     * GET /productManagement/findOrderGoodsAudit
     */
    public static final String URL_FIND_ORDERGOODS_AUDIT = URL_HOST
            + URL_BACK_SERVER + "/productManagement/findOrderGoodsAudit";
    /**
     * 订货审核明细
     * GET /productManagement/findOrderGoodsAuditDeatil
     */
    public static final String URL_FIND_ORDERGOODS_AUDIT_DEATIL = URL_HOST
            + URL_BACK_SERVER + "/productManagement/findOrderGoodsAuditDeatil";
    /**
     * 订货批量审核明细
     * GET /productManagement/batchFindOrderGoodsDetail
     */
    public static final String URL_BATCH_FIND_ORDERGOODS_DEATIL = URL_HOST
            + URL_BACK_SERVER + "/productManagement/batchFindOrderGoodsDetail";
    /**
     * 订货审核添加或修改
     * POST /productManagement/saveUpdateOrderGoodsAuditions
     */
    public static final String URL_SAVE_UPDATE_ORDERGOODS_AUDITIONS = URL_HOST
            + URL_BACK_SERVER + "/productManagement/saveUpdateOrderGoodsAuditions";

    /**
     * 订货审核批量添加或修改
     * POST /productManagement/batchSaveOrderGoodsAuditions
     */
    public static final String URL_BATCH_SAVE_UPDATE_ORDERGOODS_AUDITIONS = URL_HOST
            + URL_BACK_SERVER + "/productManagement/batchSaveOrderGoodsAuditions";

    /**
     * 产品查询
     * GET /productManagement/findProductList
     */
    public static final String URL_FIND_PRODUCT_LIST = URL_HOST
            + URL_BACK_SERVER + "/productManagement/findProductList";
    /**
     * 调入调出产品查询
     * POST /productManagement/findInOutProductList
     */
    public static final String URL_FIND_IN_OUT_PRODUCT_LIST = URL_HOST
            + URL_BACK_SERVER + "/productManagement/findInOutProductList";
    /**
     * 产品调入调出
     * POST /productManagement/saveTransferredInOrOut
     */
    public static final String URL_SAVE_TRANSFERRED_INOROUT = URL_HOST
            + URL_BACK_SERVER + "/productManagement/saveTransferredInOrOut";

    /**
     * 修改调拨收货
     * POST /storeAllot/updateStoreAllot
     */
    public static final String URL_UPDATE_STORE_ALLOT = URL_HOST + URL_BASE_APP + "/storeAllot/updateStoreAllot";

    /**
     * 调入调出查询
     * GET /productManagement/findTransferredInAndOut
     */
    public static final String URL_FIND_TRANSFERRED_INANDOUT = URL_HOST
            + URL_BACK_SERVER + "/productManagement/findTransferredInAndOut";
    /**
     * 调入调出查询明细
     * GET /productManagement/findTransferredInAndOutDetail
     */
    public static final String URL_FIND_TRANSFERRED_INANDOUT_DETAIL = URL_HOST
            + URL_BACK_SERVER + "/productManagement/findTransferredInAndOutDetail";
    /**
     * 查询门店距离
     * GET /shopV2/queryDistance
     */
    public static final String URL_QUERY_DISTANCE = URL_HOST
            + URL_BACK_SERVER + "/shopV2/queryDistance";
    /**
     * 存货盘点门店
     * GET /productManagement/findStockGoodsCheckStore
     */
    public static final String URL_FIND_STOCKGOODS_CHECK_STORE = URL_HOST
            + URL_BACK_SERVER + "/productManagement/findStockGoodsCheckStore";
    /**
     * 存货盘点明细
     * GET /productManagement/findStockGoodsCheckDeatils
     */
    public static final String URL_FIND_STOCKGOODS_CHECK_DEATILS = URL_HOST
            + URL_BACK_SERVER + "/productManagement/findStockGoodsCheckDeatils";
    /**
     * 修改存货盘点
     * POST /productManagement/updateStockGoodsCheck
     */
    public static final String URL_UPDATE_STOCKGOODS_CHECK = URL_HOST
            + URL_BACK_SERVER + "/productManagement/updateStockGoodsCheck";
    /**
     * 反审存货盘点
     * POST /productManagement/rejectStockGoodsCheck
     */
    public static final String URL_REJECT_STOCKGOODS_CHECK = URL_HOST
            + URL_BACK_SERVER + "/productManagement/rejectStockGoodsCheck";
    /**
     * 资材收货查询
     * GET /capitalManagementV2/findCapitalReceipts
     */
    public static final String URL_FIND_CAPITAL_RECEIPTS = URL_HOST
            + URL_BACK_SERVER + "/capitalManagementV2/findCapitalReceipts";
    /**
     * 资材收货明细查询
     * GET /capitalManagementV2/findCapitalReceiptsDetail
     */
    public static final String URL_FIND_CAPITAL_RECEIPTS_DETAIL = URL_HOST
            + URL_BACK_SERVER + "/capitalManagementV2/findCapitalReceiptsDetail";
    /**
     * 资材收货确认
     * POST /capitalManagementV2/updateCapitalReceipts
     */
    public static final String URL_UPDATE_CAPITAL_RECEIPTS = URL_HOST
            + URL_BACK_SERVER + "/capitalManagementV2/updateCapitalReceipts";
    /**
     * 资材库存查询
     * GET /capitalManagement/findCapitalStockSearch
     */
    public static final String URL_FIND_CAPITAL_STOCK_SEARCH = URL_HOST
            + URL_BACK_SERVER + "/capitalManagement/findCapitalStockSearch";
    /**
     * 资材库存查询明细
     * GET /capitalManagement/findCapitalStockDetail
     */
    public static final String URL_FIND_CAPITAL_STOCK_DETAIL = URL_HOST
            + URL_BACK_SERVER + "/capitalManagement/findCapitalStockDetail";
    /**
     * 资材调拨
     * POST /capitalManagement/capitalStockTransferred
     */
    public static final String URL_SAVE_CAPITAL_STOCK_TRANSFERRED = URL_HOST
            + URL_BACK_SERVER + "/capitalManagement/capitalStockTransferred";

    /**
     * 获取销售预测门店
     * GET /saleforecast/getSaleForecastShop
     */
    public static final String URL_GET_SALEFORECAST_SHOP = URL_HOST
            + URL_BACK_SERVER + "/saleforecast/getSaleForecastShop";

    /**
     * 填写销售预测前查询产品相关信息
     * GET /saleforecast/getSaleForecastProductInfo
     */
    public static final String URL_GET_SALEFORECAST_PRODUCT_INFO = URL_HOST
            + URL_BACK_SERVER + "/saleforecast/getSaleForecastProductInfo";

    /**
     * 新增销售预测
     * POST /saleforecast/saveSaleForecast
     */
    public static final String URL_SAVE_SALEFORECAST = URL_HOST
            + URL_BACK_SERVER + "/saleforecast/saveSaleForecast";

    /**
     * 获取以往销售
     * GET /saleforecast/getShopHistorySale
     */
    public static final String URL_GET_SHOPHISTORY_SALE = URL_HOST
            + URL_BACK_SERVER + "/saleforecast/getShopHistorySale";

    /**
     * 获取以往销售-单品销售
     * GET /saleforecast/getShopProductHistorySale
     */
    public static final String URL_GET_SHOP_PRODUCT_HISTORY_SALE = URL_HOST
            + URL_BACK_SERVER + "/saleforecast/getShopProductHistorySale";

    /**
     * 客户拜访查询
     * GET /kacusmanager/findCustomerVisit
     */
    public static final String URL_GET_FIND_CUSTOMER_VISIT = URL_HOST
            + URL_BACK_SERVER + "/kacusmanager/findCustomerVisit";
    /**
     * 查询商超系统和客户职位
     * GET /kacusmanager/findSupermarketAndPoistion
     */
    public static final String URL_GET_FIND_SUPERMARKET_AND_POISTION = URL_HOST
            + URL_BACK_SERVER + "/kacusmanager/findSupermarketAndPoistion";
    /**
     * 客户拜访
     * POST /kacusmanager/saveCustomerVisit
     */
    public static final String URL_SAVE_CUSTOMER_VISIT = URL_HOST
            + URL_BACK_SERVER + "/kacusmanager/saveCustomerVisit";
    /**
     * 查询营养顾问面试评估记录
     * GET /nutritionConsultant/findStaffAuditionAppraiseList
     */
    public static final String URL_FIND_STAFF_AUDITION_APPRAISELIST = URL_HOST
            + URL_BACK_SERVER + "/nutritionConsultant/findStaffAuditionAppraiseList";
    /**
     * 查询单个营养顾问面试评估记录
     * GET /nutritionConsultant/findStaffAuditionAppraise
     */
    public static final String URL_FIND_STAFF_AUDITION_APPRAISE = URL_HOST
            + URL_BACK_SERVER + "/nutritionConsultant/findStaffAuditionAppraise";
    /**
     * 新增营养顾问面试评估
     * POST /nutritionConsultant/saveStaffAuditionAppraise
     */
    public static final String URL_SAVE_STAFF_AUDITION_APPRAISE = URL_HOST
            + URL_BACK_SERVER + "/nutritionConsultant/saveStaffAuditionAppraise";

    /**
     * 查询门店是否填写商超大数据
     * GET /supermarketData/getSupermarketBigDataShop
     */
    public static final String URL_GET_SUPERMARKET_BIGDATA_SHOP = URL_HOST
            + URL_BACK_SERVER + "/supermarketData/getSupermarketBigDataShop";
    /**
     * 查询门店商超大数据
     * GET /supermarketData/findStoreSupermarketBigData
     */
    public static final String URL_FIND_STORE_SUPERMARKET_BIGDATA = URL_HOST
            + URL_BACK_SERVER + "/supermarketData/findStoreSupermarketBigData";
    /**
     * 查询门店商超大数据
     * GET /supermarketData/getSupermarketBigDataReport
     */
    public static final String URL_GET_SUPERMARKET_BIGDATA_REPORT = URL_HOST
            + URL_BACK_SERVER + "/supermarketData/getSupermarketBigDataReport";
    /**
     * 新增商超大数据
     * POST /supermarketData/saveSupermarketBigData
     */
    public static final String URL_SAVE_SUPERMARKET_BIGDATA = URL_HOST
            + URL_BACK_SERVER + "/supermarketData/saveSupermarketBigData";
    /**
     * GET /talentPool/findOrgTalentNum 组织下门店储备人数查询
     */
    public static final String URL_FIND_ORG_TALENT_NUM = URL_HOST
            + URL_BACK_SERVER + "/talentPool/findOrgTalentNum";
    /**
     * GET /talentPool/findShopTalent 门店储备人才
     */
    public static final String URL_FIND_SHOP_TALENT = URL_HOST
            + URL_BACK_SERVER + "/talentPool/findShopTalent";
    /**
     * GET /talentPool/getTalentPoolByPhone 人才库查询-手机校验
     */
    public static final String URL_GET_TALENT_POOL_BY_PHONE = URL_HOST
            + URL_BACK_SERVER + "/talentPool/getTalentPoolByPhone";
    /**
     * GET /talentPool/findShopTalentDetail 门店储备人才详情
     */
    public static final String URL_FIND_SHOP_TALENT_DETAIL = URL_HOST
            + URL_BACK_SERVER + "/talentPool/findShopTalentDetail";
    /**
     * GET /talentPool/deleteTalentPool 删除储备人才
     */
    public static final String URL_DELETE_TALENT_POOL = URL_HOST
            + URL_BACK_SERVER + "/talentPool/deleteTalentPool";
    /**
     * POST /talentPool/saveTalentPool 新增/更新人才库
     */
    public static final String URL_SAVE_TALENT_POOL = URL_HOST
            + URL_BACK_SERVER + "/talentPool/saveTalentPool";
    /**
     * GET /newcusactitycontroller/getSaleLessOPFThousandShopNum 主管下门店连续三个月销售小于1.5w记录
     */
    public static final String URL_GET_SALELESS_OPFTHOUSAND_SHOP_NUM = URL_HOST
            + URL_BACK_SERVER + "/newcusactitycontroller/getSaleLessOPFThousandShopNum";
    /**
     * POST /newcusactitycontroller/saveSaleWariningMeasures 销售预警改善措施填写
     */
    public static final String URL_SAVE_SALE_WARINING_MEASURES = URL_HOST
            + URL_BACK_SERVER + "/newcusactitycontroller/saveSaleWariningMeasures";

    /**
     * POST /memDaySign/checkCusDay 判断是否为会员日
     */
    public static final String URL_CHECK_CUS_DAY = URL_HOST
            + URL_BACK_SERVER + "/memDaySign/checkCusDay";
    /**
     * POST /memDaySign/getSearchStoreByStaffId 根据工号获取该员工最近搜索的4家门店
     */
    public static final String URL_GET_SEARCH_STORE_BY_STAFFID = URL_HOST
            + URL_BACK_SERVER + "/memDaySign/getSearchStoreByStaffId";
    /**
     * POST /memDaySign/memDaySignShow 会员日下店签到签退(销售金额,签到状态)
     */
    public static final String URL_MEM_DAY_SIGN_SHOW = URL_HOST
            + URL_BACK_SERVER + "/memDaySign/memDaySignShow";
    /**
     * POST /memDaySign/saveSearchStore 保存门店搜索记录
     */
    public static final String URL_SAVE_SEARCH_STORE = URL_HOST
            + URL_BACK_SERVER + "/memDaySign/saveSearchStore";
    /**
     * POST /memDaySign/saveSignIn 签到保存
     */
    public static final String URL_MEM_DAY_SIGN = URL_HOST
            + URL_BACK_SERVER + "/memDaySign/saveSignIn";
    /**
     * POST /memDaySign/saveSignOut 保存签退
     */
    public static final String URL_SAVE_SIGN_OUT = URL_HOST
            + URL_BACK_SERVER + "/memDaySign/saveSignOut";
    /**
     * POST /memDaySign/getMemDaySign 会员日下店情况报表
     */
    public static final String URL_GET_MEM_DAY_SIGN = URL_HOST
            + URL_BACK_SERVER + "/memDaySign/getMemDaySign";
    /**
     * GET /memDaySign/getMemDaySignImgAndSaleCount 门店销售金额+会员日下店签到签退图片
     */
    public static final String URL_GET_SHOP_CUS_DAY_SALE_AMOUNT = URL_HOST
            + URL_BACK_SERVER + "/memDaySign/getMemDaySignImgAndSaleCount";

    /**
     * GET /partTimeTourShop/getPartTimeTourShopCheck 判读该店是否检查过
     */
    public static final String URL_GET_PARTTIME_TOURSHOP_CHECK = URL_HOST
            + URL_BACK_SERVER + "/partTimeTourShop/getPartTimeTourShopCheck";
    /**
     * GET /partTimeTourShop/getPartTimeTourShopModel 获取检查项的模型
     */
    public static final String URL_GET_PARTTIME_TOURSHOP_MODEL = URL_HOST
            + URL_BACK_SERVER + "/partTimeTourShop/getPartTimeTourShopModel";
    /**
     * GET /partTimeTourShop/getShopInfo 巡店门店搜索
     */
    public static final String URL_GET_SHOP_INFO = URL_HOST
            + URL_BACK_SERVER + "/partTimeTourShop/getShopInfo";
    /**
     * GET /partTimeTakeStock/takeStockGetShopInfo 巡店门店搜索(带临期货数)
     */
    public static final String URL_TAKE_STOCK_GET_SHOP_INFO = URL_HOST
            + URL_BACK_SERVER + "/partTimeTakeStock/takeStockGetShopInfo";
    /**
     * GET /partTimeTakeStock/getShopCheckList 查询门店的盘点记录
     */
    public static final String URL_GET_SHOP_CHECK_LIST = URL_HOST
            + URL_BACK_SERVER + "/partTimeTakeStock/getShopCheckList";
    /**
     * POST /partTimeTourShop/savePartTimeTourShop 保存兼职督查巡店检查
     */
    public static final String URL_SAVE_PARTTIME_TOURSHOP = URL_HOST
            + URL_BACK_SERVER + "/partTimeTourShop/savePartTimeTourShop";
    /**
     * POST /partTimeTourShop/savePartTimeTourShopDetail 提交检查
     */
    public static final String URL_SAVE_PARTTIME_TOURSHOP_DETAIL = URL_HOST
            + URL_BACK_SERVER + "/partTimeTourShop/savePartTimeTourShopDetail";
    /**
     * GET /shopSchedule/getFetureShopSchedule 获取门店近七天排班
     */
    public static final String URL_GET_FETURE_SHOP_SCHEDULE = URL_HOST
            + URL_BACK_SERVER + "/shopSchedule/getFetureShopSchedule";

    /**
     * GET /partTimeTakeStock/getPartTimeTakeStock 当天是否锁定库存盘点
     */
    public static final String URL_GET_PARTTIME_TAKESTOCK = URL_HOST
            + URL_BACK_SERVER + "/partTimeTakeStock/getPartTimeTakeStock";
    /**
     * POST /partTimeTakeStock/savePartTimeTakeStock 锁定库存
     */
    public static final String URL_SAVE_PARTTIME_TAKESTOCK = URL_HOST
            + URL_BACK_SERVER + "/partTimeTakeStock/savePartTimeTakeStock";
    /**
     * GET /partTimeTakeStock/removePartTimeTakeStock 解除库存
     */
    public static final String URL_REMOVE_PARTTIME_TAKESTOCK = URL_HOST
            + URL_BACK_SERVER + "/partTimeTakeStock/removePartTimeTakeStock";
    /**
     * GET /partTimeTakeStock/getTakeStockByShopId 获取门店盘点信息
     */
    public static final String URL_GET_TAKESTOCK_BY_SHOPID = URL_HOST
            + URL_BACK_SERVER + "/partTimeTakeStock/getTakeStockByShopId";
    /**
     * GET /partTimeTakeStock/getPartTimeTakeStockDetail 盘点信息详情
     */
    public static final String URL_GET_PARTTIME_TAKESTOCK_DETAIL = URL_HOST
            + URL_BACK_SERVER + "/partTimeTakeStock/getPartTimeTakeStockDetail";
    /**
     * GET /partTimeTakeStock/getShopBrandList  添加门店查询品牌
     */
    public static final String URL_GET_SHOP_BRAND_LIST = URL_HOST
            + URL_BACK_SERVER + "/partTimeTakeStock/getShopBrandList";
    /**
     * POST /partTimeTakeStock/batchSavePartTimeTakeStockDetail 批量盘点提交
     */
    public static final String URL_GET_BATCH_SAVE_PARTTIME_TAKESTOCK_DETAIL = URL_HOST
            + URL_BACK_SERVER + "/partTimeTakeStock/batchSavePartTimeTakeStockDetail";
    /**
     * get /partTimeTourShop/cancelTourShop 兼职督察自己作废
     */
    public static final String URL_GET_CANCEL_TOUR_SHOP = URL_HOST
            + URL_BACK_SERVER + "/partTimeTourShop/cancelTourShop";
    /**
     * get /mkt/report/getReportByProject 项目(按项目查或门店下的项目)
     */
    public static final String URL_GET_REPORT_BY_PROJECT = URL_HOST
            + URL_BACK_SERVER + "/mkt/report/getReportByProject";
    /**
     * get /mkt/report/getReportByShop 门店(按门店查或项目下的门店)
     */
    public static final String URL_GET_REPORT_BY_SHOP = URL_HOST
            + URL_BACK_SERVER + "/mkt/report/getReportByShop";
    /**
     * get /mkt/report/getReportStandardModel 获取上报标准配置model
     */
    public static final String URL_GET_REPORT_STANDARD_MODEL = URL_HOST
            + URL_BACK_SERVER + "/mkt/report/getReportStandardModel";
    /**
     * post /mkt/report/saveReportStandardDetail提交(全部都是新增,没有修改)
     */
    public static final String URL_SAVE_REPORT_STANDARD_DETAIL = URL_HOST
            + URL_BACK_SERVER + "/mkt/report/saveReportStandardDetail";
    /**
     * get /employAbility/findUserList 查询营养顾问信息
     */
    public static final String URL_FIND_USER_LIST = URL_HOST
            + URL_BACK_SERVER + "/employAbility/findUserList";
    /**
     * get /employAbility/findInStoreUserList 查询驻店营养顾问信息
     */
    public static final String URL_FIND_INSTORE_USER_LIST = URL_HOST
            + URL_BACK_SERVER + "/employAbility/findInStoreUserList";
    /**
     * get /employAbility/findEmployAbility 员工能力评估查询
     */
    public static final String URL_FIND_EMPLOY_ABILITY = URL_HOST
            + URL_BACK_SERVER + "/employAbility/findEmployAbility";
    /**
     * get /employAbility/findEmpAbilityQualifiedAndUn 员工能力项合格和不合格查询
     */
    public static final String URL_FIND_EMPABILITY_QUALIFIED_ANDUN = URL_HOST
            + URL_BACK_SERVER + "/employAbility/findEmpAbilityQualifiedAndUn";
    /**
     * get /employAbility/findEmployItemsTrainRecords 项目培训记录查询
     */
    public static final String URL_FIND_EMPLOY_ITEMS_TRAIN_RECORDS = URL_HOST
            + URL_BACK_SERVER + "/employAbility/findEmployItemsTrainRecords";
    /**
     * get /employAbility/findEmployAbilityTitle 员工能力评估查询一级菜单
     */
    public static final String URL_FIND_EMPLOY_ABILITY_TITLE = URL_HOST
            + URL_BACK_SERVER + "/employAbility/findEmployAbilityTitle";
    /**
     * post /employAbility/saveEmployAbilityBean 新增或修改能力评估
     */
    public static final String URL_SAVE_EMPLOY_ABILITY_BEAN = URL_HOST
            + URL_BACK_SERVER + "/employAbility/saveEmployAbilityBean";
    /**
     * post /employAbility/saveEmployItemsTrainRecords 新增项目培训记录
     */
    public static final String URL_SAVE_EMPLOY_ITEMS_TRAIN_RECORDS = URL_HOST
            + URL_BACK_SERVER + "/employAbility/saveEmployItemsTrainRecords";
    /**
     * get /newWorkerTrain/queryWorkerTrainMain 入职培训导师分配顾问信息
     */
    public static final String URL_SAVE_QUERY_WORKER_TRAIN_MAIN = URL_HOST
            + URL_BACK_SERVER + "/newWorkerTrain/queryWorkerTrainMain";
    /**
     * get /newWorkerTrain/queryWorkerTrainInfoNew 查询顾问培训记录及培训项目
     */
    public static final String URL_QUERY_WORKER_TRAIN_INFO_NEW = URL_HOST
            + URL_BACK_SERVER + "/newWorkerTrain/queryWorkerTrainInfoNew";
    /**
     * get /newWorkerTrain/queryWorkerTrainInfoList 查询顾问评估-营销管家
     */
    public static final String URL_QUERY_WORKER_TRAIN_INFO_LIST = URL_HOST
            + URL_BACK_SERVER + "/newWorkerTrain/queryWorkerTrainInfoList";
    /**
     * get /newWorkerTrain/queryNotEvaluatedUser 入职未评估用户信息
     */
    public static final String URL_SAVE_QUERY_NOT_EVALUATED_USER = URL_HOST
            + URL_BACK_SERVER + "/newWorkerTrain/queryNotEvaluatedUser";
    /**
     * get /newWorkerTrain/queryWorkerTrainContent 查询顾问培训内容
     */
    public static final String URL_QUERY_WORKER_TRAIN_CONTENT = URL_HOST
            + URL_BACK_SERVER + "/newWorkerTrain/queryWorkerTrainContent";
    /**
     * post /newWorkerTrain/saveWorkerTrainBean 新增或修改顾问培训记录
     */
    public static final String URL_SAVE_WORKER_TRAIN_BEAN = URL_HOST
            + URL_BACK_SERVER + "/newWorkerTrain/saveWorkerTrainBean";
    /**
     * post /newWorkerTrain/saveWorkerTrainEvaluation 顾问评估
     */
    public static final String URL_SAVE_WORKER_TRAIN_EVALUATION = URL_HOST
            + URL_BACK_SERVER + "/newWorkerTrain/saveWorkerTrainEvaluation";

    /**
     * get /workerTalentEvaluate/findInStoreUserList 查询驻店营养顾问信息
     */
    public static final String URL_FIND_IN_STORE_USER_LIST = URL_HOST
            + URL_BACK_SERVER + "/workerTalentEvaluate/findInStoreUserList";
    /**
     * get /workerTalentEvaluate/findUserList 查询营养顾问信息
     */
    public static final String URL_FIND_WORKER_TALENT_USER_LIST = URL_HOST
            + URL_BACK_SERVER + "/workerTalentEvaluate/findUserList";
    /**
     * post /workerTalentEvaluate/saveWorkerTalentEvaluate 顾问人才评估
     */
    public static final String URL_SAVE_WORKER_TALENT_EVALUATE = URL_HOST
            + URL_BACK_SERVER + "/workerTalentEvaluate/saveWorkerTalentEvaluate";
    /**
     * get /terminalDisCorrective/findTerminalDisShop 查询终端陈列整改门店
     */
    public static final String URL_FIND_TERMINAL_DISSHOP = URL_HOST
            + URL_BACK_SERVER + "/terminalDisCorrective/findTerminalDisShop";
    /**
     * post /exhibit/queryMissionByStoreNo 查询门店陈列任务
     */
    public static final String URL_QUERY_MISSION_BY_STORENO = URL_HOST
            + URL_APP_SALER + "/exhibit/queryMissionByStoreNo";
    /**
     * post /exhibit/addSubmition 新增提报数据
     */
    public static final String URL_ADD_SUBMITION = URL_HOST
            + URL_APP_SALER + "/exhibit/addSubmition";
    /**
     * post /exhibit/updateSubmition 修改提报数据
     */
    public static final String URL_UPDATE_SUBMITION = URL_HOST
            + URL_APP_SALER + "/exhibit/updateSubmition";
    /**
     * get /starsLights/findShopWorkersStarsLights 查询 门店下的顾问点灯记录
     */
    public static final String URL_FIND_SHOP_WORKERS_STARS_LIGHTS = URL_HOST
            + URL_BACK_SERVER + "/starsLights/findShopWorkersStarsLights";
    /**
     * get /starsLights/findOrgWorkersStarsLights 查询 组织下的顾问点灯记录
     */
    public static final String URL_FIND_ORG_WORKERS_STARS_LIGHTS = URL_HOST
            + URL_BACK_SERVER + "/starsLights/findOrgWorkersStarsLights";

    /**
     * get /customerComment/queryShopWorkers 查询 门店下的顾客评论记录
     */
    public static final String URL_QUERY_SHOP_WORKERS = URL_HOST
            + URL_BACK_SERVER + "/customerComment/queryShopWorkers";
    /**
     * get /customerComment/queryOrgWorkers 查询 组织下的顾客评论记录
     */
    public static final String URL_QUERY_ORG_WORKERS = URL_HOST
            + URL_BACK_SERVER + "/customerComment/queryOrgWorkers";

    /**
     * get  /gohome/queryTaskList  到家业务任务查询
     */
    public static final String URL_QUERY_TASK_LIST = URL_HOST
            + URL_BACK_SERVER + "/gohome/queryTaskList";

    /**
     * get /gohome/queryTaskDetail  到家业务任务详情查询
     */
    public static final String URL_QUERY_TASK_DETAIL = URL_HOST
            + URL_BACK_SERVER + "/gohome/queryTaskDetail";

    /**
     * post /gohome/submit 提交任务
     */
    public static final String URL_SUBMIT = URL_HOST
            + URL_BACK_SERVER + "/gohome/submit";

    /**
     * post /crm-api/common/customizeTask/create 创建自定义任务
     */
    public static final String URL_CREATE_CUSTOM_TASK = URL_API_HOST
            + URL_CRM_SERVER + "/common/customizeTask/create";

    /**
     * post /crm-api/common/customizeTask/page/list 分页查询自定义任务列表
     */
    public static final String URL_QUERY_CUSTOM_TASK_PAGE_LIST = URL_API_HOST
            + URL_CRM_SERVER + "/common/customizeTask/page/list";

    /**
     * post /crm-api/common/customizeTask/querySatisfyCustomizeTaskCount 查询满足条件的生成自定义任务客户数量
     */
    public static final String URL_QUERY_SATISFY_CUSTOM_TASK_COUNT = URL_API_HOST
            + URL_CRM_SERVER + "/common/customizeTask/querySatisfyCustomizeTaskCount";

    /**
     * post /crm-api/common/customizeTask/updateReferentialSpeech  编辑自定义任务参考话术
     */
    public static final String URL_UPDATE_REFERENTIAL_SPEECH = URL_API_HOST
            + URL_CRM_SERVER + "/common/customizeTask/updateReferentialSpeech";

    /**
     * post /crm-api/common/customizeTask/updateTaskStatus 更新任务状态
     */
    public static final String URL_UPDATE_TASK_STATUS = URL_API_HOST
            + URL_CRM_SERVER + "/common/customizeTask/updateTaskStatus";

    /**
     * get /product/offline 获取线下所有产品
     */
    public static final String URL_PRODUCT_OFFLINE = URL_WX_HOST
            + URL_MARKTING_ACTIVITIES_MANAGEMENT_SERVER + "/product/offline";

    /**
     * post  /crm-api/basic/label/option/list 获取所有标签列表
     */
    public static final String URL_QUERY_LABEL_OPTION_LIST = URL_API_HOST
            + URL_CRM_SERVER + "/basic/label/option/list";

    /**
     * post /baseDateOrgController/getSupermarketInfo 获取商超列表
     */
    public static final String URL_GET_SUPER_MARKET_IFNO = URL_WX_HOST
            + URL_BASE_DATA_SERVICE + "/baseDateOrgController/getSupermarketInfo";

    /**
     * get /baseDateOrgController/getOfficeInfoByOrgAndMarket  获取办事处  partnerId=&areaCode=MWA01&staffOrgCode=M
     */
    public static final String URL_GET_OFFICE_INFO_BY_ORG_AND_MARKET = URL_WX_HOST
            + URL_BASE_DATA_SERVICE + "/baseDateOrgController/getOfficeInfoByOrgAndMarket";

    /**
     * get  /saleOrg/shopInfoByByOrgAndMarket 获取所有门店  ?partnerId=&officeCode=MWA0102&managerCode=&staffOrgCode=
     */
    public static final String URL_SHOP_INFO_BY_ORG_AND_MARKET = URL_WX_HOST
            + URL_BASE_DATA_SERVICE + "/saleOrg/shopInfoByByOrgAndMarket";

    /**
     * post /crm-api/basic/shop/organization/queryActiveOrgList" 查询活跃的门店销售组织数据（有客户购买过的门店）
     */
    public static final String URL_QUERY_ACTIVE_ORG_LIST = URL_API_HOST
            + URL_CRM_SERVER + "/basic/shop/organization/queryActiveOrgList";

    /**
     * post /crm-api/order-api/basic/coupon/option/list 优惠券基础下拉列表
     */
    public static final String URL_BASIC_COUPON_OPTION_LIST = URL_API_HOST
            + "/order-api/basic/coupon/option/list";

    /**
     * post /crm-api/mkt/employee/dimission/audit 员工离职审核
     */
    public static final String URL_EMPLOYEE_DIMISSION_AUDIT = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/dimission/audit";

    /**
     * post /mkt/employee/dimission/page/List 分页查询员工离职记录列表
     */
    public static final String URL_EMPLOYEE_DIMISSION_PAGE_LIST = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/dimission/page/List";

    /**
     * post /mkt/employee/dimission/queryEmplDimissionAuditPageList  分页查询员工离职审核列表
     */
    public static final String URL_EMPLOYEE_DIMISSION_AUDIT_PAGE_LIST = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/dimission/queryEmplDimissionAuditPageList";

    /**
     * post /mkt/employee/dimission/queryEmplIsHaveDimissionApply   根据员工工号查询是否处于离职待审核状态
     */
    public static final String URL_EMPL_IS_HAVE_DIMISSION_APPLY = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/dimission/queryEmplIsHaveDimissionApply";

    /**
     * post /mkt/employee/dimission/save 保存员工离职
     */
    public static final String URL_EMPLOYEE_DIMISSION_SAVE = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/dimission/save";

    /**
     * post /mkt/employee/dimission/specifyAllocationEmployee 指定分配人
     */
    public static final String URL_EMPLOYEE_DIMISSION_SPECIFYAL_LOCATION_EMPLOYEE = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/dimission/specifyAllocationEmployee";

    /**
     * post /mkt/employee/dimission/reapplyDimission 重新发起申请员工离职
     */
    public static final String URL_EMPLOYEE_DIMISSION_UPDATE_DIMISSION = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/dimission/reapplyDimission";

    /**
     * post /mkt/employee/customerAllocation/queryConsultantPageList 分页查询顾问列表
     */
    public static final String URL_EMPLOYEE_CUSTOMER_ALLOCATION_CONSULTANT_PAGE_LIST = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/customerAllocation/queryConsultantPageList";

    /**
     * post /mkt/employee/customerAllocation/queryConsultantTotal 查询员工的顾问汇总信息
     */
    public static final String URL_EMPLOYEE_CUSTOMER_ALLOCATION_TOTAL = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/customerAllocation/queryConsultantTotal";

    /**
     * post mkt/employee/customerAllocation/queryUserAndCustomerRelationPageList
     */
    public static final String URL_EMPLOYEE_CUSTOMER_ALLOCATION_USER_CUSTOMER_RELATION_PAGE_LIST = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/customerAllocation/queryUserAndCustomerRelationPageList";

    /**
     * post mkt/employee/customerAllocation/queryCurrentConsultantIsCanApplyInfo
     */
    public static final String URL_EMPLOYEE_CUSTOMER_ALLOCATION_CAN_APPLY_INFO = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/customerAllocation/queryCurrentConsultantIsCanApplyInfo";

    /**
     * post mkt/employee/customerAllocation/save
     */
    public static final String URL_EMPLOYEE_CUSTOMER_ALLOCATION_SAVE = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/customerAllocation/save";

    /**
     * post mkt/employee/customerAllocation/page/list
     */
    public static final String URL_EMPLOYEE_CUSTOMER_ALLOCATION_PAGE_LIST = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/customerAllocation/page/list";

    /**
     * post organization/user/queryStaffStatus
     */
    public static final String URL_ORGANIZATION_USER_STAFF_STATUS = URL_API_HOST
            + URL_CRM_SERVER + "/organization/user/queryStaffStatus";

    /**
     * post mkt/employee/customerAllocation/queryAuditPageList
     */
    public static final String URL_EMPLOYEE_CUSTOMER_ALLOCATION_AUDIT_PAGE_LIST = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/customerAllocation/queryAuditPageList";


    /**
     * post mkt/employee/customerAllocation/audit
     */
    public static final String URL_EMPLOYEE_CUSTOMER_ALLOCATION_AUDIT = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/employee/customerAllocation/audit";

    /**
     * post /crm-api/mkt/customer/monthlyTarget/queryList 查询月度目标系数列表
     */
    public static final String URL_QUERY_MONTHLY_TARGET_LIST = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/user/target/monthlyTarget/queryList";

    /**
     * post /crm-api/mkt/customer/monthlyTarget/update 修改月度目标系数
     */
    public static final String URL_UPDATE_MONTHLY_TARGET = URL_API_HOST
            + URL_CRM_SERVER + "/mkt/user/target/monthlyTarget/update";


}