package com.wgmf.yxgj.model;

import org.greenrobot.greendao.annotation.Entity;
import org.greenrobot.greendao.annotation.Id;
import org.greenrobot.greendao.annotation.Generated;

/**
 * 登录常用功能列表实体
 *
 * @author xiep
 */
@Entity
public class CommonResourcesBean {
    /**
     * 主键ID
     */
    @Id
    private Long Id;

    private Long resourceId;
    /**
     * 是否为默认菜单(0.否，1.是)
     */
    private int isDefaultMenu;
    /**
     * 资源名称
     */
    private String name;
    /**
     * 父类Id,parentID=10008时为根目录
     */
    private Long parentId;
    /**
     * URL地址
     */
    private String resUrl;
    /**
     * 权限类型：1．表示目录　2，表示菜单．3，表示按扭．．在spring
     */
    private int type;
    // security3安全权限中，涉及精确到按扭控制
    /**
     * 资源描述
     */
    private String description;
    /**
     * 常用功能选择标识,本地标志
     */
    private boolean isChoice;

    /**
     * 后台权限重新配置后，用户是否仍然存在该权限的标识，本地标志
     */
    private boolean isExist;

    @Generated(hash = 1545703920)
    public CommonResourcesBean(Long Id, Long resourceId, int isDefaultMenu,
            String name, Long parentId, String resUrl, int type, String description,
            boolean isChoice, boolean isExist) {
        this.Id = Id;
        this.resourceId = resourceId;
        this.isDefaultMenu = isDefaultMenu;
        this.name = name;
        this.parentId = parentId;
        this.resUrl = resUrl;
        this.type = type;
        this.description = description;
        this.isChoice = isChoice;
        this.isExist = isExist;
    }


    @Generated(hash = 1212103010)
    public CommonResourcesBean() {
    }

    public boolean getIsExist() {
        return this.isExist;
    }


    public void setIsExist(boolean isExist) {
        this.isExist = isExist;
    }


    public boolean getIsChoice() {
        return this.isChoice;
    }


    public void setIsChoice(boolean isChoice) {
        this.isChoice = isChoice;
    }


    public String getResUrl() {
        return this.resUrl;
    }


    public void setResUrl(String resUrl) {
        this.resUrl = resUrl;
    }


    public Long getParentId() {
        return this.parentId;
    }


    public void setParentId(Long parentId) {
        this.parentId = parentId;
    }


    public String getName() {
        return this.name;
    }


    public void setName(String name) {
        this.name = name;
    }


    public int getIsDefaultMenu() {
        return this.isDefaultMenu;
    }


    public void setIsDefaultMenu(int isDefaultMenu) {
        this.isDefaultMenu = isDefaultMenu;
    }


    public void setResourceId(Long resourceId) {
        this.resourceId = resourceId;
    }


    public Long getResourceId() {
        return this.resourceId;
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }


    public Long getId() {
        return this.Id;
    }


    public void setId(Long Id) {
        this.Id = Id;
    }
}