package com.wgmf.yxgj.model;

import com.google.gson.annotations.SerializedName;
import com.wgmf.yxgj.publics.model.Shop;

import org.greenrobot.greendao.annotation.Entity;
import org.greenrobot.greendao.annotation.Generated;
import org.greenrobot.greendao.annotation.Id;
import org.greenrobot.greendao.annotation.Property;
import org.greenrobot.greendao.annotation.Transient;

import java.io.Serializable;
import java.util.List;

/**
 * 1，员工入职查询
 * 2，员工离职查询
 * 3，员工审批查询
 * 4，员工信息修改查询
 * 5，员工信息修改提交
 * 6，新员工入职办理本地数据库读取转化
 * 7，新员工入职提交
 */
@SuppressWarnings("all")
@Entity
public class NutritionConsultant implements Serializable {

    private static final long serialVersionUID = 1L;
    //表Id，本地字段
    @Id(autoincrement = true)
    private Long Id;

    private String entryOfficeId;
    /**
     * 上次保存时间，本地字段
     */
    private String newStaffInductionTime;

    //培训导师工号
    private String trainTutorId;

    //培训导师名字
    private String trainTutorName;

    // @ApiModelProperty(value = "组织机构ID")
    private int saleOrganization;

    // @ApiModelProperty(value = "员工编号")
    @SerializedName(value = "operatorId", alternate = {"staffId"})
    private String operatorId;

    // @ApiModelProperty(value = "员工姓名")
    @Property(nameInDb = "STAFFNAME")
    @SerializedName(value = "operName", alternate = {"name"})
    private String operName;

    // @ApiModelProperty(value = "员工密码")
    private String password;

    // @ApiModelProperty(value = "员工性别")
    private String sex;

    // @ApiModelProperty(value = "员工类型")
    private String optype;
    //门店信息
    @Transient
    private List<Shop> shopList;

    //门店信息：用于存数据库
    private String shopListString;

    // @ApiModelProperty(value = "紧急联系人")
    private String emergencyName;

    // @ApiModelProperty(value = "紧急联系电话")
    private String phone;

    // @ApiModelProperty(value = "手机")
    private String mobilePhone;

    // @ApiModelProperty(value = "身份证")
    private String personalId;

    // @ApiModelProperty(value = "出生日期")
    private String birthday;

    // @ApiModelProperty(value = "入职日期")
    private String workDate;

    // @ApiModelProperty(value =
    // "工作岗位 1：驻店营养顾问 2：流动营养顾问 3：促销主管 4：机修 5：办事处文员 6：终端经理 7：区域经理")
    private String roleStatus;

    // @ApiModelProperty(value = "离职状态：在职(0),离职(1)
    private String status;

    //1-待审核，2-审批不通过，3-待入职，4-入职")
    private String entrystatus;

    // @ApiModelProperty(value = "学历 01：本科 02：大专 03：中专 04：高中 05：初中 06：小学")
    private String xlId;

    // @ApiModelProperty(value = "籍贯")
    private String ryjg;

    // @ApiModelProperty(value = "现在住址")
    private String nowAddress;

    // @ApiModelProperty(value = "录入日期")
    private String addDate;

    // 入职,离职,审批,转正,修改,操作人id统一为approvalPerson
    private String approvalPerson;

    // @ApiModelProperty(value = "离职日期")
    private String lzDate;

    // @ApiModelProperty(value = "修改人编号")
    private String chgPerson;

    // @ApiModelProperty(value = "修改人名称")
    private String chgName;

    // @ApiModelProperty(value = "修改日期")
    private String chgDate;

    // @ApiModelProperty(value = "审核状态：-- 0-未审核，1-已审核")
    private String shStatus;

    // @ApiModelProperty(value = "审核日期")
    private String shDate;

    // @ApiModelProperty(value = "审核人编号")
    private String shPerson;

    // @ApiModelProperty(value = "审核人名称")
    private String shName;

    // @ApiModelProperty(value = "开户银行")
    private String bankName;

    // @ApiModelProperty(value = "开户省市")
    private String bankCity;

    // @ApiModelProperty(value = "开户行信息")
    private String bankCityDetail;

    // @ApiModelProperty(value = "银行账号")
    private String accountId;

    // @ApiModelProperty(value = "基本工资")
    private String jbNet;

    // @ApiModelProperty(value = "底薪增加值")
    private String salaryIncrease;

    // @ApiModelProperty(value = "绩效工资")
    private String jxNet;

    // @ApiModelProperty(value = "爱心基金")
    private String axNet;

    // @ApiModelProperty(value = "任务内提成点")
    private String rwnRate;

    // @ApiModelProperty(value = "超额提成点")
    private String ceRate;

    // @ApiModelProperty(value = "交通补贴")
    private String trafficSubsidy;

    // @ApiModelProperty(value = "通讯补贴")
    private String commSubsidy;

    // @ApiModelProperty(value = "上级主管")
    private String orgName;

    // 招聘来源：('01','58同城'),('02','赶集网'),('03','智联招聘'),('04','前程无忧'),('05','内部推荐'),('06','巡场招聘'),('07','地方论坛'),('08','熟人介绍')
    private String zply;

    // 有无亲属在本公司：('Y','有'),('N','无')
    private String ifrelatives;

    // 亲属姓名
    private String relatives;

    // 亲属职位
    private String relativesPost;

    // 营养顾问资料修改人id
    private String updateUserInfoPersonId;

    // 外包公司名称
    private String outsourcedName;

    // 外包公司编号
    private String outsourcedNo;

    // @ApiModelProperty(value = "健康证编号")
    private String healthyNo;

    // @ApiModelProperty(value = "健康证有效期")
    private String healthyTime;

    // @ApiModelProperty(value = "健康证图片(路径)")
    private String healthyImg;

    // @ApiModelProperty(value = "身份证图片(路径)")
    private String personalidImg;

    // @ApiModelProperty(value = "生活照片url ")
    private String lifePhotosUrl;

    // @ApiModelProperty(value = "合同照片url ")
    private String contractImg;

    // @ApiModelProperty(value = "体检机构名称")
    private String mechanismName;
    // @ApiModelProperty(value = "体检时间")
    private String medicalTime;
    /**
     * shopCityCountryId  (integer, optional):门店所属城市区域id ,
     */
    private Integer shopCityCountryId;
    //所在城市
    private String shopSlaryAdress;
    //顾问品牌
    @Transient
    private List<BrandList> brandList;
    //顾问品牌:用于数据库存储
    private String brandListString;

    //isRehire (boolean, optional):是否可返聘 : true 表示可以返聘，false 不返聘 ,
    @Transient
    private boolean isRehire;
    //离职原因
    @Transient
    private String lzreason;
    //离职类型：'01','主动离职'),('02','被动离职'),('03','自离') ,
    @Transient
    private String lztype;
    @Transient
    private List<LeavNutConWorkDataListEntity> leavNutConWorkDataList;
    //是否购买社保
    @Transient
    private boolean isSocialSecurity;
    //购买城市
    @Transient
    private String socialSecurityCity;
    //OA流水号
    @Transient
    private String oaCode;
    //劳动合同开始时间
    @Transient
    private String beginDateContract;
    //劳动合同结束时间
    @Transient
    private String endDateContract;
    //劳动合同期限
    @Transient
    private String termContract;

    @Generated(hash = 1326280462)
    public NutritionConsultant(Long Id, String entryOfficeId, String newStaffInductionTime, String trainTutorId,
            String trainTutorName, int saleOrganization, String operatorId, String operName, String password, String sex,
            String optype, String shopListString, String emergencyName, String phone, String mobilePhone, String personalId,
            String birthday, String workDate, String roleStatus, String status, String entrystatus, String xlId,
            String ryjg, String nowAddress, String addDate, String approvalPerson, String lzDate, String chgPerson,
            String chgName, String chgDate, String shStatus, String shDate, String shPerson, String shName, String bankName,
            String bankCity, String bankCityDetail, String accountId, String jbNet, String salaryIncrease, String jxNet,
            String axNet, String rwnRate, String ceRate, String trafficSubsidy, String commSubsidy, String orgName,
            String zply, String ifrelatives, String relatives, String relativesPost, String updateUserInfoPersonId,
            String outsourcedName, String outsourcedNo, String healthyNo, String healthyTime, String healthyImg,
            String personalidImg, String lifePhotosUrl, String contractImg, String mechanismName, String medicalTime,
            Integer shopCityCountryId, String shopSlaryAdress, String brandListString) {
        this.Id = Id;
        this.entryOfficeId = entryOfficeId;
        this.newStaffInductionTime = newStaffInductionTime;
        this.trainTutorId = trainTutorId;
        this.trainTutorName = trainTutorName;
        this.saleOrganization = saleOrganization;
        this.operatorId = operatorId;
        this.operName = operName;
        this.password = password;
        this.sex = sex;
        this.optype = optype;
        this.shopListString = shopListString;
        this.emergencyName = emergencyName;
        this.phone = phone;
        this.mobilePhone = mobilePhone;
        this.personalId = personalId;
        this.birthday = birthday;
        this.workDate = workDate;
        this.roleStatus = roleStatus;
        this.status = status;
        this.entrystatus = entrystatus;
        this.xlId = xlId;
        this.ryjg = ryjg;
        this.nowAddress = nowAddress;
        this.addDate = addDate;
        this.approvalPerson = approvalPerson;
        this.lzDate = lzDate;
        this.chgPerson = chgPerson;
        this.chgName = chgName;
        this.chgDate = chgDate;
        this.shStatus = shStatus;
        this.shDate = shDate;
        this.shPerson = shPerson;
        this.shName = shName;
        this.bankName = bankName;
        this.bankCity = bankCity;
        this.bankCityDetail = bankCityDetail;
        this.accountId = accountId;
        this.jbNet = jbNet;
        this.salaryIncrease = salaryIncrease;
        this.jxNet = jxNet;
        this.axNet = axNet;
        this.rwnRate = rwnRate;
        this.ceRate = ceRate;
        this.trafficSubsidy = trafficSubsidy;
        this.commSubsidy = commSubsidy;
        this.orgName = orgName;
        this.zply = zply;
        this.ifrelatives = ifrelatives;
        this.relatives = relatives;
        this.relativesPost = relativesPost;
        this.updateUserInfoPersonId = updateUserInfoPersonId;
        this.outsourcedName = outsourcedName;
        this.outsourcedNo = outsourcedNo;
        this.healthyNo = healthyNo;
        this.healthyTime = healthyTime;
        this.healthyImg = healthyImg;
        this.personalidImg = personalidImg;
        this.lifePhotosUrl = lifePhotosUrl;
        this.contractImg = contractImg;
        this.mechanismName = mechanismName;
        this.medicalTime = medicalTime;
        this.shopCityCountryId = shopCityCountryId;
        this.shopSlaryAdress = shopSlaryAdress;
        this.brandListString = brandListString;
    }

    @Generated(hash = 2103699606)
    public NutritionConsultant() {
    }

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public Long getId() {
        return Id;
    }

    public void setId(Long id) {
        Id = id;
    }

    public String getEntryOfficeId() {
        return entryOfficeId;
    }

    public void setEntryOfficeId(String entryOfficeId) {
        this.entryOfficeId = entryOfficeId;
    }

    public String getNewStaffInductionTime() {
        return newStaffInductionTime;
    }

    public void setNewStaffInductionTime(String newStaffInductionTime) {
        this.newStaffInductionTime = newStaffInductionTime;
    }

    public String getTrainTutorId() {
        return trainTutorId;
    }

    public void setTrainTutorId(String trainTutorId) {
        this.trainTutorId = trainTutorId;
    }

    public String getTrainTutorName() {
        return trainTutorName;
    }

    public void setTrainTutorName(String trainTutorName) {
        this.trainTutorName = trainTutorName;
    }

    public int getSaleOrganization() {
        return saleOrganization;
    }

    public void setSaleOrganization(int saleOrganization) {
        this.saleOrganization = saleOrganization;
    }

    public String getOperatorId() {
        return operatorId;
    }

    public void setOperatorId(String operatorId) {
        this.operatorId = operatorId;
    }

    public String getOperName() {
        return operName;
    }

    public void setOperName(String operName) {
        this.operName = operName;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getSex() {
        return sex;
    }

    public void setSex(String sex) {
        this.sex = sex;
    }

    public String getOptype() {
        return optype;
    }

    public void setOptype(String optype) {
        this.optype = optype;
    }

    public String getEmergencyName() {
        return emergencyName;
    }

    public void setEmergencyName(String emergencyName) {
        this.emergencyName = emergencyName;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getMobilePhone() {
        return mobilePhone;
    }

    public void setMobilePhone(String mobilePhone) {
        this.mobilePhone = mobilePhone;
    }

    public String getPersonalId() {
        return personalId;
    }

    public void setPersonalId(String personalId) {
        this.personalId = personalId;
    }

    public String getBirthday() {
        return birthday;
    }

    public void setBirthday(String birthday) {
        this.birthday = birthday;
    }

    public String getWorkDate() {
        return workDate;
    }

    public void setWorkDate(String workDate) {
        this.workDate = workDate;
    }

    public String getRoleStatus() {
        return roleStatus;
    }

    public void setRoleStatus(String roleStatus) {
        this.roleStatus = roleStatus;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getEntrystatus() {
        return entrystatus;
    }

    public void setEntrystatus(String entrystatus) {
        this.entrystatus = entrystatus;
    }

    public String getXlId() {
        return xlId;
    }

    public void setXlId(String xlId) {
        this.xlId = xlId;
    }

    public String getRyjg() {
        return ryjg;
    }

    public void setRyjg(String ryjg) {
        this.ryjg = ryjg;
    }

    public String getNowAddress() {
        return nowAddress;
    }

    public void setNowAddress(String nowAddress) {
        this.nowAddress = nowAddress;
    }

    public String getAddDate() {
        return addDate;
    }

    public void setAddDate(String addDate) {
        this.addDate = addDate;
    }

    public String getApprovalPerson() {
        return approvalPerson;
    }

    public void setApprovalPerson(String approvalPerson) {
        this.approvalPerson = approvalPerson;
    }

    public String getLzDate() {
        return lzDate;
    }

    public void setLzDate(String lzDate) {
        this.lzDate = lzDate;
    }

    public String getChgPerson() {
        return chgPerson;
    }

    public void setChgPerson(String chgPerson) {
        this.chgPerson = chgPerson;
    }

    public String getChgName() {
        return chgName;
    }

    public void setChgName(String chgName) {
        this.chgName = chgName;
    }

    public String getChgDate() {
        return chgDate;
    }

    public void setChgDate(String chgDate) {
        this.chgDate = chgDate;
    }

    public String getShStatus() {
        return shStatus;
    }

    public void setShStatus(String shStatus) {
        this.shStatus = shStatus;
    }

    public String getShDate() {
        return shDate;
    }

    public void setShDate(String shDate) {
        this.shDate = shDate;
    }

    public String getShPerson() {
        return shPerson;
    }

    public void setShPerson(String shPerson) {
        this.shPerson = shPerson;
    }

    public String getShName() {
        return shName;
    }

    public void setShName(String shName) {
        this.shName = shName;
    }

    public String getBankName() {
        return bankName;
    }

    public void setBankName(String bankName) {
        this.bankName = bankName;
    }

    public String getBankCity() {
        return bankCity;
    }

    public void setBankCity(String bankCity) {
        this.bankCity = bankCity;
    }

    public String getBankCityDetail() {
        return bankCityDetail;
    }

    public void setBankCityDetail(String bankCityDetail) {
        this.bankCityDetail = bankCityDetail;
    }

    public String getAccountId() {
        return accountId;
    }

    public void setAccountId(String accountId) {
        this.accountId = accountId;
    }

    public String getJbNet() {
        return jbNet;
    }

    public void setJbNet(String jbNet) {
        this.jbNet = jbNet;
    }

    public String getJxNet() {
        return jxNet;
    }

    public void setJxNet(String jxNet) {
        this.jxNet = jxNet;
    }

    public String getAxNet() {
        return axNet;
    }

    public void setAxNet(String axNet) {
        this.axNet = axNet;
    }

    public String getRwnRate() {
        return rwnRate;
    }

    public void setRwnRate(String rwnRate) {
        this.rwnRate = rwnRate;
    }

    public String getCeRate() {
        return ceRate;
    }

    public void setCeRate(String ceRate) {
        this.ceRate = ceRate;
    }

    public String getTrafficSubsidy() {
        return trafficSubsidy;
    }

    public void setTrafficSubsidy(String trafficSubsidy) {
        this.trafficSubsidy = trafficSubsidy;
    }

    public String getCommSubsidy() {
        return commSubsidy;
    }

    public void setCommSubsidy(String commSubsidy) {
        this.commSubsidy = commSubsidy;
    }

    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public String getZply() {
        return zply;
    }

    public void setZply(String zply) {
        this.zply = zply;
    }

    public String getIfrelatives() {
        return ifrelatives;
    }

    public void setIfrelatives(String ifrelatives) {
        this.ifrelatives = ifrelatives;
    }

    public String getRelatives() {
        return relatives;
    }

    public void setRelatives(String relatives) {
        this.relatives = relatives;
    }

    public String getRelativesPost() {
        return relativesPost;
    }

    public void setRelativesPost(String relativesPost) {
        this.relativesPost = relativesPost;
    }

    public String getUpdateUserInfoPersonId() {
        return updateUserInfoPersonId;
    }

    public void setUpdateUserInfoPersonId(String updateUserInfoPersonId) {
        this.updateUserInfoPersonId = updateUserInfoPersonId;
    }

    public String getOutsourcedName() {
        return outsourcedName;
    }

    public void setOutsourcedName(String outsourcedName) {
        this.outsourcedName = outsourcedName;
    }

    public String getOutsourcedNo() {
        return outsourcedNo;
    }

    public void setOutsourcedNo(String outsourcedNo) {
        this.outsourcedNo = outsourcedNo;
    }

    public String getHealthyNo() {
        return healthyNo;
    }

    public void setHealthyNo(String healthyNo) {
        this.healthyNo = healthyNo;
    }

    public String getHealthyTime() {
        return healthyTime;
    }

    public void setHealthyTime(String healthyTime) {
        this.healthyTime = healthyTime;
    }

    public String getHealthyImg() {
        return healthyImg;
    }

    public void setHealthyImg(String healthyImg) {
        this.healthyImg = healthyImg;
    }

    public String getPersonalidImg() {
        return personalidImg;
    }

    public void setPersonalidImg(String personalidImg) {
        this.personalidImg = personalidImg;
    }

    public String getMechanismName() {
        return mechanismName;
    }

    public void setMechanismName(String mechanismName) {
        this.mechanismName = mechanismName;
    }

    public String getMedicalTime() {
        return medicalTime;
    }

    public void setMedicalTime(String medicalTime) {
        this.medicalTime = medicalTime;
    }

    public String getLifePhotosUrl() {
        return lifePhotosUrl;
    }

    public void setLifePhotosUrl(String lifePhotosUrl) {
        this.lifePhotosUrl = lifePhotosUrl;
    }

    public boolean isRehire() {
        return isRehire;
    }

    public void setRehire(boolean rehire) {
        isRehire = rehire;
    }

    public String getLzreason() {
        return lzreason;
    }

    public void setLzreason(String lzreason) {
        this.lzreason = lzreason;
    }

    public String getLztype() {
        return lztype;
    }

    public void setLztype(String lztype) {
        this.lztype = lztype;
    }

    public List<LeavNutConWorkDataListEntity> getLeavNutConWorkDataList() {
        return leavNutConWorkDataList;
    }

    public void setLeavNutConWorkDataList(List<LeavNutConWorkDataListEntity> leavNutConWorkDataList) {
        this.leavNutConWorkDataList = leavNutConWorkDataList;
    }

    public boolean isSocialSecurity() {
        return isSocialSecurity;
    }

    public void setSocialSecurity(boolean socialSecurity) {
        isSocialSecurity = socialSecurity;
    }

    public String getSocialSecurityCity() {
        return socialSecurityCity;
    }

    public void setSocialSecurityCity(String socialSecurityCity) {
        this.socialSecurityCity = socialSecurityCity;
    }

    public String getOaCode() {
        return oaCode;
    }

    public void setOaCode(String oaCode) {
        this.oaCode = oaCode;
    }

    public String getBeginDateContract() {
        return beginDateContract;
    }

    public void setBeginDateContract(String beginDateContract) {
        this.beginDateContract = beginDateContract;
    }

    public String getEndDateContract() {
        return endDateContract;
    }

    public void setEndDateContract(String endDateContract) {
        this.endDateContract = endDateContract;
    }

    public String getTermContract() {
        return termContract;
    }

    public void setTermContract(String termContract) {
        this.termContract = termContract;
    }

    public Integer getShopCityCountryId() {
        return shopCityCountryId;
    }

    public void setShopCityCountryId(Integer shopCityCountryId) {
        this.shopCityCountryId = shopCityCountryId;
    }

    public String getShopSlaryAdress() {
        return this.shopSlaryAdress;
    }

    public void setShopSlaryAdress(String shopSlaryAdress) {
        this.shopSlaryAdress = shopSlaryAdress;
    }

    public List<Shop> getShopList() {
        return shopList;
    }

    public void setShopList(List<Shop> shopList) {
        this.shopList = shopList;
    }

    public List<BrandList> getBrandList() {
        return brandList;
    }

    public void setBrandList(List<BrandList> brandList) {
        this.brandList = brandList;
    }

    public String getShopListString() {
        return this.shopListString;
    }

    public void setShopListString(String shopListString) {
        this.shopListString = shopListString;
    }

    public String getBrandListString() {
        return this.brandListString;
    }

    public void setBrandListString(String brandListString) {
        this.brandListString = brandListString;
    }

    public String getSalaryIncrease() {
        return salaryIncrease;
    }

    public void setSalaryIncrease(String salaryIncrease) {
        this.salaryIncrease = salaryIncrease;
    }

    public String getContractImg() {
        return contractImg;
    }

    public void setContractImg(String contractImg) {
        this.contractImg = contractImg;
    }

    @Override
    public String toString() {
        return "NutritionConsultant{" +
                "Id=" + Id +
                ", entryOfficeId='" + entryOfficeId + '\'' +
                ", newStaffInductionTime='" + newStaffInductionTime + '\'' +
                ", trainTutorId='" + trainTutorId + '\'' +
                ", trainTutorName='" + trainTutorName + '\'' +
                ", saleOrganization=" + saleOrganization +
                ", operatorId='" + operatorId + '\'' +
                ", operName='" + operName + '\'' +
                ", password='" + password + '\'' +
                ", sex='" + sex + '\'' +
                ", optype='" + optype + '\'' +
                ", shopList=" + shopList +
                ", shopListString='" + shopListString + '\'' +
                ", emergencyName='" + emergencyName + '\'' +
                ", phone='" + phone + '\'' +
                ", mobilePhone='" + mobilePhone + '\'' +
                ", personalId='" + personalId + '\'' +
                ", birthday='" + birthday + '\'' +
                ", workDate='" + workDate + '\'' +
                ", roleStatus='" + roleStatus + '\'' +
                ", status='" + status + '\'' +
                ", entrystatus='" + entrystatus + '\'' +
                ", xlId='" + xlId + '\'' +
                ", ryjg='" + ryjg + '\'' +
                ", nowAddress='" + nowAddress + '\'' +
                ", addDate='" + addDate + '\'' +
                ", approvalPerson='" + approvalPerson + '\'' +
                ", lzDate='" + lzDate + '\'' +
                ", chgPerson='" + chgPerson + '\'' +
                ", chgName='" + chgName + '\'' +
                ", chgDate='" + chgDate + '\'' +
                ", shStatus='" + shStatus + '\'' +
                ", shDate='" + shDate + '\'' +
                ", shPerson='" + shPerson + '\'' +
                ", shName='" + shName + '\'' +
                ", bankName='" + bankName + '\'' +
                ", bankCity='" + bankCity + '\'' +
                ", bankCityDetail='" + bankCityDetail + '\'' +
                ", accountId='" + accountId + '\'' +
                ", jbNet='" + jbNet + '\'' +
                ", salaryIncrease='" + salaryIncrease + '\'' +
                ", jxNet='" + jxNet + '\'' +
                ", axNet='" + axNet + '\'' +
                ", rwnRate='" + rwnRate + '\'' +
                ", ceRate='" + ceRate + '\'' +
                ", trafficSubsidy='" + trafficSubsidy + '\'' +
                ", commSubsidy='" + commSubsidy + '\'' +
                ", orgName='" + orgName + '\'' +
                ", zply='" + zply + '\'' +
                ", ifrelatives='" + ifrelatives + '\'' +
                ", relatives='" + relatives + '\'' +
                ", relativesPost='" + relativesPost + '\'' +
                ", updateUserInfoPersonId='" + updateUserInfoPersonId + '\'' +
                ", outsourcedName='" + outsourcedName + '\'' +
                ", outsourcedNo='" + outsourcedNo + '\'' +
                ", healthyNo='" + healthyNo + '\'' +
                ", healthyTime='" + healthyTime + '\'' +
                ", healthyImg='" + healthyImg + '\'' +
                ", personalidImg='" + personalidImg + '\'' +
                ", lifePhotosUrl='" + lifePhotosUrl + '\'' +
                ", contractImg='" + contractImg + '\'' +
                ", mechanismName='" + mechanismName + '\'' +
                ", medicalTime='" + medicalTime + '\'' +
                ", shopCityCountryId=" + shopCityCountryId +
                ", shopSlaryAdress='" + shopSlaryAdress + '\'' +
                ", brandList=" + brandList +
                ", brandListString='" + brandListString + '\'' +
                ", isRehire=" + isRehire +
                ", lzreason='" + lzreason + '\'' +
                ", lztype='" + lztype + '\'' +
                ", leavNutConWorkDataList=" + leavNutConWorkDataList +
                ", isSocialSecurity=" + isSocialSecurity +
                ", socialSecurityCity='" + socialSecurityCity + '\'' +
                ", oaCode='" + oaCode + '\'' +
                ", beginDateContract='" + beginDateContract + '\'' +
                ", endDateContract='" + endDateContract + '\'' +
                ", termContract='" + termContract + '\'' +
                '}';
    }
}