package com.wgmf.yxgj.model;

import org.greenrobot.greendao.annotation.Entity;
import org.greenrobot.greendao.annotation.Id;
import org.greenrobot.greendao.annotation.Transient;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.greenrobot.greendao.annotation.Generated;


/**
 * @author xiep  on 2016/9/27 15:41
 * maxSuggestOrderGoodsNum (number, optional):最大建议订货量 ,
 * orderGoodsAmount (number, optional):订货金额 ,
 * orderGoodsAuditId (integer, optional):订货审核Id ,
 * orderGoodsAuditNum (number, optional):审核数量 ,
 * orderGoodsNum (number, optional):订货数量 ,
 * orderGoodsNumINControl (string, optional):订货数量是否管控 ,
 * orderGoodsStoreWeekDayAndCycle (OrderGoodsStoreWeekDayAndCycle, optional):订货审核门店周期和星期 ,
 * pdBillCode (string, optional):盘点单号 ,
 * pdId (integer, optional):盘点ID ,
 * productAlreadyOrderNum (number, optional):已提交数量 ,
 * productBigFatherType (string, optional):产品大类父类 ,
 * productBigType (string, optional):产品大类 ,
 * productBoxNum (number, optional):产品箱装数量 ,
 * productCode (string, optional):产品编码 ,
 * productFutureNum (number, optional):产品在途数量 ,
 * productId (integer, optional):产品Id ,
 * productIsNotStock (boolean, optional):产品是否缺货： true/缺货，false/不缺 ,
 * productLastMonthOrderNum (number, optional):近30天已订货数量 ,
 * productLastMonthSaleNum (number, optional):产品前30天销售数量 ,
 * productName (string, optional):产品名称 ,
 * productPrice (string, optional):产品价格 ,
 * productStockNum (number, optional):产品库存数量 ,
 * productUnit (string, optional):产品单位 ,
 * productUnitId (integer, optional):产品单位id ,
 * suggestOrderGoodsNum (number, optional):建议订货量 ,
 * type (string, optional):类型（是UPDATE =0 或 INSERT =1） ,
 * userNo (string, optional):处理人工号
 */

@Entity
public class OrderGoodsAuditBatchDetail implements Serializable {
    @Transient
    static final long serialVersionUID = 1L;

    private String userNo;

    private String storeName;

    private String storeNo;

    private String productName;

    private String productCode;

    private String productUnit;

    private int productUnitId;

    private String productPrice;

    private double suggestOrderGoodsNum;

    private double orderGoodsNum;

    private double orderGoodsAuditNum;

    private double productFutureNum;

    private double productLastMonthOrderNum;

    private int productStockDayNum;

    private int type;

    private boolean productIsNotStock;

    private boolean invalid;

    private boolean secondValid;

    private String productImage;

    private double productStockNum;

    private double productLastMonthSaleNum;

    private String productBigType;

    private String productBigFatherType;

    private double productBoxNum;

    private double productAlreadyOrderNum;

    @Id
    private long productId;

    private String orderGoodsAmount;

    private String orderGoodsNumINControl;

    private String pdBillCode;

    private String pdId;

    private double maxSuggestOrderGoodsNum;

    private String batchOrderAuditBillCode;

    @Transient
    public List<BatchOrderAuditBillCode> batchOrderAuditBillCodeList = new ArrayList<>();

    @Transient
    public boolean isShowImageTv = false;//自建字段：是否显示“查看图片”文字，如果图片链接无效，则不显示，反之显示。

    @Generated(hash = 1560572780)
    public OrderGoodsAuditBatchDetail(String userNo, String storeName, String storeNo,
            String productName, String productCode, String productUnit, int productUnitId,
            String productPrice, double suggestOrderGoodsNum, double orderGoodsNum,
            double orderGoodsAuditNum, double productFutureNum,
            double productLastMonthOrderNum, int productStockDayNum, int type,
            boolean productIsNotStock, boolean invalid, boolean secondValid,
            String productImage, double productStockNum, double productLastMonthSaleNum,
            String productBigType, String productBigFatherType, double productBoxNum,
            double productAlreadyOrderNum, long productId, String orderGoodsAmount,
            String orderGoodsNumINControl, String pdBillCode, String pdId,
            double maxSuggestOrderGoodsNum, String batchOrderAuditBillCode) {
        this.userNo = userNo;
        this.storeName = storeName;
        this.storeNo = storeNo;
        this.productName = productName;
        this.productCode = productCode;
        this.productUnit = productUnit;
        this.productUnitId = productUnitId;
        this.productPrice = productPrice;
        this.suggestOrderGoodsNum = suggestOrderGoodsNum;
        this.orderGoodsNum = orderGoodsNum;
        this.orderGoodsAuditNum = orderGoodsAuditNum;
        this.productFutureNum = productFutureNum;
        this.productLastMonthOrderNum = productLastMonthOrderNum;
        this.productStockDayNum = productStockDayNum;
        this.type = type;
        this.productIsNotStock = productIsNotStock;
        this.invalid = invalid;
        this.secondValid = secondValid;
        this.productImage = productImage;
        this.productStockNum = productStockNum;
        this.productLastMonthSaleNum = productLastMonthSaleNum;
        this.productBigType = productBigType;
        this.productBigFatherType = productBigFatherType;
        this.productBoxNum = productBoxNum;
        this.productAlreadyOrderNum = productAlreadyOrderNum;
        this.productId = productId;
        this.orderGoodsAmount = orderGoodsAmount;
        this.orderGoodsNumINControl = orderGoodsNumINControl;
        this.pdBillCode = pdBillCode;
        this.pdId = pdId;
        this.maxSuggestOrderGoodsNum = maxSuggestOrderGoodsNum;
        this.batchOrderAuditBillCode = batchOrderAuditBillCode;
    }

    @Generated(hash = 334209610)
    public OrderGoodsAuditBatchDetail() {
    }

    public String getUserNo() {
        return this.userNo;
    }

    public void setUserNo(String userNo) {
        this.userNo = userNo;
    }

    public String getStoreName() {
        return this.storeName;
    }

    public void setStoreName(String storeName) {
        this.storeName = storeName;
    }

    public String getStoreNo() {
        return this.storeNo;
    }

    public void setStoreNo(String storeNo) {
        this.storeNo = storeNo;
    }

    public String getProductName() {
        return this.productName;
    }

    public void setProductName(String productName) {
        this.productName = productName;
    }

    public String getProductCode() {
        return this.productCode;
    }

    public void setProductCode(String productCode) {
        this.productCode = productCode;
    }

    public String getProductUnit() {
        return this.productUnit;
    }

    public void setProductUnit(String productUnit) {
        this.productUnit = productUnit;
    }

    public int getProductUnitId() {
        return this.productUnitId;
    }

    public void setProductUnitId(int productUnitId) {
        this.productUnitId = productUnitId;
    }

    public String getProductPrice() {
        return this.productPrice;
    }

    public void setProductPrice(String productPrice) {
        this.productPrice = productPrice;
    }

    public double getSuggestOrderGoodsNum() {
        return this.suggestOrderGoodsNum;
    }

    public void setSuggestOrderGoodsNum(double suggestOrderGoodsNum) {
        this.suggestOrderGoodsNum = suggestOrderGoodsNum;
    }

    public double getOrderGoodsNum() {
        return this.orderGoodsNum;
    }

    public void setOrderGoodsNum(double orderGoodsNum) {
        this.orderGoodsNum = orderGoodsNum;
    }

    public double getOrderGoodsAuditNum() {
        return this.orderGoodsAuditNum;
    }

    public void setOrderGoodsAuditNum(double orderGoodsAuditNum) {
        this.orderGoodsAuditNum = orderGoodsAuditNum;
    }

    public double getProductFutureNum() {
        return this.productFutureNum;
    }

    public void setProductFutureNum(double productFutureNum) {
        this.productFutureNum = productFutureNum;
    }

    public double getProductLastMonthOrderNum() {
        return this.productLastMonthOrderNum;
    }

    public void setProductLastMonthOrderNum(double productLastMonthOrderNum) {
        this.productLastMonthOrderNum = productLastMonthOrderNum;
    }

    public int getProductStockDayNum() {
        return this.productStockDayNum;
    }

    public void setProductStockDayNum(int productStockDayNum) {
        this.productStockDayNum = productStockDayNum;
    }

    public int getType() {
        return this.type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public boolean getProductIsNotStock() {
        return this.productIsNotStock;
    }

    public void setProductIsNotStock(boolean productIsNotStock) {
        this.productIsNotStock = productIsNotStock;
    }

    public boolean getInvalid() {
        return this.invalid;
    }

    public void setInvalid(boolean invalid) {
        this.invalid = invalid;
    }

    public boolean getSecondValid() {
        return this.secondValid;
    }

    public void setSecondValid(boolean secondValid) {
        this.secondValid = secondValid;
    }

    public String getProductImage() {
        return this.productImage;
    }

    public void setProductImage(String productImage) {
        this.productImage = productImage;
    }

    public double getProductStockNum() {
        return this.productStockNum;
    }

    public void setProductStockNum(double productStockNum) {
        this.productStockNum = productStockNum;
    }

    public double getProductLastMonthSaleNum() {
        return this.productLastMonthSaleNum;
    }

    public void setProductLastMonthSaleNum(double productLastMonthSaleNum) {
        this.productLastMonthSaleNum = productLastMonthSaleNum;
    }

    public String getProductBigType() {
        return this.productBigType;
    }

    public void setProductBigType(String productBigType) {
        this.productBigType = productBigType;
    }

    public String getProductBigFatherType() {
        return this.productBigFatherType;
    }

    public void setProductBigFatherType(String productBigFatherType) {
        this.productBigFatherType = productBigFatherType;
    }

    public double getProductBoxNum() {
        return this.productBoxNum;
    }

    public void setProductBoxNum(double productBoxNum) {
        this.productBoxNum = productBoxNum;
    }

    public double getProductAlreadyOrderNum() {
        return this.productAlreadyOrderNum;
    }

    public void setProductAlreadyOrderNum(double productAlreadyOrderNum) {
        this.productAlreadyOrderNum = productAlreadyOrderNum;
    }

    public long getProductId() {
        return this.productId;
    }

    public void setProductId(long productId) {
        this.productId = productId;
    }

    public String getOrderGoodsAmount() {
        return this.orderGoodsAmount;
    }

    public void setOrderGoodsAmount(String orderGoodsAmount) {
        this.orderGoodsAmount = orderGoodsAmount;
    }

    public String getOrderGoodsNumINControl() {
        return this.orderGoodsNumINControl;
    }

    public void setOrderGoodsNumINControl(String orderGoodsNumINControl) {
        this.orderGoodsNumINControl = orderGoodsNumINControl;
    }

    public String getPdBillCode() {
        return this.pdBillCode;
    }

    public void setPdBillCode(String pdBillCode) {
        this.pdBillCode = pdBillCode;
    }

    public String getPdId() {
        return this.pdId;
    }

    public void setPdId(String pdId) {
        this.pdId = pdId;
    }

    public double getMaxSuggestOrderGoodsNum() {
        return this.maxSuggestOrderGoodsNum;
    }

    public void setMaxSuggestOrderGoodsNum(double maxSuggestOrderGoodsNum) {
        this.maxSuggestOrderGoodsNum = maxSuggestOrderGoodsNum;
    }

    public String getBatchOrderAuditBillCode() {
        return this.batchOrderAuditBillCode;
    }

    public void setBatchOrderAuditBillCode(String batchOrderAuditBillCode) {
        this.batchOrderAuditBillCode = batchOrderAuditBillCode;
    }



}
