package com.wgmf.yxgj.pop;

import android.content.Context;
import android.graphics.drawable.BitmapDrawable;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.WindowManager;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.wgmf.yxgj.base.R;

/**
 * @author xiep on 2017/3/1 09:37
 */
@SuppressWarnings("all")
public class GoodsReceiptsSuccessPop implements View.OnClickListener {

    private PopupWindow goodsReceiptsSuccessPw;

    private View viewParent;

    private TextView reportFeedbackTv;

    private TextView goodsLibQueryTv;

    private TextView backToHomepageTv;

    private GoodsReceiptsSuccessPopListener goodsReceiptsSuccessPopListener;

    public interface GoodsReceiptsSuccessPopListener {

        void toReportFeedback();

        void toGoodsLibQuery();

        void backToHomepage();
    }

    public GoodsReceiptsSuccessPop(final Context context, GoodsReceiptsSuccessPopListener listener) {
        this(context, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, listener);
    }

    private GoodsReceiptsSuccessPop(final Context context, final int width, final int height, GoodsReceiptsSuccessPopListener listener) {
        this.goodsReceiptsSuccessPopListener = listener;

        LayoutInflater inflater = LayoutInflater.from(context);
        viewParent = inflater.inflate(R.layout.success_popupwindow, null);
        reportFeedbackTv = (TextView) viewParent.findViewById(R.id.report_feedback_tv);
        goodsLibQueryTv = (TextView) viewParent.findViewById(R.id.goods_lib_query_tv);
        backToHomepageTv = (TextView) viewParent.findViewById(R.id.back_to_homepage_tv);
        goodsReceiptsSuccessPw = new PopupWindow(viewParent, width, height, true);
        goodsReceiptsSuccessPw.setBackgroundDrawable(new BitmapDrawable());
        reportFeedbackTv.setOnClickListener(this);
        goodsLibQueryTv.setOnClickListener(this);
        backToHomepageTv.setOnClickListener(this);
    }

    public boolean isShowing() {
        return null != goodsReceiptsSuccessPw && goodsReceiptsSuccessPw.isShowing();
    }

    public void show(View parent) {
        if (null == parent) {
            throw new IllegalArgumentException("StoreDateSelectorPop.showAtLocation parent is null");
        }
        viewParent = parent;
        goodsReceiptsSuccessPw.showAtLocation(parent, Gravity.CENTER, 0, 0);
    }

    public void dismiss() {
        if (null != goodsReceiptsSuccessPw && goodsReceiptsSuccessPw.isShowing()) {
            goodsReceiptsSuccessPw.dismiss();
        }
    }

    @Override
    public void onClick(View view) {
        if (view == reportFeedbackTv) {
            dismiss();
            if (null != goodsReceiptsSuccessPopListener) {
                goodsReceiptsSuccessPopListener.toReportFeedback();
            }
        } else if (view == goodsLibQueryTv) {
            dismiss();
            if (null != goodsReceiptsSuccessPopListener) {
                goodsReceiptsSuccessPopListener.toGoodsLibQuery();
            }
        } else if (view == backToHomepageTv) {
            dismiss();
            if (null != goodsReceiptsSuccessPopListener) {
                goodsReceiptsSuccessPopListener.backToHomepage();
            }
        } else {
            dismiss();
        }
    }
}