package com.wgmf.yxgj.pop;

import android.content.Context;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.R;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;

import java.util.List;

/**
 * 公共选择结果查询PopWindow
 *
 * @author xiep on 2017/3/1 09:37
 */
@SuppressWarnings("all")
public class PublicSelectPop implements View.OnClickListener, AdapterView.OnItemClickListener {

    private PopupWindow reportQuerySelectPw;

    private View viewParent;

    private ReportQuerySelectPopListener reportQuerySelectPopListener;

    private List<BaseSelectorEntity> reportQuerys;

    @Override
    public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {
        dismiss();
        reportQuerySelectPopListener.onAdapterItemClick(i, reportQuerys);
    }

    public interface ReportQuerySelectPopListener {

        void onAdapterItemClick(int position, List<BaseSelectorEntity> reportQuerys);

    }

    public PublicSelectPop(final Context context, ReportQuerySelectPopListener reportQuerySelectPopListener, List<BaseSelectorEntity> reportQuerys) {
        this(context, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, reportQuerySelectPopListener, reportQuerys);
    }

    private PublicSelectPop(final Context context, final int width, final int height, ReportQuerySelectPopListener reportQuerySelectPopListener, List<BaseSelectorEntity> reportQuerys) {
        this.reportQuerySelectPopListener = reportQuerySelectPopListener;
        this.reportQuerys = reportQuerys;

        LayoutInflater inflater = LayoutInflater.from(context);
        viewParent = inflater.inflate(R.layout.public_select_pop_view, null);

        ListView shopHistoryLv = (ListView) viewParent.findViewById(R.id.public_select_pop_lv);
        TextView shopProductHistoryEmptyTv = (TextView) viewParent.findViewById(R.id.public_select_pop_empty_tv);
        shopHistoryLv.setEmptyView(shopProductHistoryEmptyTv);
        LinearLayout shopHistoryDialogCancelLl = (LinearLayout) viewParent.findViewById(R.id.public_select_pop_ll);
        ImageView shopHistoryDialogCancelIv = (ImageView) viewParent.findViewById(R.id.cpublic_select_pop_cancel_iv);

        BaseCommonAdapter typeAdapter = new BaseCommonAdapter<BaseSelectorEntity>(context, reportQuerys) {
            @Override
            public void convert(ViewHolder helper, BaseSelectorEntity item) {
                helper.setText(item.getSelectorName() + "");
            }
        };
        shopHistoryLv.setAdapter(typeAdapter);
        reportQuerySelectPw = new PopupWindow(viewParent, width, height, true);
        shopHistoryDialogCancelLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                reportQuerySelectPw.dismiss();
            }
        });
        shopHistoryDialogCancelIv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                reportQuerySelectPw.dismiss();
            }
        });
        shopHistoryLv.setOnItemClickListener(this);
        ListViewUtil.setListViewHeight(shopHistoryLv);
    }

    public boolean isShowing() {
        return null != reportQuerySelectPw && reportQuerySelectPw.isShowing();
    }

    public void show(View parent) {
        if (null == parent) {
            throw new IllegalArgumentException("StoreDateSelectorPop.showAtLocation parent is null");
        }
        viewParent = parent;
        reportQuerySelectPw.showAtLocation(parent, Gravity.CENTER, 0, 0);
    }

    public void dismiss() {
        if (null != reportQuerySelectPw && reportQuerySelectPw.isShowing()) {
            reportQuerySelectPw.dismiss();
        }
    }

    @Override
    public void onClick(View view) {
        dismiss();
    }
}