package com.wgmf.yxgj.pop;

import android.content.Context;
import android.graphics.drawable.BitmapDrawable;
import android.text.TextUtils;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.WindowManager;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.wgmf.yxgj.base.R;
import com.wgmf.yxgj.widgets.CountDownTextViewHelper;

/**
 * 图片选择
 *
 * @author xiep on 2017/3/1 09:37
 */
@SuppressWarnings("all")
public class PublicThreeSecondsPop implements CountDownTextViewHelper.OnFinishListener {

    private PopupWindow threeSecondsPw;

    private View viewParent;

    private TextView uploadToOeSuccessInfo;

    private ThreeSecondsPopListener threeSecondsPopListener;

    public interface ThreeSecondsPopListener {

        void onTimingFinish();
    }

    public void setTips(String tips) {
        if (null != uploadToOeSuccessInfo && !TextUtils.isEmpty(tips))
            uploadToOeSuccessInfo.setText(tips);
    }

    public PublicThreeSecondsPop(final Context context, ThreeSecondsPopListener listener) {
        this(context, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, listener);
    }

    private PublicThreeSecondsPop(final Context context, final int width, final int height, ThreeSecondsPopListener listener) {
        this.threeSecondsPopListener = listener;
        LayoutInflater inflater = LayoutInflater.from(context);
        viewParent = inflater.inflate(R.layout.three_seconds_popupwindow, null);

        uploadToOeSuccessInfo = (TextView) viewParent.findViewById(R.id.upload_to_oe_success_info);
        TextView threeSecondsTv = (TextView) viewParent.findViewById(R.id.three_seconds_tv);
        threeSecondsPw = new PopupWindow(viewParent, width, height, true);
        threeSecondsPw.setBackgroundDrawable(new BitmapDrawable());

        CountDownTextViewHelper helperPay = new CountDownTextViewHelper(threeSecondsTv);
        helperPay.setOnFinishListener(this);
        helperPay.start();
    }

    public boolean isShowing() {
        return null != threeSecondsPw && threeSecondsPw.isShowing();
    }

    public void show(View parent) {
        if (null == parent) {
            throw new IllegalArgumentException("StoreDateSelectorPop.showAtLocation parent is null");
        }
        viewParent = parent;
        threeSecondsPw.showAtLocation(parent, Gravity.CENTER, 0, 0);
    }

    public void dismiss() {
        if (null != threeSecondsPw && threeSecondsPw.isShowing()) {
            threeSecondsPw.dismiss();
        }
    }

    @Override
    public void countDownFinish() {
        dismiss();
        if (null != threeSecondsPopListener) {
            threeSecondsPopListener.onTimingFinish();
        }
    }
}