package com.wgmf.yxgj.pop;

import android.content.Context;
import android.graphics.drawable.BitmapDrawable;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.WindowManager;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.wgmf.yxgj.base.R;

/**
 * @author xiep on 2018/3/30 17:03
 */
@SuppressWarnings("all")
public class WarningPop implements View.OnClickListener {

    private PopupWindow warningPw;

    private View viewParent;

    private TextView warningTitleTv;

    private TextView warningTipsTv;

    private TextView warningConfirmBtn;

    private TextView warningCancelBtn;

    public void setTitle(String title) {
        warningTitleTv.setText(title);
    }

    public void setTips(String tips) {
        warningTipsTv.setText(tips);
    }

    private WarningPopListener warningPopListener;

    public interface WarningPopListener {

        void warningConfirm();

        void warningCancel();
    }

    public WarningPop(final Context context, WarningPopListener listener) {
        this(context, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, listener);
    }

    private WarningPop(final Context context, final int width, final int height, WarningPopListener listener) {
        this.warningPopListener = listener;

        LayoutInflater inflater = LayoutInflater.from(context);
        viewParent = inflater.inflate(R.layout.warning_popupwindow, null);
        warningConfirmBtn = (TextView) viewParent.findViewById(R.id.warning_confirm_btn);
        warningCancelBtn = (TextView) viewParent.findViewById(R.id.warning_cancel_btn);
        warningTitleTv = (TextView) viewParent.findViewById(R.id.warning_title_tv);
        warningTipsTv = (TextView) viewParent.findViewById(R.id.warning_tips_tv);

        warningPw = new PopupWindow(viewParent, width, height, true);
        warningPw.setBackgroundDrawable(new BitmapDrawable());
        warningConfirmBtn.setOnClickListener(this);
        warningCancelBtn.setOnClickListener(this);
    }

    public boolean isShowing() {
        return null != warningPw && warningPw.isShowing();
    }

    public void show(View parent) {
        if (null == parent) {
            throw new IllegalArgumentException("StoreDateSelectorPop.showAtLocation parent is null");
        }
        viewParent = parent;
        warningPw.showAtLocation(parent, Gravity.CENTER, 0, 0);
    }

    public void dismiss() {
        if (null != warningPw && warningPw.isShowing()) {
            warningPw.dismiss();
        }
    }

    @Override
    public void onClick(View view) {
        if (view == warningConfirmBtn) {
            dismiss();
            if (null != warningPopListener) {
                warningPopListener.warningConfirm();
            }
        } else if (view == warningCancelBtn) {
            dismiss();
            if (null != warningPopListener) {
                warningPopListener.warningCancel();
            }
        } else {
            dismiss();
        }
    }
}