package com.wgmf.yxgj.publics.service;

import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.global.OeRoleParams;

/**
 * 全面绩效管理类
 *
 * @author xiep on 2017/4/19 10:40
 */

public class TotalPerfomanceManager {
    public static String getOrgBylength(String mOrgCode) {
        String mOrganization = "";
        if (!StringUtil.isNullOrEmpty(mOrgCode)) {
            if (mOrgCode.length() == 5) {
                mOrganization = "大区";
            } else if (mOrgCode.length() == 6) {
                mOrganization = "办事处";
            } else if (mOrgCode.length() > 6) {
                mOrganization = "主管";
            }
        }
        return mOrganization;
    }
    /**
     *
     * @param mOeRole 员工OE角色
     * @param mOrganization  组织机构为“大区”时具有该角色具有查看和操作大区事务权限；“办事处”->区域；"主管"->主管
     * @return 组织机构“主管”角色转化3为主管, “办事处”角色转化为7区域经理，"大区"角色8为大区总监
     */
    public static String getTotalPerfomance(String mOeRole, String mOrganization) {
        String url = NetworkParams.URL_ERROR;
        if (OeRoleParams.OE_ROLE_PARAMS_3.equals(mOeRole) || OeRoleParams.OE_ROLE_PARAMS_7.equals(mOeRole) || OeRoleParams.OE_ROLE_PARAMS_8.equals(mOeRole) || OeRoleParams.OE_ROLE_PARAMS_21.equals(mOeRole) || OeRoleParams.OE_ROLE_PARAMS_23.equals(mOeRole) || OeRoleParams.OE_ROLE_PARAMS_24.equals(mOeRole) || OeRoleParams.OE_ROLE_PARAMS_25.equals(mOeRole)) {
            if ("大区".equals(mOrganization)) {
                url = NetworkParams.URL_SEARCH_AREA;
            } else if ("办事处".equals(mOrganization)) {
                url = NetworkParams.URL_SEARCH_OFFICE;
            } else if ("主管".equals(mOrganization)) {
                url = NetworkParams.URL_SEARCH_MANAGER;
            }
        }
        return url;
    }

    /**
     * @param mOeRole          员工OE角色:
     *                         1：营养顾问 2：流动营养顾问 3：促销主管 4：机修 5：办事处文员 6：终端推广经理 7：区域经理  8：大区总监
     *                         9：人事经理 10：推广经理 11：培训经理 12：KA经理 13：终端主任 14：总部人员 15：店长 16：流动队长
     *                         17：金牌导师（驻店）18：金牌导师（流动） 19：工厂人员 20：会员营销主任 21：KA主管 22：推广专员
     *                         23：督导,24：片区经理，25：片区主管 26：兼职人员 27：兼职销售
     * @param organizationCode 组织机构编码长度大于6位为主管，等于6位为区域经理，等于5位为大区总监
     * @return OE角色3为主管, 7区域经理，8为大区总监
     */
    public static String getOeRoleBylength(String mOeRole, String organizationCode) {
        if (!StringUtil.isNullOrEmpty(organizationCode)) {
            if (organizationCode.length() == 5) {
                mOeRole = OeRoleParams.OE_ROLE_PARAMS_8;
            } else if (organizationCode.length() == 6) {
                mOeRole = OeRoleParams.OE_ROLE_PARAMS_7;
            } else if (organizationCode.length() > 6) {
                mOeRole = OeRoleParams.OE_ROLE_PARAMS_3;
            }
        }
        return mOeRole;
    }

    /**
     * @param mOeRole OE角色21为KA主管,23为督导,24为片区经理，25为片区主管
     * @return 转为3主管的功能
     */
    public static String setOeRole(String mOeRole) {
        if (!StringUtil.isNullOrEmpty(mOeRole) && (OeRoleParams.OE_ROLE_PARAMS_21.equals(mOeRole)
                || OeRoleParams.OE_ROLE_PARAMS_23.equals(mOeRole)
                || OeRoleParams.OE_ROLE_PARAMS_24.equals(mOeRole)
                || OeRoleParams.OE_ROLE_PARAMS_25.equals(mOeRole))) {
            mOeRole = OeRoleParams.OE_ROLE_PARAMS_3;
        }
        return mOeRole;
    }
}