package com.wgmf.yxgj.publics.ui;

import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ImageView;
import android.widget.ListView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.base.R;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.model.CommonResourcesBean;
import com.xp.arouter.RouterCommonUtil;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.List;

/**
 * 二级功能列表页面
 *
 * @author xiep
 */
@SuppressWarnings("all")
@Route(path = RouterParams.URL_DATALISTACTIVITY)
public class DataListActivity extends BaseParentAct {
    private List<CommonResourcesBean> fonctionList;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.public_list_view);
        initTitle();
        initData();
        initContent();
    }

    private void initData() {
        Long branchID = getIntent().getLongExtra("branchID", 0);
        if (null == resources) {
            resources = getCommonResourcesData();
        }
        fonctionList = new ArrayList<>();
        for (int i = 0; i < resources.size(); i++) {
            if (resources.get(i).getParentId().equals(branchID)) {
                fonctionList.add(resources.get(i));
            }
        }
    }

    private void initContent() {
        ListView mListView = (ListView) findViewById(R.id.public_list_view_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        BaseCommonAdapter<CommonResourcesBean> mAdapter = new BaseCommonAdapter<CommonResourcesBean>(this, fonctionList) {
            @Override
            public void convert(ViewHolder helper, CommonResourcesBean item) {
                helper.setText(item.getName());
            }
        };
        mListView.setAdapter(mAdapter);
        mListView.setOnItemClickListener(mItemClick);
    }

    @Override
    public void initTitle() {
        super.initTitle();
        String branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        if ("兼职督察".equals(branchTitle)) {
            homeTitleBackLl.setVisibility(View.INVISIBLE);
        }
    }

    private OnItemClickListener mItemClick = new OnItemClickListener() {
        @Override
        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
            Long branchID = fonctionList.get(position).getResourceId();
            Bundle mBundle = new Bundle();
            mBundle.putLong("branchID", branchID);
            mBundle.putString("branchTitle", fonctionList.get(position).getName());
            mBundle.putString("branchUrl", fonctionList.get(position).getResUrl());
            RouterCommonUtil.startFunctionActivity(DataListActivity.this, 0, branchID, mBundle);
        }
    };
}