package com.wgmf.yxgj.publics.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.base.R;

import java.util.List;

/**
 * @author xiep
 */
public class ReportTypeAdapter extends BaseAdapter {
    private Context context;
    private List<String> reportTypeList;

    public ReportTypeAdapter(List<String> reportTypeList, Context context) {
        this.reportTypeList = reportTypeList;
        this.context = context;
    }

    @Override
    public int getCount() {
        return reportTypeList == null ? 0 : reportTypeList.size();
    }

    @Override
    public Object getItem(int position) {
        return reportTypeList == null ? null : reportTypeList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @SuppressWarnings("all")
    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.report_type_listview_item, null);
            viewHolder = new ViewHolder();
            viewHolder.reportType=(TextView)convertView.findViewById(R.id.report_type);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        viewHolder.reportType.setText(reportTypeList.get(position));
        return convertView;
    }

    class ViewHolder {
        TextView reportType;
    }
}