package com.wgmf.yxgj.publics.ui;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;

import com.bumptech.glide.Glide;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.base.R;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;

import java.util.ArrayList;
import java.util.List;

/**
 * 选择列表公共基类
 *
 * @author xiep on 2017/1/16 10:15
 */
@SuppressWarnings("all")
public class SelectorBaseActivity extends BaseParentAct {
    public static final int RESULTCODE = 100;
    public static final String STORE_TAG = "store";
    protected ListView mListView;
    protected BaseCommonAdapter<BaseSelectorEntity> mAdapter;
    protected List<BaseSelectorEntity> mListStore;
    protected List<BaseSelectorEntity> listShow;
    protected ClearEditText storeNameEt;
    protected String branchTitle;
    protected LinearLayout reportContentComfirmLl;
    protected Button reportContentComfirmBtn;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.public_list_view);
        initTitle();
        initContent();
        setListener();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    protected void initContent() {
        mListStore = new ArrayList<>();
        listShow = new ArrayList<>();
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        reportContentComfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentComfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        storeNameEt = (ClearEditText) findViewById(R.id.store_name_et);
        storeNameEt.setVisibility(View.VISIBLE);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        mAdapter = new BaseCommonAdapter<BaseSelectorEntity>(this, listShow) {
            @Override
            public void convert(ViewHolder helper, BaseSelectorEntity item) {
                helper.setText(item.getSelectorName() + "");
                helper.setRightGone(View.GONE);
            }
        };
        mListView.setAdapter(mAdapter);
        mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {
                BaseSelectorEntity se = listShow.get(position);
                Intent intent = new Intent();
                intent.putExtra(STORE_TAG, se);
                setResult(RESULTCODE, intent);
                SelectorBaseActivity.this.finish();
            }
        });
    }

    protected void setListener() {
        storeNameEt.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                textChanged();
            }
        });
    }

    public void textChanged() {
        if (null == listShow) {
            listShow = new ArrayList<>();
        }
        String itemId = storeNameEt.getText().toString().trim();
        if (TextUtils.isEmpty(itemId)) {
            listShow.clear();
            if (null != mListStore) {
                listShow.addAll(mListStore);
            }

        } else {
            listShow.clear();
            if (null != mListStore) {
                for (BaseSelectorEntity p : mListStore) {
                    if (null != p.getSelectorName()) {
                        if (p.getSelectorName().contains(itemId)) {
                            listShow.add(p);
                        }
                    }
                }
            }
        }
        if (null != mAdapter) {
            mAdapter.notifyDataSetChanged();
        }
    }

    protected void search() {
        if (null != listShow && null != mListStore && null != mAdapter) {
            mListStore.clear();
            mListStore.addAll(listShow);
            mAdapter.notifyDataSetChanged();
        }
    }
}