package com.wgmf.yxgj.report.ui;

import android.graphics.Bitmap;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;

import com.wgmf.yxgj.base.BaseActivity;
import com.wgmf.yxgj.base.R;
import com.wgmf.library.utils.Files;
import com.wgmf.yxgj.utils.PhotoUtils;

import java.lang.ref.SoftReference;
import java.util.HashMap;
import java.util.List;

/**
 * @author xiep
 */
public class ReportPicAdapter extends BaseAdapter {
    private List<String> list;
    private BaseActivity context;
    HashMap<String, SoftReference<Bitmap>> imageCache = new HashMap<>();

    ReportPicAdapter(List<String> list, BaseActivity context) {
        this.list = list;
        this.context = context;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size() + 1;
    }

    @Override
    public Object getItem(int position) {
        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public int getItemViewType(int position) {
        if (position < list.size()) {
            return 0;
        } else {
            return 1;
        }
    }

    @Override
    public int getViewTypeCount() {
        return 2;
    }
    @SuppressWarnings("all")
    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        ViewHolder viewHolder;
        int itemViewType = getItemViewType(position);
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.report_picture_listview_item, null);
            viewHolder = new ViewHolder();
            viewHolder.imageView = (ImageView) convertView
                    .findViewById(R.id.report_pic_item);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        if (itemViewType == 0) {
            Bitmap bitmap;
            if (imageCache.get(list.get(position)) == null
                    || imageCache.get(list.get(position)).get() == null) {
                bitmap = PhotoUtils.revitionImageSize(Files.getPhotoPath() + list.get(position));
                if (bitmap != null) {
                    viewHolder.imageView.setImageBitmap(bitmap);
                }
                imageCache.put(list.get(position), new SoftReference<>(bitmap));
            } else {
                bitmap = imageCache.get(list.get(position)).get();
            }
            viewHolder.imageView.setImageBitmap(bitmap);
        } else {
            viewHolder.imageView.setImageResource(R.drawable.add_picture);
        }
        return convertView;
    }

    class ViewHolder {
        ImageView imageView;
    }
}