package com.wgmf.yxgj.report.ui;

import android.annotation.TargetApi;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.support.annotation.NonNull;
import android.support.v4.content.ContextCompat;
import android.support.v7.widget.RecyclerView;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ExpandableListView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.qiniu.android.common.FixedZone;
import com.qiniu.android.http.ResponseInfo;
import com.qiniu.android.storage.Configuration;
import com.qiniu.android.storage.KeyGenerator;
import com.qiniu.android.storage.Recorder;
import com.qiniu.android.storage.UpCancellationSignal;
import com.qiniu.android.storage.UpCompletionHandler;
import com.qiniu.android.storage.UpProgressHandler;
import com.qiniu.android.storage.UploadManager;
import com.qiniu.android.storage.UploadOptions;
import com.qiniu.android.storage.persistent.FileRecorder;
import com.qiniu.android.utils.UrlSafeBase64;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DataCleanManager;
import com.wgmf.library.utils.Files;
import com.wgmf.library.utils.PermissionsCheckerUtil;
import com.wgmf.library.utils.tools.DeviceHelper;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.library.utils.tools.SystemBarTintManager;
import com.wgmf.yxgj.base.R;
import com.wgmf.yxgj.db.CommonUserinfoBeanDao;
import com.wgmf.yxgj.db.GreenDaoManager;
import com.wgmf.yxgj.dialog.PublicDialogLoading;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.model.CommonUserinfoBean;
import com.wgmf.yxgj.other.PermissionsActivity;
import com.wgmf.yxgj.utils.PhotoUtils;
import com.wgmf.yxgj.utils.helper.DialogHelper;
import com.xp.pro.imagepickerlib.ImagePickerBaseActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.utils.PathConfig;
import com.xp.pro.imagepickerlib.widgets.TipDialog;

import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * @author xiep
 */
@SuppressWarnings("all")
public class ReportWithPhotoBaseActivity extends ImagePickerBaseActivity implements ResultData.BusinessCallback, DialogHelper.DialogResult {
    protected static final String TAG = "ReportWithPhoto";
    /**
     * 请求码
     */
    private static final int REQUEST_CODE = 10000;
    /**
     * 上报类型
     */
    protected String reportType = "UNKOWN";
    /**
     * 上报图片状态
     */
    protected String imgStatus = "";

    private String tip;

    protected Context mContext;
    /**
     * 上报图片方式
     */
    protected boolean imgType = false;
    /**
     * 图片URL集合(已上传)
     */
    protected List<String> urlLists = new ArrayList<>();
    /**
     * 图片七牛名称集合（未上传）
     */
    protected List<String> qiniuUrlLists = new ArrayList<>();
    /**
     * 权限检测器
     */
    private PermissionsCheckerUtil mPermissionsChecker;

    private PublicDialogLoading dialog;
    /**
     * 公共列表
     */
    protected ListView publicListViewLv;
    /**
     * 公共可扩展列表
     */
    protected ExpandableListView publicListViewElv;
    /**
     * 公共列表
     */
    protected RecyclerView mPublicListViewRv;
    /**
     * 上报信息布局
     */
    protected LinearLayout titleMoreLl;
    /**
     * 上报门店或顾问信息
     */
    protected TextView reportDetailTitle;
    /**
     * 上报日期
     */
    protected TextView reportDetailDate;

    /**
     * 修改按钮
     */
    protected Button reportContentModifyBtn;
    /**
     * 确认按钮
     */
    protected Button reportContentConfirmBtn;
    /**
     * 确认按钮布局
     */
    protected LinearLayout reportContentConfirmLl;
    /**
     * 确认按钮提示信息
     */
    protected TextView reportContentComfirmTipTxt;

    /**
     * 总结标题
     */
    protected TextView tvSummary;
    /**
     * 上报输入框
     */
    protected EditText reportEdit;
    /**
     * 图片选择布局
     */
    protected LinearLayout publicTakePhotoLl;
    /**
     * 图片选择布局根目录
     */
    protected LinearLayout publicTakePhotoRootLl;

    protected LinearLayout homeTitleLl;
    protected LinearLayout homeTitleBackLl;
    protected LinearLayout homeTitleMoreLl;
    protected TextView homeTitleBack;
    protected TextView homeTitleMore;
    protected TextView homeTitleText;

    protected static CommonUserinfoBean userInfo;
    protected static CommonUserinfoBeanDao mCommonUserinfoBeanDao;

    public void showDialog() {
        if (null == dialog) {
            dialog = new PublicDialogLoading(this);
        }
        if (!dialog.isShowing()) {
            dialog.show();
            setDialogCancel(false, false);
        }
    }

    public void dismissDialog() {
        try {
            if (null != dialog && dialog.isShowing()) {
                dialog.dismiss();
            }
        } catch (Exception e) {
            Log.e("ReportWithPhotoBaseActivity:", "dismissDialog: error");
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        initWindowView();
        super.onCreate(savedInstanceState);
        mContext = this;
        //图片默认大小使用100K
        PrefTool.setIntSave(ReportWithPhotoBaseActivity.this, Prefs.PRE_IMAGE_SIZE, 100);
        PrefTool.setBooleanSave(ReportWithPhotoBaseActivity.this, Prefs.PRE_DIALOG_SHOWING, false);
        mPermissionsChecker = new PermissionsCheckerUtil(this);
        getUserInfoData();
        initData();
        initView();
        initTitle();
        initContent();
    }

    /**
     * 通知栏一体化
     */
    protected void initWindowView() {
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
            setTranslucentStatus();
        }
        SystemBarTintManager tintManager = new SystemBarTintManager(this);
        tintManager.setStatusBarTintEnabled(true);
        // 通知栏所需颜色
        tintManager.setStatusBarTintResource(R.color.normal_color);
    }

    @TargetApi(19)
    protected void setTranslucentStatus() {
        Window win = getWindow();
        WindowManager.LayoutParams winParams = win.getAttributes();
        final int bits = WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS;
        winParams.flags |= bits;
        win.setAttributes(winParams);
    }

    protected void initTitle() {
        getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.public_user_title);
        homeTitleLl = (LinearLayout) findViewById(R.id.main_title_ll);
        homeTitleBackLl = (LinearLayout) findViewById(R.id.main_title_back_ll);
        homeTitleMoreLl = (LinearLayout) findViewById(R.id.home_title_more_ll);
        homeTitleBack = (TextView) findViewById(R.id.home_title_back);
        homeTitleText = (TextView) findViewById(R.id.home_title_text);
        homeTitleMore = (TextView) findViewById(R.id.home_title_more);
        int tempEnv = PrefTool.getIntPreferences(this, Prefs.PRE_ENVIRONMENT_STATUS, 0);
        if (tempEnv != 0) {
            homeTitleText.setTextColor(ContextCompat.getColor(this, R.color.important_txt_color));
            homeTitleText.setBackgroundResource(R.drawable.test_env_icon);
        } else {
            homeTitleText.setTextColor(ContextCompat.getColor(this, R.color.white));
            homeTitleText.setBackgroundResource(R.color.normal_color);
        }
        homeTitleBackLl.setVisibility(View.INVISIBLE);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleMoreLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                more();
            }
        });
        homeTitleBackLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                back();
            }
        });
    }

    protected void back() {
        this.finish();
    }

    protected void more() {

    }

    public CommonUserinfoBean getUserInfoData() {
        try {
            mCommonUserinfoBeanDao = getCommonUserinfoBeanDao();
            userInfo = mCommonUserinfoBeanDao.loadAll().get(0);
        } catch (Exception e) {
            Log.d("getUserInfoData:", e.toString());
        }
        return userInfo;
    }

    CommonUserinfoBeanDao getCommonUserinfoBeanDao() {
        try {
            mCommonUserinfoBeanDao = GreenDaoManager.getInstance().getDaoSession(this).getCommonUserinfoBeanDao();
        } catch (Exception e) {
            Log.d("getCommonUserinfoBeanDao:", e.toString());
        }
        return mCommonUserinfoBeanDao;
    }

    protected void showCursor(boolean isShow) {
        //设置EditText默认不显示光标，不可编辑，点击它，进入编辑状态，光标显示
        if (isShow) {
            reportEdit.setCursorVisible(false);
            reportEdit.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    reportEdit.setCursorVisible(true);
                }
            });
        }
    }

    protected void initData() {
        tip = "\n版本：" + DeviceHelper.getVersion(this) + "\t\t工号：" + userInfo.getStaffId() +
                "\n设备：Android " + Build.VERSION.RELEASE + " / " + Build.MODEL;
    }

    protected void initView() {
        setContentView(R.layout.public_list_view);
        publicListViewLv = (ListView) findViewById(R.id.public_list_view_lv);
        publicListViewElv = (ExpandableListView) findViewById(R.id.public_list_view_elv);
        mPublicListViewRv = (RecyclerView) findViewById(R.id.public_list_view_rv);
        titleMoreLl = (LinearLayout) findViewById(R.id.title_more_ll);
        reportDetailTitle = (TextView) findViewById(R.id.report_detail_title);
        reportDetailDate = (TextView) findViewById(R.id.report_detail_date);
    }

    protected void initContent() {
        setListHeadAndFootView();
        setListAdapter();
        parseHeadData();
        parseFootData();
    }

    public void setDialogCancel(boolean canceledOnTouch, boolean cancelable) {
        if (null != dialog) {
            dialog.setDialogCancel(canceledOnTouch, cancelable);
        }
    }

    /**
     * 设置列表头和尾布局
     */
    protected void setListHeadAndFootView() {
        View footView = getLayoutInflater().inflate(R.layout.public_report_footview, null);
        publicListViewLv.addFooterView(footView);
    }

    /**
     * 设置列表适配器
     */
    protected void setListAdapter() {
    }

    protected void parseHeadData() {

    }

    protected void parseFootData() {
        reportContentConfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        reportContentModifyBtn = (Button) findViewById(R.id.report_content_modify_btn);
        reportContentConfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentComfirmTipTxt = (TextView) findViewById(R.id.report_content_comfirm_tip_txt);
        publicTakePhotoRootLl = (LinearLayout) findViewById(R.id.public_take_photo_root_ll);
        publicTakePhotoLl = (LinearLayout) findViewById(R.id.public_take_photo_ll);
        tvSummary = (TextView) findViewById(R.id.tv_summary);
        reportEdit = (EditText) findViewById(R.id.report_edit);
        publicTakePhotoRootLl.setVisibility(View.GONE);
        tvSummary.setVisibility(View.GONE);
        reportEdit.setVisibility(View.GONE);
        reportContentConfirmLl.setVisibility(View.VISIBLE);
        reportContentConfirmBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                setUploadData();
            }
        });
    }

    @Override
    public void onBusinessResult(final ResultData result) {
        if (!isFinishing()) {
            if (!isMainThread()) {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        try {
                            onBusinessResultAtMainThread(result);
                        } catch (Exception e) {
                            Log.e("BaseParentAct", e + "");
                        }
                    }
                });
            } else {
                onBusinessResultAtMainThread(result);
            }
        }
    }

    /**
     * callBack回来到主线程执行
     */
    protected void onBusinessResultAtMainThread(ResultData result) {
        // 由子类继承处理业务逻辑
    }

    public boolean isMainThread() {
        return Looper.myLooper() == Looper.getMainLooper();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        // 拒绝时, 关闭页面, 缺少主要权限, 无法运行
        if (requestCode == REQUEST_CODE && resultCode == PermissionsActivity.PERMISSIONS_DENIED) {
            finish();
        }
    }

    @Override
    protected void onResume() {
        // 缺少权限时, 进入权限配置页面
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            if (Build.VERSION.SDK_INT > 32) {
                if (mPermissionsChecker.lacksPermissions(PermissionsCheckerUtil.NEWPERMISSIONS)) {
                    PermissionsActivity.startActivityForResult(this, REQUEST_CODE, PermissionsCheckerUtil.NEWPERMISSIONS);
                }
            } else {
                if (mPermissionsChecker.lacksPermissions(PermissionsCheckerUtil.PERMISSIONS)) {
                    PermissionsActivity.startActivityForResult(this, REQUEST_CODE, PermissionsCheckerUtil.PERMISSIONS);
                }
            }
        }
        super.onResume();
    }

    @Override
    public void onDialogResult(int tag) {

    }

    /**
     * 门店id 上传图片时需要
     */
    protected String shopId;

    protected String shopName;

    @Override
    public void onDestroy() {
        super.onDestroy();
        //清除自定义文件夹下的文件
        DataCleanManager.cleanCustomCache(Files.getPhotoPath());
        DataCleanManager.cleanCustomCache(Files.getLogfile());
        DataCleanManager.cleanCustomCache(PathConfig.getImagePath());
    }

    public int count = 0;
    public Handler handler = new Handler();
    public Runnable runnable = new Runnable() {
        @Override
        public void run() {
            this.update();
            // 间隔100ms
            if (count == 0) {
                handler.postDelayed(this, 100);
            }
        }

        void update() {
            if (!urlLists.isEmpty() && urlLists.size() == qiniuUrlLists.size()) {
                if (reportType == "PTPD" || reportType == "PTJC") {
                    if (urlLists.size() == mImageselectList.size()) {
                        //如果所有图片上上传完成，则开始上传数据
                        Log.i(TAG, "urlLists:" + urlLists);
                        imgStatus = "成功。" + tip;
                        uploadData();
                        count = 1;
                        handler.removeCallbacks(runnable);
                    }
                } else {
                    //如果所有图片上上传完成，则开始上传数据
                    Log.i(TAG, "urlLists:" + urlLists);
                    imgStatus = "成功。" + tip;
                    uploadData();
                    count = 1;
                    handler.removeCallbacks(runnable);
                }
            }
        }
    };

    protected void setUploadData() {
        //1 点击底部确定按钮执行第一步：设置上传数据
        count = 0;
        setUploadImage();
    }

    private void setUploadImage() {
        //1.1 设置上传图片数据
        showDialog();
        //存放图片路径的ArrayList
        setUpImages();
    }

    private boolean checkAreadyUplaod() {
        List<Boolean> falg = new ArrayList<>();
        if (mImageselectList != null && !mImageselectList.isEmpty()) {
            for (int i = 0; i < mImageselectList.size(); i++) {
                if (1 == mImageselectList.get(i).getType()) {
                    falg.add(true);
                }
            }
        }
        if (falg.size() == mImageselectList.size()) {
            return true;
        }
        return false;
    }

    protected void setUpImages() {
        mImageselectList = idImagePickerContainer.getmImageselectList();
        if (null == mImageselectList || mImageselectList.isEmpty()) {
            //没有图片，直接提交数据
            imgStatus = "没有资源。" + tip;
            uploadData();
        } else if (checkAreadyUplaod()) {
            //没有图片，直接提交数据
            uploadData();
        } else {
            if (imgType) {
                uploadByFilePathBefore();
            } else {
                for (int i = 0; i < mImageselectList.size(); i++) {
                    ImageItem imageItem = mImageselectList.get(i);
                    if (1 != imageItem.getType()) {
                        uploadCount = 1;
                        uploadByFilePath(imageItem.getImagePath());
                    }
                }
            }
            if (null != handler && null != runnable) {
                handler.postDelayed(runnable, 100);
            }
        }
    }

    protected void uploadData() {
        //1 点击底部确定按钮执行第二步：提交数据
    }

    private int uploadCount = 0;

    /**
     * 图片上传失败处理
     */
    private String uploadFail(final String msg) {
        cancell();
        urlLists.clear();
        qiniuUrlLists.clear();
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (uploadCount == 1) {
                    if (reportType == "PTPD" || reportType == "PTJC") {
                        //如果是兼职督察功能，图片上传失败需直接上传数据
                        imgStatus = "失败，" + msg + tip;
                        uploadData();
                    } else {
                        dismissDialog();
                        showTipDialog("提示", "图片上传失败，请重新上传!\n" + msg + tip);
                    }
                    uploadCount = 0;
                }
                Log.e("uploadByFilePath", msg);
            }
        });
        return msg;
    }

    TipDialog mTipDialog;

    protected void showTipDialog(String title, String content) {

        if (mTipDialog == null) {
            mTipDialog = TipDialog.createDialog(this, title);
        }

        mTipDialog.setTitle(title);
        mTipDialog.setContent(content);
        mTipDialog.setOnDismissListener(new DialogInterface.OnDismissListener() {
            @Override
            public void onDismiss(DialogInterface dialog) {
                mTipDialog = null;
            }
        });
        if (!mTipDialog.isShowing()) {
            mTipDialog.show();
        }
    }

    /**
     * 七牛上传凭证uploadToken
     */
    private String token;

    private String userId;


    /**
     * 上传文件到七牛
     *
     * @param filePath 文件路径
     */
    protected void uploadByFilePathBefore(final String filePath) {
        final String key = getQiniuKey(reportType);
        //将图片地址加入集合，图片上传成功则能找到该图片，图片上传失败则找不到图片，服务端使用默认图片显示
        qiniuUrlLists.add(PhotoUtils.getRealUrl(key));

        final byte[] imageBytes = PhotoUtils.getImageBytes(filePath, 200);

        new Thread(new Runnable() {

            @Override
            public void run() {

                // 如果是第一次获取，获得七牛上传凭证uploadToken
                if (token == null || "".equals(token)) {
                    token = PhotoUtils.getUploadToken();
                }
                Log.d("qiniu_token", token + "");
                if (token != null) {
                    UploadManager uploadManager = new UploadManager();
                    uploadManager.put(imageBytes, key, token, new UpCompletionHandler() {
                        @Override
                        public void complete(String arg0, ResponseInfo info, JSONObject response) {
                            //首先检测上传是否成功
                            if (!info.isOK()) {
                                uploadFail("\n图片上传请求超时，请稍后再试。\n");
                            }
                            if (null != response) {
                                Log.d("qiniu-url", response.toString());
                                String json = response.toString();
                                BaseResponse mTokenBean = PhotoUtils.parseTokenData(json);

                                // 解析出返回的token
                                if (null != mTokenBean && ConstantParams.CONSTANT_PARAMS_0.equals(mTokenBean.retCode)) {
                                    String url = PhotoUtils.getRealUrl(mTokenBean.retInfo);
                                    urlLists.add(url);
                                    Log.d(TAG, "mTokenBean.getRetInfo()=" + mTokenBean.retInfo);
                                } else {
                                    uploadFail("\n七牛返回错误信息:" + info.toString() + "。\n");
                                }
                            } else {
                                uploadFail("\n未获取到七牛返回信息。\n");
                            }
                        }
                    }, null);
                } else {
                    uploadFail("\n当前网络访问超时。\n");
                }
                uploadCount = 1;
            }
        }).start();
    }

    protected void uploadByFilePathBefore() {

        new Thread(new Runnable() {

            @Override
            public void run() {
                for (int i = 0; i < mImageselectList.size(); i++) {
                    ImageItem imageItem = mImageselectList.get(i);
                    if (1 != imageItem.getType()) {
                        final String key = getQiniuKey(reportType);
                        //将图片地址加入集合，图片上传成功则能找到该图片，图片上传失败则找不到图片，服务端使用默认图片显示
                        qiniuUrlLists.add(PhotoUtils.getRealUrl(key));

                        //图片旋转，压缩处理
                        final byte[] imageBytes = PhotoUtils.getImageBytes(imageItem.getImagePath(), 200);

                        // 如果是第一次获取，获得七牛上传凭证uploadToken
                        if (token == null || "".equals(token)) {
                            token = PhotoUtils.getUploadToken();
                        }
                        Log.d("qiniu_token", token + "");
                        if (token != null) {
                            UploadManager uploadManager = new UploadManager();
                            uploadManager.put(imageBytes, key, token, new UpCompletionHandler() {
                                @Override
                                public void complete(String arg0, ResponseInfo info, JSONObject response) {
                                    //首先检测上传是否成功
                                    if (!info.isOK()) {
                                        uploadFail("\n图片上传请求超时，请稍后再试。\n");
                                    }
                                    if (null != response) {
                                        Log.d("qiniu-url", response.toString());
                                        String json = response.toString();
                                        BaseResponse mTokenBean = PhotoUtils.parseTokenData(json);

                                        // 解析出返回的token
                                        if (null != mTokenBean && ConstantParams.CONSTANT_PARAMS_0.equals(mTokenBean.retCode)) {
                                            String url = PhotoUtils.getRealUrl(mTokenBean.retInfo);
                                            urlLists.add(url);
                                            Log.d(TAG, "mTokenBean.getRetInfo()=" + mTokenBean.retInfo);
                                        } else {
                                            uploadFail("\n七牛返回错误信息:" + info.toString() + "。\n");
                                        }
                                    } else {
                                        uploadFail("\n未获取到七牛返回信息。\n");
                                    }
                                }
                            }, null);
                        } else {
                            uploadFail("\n当前网络访问超时。\n");
                        }
                        uploadCount = 1;
                    }
                }
            }
        }).start();
    }

    @NonNull
    protected String getQiniuKey(String reportType) {
        if (userInfo != null) {
            userId = userInfo.getStaffId();
        }
        return PhotoUtils.getFileUrlUUID(shopId, userId, reportType);
    }

    /**
     * 上传文件到七牛
     *
     * @param filePath 文件路径
     */
    protected void uploadByFilePath(final String filePath) {
        showDialog();
        //异步上传图片
        new uploadImageAsyncTask().execute(filePath);
    }

    /**
     * 七牛图片上传完成后回调
     *
     * @param info     七牛返回信息
     * @param response 返回结果
     */
    private void getQiNiuResponse(ResponseInfo info, JSONObject response) {
        //首先检测上传是否成功
        if (!info.isOK()) {
            uploadFail("\n图片上传请求超时，请稍后再试。\n");
        }
        if (null != response) {
            Log.d("qiniu-url", response.toString());

            String json = response.toString();
            BaseResponse mTokenBean = PhotoUtils.parseTokenData(json);

            // 解析出返回的token
            if (null != mTokenBean && ConstantParams.CONSTANT_PARAMS_0.equals(mTokenBean.retCode)) {
                String url = PhotoUtils.getRealUrl(mTokenBean.retInfo);
                urlLists.add(url);
                Log.d(TAG, "mTokenBean.getRetInfo()=" + mTokenBean.retInfo);
            } else {
                uploadFail("\n七牛返回错误信息:" + info.toString() + "。\n");
            }
        } else {
            uploadFail("\n图片上传请求超时，请稍后再试。\n");
        }
    }

    /**
     * @return 图片名称
     */
    protected String getImageUrl() {
        if (userInfo != null) {
            userId = userInfo.getStaffId();
        }
        return PhotoUtils.getFileUrlUUID(shopId, userId, reportType);
    }

    class uploadImageAsyncTask extends AsyncTask<String, Void, byte[]> {

        //onPreExecute用于异步处理前的操作
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            showDialog();
        }

        //在doInBackground方法中进行异步任务的处理.
        @Override
        protected byte[] doInBackground(String... params) {
            String filePath = params[0];
            // 如果是第一次获取，获得七牛上传凭证uploadToken
            if (TextUtils.isEmpty(token)) {
                token = PhotoUtils.getUploadToken();
            }
            //兼职盘点不缩放图片
            int size = PrefTool.getIntPreferences(ReportWithPhotoBaseActivity.this, Prefs.PRE_IMAGE_SIZE, 200);

            return PhotoUtils.getImageBytes(filePath, size);
        }

        //onPostExecute用于UI的更新.此方法的参数为doInBackground方法返回的值.
        @Override
        protected void onPostExecute(byte[] bytes) {
            super.onPostExecute(bytes);
            if (bytes == null) {
                uploadFail("\n图片有问题，请重新选择！\n");
                return;
            }
            String key = getQiniuKey(reportType);
            //将图片地址加入集合，图片上传成功则能找到该图片，图片上传失败则找不到图片，服务端使用默认图片显示
            qiniuUrlLists.add(PhotoUtils.getRealUrl(key));
            if (token != null) {
                HashMap<String, String> map = new HashMap<String, String>();
                map.put("x:phone", "12345678");
                isCancelled = false;
                uploadManager.put(bytes, key, token, new UpCompletionHandler() {
                    @Override
                    public void complete(String arg0, ResponseInfo info, JSONObject response) {
                        getQiNiuResponse(info, response);
                    }
                }, new UploadOptions(map, null, false,
                        new UpProgressHandler() {
                            public void progress(String key, double percent) {
                                Log.i("qiniu", key + ": " + percent);
//                                progressbar.setVisibility(View.VISIBLE);
                                int progress = (int) (percent * 1000);
//											Log.d("qiniu", progress+"");
//                                progressbar.setProgress(progress);
                                if (progress == 1000) {
//                                    progressbar.setVisibility(View.GONE);
                                }
                            }
                        }, new UpCancellationSignal() {
                    @Override
                    public boolean isCancelled() {
                        return isCancelled;
                    }
                }));
            } else {
                uploadFail("\nToken获取失败,网络或服务器异常！\n");
            }
        }
    }


    // 初始化、执行上传
    private volatile boolean isCancelled = false;

    // 点击取消按钮，让UpCancellationSignal##isCancelled()方法返回true，以停止上传
    private void cancell() {
        isCancelled = true;
    }

    UploadManager uploadManager;

    public ReportWithPhotoBaseActivity() {
        //断点上传
        String dirPath = Files.getDownfile();
        Recorder recorder = null;
        try {
            File f = File.createTempFile("qiniu_xxxx", ".tmp");
            Log.d("qiniu", f.getAbsolutePath().toString());
            dirPath = f.getParent();
            recorder = new FileRecorder(dirPath);
        } catch (Exception e) {
            e.printStackTrace();
        }

        final String dirPath1 = dirPath;
        //默认使用 key 的url_safe_base64编码字符串作为断点记录文件的文件名。
        //避免记录文件冲突（特别是key指定为null时），也可自定义文件名(下方为默认实现)：
        KeyGenerator keyGen = new KeyGenerator() {
            public String gen(String key, File file) {
                // 不必使用url_safe_base64转换，uploadManager内部会处理
                // 该返回值可替换为基于key、文件内容、上下文的其它信息生成的文件名
                String path = key + "_._" + new StringBuffer(file.getAbsolutePath()).reverse();
                Log.d("qiniu", path);
                File f = new File(dirPath1, UrlSafeBase64.encodeToString(path));
                BufferedReader reader = null;
                try {
                    reader = new BufferedReader(new FileReader(f));
                    String tempString = null;
                    int line = 1;
                    try {
                        while ((tempString = reader.readLine()) != null) {
                            Log.d("qiniu", "line " + line + ": " + tempString);
                            line++;
                        }
                    } catch (IOException e) {
                        e.printStackTrace();
                    } finally {
                        try {
                            reader.close();
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                } catch (FileNotFoundException e) {
                    e.printStackTrace();
                }
                return path;
            }
        };
        Configuration config = new Configuration.Builder()
                .chunkSize(512 * 1024)        // 分片上传时，每片的大小。 默认256K
                .putThreshhold(1024 * 1024)   // 启用分片上传阀值。默认512K
                .connectTimeout(10)           // 链接超时。默认10秒
                .useHttps(true)               // 是否使用https上传域名
                .responseTimeout(120)          // 服务器响应超时。默认60秒
                .recorder(recorder)           // recorder分片上传时，已上传片记录器。默认null
                .recorder(recorder, keyGen)   // keyGen 分片上传时，生成标识符，用于片记录器区分是那个文件的上传记录
                .zone(FixedZone.zone0)        // 设置区域，指定不同区域的上传域名、备用域名、备用IP。
                .build();
        // 重用uploadManager。一般地，只需要创建一个uploadManager对象
        uploadManager = new UploadManager(config);
    }
}