package com.wgmf.yxgj.utils;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.text.TextUtils;

import com.qiniu.android.http.ResponseInfo;
import com.qiniu.android.storage.UpCompletionHandler;
import com.qiniu.android.storage.UploadManager;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.app.LibGroupContext;
import com.wgmf.yxgj.global.Prefs;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Sasuke on 2017/2/10.
 * 一整套的七牛操作全家桶（相当于曾经的QiNiuTokenTask）
 */

public class QiNiuDominator {

    public static void uploadImages(List<String> photoList, final CompleteQiniu callback) {
        uploadImages(photoList, callback, null, false);
    }

    /**
     * 重载,添加上传图片失败回调接口
     */
    public static void uploadImages(List<String> photoList, final CompleteQiniu callback, final FailureQiniu callbackFailured, final boolean isCancleDialog) {
        int size = photoList.size();
        final String[] array = photoList.toArray(new String[size]);
        final List<String> ourUrls = new ArrayList<>();//把这些上传成功的七牛地址传一份到咱公司。
        new uploadTask(array.length, ourUrls, callback, callbackFailured, isCancleDialog).execute(array);
    }

    /**
     * 上传任务
     */
    private static class uploadTask extends AsyncTask<String, Integer, String> {
        List<String> ourUrls = new ArrayList<>();
        CompleteQiniu callback;
        FailureQiniu callbackFailured;
        boolean isCancleDialog;
        int successCount;

        public uploadTask(int successCount, List<String> ourUrls, final CompleteQiniu callback, final FailureQiniu callbackFailured, boolean isCancleDialog) {
            this.ourUrls.clear();
            this.ourUrls.addAll(ourUrls);
            this.callback = callback;
            this.callbackFailured = callbackFailured;
            this.isCancleDialog = isCancleDialog;
            this.successCount = successCount;
        }

        @Override
        protected void onPreExecute() {
            ourUrls.clear();
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            boolean isToast = PrefTool.getBooleanPreferences(LibGroupContext.getApplication(), Prefs.KAOQIN_IS_TOAST_FLAG, true);
            if ("-1".equals(s)) {
                ViewUtils.dismissProgress();
                if (isToast) {
                    MyToast.show("请先检查网络是否已连接!");
                }
                if (callbackFailured != null) {
                    callbackFailured.onUpLoadFail("请先检查网络是否已连接!");
                }
            } else if ("-2".equals(s)) {
                ViewUtils.dismissProgress();
                if (isToast) {
                    MyToast.show("获取图片Token失败!");
                }
                if (callbackFailured != null) {
                    callbackFailured.onUpLoadFail("获取图片Token失败!");
                }
            } else if ("-3".equals(s) && callbackFailured != null) {
                ViewUtils.dismissProgress();
                callbackFailured.onUpLoadFail("图片有问题，请重新选择");
            }
        }

        String tempToken;

        @Override
        protected String doInBackground(final String... photoArray) {
            if (TextUtils.isEmpty(tempToken)) {
                tempToken = PhotoUtils.getUploadToken();
            }
//            if (response == null) {
//                return "-1";
//            } else
            if (StringUtil.isNullOrEmpty(tempToken)) {
                return "-2";
            }
            for (String tempImgUrl : photoArray) {
                //以下进行图片压缩
                Bitmap mBitmap = BitmapFactory.decodeFile(tempImgUrl);
                if (mBitmap == null) {
                    return "-3";
                }
                byte[] bytes = PhotoUtils.compressBmp2Bytes(mBitmap, 100);//压缩到80KB以下（不用保存到本地，直接把bmp压成字节流传给七牛）

                //                String key = PhotoUtils.getFileUrlUUID(shopId, userId, reportType);
                String key = "11102_Personalid_2018-09-26_16:37:27_4943";
                UploadManager uploadManager = new UploadManager();
                //开始上传图片啦！！！！！！！！！！！！！
                uploadManager.put(bytes, key,
                        tempToken, new UpCompletionHandler() {
                            @Override
                            public void complete(String s, ResponseInfo responseInfo, JSONObject response) {
                                if (responseInfo.statusCode == 200 && response != null) {
                                    successCount--;
                                    cacheQiniuUrl(s, responseInfo, response, ourUrls);
                                    if (successCount == 0 && callback != null) {
                                        callback.uploadInfo(ourUrls);//上传完图片之后继续上传其它东西的操作。
                                    }
                                } else {
                                    if (callbackFailured != null) {
                                        callbackFailured.onUpLoadFail(responseInfo.error);
                                    }
                                }
                            }
                        }, null);
            }
            return "";
        }
    }

    /**
     * 七牛上传图片完成后的回调（这里要把返回的URL传给app.wgmf.com了）
     */
    public static void cacheQiniuUrl(String s, ResponseInfo responseInfo, JSONObject response, List<String> ourUrls) {
        if (response != null) {
            String json = response.toString();
            BaseResponse mTokenBean = PhotoUtils.parseTokenData(json);
            // 解析出返回的token
            if (null != mTokenBean && "0".equals(mTokenBean.retCode)) {
                String url = PhotoUtils.getRealUrl(mTokenBean.retInfo);
                ourUrls.add(url);//图片上传成功就把图片url再传一份到app.wgmf.com......
            }
        }
    }

    /**
     * 上传完图片之后调这个上传信息
     */
    public interface CompleteQiniu {
        void uploadInfo(List<String> qiniuUrl);
    }

    /**
     * 七牛上传图片失败
     */
    public interface FailureQiniu {
        void onUpLoadFail(String failInfo);
    }
}