package com.wgmf.yxgj.widgets;

import android.content.Context;
import android.support.annotation.Nullable;
import android.support.v4.content.ContextCompat;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.base.R;
import com.wgmf.yxgj.global.Prefs;

public class CustomTitleLayout extends LinearLayout {
    private Context context;
    protected LinearLayout homeTitleLl;
    protected LinearLayout homeTitleBackLl;
    protected LinearLayout homeTitleMoreLl;
    protected TextView homeTitleBack;
    protected TextView homeTitleMore;
    protected TextView homeTitleText;

    public CustomTitleLayout(Context context) {
        super(context);
        this.context = context;
        this.init(context);
    }

    public CustomTitleLayout(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
        this.context = context;
        this.init(context);
    }

    public CustomTitleLayout(Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        this.context = context;
        this.init(context);
    }

    private void init(Context context) {
        View layout = LayoutInflater.from(context).inflate(R.layout.public_user_title, this, true);
        this.homeTitleLl = (LinearLayout) layout.findViewById(R.id.main_title_ll);
        this.homeTitleBackLl = (LinearLayout) layout.findViewById(R.id.main_title_back_ll);
        this.homeTitleMoreLl = (LinearLayout) layout.findViewById(R.id.home_title_more_ll);
        this.homeTitleBack = (TextView) layout.findViewById(R.id.home_title_back);
        this.homeTitleText = (TextView) layout.findViewById(R.id.home_title_text);
        this.homeTitleMore = (TextView) layout.findViewById(R.id.home_title_more);
        int tempEnv = PrefTool.getIntPreferences(context, Prefs.PRE_ENVIRONMENT_STATUS, 0);
        if (tempEnv != 0) {
            homeTitleText.setTextColor(ContextCompat.getColor(context, R.color.important_txt_color));
            homeTitleText.setBackgroundResource(R.drawable.test_env_icon);
        } else {
            homeTitleText.setTextColor(ContextCompat.getColor(context, R.color.white));
            homeTitleText.setBackgroundResource(R.color.normal_color);
        }
        homeTitleBackLl.setVisibility(View.INVISIBLE);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleMoreLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                more();
            }
        });
        homeTitleBackLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                back();
            }
        });
    }

    protected void back() {

    }

    protected void more() {

    }
}
