package com.wgmf.yxgj.widgets.LinearLayout;

/**
 * 日历状态
 *
 * @author xiep
 *         0:未设置，未选中，今天之后（背景白色，背景无图标，文字黑色）；（默认）
 *         1:未设置，未选中，今天之前（背景白色，背景无图标，文字灰色）；
 *         2:未设置，未选中，今天（背景白色，背景无图标，文字橙色）；
 *         3:已设置，未选中，今天之后（背景红色，背景无图标，文字白色）；
 *         4:已设置，未选中，今天之前（背景红色，背景无图标，文字灰色）；
 *         5:已设置，未选中，今天（背景红色，背景无图标，文字橙色）；
 *         6:未设置，选中，今天之后（背景白色，背景加图标，文字黑色）；
 *         7:未设置，选中，今天之前（背景白色，背景加图标，文字灰色）；
 *         8:未设置，选中，今天（背景白色，背景加图标，文字橙色）；
 *         9:已设置，选中，今天之后（背景红色，背景加图标，文字白色）；
 *         10:已设置，选中，今天之前（背景红色，背景加图标，文字灰色）；
 *         11:已设置，选中，今天（背景红色，背景加图标，文字白色）；
 *         <p>
 */
@SuppressWarnings("all")
public class CalendarBaseModelResponse {
    /**
     * 修改标志：文字背景状态,
     * 0:无（今天之后的日期，文字黑色）；可修改
     * 1:今天（文字橙色）；可修改
     * 2:只能查询（今天之前的日期，字体灰色）；不可修改
     */
    private int stateModified;
    /**
     * 选中标志：文字背景状态,
     * false:无（背景无图标）；未选中
     * true:选中（背景加图标）；选中
     */
    private boolean stateChecked;
    /**
     * 设置标志：文字外布局背景状态,
     * false:无（背景白色）；未设置
     * true:已设置（背景红色）；已设置
     */
    private boolean stateSaved;

    /**
     * 当前显示日期："yyyy-MM-dd"
     */
    private String dayShowing = "";


    public int getStateModified() {
        return stateModified;
    }

    public void setStateModified(int stateModified) {
        this.stateModified = stateModified;
    }

    public boolean isStateChecked() {
        return stateChecked;
    }

    public void setStateChecked(boolean stateChecked) {
        this.stateChecked = stateChecked;
    }

    public boolean isStateSaved() {
        return stateSaved;
    }

    public void setStateSaved(boolean stateSaved) {
        this.stateSaved = stateSaved;
    }

    public String getDayShowing() {
        return dayShowing;
    }

    public void setDayShowing(String dayShowing) {
        this.dayShowing = dayShowing;
    }

    @Override
    public String toString() {
        return "CalendarBaseModelResponse{" +
                "stateModified=" + stateModified +
                ", stateChecked=" + stateChecked +
                ", stateSaved=" + stateSaved +
                ", dayShowing='" + dayShowing + '\'' +
                '}';
    }
}