package com.wgmf.yxgj.widgets;

import android.graphics.Color;
import android.text.SpannableStringBuilder;
import android.text.style.ForegroundColorSpan;
import android.util.Log;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import com.github.yoojia.inputs.AndroidMessageDisplay;
import com.github.yoojia.inputs.Input;
import com.github.yoojia.inputs.TextInput;

/**
 * 作者：xiep on 2017/10/26 10:12
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")
public class MMessageDisplay extends AndroidMessageDisplay {

    private final static String TAG = MMessageDisplay.class.getSimpleName();

    @Override
    public void show(Input input, String message) {
        // try attach
        final View inputView;
        if (input instanceof TextInput) {
            inputView = ((TextInput) input).inputView;
        } else {
            Log.e(TAG, "- When use <AndroidMessageDisplay>, <TextInput> is recommend !");
            inputView = null;
        }
        // try show message
        if (inputView == null) {
            Log.w(TAG, "- TestResult.message=" + message);
            return;
        }
        if (TextView.class.isAssignableFrom(inputView.getClass())) {
            final TextView text = (TextView) inputView;
            ForegroundColorSpan fgcspan = new ForegroundColorSpan(Color.RED);
            SpannableStringBuilder ssbuilder = new SpannableStringBuilder(message);
            ssbuilder.setSpan(fgcspan, 0, message.length(), 0);
            //显示
            text.setError(ssbuilder);
        } else {
            Toast.makeText(inputView.getContext(), message, Toast.LENGTH_SHORT).show();
        }
    }
}