package com.wgmf.yxgj.widgets.decoration

import android.graphics.Rect
import android.support.v7.widget.RecyclerView
import android.support.v7.widget.RecyclerView.ItemDecoration
import android.view.View

class SpacesFrameDecoration(
    private val topSpace: Int,
    private val bottomSpace: Int
) : ItemDecoration() {
    override fun getItemOffsets(
        outRect: Rect,
        view: View,
        parent: RecyclerView,
        state: RecyclerView.State
    ) {
        val itemCount = parent.adapter?.itemCount ?: 0
        if (parent.getChildLayoutPosition(view) == itemCount - 1) {
            outRect.bottom = bottomSpace
        } else if (parent.getChildLayoutPosition(view) == 0) {
            outRect.top = topSpace
        } else {
            outRect.bottom = 0
        }
    }
}