package com.wgmf.yxgj.basewebview.ui;

import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.basewebview.R;
import com.wgmf.yxgj.global.Prefs;
import com.xp.arouter.RouterParams;

/**
 * @author XP
 */
@Route(path = RouterParams.URL_HTML5DETAILACTIVITY)
public class HtmlActivity extends BaseParentAct implements HtmlFragment.OnChangeTitleListener {

    private Boolean mIsShowClose = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_webview_content);
        mIsShowClose = getIntent().getBooleanExtra("isShowClose", false);

        initTitle();
        initContent();
    }

    private void initContent() {
        if (findViewById(R.id.activity_webview_content_frg) != null) {
            String partTimeStaffName = PrefTool.getStringPerferences(this, Prefs.PRE_USER_PART_TIME_NAME);
            HtmlFragment htmlFragment = new HtmlFragment();
            Bundle htmlBundle = new Bundle();
            htmlBundle.putString("mainUrl", getIntent().getStringExtra("mainUrl"));
            htmlBundle.putString("customHtml", getIntent().getStringExtra("customHtml"));
            htmlBundle.putString("orientation", getIntent().getStringExtra("orientation"));
            htmlBundle.putString("branchUrl", getIntent().getStringExtra("branchUrl"));
            htmlBundle.putString("branchTitle", getIntent().getStringExtra("branchTitle"));
            htmlBundle.putString("partTimeStaffName", partTimeStaffName);
            htmlFragment.setArguments(htmlBundle);
            getSupportFragmentManager().beginTransaction().add(R.id.activity_webview_content_frg, htmlFragment).commit();
        }
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleBackLl.setVisibility(View.VISIBLE);
        //homeTitleCloseLl.setVisibility(mIsShowClose ? View.VISIBLE : View.GONE);
    }

    @Override
    public void changeTitle(String title) {
        homeTitleText.setText(title);
    }

    @Override
    protected void back() {
        HtmlFragment fragment = (HtmlFragment) getSupportFragmentManager()
                .findFragmentById(R.id.activity_webview_content_frg);
        if (fragment != null) {
            fragment.back();
        }
    }

    @Override
    protected void close() {
        finish();
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (event.getAction() == KeyEvent.ACTION_DOWN) {
            if (keyCode == KeyEvent.KEYCODE_BACK) {
                if (mIsShowClose) {
                    back();
                } else {
                    close();
                }
                return true;
            }
        }
        return super.onKeyDown(keyCode, event);
    }
}