package com.wgmf.yxgj.businessmodule.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.TextView;

import com.wgmf.yxgj.businessmodule.R;
import com.wgmf.yxgj.model.CommonResourcesBean;
import com.wgmf.yxgj.model.CommonResourcesListBean;

import java.util.List;

/**
 * @author xiep
 */

class BusinessAdapter extends BaseAdapter implements GridAdapter.OnGirdClickListener {

    private Context context;
    private List<CommonResourcesListBean> commonResourcesBeans;

    private OnBusinessClickListener listener;

    public interface OnBusinessClickListener {
        void onBusinessClick(List<CommonResourcesBean> fonctionList, int postion);
    }

    public void setListener(OnBusinessClickListener listener) {
        this.listener = listener;
    }

    BusinessAdapter(List<CommonResourcesListBean> mPerents, Context context) {
        this.commonResourcesBeans = mPerents;
        this.context = context;
    }

    @Override
    public int getCount() {
        return !commonResourcesBeans.isEmpty() ? commonResourcesBeans.size() : 0;
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    private class PerrentViewHolder {
        TextView name;
        GridView gv;
    }

    @SuppressWarnings("all")
    @Override
    public View getView(int position, View view, ViewGroup parent) {
        final PerrentViewHolder viewHolder;
        View convertView = LayoutInflater.from(context).inflate(R.layout.list_item_business, null);
        viewHolder = new PerrentViewHolder();
        viewHolder.name = (TextView) convertView.findViewById(R.id.list_item_business_title_tv);
        viewHolder.gv = (GridView) convertView.findViewById(R.id.list_item_business_gv);
        viewHolder.name.setText(commonResourcesBeans.get(position).getName());
        List<CommonResourcesBean> childs = commonResourcesBeans.get(position).getResourcesList();

        GridAdapter mAdapter = new GridAdapter(childs, context);
        mAdapter.setData(childs);
        mAdapter.setListener(this);
        viewHolder.gv.setAdapter(mAdapter);
        mAdapter.notifyDataSetChanged();
        return convertView;
    }

    @Override
    public void onGirdClick(List<CommonResourcesBean> childs, int position) {
        listener.onBusinessClick(childs, position);
    }
}