package com.wgmf.yxgj.businessmodule.ui;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.wgmf.yxgj.businessmodule.R;
import com.wgmf.yxgj.model.CommonResourcesBean;

import java.util.List;

public class GridAdapter extends SuperBaseAdpter<CommonResourcesBean> {
    private List<CommonResourcesBean> gridDataInfos;
    private OnGirdClickListener listener;

    public interface OnGirdClickListener {
        void onGirdClick(List<CommonResourcesBean> fonctionList, int postion);
    }

     GridAdapter(List<CommonResourcesBean> gridDataInfos, Context context) {
        super(context);
        this.gridDataInfos = gridDataInfos;
    }

    public void setListener(OnGirdClickListener listener) {
        this.listener = listener;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        View view = inflater.inflate(R.layout.list_item_business_child, null);
        LinearLayout ll = (LinearLayout) view.findViewById(R.id.list_item_business_ll);
        TextView tv = (TextView) view.findViewById(R.id.list_item_business_title_tv);
        ImageView iv = (ImageView) view.findViewById(R.id.list_item_business_title_iv);

        final CommonResourcesBean item = getItem(position);
        tv.setText(item.getName());
        ll.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                listener.onGirdClick(gridDataInfos, position);
            }
        });
        Glide.with(arg2.getContext()).load(item.getDescription()).placeholder(R.drawable.btn_ic_default).error(R.drawable.btn_ic_default).into(iv);

        return view;
    }
}