package com.wgmf.yxgj.businessmodule.ui.base;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.wgmf.yxgj.base.BaseParentFra;
import com.wgmf.yxgj.businessmodule.R;
import com.wgmf.yxgj.businessmodule.graph.components.DaggerIBaseFragmentComponent;
import com.wgmf.yxgj.businessmodule.graph.modules.IBaseFragmentModule;

import org.jetbrains.annotations.NotNull;

import javax.inject.Inject;

@SuppressWarnings("all")
public class IBaseFragment extends BaseParentFra implements IBaseView {
    @Inject
    protected IBasePresenter businessPresenter;

    protected ListView publicListViewLv;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        initInjector();
    }

    private void initInjector() {
        DaggerIBaseFragmentComponent.builder()
                .iBaseFragmentModule(new IBaseFragmentModule(this))
                .build()
                .inject(this);
    }

    @Override
    public View onCreateView(@NotNull LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.public_list_content_view, container, false);
        publicListViewLv = (ListView) view.findViewById(R.id.public_list_view_lv);
        LinearLayout publicListViewEmptyLl = (LinearLayout) view.findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) view.findViewById(R.id.public_list_view_empty_iv);
        TextView publicListViewEmptyTv = view.findViewById(R.id.public_list_view_empty_tv);
        publicListViewEmptyTv.setText(R.string.no_permissions);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        publicListViewLv.setEmptyView(publicListViewEmptyLl);
        View footView = inflater.inflate(R.layout.list_item_business, null);
        publicListViewLv.addFooterView(footView);
        publicListViewLv.setAdapter(businessPresenter.getAdapter());
        publicListViewLv.setOnItemClickListener(mItemClick);
        return view;
    }

    private OnItemClickListener mItemClick = new OnItemClickListener() {
        @Override
        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
            businessPresenter.onItemClickListener(position);
        }
    };

    @Override
    public void refresh() {
    }

    @Override
    public void showTip(String msg) {
        showMsg(msg);
    }
}