package com.wgmf.yxgj.loginmodule.ui;

import com.wgmf.yxgj.loginmodule.model.UserOrgInfoData;
import com.wgmf.yxgj.model.CommonDataBean;

/**
 * @author XP on 2016/7/19 16:29
 */
interface LoginView {
    /**
     * 显示提示信息
     *
     * @param msg 提示信息
     */
    void showTip(String msg);

    /**
     * @param isRemember   是否记住密码
     * @param userPassword 用户密码
     */
    void rememberLoginPassword(boolean isRemember, String userName, String userPassword);

    /**
     * @param version 版本名称
     * @param color   字体颜色
     */
    void setVersion(String version, int color);

    /**
     * 允许登录
     */
    void loginAllow(UserOrgInfoData userOrgInfoData);

    /**
     * 登录成功
     */
    void loginSuccess(String staffId, String orgId);

    /**
     * 获取登录用户信息成功
     */
    void loginSuccessInfo(CommonDataBean commonData);

    /**
     * 登录背景
     */
    void loginBgImg(String url);

    /**
     * 从登录跳转到首页
     */
    void loginHome();

    /**
     * 从登录跳转到兼职督察
     */
    void loginPartTime();

    /**
     * 从登录跳转到组织选择
     */
    void loginOrgSelect(String staffId);

    /**
     * 登录加载对话框
     */
    void showLoginDialog();

    /**
     * 登录加载对话框
     */
    void dismissLoginDialog();
}