package com.wgmf.yxgj.modulemain.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * @author chenji
 * @date 2017/4/21
 * 首页广告弹窗
 */

public class NationalAdBean extends ArrayList<NationalAdBean.AdItem> implements Serializable {
    /**
     * adDesc : null
     * url : http://test.wgmf.com/crmserver-front/html/firstHeartHoney/entryDeclaration.html
     * linkType : url
     * androidLink : null
     * iosLink : null
     * androidImgUrl : http://7xqiu3.com1.z0.glb.clouddn.com/1525415749008
     * iosImgUrl : http://7xqiu3.com1.z0.glb.clouddn.com/1525415749008
     * storeJudge : 0
     */

    //排除掉0否的项，保留需要强制弹出的项。
    public static void removeByShowSwitch(ArrayList<NationalAdBean.AdItem> list){
//        ArrayList<NationalAdRes.AdItem> newList = new ArrayList();
        Iterator<AdItem> it = list.iterator();
        while (it.hasNext()){
            AdItem item = it.next();
            if (item.getShowSwitch() == 0){
                it.remove();
            }
        }
    }

    public static class AdItem{
        private String adDesc;

        private String adId;
        /**
         * 外部跳转URL
         */
        private String url;
        /**
         * 跳转类型(no:不跳转;native:内部跳转;url:外部跳转) ,
         */
        private String linkType;

        private String nameType;//用户类型（1:全部用户，2:未订货，3:未盘点，4:全国卫生日，5:考试提醒） ,

        /**安卓跳转连接*/
        private String androidLink;
        private String iosLink;

        /**安卓图片链接*/
        private String androidImgUrl;
        private String iosImgUrl;
        private int storeJudge;
        private int showSwitch;//每次显示（0：否，1：是） ,

        public String getAdId() {
            return adId;
        }

        public String getNameType() {
            return nameType;
        }

        public int getShowSwitch() {
            return showSwitch;
        }

        public String getAdDesc() {
            return adDesc;
        }

        public void setAdDesc(String adDesc) {
            this.adDesc = adDesc;
        }

        public String getUrl() {
            if (linkType.equals("url")){
                return url;
            }else if (linkType.equals("native")){
                return androidLink;
            }else if (linkType.equals("no")){
                return "";
            }
            return "";
        }

        public void setUrl(String url) {
            this.url = url;
        }

        public String getLinkType() {
            return linkType;
        }

        public void setLinkType(String linkType) {
            this.linkType = linkType;
        }

        public String getAndroidLink() {
            return androidLink;
        }

        public void setAndroidLink(String androidLink) {
            this.androidLink = androidLink;
        }

        public String getIosLink() {
            return iosLink;
        }

        public void setIosLink(String iosLink) {
            this.iosLink = iosLink;
        }

        public String getAndroidImgUrl() {
            return androidImgUrl;
        }

        public void setAndroidImgUrl(String androidImgUrl) {
            this.androidImgUrl = androidImgUrl;
        }

        public String getIosImgUrl() {
            return iosImgUrl;
        }

        public void setIosImgUrl(String iosImgUrl) {
            this.iosImgUrl = iosImgUrl;
        }

        public int getStoreJudge() {
            return storeJudge;
        }

        public void setStoreJudge(int storeJudge) {
            this.storeJudge = storeJudge;
        }

        @Override
        public String toString() {
            return "NationalAdRes{" +
                    "adDesc=" + adDesc +
                    ", url='" + url + '\'' +
                    ", linkType='" + linkType + '\'' +
                    ", androidLink=" + androidLink +
                    ", iosLink=" + iosLink +
                    ", androidImgUrl='" + androidImgUrl + '\'' +
                    ", iosImgUrl='" + iosImgUrl + '\'' +
                    ", storeJudge=" + storeJudge +
                    '}';
        }
    }
}