package com.wgmf.yxgj.modulemain.ui;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.wgmf.library.app.WGMFLibApplication;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.modulemain.R;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.List;

/**
 * @author XP
 * 开发者模式
 * 目前有的：
 * 1: 环境切换
 */
@SuppressWarnings("all")
@Route(path = RouterParams.URL_DEVELOPERACTIVITY)
public class DeveloperActivity extends BaseParentAct {
    private BaseCommonAdapter<BaseSelectorEntity> mAdapter;
    private List<BaseSelectorEntity> mListDataEntity;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.public_list_view);
        initTitle();
        initContent();
        initData();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        String branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText(branchTitle);
    }

    private void initContent() {
        ListView mListView = (ListView) findViewById(R.id.public_list_view_lv);
        TextView dataEmpty = (TextView) findViewById(R.id.public_list_view_empty_tv);
        mListView.setEmptyView(dataEmpty);
        mListDataEntity = new ArrayList<>();
        mAdapter = getAdapter();
        mListView.setAdapter(mAdapter);
        mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {
                if (position == 0) {
                    //切换环境
                    showListDialog();
                }
            }
        });
    }

    private BaseCommonAdapter<BaseSelectorEntity> getAdapter() {
        return mAdapter = new BaseCommonAdapter<BaseSelectorEntity>(
                this, mListDataEntity) {
            @Override
            public void convert(ViewHolder helper, BaseSelectorEntity item) {
                helper.setText(item.getSelectorName());
            }
        };
    }

    private void initData() {
        BaseSelectorEntity mDataEntity0 = new BaseSelectorEntity();
        mDataEntity0.setSelectorId("0");
        mDataEntity0.setSelectorName("环境切换");
        mListDataEntity.add(mDataEntity0);
        mAdapter.notifyDataSetChanged();
    }

    /**
     * 环境切换弹出对话框
     */
    private void showListDialog() {
        new AlertDialog.Builder(this).setTitle("环境切换").setIcon(
                null).setSingleChoiceItems(
                new String[]{"正式环境", "测试环境"}, 0,
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, final int which) {
                        dialog.dismiss();
                        reLogin();
                        showMsg("正在切换环境......");
                        //设置环境标志
                        PrefTool.setIntSave(DeveloperActivity.this, Prefs.PRE_ENVIRONMENT_STATUS, which);
                        new Thread(new Runnable() {
                            @Override
                            public void run() {
                                runOnUiThread(new Runnable() {
                                    @Override
                                    public void run() {
                                        showMsg("环境切换成功，请重新登录！");
                                        WGMFLibApplication.getInstance().exit();
                                    }
                                });
                            }
                        }).start();
                    }
                }).show();
    }
}