package com.wgmf.yxgj.modulemain.ui;

import android.app.Dialog;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.view.ViewPager;
import android.support.v4.widget.DrawerLayout;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.TextView;
import android.widget.Toast;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.umeng.analytics.MobclickAgent;
import com.wgmf.library.app.WGMFLibApplication;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DataCleanManager;
import com.wgmf.library.utils.Files;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.base.BaseActivity;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.basewebview.ui.HtmlFragment;
import com.wgmf.yxgj.businessmodule.ui.BusinessFragment;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.AdDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.loginmodule.ui.LoginActivity;
import com.wgmf.yxgj.loginmodule.ui.OrgSelectorActivity;
import com.wgmf.yxgj.modulemain.dialog.HomeDataAnalyzeDialog;
import com.wgmf.yxgj.modulemain.model.NationalAdBean;
import com.wgmf.yxgj.modulemain.model.NationalAdResEntity;
import com.wgmf.yxgj.modulelowperformance.model.LowPerformanceResultListEntity;
import com.wgmf.yxgj.modulelowperformance.model.SaleWaringBeanList;
import com.wgmf.yxgj.modulelowperformance.service.PerformanceService;
import com.wgmf.yxgj.modulelowperformance.ui.LowPerformanceActivity;
import com.wgmf.yxgj.modulemain.R;
import com.wgmf.yxgj.modulemain.model.PopWindowShowEntity;
import com.wgmf.yxgj.modulemain.service.HomeService;
import com.wgmf.yxgj.modulemessage.MessageActivity;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.utils.ActivityTaskManager;
import com.wgmf.yxgj.widgets.ViewPager.NoScrollViewPager;
import com.xp.arouter.RouterParams;
import com.xp.pro.imagepickerlib.utils.PathConfig;

import org.jetbrains.annotations.NotNull;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.Timer;
import java.util.TimerTask;


/**
 * @author XP created at 2016/1/12 17:46
 * 主界面
 */
@Route(path = RouterParams.URL_HOMEACTIVITY)
public class HomeActivity extends BaseParentAct implements OnClickListener, HtmlFragment.OnChangeTitleListener {

    TextView alarmTipsTv;
    LinearLayout alarmTipsLl;
    List<SaleWaringBeanList> mLowPerformanceResultEntity;

    private DrawerLayout mDrawerLayout;
    /**
     * 装载Fragment的集合
     */
    private List<Fragment> mListFragments;
    /**
     * 装载RadioButton的集合
     */
    private List<RadioButton> listRadioButton;
    private NoScrollViewPager mViewPager;
    private ListView lvSlide;
    private List<BaseSelectorEntity> mDatas;
    private String[] items = new String[]{"消息", "版本更新", "二维码分享", "数据清理", "注销", "切换组织"};
    private static final String OPTIONS = "options";

    private HomeDataAnalyzeDialog mHomeDataAnalyzeDialog = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_home);
        initTitle();
        initMenu();
        initFragment();
        initViewPager();
        initSlideData();
        initSlideView();

        //每天首次登录发起网络请求广告弹窗数据
        requestAdPage();
        requestPopWindowShow();
        initAd();
    }

    @Override
    protected void onResume() {
        super.onResume();
        //获取低绩效预警数据
        getLowPerformance();
    }

    /**
     * 首页广告弹窗(后台配置)
     * 一天只能弹出一次，按照日期来判断
     *
     * @param title   。。。
     * @param content 。。。
     */
    @SuppressWarnings("all")
    private NationalAdBean dialogInfoCaches;

    private void checkIsNationalDay(NationalAdBean resultInfo) {
        String currentFormat = new SimpleDateFormat("yyyy-MM-dd", Locale.CHINA).format(new Date());
        //获取上次的日期
        String lastOpen = PrefTool.getStringPerferences(this, Prefs.NEW_AD_LAST_OPEN_TIME + userInfo.getStaffId());
        //如果与上次弹出日期相同，说明是同一天，那就循环把 dialogInfoCaches 里的带”强制每次弹出“标记的项筛选出来，接下来只需要他们弹了。
        if (null != lastOpen && lastOpen.equals(currentFormat)) {
            NationalAdBean.removeByShowSwitch(resultInfo);
        }
        //开始正式弹窗
        dialogInfoCaches = resultInfo;
        if (dialogInfoCaches != null && dialogInfoCaches.size() > 0) {
            PrefTool.setStringsave(this, Prefs.NEW_AD_LAST_OPEN_TIME + userInfo.getStaffId(), currentFormat);
            showAdDialog(dialogInfoCaches.get(0));//读取第一个
        }
    }

    /**
     * 弹出广告弹窗
     *
     * @param adInfo NationalAdBean.AdItem
     */
    private void showAdDialog(NationalAdBean.AdItem adInfo) {
        AdDialog adDialog = new AdDialog(this, adInfo.getAndroidImgUrl());
        //点击空白区域能不能退出
        adDialog.setCanceledOnTouchOutside(false);
        //按返回键能不能退出
        adDialog.setCancelable(false);
        adDialog.setClickLink(adInfo.getUrl());
        adDialog.setLinkType(adInfo.getLinkType());
        adDialog.setDismissCallback(new AdDialog.DismissCallback() {
            @Override
            public void run() {
                dialogInfoCaches.remove(0);//为实现连续弹窗，则需要把刚才刚过的那个给删掉。
                if (dialogInfoCaches.size() > 0) {
                    showAdDialog(dialogInfoCaches.get(0));//读取第一个
                }
            }
        });
        adDialog.show();
    }

    /**
     * 判断是否显示PopWindow
     */
    private void checkIsShowPopWindow(PopWindowShowEntity.PopWindowShowBean popWindowShowBean) {
        if (popWindowShowBean.getPopFlag()) {
            if (null != userInfo && null != userInfo.getStaffId()) {
                showPopWindow(popWindowShowBean, userInfo.getLevel());
            }
        }
    }

    /**
     * 数据分析消息弹窗
     *
     * @param popWindowShowBean PopWindowShowEntity.PopWindowShowBean
     */
    private void showPopWindow(PopWindowShowEntity.PopWindowShowBean popWindowShowBean, String level) {
        if (mHomeDataAnalyzeDialog == null) {
            final HomeDataAnalyzeDialog.Companion.Builder builder = new HomeDataAnalyzeDialog.Companion.Builder(this);
            builder.setPopWindowShowBean(popWindowShowBean);
            builder.setLevel(level);
            builder.setClickButton(new HomeDataAnalyzeDialog.OnClickDialogListener() {
                @Override
                public void onClick(@NotNull Dialog dialog, int index) {
                    jumpSalesDataTab(index);
                    dialog.dismiss();
                }
            });
            mHomeDataAnalyzeDialog = builder.create();
        }
        mHomeDataAnalyzeDialog.show();
    }

    /**
     * 首页广告查询
     */
    private void requestAdPage() {
        if (null != userInfo && null != userInfo.getStaffId()) {
            HomeService.getInstance().requestAdPage(userInfo.getStaffId(), userInfo.getOrganizationId(), this);
        }
    }

    /**
     * 首页弹窗查询
     */
    private void requestPopWindowShow() {
        if (null != userInfo && null != userInfo.getStaffId()) {
            HomeService.getInstance().requestPopWindowShow(userInfo.getStaffId(), userInfo.getOrganizationId(),
                    userInfo.getUserPostLevel(), this);
        }
    }

    /**
     * 主管判断是否需要低绩效预警
     */
    private void initAd() {
        alarmTipsLl = findViewById(R.id.alarm_tips_ll);
        alarmTipsTv = findViewById(R.id.alarm_tips_tv);
        TextView clickTipTv = findViewById(R.id.click_tip_tv);
        clickTipTv.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent();
                intent.setClass(HomeActivity.this, LowPerformanceActivity.class);
                startActivity(intent);
            }
        });
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText(getString(R.string.radio_button1));
        homeTitleBackLl.setVisibility(View.INVISIBLE);
        homeTitleMoreLl.setVisibility(View.VISIBLE);
        homeTitleLl.setVisibility(View.VISIBLE);
        homeTitleMore.setBackgroundResource(R.drawable.btn_settings_selector);
    }

    private void initSlideData() {
        mDatas = new ArrayList<>();
        for (String item : items) {
            BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
            mBaseSelectorEntity.setSelectorName(item);
            mDatas.add(mBaseSelectorEntity);
        }
    }

    private void initSlideView() {
        mDrawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
        lvSlide = (ListView) findViewById(R.id.lv_slide);
        BaseCommonAdapter<BaseSelectorEntity> mAdapter = new BaseCommonAdapter<BaseSelectorEntity>(this, mDatas) {
            @Override
            public void convert(ViewHolder helper, BaseSelectorEntity item) {
                helper.setText(item.getSelectorName());
            }
        };
        lvSlide.setAdapter(mAdapter);
        // 关闭手势滑动
        mDrawerLayout.setDrawerLockMode(DrawerLayout.LOCK_MODE_LOCKED_CLOSED);
    }

    @Override
    protected void more() {
        super.more();
        // 按钮按下，将抽屉打开
        if (mDrawerLayout.isDrawerOpen(Gravity.END)) {
            mDrawerLayout.closeDrawers();
        } else {
            mDrawerLayout.openDrawer(Gravity.END);
        }

        lvSlide.setOnItemClickListener(new OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {
                // "消息","版本更新", "二维码分享", "注销", "数据清理"
                mDrawerLayout.closeDrawers();

                switch (position) {
                    case 0:
                        Intent intentMsg = new Intent(HomeActivity.this, MessageActivity.class);
                        intentMsg.putExtra(OPTIONS, "check_msg");
                        startActivity(intentMsg);
                        break;
                    case 1:
                        Intent intent = new Intent(HomeActivity.this, SettingActivity.class);
                        intent.putExtra(OPTIONS, "check_update");
                        startActivity(intent);
                        break;
                    case 2:
                        Intent intent2 = new Intent(HomeActivity.this, SettingActivity.class);
                        intent2.putExtra(OPTIONS, "qr_share");
                        startActivity(intent2);
                        break;
                    case 3:
                        clearUserData();
                        // 清除自定义路径下的文件
                        clearUserPathData();
                        showMsg("数据清理成功，请重新登录！");
                        Intent outIntent = new Intent(HomeActivity.this, LoginActivity.class);
                        outIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK);
                        startActivity(outIntent);
                        HomeActivity.this.finish();
                        break;
                    case 4:
                        // 登录状态为假
                        PrefTool.setBooleanSave(HomeActivity.this, Prefs.PRE_LOGIN_STATUS, false);
                        // 消息状态为假
                        PrefTool.setBooleanSave(HomeActivity.this, Prefs.PRE_MESSAGE_STATUS, false);
                        Intent logoutIntent = new Intent(HomeActivity.this, LoginActivity.class);
                        logoutIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK);
                        startActivity(logoutIntent);
                        HomeActivity.this.finish();
                        break;
                    case 5://切换组织
                        // 登录状态为假
                        PrefTool.setBooleanSave(HomeActivity.this, Prefs.PRE_LOGIN_STATUS, false);
                        // 消息状态为假
                        PrefTool.setBooleanSave(HomeActivity.this, Prefs.PRE_MESSAGE_STATUS, false);
                        Intent orgIntent = new Intent(HomeActivity.this, OrgSelectorActivity.class);
                        orgIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK);
                        startActivity(orgIntent);
                        HomeActivity.this.finish();
                        break;
                    default:
                        break;
                }
            }
        });
    }

    private void clearUserPathData() {
        DataCleanManager.cleanCustomCache(Files.getPhotoPath());
        DataCleanManager.cleanCustomCache(Files.getLogfile());
        DataCleanManager.cleanCustomCache(PathConfig.getImagePath());
        DataCleanManager.cleanApplicationData(HomeActivity.this);
    }

    private void initMenu() {
        RadioButton commonRadioButton = (RadioButton) findViewById(R.id.tab_common_rb);
        RadioButton businessRadioButton = (RadioButton) findViewById(R.id.tab_bussiness_rb);
        // 点击事件
        commonRadioButton.setOnClickListener(this);
        businessRadioButton.setOnClickListener(this);
        // 装载控件到集合
        listRadioButton = new ArrayList<>();
        listRadioButton.add(commonRadioButton);
        listRadioButton.add(businessRadioButton);
        // 初始化首页按钮选择状态
        commonRadioButton.setChecked(true);
    }

    /**
     * 初始化initViewPager
     */
    @SuppressWarnings("all")
    private void initViewPager() {
        mViewPager = (NoScrollViewPager) findViewById(R.id.home_activity_viewpager);
        FragmentManager fm = getSupportFragmentManager();
        PagerAdapter mAdapter = new PagerAdapter(fm);
        mViewPager.setAdapter(mAdapter);
        mViewPager.setCurrentItem(0);
        mViewPager.setOffscreenPageLimit(2);
        mViewPager.setOnPageChangeListener(new ViewPager.OnPageChangeListener() {

            @Override
            public void onPageSelected(int arg0) {

            }

            @Override
            public void onPageScrolled(int arg0, float arg1, int arg2) {

            }

            @Override
            public void onPageScrollStateChanged(int arg0) {

            }
        });
    }

    private void initFragment() {
        mListFragments = new ArrayList<>();

        HtmlFragment commonFragment = new HtmlFragment();
        Bundle commonBundle = new Bundle();
        commonBundle.putString("branchUrl", "/mkt-front/html/smartStore/index.html");
        commonBundle.putString("orientation", "PORTRAIT");
        commonFragment.setArguments(commonBundle);
        mListFragments.add(commonFragment);

        BusinessFragment businessFragment = new BusinessFragment();
        mListFragments.add(businessFragment);
    }

    @Override
    public void changeTitle(String title) {
        homeTitleText.setText(title);
        homeTitleBackLl.setVisibility(View.INVISIBLE);
    }

    /**
     * 自定义ViewPager的适配器
     *
     * @author XP
     */
    private class PagerAdapter extends FragmentPagerAdapter {

        PagerAdapter(FragmentManager fm) {
            super(fm);
        }

        @Override
        public Fragment getItem(int arg0) {
            return mListFragments.get(arg0);
        }

        @Override
        public int getCount() {
            return mListFragments.size();
        }
    }

    // 处理底部菜单点击事件
    @Override
    public void onClick(View view) {
        int position;
        if (view.getId() == R.id.tab_common_rb) {
            position = 0;
            setSelectedItem(position);
            homeTitleText.setText(R.string.radio_button1);
            getLowPerformance();
        } else if (view.getId() == R.id.tab_bussiness_rb) {
            position = 1;
            setSelectedItem(position);
            homeTitleText.setText(R.string.radio_button3);
            alarmTipsLl.setVisibility(View.GONE);
        }
    }

    /**
     * 数据分析页面顶部Tab切换
     */
    private void jumpSalesDataTab(int index) {
        //关闭任务栈中所有Activty,除了HomeActivity
        ActivityTaskManager.getInstance().finishExcept(HomeActivity.class);

        setSelectedItem(0);
        homeTitleText.setText(R.string.radio_button1);

        if (mListFragments.size() > 0) {
            HtmlFragment fragment = (HtmlFragment) mListFragments.get(0);
            fragment.setPageTabParams(index);
        }
    }

    /**
     * 设置下标选择状态
     */
    private void setSelectedItem(int position) {
        for (int i = 0; i < listRadioButton.size(); i++) {
            if (i == position) {
                listRadioButton.get(position).setChecked(true);
            } else {
                listRadioButton.get(i).setChecked(false);
            }
        }
        mViewPager.setCurrentItem(position);
    }

    /**
     * 选中智慧门店功能，判断是主管身份，查询是否需要低绩效预警
     */
    private void getLowPerformance() {
        if (BaseActivity.userInfo != null && BaseActivity.userInfo.getOrganizationCode() != null && BaseActivity.userInfo.getOrganizationCode().length() == 8) {
            showDialog();
            String orgId = BaseActivity.userInfo.getOrganizationId();
            PerformanceService.getInstance().requestGetSaleLessOPFThousandShopNum(orgId, this);
        }
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            exitBy2Click();
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    /**
     * 双击退出函数
     */
    private Boolean isExit = false;

    private void exitBy2Click() {
        Timer tExit;
        if (!isExit) {
            // 准备退出
            isExit = true;
            Toast.makeText(this, "再按一次退出程序", Toast.LENGTH_SHORT).show();
            tExit = new Timer();
            tExit.schedule(new TimerTask() {
                @Override
                public void run() {
                    // 取消退出
                    isExit = false;
                    // 如果2秒钟内没有按下返回键，则启动定时器取消掉刚才执行的任务
                }
            }, 2000);
        } else {
            clearUserData();
            MobclickAgent.onKillProcess(this);
            ActivityTaskManager.getInstance().finishAllActivity();
            WGMFLibApplication.getInstance().exit();
        }
    }


    @Override
    protected void clearUserData() {
        super.clearUserData();
    }


    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.OpfthousAndShopnum.MSG_ON_GET_SALE_LESS_OPFTHOUS_AND_SHOPNUM) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    LowPerformanceResultListEntity mLowPerformanceResultListEntity = new Gson().fromJson(msg, LowPerformanceResultListEntity.class);
                    Log.d(BaseActivity.TAG, "mLowPerformanceResultListEntity=" + mLowPerformanceResultListEntity.toString());
                    if (ConstantParams.CONSTANT_PARAMS_0.equals(mLowPerformanceResultListEntity.retCode)) {
                        if (mLowPerformanceResultListEntity.getResult() != null
                                && ConstantParams.CONSTANT_PARAMS_2.equals(mLowPerformanceResultListEntity.getResult().getSaleWaringFlag())
                                && !mLowPerformanceResultListEntity.getResult().getSaleWaringBeanList().isEmpty()) {
                            //需要预警
                            mLowPerformanceResultEntity = mLowPerformanceResultListEntity.getResult().getSaleWaringBeanList();
                            if (null != mLowPerformanceResultEntity && !mLowPerformanceResultEntity.isEmpty()) {
                                alarmTipsLl.setVisibility(View.VISIBLE);
                                String text = "有" + mLowPerformanceResultEntity.size() + "家门店连续3个月小于1.5万";
                                alarmTipsTv.setText(text);
                            } else {
                                alarmTipsLl.setVisibility(View.GONE);
                            }
                        }
                    } else {
                        showMsg(mLowPerformanceResultListEntity.retInfo);
                    }
                } else {
                    showMsg(result.getResultInfo());
                }
            } else if (id == BusinessID.HomePage.MSG_ON_GET_AD_PAGE) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    NationalAdResEntity nationalAdResEntity = new Gson().fromJson(msg, NationalAdResEntity.class);
                    Log.d(TAG, "NationalAdResEntity=" + nationalAdResEntity.toString());
                    if (ConstantParams.CONSTANT_PARAMS_0.equals(nationalAdResEntity.msgCode)) {
                        if (!nationalAdResEntity.getResultInfo().isEmpty()) {
                            checkIsNationalDay(nationalAdResEntity.getResultInfo());
                        }
                    }
                }
            } else if (id == BusinessID.HomePage.MSG_ON_POP_WINDOW_SHOW) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    PopWindowShowEntity popWindowShowEntity = new Gson().fromJson(msg, PopWindowShowEntity.class);
                    Log.d(TAG, "PopWindowShowEntity=" + popWindowShowEntity.toString());
                    if (ConstantParams.CONSTANT_PARAMS_0.equals(popWindowShowEntity.msgCode)) {
                        if (popWindowShowEntity.getResultInfo() != null) {
                            checkIsShowPopWindow(popWindowShowEntity.getResultInfo());
                        }
                    }
                }
            }
        }
    }
}