package com.wgmf.yxgj.modulelowperformance.service;

import android.text.TextUtils;
import android.util.Log;

import com.google.gson.Gson;
import com.wgmf.library.base.BaseRequest;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.BaseSingleton;
import com.wgmf.yxgj.base.BaseService;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.NetworkParams;

import java.lang.ref.WeakReference;

/**
 * @author xiep on 2016/5/31 16:29
 */
public class PerformanceService extends BaseService {
    private static BaseSingleton<PerformanceService, Void> mMainService = new BaseSingleton<PerformanceService, Void>() {
        @Override
        protected PerformanceService create(Void var1) {
            return new PerformanceService();
        }
    };

    public static PerformanceService getInstance() {
        return mMainService.get(null);
    }

    private PerformanceService() {
    }

    /**
     * 低绩效（连续三月销量低于1.5万）查询
     * GET /newcusactitycontroller/getSaleLessOPFThousandShopNum 主管下门店连续三个月销售小于1.5w记录
     */
    public void requestGetSaleLessOPFThousandShopNum(final String orgId, ResultData.BusinessCallback callback) {
        BaseRequest request = new BaseRequest();
        request.taskID = BusinessID.OpfthousAndShopnum.MSG_ON_GET_SALE_LESS_OPFTHOUS_AND_SHOPNUM;
        request.callback = new WeakReference<>(callback);
        request.url = NetworkParams.URL_GET_SALELESS_OPFTHOUSAND_SHOP_NUM + "?" + "orgId=" + orgId;
        Log.d(TAG, "请求地址：" + request.url);
        sendGetRequest(request);
    }

    /**
     * 销售预警改善措施填写
     * POST /newcusactitycontroller/saveSaleWariningMeasures
     */
    public void requestSaveSaleWariningMeasures(final String json, ResultData.BusinessCallback callback) {
        BaseRequest request = new BaseRequest();
        request.taskID = BusinessID.OpfthousAndShopnum.MSG_ON_GET_SAVE_SALE_WARINING_MEASURES;
        request.callback = new WeakReference<>(callback);
        request.url = NetworkParams.URL_SAVE_SALE_WARINING_MEASURES;
        request.json = json;
        Log.d(TAG, "请求地址：" + request.url);
        sendPostJsonRequest(request);
    }

    @Override
    protected void onTaskDone(ResultData data) {
        if (null != data) {
            final int id = data.taskID;
            switch (id) {
                case BusinessID.OpfthousAndShopnum.MSG_ON_GET_SALE_LESS_OPFTHOUS_AND_SHOPNUM:
                case BusinessID.OpfthousAndShopnum.MSG_ON_GET_SAVE_SALE_WARINING_MEASURES: {
                    if (data.isSuccessed()) {
                        final String json = data.getInfo();
                        if (!TextUtils.isEmpty(json)) {
                            BaseResponse mBaseResponse = new Gson().fromJson(json, BaseResponse.class);
                            Log.d(TAG, "id:" + id + ";mBaseResponse=" + mBaseResponse.toString());
                            data.setResultCode(mBaseResponse.retCode);
                            data.setResultInfo(mBaseResponse.retInfo);
                        }
                    }
                    break;
                }
                default:
                    break;
            }
        }
    }
}