package com.wgmf.yxgj.modulelowperformance.ui;

import android.os.Bundle;
import android.util.Log;
import android.view.View;

import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.base.BaseActivity;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.modulelowperformance.R;
import com.wgmf.yxgj.modulelowperformance.model.LowPerformanceResultListEntity;
import com.wgmf.yxgj.modulelowperformance.model.SaleWaringBeanList;
import com.wgmf.yxgj.modulelowperformance.model.SaleWariningMeasures;
import com.wgmf.yxgj.modulelowperformance.service.PerformanceService;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.xp.arouter.RouterCommonUtil;

import java.util.ArrayList;
import java.util.List;

/**
 * 费销比预警填写页面
 *
 * @author xiep on 2017/12/15 17:25
 */
public class LowPerformanceActivity extends SelectorBaseActivity {
    List<SaleWaringBeanList> mLowPerformanceResultEntity;
    LowPerformanceAdapter mLowPerformanceAdapter;

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText("低绩效门店");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void initContent() {
        super.initContent();
        storeNameEt.setVisibility(View.GONE);
        reportContentComfirmLl.setVisibility(View.VISIBLE);
        reportContentComfirmBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                upLoadData();
            }
        });
        getShopData();
    }

    private void getShopData() {
        if (null != BaseActivity.userInfo) {
            showDialog();
            String orgId = BaseActivity.userInfo.getOrganizationId();
            PerformanceService.getInstance().requestGetSaleLessOPFThousandShopNum(orgId, this);
        }
    }

    private void upLoadData() {
        List<SaleWaringBeanList> mSaleWaringBeanList = mLowPerformanceAdapter.getData();
        List<SaleWariningMeasures> mSaleWariningMeasures = new ArrayList<>();
        if (null != mSaleWaringBeanList && !mSaleWaringBeanList.isEmpty()) {
            for (int i = 0; i < mSaleWaringBeanList.size(); i++) {
                if (null != mSaleWaringBeanList.get(i).getWorkerCostRatioList() && mSaleWaringBeanList.get(i).getWorkerCostRatioList().size() > 2) {
                    if (null == mSaleWaringBeanList.get(i).getSaleWarMeaImproveMea() || "".equals(mSaleWaringBeanList.get(i).getSaleWarMeaImproveMea())) {
                        showMsg("请将改善措施填写完整！");
                        return;
                    }
                    SaleWariningMeasures mSaleWariningMeasure = new SaleWariningMeasures();
                    if (null != mSaleWaringBeanList.get(i).getWorkerCostRatioList() && mSaleWaringBeanList.get(i).getWorkerCostRatioList().size() > 2) {
                        //去掉合计占比的%
                        String rate = mSaleWaringBeanList.get(i).getWorkerCostRatioList().get(2).getWorkCostFctRoi();
                        mSaleWariningMeasure.setSaleWarMeaMonthWasSale(mSaleWaringBeanList.get(i).getWorkerCostRatioList().get(2).getFctSale());
                        if (!StringUtil.isNullOrEmpty(rate)) {
                            rate = rate.substring(0, rate.length() - 1);
                            mSaleWariningMeasure.setSaleWarMeaMonthWasCostRate(StringUtil.toDouble(rate) * 100 + "");
                        }
                    }
                    mSaleWariningMeasure.setSaleWarMeaAddUserId(BaseActivity.userInfo.getStaffId());
                    mSaleWariningMeasure.setSaleWarMeaImproveMea(mSaleWaringBeanList.get(i).getSaleWarMeaImproveMea());
                    mSaleWariningMeasure.setSaleWarMeaShopId(mSaleWaringBeanList.get(i).getShop().getShopId());
                    mSaleWariningMeasure.setSaleWarMeaShopName(mSaleWaringBeanList.get(i).getShop().getShopName());
                    mSaleWariningMeasures.add(mSaleWariningMeasure);
                }
            }
        }
        showDialog();
        String content = new Gson().toJson(mSaleWariningMeasures);
        Log.d(BaseActivity.TAG, content);
        PerformanceService.getInstance().requestSaveSaleWariningMeasures(content, this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.OpfthousAndShopnum.MSG_ON_GET_SALE_LESS_OPFTHOUS_AND_SHOPNUM:
                    getSaveLessData(result);
                    break;
                case BusinessID.OpfthousAndShopnum.MSG_ON_GET_SAVE_SALE_WARINING_MEASURES:
                    getSaveData(result);
                    break;
                default:
                    break;
            }
        }
    }

    private void getSaveData(ResultData result) {
        final String msg = result.getInfo();
        if (result.isSuccessed()) {
            try {
                BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                Log.d(BaseActivity.TAG, "mBaseResponse=" + mBaseResponse.toString());
                if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                    Bundle mBundle = new Bundle();
                    mBundle.putLong("branchID", 0L);
                    mBundle.putString("branchTitle", "营销管家");
                    RouterCommonUtil.startFunctionActivity(this, -3, 0L, mBundle);
                    this.finish();
                }
                showMsg(mBaseResponse.retInfo);
            } catch (Exception e) {
                showMsg(getString(R.string.request_data_fail));
            }
        } else {
            showMsg(result.getResultInfo());
        }
    }

    private void getSaveLessData(ResultData result) {
        final String msg = result.getInfo();
        if (result.isSuccessed()) {
            LowPerformanceResultListEntity mLowPerformanceResultListEntity = new Gson().fromJson(msg, LowPerformanceResultListEntity.class);
            Log.d(BaseActivity.TAG, "mLowPerformanceResultListEntity=" + mLowPerformanceResultListEntity.toString());
            if (ConstantParams.CONSTANT_PARAMS_0.equals(mLowPerformanceResultListEntity.retCode)) {
                if (mLowPerformanceResultListEntity.getResult() != null
                        && ConstantParams.CONSTANT_PARAMS_2.equals(mLowPerformanceResultListEntity.getResult().getSaleWaringFlag())
                        && !mLowPerformanceResultListEntity.getResult().getSaleWaringBeanList().isEmpty()) {
                    mLowPerformanceResultEntity = mLowPerformanceResultListEntity.getResult().getSaleWaringBeanList();
                    mLowPerformanceAdapter = new LowPerformanceAdapter(mLowPerformanceResultEntity, this);
                    mListView.setAdapter(mLowPerformanceAdapter);
                }
            } else {
                showMsg(mLowPerformanceResultListEntity.retInfo);
            }
        } else {
            showMsg(result.getResultInfo());
        }
    }
}