package com.wgmf.yxgj.modulelowperformance.ui;

import android.content.Context;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.TextView;

import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.modulelowperformance.R;
import com.wgmf.yxgj.modulelowperformance.model.SaleWaringBeanList;

import java.util.List;

/**
 * @author xiep  on 2017/11/14 15:00
 */

public class LowPerformanceAdapter extends BaseAdapter {

    private List<SaleWaringBeanList> list;
    private Context context;

    LowPerformanceAdapter(List<SaleWaringBeanList> mlist, Context context) {
        this.list = mlist;
        this.context = context;
    }

    public List<SaleWaringBeanList> getData() {
        return list;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {
        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @SuppressWarnings("all")
    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.low_performance_content_list_item, null);
            viewHolder = new ViewHolder();
            viewHolder.name = (TextView) convertView.findViewById(R.id.low_performance_content_store_name);
            viewHolder.fctSale1 = (TextView) convertView.findViewById(R.id.fct_sale_1);
            viewHolder.fctSale2 = (TextView) convertView.findViewById(R.id.fct_sale_2);
            viewHolder.fctSale3 = (TextView) convertView.findViewById(R.id.fct_sale_3);
            viewHolder.fctSaleValue1 = (TextView) convertView.findViewById(R.id.fct_sale_value_1);
            viewHolder.fctSaleValue2 = (TextView) convertView.findViewById(R.id.fct_sale_value_2);
            viewHolder.fctSaleValue3 = (TextView) convertView.findViewById(R.id.fct_sale_value_3);
            viewHolder.fctSaleEdit = (EditText) convertView.findViewById(R.id.fct_sale_edit);
            viewHolder.fctSaleEdit.setHint(R.string.fct_sale_edit_hint);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        if (null != list.get(position)) {
            if (null != list.get(position).getShop()) {
                viewHolder.name.setText(list.get(position).getShop().getShopName());
            }
            if (null != list.get(position).getWorkerCostRatioList() && list.get(position).getWorkerCostRatioList().size() > 2) {
                viewHolder.fctSale1.setText(setString(list.get(position).getWorkerCostRatioList().get(0).getYearmonth().substring(4, 6)) + "月销量/费比");
                viewHolder.fctSale2.setText(setString(list.get(position).getWorkerCostRatioList().get(1).getYearmonth().substring(4, 6)) + "销量/费比");
                viewHolder.fctSale3.setText(setString(list.get(position).getWorkerCostRatioList().get(2).getYearmonth().substring(4, 6)) + "销量/费比预估");
                viewHolder.fctSaleValue1.setText(setString(list.get(position).getWorkerCostRatioList().get(0).getFctSale()) + "万/" + setString(list.get(position).getWorkerCostRatioList().get(0).getWorkCostFctRoi()));
                viewHolder.fctSaleValue2.setText(setString(list.get(position).getWorkerCostRatioList().get(1).getFctSale()) + "万/" + setString(list.get(position).getWorkerCostRatioList().get(1).getWorkCostFctRoi()));
                viewHolder.fctSaleValue3.setText(setString(list.get(position).getWorkerCostRatioList().get(2).getFctSale()) + "万/" + setString(list.get(position).getWorkerCostRatioList().get(2).getWorkCostFctRoi()));
            }
        }
        // 改善措施
        viewHolder.fctSaleEdit.addTextChangedListener(new TextWatcher() {
            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                list.get(position).setSaleWarMeaImproveMea(viewHolder.fctSaleEdit.getText().toString().trim());
            }
        });
        return convertView;
    }

    class ViewHolder {
        TextView name;
        TextView fctSale1;
        TextView fctSale2;
        TextView fctSale3;
        TextView fctSaleValue1;
        TextView fctSaleValue2;
        TextView fctSaleValue3;
        EditText fctSaleEdit;
    }

    private String setString(String s) {
        if (StringUtil.isNullOrEmpty(s)) {
            return "--";
        } else {
            return s;
        }
    }
}