package com.wgmf.yxgj.module.business.parttime.model

import com.wgmf.library.base.BaseResponse
import java.io.Serializable

/**
 * 巡店门店搜索实体类
 */
data class PartTimeShopInfoListEntity(val result: List<ShopInfoBean>?) : BaseResponse() {
    data class ShopInfoBean(
        val address: String?,  //门店地址
        val adventAmount: String?,  // 临期金额(元)
        val adventQty: String?,  //临期货数量
        val checkType: Int,  //抽查方式1全盘2抽盘3临期
        val currentMonthSaleCount: String?,  //本月销售(元)
        val distance: Double,  //和给定地点的距离
        val id: String?,
        val lastMonthSaleCount: String?,  //上月销售(元)
        val lat: Double,  //纬度
        val lng: Double,  //经度
        val shopScheduleList: List<ShopScheduleBean>?,  //门店今日排班
        val shopStatusId: String?,  //店态id
        val shopStatusName: String?,  //店态名
        val stockAmount: String?,  //库存金额(元)
        val storeId: String?,  //门店ID
        val storeName: String?,   //门店名称
        val submitTime: String?   //门店的最近检查时间
    ) : Serializable {
        data class ShopScheduleBean(
            val endTime: String?,  //结束时间
            val hughFlag: String?,  //例休还是正常排班(1 :例休 3 :早班 4：中班 5：晚班 6：直落班 7：做一休一（工作） 8：做一休一（休息）9：高峰班 10：月会培训) ,
            val schedulingDay: String?,  //排班日
            val staffName: String?,  //排班员工
            val startTime: String?, //开始时间
            val storeId: String? //门店ID
        ) : Serializable
    }
}