package com.wgmf.yxgj.module.business.parttime.model

import com.wgmf.library.base.BaseResponse

/**
 * 排班信息+今日打卡实体类
 */
data class PartTimeShopScheduleEntity(val result: PartTimeShopScheduleBean?) : BaseResponse() {

    data class PartTimeShopScheduleBean(
        val lastMonthSaleCount: String?,
        val shopScheduleVoList: List<ShopScheduleVoBean>?,
        val signTimeBeanList: List<SignTimeBeanBean>?
    ) {
        data class ShopScheduleVoBean(
            val checked: Boolean, val schedulingDay: String?,
            val week: Int, val shopScheduleList: List<ShopScheduleBean>?
        ) {
            private val weeks = arrayOf("一", "二", "三", "四", "五", "六", "日")

            /**
             * 星期序号转换数字成中文
             * @param week int型星期
             * @return 中文星期
             */
            fun getDecodeWeek(week: Int): String {
                return weeks[week - 1]
            }

            data class ShopScheduleBean(
                val hughFlag: String?, //例休还是正常排班(1 :例休 3 :早班 4：中班 5：晚班 6：直落班 7：做一休一（工作） 8：做一休一（休息）9：高峰班 10：月会培训) ,
                val schedulingDay: String?,    //排班日
                val staffName: String?,  //排班员工
                val storeId: String?  //门店ID
            )
        }

        data class SignTimeBeanBean(
            val signDay: String?, //打卡日期
            val signDayDesc: String?,  //打卡日期描述
            val todaySignVoList: List<ToDaySignVoBean>?
        ) {

            data class ToDaySignVoBean(
                val staffId: String?,
                val staffName: String?,
                val toDaySignList: List<ToDaySignBean>? //今日打卡记录
            ) {

                data class ToDaySignBean(
                    val signInTime: String?,
                    val signOutTime: String?
                )
            }
        }
    }
}