package com.wgmf.yxgj.module.business.parttime.model

import com.wgmf.library.base.BaseResponse

/**
 * 盘点信息详情
 */
data class PartTimeTakeStockDetailEntity(val result: PartTimeTakeStockDetailBean?) :
    BaseResponse() {

    data class PartTimeTakeStockDetailBean(
        val checkListStatus: Int,  //是否审核(0未审核1已审核)
        val takeStockDetailList: List<TakeStockDetailBeam>? //库存盘点详情列表
    ) {
        data class TakeStockDetailBeam(
            val adventQty: Double,  //提示临期
            val invQty: Double,   //上月盘点数量（未审核）
            val productName: String?,//产品名称
            val productNo: String?,  //产品编号
            val stockQty: Double,  //实时库存（审核)

            var stockCount: Double? = null,  //盘点数
            var stockDifferenceCount: Double = 0.0, //差异数量

            val takeStockId: Int,   //锁定id
            val takeStoclDetailId: Int,  //明细id
            var adventStatus:Int,  //是否临期(1临期2不临期)
            var differenceDesc: String?, //差异说明
            var overTimeNumber: String?, //过期货数
            var overTimeRemark: String?,  //过期货数备注
            var partTimeAdventQty: String?,  //临期货数
            var remark: String? //临期货数备注
        )
    }
}