package com.wgmf.yxgj.module.business.parttime.model

import com.wgmf.library.base.BaseResponse

/**
 * 获取门店盘点信息
 */
data class PartTimeTakeStockEntity(val result: PartTimeTakeStockBean?) : BaseResponse() {

    data class PartTimeTakeStockBean(
        val actualColumnName: String?,
        val adventModelList: List<ModelBean>?,  //盘点数据(临期)
        val allModelList: List<ModelBean>?,  //盘点数据(全盘)
        val checkModelList: List<ModelBean>?,  //盘点数据(抽盘)
        val checkType: Int,   // 盘点类型(1全盘2抽盘3临期)
        val paperColumnName: String?,  //账面列名
        val statusStr: String?   //是否已盘点
    ) {
        data class ModelBean(
            var isChecked: Boolean = true,  //是否选中状态
            val adventQty: String?,  //临期数
            val adventQtyDecimal: String?,  //临期数（仅用于排序）
            val brandId: Int,  //产品品牌
            val invQty: String?,  //上月盘点数
            val lockProduct: Int,  // 产品锁定1锁定2未锁定
            val productName: String?,  //产品名称
            val productNo: String?,  //产品编号
            val productSort: Int,  // 排序（越小越靠前）
            val shouhuoQty: String?,  //盘点账面数量
            val stockQty: String?,  //当前库存
            val storeName: String?,  //门店名称

            val status:String?,
            var stockCount:String?,
            val remark:String?,
            val takeStockId:String?,
            val takeStoclDetailId:String?,
            val overTimeNumber:String?,  //过期货数
            val overTimeRemark:String?,  //过期货数备注
            val partTimeAdventQty:String? //兼职自己填的临期货数

        )
    }
}