package com.wgmf.yxgj.module.business.parttime.ui;

import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;

import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;

/**
 * @author xiep
 */
@SuppressWarnings("all")
public class PartTimeEdtDialog extends Dialog {

    private PartTimeEdtDialog(Context context) {
        super(context, R.style.textview_dialog);
        setCanceledOnTouchOutside(false);
        //这句代码设置这个对话框不能被用户按[返回键]而取消掉
        setCancelable(false);
    }

    public static class Builder {
        private Context context;
        private String negativeButtonText;
        private OnClickListener negativeButtonClickListener;
        private ClearEditText partTimeName;

        public String getPartTimeName() {
            return partTimeName.getText().toString().trim();
        }

        public Builder(Context context) {
            this.context = context;
        }

        public Builder setNegativeButton(int negativeButtonText,
                                         OnClickListener listener) {
            this.negativeButtonText = (String) context
                    .getText(negativeButtonText);
            this.negativeButtonClickListener = listener;
            return this;
        }

        public Builder setNegativeButton(OnClickListener listener) {
            this.negativeButtonText = "确定";
            this.negativeButtonClickListener = listener;
            return this;
        }

        public PartTimeEdtDialog create() {
            final PartTimeEdtDialog dialog = new PartTimeEdtDialog(context);
            View layout = LayoutInflater.from(context).inflate(R.layout.part_time_info, null);
            dialog.addContentView(layout, new LayoutParams(
                    LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));

            partTimeName = ((ClearEditText) layout
                    .findViewById(R.id.login_user_name_et));
            if (negativeButtonText != null) {
                ((Button) layout.findViewById(R.id.part_time_confirm_btn))
                        .setText(negativeButtonText);
                if (negativeButtonClickListener != null) {
                    layout.findViewById(R.id.part_time_confirm_btn)
                            .setOnClickListener(new View.OnClickListener() {
                                @Override
                                public void onClick(View v) {
                                    negativeButtonClickListener.onClick(dialog,
                                            DialogInterface.BUTTON_NEGATIVE);
                                }
                            });
                }
            } else {
                layout.findViewById(R.id.part_time_confirm_btn).setVisibility(View.GONE);
            }
            dialog.setContentView(layout);
            return dialog;
        }
    }
}