package com.wgmf.yxgj.module.business.parttime.ui;

import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.xp.arouter.RouterCommonUtil;
import com.xp.arouter.RouterParams;

/**
 * 兼职督查我的检查管理
 *
 * @author XiePing
 */
@Route(path = RouterParams.URL_PARTTIMEQUERYMANAGERACTIVITY)
public class ParttimeQueryManagerActivity extends SelectorBaseActivity {

    private String[] mFunctionName = {"库存盘点记录", "门店检查记录"};

    private String[] branchUrl = {"/mkt-front/html/assetInventory/myStoreCheck.html", "/mkt-front/html/assetInventory/myShopCheck.html"};

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        initData();
    }

    private void initData() {
        for (String aMFunctionName : mFunctionName) {
            BaseSelectorEntity mModel = new BaseSelectorEntity();
            mModel.setSelectorName(aMFunctionName);
            listShow.add(mModel);
        }
        mAdapter.notifyDataSetChanged();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("我的检查");
    }

    @Override
    public void initContent() {
        super.initContent();
        storeNameEt.setVisibility(View.GONE);
        mListView.setAdapter(mAdapter);
        mListView.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {
                toActivity(position);
            }
        });
    }

    private void toActivity(int position) {
        Bundle mBundle = new Bundle();
        mBundle.putString("branchUrl", branchUrl[position]);
        mBundle.putString("branchTitle", mFunctionName[position]);
        RouterCommonUtil.startFunctionActivity(this, 0, 0L, mBundle);
    }
}