package com.wgmf.yxgj.module.business.parttime.ui.adapter

import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.business.parttime.R
import com.wgmf.yxgj.module.business.parttime.model.PartTimeCheckRecordsEntity
import com.wgmf.yxgj.utils.convertDefaultValue

/**
 * 查询门店的盘点记录 适配器
 * @author LW
 */
class PartTimeCheckRecordsListAdapter(
    entity: List<PartTimeCheckRecordsEntity.CheckRecordsBean>
) : BaseQuickAdapter<PartTimeCheckRecordsEntity.CheckRecordsBean, BaseViewHolder>(
    R.layout.item_part_time_check_records,
    entity
) {

    override fun convert(
        helper: BaseViewHolder?,
        item: PartTimeCheckRecordsEntity.CheckRecordsBean?
    ) {
        helper?.apply {
            item?.let {
                val checkTypeName =
                    if (it.checkType == ConstantParams.CONSTANT_STARTS_1) {   //1全盘2抽盘3临期
                        mContext.getString(R.string.part_time_shop_info_wholesale)
                    } else if (it.checkType == ConstantParams.CONSTANT_STARTS_2) {
                        mContext.getString(R.string.part_time_shop_info_draw)
                    } else if (it.checkType == ConstantParams.CONSTANT_STARTS_3) {
                        mContext.getString(R.string.part_time_shop_info_advent)
                    } else {
                        "".convertDefaultValue()
                    }
                setText(
                    R.id.part_time_item_left_title_tv, it.submitTime.convertDefaultValue()
                )
                setText(
                    R.id.part_time_item_right_title_tv,
                    checkTypeName
                )
            }
        }
    }
}