package com.wgmf.yxgj.module.business.parttime.ui.takestock

import android.content.Intent
import android.os.Bundle
import android.support.design.widget.AppBarLayout
import android.support.design.widget.CoordinatorLayout
import android.support.v4.content.ContextCompat
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.View
import android.widget.*
import com.chad.library.adapter.base.BaseQuickAdapter
import com.google.gson.Gson
import com.melnykov.fab.FloatingActionButton
import com.scwang.smartrefresh.layout.SmartRefreshLayout
import com.wgmf.library.base.ResultData
import com.wgmf.library.global.LocationParams
import com.wgmf.library.utils.Log
import com.wgmf.library.utils.TextColorDominator
import com.wgmf.library.utils.tools.PrefTool
import com.wgmf.yxgj.base.BaseParentAct
import com.wgmf.yxgj.config.BusinessID
import com.wgmf.yxgj.dialog.LoadWaitDominator
import com.wgmf.yxgj.dialog.PublicTipDialog
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.global.Prefs
import com.wgmf.yxgj.module.business.parttime.R
import com.wgmf.yxgj.module.business.parttime.model.*
import com.wgmf.yxgj.module.business.parttime.model.PartTimeShopInfoListEntity.ShopInfoBean
import com.wgmf.yxgj.module.business.parttime.service.PartTimeService
import com.wgmf.yxgj.module.business.parttime.ui.PartTimeShopScheduleFragment
import com.wgmf.yxgj.module.business.parttime.ui.takestock.adapter.PartTimeTakeStockLockAdapter
import com.wgmf.yxgj.utils.StringUtils
import com.wgmf.yxgj.utils.convertDefaultValue
import com.wgmf.yxgj.utils.isNotNullOrSize
import com.wgmf.yxgj.utils.notNullAndEmpty
import com.wgmf.yxgj.widgets.decoration.DividerItemDecoration

/**
 * @author LW on 2023-7-14 0014.
 * 门店详情
 */
class PartTimeTakeStockLockActivity : BaseParentAct() {

    private var mPartTimeTakeStockReturnTopFab: FloatingActionButton? = null

    private var mPartTimeTakeStockStatusTv: TextView? = null

    private var mPartTimeTakeStockStoreOverallTv: TextView? = null
    private var mPartTimeTakeStockStoreDrawTv: TextView? = null
    private var mPartTimeTakeStockStoreAdventTv: TextView? = null

    private var mPartTimeTakeStockStoreOverallRl: RelativeLayout? = null
    private var mPartTimeTakeStockStoreDrawRl: RelativeLayout? = null
    private var mPartTimeTakeStockStoreAdventRl: RelativeLayout? = null

    private var mPartTimeTakeStockInvqtyTv: TextView? = null
    private var mPartTimeTakeStockSpTv: TextView? = null

    private var mPublicListViewRv: RecyclerView? = null
    private var mPublicRefreshView: SmartRefreshLayout? = null

    private var mPartTimeTakeStockLockStockBtn: Button? = null
    private var mPartTimeTakeStockUnlockStockBtn: Button? = null

    private var mPartTimeTakeStockLockAdapter: PartTimeTakeStockLockAdapter? = null

    private lateinit var mLoadWait: LoadWaitDominator

    private val mShopInfoBean: ShopInfoBean? by lazy {
        intent?.getSerializableExtra(AppConstants.ExtraKeys.PART_TIME_SHOP_INFO) as ShopInfoBean
    }

    private var mPartTimeShopBrandList: List<PartTimeShopBrandEntity.PartTimeShopBrandBean>? =
        mutableListOf()

    private var mPartTimeTakeStockBean: PartTimeTakeStockEntity.PartTimeTakeStockBean? = null

    private var mUserPartTimeName: String? = null

    /**
     * 抽盘方式
     */
    private var mCheckType: Int = ConstantParams.CONSTANT_STARTS_1

    /**
     * 品牌类型
     */
    private var mSelectBrandId: Int = ConstantParams.CONSTANT_STARTS_8;

    /**
     * 锁Id
     */
    private var mTakeStockId: String? = null

    /**
     * 锁定状态
     */
    private var mOperateType: Int = 0  //1：锁定状态 0：未锁定

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_part_time_take_stock_lock)
        initTitle()
        initData()
        initView()
    }

    override fun initTitle() {
        super.initTitle()
        homeTitleText.text = mContext.getString(R.string.part_time_shop_info_store_detail)
        homeTitleBackLl.visibility = View.VISIBLE
    }

    private fun initData() {
        mUserPartTimeName = PrefTool.getStringPerferences(this, Prefs.PRE_USER_PART_TIME_NAME)
    }

    private fun initView() {
        initRecyclerView()
        val partTimeTakeStockAppbarAbl =
            findViewById<AppBarLayout>(R.id.part_time_take_stock_appbar_abl)
        mPartTimeTakeStockReturnTopFab =
            findViewById<FloatingActionButton>(R.id.part_time_take_stock_return_top_fab).apply {
                hide()
                setOnClickListener {
                    mPublicListViewRv?.scrollToPosition(0)
                    if (partTimeTakeStockAppbarAbl != null) {
                        val behavior =
                            (partTimeTakeStockAppbarAbl.layoutParams as CoordinatorLayout.LayoutParams).behavior
                        if (behavior is AppBarLayout.Behavior) {
                            val appBarLayoutBeHavior = behavior as AppBarLayout.Behavior
                            val topAndBottomOffset = appBarLayoutBeHavior.topAndBottomOffset
                            if (topAndBottomOffset != 0) {
                                appBarLayoutBeHavior.topAndBottomOffset = 0;
                                partTimeTakeStockAppbarAbl.setExpanded(true, true);
                            }
                        }
                    }
                }
            }
        mPartTimeTakeStockStatusTv =
            findViewById(R.id.part_time_take_stock_status_tv)

        mPartTimeTakeStockStoreOverallRl =
            findViewById(R.id.part_time_take_stock_store_overall_rl)
        val partTimeTakeStockStoreOverallStatusIv =
            findViewById<ImageView>(R.id.part_time_take_stock_store_overall_status_iv)
        mPartTimeTakeStockStoreOverallTv =
            findViewById(R.id.part_time_take_stock_store_overall_tv)

        mPartTimeTakeStockStoreDrawRl =
            findViewById(R.id.part_time_take_stock_store_draw_rl)
        val partTimeTakeStockStoreDrawStatusIv =
            findViewById<ImageView>(R.id.part_time_take_stock_store_draw_status_iv)
        mPartTimeTakeStockStoreDrawTv =
            findViewById(R.id.part_time_take_stock_store_draw_tv)

        mPartTimeTakeStockStoreAdventRl =
            findViewById(R.id.part_time_take_stock_store_advent_rl)
        val partTimeTakeStockStoreAdventStatusIv =
            findViewById<ImageView>(R.id.part_time_take_stock_store_advent_status_iv)
        mPartTimeTakeStockStoreAdventTv =
            findViewById(R.id.part_time_take_stock_store_advent_tv)

        mPartTimeTakeStockStoreOverallTv?.setOnClickListener {
            it.isSelected = true
            partTimeTakeStockStoreOverallStatusIv.visibility = View.VISIBLE

            mPartTimeTakeStockStoreDrawTv?.isSelected = false
            partTimeTakeStockStoreDrawStatusIv.visibility = View.GONE

            mPartTimeTakeStockStoreAdventTv?.isSelected = false
            partTimeTakeStockStoreAdventStatusIv.visibility = View.GONE

            mCheckType = ConstantParams.CONSTANT_STARTS_1
            switchCheckType(mCheckType)
        }

        mPartTimeTakeStockStoreDrawTv?.setOnClickListener {
            it.isSelected = true
            partTimeTakeStockStoreDrawStatusIv.visibility = View.VISIBLE

            mPartTimeTakeStockStoreOverallTv?.isSelected = false
            partTimeTakeStockStoreOverallStatusIv.visibility = View.GONE

            mPartTimeTakeStockStoreAdventTv?.isSelected = false
            partTimeTakeStockStoreAdventStatusIv.visibility = View.GONE

            mCheckType = ConstantParams.CONSTANT_STARTS_2
            switchCheckType(mCheckType)
        }

        mPartTimeTakeStockStoreAdventTv?.setOnClickListener {
            it.isSelected = true
            partTimeTakeStockStoreAdventStatusIv.visibility = View.VISIBLE

            mPartTimeTakeStockStoreOverallTv?.isSelected = false
            partTimeTakeStockStoreOverallStatusIv.visibility = View.GONE

            mPartTimeTakeStockStoreDrawTv?.isSelected = false
            partTimeTakeStockStoreDrawStatusIv.visibility = View.GONE

            mCheckType = ConstantParams.CONSTANT_STARTS_3
            switchCheckType(mCheckType)
        }

        mPartTimeTakeStockInvqtyTv = findViewById(R.id.part_time_take_stock_invqty_tv)
        mPartTimeTakeStockSpTv = findViewById(R.id.part_time_take_stock_sp_tv)

        mPartTimeTakeStockLockStockBtn =
            findViewById<Button>(R.id.part_time_take_stock_lock_stock_btn).apply {
                setOnClickListener {
                    if (mOperateType == ConstantParams.CONSTANT_STARTS_1) { //锁定状态
                        removePartTimeTakeStock()
                    } else {
                        showStockTipDialog()
                    }
                }
            }
        mPartTimeTakeStockUnlockStockBtn =
            findViewById<Button>(R.id.part_time_take_stock_continue_enter_btn).apply {  //继续录入
                setOnClickListener {
                    jumpPartTimeTakeStockDetailActivity(mTakeStockId)
                }
            }

        findViewById<TextView>(R.id.part_time_take_stock_location_tv).apply {
            val address = LocationParams.Address
            if (address.notNullAndEmpty()) {
                visibility = View.VISIBLE
                text = StringUtils.formatString(
                    getString(R.string.part_time_take_stock_location),
                    address
                )
            }
        }
        //添加门店查询品牌
        getShopBrandList()

    }

    override fun onResume() {
        super.onResume()
        getTakeStockByShopId()
    }

    private fun initFragment(partTimeShopBrandList: List<PartTimeShopBrandEntity.PartTimeShopBrandBean>) {
        val partTimeShopScheduleFragment = PartTimeShopScheduleFragment()
        val partTimeShopScheduleBundle = Bundle()
        partTimeShopScheduleBundle.putSerializable(
            AppConstants.ExtraKeys.PART_TIME_SHOP_INFO, mShopInfoBean
        )
        partTimeShopScheduleBundle.putParcelableArrayList(
            AppConstants.ExtraKeys.PART_TIME_SHOP_BRAND,
            partTimeShopBrandList as ArrayList<PartTimeShopBrandEntity.PartTimeShopBrandBean>
        )

        partTimeShopScheduleFragment.arguments = partTimeShopScheduleBundle
        supportFragmentManager.beginTransaction()
            .add(R.id.part_time_take_stock_store_info_fl, partTimeShopScheduleFragment).commit()
    }

    private fun initRecyclerView() {
        mLoadWait =
            LoadWaitDominator(mContext, findViewById(R.id.public_container_fl))

        mPublicRefreshView = findViewById<SmartRefreshLayout>(R.id.public_refresh_view).apply {
            isEnableLoadmore = false
            //刷新
            setOnRefreshListener {
                getTakeStockByShopId()
            }
        }

        mPartTimeTakeStockLockAdapter = PartTimeTakeStockLockAdapter(mutableListOf())
        mPublicListViewRv = findViewById<RecyclerView>(R.id.public_list_view_rv).apply {
            layoutManager = LinearLayoutManager(mContext)
            adapter = mPartTimeTakeStockLockAdapter
            addItemDecoration(
                DividerItemDecoration(
                    DividerItemDecoration.HORIZONTAL_LIST,
                    1,
                    ContextCompat.getColor(mContext, R.color.divider_line_deep_two)
                )
            )

            addOnScrollListener(object : RecyclerView.OnScrollListener() {
                override fun onScrolled(recyclerView: RecyclerView, dx: Int, dy: Int) {
                    super.onScrolled(recyclerView, dx, dy)
                    if (dy == 0) {
                        mPartTimeTakeStockReturnTopFab?.hide()
                    } else {
                        mPartTimeTakeStockReturnTopFab?.show()
                    }
                }

                override fun onScrollStateChanged(recyclerView: RecyclerView, newState: Int) {
                    super.onScrollStateChanged(recyclerView, newState)
                    if (newState == RecyclerView.SCROLL_STATE_IDLE) { //当前状态为停止滑动
                        if (!canScrollVertically(1)) { // 到达底部
                        } else if (!canScrollVertically(-1)) { // 到达顶部
                            mPartTimeTakeStockReturnTopFab?.hide()
                        }
                    }
                }
            })
        }

        BaseQuickAdapter.OnItemChildClickListener { adapter, view, pos -> //跳转到任务列表详情
            val bean =
                adapter?.getItem(pos) as PartTimeTakeStockEntity.PartTimeTakeStockBean.ModelBean
        }.also { mPartTimeTakeStockLockAdapter?.onItemChildClickListener = it }
    }

    /**
     * 添加门店查询品牌
     */
    private fun getShopBrandList() {
        mShopInfoBean?.let {
            PartTimeService.getInstance()
                .requestGetShopBrandList(it.storeId, this@PartTimeTakeStockLockActivity)
        }
    }

    /**
     * 获取门店盘点信息
     */
    private fun getTakeStockByShopId() {
        mShopInfoBean?.let {
            showDialog()
            PartTimeService.getInstance()
                .requestGetTakeStockByShopId(
                    it.storeId,
                    mUserPartTimeName,
                    userInfo.staffId, mSelectBrandId, this@PartTimeTakeStockLockActivity
                )
        }
    }

    /**
     * 当天是否锁定库存盘点
     */
    private fun getPartTimeTakeStock() {
        mShopInfoBean?.let {
            PartTimeService.getInstance()
                .requestGetPartTimeTakeStock(
                    it.storeId,
                    mUserPartTimeName,
                    userInfo.staffId,
                    mSelectBrandId,
                    this@PartTimeTakeStockLockActivity
                )
        }
    }

    /**
     * 解除库存
     */
    private fun removePartTimeTakeStock() {
        mShopInfoBean?.let {
            showDialog()
            PartTimeService.getInstance()
                .requestRemovePartTimeTakeStock(
                    it.storeId, mUserPartTimeName,
                    userInfo.staffId,
                    mSelectBrandId, this@PartTimeTakeStockLockActivity
                )
        }
    }

    /**
     * 锁定库存
     */
    private fun savePartTimeTakeStock() {
        mShopInfoBean?.let {
            showDialog()
            val modelList: List<PartTimeTakeStockEntity.PartTimeTakeStockBean.ModelBean> =
                if (mCheckType == ConstantParams.CONSTANT_STARTS_1) {
                    mPartTimeTakeStockBean?.allModelList ?: listOf()
                } else if (mCheckType == ConstantParams.CONSTANT_STARTS_2) {
                    mPartTimeTakeStockBean?.checkModelList ?: listOf()
                } else if (mCheckType == ConstantParams.CONSTANT_STARTS_3) {
                    mPartTimeTakeStockBean?.adventModelList ?: listOf()
                } else {
                    listOf()
                }
            val partTimeTakeStockDetailList =
                mutableListOf<PartTimeTakeStockSubmitEntity.partTimeTakeStockDetailBean>()
            modelList.filter { it.isChecked }.forEach {
                partTimeTakeStockDetailList.add(
                    PartTimeTakeStockSubmitEntity.partTimeTakeStockDetailBean(
                        it.productNo
                    )
                )
            }

            val bean = PartTimeTakeStockSubmitEntity(
                mTakeStockId,
                userInfo.staffId,
                it.storeId,
                it.storeName,
                mUserPartTimeName,
                mSelectBrandId,
                mCheckType,
                partTimeTakeStockDetailList
            )

            val content = Gson().toJson(bean)
            PartTimeService.getInstance()
                .requestSavePartTimeTakeStock(content, this@PartTimeTakeStockLockActivity)
        }
    }

    /**
     * 设置选中品牌
     */
    fun setSelectBranchId(brandId: Int) {
        this.mSelectBrandId = brandId
        mPublicRefreshView?.autoRefresh()
    }

    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)
        dismissDialog()
        mPublicRefreshView?.finishRefresh()
        result?.let {
            if (it.taskID == BusinessID.PartTime.MSG_ON_GET_SHOP_BRAND_LIST) {
                if (!isFinishing && it.isSuccessed) {
                    val entity =
                        Gson().fromJson(it.info, PartTimeShopBrandEntity::class.java)
                    Log.d(TAG, "PartTimeShopBrandEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        this.mPartTimeShopBrandList = entity.result
                        entity.result?.let { initFragment(it) }
                    } else {
                        showMsg(entity.retInfo)
                    }
                } else {
                    showMsg(R.string.request_data_fail)
                }
            } else if (it.taskID == BusinessID.PartTime.MSG_ON_GET_TAKESTOCK_BY_SHOPID) {
                if (!isFinishing && it.isSuccessed) {
                    val entity =
                        Gson().fromJson(it.info, PartTimeTakeStockEntity::class.java)
                    Log.d(TAG, "PartTimeTakeStockEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        this.mPartTimeTakeStockBean = entity.result
                        takeStockByShopIdToView()
                    } else {
                        mLoadWait.show(entity.retInfo)
                    }
                } else {
                    mLoadWait.showNetError()
                }
            } else if (it.taskID == BusinessID.PartTime.MSG_ON_GET_PARTTIME_TAKESTOCK) {
                if (!isFinishing && it.isSuccessed) {
                    val entity =
                        Gson().fromJson(it.info, PartTimeTakeStockUnLockEntity::class.java)
                    Log.d(TAG, "PartTimeTakeStockUnLockEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        //已锁定库存，则可进行解锁库存和库存录入工作
                        mTakeStockId = entity.result?.takeStockId
                        mOperateType = ConstantParams.CONSTANT_STARTS_1
                        mPartTimeTakeStockLockAdapter?.setEnable(false)
                    } else {
                        //没有锁定库存,则显示锁定库存按钮
                        mTakeStockId = null
                        mOperateType = ConstantParams.CONSTANT_STARTS_0
                        if (mCheckType == ConstantParams.CONSTANT_STARTS_2 || mCheckType ==
                            ConstantParams.CONSTANT_STARTS_3
                        ) {
                            mPartTimeTakeStockLockAdapter?.setEnable(true)
                        } else {
                            mPartTimeTakeStockLockAdapter?.setEnable(false)
                        }
                    }
                    refreshDrawModeview()
                    refreshButtonView()
                    //showMsg(entity.retInfo)
                } else {
                    showMsg(R.string.request_data_fail)
                }
            } else if (it.taskID == BusinessID.PartTime.MSG_ON_SAVE_PARTTIME_TAKESTOCK
                || it.taskID == BusinessID.PartTime.MSG_ON_REMOVE_PARTTIME_TAKESTOCK
            ) {
                if (!isFinishing && it.isSuccessed) {
                    val entity =
                        Gson().fromJson(it.info, PartTimeTakeStockLockEntity::class.java)
                    Log.d(TAG, "PartTimeTakeStockLockEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        //已锁定库存，则可进行解锁库存和库存录入工作
                        mTakeStockId = entity.result
                        if (mTakeStockId.notNullAndEmpty()) {
                            mOperateType = ConstantParams.CONSTANT_STARTS_1
                            mPartTimeTakeStockLockAdapter?.setEnable(false)
                            jumpPartTimeTakeStockDetailActivity(mTakeStockId)
                        } else {
                            mOperateType = ConstantParams.CONSTANT_STARTS_0
                            if (mCheckType == ConstantParams.CONSTANT_STARTS_2 || mCheckType ==
                                ConstantParams.CONSTANT_STARTS_3
                            ) {
                                mPartTimeTakeStockLockAdapter?.setEnable(true)
                            } else {
                                mPartTimeTakeStockLockAdapter?.setEnable(false)
                            }
                            getTakeStockByShopId()
                        }
                        refreshDrawModeview()
                        refreshButtonView()
                    }
                    showMsg(entity.retInfo)
                } else {
                    showMsg(R.string.request_data_fail)
                }
            } else {

            }
        }
    }

    private fun refreshButtonView() {
        if (mOperateType == ConstantParams.CONSTANT_STARTS_1) {  //锁定状态
            mPartTimeTakeStockUnlockStockBtn?.visibility = View.VISIBLE
            mPartTimeTakeStockLockStockBtn?.text =
                mContext.getString(R.string.part_time_take_stock_unlock_stock)
        } else {
            mPartTimeTakeStockUnlockStockBtn?.visibility = View.GONE
            mPartTimeTakeStockLockStockBtn?.text =
                mContext.getString(R.string.part_time_take_stock_lock_stock)
        }
    }

    private fun refreshDrawModeview() {
        if (mOperateType == ConstantParams.CONSTANT_STARTS_1) { //锁定状态
            mPartTimeTakeStockStoreOverallTv?.isEnabled = false
            mPartTimeTakeStockStoreDrawTv?.isEnabled = false
            mPartTimeTakeStockStoreAdventTv?.isEnabled = false
        } else {
            mPartTimeTakeStockStoreOverallTv?.isEnabled = true
            mPartTimeTakeStockStoreDrawTv?.isEnabled = true
            mPartTimeTakeStockStoreAdventTv?.isEnabled = true
        }
    }

    /**
     * 获取门店盘点信息
     */
    private fun takeStockByShopIdToView() {
        mPartTimeTakeStockBean?.let {
            val statusStr = it.statusStr
            mPartTimeTakeStockStatusTv?.text =
                StringUtils.formatString(
                    mContext.getString(R.string.part_time_take_stock_store_tips),
                    statusStr.convertDefaultValue()
                )

            mPartTimeTakeStockInvqtyTv?.text = it.paperColumnName
            mPartTimeTakeStockSpTv?.text = it.actualColumnName
            it.allModelList?.apply {
                forEach {
                    it.isChecked = it.lockProduct == ConstantParams.CONSTANT_STARTS_1
                }
            }
            it.checkModelList?.apply {
                forEach {
                    it.isChecked = it.lockProduct == ConstantParams.CONSTANT_STARTS_1
                }
            }
            it.adventModelList?.apply {
                forEach {
                    it.isChecked = it.lockProduct == ConstantParams.CONSTANT_STARTS_1
                }
            }
            this.mCheckType = it.checkType
            if (it.checkType == ConstantParams.CONSTANT_STARTS_2) {
                mPartTimeTakeStockStoreDrawTv?.performClick()
            } else if (it.checkType == ConstantParams.CONSTANT_STARTS_3) {
                mPartTimeTakeStockStoreAdventTv?.performClick()
            } else {
                mPartTimeTakeStockStoreOverallTv?.performClick()
            }
            //当天是否锁定库存盘点
            getPartTimeTakeStock()

        } ?: apply {
            mLoadWait.showNoData()
        }
    }

    /**
     * 盘点类型(1全盘2抽盘3临期)
     */
    private fun switchCheckType(mode: Int) {
        mLoadWait.dismissAll()
        mPartTimeTakeStockLockAdapter?.setCheckType(mode)
        if (mode == ConstantParams.CONSTANT_STARTS_1) {
            val allModelList = mPartTimeTakeStockBean?.allModelList
            mPartTimeTakeStockLockAdapter?.setNewData(allModelList ?: mutableListOf())
            if (allModelList.isNotNullOrSize()) {
                mPartTimeTakeStockLockAdapter?.setEnable(false)
            } else {
                mLoadWait.showNoData()
            }
        } else if (mode == ConstantParams.CONSTANT_STARTS_2) {
            val checkModelList = mPartTimeTakeStockBean?.checkModelList
            mPartTimeTakeStockLockAdapter?.setNewData(checkModelList ?: mutableListOf())
            if (checkModelList.isNotNullOrSize()) {
                mPartTimeTakeStockLockAdapter?.setEnable(true)
            } else {
                mLoadWait.showNoData()
            }
        } else if (mode == ConstantParams.CONSTANT_STARTS_3) {
            val adventModelList = mPartTimeTakeStockBean?.adventModelList
            mPartTimeTakeStockLockAdapter?.setNewData(adventModelList ?: mutableListOf())
            if (adventModelList.isNotNullOrSize()) {
                mPartTimeTakeStockLockAdapter?.setEnable(true)
            } else {
                mLoadWait.showNoData()
            }
        }
    }

    /**
     * 确认退出对话框
     */
    private fun showStockTipDialog() {
        val builder = PublicTipDialog.Builder(this)
        //if (mOperateType == ConstantParams.CONSTANT_STARTS_0) {
        builder.setTitle(R.string.part_time_take_stock_confirm_lock)
        val content =
            mContext.getString(R.string.part_time_take_stock_confirm_lock_content)
        builder.setMessage(
            TextColorDominator.styleTextColor(
                content,
                ContextCompat.getColor(mContext, R.color.common_txt_tag_third_color),
                content.lastIndexOf("，"),
                content.length - 1
            )
        )
        // } else {
        //     builder.setTitle(R.string.part_time_take_stock_confirm_not_lock)
        //     builder.setMessage(R.string.part_time_take_stock_confirm_not_lock_content)
        // }
        builder.setNegativeButton(R.string.confirm_btn_txt) { dialog, which ->
            //if (mOperateType == ConstantParams.CONSTANT_STARTS_0) {  //锁定库存
            savePartTimeTakeStock()
            //} else {  //解除锁定
            //    removePartTimeTakeStock()
            //}
            dialog.dismiss()
        }
        builder.setPositiveButton(
            R.string.cancel_btn_txt
        ) { dialog, _ -> dialog.dismiss() }
        builder.create().show()
    }

    /**
     * 跳转到 PartTimeTakeStockListActivity
     */
    private fun jumpPartTimeTakeStockDetailActivity(takeStockId: String?) {
        if (takeStockId.notNullAndEmpty()) {
            startActivity(Intent(mContext, PartTimeTakeStockDetailActivity::class.java).apply {
                putExtra(AppConstants.ExtraKeys.PART_TIME_TAKE_STOCK_ID, takeStockId)
                putExtra(AppConstants.ExtraKeys.BRAND_ID, mSelectBrandId)
            })
        }
    }
}