package com.wgmf.yxgj.module.business.parttime.ui.takestock.adapter

import android.support.v4.content.ContextCompat
import android.widget.CheckBox
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.business.parttime.R
import com.wgmf.yxgj.module.business.parttime.model.PartTimeTakeStockEntity
import com.wgmf.yxgj.utils.convertDefaultValue

/**
 * 商品详情 适配器
 * @author LW
 */
class PartTimeTakeStockLockAdapter(
    entity: List<PartTimeTakeStockEntity.PartTimeTakeStockBean.ModelBean>
) : BaseQuickAdapter<PartTimeTakeStockEntity.PartTimeTakeStockBean.ModelBean, BaseViewHolder>(
    R.layout.item_part_time_take_stock_lock,
    entity
) {
    private var mIsEnable: Boolean = true;

    /**
     * 盘点类型(1全盘2抽盘3临期)
     */
    private var mCheckType: Int = ConstantParams.CONSTANT_STARTS_1

    /**
     * 是否可以操作
     */
    fun setEnable(enable: Boolean) {
        this.mIsEnable = enable
        notifyDataSetChanged()
    }

    fun setCheckType(mode: Int) {
        mCheckType = mode
    }

    override fun convert(
        helper: BaseViewHolder?,
        item: PartTimeTakeStockEntity.PartTimeTakeStockBean.ModelBean?
    ) {
        helper?.apply {
            item?.let {
                getView<CheckBox>(R.id.part_time_take_stock_choose_cb).apply {
                    isEnabled = mIsEnable
                    isChecked = it.isChecked
                    setOnCheckedChangeListener { _, isChecked ->
                        if (adapterPosition >= 0 && adapterPosition < data.size) {
                            val bean = data[adapterPosition]
                            bean.isChecked = isChecked  //选中更新状态
                        }
                    }
                }
                setText(
                    R.id.part_time_take_stock_product_name_tv,
                    it.productName
                )
                setText(
                    R.id.part_time_take_stock_product_code_tv,
                    it.productNo
                )

                setText(
                    R.id.part_time_take_stock_stock_qty_tv,
                    it.stockQty.convertDefaultValue()
                )

                setText(
                    R.id.part_time_take_stock_shouhuo_qty_tv,
                    it.shouhuoQty.convertDefaultValue()
                )

                setText(
                    R.id.part_time_take_stock_inv_qty_tv,
                    it.invQty.convertDefaultValue()
                )

                setText(
                    R.id.part_time_take_stock_advent_qty_tv,
                    it.adventQty.convertDefaultValue()
                )
                if (it.adventQty?.toInt() ?: 0 > 0) {
                    itemView.setBackgroundColor(
                        ContextCompat.getColor(
                            mContext,
                            R.color.region_five_bg
                        )
                    )
                } else {
                    itemView.setBackgroundColor(ContextCompat.getColor(mContext, R.color.normal_bg))
                }
            }
        }
    }
}