package com.wgmf.yxgj.module.business.parttime.ui.tourshop;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.Gravity;
import android.view.View;

import com.google.gson.Gson;
import com.jakewharton.rxbinding.view.RxView;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.PublicTipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeTourShopDetailEntity;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeTourShopImgList;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeTourShopModelEntity;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeTourShopModelListEntity;
import com.wgmf.yxgj.module.business.parttime.service.PartTimeManager;
import com.wgmf.yxgj.module.business.parttime.service.PartTimeService;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.global.Params;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

import rx.functions.Action1;

@SuppressWarnings("all")
public class PartTimeTourShopReportDetailActivity2 extends ReportWithPhotoBaseActivity implements ImagePickerLayout.ImagePicker {

    String[] types = {"上传现场员工形象相关图片", "上传专柜卫生及内部陈列检查图片", "上传专柜外部陈列相关图片", "上传现场音频"};
    int[] mPics = {2, 8, 5};
    /**
     * 专柜外部检查
     */
    private static final int REPORTTYPEID_2 = 2;
    private int typeID;
    private String tourId;
    private PartTimeTourShopReportDetailAdapter mPartTimeTourShopReportAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        queryData();
    }

    @Override
    protected void initData() {
        super.initData();
        //兼职检查
        reportType = "PTJC";
        typeID = getIntent().getIntExtra("typeID", 0);
    }

    @Override
    protected void initContent() {
        super.initContent();
        shopId = getIntent().getStringExtra("shopId");
        shopName = getIntent().getStringExtra("shopName");
        tourId = getIntent().getStringExtra("tourId");
    }

    @Override
    protected void parseFootData() {
        super.parseFootData();
        reportEdit.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_gray_style));
        reportEdit.setPadding(10, 10, 10, 10);
        reportEdit.setHint("请输入备注");
        reportEdit.setVisibility(View.VISIBLE);
        tvSummary.setVisibility(View.GONE);
        reportContentConfirmBtn.setText(R.string.submit_btn_txt);
        //3秒钟之内只取一个点击事件，防抖操作
        RxView.clicks(reportContentConfirmBtn).throttleFirst(3, TimeUnit.SECONDS).subscribe(new Action1<Void>() {
            @Override
            public void call(Void aVoid) {
                setUploadData();
            }
        });
        publicTakePhotoLl.setVisibility(View.GONE);
        publicTakePhotoRootLl.setVisibility(View.VISIBLE);
        initPictureDisplayView();
    }

    private void initPictureDisplayView() {
        idImagePickerContainer = (ImagePickerLayout) findViewById(R.id.id_image_picker_container);
        idImagePickerContainer.setVisibility(View.VISIBLE);
        idImagePickerContainer.setTitle(types[typeID]);
        idImagePickerContainer.setTip("(最多可上传" + mPics[typeID] + "张图片)");
        idImagePickerContainer.setImagePicker(this);
        idImagePickerContainer.setSizePhotoNum(3);
        idImagePickerContainer.setMaxPhotoNum(mPics[typeID]);
        idImagePickerContainer.setmImageselectList(mImageselectList);
        idImagePickerContainer.setImagePickerView(idImagePickerContainer);
        idImagePickerContainer.setOlnyViewMode(false);
    }

    @Override
    public void initTitle() {
        super.initTitle();
        String typeName = getIntent().getStringExtra("typeName");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText(typeName);
    }

    protected void queryData() {
        if (null != userInfo) {
            showDialog();
            PartTimeService.getInstance().requestGetPartTimeTourShopModel(typeID + "", shopId, PartTimeTourShopReportDetailActivity2.this);
        }
    }

    @Override
    protected void setUploadData() {
        List<PartTimeTourShopModelEntity> partTimeTourShopDetail = mPartTimeTourShopReportAdapter.getTourShopListEntity();
        if (REPORTTYPEID_2 != typeID) {
            if (null != partTimeTourShopDetail && !partTimeTourShopDetail.isEmpty()) {
                for (PartTimeTourShopModelEntity mPartTimeTourShopDetail : partTimeTourShopDetail) {
                    if (null == mPartTimeTourShopDetail.getIsOk()) {
                        ToastUtil.show(this, "第" + mPartTimeTourShopDetail.getPos() + "道题需作答后才可提交哦！");
                        dismissDialog();
                        return;
                    }
                }
            }
        }
        super.setUploadData();
    }

    /**
     * 上传巡店辅导数据
     */
    @Override
    protected void uploadData() {
        super.uploadData();
        showDialog();
        PartTimeTourShopDetailEntity partTimeTourShopDetailEntity = new PartTimeTourShopDetailEntity();
        List<PartTimeTourShopModelEntity> partTimeTourShopDetail = new ArrayList<>();
        partTimeTourShopDetailEntity.setTourId(tourId);
        partTimeTourShopDetailEntity.setShopId(shopId);
        partTimeTourShopDetailEntity.setShopName(shopName);
        partTimeTourShopDetailEntity.setPartTimeStaffId(userInfo.getStaffId());
        String userName = PrefTool.getStringPerferences(this, Prefs.PRE_USER_PART_TIME_NAME);
        partTimeTourShopDetailEntity.setPartTimeStaffName(userName);
        //图片成功或失败信息
        PartTimeManager.setImageStatus(typeID, partTimeTourShopDetailEntity, imgStatus);
        //添加备注信息
        PartTimeManager.setRemark(typeID, partTimeTourShopDetailEntity, reportEdit.getText().toString());
        //设置提交人信息
        PartTimeTourShopModelEntity partTimeTourShopDetails = new PartTimeTourShopModelEntity();
        partTimeTourShopDetails.setTourId(tourId);
        partTimeTourShopDetails.setType(typeID);
        partTimeTourShopDetail.add(partTimeTourShopDetails);
        partTimeTourShopDetailEntity.setPartTimeTourShopDetailList(partTimeTourShopDetail);
        //设置提交图片信息
        if (urlLists != null && !urlLists.isEmpty()) {
            List<PartTimeTourShopImgList> partTimeTourShopImgLists = new ArrayList<>();
            for (int i = 0; i < urlLists.size(); i++) {
                PartTimeTourShopImgList partTimeTourShopImgList = new PartTimeTourShopImgList();
                partTimeTourShopImgList.setImgOrVoiceUrl(urlLists.get(i));
                partTimeTourShopImgList.setTourShopId(tourId);
                partTimeTourShopImgList.setType(typeID);
                partTimeTourShopImgLists.add(partTimeTourShopImgList);
            }
            partTimeTourShopDetailEntity.setPartTimeTourShopImgList(partTimeTourShopImgLists);
        }
        String content = new Gson().toJson(partTimeTourShopDetailEntity);
        Log.d(TAG, content);
        PartTimeService.getInstance().requestSavePartTimeTourShopDetail(content, PartTimeTourShopReportDetailActivity2.this);
    }

    private void setData(PartTimeTourShopModelListEntity item) {
        List<PartTimeTourShopModelEntity> mPartTimeTourShopModelListEntity = item.getResult();
        mPartTimeTourShopReportAdapter = new PartTimeTourShopReportDetailAdapter(this, mPartTimeTourShopModelListEntity, typeID);
        publicListViewLv.setAdapter(mPartTimeTourShopReportAdapter);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.PartTime.MSG_ON_GET_PARTTIME_TOURSHOP_MODEL: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        PartTimeTourShopModelListEntity mPartTimeTourShopModelListEntity = new Gson().fromJson(msg,
                                PartTimeTourShopModelListEntity.class);
                        Log.d(TAG, "mPartTimeTourShopModelListEntity=" + mPartTimeTourShopModelListEntity.toString());
                        if (!ConstantParams.CONSTANT_PARAMS_0.equals(mPartTimeTourShopModelListEntity.retCode)) {
                            ToastUtil.show(this, mPartTimeTourShopModelListEntity.retInfo);
                        } else {
                            setData(mPartTimeTourShopModelListEntity);
                        }
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                    dismissDialog();
                }
                break;
                case BusinessID.PartTime.MSG_ON_SAVE_PARTTIME_TOURSHOP_DETAIL: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                            dismissDialog();
                            if (imgStatus.contains("失败")) {
                                showTipDialog("提示", mBaseResponse.retInfo + ",图片上传" + imgStatus);
                                return;
                            }
                            ToastUtil.show(this, result.getResultInfo());
                            this.finish();
                        }
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                    dismissDialog();
                }
                break;
                default:
                    break;
            }
        }
    }

    protected void showTipDialog(String title, final String msg) {
        if (!PrefTool.getBooleanPreferences(PartTimeTourShopReportDetailActivity2.this, Prefs.PRE_DIALOG_SHOWING, false)) {
            PublicTipDialog.Builder builder = new PublicTipDialog.Builder(this);
            builder.setMessage(msg + "\n\n确定完成上报？");
            builder.setTitle(title);
            builder.setPositiveButton("重报",
                    new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                            PrefTool.setBooleanSave(PartTimeTourShopReportDetailActivity2.this, Prefs.PRE_DIALOG_SHOWING, false);
                        }
                    });
            builder.setNegativeButton("确定",
                    new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                            PrefTool.setBooleanSave(PartTimeTourShopReportDetailActivity2.this, Prefs.PRE_DIALOG_SHOWING, false);
                            PartTimeTourShopReportDetailActivity2.this.finish();
                        }
                    });

            if (null != this) {
                builder.create().show();
                PrefTool.setBooleanSave(PartTimeTourShopReportDetailActivity2.this, Prefs.PRE_DIALOG_SHOWING, true);
                //设置对话框样式
                builder.setTitleView(Gravity.CENTER, ContextCompat.getColor(this, R.color.important_txt_color));
                builder.setMessageView(Gravity.CENTER, ContextCompat.getColor(this, R.color.important_txt_color));
                builder.setDialogConfirmBtnView(ContextCompat.getColor(this, R.color.normal_color), ContextCompat.getColor(this, R.color.white));
            }
        }
    }

    @Override
    public void setSelectDialog(int selectType, View view) {
        idImagePickerContainer = (ImagePickerLayout) view;
        setSelectDialogListeners(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //拍照处理
                takePhoto(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //相片处理
                getPictrue(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                hideSelectDialog();
            }
        });
        showSelectDialog("选择图片", null, "相机拍照", "本地相册", "取消");
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, Params.TAKE_PICTURE);
    }

    @Override
    public void toPhotoPreview(int index, ArrayList<ImageItem> mImageselectList) {
        toPhotoPreviewFragment(index, mImageselectList);//大图显示
    }
}