package com.wgmf.yxgj.module.business.parttime.ui.tourshop;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.RadioButton;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeTourShopModelEntity;

import java.util.List;
@SuppressWarnings("all")
class PartTimeTourShopReportDetailAdapter extends BaseAdapter {
    private int typeID;
    private Context context;
    private List<PartTimeTourShopModelEntity> list;

    PartTimeTourShopReportDetailAdapter(Context context, List<PartTimeTourShopModelEntity> list, int typeID) {
        this.context = context;
        this.list = list;
        this.typeID = typeID;
    }

    /**
     * 巡店上报实体
     */
    List<PartTimeTourShopModelEntity> getTourShopListEntity() {
        return list;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }


    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        TextView tourshopItemContent;
        TextView tourshopItemPoint;
        TextView tourshopItemLastpoint;
        RadioButton isokYes;
        RadioButton isokNo;
        ImageView tourshopItemImg;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        convertView = null;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.part_time_tour_shop_report_list_item, null);
            holder.tourshopItemContent = (TextView) convertView.findViewById(R.id.tourshop_item_content);
            holder.tourshopItemImg = (ImageView) convertView.findViewById(R.id.tourshop_item_img);
            holder.tourshopItemPoint = (TextView) convertView.findViewById(R.id.tourshop_item_point);
            holder.tourshopItemLastpoint = (TextView) convertView.findViewById(R.id.tourshop_item_lastpoint);
            holder.isokYes = (RadioButton) convertView.findViewById(R.id.tourshop_item_isok_yes);
            holder.isokNo = (RadioButton) convertView.findViewById(R.id.tourshop_item_isok_no);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final PartTimeTourShopModelEntity data = list.get(position);

        if (2==typeID) {
            //标题
            holder.tourshopItemContent.setText(data.getContent());
            holder.isokYes.setVisibility(View.GONE);
            holder.isokNo.setVisibility(View.GONE);
        } else {
            //标题
            holder.tourshopItemContent.setText(data.getContent());
        }
        //加载图片
        Glide.with(context).load(data.getImgUrl()).placeholder(R.drawable.img_default).error(R.drawable.img_default).into(holder.tourshopItemImg);
        //设置选项序号
        data.setPos((position + 1) + "");
        holder.isokYes.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (holder.isokYes.isChecked()) {
                    data.setIsOk(1L);
                } else {
                    data.setIsOk(0L);
                }
                radioButtonShow(holder, data);
            }
        });
        holder.isokNo.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (holder.isokNo.isChecked()) {
                    data.setIsOk(0L);
                } else {
                    data.setIsOk(1L);
                }
                radioButtonShow(holder, data);
            }
        });

        radioButtonShow(holder, data);
        return convertView;
    }

    private void radioButtonShow(ViewHolder holder, PartTimeTourShopModelEntity data) {
        if (null != data.getIsOk()) {
            if (data.getIsOk() == 1) {
                holder.isokYes.setChecked(true);
                holder.isokYes.setTextColor(context.getResources().getColor(
                        R.color.green));
                holder.isokYes.setBackgroundResource(R.drawable.btn_green_style);
                holder.isokNo
                        .setBackgroundResource(R.drawable.btn_gray_style);
                holder.isokNo.setTextColor(context.getResources().getColor(
                        R.color.important_txt_color));
            } else {
                holder.isokNo.setChecked(true);
                holder.isokNo.setTextColor(context.getResources().getColor(
                        R.color.pink));
                holder.isokNo.setBackgroundResource(R.drawable.btn_red_style);
                holder.isokYes
                        .setBackgroundResource(R.drawable.btn_gray_style);
                holder.isokYes.setTextColor(context.getResources().getColor(
                        R.color.important_txt_color));
            }
        }
    }
}