package com.wgmf.yxgj.module.bussiness.reportact.service;

import android.text.TextUtils;
import android.util.Log;

import com.google.gson.Gson;
import com.wgmf.library.base.BaseRequest;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.BaseSingleton;
import com.wgmf.yxgj.base.BaseService;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.NetworkParams;

import java.lang.ref.WeakReference;

/**
 * 作者：XiePing on 2016/5/31 16:31
 * 邮箱：2975837870@qq.com
 */
public class ActService extends BaseService {
    private static BaseSingleton<ActService, Void> mMainService = new BaseSingleton<ActService, Void>() {
        @Override
        protected ActService create(Void var1) {
            return new ActService();
        }
    };

    public static ActService getInstance() {
        return mMainService.get(null);
    }

    private ActService() {
    }

    /**
     * 特殊活动上报查询
     */
    public void requestQuerySpecialActivity(final String loginCode, final String dateTime,
                                            ResultData.BusinessCallback callback) {
        BaseRequest request = new BaseRequest();
        request.taskID = BusinessID.ActReport.MSG_ON_QUERY_SPECIAL_ACTIVITY;
        request.callback = new WeakReference<>(callback);
        request.url = NetworkParams.URL_QUERYSPECIALACTIVITY + "?"
                + "loginCode=" + loginCode + "&dateTime=" + dateTime;
        Log.d(TAG, "请求地址：" + request.url);
        sendGetRequest(request);
    }

    /**
     * POST 特殊活动上报保存
     */
    public void requestSaveSpecialActivity(final String json, ResultData.BusinessCallback callback) {
        BaseRequest request = new BaseRequest();
        request.taskID = BusinessID.ActReport.MSG_ON_SAVE_SPECIAL_ACTIVITY;
        request.callback = new WeakReference<>(callback);
        request.url = NetworkParams.URL_SAVESPECIALACTIVITY + "?";
        request.json = json;
        Log.d(TAG, "请求地址：" + request.url);
        sendPostJsonRequest(request);
    }

    /**
     * POST /newcusactitycontroller/saveNewCusActityService 新客拉新活动上报
     */
    public void requestSaveNewCusActityService(final String json, ResultData.BusinessCallback callback) {
        BaseRequest request = new BaseRequest();
        request.taskID = BusinessID.ActReport.MSG_ON_SAVE_NEWCUS_ACTITY_SERVICE;
        request.callback = new WeakReference<>(callback);
        request.url = NetworkParams.URL_SAVE_NEWCUS_ACTITY_SERVICE;
        request.json = json;
        Log.d(TAG, "请求地址：" + request.url);
        sendPostJsonRequest(request);
    }


    /**
     * GET /newcusactitycontroller/getNewCusActityType 查询新客拉新活动类型
     */
    public void requestGetNewCusActityType(final ResultData.BusinessCallback callback) {
        BaseRequest request = new BaseRequest();
        request.taskID = BusinessID.ActReport.MSG_ON_GET_NEWCUS_ACTITY_TYPE;
        request.callback = new WeakReference<>(callback);
        request.url = NetworkParams.URL_GET_NEWCUS_ACTITY_TYPE;
        Log.d(TAG, "请求地址：" + request.url);
        sendGetRequest(request);
    }

    /**
     * /newcusactitycontroller/getNewCusActitySubject 查询新客拉新活动主题
     */
    public void requestGetNewCusActitySubject(final ResultData.BusinessCallback callback) {
        BaseRequest request = new BaseRequest();
        request.taskID = BusinessID.ActReport.MSG_ON_GET_NEWCUS_ACTITY_SUBJECT;
        request.callback = new WeakReference<>(callback);
        request.url = NetworkParams.URL_GET_NEWCUS_SUBJECT;
        Log.d(TAG, "请求地址：" + request.url);
        sendGetRequest(request);
    }

    /**
     * /newcusactitycontroller/getNewCusActPromoProps 查询新客拉新活动推广道具
     */
    public void requestGetNewCusActPromoProps(final ResultData.BusinessCallback callback) {
        BaseRequest request = new BaseRequest();
        request.taskID = BusinessID.ActReport.MSG_ON_GET_NEWCUS_ACT_PROMO_PROPS;
        request.callback = new WeakReference<>(callback);
        request.url = NetworkParams.URL_GET_NEWCUS_ACT_PROMO_PROPS;
        Log.d(TAG, "请求地址：" + request.url);
        sendGetRequest(request);
    }

    @Override
    protected void onTaskDone(ResultData data) {
        if (null != data) {
            final int id = data.taskID;
            switch (id) {
                case BusinessID.ActReport.MSG_ON_QUERY_SPECIAL_ACTIVITY:
                case BusinessID.ActReport.MSG_ON_SAVE_SPECIAL_ACTIVITY:
                case BusinessID.ActReport.MSG_ON_GET_NEWCUS_ACTITY_TYPE:
                case BusinessID.ActReport.MSG_ON_GET_NEWCUS_ACT_PROMO_PROPS:
                case BusinessID.ActReport.MSG_ON_GET_NEWCUS_ACTITY_SUBJECT:
                case BusinessID.ActReport.MSG_ON_SAVE_NEWCUS_ACTITY_SERVICE: {
                    if (data.isSuccessed()) {
                        final String json = data.getInfo();
                        if (!TextUtils.isEmpty(json)) {
                            try {
                                BaseResponse mBaseResponse = new Gson().fromJson(json, BaseResponse.class);
                                Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());

                                data.setResultCode(mBaseResponse.retCode);
                                data.setResultInfo(mBaseResponse.retInfo);
                            } catch (Exception e) {
                                Log.d(TAG, "mBaseResponse:" + e);
                            }
                        }
                    }
                    break;
                }
                default:
                    break;
            }
        }
    }
}