package com.wgmf.yxgj.module.bussiness.reportact.ui;

import android.content.Intent;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.module.bussiness.reportact.R;
import com.wgmf.yxgj.module.bussiness.reportact.model.ReportActEntity;
import com.wgmf.yxgj.module.bussiness.reportact.model.ReportActUploadEntity;
import com.wgmf.yxgj.module.bussiness.reportact.model.SpecialActivityReport;
import com.wgmf.yxgj.module.bussiness.reportact.model.urlList;
import com.wgmf.yxgj.module.bussiness.reportact.service.ActService;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.xp.arouter.RouterParams;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

@Route(path = RouterParams.URL_REPORTACTDETAILACTIVITY)
public class ReportActDetailActivity extends ReportWithPhotoBaseActivity implements ReportActListPop.ReportActListPopListener, ImagePickerLayout.ImagePicker {
    private BaseCommonAdapter mAdapter;
    private ArrayList<ReportActEntity> reportActEntitys = new ArrayList<>();
    private ReportActEntity uploadReportActEntity = new ReportActEntity();
    private List<BaseSelectorEntity> baseSelectorEntitys;
    /**
     * 用来存放选中的活动内容
     */
    private BaseSelectorEntity baseSelectorEntity;
    private ReportActListPop reportActListPop;

    @Override
    protected void initData() {
        super.initData();
        //特殊活动
        reportType = "HD";
        baseSelectorEntitys = new ArrayList<>();
        baseSelectorEntity = new BaseSelectorEntity();
        baseSelectorEntity.setSelectorName("请选择门店活动");
        baseSelectorEntitys.add(baseSelectorEntity);
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText("特殊活动上报");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void initContent() {
        super.initContent();
        shopName = getIntent().getStringExtra("shopName");
        shopId = getIntent().getStringExtra("shopId");
        reportDetailTitle.setText(shopName);
        reportDetailDate.setText(DateUtil.getFormatCurrentDate("yyyy-MM-dd"));
        titleMoreLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void parseFootData() {
        super.parseFootData();
        tvSummary.setVisibility(View.VISIBLE);
        reportEdit.setVisibility(View.VISIBLE);
        publicTakePhotoLl.setVisibility(View.GONE);
        publicTakePhotoRootLl.setVisibility(View.VISIBLE);
        initPictureDisplayView();
    }

    private void initPictureDisplayView() {
        idImagePickerContainer = (ImagePickerLayout) findViewById(R.id.id_image_picker_container);
        idImagePickerContainer.setVisibility(View.VISIBLE);
        idImagePickerContainer.setTitle("特殊活动上报图片");
        idImagePickerContainer.setTip("(最多可上传4张)");
        idImagePickerContainer.setImagePicker(this);
        idImagePickerContainer.setSizePhotoNum(4);
        idImagePickerContainer.setMaxPhotoNum(4);
        idImagePickerContainer.setmImageselectList(mImageselectList);
        idImagePickerContainer.setImagePickerView(idImagePickerContainer);
        idImagePickerContainer.setOlnyViewMode(false);
    }

    @Override
    protected void setListAdapter() {
        super.setListAdapter();
        mAdapter = new BaseCommonAdapter<BaseSelectorEntity>(this, baseSelectorEntitys) {
            @Override
            public void convert(ViewHolder helper, BaseSelectorEntity item) {
                helper.setText(item.getSelectorName() + "");
            }
        };
        publicListViewLv.setAdapter(mAdapter);
        publicListViewLv.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {
                if (position == 0) {
                    showDialog();
                    if (null != userInfo) {
                        String loginCode = userInfo.getOrganizationCode();
                        String dateTime = DateUtil.getFormatCurrentDate("yyyyMMdd");
                        ActService.getInstance().requestQuerySpecialActivity(loginCode, dateTime, ReportActDetailActivity.this);
                    }
                }
            }
        });
    }

    @Override
    protected void uploadData() {
        ReportActUploadEntity mReportActUploadEntity = new ReportActUploadEntity();
        SpecialActivityReport specialActivityReport = new SpecialActivityReport();
        if (null != userInfo && null != uploadReportActEntity) {
            specialActivityReport.setAuditState("");
            specialActivityReport.setIssueId("");

            specialActivityReport.setArea(userInfo.getRegionId() + "");
            specialActivityReport.setAreaName(userInfo.getRegionName());
            specialActivityReport.setOffice(userInfo.getOfficeId() + "");
            specialActivityReport.setOfficeName(userInfo.getOfficeName());
            // 特殊活动id
            specialActivityReport.setActivityId(uploadReportActEntity.getId());
            // 特殊活动名称
            specialActivityReport.setActivityName(uploadReportActEntity.getActivityName());
            // 上报人id
            specialActivityReport.setReportUserId(userInfo.getStaffId());
            // 门店id
            specialActivityReport.setStoreId(shopId);
            // 门店名称
            specialActivityReport.setStoreName(shopName);
            // 特殊活动描述
            specialActivityReport.setReportDescribe(reportEdit.getText().toString());
            mReportActUploadEntity.setSpecialActivityReport(specialActivityReport);

            List<urlList> urlList = new ArrayList<>();
            if (null != urlLists) {
                for (int i = 0; i < urlLists.size(); i++) {
                    urlList mUrlList = new urlList();
                    mUrlList.setActivityId(uploadReportActEntity.getId());
                    mUrlList.setUrl(urlLists.get(i));
                    urlList.add(mUrlList);
                }
                mReportActUploadEntity.setUrlList(urlList);
            }

            String content = new Gson().toJson(mReportActUploadEntity);
            Log.d(TAG, content);
            showDialog();
            ActService.getInstance().requestSaveSpecialActivity(content, ReportActDetailActivity.this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.ActReport.MSG_ON_QUERY_SPECIAL_ACTIVITY: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        ReportActEntity mReportActEntity;
                        Type listType = new TypeToken<LinkedList<ReportActEntity>>() {
                        }.getType();
                        Gson gson = new Gson();
                        LinkedList<ReportActEntity> resources = gson.fromJson(msg,
                                listType);
                        for (ReportActEntity resource : resources) {
                            mReportActEntity = resource;
                            reportActEntitys.add(mReportActEntity);
                        }
                        if (reportActEntitys != null && !reportActEntitys.isEmpty()) {
                            reportActListPop = new ReportActListPop(ReportActDetailActivity.this, reportActEntitys, uploadReportActEntity, ReportActDetailActivity.this);
                            if (!reportActListPop.isShowing()) {
                                reportActListPop.show(ReportActDetailActivity.this.findViewById(R.id.title));
                            }
                        } else {
                            ToastUtil.show(this, "无此类数据！");
                        }
                    } else {
                        ToastUtil.show(this, msg);
                    }
                }
                break;
                case BusinessID.ActReport.MSG_ON_SAVE_SPECIAL_ACTIVITY: {
                    if (result.isSuccessed()) {
                        ToastUtil.show(this, getString(R.string.save_data_success));
                        ReportActDetailActivity.this.finish();
                    }
                }
                break;
                default:
                    break;
            }
        }
    }


    @Override
    public void isChecked(List<ReportActEntity> reportActEntity, int position) {
        if (position == -1) {
            ToastUtil.show(this, "未选择活动");
            uploadReportActEntity = null;
            baseSelectorEntity.setSelectorName("请选择门店活动");
            mAdapter.notifyDataSetChanged();
            return;
        }
        reportActListPop.dismiss();
        uploadReportActEntity = reportActEntity.get(position);
        baseSelectorEntity.setSelectorId(position + "");
        baseSelectorEntity.setSelectorName(uploadReportActEntity.getActivityName());
        mAdapter.notifyDataSetChanged();
    }

    @Override
    public void setSelectDialog(int selectType,View view) {
        idImagePickerContainer = (ImagePickerLayout) view;
        setSelectDialogListeners(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //拍照处理
                takePhoto(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //相片处理
                getPictrue(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                hideSelectDialog();
            }
        });
        showSelectDialog("选择图片", null, "相机拍照", "本地相册", "取消");
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, com.xp.pro.imagepickerlib.global.Params.TAKE_PICTURE);
    }

    @Override
    public void toPhotoPreview(int index, ArrayList<ImageItem> mImageselectList) {
        toPhotoPreviewFragment(index, mImageselectList);//大图显示
    }
}