package com.wgmf.yxgj.module.bussiness.reportact.ui;

import android.content.Context;
import android.content.Intent;
import android.text.Html;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.wgmf.yxgj.basewebview.ui.HtmlActivity;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.module.bussiness.reportact.R;
import com.wgmf.yxgj.module.bussiness.reportact.model.ReportActEntity;

import java.util.List;

/**
 * 作者：xiep on 2017/3/17 10:49
 * 邮箱：2975837870@qq.com
 */

public class ReportActListAdapter extends BaseAdapter {

    private Context context;
    private ReportActEntity uploadReportActEntity;
    private List<ReportActEntity> reportActEntitys;

    ReportActListAdapter(Context context, List<ReportActEntity> reportActEntitys, ReportActEntity uploadReportActEntity) {
        this.context = context;
        this.reportActEntitys = reportActEntitys;
        this.uploadReportActEntity = uploadReportActEntity;
    }

    /**
     * @return 活动上报数据
     */
    List<ReportActEntity> getUploadData() {
        return reportActEntitys;
    }

    /**
     * @return 选中位置
     */
    int getSelected() {
        return uploadReportActEntity.getSelectedActPosition();
    }

    /**
     * 设置选中位置
     */
    private void setSelected(int selected) {
        uploadReportActEntity.setSelectedActPosition(selected);
    }

    @Override
    public int getCount() {
        return reportActEntitys.size();
    }

    @Override
    public Object getItem(int position) {
        return reportActEntitys.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView,
                        ViewGroup parent) {
        if (convertView == null) {
            convertView = View.inflate(context,
                    R.layout.list_item_report_act_view,
                    null);
        }

        RelativeLayout actContentLl = (RelativeLayout) convertView
                .findViewById(R.id.act_content_rl);
        TextView reportActTv = (TextView) convertView
                .findViewById(R.id.report_act_tv);
        Button reportActDetail = (Button) convertView
                .findViewById(R.id.report_act_detail);
        ImageView reportActChoice = (ImageView) convertView
                .findViewById(R.id.report_act_choice);
        reportActTv.setText(Html.fromHtml(reportActEntitys.get(position)
                .getActivityName()));

        if (getSelected() == position) {
            // 设置为选中
            reportActChoice.setImageResource(R.drawable.circle_orange);
        } else {
            // 设置为未选中
            reportActChoice.setImageResource(R.drawable.circle_gray);
        }

        actContentLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // 点击条目前已经是选中状态，则取消
                if (getSelected() == position) {
                    setSelected(-1);
                    reportActEntitys.get(position).setSelectedActPosition(-1);
                } else {// 点击条目前已经是未选中状态，则取消
                    setSelected(position);
                    reportActEntitys.get(position).setSelectedActPosition(position);
                }
                notifyDataSetChanged();
            }
        });
        reportActDetail.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                Intent intent = new Intent();
                intent.setClass(context, HtmlActivity.class);
                String customHtml = "<p>开始时间:"
                        + reportActEntitys.get(position).getActivityStartTime()
                        + "</p><p>结束时间:"
                        + reportActEntitys.get(position).getActivityEndTime()
                        + "</p><p>活动内容:</p>"
                        + reportActEntitys.get(position).getActivityDetail();

                String branchUrl = NetworkParams.URL_SPECIAL_ACTIVITY;
                String title = "活动详情";
                String actId = reportActEntitys.get(position).getId() + "";
                intent.putExtra("branchUrl", branchUrl);
                intent.putExtra("branchTitle", title);
                intent.putExtra("act_id", actId);
                intent.putExtra("customHtml", customHtml);
                context.startActivity(intent);
            }
        });
        return convertView;
    }
}
