package com.wgmf.yxgj.module.bussiness.reportact.ui;

import android.content.Context;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.wgmf.yxgj.module.bussiness.reportact.R;
import com.wgmf.yxgj.module.bussiness.reportact.model.ReportActEntity;

import java.util.List;


/**
 * 销售预测单品销售
 * 作者：xiep on 2017/3/1 09:37
 * 邮箱：2975837870@qq.com
 */

public class ReportActListPop implements View.OnClickListener {

    private View viewParent;

    private PopupWindow shopHistorySalePw;

    private ReportActListAdapter reportActAdapter;

    private TextView reportActDialogCancelBtn;

    private TextView reportActDialogConfirmBtn;

    private ReportActListPopListener reportActListPopListener;


    public interface ReportActListPopListener {

        void isChecked(List<ReportActEntity> reportActEntity, int position);

    }

     ReportActListPop(final Context context, List<ReportActEntity> reportActEntitys, ReportActEntity reportActEntity, ReportActListPopListener reportActListPopListener) {
        this(context, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, reportActEntitys, reportActEntity, reportActListPopListener);
    }

    private ReportActListPop(final Context context, final int width, final int height, List<ReportActEntity> reportActEntitys, ReportActEntity reportActEntity, ReportActListPopListener reportActListPopListener) {
        this.reportActListPopListener = reportActListPopListener;

        LayoutInflater inflater = LayoutInflater.from(context);
        viewParent = inflater.inflate(R.layout.view_report_act_list_dialog, null);

        ListView reportActLv = (ListView) viewParent.findViewById(R.id.report_act_lv);
        TextView reportActEmptyTv = (TextView) viewParent.findViewById(R.id.report_act_empty_tv);
        reportActLv.setEmptyView(reportActEmptyTv);
        reportActDialogCancelBtn = (TextView) viewParent.findViewById(R.id.report_act_dialog_cancel_btn);
        reportActDialogConfirmBtn = (TextView) viewParent.findViewById(R.id.report_act_dialog_confirm_btn);

        reportActAdapter = new ReportActListAdapter(context, reportActEntitys, reportActEntity);
        reportActLv.setAdapter(reportActAdapter);
        shopHistorySalePw = new PopupWindow(viewParent, width, height, true);
        reportActDialogCancelBtn.setOnClickListener(this);
        reportActDialogConfirmBtn.setOnClickListener(this);
        setListViewHeight(reportActLv);
    }

    public boolean isShowing() {
        return null != shopHistorySalePw && shopHistorySalePw.isShowing();
    }

    public void show(View parent) {
        if (null == parent) {
            throw new IllegalArgumentException("StoreDateSelectorPop.showAtLocation parent is null");
        }
        viewParent = parent;
        shopHistorySalePw.showAtLocation(parent, Gravity.CENTER, 0, 0);
    }

    public void dismiss() {
        if (null != shopHistorySalePw && shopHistorySalePw.isShowing()) {
            shopHistorySalePw.dismiss();
        }
    }

    private void setListViewHeight(ListView listView) {

        ListAdapter listAdapter = listView.getAdapter();

        if (listAdapter == null) {
            return;
        }
        int totalHeight = 0;
        for (int i = 0, len = listAdapter.getCount(); i < len; i++) {
            View listItem = listAdapter.getView(i, null, listView);
            listItem.measure(0, 0);
            totalHeight += listItem.getMeasuredHeight();
        }
        ViewGroup.LayoutParams params = listView.getLayoutParams();
        params.height = totalHeight
                + (listView.getDividerHeight() * (listAdapter.getCount() - 1));
        listView.setLayoutParams(params);
    }


    @Override
    public void onClick(View view) {
        if (view == reportActDialogConfirmBtn) {
            reportActListPopListener.isChecked(reportActAdapter.getUploadData(), reportActAdapter.getSelected());
        } else if (view == reportActDialogCancelBtn) {
            dismiss();
        } else {
            dismiss();
        }
    }
}