package com.wgmf.yxgj.module.bussiness.reportact.ui;

import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.support.v4.content.ContextCompat;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.bussiness.reportact.R;
import com.wgmf.yxgj.module.bussiness.reportact.model.NewCusActityGroupSaveEntity;
import com.wgmf.yxgj.module.bussiness.reportact.model.NewCusActityImag;
import com.wgmf.yxgj.module.bussiness.reportact.model.ReportNewCusPropsEntity;
import com.wgmf.yxgj.module.bussiness.reportact.model.ReportNewCusPropsGroupEntity;
import com.wgmf.yxgj.module.bussiness.reportact.model.ReportNewCusSubjectEntity;
import com.wgmf.yxgj.module.bussiness.reportact.model.ReportNewCusSubjuectGroupEntity;
import com.wgmf.yxgj.module.bussiness.reportact.model.ReportNewCusTypeEntity;
import com.wgmf.yxgj.module.bussiness.reportact.model.ReportNewCusTypeGroupEntity;
import com.wgmf.yxgj.module.bussiness.reportact.service.ActService;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.wgmf.yxgj.utils.helper.DialogHelper;
import com.xp.arouter.RouterParams;
import com.xp.arouter.model.PCClass;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.global.Params;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Route(path = RouterParams.URL_REPORTNEWCUSDETAILACTIVITY)
public class ReportNewCusDetailActivity extends ReportWithPhotoBaseActivity implements ImagePickerLayout.ImagePicker {
    private TextView reportNewCusDateItemStartTv;
    private TextView reportNewCusDateItemEndTv;

    private ListView reportNewCusTypeLv;
    private ListView reportNewCusTopicLv;
    private ListView reportNewCusKitLv;

    private ReportNewCusTypeAdapter mReportNewCusTypeAdapter;
    private ReportNewCusSubjectAdapter mReportNewCusSubjectAdapter;
    private ReportNewCusPropsAdapter mReportNewCusPropsAdapter;

    private boolean typeFlag;
    private boolean subjectFlag;
    private boolean propsFlag;

    @Override
    protected void initData() {
        super.initData();
        //特殊活动
        reportType = "XK";
        getData();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText("新客拉新活动上报");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void initContent() {
        super.initContent();
        shopName = getIntent().getStringExtra("shopName");
        shopId = getIntent().getStringExtra("shopId");
        reportDetailTitle.setText(shopName);
        reportDetailDate.setText(DateUtil.getFormatCurrentDate("yyyy-MM-dd"));
        titleMoreLl.setVisibility(View.VISIBLE);
        publicListViewLv.setVisibility(View.GONE);
        publicListViewElv.setVisibility(View.VISIBLE);
    }

    @Override
    protected void setListHeadAndFootView() {
        View headerView = getLayoutInflater().inflate(R.layout.report_new_cus_date_item, null);
        publicListViewElv.addHeaderView(headerView);
        View footView = getLayoutInflater().inflate(R.layout.report_new_cus_footer_item, null);
        publicListViewElv.addFooterView(footView);
    }

    @Override
    protected void parseHeadData() {
        super.parseHeadData();
        final LinearLayout reportNewCusDateItemStartLl = (LinearLayout) findViewById(R.id.report_new_cus_date_item_start_ll);
        LinearLayout reportNewCusDateItemEndLl = (LinearLayout) findViewById(R.id.report_new_cus_date_item_end_ll);
        reportNewCusDateItemStartTv = (TextView) findViewById(R.id.report_new_cus_date_item_start_tv);
        reportNewCusDateItemEndTv = (TextView) findViewById(R.id.report_new_cus_date_item_end_tv);

        reportNewCusDateItemStartLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                DialogHelper.AlertDatePicker(ReportNewCusDetailActivity.this, ReportNewCusDetailActivity.this, reportNewCusDateItemStartTv);
            }
        });
        reportNewCusDateItemEndLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                DialogHelper.AlertDatePicker(ReportNewCusDetailActivity.this, ReportNewCusDetailActivity.this, reportNewCusDateItemEndTv);
            }
        });
        reportNewCusDateItemStartTv.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                String yearsMonths = reportNewCusDateItemStartTv.getText().toString();
                SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
                try {
                    // 选中的日期
                    Date date1 = formatter.parse(yearsMonths);
                    // 今天
                    Date date2 = formatter.parse(formatter.format(new Date()));
                    if (((DateUtil.daysBetween(date1, date2) > 30)) || ((DateUtil.daysBetween(date1, date2) < 0))) {
                        ToastUtil.show(ReportNewCusDetailActivity.this, "开始时间必须为前30天到当前时间的任意一天！");
                        reportNewCusDateItemStartTv.setText("");
                        return;
                    }
                } catch (Exception e) {
                    Log.e(TAG, "submitInfo: ", e);
                }
                String startYearsMonths = reportNewCusDateItemStartTv.getText().toString();
                String endYearsMonths = reportNewCusDateItemEndTv.getText().toString();
                if (!"".equals(startYearsMonths) && !"".equals(endYearsMonths)) {
                    if (endTimeCheck(startYearsMonths, endYearsMonths)) {
                        ToastUtil.show(ReportNewCusDetailActivity.this, "结束时间需大于开始时间哦！");
                        reportNewCusDateItemStartTv.setText("");
                    }
                }
            }
        });
        reportNewCusDateItemEndTv.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                String startYearsMonths = reportNewCusDateItemStartTv.getText().toString();
                String endYearsMonths = reportNewCusDateItemEndTv.getText().toString();
                if (!"".equals(startYearsMonths) && !"".equals(endYearsMonths)) {
                    if (endTimeCheck(startYearsMonths, endYearsMonths)) {
                        ToastUtil.show(ReportNewCusDetailActivity.this, "结束时间需大于开始时间哦！");
                        reportNewCusDateItemEndTv.setText("");
                    }
                }
            }
        });
    }

    @Override
    protected void parseFootData() {
        super.parseFootData();
        LinearLayout publicTakePhotoRootLl = (LinearLayout) findViewById(R.id.public_take_photo_root_ll);
        LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
        layoutParams.setMargins(0, 10, 0, 0);
        publicTakePhotoRootLl.setLayoutParams(layoutParams);
        tvSummary.setVisibility(View.GONE);
        reportEdit.setVisibility(View.GONE);
        reportContentConfirmBtn.setText(getString(R.string.submit_btn_txt));

        LinearLayout reportNewCusTypeLl = (LinearLayout) findViewById(R.id.report_new_cus_type_ll);
        LinearLayout reportNewCusTopicLl = (LinearLayout) findViewById(R.id.report_new_cus_topic_ll);
        LinearLayout reportNewCusKitLl = (LinearLayout) findViewById(R.id.report_new_cus_kit_ll);

        final TextView reportNewCusTypeTv = (TextView) findViewById(R.id.report_new_cus_type_tv);
        final TextView reportNewCusTopicTv = (TextView) findViewById(R.id.report_new_cus_topic_tv);
        final TextView reportNewCusKitTv = (TextView) findViewById(R.id.report_new_cus_kit_tv);

        reportNewCusTypeLv = (ListView) findViewById(R.id.report_new_cus_type_lv);
        reportNewCusTopicLv = (ListView) findViewById(R.id.report_new_cus_topic_lv);
        reportNewCusKitLv = (ListView) findViewById(R.id.report_new_cus_kit_lv);

        reportNewCusTypeLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!typeFlag) {
                    setListView(reportNewCusTypeTv, R.drawable.row_up, reportNewCusTypeLv, View.VISIBLE);
                } else {
                    setListView(reportNewCusTypeTv, R.drawable.row_down, reportNewCusTypeLv, View.GONE);
                }
                typeFlag = !typeFlag;
            }
        });
        reportNewCusTopicLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!subjectFlag) {
                    setListView(reportNewCusTopicTv, R.drawable.row_up, reportNewCusTopicLv, View.VISIBLE);
                } else {
                    setListView(reportNewCusTopicTv, R.drawable.row_down, reportNewCusTopicLv, View.GONE);
                }
                subjectFlag = !subjectFlag;
            }
        });
        reportNewCusKitLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!propsFlag) {
                    setListView(reportNewCusKitTv, R.drawable.row_up, reportNewCusKitLv, View.VISIBLE);
                } else {
                    setListView(reportNewCusKitTv, R.drawable.row_down, reportNewCusKitLv, View.GONE);
                }
                propsFlag = !propsFlag;
            }
        });
        publicTakePhotoLl.setVisibility(View.GONE);
        publicTakePhotoRootLl.setVisibility(View.VISIBLE);
        initPictureDisplayView();
    }

    private void initPictureDisplayView() {
        idImagePickerContainer = (ImagePickerLayout) findViewById(R.id.id_image_picker_container);
        idImagePickerContainer.setVisibility(View.VISIBLE);
        idImagePickerContainer.setTitle("新客拉新活动上报图片");
        idImagePickerContainer.setTip("(最多可上传3张)");
        idImagePickerContainer.setImagePicker(this);
        idImagePickerContainer.setSizePhotoNum(3);
        idImagePickerContainer.setMaxPhotoNum(3);
        idImagePickerContainer.setmImageselectList(mImageselectList);
        idImagePickerContainer.setImagePickerView(idImagePickerContainer);
        idImagePickerContainer.setOlnyViewMode(false);
    }

    private void setListView(TextView tv, int id, ListView lv, int visibility) {
        Drawable drawable = ContextCompat.getDrawable(ReportNewCusDetailActivity.this, id);
        //必须设置图片大小，否则不显示
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv.setCompoundDrawables(null, null, drawable, null);
        lv.setVisibility(visibility);
    }

    /**
     * 检查结束时间不得小于
     */
    private boolean endTimeCheck(String startYearsMonths, String endYearsMonths) {
        Date startYearsMonthsDate = DateUtil.string2Date(startYearsMonths, "yyyy-MM-dd");
        Date endYearsMonthsDate = DateUtil.string2Date(endYearsMonths, "yyyy-MM-dd");
        return DateUtil.daysBetween(startYearsMonthsDate, endYearsMonthsDate) < 0;
    }

    @Override
    protected void setListAdapter() {
        super.setListAdapter();
        PCClass mReportTypeResultBean = new PCClass();
        ReportNewCusDetailAdapter typeAdapter = new ReportNewCusDetailAdapter(this, mReportTypeResultBean);
        publicListViewElv.setAdapter(typeAdapter);
    }

    @Override
    protected void uploadData() {
        showDialog();
        List<ReportNewCusPropsEntity> mReportNewCusPropsEntitys;
        ReportNewCusTypeEntity mReportNewCusTypeEntity;
        ReportNewCusSubjectEntity mReportNewCusSubjectEntity;

        if (TextUtils.isEmpty(reportNewCusDateItemStartTv.getText().toString())) {
            ToastUtil.show(ReportNewCusDetailActivity.this, "请填写开始时间！");
            dismissDialog();
            return;
        }
        if (TextUtils.isEmpty(reportNewCusDateItemEndTv.getText().toString())) {
            ToastUtil.show(ReportNewCusDetailActivity.this, "请填写结束时间！");
            dismissDialog();
            return;
        }
        if (null != mReportNewCusTypeAdapter && null != mReportNewCusTypeAdapter.getUploadData() && mReportNewCusTypeAdapter.getSelected() != -1) {
            mReportNewCusTypeEntity = mReportNewCusTypeAdapter.getUploadData().get(mReportNewCusTypeAdapter.getSelected());
        } else {
            ToastUtil.show(ReportNewCusDetailActivity.this, "请选择活动类型！");
            dismissDialog();
            return;
        }
        if (null != mReportNewCusSubjectAdapter && null != mReportNewCusSubjectAdapter.getUploadData() && mReportNewCusSubjectAdapter.getSelected() != -1) {
            mReportNewCusSubjectEntity = mReportNewCusSubjectAdapter.getUploadData().get(mReportNewCusSubjectAdapter.getSelected());
        } else {
            ToastUtil.show(ReportNewCusDetailActivity.this, "请选择活动主题！");
            dismissDialog();
            return;
        }
        if (null != mReportNewCusPropsAdapter && null != mReportNewCusPropsAdapter.getUploadData() && !mReportNewCusPropsAdapter.getUploadData().isEmpty()) {
            mReportNewCusPropsEntitys = mReportNewCusPropsAdapter.getUploadData();
        } else {
            ToastUtil.show(ReportNewCusDetailActivity.this, "请选择活动道具！");
            dismissDialog();
            return;
        }
        if (urlLists == null || urlLists.size() == 0) {
            ToastUtil.show(ReportNewCusDetailActivity.this, "请选择上传图片");
            dismissDialog();
            return;
        }
        if (null != userInfo && null != mReportNewCusTypeEntity
                && null != mReportNewCusSubjectEntity && null != mReportNewCusPropsEntitys) {
            showDialog();
            NewCusActityGroupSaveEntity newCusActityGroupSaveEntity = new NewCusActityGroupSaveEntity();
            List<ReportNewCusTypeEntity> mReportNewCusTypeEntitys = new ArrayList<>();
            List<ReportNewCusSubjectEntity> mReportNewCusSubjectEntitys = new ArrayList<>();
            // 门店id
            newCusActityGroupSaveEntity.setShopId(shopId);
            // 门店名称
            newCusActityGroupSaveEntity.setShopName(shopName);
            newCusActityGroupSaveEntity.setNewCusActtyUserId(userInfo.getStaffId());
            //结束时间
            newCusActityGroupSaveEntity.setActivityEndTime(reportNewCusDateItemEndTv.getText().toString());
            //开始时间
            newCusActityGroupSaveEntity.setNewCusActivityStartTime(reportNewCusDateItemStartTv.getText().toString());
            newCusActityGroupSaveEntity.setNewCusActivityType(mReportNewCusTypeEntity.getNewCusActivityTypeId());
            newCusActityGroupSaveEntity.setNewCusActivityTypeName(mReportNewCusTypeEntity.getNewCusActivityTypeName());
            //活动类型集合
            mReportNewCusTypeEntitys.add(mReportNewCusTypeEntity);
            newCusActityGroupSaveEntity.setNewCusActityType(mReportNewCusTypeEntitys);
            //活动主题结合
            mReportNewCusSubjectEntitys.add(mReportNewCusSubjectEntity);
            newCusActityGroupSaveEntity.setNewCustActSubject(mReportNewCusSubjectEntitys);
            //活动道具集合
            newCusActityGroupSaveEntity.setNewCusActPromoProps(mReportNewCusPropsEntitys);
            //图片集合
            List<NewCusActityImag> mNewCusActityImags = new ArrayList<>();
            if (null != urlLists) {
                for (int i = 0; i < urlLists.size(); i++) {
                    NewCusActityImag mUrlList = new NewCusActityImag();
                    mUrlList.setNewCusActivityUrl(urlLists.get(i));
                    mNewCusActityImags.add(mUrlList);
                }
                newCusActityGroupSaveEntity.setNewCusActityImag(mNewCusActityImags);
            }
            String content = new Gson().toJson(newCusActityGroupSaveEntity);
            Log.d(TAG, content);
            showDialog();
            ActService.getInstance().requestSaveNewCusActityService(content, ReportNewCusDetailActivity.this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.ActReport.MSG_ON_GET_NEWCUS_ACTITY_TYPE: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        ReportNewCusTypeGroupEntity reportNewCusGroupEntity = new Gson().fromJson(msg, ReportNewCusTypeGroupEntity.class);
                        if (null != reportNewCusGroupEntity && null != reportNewCusGroupEntity.getResultList()) {
                            List<ReportNewCusTypeEntity> reportNewCusTypeEntitys = reportNewCusGroupEntity.getResultList();
                            mReportNewCusTypeAdapter = new ReportNewCusTypeAdapter(this, reportNewCusTypeEntitys);
                            reportNewCusTypeLv.setAdapter(mReportNewCusTypeAdapter);
                            ListViewUtil.setListViewHeight(reportNewCusTypeLv);
                        } else {
                            ToastUtil.show(ReportNewCusDetailActivity.this, "无此类数据！");
                        }
                    } else {
                        if (!TextUtils.isEmpty(msg)) {
                            ToastUtil.show(ReportNewCusDetailActivity.this, msg);
                        }
                    }
                }
                break;
                case BusinessID.ActReport.MSG_ON_GET_NEWCUS_ACTITY_SUBJECT: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        ReportNewCusSubjuectGroupEntity reportNewCusSubjectEntity = new Gson().fromJson(msg, ReportNewCusSubjuectGroupEntity.class);
                        if (null != reportNewCusSubjectEntity && null != reportNewCusSubjectEntity.getResultList()) {
                            List<ReportNewCusSubjectEntity> reportNewCusSubjectEntities = reportNewCusSubjectEntity.getResultList();
                            mReportNewCusSubjectAdapter = new ReportNewCusSubjectAdapter(this, reportNewCusSubjectEntities);
                            reportNewCusTopicLv.setAdapter(mReportNewCusSubjectAdapter);
                            ListViewUtil.setListViewHeight(reportNewCusTopicLv);
                        } else {
                            ToastUtil.show(ReportNewCusDetailActivity.this, "无此类数据！");
                        }
                    } else {
                        if (!TextUtils.isEmpty(msg)) {
                            ToastUtil.show(ReportNewCusDetailActivity.this, msg);
                        }
                    }
                }
                break;
                case BusinessID.ActReport.MSG_ON_GET_NEWCUS_ACT_PROMO_PROPS: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        ReportNewCusPropsGroupEntity reportNewCusPropsGroupEntity = new Gson().fromJson(msg, ReportNewCusPropsGroupEntity.class);
                        if (null != reportNewCusPropsGroupEntity && null != reportNewCusPropsGroupEntity.getResultList()) {
                            List<ReportNewCusPropsEntity> reportNewCusPropsEntitys = reportNewCusPropsGroupEntity.getResultList();
                            mReportNewCusPropsAdapter = new ReportNewCusPropsAdapter(this, reportNewCusPropsEntitys);
                            reportNewCusKitLv.setAdapter(mReportNewCusPropsAdapter);
                            ListViewUtil.setListViewHeight(reportNewCusKitLv);
                        } else {
                            ToastUtil.show(ReportNewCusDetailActivity.this, "无此类数据！");
                        }
                    } else {
                        if (!TextUtils.isEmpty(msg)) {
                            ToastUtil.show(ReportNewCusDetailActivity.this, msg);
                        }
                    }
                }
                break;
                case BusinessID.ActReport.MSG_ON_SAVE_NEWCUS_ACTITY_SERVICE: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                            ReportNewCusDetailActivity.this.finish();
                        }
                        ToastUtil.show(ReportNewCusDetailActivity.this, mBaseResponse.retInfo);
                    } else {
                        ToastUtil.show(ReportNewCusDetailActivity.this, result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    /**
     * 获取活动数据
     */
    public void getData() {
        //1，获取活动类型
        ActService.getInstance().requestGetNewCusActityType(this);
        //2，获取活动主题
        ActService.getInstance().requestGetNewCusActitySubject(this);
        //3，获取活动推广道具
        ActService.getInstance().requestGetNewCusActPromoProps(this);
    }

    @Override
    public void setSelectDialog(int selectType,View view) {
        idImagePickerContainer = (ImagePickerLayout) view;
        setSelectDialogListeners(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //拍照处理
                takePhoto(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //相片处理
                getPictrue(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                hideSelectDialog();
            }
        });
        showSelectDialog("选择图片", null, "相机拍照", "本地相册", "取消");
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, Params.TAKE_PICTURE);
    }

    @Override
    public void toPhotoPreview(int index, ArrayList<ImageItem> mImageselectList) {
        toPhotoPreviewFragment(index, mImageselectList);//大图显示
    }
}