package com.wgmf.yxgj.module.bussiness.reportact.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.CheckBox;
import android.widget.RadioButton;
import android.widget.TextView;

import com.xp.arouter.model.PCClass;
import com.wgmf.yxgj.module.bussiness.reportact.R;

/**
 * 作者：xiep on 2017/12/13 14:24
 * 邮箱：2975837870@qq.com
 */

public class ReportNewCusDetailAdapter extends BaseExpandableListAdapter {

    private Context context;
    private PCClass mReportTypeResultBean;

    ReportNewCusDetailAdapter(Context context, PCClass mReportTypeResultBean) {
        this.context = context;
        this.mReportTypeResultBean = mReportTypeResultBean;
    }

    @Override
    public int getGroupCount() {
        return mReportTypeResultBean.getResultList() != null ? mReportTypeResultBean.getResultList().size() : 0;
    }

    @Override
    public int getChildrenCount(int i) {
        return mReportTypeResultBean.getResultList().get(i).getResultList() != null ? mReportTypeResultBean.getResultList().get(i).getResultList().size() : 0;
    }

    @Override
    public Object getGroup(int i) {
        return mReportTypeResultBean.getResultList();
    }

    @Override
    public Object getChild(int i, int i1) {
        return mReportTypeResultBean.getResultList().get(i).getResultList();
    }

    @Override
    public long getGroupId(int i) {
        return i;
    }

    @Override
    public long getChildId(int i, int i1) {
        return i1;
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public View getGroupView(int i, boolean b, View convertView, ViewGroup viewGroup) {
        final GroupViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.report_new_cus_group_item, null);
            viewHolder = new GroupViewHolder();
            viewHolder.groupName = (TextView) convertView.findViewById(R.id.group_name);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (GroupViewHolder) convertView.getTag();
        }
        viewHolder.groupName.setText(mReportTypeResultBean.getResultList().get(i).getName());
        return convertView;
    }

    @Override
    public View getChildView(int groupPosition, int childPosition, boolean b, View convertView, ViewGroup viewGroup) {
        final ChildViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.report_new_cus_child_item, null);
            viewHolder = new ChildViewHolder();
            viewHolder.childName1 = (RadioButton) convertView.findViewById(R.id.child_name_1);
            viewHolder.childName2 = (CheckBox) convertView.findViewById(R.id.child_name_2);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ChildViewHolder) convertView.getTag();
        }
        //单选
        viewHolder.childName1.setText(mReportTypeResultBean.getResultList().get(groupPosition).getResultList().get(childPosition).getName());
        //多选
        viewHolder.childName2.setText(mReportTypeResultBean.getResultList().get(groupPosition).getResultList().get(childPosition).getName());
        return convertView;
    }

    @Override
    public boolean isChildSelectable(int i, int i1) {
        return true;
    }

    class GroupViewHolder {
        TextView groupName;
    }

    class ChildViewHolder {
        RadioButton childName1;
        CheckBox childName2;
    }
}