package com.wgmf.yxgj.module.bussiness.reportact.ui;

import android.content.Context;
import android.text.Html;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.bussiness.reportact.R;
import com.wgmf.yxgj.module.bussiness.reportact.model.ReportNewCusTypeEntity;

import java.util.List;

/**
 * 作者：xiep on 2017/3/17 10:49
 * 邮箱：2975837870@qq.com
 */

public class ReportNewCusTypeAdapter extends BaseAdapter {
    private Context context;
    private ReportNewCusTypeEntity reportNewCusEntity;
    private List<ReportNewCusTypeEntity> reportNewCusEntitys;

    /**
     * @return 活动上报数据
     */
    public List<ReportNewCusTypeEntity> getUploadData() {
        return reportNewCusEntitys;
    }

    /**
     * @return 选中位置
     */
    public int getSelected() {
        return reportNewCusEntity.getSelectedActPosition();
    }

    /**
     * 设置选中位置
     */
    void setSelected(int selected) {
        reportNewCusEntity.setSelectedActPosition(selected);
    }

    public ReportNewCusTypeAdapter(Context context, List<ReportNewCusTypeEntity> reportNewCusEntitys) {
        this.context = context;
        this.reportNewCusEntitys = reportNewCusEntitys;
        reportNewCusEntity = new ReportNewCusTypeEntity();
    }

    @Override
    public int getCount() {
        return reportNewCusEntitys.size();
    }

    @Override
    public Object getItem(int position) {
        return reportNewCusEntitys.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        if (convertView == null) {
            convertView = View.inflate(context, R.layout.list_item_report_act_view, null);
        }

        RelativeLayout actContentLl = (RelativeLayout) convertView
                .findViewById(R.id.act_content_rl);
        TextView reportActTv = (TextView) convertView
                .findViewById(R.id.report_act_tv);
        Button reportActDetail = (Button) convertView
                .findViewById(R.id.report_act_detail);
        ImageView reportActChoice = (ImageView) convertView
                .findViewById(R.id.report_act_choice);
        reportActTv.setText(Html.fromHtml(reportNewCusEntitys.get(position)
                .getNewCusActivityTypeName()));
        // 设置为选中
        if (getSelected() == position) {
            reportActChoice.setImageResource(R.drawable.circle_orange);
        } else {
            // 设置为未选中
            reportActChoice.setImageResource(R.drawable.circle_gray);
        }

        actContentLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // 点击条目前已经是选中状态，则取消
                if (getSelected() == position) {
                    setSelected(-1);
                    reportNewCusEntitys.get(position).setSelectedActPosition(-1);
                } else {
                    // 点击条目前已经是未选中状态，则取消
                    setSelected(position);
                    reportNewCusEntitys.get(position).setSelectedActPosition(position);
                }
                notifyDataSetChanged();
            }
        });
        reportActDetail.setVisibility(View.GONE);
        return convertView;
    }
}