package com.wgmf.yxgj.module.business.reportbigdata.ui;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.reportbigdata.R;
import com.wgmf.yxgj.module.business.reportbigdata.model.SupermarketBigDataReport;
import com.wgmf.yxgj.module.business.reportbigdata.model.SupermarketBigDataReportList;
import com.wgmf.yxgj.module.business.reportbigdata.service.BigDataManagerService;
import com.wgmf.yxgj.pop.PublicSelectPop;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;

import java.util.ArrayList;
import java.util.List;

/**
 * 客户拜访查询
 * 作者：xiep on 2017/7/26 10:29
 * 邮箱：2975837870@qq.com
 */

public class BigDataQueryActivity extends BaseParentAct implements PublicSelectPop.ReportQuerySelectPopListener, View.OnClickListener {

    TextView bigDataQueryHeaderLeftTv;
    TextView bigDataQueryHeaderRightTv;
    ListView bigDataQueryContentLv;
    BigDataQueryAdapter mCustomerVisitQueryAdapter;
    List<SupermarketBigDataReport> mCustomerVisitEntitys;
    PublicSelectPop customerVisitSelectPop2;

    private List<BaseSelectorEntity> dataRanges = new ArrayList<>();
    /**
     * dataRangeId (string, optional): 数据范围id:生鲜区/'1'；果蔬区/'2';生鲜+果蔬/'3'；熟食区/'4'；整个门店/'5' ,
     */
    private String[] dataRange = new String[]{"生鲜区", "果蔬区", "生鲜区+果蔬区", "熟食区", "整个门店"};


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.big_data_query_activity);
        initTitle();
        initContent();
        getData(ConstantParams.CONSTANT_PARAMS_5);
    }

    private void initContent() {
        bigDataQueryHeaderLeftTv = (TextView) findViewById(R.id.big_data_query_header_left_tv);
        bigDataQueryHeaderRightTv = (TextView) findViewById(R.id.big_data_query_header_right_tv);
        bigDataQueryHeaderRightTv.setText("整个门店");
        bigDataQueryHeaderRightTv.setOnClickListener(this);
        bigDataQueryContentLv = (ListView) findViewById(R.id.public_list_view_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        bigDataQueryContentLv.setEmptyView(emptyView);
        mCustomerVisitEntitys = new ArrayList<>();
        mCustomerVisitQueryAdapter = new BigDataQueryAdapter(mCustomerVisitEntitys, this);
        bigDataQueryContentLv.setAdapter(mCustomerVisitQueryAdapter);
    }

    List<BaseSelectorEntity> getDataRange() {
        for (int i = 0; i < dataRange.length; i++) {
            BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
            mBaseSelectorEntity.setSelectorName(dataRange[i]);
            mBaseSelectorEntity.setSelectorId(i + 1 + "");
            dataRanges.add(mBaseSelectorEntity);
        }
        return dataRanges;
    }

    private void getData(String dataRangeId) {
        if (null != userInfo) {
            mCustomerVisitEntitys.clear();
            mCustomerVisitQueryAdapter.notifyDataSetChanged();
            showDialog();
            String orgId = userInfo.getOrganizationId();
            BigDataManagerService.getInstance().requestGetSupermarketBigDataReport(dataRangeId, orgId, this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("商超大数据查询");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.BigDataReport.MSG_ON_GET_SUPERMARKET_BIGDATA_REPORT) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    SupermarketBigDataReportList mCustomerVisitList = new Gson().fromJson(msg, SupermarketBigDataReportList.class);
                    Log.d(TAG, "mCustomerVisitList=" + mCustomerVisitList.toString());
                    if (mCustomerVisitList.getResultList() != null && !mCustomerVisitList.getResultList().isEmpty()) {
                        mCustomerVisitEntitys = mCustomerVisitList.getResultList();
                        mCustomerVisitQueryAdapter = new BigDataQueryAdapter(mCustomerVisitEntitys, this);
                        bigDataQueryContentLv.setAdapter(mCustomerVisitQueryAdapter);
                        ListViewUtil.setListViewHeight(bigDataQueryContentLv);
                    }
                }
            }
        }
    }

    @Override
    public void onAdapterItemClick(int position, List<BaseSelectorEntity> reportQuerys) {
        //数据范围
        getData(reportQuerys.get(position).getSelectorId());
        bigDataQueryHeaderRightTv.setText(reportQuerys.get(position).getSelectorName());
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.big_data_query_header_right_tv) {
            if (null == customerVisitSelectPop2) {
                customerVisitSelectPop2 = new PublicSelectPop(BigDataQueryActivity.this, BigDataQueryActivity.this, getDataRange());
            }
            if (!customerVisitSelectPop2.isShowing()) {
                customerVisitSelectPop2.show(this.findViewById(R.id.title));
            }
        }
    }
}