package com.wgmf.yxgj.module.business.reportbigdata.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;

import com.wgmf.library.utils.CastingNumbers;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.module.business.reportbigdata.R;
import com.wgmf.yxgj.module.business.reportbigdata.model.SupermarketBigDataReport;
import com.wgmf.yxgj.widgets.TextView.MarqueeTextView;

import java.util.List;

/**
 * 作者：xiep on 2017/7/21 13:49
 * 邮箱：2975837870@qq.com
 */

class BigDataQueryAdapter extends BaseAdapter {

    private Context context;
    private List<SupermarketBigDataReport> mCustomerVisitEntity;


    BigDataQueryAdapter(List<SupermarketBigDataReport> mlist, Context context) {
        this.mCustomerVisitEntity = mlist;
        this.context = context;
    }

    @Override
    public int getCount() {
        return mCustomerVisitEntity == null ? 0 : mCustomerVisitEntity.size();
    }

    @Override
    public Object getItem(int position) {
        return mCustomerVisitEntity == null ? null : mCustomerVisitEntity.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.big_data_query_content_list_item, null);
            viewHolder = new ViewHolder();
            viewHolder.storeName = (MarqueeTextView) convertView.findViewById(R.id.big_data_query_content_store_name);
            viewHolder.annualSale = (MarqueeTextView) convertView.findViewById(R.id.big_data_query_content_annual_sale);
            viewHolder.annualVolume = (MarqueeTextView) convertView.findViewById(R.id.big_data_query_content_annual_volume);
            viewHolder.annualRadio = (MarqueeTextView) convertView.findViewById(R.id.big_data_query_content_annual_radio);
            viewHolder.areaVolume = (MarqueeTextView) convertView.findViewById(R.id.big_data_query_content_area_volume);
            viewHolder.areaRadio = (MarqueeTextView) convertView.findViewById(R.id.big_data_query_content_area_radio);
            viewHolder.diffRate = (MarqueeTextView) convertView.findViewById(R.id.big_data_query_content_diff_rate);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        SupermarketBigDataReport ent = mCustomerVisitEntity.get(position);
        viewHolder.storeName.setText(ent.getOrgName());
        viewHolder.annualRadio.setText(ent.getYearAmountRate());
        viewHolder.areaRadio.setText(ent.getOrgAmountRate());
        viewHolder.diffRate.setText(ent.getDiffRate());

        if (!StringUtil.isNullOrEmpty(ent.getCompanySaleAmount() + "")&&ent.getCompanySaleAmount() !=0) {
            viewHolder.annualSale.setText(StringUtil.formatDouble(CastingNumbers.doRound(ent.getCompanySaleAmount(), 4)/10000, "#.####"));
        }
        if (!StringUtil.isNullOrEmpty(ent.getMarketSaleAmount() + "")&&ent.getMarketSaleAmount() !=0) {
            viewHolder.annualVolume.setText(StringUtil.formatDouble(CastingNumbers.doRound(ent.getMarketSaleAmount(),4)/10000, "#.####"));
        }
        if (!StringUtil.isNullOrEmpty(ent.getOrgSaleAmount() + "")&&ent.getOrgSaleAmount() !=0) {
            viewHolder.areaVolume.setText(StringUtil.formatDouble(CastingNumbers.doRound(ent.getOrgSaleAmount(),4)/10000, "#.####"));
        }
        return convertView;
    }

    class ViewHolder {
        MarqueeTextView storeName;
        MarqueeTextView annualSale;
        MarqueeTextView annualVolume;
        MarqueeTextView annualRadio;
        MarqueeTextView areaVolume;
        MarqueeTextView areaRadio;
        MarqueeTextView diffRate;
    }
}