package com.wgmf.yxgj.module.business.reportbigdata.ui;

import android.content.Intent;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.reportbigdata.model.SupermarketBigDataShop;
import com.wgmf.yxgj.module.business.reportbigdata.model.SupermarketBigDataShopList;
import com.wgmf.yxgj.module.business.reportbigdata.service.BigDataManagerService;
import com.wgmf.yxgj.module.business.reportbigdata.ui.bigData.BigDataActivity;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.xp.arouter.RouterParams;

import java.util.List;

/**
 * 商超大数据上报
 * 作者：xiep on 2017/7/26 10:29
 * 邮箱：2975837870@qq.com
 */
@Route(path = RouterParams.URL_BIGDATAMANAGERACTIVITY)
public class BigDataShopListActivity extends SelectorBaseActivity {

    List<SupermarketBigDataShop> mSupermarketBigDataShopLists;

    @Override
    protected void onResume() {
        super.onResume();
        getShopData();
    }

    private void getShopData() {
        if (null != userInfo) {
            showDialog();
            //清空数据，保证每次显示的都是接口返回的数据
            listShow.clear();
            String staffId = userInfo.getStaffId();
            String orgId = userInfo.getOrganizationId();
            BigDataManagerService.getInstance().requestGetSupermarketBigDataShop(staffId, orgId, this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("商超大数据");
    }

    @Override
    protected void initContent() {
        super.initContent();
        storeNameEt.setVisibility(View.GONE);
        mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Intent intent = new Intent(BigDataShopListActivity.this, BigDataActivity.class);
                intent.putExtra("storeNo", mSupermarketBigDataShopLists.get(position).getShop().getShopId());
                intent.putExtra("storeName", mSupermarketBigDataShopLists.get(position).getShop().getShopName());
                intent.putExtra("supermarketBigDataFlag", mSupermarketBigDataShopLists.get(position).getSupermarketBigDataFlag());
                startActivity(intent);
            }
        });
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.BigDataReport.MSG_ON_GET_SUPERMARKET_BIGDATA_SHOP: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        SupermarketBigDataShopList mSupermarketBigDataShopList = new Gson().fromJson(msg, SupermarketBigDataShopList.class);
                        Log.d(TAG, "mSupermarketBigDataShopList=" + mSupermarketBigDataShopList.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mSupermarketBigDataShopList.retCode)) {
                            if (mSupermarketBigDataShopList.getResultList() != null && !mSupermarketBigDataShopList.getResultList().isEmpty()) {
                                mSupermarketBigDataShopLists = mSupermarketBigDataShopList.getResultList();
                                BigDataShopListAdapter adapter = new BigDataShopListAdapter(mSupermarketBigDataShopLists, this);
                                mListView.setAdapter(adapter);
                            }
                        } else {
                            showMsg(mSupermarketBigDataShopList.retInfo);
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }
}