package com.wgmf.yxgj.module.business.reportbigdata.ui;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.reportbigdata.R;
import com.wgmf.yxgj.module.business.reportbigdata.model.SupermarketBigDataShop;

import java.util.List;

/**
 * 作者：xiep on 2017/11/14 15:00
 * 邮箱：2975837870@qq.com
 */

public class BigDataShopListAdapter extends BaseAdapter {

    private List<SupermarketBigDataShop> list;
    private Context context;

    BigDataShopListAdapter(List<SupermarketBigDataShop> mlist, Context context) {
        this.list = mlist;
        this.context = context;
    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.big_data_shop_list_item, null);
            viewHolder = new ViewHolder();
            viewHolder.name = (TextView) convertView.findViewById(R.id.big_data_shop_name);
            viewHolder.status = (TextView) convertView.findViewById(R.id.big_data_shop_status);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        SupermarketBigDataShop ent = list.get(position);
        viewHolder.name.setText(ent.getShop().getShopName());

        if (ConstantParams.CONSTANT_PARAMS_2.equals(ent.getSupermarketBigDataFlag())) {
            viewHolder.status.setText("未提交");
            viewHolder.status.setTextColor(ContextCompat.getColor(context, R.color.red));
        } else if (ConstantParams.CONSTANT_PARAMS_1.equals(ent.getSupermarketBigDataFlag())) {
            viewHolder.status.setText("已提交");
            viewHolder.status.setTextColor(ContextCompat.getColor(context, R.color.dark_gray));
        }
        return convertView;
    }

    class ViewHolder {
        TextView name;
        TextView status;
    }
}