package com.wgmf.yxgj.module.business.reportbigdata.ui.bigData;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.github.yoojia.inputs.ValueScheme;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.CastingNumbers;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.module.business.reportbigdata.R;
import com.wgmf.yxgj.module.business.reportbigdata.graph.BigDataModule;
import com.wgmf.yxgj.module.business.reportbigdata.graph.DaggerBigDataComponent;
import com.wgmf.yxgj.module.business.reportbigdata.model.SupermarketBigData;
import com.wgmf.yxgj.module.business.reportbigdata.service.BigDataManagerService;
import com.wgmf.yxgj.module.business.reportbigdata.ui.BigDataQueryActivity;
import com.wgmf.yxgj.pop.PublicSelectPop;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.widgets.MMessageDisplay;

import java.util.List;

import javax.inject.Inject;

/**
 * 客户拜访
 * 作者：xiep on 2017/7/26 10:29
 * 邮箱：2975837870@qq.com
 */

public class BigDataActivity extends BaseParentAct implements BigDataView, PublicSelectPop.ReportQuerySelectPopListener, View.OnClickListener {

    TextView bigDataTypeTv;
    TextView bigDataRangeTv;
    EditText bigDataValueEdt;

    Button reportContentComfirmBtn;
    LinearLayout reportContentComfirmLl;

    PublicSelectPop customerVisitSelectPop1;
    PublicSelectPop customerVisitSelectPop2;
    /**
     * 1,商超系统 2,职位类型
     */
    int popType;
    String storeNo;
    String storeName;

    SupermarketBigData mSupermarketBigDatas = new SupermarketBigData();

    @Inject
    BigDataPresenter customerVisitPresenter;

    @Override
    protected void more() {
        super.more();
        Intent intent = new Intent();
        intent.setClass(this, BigDataQueryActivity.class);
        startActivity(intent);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.big_data_activity);
        initTitle();
        initContent();
        initInjector();
    }

    private void initInjector() {
        DaggerBigDataComponent.builder()
                .bigDataModule(new BigDataModule(this))
                .build()
                .inject(this);
    }

    private void initContent() {
        reportContentComfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        reportContentComfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        bigDataTypeTv = (TextView) findViewById(R.id.big_data_type_tv);
        bigDataRangeTv = (TextView) findViewById(R.id.big_data_range_tv);
        bigDataValueEdt = (EditText) findViewById(R.id.big_data_value_edt);

        reportContentComfirmLl.setVisibility(View.VISIBLE);
        reportContentComfirmBtn.setText(R.string.submit_btn_txt);
        reportContentComfirmBtn.setOnClickListener(this);
        bigDataTypeTv.setOnClickListener(this);
        bigDataRangeTv.setOnClickListener(this);
        // 默认不弹出软键盘
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);

        storeNo = getIntent().getStringExtra("storeNo");
        storeName = getIntent().getStringExtra("storeName");

        String supermarketBigDataFlag = getIntent().getStringExtra("supermarketBigDataFlag");
        if ("1".equals(supermarketBigDataFlag)) {
            reportContentComfirmBtn.setText(R.string.update_btn_txt);
            //查询提交数据
            BigDataManagerService.getInstance().requestFindStoreSupermarketBigData(storeNo, this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("商超大数据提交");
        homeTitleMore.setText("结果");
        homeTitleMoreLl.setVisibility(View.VISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        customerVisitPresenter.switchService(result);
    }

    @Override
    public void onAdapterItemClick(int position, List<BaseSelectorEntity> reportQuerys) {
        if (popType == 1) {
            //数据类型
            mSupermarketBigDatas.setDataTypeId(reportQuerys.get(position).getSelectorId());
            mSupermarketBigDatas.setDataType(reportQuerys.get(position).getSelectorName());
            bigDataTypeTv.setText(reportQuerys.get(position).getSelectorName());
        } else if (popType == 2) {
            //数据范围
            mSupermarketBigDatas.setDataRangeId(reportQuerys.get(position).getSelectorId());
            mSupermarketBigDatas.setDataRange(reportQuerys.get(position).getSelectorName());
            bigDataRangeTv.setText(reportQuerys.get(position).getSelectorName());
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.big_data_type_tv) {
            //数据类型
            popType = 1;
            if (null == customerVisitSelectPop1) {
                customerVisitSelectPop1 = new PublicSelectPop(this, this, customerVisitPresenter.getDataType());
            }
            if (!customerVisitSelectPop1.isShowing()) {
                customerVisitSelectPop1.show(this.findViewById(R.id.title));
            }
        } else if (v.getId() == R.id.big_data_range_tv) {
            //数据范围
            popType = 2;
            if (null == customerVisitSelectPop2) {
                customerVisitSelectPop2 = new PublicSelectPop(this, this, customerVisitPresenter.getDataRange());
            }
            if (!customerVisitSelectPop2.isShowing()) {
                customerVisitSelectPop2.show(this.findViewById(R.id.title));
            }
        } else if (v.getId() == R.id.report_content_confirm_btn) {
            if (checkUploadData()) {
                uploadData();
            }
        }
    }

    private void uploadData() {
        showDialog();
        if (null != userInfo) {
            mSupermarketBigDatas.setSuppermarketSubmitId(userInfo.getStaffId());
        }
        mSupermarketBigDatas.setSupermarketDataShopId(storeNo);
        mSupermarketBigDatas.setSupermarketDataShopName(storeName);
        mSupermarketBigDatas.setDataValue(StringUtil.toDouble(bigDataValueEdt.getText().toString()));
        customerVisitPresenter.uploadData(mSupermarketBigDatas);
    }

    private boolean checkUploadData() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        inputs.add(bigDataTypeTv, StaticScheme.Required(), ValueScheme.NotEquals(getString(R.string.empty_etb_hint_select_txt)).msgOnFail("未选择数据类型"));
        inputs.add(bigDataRangeTv, StaticScheme.Required(), ValueScheme.NotEquals(getString(R.string.empty_etb_hint_select_txt)).msgOnFail("未选择数据范围"));
        inputs.add(bigDataValueEdt, StaticScheme.Required());

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            showMsg("填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    @Override
    public void findStore(SupermarketBigData mSupermarketBigData) {
        bigDataTypeTv.setText(mSupermarketBigData.getDataType());
        bigDataRangeTv.setText(mSupermarketBigData.getDataRange());
        if (!StringUtil.isNullOrEmpty(mSupermarketBigData.getDataValue() + "") && mSupermarketBigData.getDataValue() != 0) {
            bigDataValueEdt.setText(StringUtil.formatDouble(CastingNumbers.doRound(mSupermarketBigData.getDataValue(), 4) / 10000, "#.####"));
        }

        bigDataValueEdt.setSelection(bigDataValueEdt.getText().length());

        mSupermarketBigDatas.setSupermarketDataShopId(storeNo);
        mSupermarketBigDatas.setSupermarketDataShopName(storeName);
        mSupermarketBigDatas.setDataValue(mSupermarketBigData.getDataValue());
        mSupermarketBigDatas.setDataRange(mSupermarketBigData.getDataRange());
        mSupermarketBigDatas.setDataRangeId(mSupermarketBigData.getDataRangeId());
        mSupermarketBigDatas.setDataType(mSupermarketBigData.getDataType());
        mSupermarketBigDatas.setDataTypeId(mSupermarketBigData.getDataTypeId());
    }

    @Override
    public void saveSuccessed(String mag) {
        showMsg(mag);
        this.finish();
    }
}