package com.wgmf.yxgj.module.bussiness.reporthome.model

import android.widget.TextView
import com.wgmf.library.base.BaseResponse
import com.wgmf.library.utils.ThreadManager


/**
 * 到家业务任务详情查询
 *
ReturnInfo«GohomeInfoDetail» {
msgCode (integer, optional): 0 操作成功，1 操作失败 ,
msgContent (string, optional): 操作错误信息提示 ,
result (GohomeInfoDetail, optional): 返回的数据对象 ,
resultList (Array[GohomeInfoDetail], optional): 返回的数据集合 ,
sysCode (integer, optional): 0 系统正常，1系统异常 ,
sysContent (string, optional): 服务器异常错误信息提示
}
GohomeInfoDetail {
auditStatus (integer, optional): 审核（0：未审核，1：合格，2：不合格） ,
ema (GohomeAudit, optional): 审核记录 ,
ems (GohomeShopDetail, optional): 提交记录 ,
status (integer, optional): 状态（0：未提交，1：已提交）
}
GohomeAudit {
auditResult (string, optional): 审核结果 ,
auditStatus (string, optional): 审核情况 ,
exceptionSpecification (string, optional): 异常说明 ,
list (Array[ProductInfo], optional): 上架产品明细 ,
photos (Array[string], optional): 提交照片 ,
remark (string, optional): 审核备注 ,
reportId (string, optional): 提交id ,
reportTime (string, optional): 提交时间 ,
shopId (string, optional): 门店id ,
shopName (string, optional): 门店名称
}
GohomeShopDetail {
exceptionSpecification (string, optional): 异常说明 ,
list (Array[ProductInfo], optional): 上架产品明细 ,
photos (Array[string], optional): 提交照片 ,
reportId (string, optional): 提交id ,
reportTime (string, optional): 提交时间 ,
reporterId (string, optional): 提交工号 ,
reporterName (string, optional): 提交人姓名 ,
shopId (string, optional): 门店id ,
shopName (string, optional): 门店名称 ,
taskId (string, optional): 任务id
}
ProductInfo {
productName (string, optional): 产品名称 ,
productNo (string, optional): 产品编码
}
}
 */

data class HomeBusinessDetailEntity(val result: HomeBusinessDetail?) : BaseResponse() {
    data class HomeBusinessDetail(
        var auditStatus: Int,
        var ema: Ema?,
        var ems: Ems?,
        var remark: String,
        var status: Int
    ) {

        data class Ema(
            var auditResult: String?,
            var auditStatus: String?,
            var exceptionSpecification: String?,
            var list: List<Product>?,
            var photos: List<String>?,
            var remark: String?,
            var reportId: String,
            var reportTime: String?,
            var shopId: String?,
            var shopName: String?,
            var course: String,
            var courseDetail: String
        ) {

            /**
             * 格式化产品数据
             */
            fun getProductFormatStr(view: TextView) {
                ThreadManager.runOnThread {
                    var productStr = ""
                    list?.let {
                        it.forEachIndexed { index, product ->
                            productStr += "${product.productName}（${product.productNo}）"
                            if (index < it.size - 1) {
                                productStr += "\n"
                            }
                        }
                    }

                    view.post {
                        view.text = productStr
                    }
                }
            }
        }

        data class Ems(
            var exceptionSpecification: String?,
            var list: List<Product>?,
            var photos: List<String>?,
            var reportId: String,
            var reportTime: String,
            var reporterId: String,
            var reporterName: String,
            var shopId: String?,
            var shopName: String?,
            var course: String,
            var courseDetail: String,
            var taskId: String
        ) {
            /**
             * 格式化产品数据
             */
            fun getProductFormatStr(view: TextView) {
                ThreadManager.runOnThread {
                    var productStr = ""
                    list?.let {
                        it.forEach {
                            productStr += "${it.productName}（${it.productNo}）\n"
                        }
                    }

                    view.post {
                        view.text = productStr
                    }
                }
            }
        }

        data class Product(
            var productName: String,
            var productNo: String
        )
    }
}
