package com.wgmf.yxgj.module.bussiness.reporthome.model

import com.chad.library.adapter.base.entity.AbstractExpandableItem
import com.chad.library.adapter.base.entity.MultiItemEntity
import com.wgmf.library.base.BaseResponse
import com.wgmf.yxgj.module.bussiness.reporthome.ui.adapter.HomeBusinessAdapter
import java.io.Serializable

/**
 * 到家业务任务查询
 *
ReturnInfo«GohomeTask» {
msgCode (integer, optional): 0 操作成功，1 操作失败 ,
msgContent (string, optional): 操作错误信息提示 ,
result (GohomeTask, optional): 返回的数据对象 ,
resultList (Array[GohomeTask], optional): 返回的数据集合 ,
sysCode (integer, optional): 0 系统正常，1系统异常 ,
sysContent (string, optional): 服务器异常错误信息提示
}
GohomeTask {
list (Array[GohomeTaskDetail], optional): 列表 ,
shopId (string, optional): 门店id ,
shopName (string, optional): 门店名称
}
GohomeTaskDetail {
auditStatus (string, optional): 审核状态（0：未审核，1：合格，2：不合格） ,
reportStatus (string, optional): 提交状态（0：未提交，1：已提交） ,
taskId (string, optional): 任务id ,
taskName (string, optional): 任务名称
}
 */

data class HomeBusinessEntity(val resultList:List<HomeBusinessList>?) : BaseResponse() {

    data class HomeBusinessList(
        var shopId: String,
        var shopName: String,
        var list: List<TasksBean>?
    ) : BaseResponse() {

        data class TasksBean(
            var reportStatus: String,
            var auditStatus: String,
            var taskId: String,
            var taskName: String
        )
    }
}


data class HomeTasksGroup(
    var shopId: String,
    var shopName: String
) : AbstractExpandableItem<HomeTasksChild>(), MultiItemEntity {

    override fun getItemType(): Int = HomeBusinessAdapter.TYPE_LEVEL_0

    override fun getLevel(): Int = 0
}

data class HomeTasksChild(
    var shopId:String,
    var shopName: String,
    var reportStatus: String,
    var auditStatus: String,
    var taskId: String,
    var taskName: String
) : MultiItemEntity, Serializable {
    override fun getItemType(): Int = HomeBusinessAdapter.TYPE_LEVEL_1
}