package com.wgmf.yxgj.module.bussiness.reporthome.ui

import android.content.Intent
import android.net.Uri
import android.support.v4.content.ContextCompat
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.widget.*
import com.alibaba.android.arouter.facade.annotation.Route
import com.bumptech.glide.Glide
import com.google.gson.Gson
import com.wgmf.library.base.BaseResponse
import com.wgmf.library.base.ResultData
import com.wgmf.library.utils.ToastUtil
import com.wgmf.yxgj.config.BusinessID
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.bussiness.reporthome.R
import com.wgmf.yxgj.module.bussiness.reporthome.model.HomeBusinessDetailEntity
import com.wgmf.yxgj.module.bussiness.reporthome.model.HomeBusinessSubmitEntity
import com.wgmf.yxgj.module.bussiness.reporthome.model.HomeTasksChild
import com.wgmf.yxgj.module.bussiness.reporthome.service.ReportHomeService
import com.wgmf.yxgj.module.bussiness.reporthome.ui.adapter.HomeBusinessEditAdapter
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity
import com.wgmf.yxgj.utils.isNotNullOrSize
import com.wgmf.yxgj.utils.notNullAndEmpty
import com.wgmf.yxgj.widgets.decoration.DividerItemDecoration
import com.xp.arouter.RouterParams
import com.xp.pro.imagepickerlib.TakePictureActivity
import com.xp.pro.imagepickerlib.bean.ImageItem
import com.xp.pro.imagepickerlib.global.Params
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout
import org.jetbrains.anko.find
import java.io.File

/**
 *  到家业务:（第二页） 到家业务上报页面
 * @author LW
 */
@Route(path = RouterParams.URL_HOME_BUSINESS_EDIT_ACTIVITY)
class HomeBusinessEditActivity : ReportWithPhotoBaseActivity(), ImagePickerLayout.ImagePicker,
    HomeBusinessEditAdapter.OnPictureClickListener {

    private var mHomeBusinessDetail: HomeBusinessDetailEntity.HomeBusinessDetail? = null

    private var mHomeBusinessEditAdapter: HomeBusinessEditAdapter? = null

    private var mRecyclerFootView: View? = null

    private var mRecyclerOneHeaderView: View? = null
    private var mRecyclerTwoHeaderView: View? = null

    private var mRecyclerSubmitView: View? = null

    private val mTasksChild: HomeTasksChild? by lazy {
        intent.getSerializableExtra("tasksChild") as HomeTasksChild
    }

    private val mBranchTitle: String? by lazy {
        intent.getStringExtra("branchTitle")
    }

    override fun initTitle() {
        super.initTitle()
        homeTitleText.text = mBranchTitle
        homeTitleBackLl.visibility = View.VISIBLE
    }

    override fun setListHeadAndFootView() {
        mRecyclerFootView = LayoutInflater.from(this).inflate(
            R.layout.item_report_home_footer_view,
            null, false
        )

        mRecyclerOneHeaderView = View.inflate(mContext, R.layout.item_report_title, null)

        mRecyclerTwoHeaderView = View.inflate(mContext, R.layout.item_report_title, null)

        mRecyclerSubmitView = View.inflate(mContext, R.layout.public_confirm_btn_view, null)
    }

    override fun setListAdapter() {
        mHomeBusinessEditAdapter = HomeBusinessEditAdapter(listOf(), this)
        publicListViewLv.visibility = View.GONE
        mPublicListViewRv.apply {
            visibility = View.VISIBLE
            layoutManager = LinearLayoutManager(mContext, RecyclerView.VERTICAL, false)
            addItemDecoration(
                DividerItemDecoration(
                    DividerItemDecoration.HORIZONTAL_LIST,
                    1,
                    ContextCompat.getColor(mContext, R.color.divider_line)
                )
            )
            adapter = mHomeBusinessEditAdapter
        }
    }

    override fun parseHeadData() {
        mRecyclerOneHeaderView?.let {
            it.findViewById<TextView>(R.id.report_home_item_title).text =
                getString(R.string.display_report_last_time_submit_details)
        }
        mRecyclerTwoHeaderView?.let {
            it.findViewById<TextView>(R.id.report_home_item_title).text =
                getString(R.string.display_report_current_submit)
        }
    }

    private var mReportHomeStoreCodeTv: TextView? = null
    private var mReportHomeStoreNameTv: TextView? = null

    private var mReportHomeProductListedTv: TextView? = null
    private var mReportHomeProductListTv: TextView? = null

    private var mReportHomeCaseIv: ImageView? = null
    private var mReportHomeCaseInfoTv: TextView? = null
    private var mReportHomeCaseTipTv: TextView? = null

    private var mReportHomeReasonInputEt: EditText? = null

    private var mReportContentConfirmLl: LinearLayout? = null
    private var mReportContentConfirmBtn: Button? = null


    override fun parseFootData() {
        mRecyclerFootView?.let {
            mReportHomeStoreCodeTv = it.findViewById(R.id.report_home_store_code_tv)
            mReportHomeStoreNameTv = it.findViewById(R.id.report_home_store_name_tv)
            mReportHomeProductListedTv = it.findViewById(R.id.report_home_product_listed_tv)
            mReportHomeProductListTv = it.findViewById(R.id.report_home_product_list_tv)

            mReportHomeCaseIv = it.findViewById(R.id.report_home_case_iv)
            mReportHomeCaseInfoTv = it.findViewById(R.id.report_home_case_info_tv)
            mReportHomeCaseTipTv = it.findViewById(R.id.report_home_case_tip_tv)

            idImagePickerContainer =
                it.find<ImagePickerLayout>(R.id.report_home_image_picker_container).apply {
                    title = "照片:"
                    tip = "(最多可添加30张)"
                    imagePicker = this@HomeBusinessEditActivity
                    sizePhotoNum = 3
                    maxPhotoNum = 30
                    setmImageselectList(mImageselectList)
                    imagePickerView = this
                    isOlnyViewMode = false
                }

            mReportHomeReasonInputEt = it.findViewById(R.id.report_home_reason_input_et)
        }

        mRecyclerSubmitView?.let {
            mReportContentConfirmLl = it.findViewById(R.id.report_content_confirm_ll)
            mReportContentConfirmBtn = it.findViewById(R.id.report_content_confirm_btn)

        }
        //auditStatus (string, optional): 审核状态（0：未审核，1：合格，2：不合格）
        //reportStatus (string, optional): 提交状态（0：未提交，1：已提交）
        mReportContentConfirmLl?.visibility = View.VISIBLE
        mTasksChild?.let {
            if (it.reportStatus == ConstantParams.CONSTANT_PARAMS_1) {  //已提交
                if (it.auditStatus == ConstantParams.CONSTANT_PARAMS_1 || it.auditStatus == ConstantParams.CONSTANT_PARAMS_2) {  //合格、不合格
                    mReportContentConfirmBtn?.text = getString(R.string.submit_btn_txt)
                } else {  //未审核
                    mReportContentConfirmBtn?.text = getString(R.string.modify_btn_txt)
                }
            } else { //未提交
                mReportContentConfirmBtn?.text = getString(R.string.submit_btn_txt)
            }
        }

        mReportContentConfirmBtn?.setOnClickListener {
            imgType = true
            setUploadData()
        }

    }

    override fun initContent() {
        super.initContent()

        reportType = "RH"
        mTasksChild?.let {
            showDialog()
            ReportHomeService.instance.requestQueryTaskDetail(it.taskId, it.shopId, this)
        }
    }

    /**
     * 设置数据
     * auditStatus 审核（0：未审核，1：合格，2：不合格）
     * status 状态（0：未提交，1：已提交）
     * @param homeBusinessDetail HomeBusinessDetailEntity.HomeBusinessDetail
     */
    private fun setData(homeBusinessDetail: HomeBusinessDetailEntity.HomeBusinessDetail) {
        this.mHomeBusinessDetail = homeBusinessDetail

        mHomeBusinessEditAdapter?.removeAllHeaderView()
        mHomeBusinessEditAdapter?.removeAllFooterView()

        homeBusinessDetail.apply {
            mTasksChild?.let {
                ema?.shopId = mTasksChild?.shopId ?: ""
                ema?.shopName = mTasksChild?.shopName ?: ""
                if (it.reportStatus == ConstantParams.CONSTANT_PARAMS_1) {
                    if (it.auditStatus == ConstantParams.CONSTANT_PARAMS_2) {  //审核不合格
                        mHomeBusinessEditAdapter?.setHeaderView(mRecyclerOneHeaderView)
                        mHomeBusinessEditAdapter?.setFooterView(mRecyclerTwoHeaderView, 0)

                        mHomeBusinessEditAdapter?.setNewData(mutableListOf(ema))

                        mHomeBusinessEditAdapter?.setFooterView(mRecyclerFootView, 1)
                        mHomeBusinessEditAdapter?.setFooterView(mRecyclerSubmitView, 2)

                    } else if (it.auditStatus == ConstantParams.CONSTANT_PARAMS_1) { //审核合格
                        mHomeBusinessEditAdapter?.removeAllHeaderView()
                        mHomeBusinessEditAdapter?.removeAllFooterView()

                        mHomeBusinessEditAdapter?.setNewData(mutableListOf(ema))
                    } else {
                        mHomeBusinessEditAdapter?.setFooterView(mRecyclerFootView, 0)
                        mHomeBusinessEditAdapter?.setFooterView(mRecyclerSubmitView, 1)
                    }
                } else {
                    mHomeBusinessEditAdapter?.setFooterView(mRecyclerFootView, 0)
                    mHomeBusinessEditAdapter?.setFooterView(mRecyclerSubmitView, 1)
                }
            }

            ems?.apply {
                shopId = mTasksChild?.shopId ?: ""
                shopName = mTasksChild?.shopName ?: ""

                mReportHomeStoreCodeTv?.text =
                    mContext.getString(R.string.display_report_store_code, shopId?:"")

                mReportHomeStoreNameTv?.text =
                    mContext.getString(R.string.display_report_store_name, shopName?:"")

                mReportHomeProductListedTv?.text =
                    mContext.getString(R.string.display_report_products_listed)

                mReportHomeProductListTv?.let {
                    if (list?.isNotNullOrSize() == true) {
                        it.text = mContext.getString(R.string.display_reprot_products_listed_tip)
                        getProductFormatStr(it)
                    }
                }

                //加载图片
                if (course.notNullAndEmpty()) {
                    Glide.with(mContext).load(course).placeholder(R.drawable.pop_hone_qgwsr_default)
                        .error(R.drawable.pop_hone_qgwsr_default).into(mReportHomeCaseIv)
                    mReportHomeCaseIv?.setOnClickListener {
                        showPreviewPhoto(course)
                    }
                }

                if (courseDetail.notNullAndEmpty()) {
                    mReportHomeCaseTipTv?.setOnClickListener {
                        showPreviewPhoto(courseDetail)
                    }
                }

                val imageLists: List<String>? = photos
                if (imageLists.isNotNullOrSize()) {
                    imageLists?.forEachIndexed { index, value ->
                        val item = ImageItem()
                        item.setImgneturl(value)
                        item.setImagePath(value)
                        item.setImageId(index.toString() + "")
                        item.setUri(Uri.fromFile(File(value)))
                        item.setType(1)
                        mImageselectList.add(item)
                    }
                }
                idImagePickerContainer?.refreshPhotoContentView(mImageselectList)

                mReportHomeReasonInputEt?.setText(exceptionSpecification?:"")
            }
        }
    }

    override fun setUploadData() {
        if (idImagePickerContainer.getmImageselectList().isNullOrEmpty()) {
            ToastUtil.show(mContext, R.string.diaplay_report_picture_out_of_stock_not_empty_tip)
            return
        }
        super.setUploadData()
    }

    override fun uploadData() {
        super.uploadData()

        if (mImageselectList != null && mImageselectList.isNotEmpty()) {
            //先添加已上传的
            for (i in mImageselectList.indices) {
                //如果图片时上传过后再寻得到则存在id
                if (1 == mImageselectList[i].getType()) {
                    //将已经在上传过的图片添加到url中
                    urlLists.add(mImageselectList[i].getImgneturl())
                }
            }
        }
        val exceptionSpecification = mReportHomeReasonInputEt?.text?.toString()

        userInfo?.let {
            val json = Gson().toJson(
                HomeBusinessSubmitEntity(
                    exceptionSpecification,
                    urlLists,
                    mHomeBusinessDetail?.ems?.reportId?.toInt(),
                    it.staffId ?: "",
                    it.name ?: "",
                    mTasksChild?.shopId,
                    mTasksChild?.shopName,
                    mTasksChild?.taskId
                )
            )
            ReportHomeService.instance.requestSubmit(json, this)
        }
    }


    /**
     * 显示预览图片
     * @param url:String
     */
    private fun showPreviewPhoto(url: String) {
        toPhotoPreviewFragment(0, listOf(ImageItem().apply {
            imgneturl = url
            imagePath = url
            imageId = "0"
            uri = Uri.fromFile(File(url))
            type = 1
        }))
    }


    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)
        dismissDialog()
        result?.let {
            if (it.taskID == BusinessID.HomeReport.MSG_ON_QUERY_TASK_DETAIL) {
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, HomeBusinessDetailEntity::class.java)
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        val data = entity.result
                        if (data != null) {
                            setData(data)
                        }
                    } else {
                        val retInfo = entity.retInfo
                        if (retInfo.notNullAndEmpty()) {
                            ToastUtil.show(mContext, retInfo)
                        }
                    }
                }
            } else if (it.taskID == BusinessID.HomeReport.MSG_ON_SUBMIT) {
                urlLists.clear()
                qiniuUrlLists.clear()
                if (!isFinishing && it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, BaseResponse::class.java)
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.retCode) {
                        finish()
                    } else {
                        if (entity.retInfo.notNullAndEmpty()) {
                            ToastUtil.show(mContext, entity.retInfo)
                        }
                    }
                }
            }
        }
    }

    override fun setSelectDialog(selectType: Int, view: View?) {
        idImagePickerContainer = view as ImagePickerLayout
        if (idImagePickerContainer != null) {
            setSelectDialogListeners(View.OnClickListener { //拍照处理
                takePhoto(idImagePickerContainer)
                hideSelectDialog()

            }, View.OnClickListener { //相片处理
                getPictrue(idImagePickerContainer)
                hideSelectDialog()
            }, View.OnClickListener { hideSelectDialog() })

            showSelectDialog("选择图片", null, "相机拍照", "本地相册", "取消")
        }
    }

    override fun toPhotoPreview(index: Int, arrayList: ArrayList<ImageItem>?) {
        toPhotoPreviewFragment(index, arrayList) //大图显示
    }

    /**
     * 调用系统拍照
     */
    protected fun takePhoto(idImagePickerContainer: ImagePickerLayout?) {
        val intent = Intent(this, TakePictureActivity::class.java)
        intent.putExtra("authority", "com.wgmf.yxgj")
        startActivityForResultByAnimation(intent, Params.TAKE_PICTURE)
    }

    override fun setItemSelectDialog(selectType: Int, view: View?) {
        ToastUtil.show(this, R.string.query_status_not_update_picture_tip)
    }

    override fun toItemPhotoPreview(i: Int, arrayList: ArrayList<ImageItem>?) {
        toPhotoPreviewFragment(i, arrayList) //大图显示
    }
}