package com.wgmf.yxgj.module.bussiness.reporthome.ui.adapter

import android.net.Uri
import android.view.View
import android.widget.TextView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.yxgj.module.bussiness.reporthome.R
import com.wgmf.yxgj.module.bussiness.reporthome.model.HomeBusinessDetailEntity
import com.wgmf.yxgj.utils.isNotNullOrSize
import com.xp.pro.imagepickerlib.bean.ImageItem
import java.io.File
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout.ImagePicker

/**
 * 到家业务详情列表适配器
 * @author LW
 */
class HomeBusinessEditAdapter(
    entity: List<HomeBusinessDetailEntity.HomeBusinessDetail.Ema>,
    private val onPictureClickListener: OnPictureClickListener?
) : BaseQuickAdapter<HomeBusinessDetailEntity.HomeBusinessDetail.Ema, BaseViewHolder>(
    R.layout.item_report_home_view,
    entity
), ImagePicker {

    override fun convert(
        helper: BaseViewHolder?,
        item: HomeBusinessDetailEntity.HomeBusinessDetail.Ema?
    ) {
        helper?.apply {


            item?.let {
                setText(
                    R.id.report_home_store_code_tv,
                    mContext.getString(R.string.display_report_store_code, it.shopId?:"")
                )
                setText(
                    R.id.report_home_store_name_tv,
                    mContext.getString(R.string.display_report_store_name, it.shopName?:"")
                )
                setText(
                    R.id.report_home_product_listed_tv,
                    mContext.getString(R.string.display_report_products_listed)
                )

                val view = getView<TextView>(R.id.report_home_product_list_tv)
                if (it.list?.isNotNullOrSize()==true) {
                    view.text = mContext.getString(R.string.display_reprot_products_listed_tip)
                    it.getProductFormatStr(view)
                }
                setText(
                    R.id.report_home_exception_desc_tv,
                    mContext.getString(
                        R.string.display_report_exception_desc,
                        it.exceptionSpecification?:""
                    )
                )

                setText(
                    R.id.report_home_submit_time_tv,
                    mContext.getString(R.string.display_report_submit_time, it.reportTime?:"")
                )

                setText(
                    R.id.report_home_audit_result_tv,
                    mContext.getString(R.string.display_report_audit_situation, it.auditStatus?:"")
                )

                setText(
                    R.id.report_home_audit_situation_tv,
                    mContext.getString(R.string.display_report_audit_result, it.auditResult?:"")
                )

                setText(
                    R.id.report_home_review_notes_tv,
                    mContext.getString(R.string.display_report_review_notes, it.remark?:"")
                )

                val imageList = arrayList(it.photos ?: arrayListOf())
                getView<ImagePickerLayout>(R.id.report_home_image_picker_container).apply {
                    setmImageselectList(imageList)
                    title = "导出照片:"
                    setTipVisibility(View.GONE)
                    isOlnyViewMode = true
                    imagePicker = this@HomeBusinessEditAdapter
                    maxPhotoNum = 30
                    sizePhotoNum = 3
                    imagePickerView = this
                    refreshPhotoContentView(imageList)
                    tag = layoutPosition
                }
            }
        }
    }

    private fun arrayList(imgs: List<String>): ArrayList<ImageItem> {
        val list = arrayListOf<ImageItem>()
        if (imgs.isNotNullOrSize()) {
            for (i in imgs.indices) {
                val item = ImageItem()
                item.setImgneturl(imgs[i])
                item.setImagePath(imgs[i])
                item.setImageId(i.toString() + "")
                item.setUri(Uri.fromFile(File(imgs[i])))
                item.setType(1)
                list.add(item)
            }
        }
        return list
    }

    override fun setSelectDialog(selectType: Int, view: View) {
        onPictureClickListener?.setItemSelectDialog(selectType, view)
    }

    override fun toPhotoPreview(i: Int, arrayList: ArrayList<ImageItem>) {
        onPictureClickListener?.toItemPhotoPreview(i, arrayList)
    }

    interface OnPictureClickListener {
        fun setItemSelectDialog(selectType: Int, view: View?)
        fun toItemPhotoPreview(i: Int, arrayList: ArrayList<ImageItem>?)
    }

}