package com.wgmf.yxgj.module.business.reportibeacon.ui;

import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.EditText;

import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.reportibeacon.R;
import com.wgmf.yxgj.module.business.reportibeacon.model.IbeaconEntity;
import com.wgmf.yxgj.module.business.reportibeacon.model.IbeaconImagesSet;
import com.wgmf.yxgj.module.business.reportibeacon.service.IbeaconService;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.model.ShopEntityWithTime;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.util.ArrayList;
import java.util.List;

/**
 * 作者：xiep on 2016/7/28 16:27
 * 邮箱：2975837870@qq.com
 */
public class IbeaconReportDetailActivity extends ReportWithPhotoBaseActivity implements ImagePickerLayout.ImagePicker {
    /**
     * 0，查询1，上报
     */
    private int type;
    private EditText majorTv;
    private EditText minjorTv;
    private List<BaseSelectorEntity> baseSelectorEntitys;
    private ShopEntityWithTime mIbeaconShopEntity = new ShopEntityWithTime();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        switchMode();
    }
    @Override
    protected void initData() {
        super.initData();
        //Ibeancon上报
        reportType = "Ibeacon";
        baseSelectorEntitys = new ArrayList<>();
        BaseSelectorEntity baseSelectorEntity = new BaseSelectorEntity();
        baseSelectorEntity.setSelectorName("Ibeacon上报项");
        baseSelectorEntitys.add(baseSelectorEntity);
    }

    @Override
    protected void initContent() {
        super.initContent();
        mIbeaconShopEntity = (ShopEntityWithTime) getIntent().getSerializableExtra("shopEntityWithTimes");
        shopId = mIbeaconShopEntity.getShop().getShopId();

        reportDetailTitle.setText(mIbeaconShopEntity.getShop().getShopName());
        reportDetailDate.setText(DateUtil.getFormatCurrentDate("yyyy-MM-dd"));
        titleMoreLl.setVisibility(View.VISIBLE);
    }
    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        String branchTitle = getIntent().getStringExtra("branchTitle");
        type = getIntent().getIntExtra("type", 0);
        homeTitleText.setText(branchTitle);
    }

    @Override
    protected void more() {
        super.more();
        queryData();
    }

    private void switchMode() {
        if (type != 0 && !"".equals(mIbeaconShopEntity.getAddTime())) {
            homeTitleMore.setText("结果");
            homeTitleMoreLl.setVisibility(View.VISIBLE);
        }
        if (type == 0) {
            queryData();
        }
    }

    private void queryData() {
        majorTv.setCompoundDrawables(null, null, null, null);
        // 为EditText设置不可点击
        majorTv.setEnabled(false);
        minjorTv.setCompoundDrawables(null, null, null, null);
        // 为EditText设置不可点击
        minjorTv.setEnabled(false);
        majorTv.setFocusable(false);
        minjorTv.setFocusable(false);
        publicTakePhotoRootLl.setVisibility(View.GONE);
        reportContentConfirmLl.setVisibility(View.GONE);
        queryIbeaconReportData();
    }

    private void queryIbeaconReportData() {
        if (null != userInfo) {
            showDialog();
            IbeaconService.getInstance().requestGetIbeacon(shopId, IbeaconReportDetailActivity.this);
        }
    }

    @Override
    protected void setListAdapter() {
        super.setListAdapter();
        BaseCommonAdapter mAdapter = new BaseCommonAdapter<BaseSelectorEntity>(this, baseSelectorEntitys) {
            @Override
            public void convert(ViewHolder helper, BaseSelectorEntity item) {
                helper.setText(item.getSelectorName() + "");
            }
        };
        publicListViewLv.setAdapter(mAdapter);
    }

    @Override
    protected void setListHeadAndFootView() {
        View footView = getLayoutInflater().inflate(R.layout.activity_ibean_report_detail, null);
        publicListViewLv.addFooterView(footView);
    }

    @Override
    protected void parseFootData() {
        super.parseFootData();
        showCursor(false);
        majorTv = (EditText) findViewById(R.id.major_tv);
        minjorTv = (EditText) findViewById(R.id.minjor_tv);

        publicTakePhotoLl.setVisibility(View.GONE);
        publicTakePhotoRootLl.setVisibility(View.VISIBLE);
        reportContentConfirmLl.setVisibility(View.VISIBLE);
        initPictureDisplayView();
    }

    private void initPictureDisplayView() {
        idImagePickerContainer = (ImagePickerLayout) findViewById(R.id.id_image_picker_container);
        idImagePickerContainer.setVisibility(View.VISIBLE);
        idImagePickerContainer.setTitle("Ibeacon上报图片");
        idImagePickerContainer.setTip("(最多可上传3张)");
        idImagePickerContainer.setImagePicker(this);
        idImagePickerContainer.setSizePhotoNum(3);
        idImagePickerContainer.setMaxPhotoNum(3);
        idImagePickerContainer.setmImageselectList(mImageselectList);
        idImagePickerContainer.setImagePickerView(idImagePickerContainer);
        idImagePickerContainer.setOlnyViewMode(false);
    }

    @Override
    protected void uploadData() {
        if (TextUtils.isEmpty(majorTv.getText().toString())) {
            ToastUtil.show(this, "请填写Major");
            return;
        }
        if (majorTv.getText().toString().length() > 20) {
            ToastUtil.show(this, "Major太长，请重新填写");
            majorTv.setText("");
            return;
        }
        if (TextUtils.isEmpty(minjorTv.getText().toString())) {
            ToastUtil.show(this, "请填写Minor");
            return;
        }
        if (minjorTv.getText().toString().length() > 20) {
            ToastUtil.show(this, "Minor太长，请重新填写");
            minjorTv.setText("");
            return;
        }
        if (null != userInfo) {
            IbeaconEntity mIbeaconEntity = new IbeaconEntity();
            mIbeaconEntity.setMajor(majorTv.getText().toString());
            mIbeaconEntity.setMinor(minjorTv.getText().toString());
            mIbeaconEntity.setUserId(userInfo.getStaffId());
            mIbeaconEntity.setShopId(shopId);
            List<IbeaconImagesSet> ibeaconImagesSet = new ArrayList<>();
            for (int i = urlLists.size() - 1; i >= 0; i--) {
                IbeaconImagesSet mIbeaconImagesSet = new IbeaconImagesSet();
                mIbeaconImagesSet.setUrl(urlLists.get(i));
                ibeaconImagesSet.add(mIbeaconImagesSet);
            }
            mIbeaconEntity.setIbeaconImagesSet(ibeaconImagesSet);

            String content = new Gson().toJson(mIbeaconEntity);
            Log.d(TAG, content);
            IbeaconService.getInstance().requestSaveIbeacon(content, IbeaconReportDetailActivity.this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.IbeanconReport.MSG_ON_GET_IBEACON: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        IbeaconEntity mIbeaconEntity = new Gson().fromJson(msg, IbeaconEntity.class);
                        Log.d(TAG, "mIbeaconEntity=" + mIbeaconEntity.toString());
                        reportDetailDate.setText(mIbeaconEntity.getAddTime());
                        majorTv.setText(mIbeaconEntity.getMajor());
                        minjorTv.setText(mIbeaconEntity.getMinor());
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                }
                break;
                case BusinessID.IbeanconReport.MSG_ON_SAVE_IBEACON: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg,
                                BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                            this.finish();
                        }
                        ToastUtil.show(this, mBaseResponse.retInfo);
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    @Override
    public void setSelectDialog(int selectType,View view) {
        idImagePickerContainer = (ImagePickerLayout) view;
        setSelectDialogListeners(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //拍照处理
                takePhoto(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //相片处理
                getPictrue(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                hideSelectDialog();
            }
        });
        showSelectDialog("选择图片", null, "相机拍照", "本地相册", "取消");
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, com.xp.pro.imagepickerlib.global.Params.TAKE_PICTURE);
    }

    @Override
    public void toPhotoPreview(int index, ArrayList<ImageItem> mImageselectList) {
        toPhotoPreviewFragment(index, mImageselectList);//大图显示
    }
}