package com.wgmf.yxgj.module.business.reportibeacon.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.publics.model.ShopEntityWithTime;
import com.wgmf.yxgj.module.business.reportibeacon.R;

import java.util.List;


/**
 * 作者：xiep on 2016/7/28 16:27
 * 邮箱：2975837870@qq.com
 */
class IbeaconShopListAdapter extends BaseAdapter {
    private Context context;
    private List<ShopEntityWithTime> list;

    IbeaconShopListAdapter(Context context, List<ShopEntityWithTime> list) {
        this.context = context;
        this.list = list;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public ShopEntityWithTime getItem(int position) {
        if (position >= list.size())
            return null;
        else
            return list.get(position);
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        TextView name;
        TextView no;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.list_item_report_shop, null);
            holder.name = (TextView) convertView.findViewById(R.id.list_item_title_txt);
            holder.no = (TextView) convertView.findViewById(R.id.list_item_time_txt);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        ShopEntityWithTime data = list.get(position);
        holder.name.setText(data.getShop().getShopName());
        String text = "最近上报时间：" + data.getAddTime() + "";
        holder.no.setText(text);
        return convertView;
    }
}