package com.wgmf.yxgj.module.business.reportmodule.model;

import com.xp.pro.imagepickerlib.bean.ImageItem;

import java.util.ArrayList;
import java.util.List;

/**
 * detailId (integer, optional):明细id ,
 * detailOptionsId (integer, optional),
 * modelId (integer, optional):MODEL_ID ,
 * modelOptionsId (integer, optional):MODEL_OPTIONS_ID ,
 * value (string, optional):填写的值
 */
public class ReportModelListEntity {
    /**
     * 类型：
     * 1:单行文本
     * 2:多行文本
     * 3:单项选择
     * 4:多项选择
     * 5:日期选择
     * 6:照片选择
     * 7:音频选择
     */
    private int type;
    /**
     * 标题
     */
    private String title;
    /**
     * 描述文字
     */
    private String tip;
    /**
     * 描述图片
     */
    private String img;
    /**
     * 是否必填
     */
    private String necessary;
    /**
     * 值
     */
    private String value;
    /**
     * 查询配置时使用的选项
     */
    private List<ReportModuleOptionEntity> options;
    /**
     * 图片集合
     */
    private ArrayList<ImageItem> storeImageselectList = new ArrayList<>();

    private String modelId;

    private String standardId;

    private int orderNum;

    private int imgOrVoiceType;

    private int imgOrVoiceNum;

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getTip() {
        return tip;
    }

    public void setTip(String tip) {
        this.tip = tip;
    }

    public String getImg() {
        return img;
    }

    public void setImg(String img) {
        this.img = img;
    }

    public String isNecessary() {
        return necessary;
    }

    public void setNecessary(String necessary) {
        this.necessary = necessary;
    }

    public List<ReportModuleOptionEntity> getOptions() {
        return options;
    }

    public void setOptions(List<ReportModuleOptionEntity> options) {
        this.options = options;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String getModelId() {
        return modelId;
    }

    public void setModelId(String modelId) {
        this.modelId = modelId;
    }

    public String getStandardId() {
        return standardId;
    }

    public void setStandardId(String standardId) {
        this.standardId = standardId;
    }

    public int getOrderNum() {
        return orderNum;
    }

    public void setOrderNum(int orderNum) {
        this.orderNum = orderNum;
    }

    public String getNecessary() {
        return necessary;
    }

    public int getImgOrVoiceType() {
        return imgOrVoiceType;
    }

    public void setImgOrVoiceType(int imgOrVoiceType) {
        this.imgOrVoiceType = imgOrVoiceType;
    }

    public int getImgOrVoiceNum() {
        return imgOrVoiceNum;
    }

    public void setImgOrVoiceNum(int imgOrVoiceNum) {
        this.imgOrVoiceNum = imgOrVoiceNum;
    }

    public ArrayList<ImageItem> getStoreImageselectList() {
        return storeImageselectList;
    }

    public void setStoreImageselectList(ArrayList<ImageItem> storeImageselectList) {
        this.storeImageselectList = storeImageselectList;
    }

    @Override
    public String toString() {
        return "ReportModelListEntity{" +
                "type=" + type +
                ", title='" + title + '\'' +
                ", tip='" + tip + '\'' +
                ", img='" + img + '\'' +
                ", necessary='" + necessary + '\'' +
                ", value='" + value + '\'' +
                ", options=" + options +
                ", modelId='" + modelId + '\'' +
                ", standardId='" + standardId + '\'' +
                ", orderNum=" + orderNum +
                ", imgOrVoiceType=" + imgOrVoiceType +
                ", imgOrVoiceNum=" + imgOrVoiceNum +
                '}';
    }
}