package com.wgmf.yxgj.module.business.reportmodule.model;

import java.io.Serializable;
import java.util.List;

/**
 * {
 * "shopId": "0110012",
 * "shopName": "华润万家沙井店",
 * "status": 5,
 * "statusStr": "待上报",
 * "standardId": 2560606,
 * "standardList": [
 * {
 * "standardId": 2560606,
 * "reportName": "堆头数量上报",
 * "beginDate": "2019-01-31 00:00:00",
 * "endDate": "2019-07-16 00:00:00",
 * "status": 5,
 * "statusStr": "待上报",
 * "reportRemark": "堆头备注",
 * "reportPerson": "赵兴春"
 * }
 * ]
 * }
 */
public class ReportShopListEntity implements Serializable {
    /**
     * 上报门店ID
     */
    private String shopId;
    /**
     * 上报门店名称
     */
    private String shopName;
    /**
     * 上报状态
     */
    private String statusStr;
    /**
     * (integer, optional):
     * <p>
     * 状态:分两个维度 1)门店维度:5:需上报 6:不需上报
     * 2)门店+项目维度: 0:不可用 1:待审核 2:审核通过 3:审核不通过 4:审核不通过再次提交 5:待上报 ,
     */
    private int status;

    private int updateFlag;
    /**
     * 上报模板id
     */
    private String standardId;

    /**
     * 上报项数据
     */
    private List<ReportProjectListEntity> standardList;


    public String getShopId() {
        return shopId;
    }

    public void setShopId(String shopId) {
        this.shopId = shopId;
    }

    public String getShopName() {
        return shopName;
    }

    public void setShopName(String shopName) {
        this.shopName = shopName;
    }

    public String getStatusStr() {
        return statusStr;
    }

    public void setStatusStr(String statusStr) {
        this.statusStr = statusStr;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public String getStandardId() {
        return standardId;
    }

    public void setStandardId(String standardId) {
        this.standardId = standardId;
    }

    public List<ReportProjectListEntity> getStandardList() {
        return standardList;
    }

    public void setStandardList(List<ReportProjectListEntity> standardList) {
        this.standardList = standardList;
    }
    public int getUpdateFlag() {
        return updateFlag;
    }

    public void setUpdateFlag(int updateFlag) {
        this.updateFlag = updateFlag;
    }

}