package com.wgmf.yxgj.module.business.reportmodule.ui;

import android.app.DatePickerDialog;
import android.content.Context;
import android.net.Uri;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.module.business.reportmodule.R;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportModelListEntity;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportModuleOptionEntity;
import com.wgmf.yxgj.module.business.reportmodule.service.ReportStaticData;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.io.File;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

@SuppressWarnings("all")
class ReportModuleDetailAdapter extends BaseAdapter implements ImagePickerLayout.ImagePicker {
    private Long branchID;
    private Context context;
    private LvListener lvListener;
    private List<ReportModelListEntity> reportModuleItemEntities;

    interface LvListener {
        void setSelectDialog(int selectType, View view);

        void toPhotoPreview(int i, ArrayList<ImageItem> arrayList);

        void onTakeAudio();

        void onChooseAudio();

        void showAudioSelect();
    }

    ReportModuleDetailAdapter(Context context, LvListener lvListener, List<ReportModelListEntity> reportModuleItemEntities, Long branchID) {
        this.branchID = branchID;
        this.context = context;
        this.lvListener = lvListener;
        this.reportModuleItemEntities = reportModuleItemEntities;
    }

    public List<ReportModelListEntity> getUploadData() {
        return reportModuleItemEntities;
    }

    @Override
    public int getCount() {
        return reportModuleItemEntities == null ? 0 : reportModuleItemEntities.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    @Override
    public void setSelectDialog(int selectType, View view) {
        lvListener.setSelectDialog(selectType, view);
    }

    @Override
    public void toPhotoPreview(int i, ArrayList<ImageItem> arrayList) {
        lvListener.toPhotoPreview(i, arrayList);
    }

    void refreshPicture(ArrayList<ImageItem> mImageselectList, ImagePickerLayout idImagePickerContainer) {
        int position = (int) idImagePickerContainer.getTag();
        //在对应位置图片集合里加入拍照返回图片
        reportModuleItemEntities.get(position).setStoreImageselectList(mImageselectList);
    }

    class ViewHolder {
        LinearLayout reportModuleItemSingleLineInputLayout;
        LinearLayout reportModuleItemMultiLineInputLayout;
        LinearLayout reportModuleItemSingleChoiceLayout;
        LinearLayout reportModuleItemMultiChoiceLayout;
        LinearLayout reportModuleItemDateLayout;
        LinearLayout reportModuleItemTakePhotoLayout;
        LinearLayout reportModuleItemTakeAudioLayout;

        TextView reportModuleItemNecessary;
        TextView reportModuleItemTitle;
        TextView reportModuleItemTip;
        ImageView reportModuleItemImg;

        ListViewForScrollView reportModuleItemSingleChoiceLv;
        ListViewForScrollView reportModuleItemMultiChoiceLv;
        ListViewForScrollView reportModuleItemTakeAudioLv;
        ImagePickerLayout reportModuleItemTakePhotoIpl;

        EditText reportModuleItemSingleLineInput;
        EditText reportModuleItemMultiLineInput;
        TextView reportModuleItemDate;

        ViewHolder(View convertView) {
            reportModuleItemSingleLineInputLayout = (LinearLayout) convertView.findViewById(R.id.report_module_item_single_line_input_layout);
            reportModuleItemMultiLineInputLayout = (LinearLayout) convertView.findViewById(R.id.report_module_item_multi_line_input_layout);
            reportModuleItemSingleChoiceLayout = (LinearLayout) convertView.findViewById(R.id.report_module_item_single_choice_layout);
            reportModuleItemMultiChoiceLayout = (LinearLayout) convertView.findViewById(R.id.report_module_item_multi_choice_layout);
            reportModuleItemDateLayout = (LinearLayout) convertView.findViewById(R.id.report_module_item_date_layout);
            reportModuleItemTakePhotoLayout = (LinearLayout) convertView.findViewById(R.id.report_module_item_take_photo_layout);
            reportModuleItemTakeAudioLayout = (LinearLayout) convertView.findViewById(R.id.report_module_item_take_audio_layout);

            reportModuleItemNecessary = (TextView) convertView.findViewById(R.id.report_module_item_necessary);
            reportModuleItemTitle = (TextView) convertView.findViewById(R.id.report_module_item_title);
            reportModuleItemTip = (TextView) convertView.findViewById(R.id.report_module_item_tip);
            reportModuleItemImg = (ImageView) convertView.findViewById(R.id.report_module_item_img);

            reportModuleItemSingleChoiceLv = (ListViewForScrollView) convertView.findViewById(R.id.report_module_item_single_choice_lv);
            reportModuleItemMultiChoiceLv = (ListViewForScrollView) convertView.findViewById(R.id.report_module_item_multi_choice_lv);
            reportModuleItemTakeAudioLv = (ListViewForScrollView) convertView.findViewById(R.id.report_module_item_take_audio_lv);
            reportModuleItemTakePhotoIpl = (ImagePickerLayout) convertView.findViewById(R.id.report_module_item_take_photo_ipl);

            reportModuleItemSingleLineInput = (EditText) convertView.findViewById(R.id.report_module_item_single_line_input);
            reportModuleItemMultiLineInput = (EditText) convertView.findViewById(R.id.report_module_item_multi_line_input);
            reportModuleItemDate = (TextView) convertView.findViewById(R.id.report_module_item_date);

            ArrayList<ImageItem> mImageselectList = new ArrayList();
            reportModuleItemTakePhotoIpl.setmImageselectList(mImageselectList);
            reportModuleItemTakePhotoIpl.setTitleVisibility(View.GONE);
            reportModuleItemTakePhotoIpl.setOlnyViewMode(false);
            reportModuleItemTakePhotoIpl.setImagePicker(ReportModuleDetailAdapter.this);
            reportModuleItemTakePhotoIpl.setSizePhotoNum(3);
            reportModuleItemTakePhotoIpl.setImagePickerView(reportModuleItemTakePhotoIpl);
        }
    }

    @Override
    public View getView(int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        convertView = null;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.report_module_detail_content_list_item, null);
            holder = new ViewHolder(convertView);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final ReportModelListEntity data = reportModuleItemEntities.get(position);

        holder.reportModuleItemSingleLineInput.setTag(data);
        holder.reportModuleItemMultiLineInput.setTag(data);
        holder.reportModuleItemDate.setTag(data);
        holder.reportModuleItemTakePhotoIpl.setTag(position);
        //是否必要
        if (ReportStaticData.getBoolean(true).equals(data.isNecessary())) {
            holder.reportModuleItemNecessary.setVisibility(View.VISIBLE);
        } else {
            holder.reportModuleItemNecessary.setVisibility(View.GONE);
        }
        //标题
        holder.reportModuleItemTitle.setText(data.getTitle());
        //文字提示
        if (!StringUtil.isNullString(data.getTip())) {
            holder.reportModuleItemTip.setText(data.getTip());
            holder.reportModuleItemTip.setVisibility(View.VISIBLE);
        } else {
            holder.reportModuleItemTip.setVisibility(View.GONE);
        }
        //图片提示
        if (!StringUtil.isNullString(data.getImg())) {
            holder.reportModuleItemImg.setVisibility(View.VISIBLE);
            Glide.with(context).load(data.getImg()).placeholder(R.drawable.img_default).error(R.drawable.img_default).into(holder.reportModuleItemImg);
        } else {
            holder.reportModuleItemImg.setVisibility(View.GONE);
        }
        holder.reportModuleItemImg.setOnClickListener(new View.OnClickListener() {
            // 点击放大
            @Override
            public void onClick(View paramView) {
                    if (!StringUtil.isNullString(data.getImg())) {
                        ArrayList<ImageItem> mImageselectList = new ArrayList<>();
                        ImageItem item = new ImageItem();
                        item.setImgneturl(data.getImg());
                        item.setImagePath(data.getImg());
                        item.setImageId(data.getImg());
                        item.setUri(Uri.fromFile(new File(data.getImg())));
                        item.setType(1);
                        mImageselectList.add(item);
                        lvListener.toPhotoPreview(0, mImageselectList);
                    }
            }
        });
        //选项类型
        if (data.getType() == 1) {
            //单行输入
            if (null != data.getOptions() && !data.getOptions().isEmpty()) {
                holder.reportModuleItemSingleLineInput.setText(data.getOptions().get(0).getValue());
            }
            holder.reportModuleItemSingleLineInputLayout.setVisibility(View.VISIBLE);
            holder.reportModuleItemSingleLineInput.addTextChangedListener(new TextWatcher() {
                @Override
                public void beforeTextChanged(CharSequence s, int start, int count, int after) {

                }

                @Override
                public void onTextChanged(CharSequence s, int start, int before, int count) {
                }

                @Override
                public void afterTextChanged(Editable s) {
                    ReportModelListEntity info = (ReportModelListEntity) holder.reportModuleItemSingleLineInput.getTag();
                    List<ReportModuleOptionEntity> reportModuleOptionEntities = new ArrayList<>();
                    ReportModuleOptionEntity reportModuleOptionEntity = new ReportModuleOptionEntity();
                    reportModuleOptionEntity.setValue(s.toString());
                    reportModuleOptionEntity.setModelId(data.getModelId());
                    reportModuleOptionEntity.setType(data.getType());
                    reportModuleOptionEntities.add(reportModuleOptionEntity);
                    info.setOptions(reportModuleOptionEntities);
                }
            });
        } else if (data.getType() == 2) {
            //多行输入
            if (null != data.getOptions() && !data.getOptions().isEmpty()) {
                holder.reportModuleItemMultiLineInput.setText(data.getOptions().get(0).getValue());
            }
            holder.reportModuleItemMultiLineInputLayout.setVisibility(View.VISIBLE);
            holder.reportModuleItemMultiLineInput.addTextChangedListener(new TextWatcher() {
                @Override
                public void beforeTextChanged(CharSequence s, int start, int count, int after) {

                }

                @Override
                public void onTextChanged(CharSequence s, int start, int before, int count) {
                }

                @Override
                public void afterTextChanged(Editable s) {
                    ReportModelListEntity info = (ReportModelListEntity) holder.reportModuleItemMultiLineInput.getTag();
                    List<ReportModuleOptionEntity> reportModuleOptionEntities = new ArrayList<>();
                    ReportModuleOptionEntity reportModuleOptionEntity = new ReportModuleOptionEntity();
                    reportModuleOptionEntity.setValue(s.toString());
                    reportModuleOptionEntity.setModelId(data.getModelId());
                    reportModuleOptionEntity.setType(data.getType());
                    reportModuleOptionEntities.add(reportModuleOptionEntity);
                    info.setOptions(reportModuleOptionEntities);
                }
            });
        } else if (data.getType() == 3) {
            //单选
            final ReportModuleItemSingleChoiceAdapter reportModuleItemSingleChoiceAdapter = new ReportModuleItemSingleChoiceAdapter(context);
            //初始化选中选项
            for (int i = 0; i < data.getOptions().size(); i++) {
                if (ReportStaticData.getBoolean(true).equals(data.getOptions().get(i).getIsChecked())) {
                    reportModuleItemSingleChoiceAdapter.setSelected(i);
                }
            }
            reportModuleItemSingleChoiceAdapter.setData(data.getOptions());
            holder.reportModuleItemSingleChoiceLv.setAdapter(reportModuleItemSingleChoiceAdapter);
            ListViewUtil.setListViewHeight(holder.reportModuleItemSingleChoiceLv);
            holder.reportModuleItemSingleChoiceLayout.setVisibility(View.VISIBLE);
        } else if (data.getType() == 4) {
            //多选
            ReportModuleItemMultiChoiceAdapter reportModuleItemMultiChoiceAdapter = new ReportModuleItemMultiChoiceAdapter(context);
            reportModuleItemMultiChoiceAdapter.setData(data.getOptions());
            holder.reportModuleItemMultiChoiceLv.setAdapter(reportModuleItemMultiChoiceAdapter);
            ListViewUtil.setListViewHeight(holder.reportModuleItemMultiChoiceLv);
            holder.reportModuleItemMultiChoiceLayout.setVisibility(View.VISIBLE);
        } else if (data.getType() == 5) {
            //日期
            if (null != data.getOptions() && !data.getOptions().isEmpty()) {
                holder.reportModuleItemDate.setText(data.getOptions().get(0).getValue());
            }
            holder.reportModuleItemDateLayout.setVisibility(View.VISIBLE);
            holder.reportModuleItemDateLayout.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    Calendar c = Calendar.getInstance();
                    DatePickerDialog.OnDateSetListener dateListener = new DatePickerDialog.OnDateSetListener() {

                        @Override
                        public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
                            String month;
                            String day;
                            if (monthOfYear + 1 < 10) {
                                month = "0" + (monthOfYear + 1);
                            } else {
                                month = "" + (monthOfYear + 1);
                            }
                            if (dayOfMonth < 10) {
                                day = "0" + dayOfMonth;
                            } else {
                                day = "" + dayOfMonth;
                            }
                            holder.reportModuleItemDate.setText(year + "-" + month + "-" + day);
                            ReportModelListEntity info = (ReportModelListEntity) holder.reportModuleItemDate.getTag();
                            List<ReportModuleOptionEntity> reportModuleOptionEntities = new ArrayList<>();
                            ReportModuleOptionEntity reportModuleOptionEntity = new ReportModuleOptionEntity();
                            reportModuleOptionEntity.setValue(year + "-" + month + "-" + day);
                            reportModuleOptionEntity.setModelId(data.getModelId());
                            reportModuleOptionEntity.setType(data.getType());
                            reportModuleOptionEntities.add(reportModuleOptionEntity);
                            info.setOptions(reportModuleOptionEntities);
                        }
                    };
                    DatePickerDialog datePickerDialog = new DatePickerDialog(context, android.R.style.Theme_Holo_Light_Panel,
                            dateListener, c.get(Calendar.YEAR), c.get(Calendar.MONTH),
                            c.get(Calendar.DAY_OF_MONTH));
                    // 对话框周围不可点击
                    datePickerDialog.setCanceledOnTouchOutside(false);
                    datePickerDialog.show();
                }
            });
        } else if (data.getType() == 6) {
            if (data.getImgOrVoiceNum() <= 0) {
                holder.reportModuleItemTakePhotoLayout.setVisibility(View.GONE);
            }else{
                holder.reportModuleItemTakePhotoLayout.setVisibility(View.VISIBLE);
                //查询图片数据转化
                holder.reportModuleItemTakePhotoIpl.setmImageselectList(data.getStoreImageselectList());
                holder.reportModuleItemTakePhotoIpl.setSelectType(data.getImgOrVoiceType());
                holder.reportModuleItemTakePhotoIpl.setImagePickerView(holder.reportModuleItemTakePhotoIpl);
                holder.reportModuleItemTakePhotoIpl.setTip("（最多添加" + data.getImgOrVoiceNum() + "张）");
                holder.reportModuleItemTakePhotoIpl.setMaxPhotoNum(data.getImgOrVoiceNum());

                if (590L == branchID) {
                    //专项上报
                    holder.reportModuleItemTakePhotoIpl.setOlnyViewMode(false);
                } else {
                    //专项上报查询
                    holder.reportModuleItemTakePhotoIpl.setOlnyViewMode(true);
                }
                holder.reportModuleItemTakePhotoIpl.refreshPhotoContentView(data.getStoreImageselectList());
                holder.reportModuleItemTakePhotoIpl.setTag(position);
            }
        } else if (data.getType() == 7) {
            holder.reportModuleItemTakeAudioLayout.setVisibility(View.VISIBLE);
            holder.reportModuleItemTakeAudioLayout.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (data.getImgOrVoiceType() == 0) {
                        //既能选择音频，又能录音
                        lvListener.showAudioSelect();
                    } else if (data.getImgOrVoiceType() == 1) {
                        //只能选择音频
                        lvListener.onChooseAudio();
                    } else if (data.getImgOrVoiceType() == 2) {
                        //只能录音
                        lvListener.onTakeAudio();
                    }
                }
            });
        }
        return convertView;
    }
}