package com.wgmf.yxgj.module.business.reportmodule.ui;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.reportmodule.R;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportModuleOptionEntity;
import com.wgmf.yxgj.module.business.reportmodule.service.ReportStaticData;

public class ReportModuleItemSingleChoiceAdapter extends SuperBaseAdpter<ReportModuleOptionEntity> {
    /**
     * 记录选中位置
     */
    private int selected = -1;

    public int getSelected() {
        return selected;
    }

    public void setSelected(int selected) {
        this.selected = selected;
    }

    ReportModuleItemSingleChoiceAdapter(Context context) {
        super(context);
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        View view = inflater.inflate(R.layout.report_module_detail_content_list_item_rb, null);
        LinearLayout reportModuleItemRbLl = (LinearLayout) view.findViewById(R.id.report_module_item_rb_ll);
        TextView tv = (TextView) view.findViewById(R.id.report_module_item_rb_tv);
        TextView iv = (TextView) view.findViewById(R.id.report_module_item_rb);
        ReportModuleOptionEntity item = getItem(position);
        tv.setText(item.getValue());
        initData(item);
        setCheckedData(position, iv, item);
        reportModuleItemRbLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                setCheckedState(position);
            }
        });
        return view;
    }

    private void setCheckedData(int position, TextView iv, ReportModuleOptionEntity item) {
        if (selected == position) {
            //设置为选中
            iv.setBackgroundResource(R.drawable.circle_orange);
            item.setIsChecked(ReportStaticData.getBoolean(true));
        } else {
            iv.setBackgroundResource(R.drawable.circle_gray);
            item.setIsChecked(ReportStaticData.getBoolean(false));
        }
    }

    private void initData(ReportModuleOptionEntity item) {
        //设置选项ID
        item.setModelOptId(item.getModelOptId());
//        if (ReportStaticData.getBoolean(true).equals(item.getIsChecked())) {
//            setSelected(position);
//        }
    }

    private void setCheckedState(int position) {
        if (selected == position) {//点击条目前已经是选中状态，则取消
            setSelected(-1);
        } else {//点击条目前已经是未选中状态，则取消
            setSelected(position);
        }
        super.notifyDataSetChanged();
    }
}