package com.wgmf.yxgj.module.business.reportmodule.ui.level1list;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseBackHandledFragment;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.reportmodule.R;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportProjectListEntity;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportProjectListResultEntity;
import com.wgmf.yxgj.module.business.reportmodule.service.ReportModuleService;
import com.wgmf.yxgj.module.business.reportmodule.service.ReportStaticData;
import com.wgmf.yxgj.module.business.reportmodule.ui.level2list.ReportModuleListActivity2;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;

import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.List;

public class ReportModuleProjectListFragment extends BaseBackHandledFragment implements ReportModuleProjectListAdapter.ClickListener {
    String branchTitle;
    Long branchID;
    private ClearEditText storeNameEt;
    private ListView mListView;
    private ReportModuleProjectListAdapter reportModuleProjectListAdapter;
    private List<ReportProjectListEntity> reportModuleProjectListResultEntities;
    private List<ReportProjectListEntity> reportModuleProjectListResultEntitiesShow;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        branchTitle = getArguments().getString("branchTitle");
        branchID = getArguments().getLong("branchID", 0);
    }

    private void getData() {
        if (null != userInfo) {
            showDialog();
            storeNameEt.setHint(getString(R.string.report_module_by_project_search));
            ReportModuleService.getInstance().requestGetReportByProject(userInfo.getOrganizationCode(), "", ReportStaticData.getFlag(branchID), this);
        }
    }

    @Override
    public View onCreateView(@NotNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_report_module_project_list, container, false);
        // 防止点击穿透，底层的fragment响应上层点击触摸事件
        view.setClickable(true);
        initView(view);
        getData();
        return view;
    }

    private void initView(View view) {
        mListView = (ListView) view.findViewById(R.id.public_list_view_lv);
        storeNameEt = (ClearEditText) view.findViewById(R.id.store_name_et);
        TextView dataEmpty = (TextView) view.findViewById(R.id.public_list_view_empty_tv);
        mListView.setEmptyView(dataEmpty);
        mListView.setVisibility(View.VISIBLE);
        storeNameEt.setVisibility(View.VISIBLE);
        setListener();
    }

    protected void setListener() {
        storeNameEt.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                textChanged();
            }
        });
    }

    public void textChanged() {
        if (null == reportModuleProjectListResultEntitiesShow) {
            reportModuleProjectListResultEntitiesShow = new ArrayList<>();
        }
        String itemId = storeNameEt.getText().toString().trim();
        if (TextUtils.isEmpty(itemId)) {
            reportModuleProjectListResultEntitiesShow.clear();
            if (null != reportModuleProjectListResultEntities) {
                reportModuleProjectListResultEntitiesShow.addAll(reportModuleProjectListResultEntities);
            }

        } else {
            reportModuleProjectListResultEntitiesShow.clear();
            if (null != reportModuleProjectListResultEntities) {
                for (ReportProjectListEntity p : reportModuleProjectListResultEntities) {
                    if (null != p.getReportName()) {
                        if (p.getReportName().contains(itemId)) {
                            reportModuleProjectListResultEntitiesShow.add(p);
                        }
                    }
                }
            }
        }
        reportModuleProjectListAdapter = new ReportModuleProjectListAdapter(getActivity(), this, reportModuleProjectListResultEntitiesShow);
        mListView.setAdapter(reportModuleProjectListAdapter);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.ModuleReport.MSG_ON_GET_REPORT_BY_PROJECT) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    ReportProjectListResultEntity reportModuleProjectListResultEntity = new Gson().fromJson(msg, ReportProjectListResultEntity.class);
                    Log.d(TAG, "reportModuleProjectListResultEntity" + reportModuleProjectListResultEntity);
                    if (null != reportModuleProjectListResultEntity && null != reportModuleProjectListResultEntity.getResult() && ConstantParams.CONSTANT_PARAMS_0.equals(reportModuleProjectListResultEntity.retCode)) {
                        reportModuleProjectListResultEntities = reportModuleProjectListResultEntity.getResult();
                        reportModuleProjectListAdapter = new ReportModuleProjectListAdapter(getActivity(), this, reportModuleProjectListResultEntities);
                        mListView.setAdapter(reportModuleProjectListAdapter);
                    }
                }
            }
        }
    }

    @Override
    public boolean onBackPressed() {
        return false;
    }

    @Override
    public void menberDayAdapterClick(int position) {
        Intent intent = new Intent(getActivity(), ReportModuleListActivity2.class);
        intent.putExtra("method", "queryShop");
        intent.putExtra("branchTitle", branchTitle);
        intent.putExtra("branchID", branchID);
        intent.putExtra("position", position);
        startActivity(intent);
    }
}