package com.wgmf.yxgj.module.business.reportmodule.ui.level1list;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.reportmodule.R;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportShopListEntity;

import java.util.List;

public class ReportModuleShopListAdapter extends BaseAdapter {
    private Context context;
    private List<ReportShopListEntity> reportModuleItemEntities;

    private ClickListener clickListener;

    public interface ClickListener {
        void menberDayAdapterClick(ReportShopListEntity reportShopListEntity, int position);
    }

    public ReportModuleShopListAdapter(Context context, ClickListener clickListener, List<ReportShopListEntity> reportModuleItemEntities) {
        this.context = context;
        this.clickListener = clickListener;
        this.reportModuleItemEntities = reportModuleItemEntities;
    }

    @Override
    public int getCount() {
        return reportModuleItemEntities == null ? 0 : reportModuleItemEntities.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        LinearLayout reportModuleListItemLl;
        TextView reportModuleListItemTitle;
        TextView reportModuleListItemNecessary;
        TextView reportModuleItemStatus;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.report_module_list_item, null);
            holder.reportModuleListItemLl = (LinearLayout) convertView.findViewById(R.id.report_module_list_item_ll);
            holder.reportModuleListItemTitle = (TextView) convertView.findViewById(R.id.report_module_list_item_title);
            holder.reportModuleListItemNecessary = (TextView) convertView.findViewById(R.id.report_module_list_item_necessary);
            holder.reportModuleItemStatus = (TextView) convertView.findViewById(R.id.report_module_item_status);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final ReportShopListEntity data = reportModuleItemEntities.get(position);
        holder.reportModuleListItemTitle.setText(data.getShopName());
        holder.reportModuleListItemNecessary.setText(data.getStatusStr());
        holder.reportModuleItemStatus.setText(data.getStatusStr());
        holder.reportModuleListItemNecessary.setVisibility(View.VISIBLE);
        holder.reportModuleItemStatus.setVisibility(View.GONE);
        if (6 == data.getStatus()) {
            //不需上报
            holder.reportModuleListItemNecessary.setVisibility(View.GONE);
        }
        holder.reportModuleListItemLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickListener.menberDayAdapterClick(data, position);
            }
        });
        return convertView;
    }
}