package com.wgmf.yxgj.module.business.reportmodule.ui.level2list;

import android.os.Bundle;
import android.support.v4.app.FragmentTransaction;
import android.view.View;

import com.wgmf.yxgj.base.BackHandledInterface;
import com.wgmf.yxgj.base.BaseBackHandledFragment;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.module.business.reportmodule.R;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportProjectListEntity;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportShopListEntity;

import java.io.Serializable;
import java.util.List;

public class ReportModuleListActivity2 extends BaseParentAct implements BackHandledInterface {
    private BaseBackHandledFragment mBackHandedFragment;

    @Override
    protected void initTitle() {
        super.initTitle();
        String branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText(branchTitle);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_report_module_list);
        initTitle();
        initFragment();
    }

    private void initFragment() {
        int position = getIntent().getIntExtra("position",0);
        String method = getIntent().getStringExtra("method");
        String shopId = getIntent().getStringExtra("shopId");
        String shopName = getIntent().getStringExtra("shopName");
        Long branchID = getIntent().getLongExtra("branchID",0);
       //如果是项目入口，则第二级查询门店数据
        if ("queryShop".equals(method)) {
            ReportModuleShopListFragment2 reportModuleShopListFragment2 = new ReportModuleShopListFragment2();
            Bundle bundle = new Bundle();
            bundle.putLong("branchID", branchID);
            bundle.putInt("position", position);
            reportModuleShopListFragment2.setArguments(bundle);
            loadFragment("reportModuleShopListFragment2", reportModuleShopListFragment2);
        } else {
            ReportModuleProjectListFragment2 reportModuleProjectListFragment2 = new ReportModuleProjectListFragment2();
            Bundle bundle = new Bundle();
            bundle.putLong("branchID", branchID);
            bundle.putString("shopId", shopId);
            bundle.putString("shopName", shopName);
            bundle.putInt("position", position);
            reportModuleProjectListFragment2.setArguments(bundle);
            loadFragment("reportModuleProjectListFragment2", reportModuleProjectListFragment2);
        }
    }

    /**
     * 加载内容
     *
     * @param tag      标签
     * @param fragment 内容
     */
    public void loadFragment(String tag, BaseBackHandledFragment fragment) {
        FragmentTransaction ft = getSupportFragmentManager().beginTransaction();
        ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_OPEN);
        ft.replace(R.id.report_module_list_fl, fragment);
        ft.addToBackStack(tag);
        ft.commit();
    }


    @Override
    public void setSelectedFragment(BaseBackHandledFragment selectedFragment) {
        this.mBackHandedFragment = selectedFragment;
    }

    @Override
    public void onBackPressed() {
        if (mBackHandedFragment == null || !mBackHandedFragment.onBackPressed()) {
            if (getFragmentManager().getBackStackEntryCount() == 0) {
                this.finish();
            } else {
                getFragmentManager().popBackStack();
            }
        }
    }

    @Override
    protected void back() {
        //使Fragment界面一级级返回
        onBackPressed();
    }
}