package com.wgmf.yxgj.module.business.reportmodule.ui.level2list;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseBackHandledFragment;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.reportmodule.R;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportProjectListEntity;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportShopListResultEntity;
import com.wgmf.yxgj.module.business.reportmodule.service.ReportModuleService;
import com.wgmf.yxgj.module.business.reportmodule.service.ReportStaticData;
import com.wgmf.yxgj.module.business.reportmodule.ui.ReportModuleDetailActivity;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;

import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.List;

public class ReportModuleProjectListFragment2 extends BaseBackHandledFragment implements ReportModuleProjectListAdapter2.ClickListener {
    private ClearEditText storeNameEt;
    private ListView mListView;
    private ReportModuleProjectListAdapter2 reportModuleProjectListAdapter;
    private List<ReportProjectListEntity> reportProjectListEntities;
    private List<ReportProjectListEntity> reportProjectListEntitiesShow;
    private int position;
    private Long branchID;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        position = getArguments().getInt("position", 0);
        branchID = getArguments().getLong("branchID", 0);
    }

    private void getData() {
        //查询最新的数据，拿第二层列表内容
        if (null != userInfo) {
            showDialog();
            ReportModuleService.getInstance().requestGetReportByShop(userInfo.getOrganizationCode(), "", ReportStaticData.getFlag(branchID), this);
        }
    }

    @Override
    public void onResume() {
        super.onResume();
        getData();
    }

    @Override
    public View onCreateView(@NotNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_report_module_project_list, container, false);
        // 防止点击穿透，底层的fragment响应上层点击触摸事件
        view.setClickable(true);
        initView(view);
        return view;
    }

    private void initView(View view) {
        mListView = (ListView) view.findViewById(R.id.public_list_view_lv);
        storeNameEt = (ClearEditText) view.findViewById(R.id.store_name_et);
        TextView dataEmpty = (TextView) view.findViewById(R.id.public_list_view_empty_tv);
        mListView.setEmptyView(dataEmpty);
        mListView.setVisibility(View.VISIBLE);
        storeNameEt.setVisibility(View.VISIBLE);
        storeNameEt.setHint(getString(R.string.report_module_by_project_search));
        setListener();
    }

    protected void setListener() {
        storeNameEt.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                textChanged();
            }
        });
    }

    public void textChanged() {
        if (null == reportProjectListEntitiesShow) {
            reportProjectListEntitiesShow = new ArrayList<>();
        }
        String itemId = storeNameEt.getText().toString().trim();
        if (TextUtils.isEmpty(itemId)) {
            reportProjectListEntitiesShow.clear();
            if (null != reportProjectListEntities) {
                reportProjectListEntitiesShow.addAll(reportProjectListEntities);
            }

        } else {
            reportProjectListEntitiesShow.clear();
            if (null != reportProjectListEntities) {
                for (ReportProjectListEntity p : reportProjectListEntities) {
                    if (null != p.getReportName()) {
                        if (p.getReportName().contains(itemId)) {
                            reportProjectListEntitiesShow.add(p);
                        }
                    }
                }
            }
        }
        reportModuleProjectListAdapter = new ReportModuleProjectListAdapter2(getActivity(), this, reportProjectListEntitiesShow);
        mListView.setAdapter(reportModuleProjectListAdapter);
    }

    @Override
    public boolean onBackPressed() {
        return false;
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.ModuleReport.MSG_ON_GET_REPORT_BY_SHOP) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    ReportShopListResultEntity reportModuleShopResultEntity = new Gson().fromJson(msg, ReportShopListResultEntity.class);
                    Log.d(TAG, "reportModuleShopResultEntity" + reportModuleShopResultEntity);
                    if (null != reportModuleShopResultEntity && null != reportModuleShopResultEntity.getResult() && ConstantParams.CONSTANT_PARAMS_0.equals(reportModuleShopResultEntity.retCode)) {
                        reportProjectListEntities = reportModuleShopResultEntity.getResult().get(position).getStandardList();
                        reportModuleProjectListAdapter = new ReportModuleProjectListAdapter2(getActivity(), this, reportProjectListEntities);
                        mListView.setAdapter(reportModuleProjectListAdapter);
                    }
                }
            }
        }
    }

    @Override
    public void menberDayAdapterClick(ReportProjectListEntity reportProjectListEntity) {
        //updateFlag (string, optional):修改标识：1/不可修改，0/可修改
        // 状态为不可修改时，点击不能进入详情页；状态为可修改时，可进入详情页提交数据。
        if(1 == reportProjectListEntity.getUpdateFlag()) {
            showMsg(reportProjectListEntity.getStatusStr()+",不可修改!");
        }else {
            String shopId = getArguments().getString("shopId");
            String shopName = getArguments().getString("shopName");
            Long branchID = getArguments().getLong("branchID", 0);
            Intent intent = new Intent(getActivity(), ReportModuleDetailActivity.class);
            intent.putExtra("standardId", reportProjectListEntity.getStandardId());
            intent.putExtra("shopId", shopId);
            intent.putExtra("shopName", shopName);
            intent.putExtra("branchID", branchID);
            startActivity(intent);
        }
    }
}