package com.wgmf.yxgj.module.business.reportmodule.ui.level2list;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.reportmodule.R;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportShopListEntity;
import com.wgmf.yxgj.widgets.TextView.MarqueeTextView;

import java.util.List;

public class ReportModuleShopListAdapter2 extends BaseAdapter {
    private Context context;
    private List<ReportShopListEntity> reportShopListEntities;

    private ClickListener clickListener;

    public interface ClickListener {
        void menberDayAdapterClick(ReportShopListEntity shopDataEntity);
    }

    public ReportModuleShopListAdapter2(Context context, ClickListener clickListener, List<ReportShopListEntity> reportModuleItemEntities) {
        this.context = context;
        this.clickListener = clickListener;
        this.reportShopListEntities = reportModuleItemEntities;
    }

    @Override
    public int getCount() {
        return reportShopListEntities == null ? 0 : reportShopListEntities.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        LinearLayout reportModuleListItemLl;
        TextView reportModuleListItemTitle;
        TextView reportModuleListItemNecessary;
        TextView reportModuleItemStatus;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.report_module_list_item, null);
            holder.reportModuleListItemLl = (LinearLayout) convertView.findViewById(R.id.report_module_list_item_ll);
            holder.reportModuleListItemTitle = (TextView) convertView.findViewById(R.id.report_module_list_item_title);
            holder.reportModuleListItemNecessary = (TextView) convertView.findViewById(R.id.report_module_list_item_necessary);
            holder.reportModuleItemStatus = (TextView) convertView.findViewById(R.id.report_module_item_status);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final ReportShopListEntity data = reportShopListEntities.get(position);
        holder.reportModuleListItemNecessary.setVisibility(View.GONE);
        holder.reportModuleItemStatus.setVisibility(View.VISIBLE);
        holder.reportModuleListItemNecessary.setText(data.getStatusStr());
        holder.reportModuleItemStatus.setText(data.getStatusStr());
        // 1:待审核 2:审核通过 3:审核不通过 4:审核不通过再次提交 5:待上报
        if (5 == data.getStatus()) {
            // 5:待上报
            holder.reportModuleItemStatus.setTextColor(ContextCompat.getColor(context, R.color.red));
        } else if (1 == data.getStatus()) {
            //1:待审核
            holder.reportModuleItemStatus.setTextColor(ContextCompat.getColor(context, R.color.normal_color));
        } else if (2 == data.getStatus()) {
            //2:审核通过
            holder.reportModuleItemStatus.setTextColor(ContextCompat.getColor(context, R.color.green));
        } else if (3 == data.getStatus() || 4 == data.getStatus()) {
            //3:审核不通过
            holder.reportModuleItemStatus.setTextColor(ContextCompat.getColor(context, R.color.red));
        }
        holder.reportModuleListItemLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                clickListener.menberDayAdapterClick(data);
            }
        });
        holder.reportModuleListItemTitle.setText(data.getShopName());
        return convertView;
    }
}