package com.wgmf.yxgj.module.business.reportmonthly.ui;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.ExpandableListView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.global.CountsParams;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.MonthReportAppraiseEdtDialog;
import com.wgmf.yxgj.dialog.MonthReportAppraiseTxtDialog;
import com.wgmf.yxgj.dialog.PublicConformTipDialog;
import com.wgmf.yxgj.dialog.PublicTipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.model.MessageExtraEntity;
import com.wgmf.yxgj.module.business.reportmonthly.R;
import com.wgmf.yxgj.module.business.reportmonthly.model.MonthlyReportBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.MonthlyReportParamListBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.MonthlyReportReplyBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.MonthlyReportSummalyBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.MonthlyReportTypeListBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.NormMonthlyReportListBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.NormMonthlyReportTypeListBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.PerformaceMonthlyReportEntity;
import com.wgmf.yxgj.module.business.reportmonthly.model.QueryUserInfoEntity;
import com.wgmf.yxgj.module.business.reportmonthly.model.SaveMonthlyReportEntity;
import com.wgmf.yxgj.module.business.reportmonthly.model.SaveMonthlyReportSummalyEntity;
import com.wgmf.yxgj.module.business.reportmonthly.model.TotalPerfomanceResultEntry;
import com.wgmf.yxgj.module.business.reportmonthly.service.MonthlyReportService;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.service.MainService;
import com.wgmf.yxgj.publics.service.ToFunctionByResId;
import com.wgmf.yxgj.publics.service.TotalPerfomanceManager;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.xp.arouter.RouterParams;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;


/**
 * 月报：月计划，月总结，月报查询
 *
 * @author XiePing
 * 2016/6/17 11:40
 */
@SuppressWarnings("all")
@Route(path = RouterParams.URL_MONTHREPORTACTIVITY)
public class MonthReportActivity extends BaseParentAct implements
        View.OnClickListener {

    private LinearLayout monthReportTopLl;
    private LinearLayout submitLl;
    private ExpandableListView monthReportElv;
    private TextView submitTv;
    private TextView saveTv;
    private TextView modifyTv;
    private TextView planTv;
    private TextView summalyTv;
    private TextView monthReportTopLeftTv;
    private TextView monthReportTopCenterTv;
    private TextView monthReportTopRightTv;
    private TextView monthReportHeaderviewExamGradeValueTv;
    private TextView monthReportHeaderviewExamRankValueTv;
    private TextView monthReportHeaderviewExamPointValueTv;
    private MonthReportAdapter monthReportAdapter;
    private SaveMonthlyReportEntity mSaveMonthlyReportEntity;
    private List<MonthlyReportTypeListBean> mMonthlyReportTypeList;
    private List<NormMonthlyReportTypeListBean> mNormMonthlyReportTypeList;
    private List<QueryUserInfoEntity> mQueryUserInfoEntitys;
    /**
     * 查询模式下，下级人员列表
     */
    private static final String LIST_TAG = "list";
    /**
     * 查询模式下，初始选中下级人员在数组中的位置
     */
    private static final String INDEX_TAG = "index";
    /**
     * 查询模式下，选中下级人员数据
     */
    private static final String SELECTOR_TAG = "selector";
    /**
     * 保存标志
     */
    private static final String SAVE_TAG = "save";
    /**
     * 提交标志
     */
    private static final String SUBMIT_TAG = "submit";
    /**
     * 消息标志标志
     */
    private int MSGTAG = 0;
    /**
     * 是否是提交数据
     */
    private boolean isSubmit = false;
    /**
     * 标题
     */
    private String title;
    private String person;
    private String oeRole;
    private String mOrgCode;
    private String mStaffId;
    /**
     * 查询模式下，被查询人在数组中的位置指针
     */
    private int index;
    /**
     * 查询模式下选中的年，月
     */
    private int years;
    private int months;
    private String queryMonth;
    private String weekMonth;
    /**
     * 查询的年月，周数计算的年月,消息入口返回的年月
     */
    private String trueMonth;
    /**
     * 待查询人员的组织机构，用于查询全面绩效
     */
    private String mOrganization;

    /**
     * 消息入口标志，1,是从通知进来
     */
    private int msgFlag;
    /**
     * 0，填写月计划；1，填写月总结；2，查询月总结与月计划
     */
    private int funcPosition;
    /**
     * 可编辑或不可编辑模式，0为不可编辑模式，1，为总结可编辑模式，2，为计划可编辑模式。
     */
    private int mode = 0;
    /**
     * 查询模式下是否是查询本人的标志，查询本人为true
     */
    private boolean isSelf = true;
    /**
     * 是否保存过计划数据，保存后可修改，默认为false
     */
    private boolean isPlanSave = false;
    /**
     * 是否保存过总结数据，保存后可修改，默认为false
     */
    private boolean isSummalySave = false;
    /**
     * 是否是不可编辑切换为可编辑状态
     */
    private boolean isEdit = false;
    /**
     * 计划是否提交标志
     */
    private int submitPlanFlag;
    private int submitSummalyFlag;
    /**
     * 计划批复标志
     */
    private Integer planAppraiseFlag;
    /**
     * 总结批复标志
     */
    private Integer summalyAppraiseFlag;
    /**
     * 默认第一次进入页面
     */
    private Boolean firstEntry = true;
    private int isPlanAppraiseComplete;
    private int isSummalyAppraiseComplete;
    private String planAppraiseMsg;
    private String summalyAppraiseMsg;
    private MonthlyReportReplyBean mAppriaseMonthlyReportEtity;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.month_report_activity);
        EventBus.getDefault().register(this);
        initTitle();
        initView();
        initContent();
        switchMode();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initView() {
        //查询模式下，下级人员切换显示布局
        monthReportTopLl = (LinearLayout) findViewById(R.id.month_report_top_ll);
        monthReportTopLeftTv = (TextView) findViewById(R.id.month_report_top_left_tv);
        monthReportTopCenterTv = (TextView) findViewById(R.id.month_report_top_center_tv);
        monthReportTopRightTv = (TextView) findViewById(R.id.month_report_top_right_tv);
        //底部保存，提交按钮布局
        submitLl = (LinearLayout) findViewById(R.id.submit_ll);
        submitTv = (TextView) findViewById(R.id.submit_tv);
        modifyTv = (TextView) findViewById(R.id.modify_tv);
        saveTv = (TextView) findViewById(R.id.save_tv);
        planTv = (TextView) findViewById(R.id.plan_tv);
        summalyTv = (TextView) findViewById(R.id.summaly_tv);
        //可扩展列表控件
        monthReportElv = (ExpandableListView) findViewById(R.id.month_report_elv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        monthReportElv.setEmptyView(emptyView);
        // 为列表添加头布局
        View headerView = getLayoutInflater().inflate(R.layout.month_report_headerview, null);
        monthReportElv.addHeaderView(headerView);
        monthReportHeaderviewExamGradeValueTv = (TextView) findViewById(R.id.month_report_headerview_exam_grade_value_tv);
        monthReportHeaderviewExamRankValueTv = (TextView) findViewById(R.id.month_report_headerview_exam_rank_value_tv);
        monthReportHeaderviewExamPointValueTv = (TextView) findViewById(R.id.month_report_headerview_exam_point_value_tv);
    }

    private void initContent() {
        mMonthlyReportTypeList = new ArrayList<>();
        mNormMonthlyReportTypeList = new ArrayList<>();
        mSaveMonthlyReportEntity = new SaveMonthlyReportEntity();
        mAppriaseMonthlyReportEtity = new MonthlyReportReplyBean();

        //为页面布局设置点击事件
        submitTv.setOnClickListener(this);
        modifyTv.setOnClickListener(this);
        saveTv.setOnClickListener(this);
        planTv.setOnClickListener(this);
        summalyTv.setOnClickListener(this);
        monthReportTopCenterTv.setOnClickListener(this);
        monthReportTopRightTv.setOnClickListener(this);
        monthReportTopLeftTv.setOnClickListener(this);
    }

    /**
     * 根据相应功能显示不同布局
     */
    private void switchMode() {
        msgFlag = getIntent().getIntExtra("msg", 0);
        Long resId = getIntent().getLongExtra("branchID", 0);
        funcPosition = ToFunctionByResId.getMonthType(resId);
        monthReportTopLl.setVisibility(View.GONE);

        if (0 == funcPosition) {
            if (null != userInfo) {
                mStaffId = userInfo.getStaffId();
                oeRole = userInfo.getOeRole();
                mOrganization = userInfo.getOrganization();
                mOrgCode = userInfo.getOrganizationCode();
                person = userInfo.getName();
            } else {
                showMsg("用户数据丢失，请重新登录获取！");
                return;
            }
            //当月工作计划
            title = DateUtil.getFormatMonth("yyyy年M月", 0) + "工作计划";
        } else if (1 == funcPosition) {
            if (null != userInfo) {
                mStaffId = userInfo.getStaffId();
                oeRole = userInfo.getOeRole();
                mOrganization = userInfo.getOrganization();
                mOrgCode = userInfo.getOrganizationCode();
                person = userInfo.getName();
            } else {
                showMsg("用户数据丢失，请重新登录获取！");
                return;
            }
            //上月工作总结
            title = DateUtil.getFormatMonth("yyyy年M月", -1) + "工作总结";
        } else if (2 == funcPosition) {
            if (msgFlag != 1) {
                //非消息入口进入
                years = getIntent().getIntExtra("years", 0);
                months = getIntent().getIntExtra("months", 0);
                person = getIntent().getStringExtra("person");
                oeRole = getIntent().getStringExtra("oeRole");
                mOrganization = getIntent().getStringExtra("mOrganization");
                mOrgCode = getIntent().getStringExtra("mCode");
                mStaffId = getIntent().getStringExtra("mStaffId");
                isSelf = getIntent().getBooleanExtra("isSelf", true);
                mQueryUserInfoEntitys = (List<QueryUserInfoEntity>) getIntent().getSerializableExtra(LIST_TAG);
                index = getIntent().getIntExtra(INDEX_TAG, 0);
                title = years + "年" + (months + 1) + "月" + "工作计划与总结";
                //默认查询当月工作总结与计划
            } else {
                //从消息入口进入
                isSelf = false;
                mStaffId = getIntent().getStringExtra("operatorId");
                mOrgCode = getIntent().getStringExtra("code");
                person = getIntent().getStringExtra("staffName");
                String msgMonth = getIntent().getStringExtra("yearMonth");
                try {
                    trueMonth = queryMonth = DateUtil.getFormatMonthFromTo(msgMonth);
                    Log.e(TAG, "queryMonth=" + queryMonth);
                    Log.e(TAG, "trueMonth=" + trueMonth);
                    years = Integer.parseInt(queryMonth.substring(0, 4));
                    months = Integer.parseInt(queryMonth.substring(5, 7));
                    Log.e(TAG, "mStaffId=" + mStaffId);
                    Log.e(TAG, "mOrgCode=" + mOrgCode);
                    Log.e(TAG, "years=" + years);
                    Log.e(TAG, "months=" + months);
                    Log.e(TAG, "person=" + person);
                    title = years + "年" + (months + 1) + "月" + "工作计划与总结";
                    //默认查询当月工作总结与计划
                } catch (Exception e) {
                    showMsg("无法获取改消息类型！");
                    this.finish();
                }
            }

            monthReportTopLl.setVisibility(View.VISIBLE);
            monthReportTopCenterTv.setText(person);
            if (isSelf) {
                // 查询本人
                if (msgFlag != 1 && null != userInfo) {
                    mStaffId = userInfo.getStaffId();
                    oeRole = userInfo.getOeRole();
                    mOrganization = userInfo.getOrganization();
                }
                monthReportTopCenterTv.setCompoundDrawables(null, null, null, null);
                monthReportTopCenterTv.setOnClickListener(null);
                monthReportTopLeftTv.setVisibility(View.INVISIBLE);
                monthReportTopRightTv.setVisibility(View.INVISIBLE);
                submitLl.setVisibility(View.VISIBLE);
            } else {
                // 查询下级
                monthReportTopCenterTv.setCompoundDrawables(
                        null,
                        null,
                        getResources().getDrawable(
                                R.drawable.month_report_down_right), null);
                monthReportTopCenterTv.setOnClickListener(this);
                monthReportTopLeftTv.setVisibility(View.VISIBLE);
                monthReportTopRightTv.setVisibility(View.VISIBLE);

                submitLl.setVisibility(View.VISIBLE);
                saveTv.setText("批复计划");
                submitTv.setText("批复总结");
            }
        }
        homeTitleText.setText(title);
        getTotalPerfomance();//获取全面绩效
        getPerformaceMonthlyReport();//获取月报内容
    }

    /**
     * 获取全面绩效情况
     */
    private void getTotalPerfomance() {
        if (funcPosition == 0) {
            //计划查前一个月的全面绩效
            queryMonth = DateUtil.getFormatMonth("yyyy-MM", -1);
            weekMonth = DateUtil.getFormatMonth("yyyy-MM", 1);
            trueMonth = DateUtil.getFormatMonth("yyyy-MM", 0);
        } else if (funcPosition == 1) {
            //总结查上上月的全面绩效
            queryMonth = DateUtil.getFormatMonth("yyyy-MM", -2);
            weekMonth = DateUtil.getFormatMonth("yyyy-MM", 0);
            trueMonth = DateUtil.getFormatMonth("yyyy-MM", -1);
        } else if (funcPosition == 2) {
            //查询默认查当月
            queryMonth = DateUtil.getFormatMonthFromTo(years + "-" + months);
            trueMonth = DateUtil.getFormatMonthFromTo(years + "-" + (months + 1));
            weekMonth = DateUtil.getFormatMonthFromTo(years + "-" + (months + 2) + "");
        }

        Log.e(TAG, "查询：" + queryMonth);

        Log.e(TAG, "需提交的月份）：" + trueMonth);
        Log.e(TAG, "查询周月份（实际－1）：" + weekMonth);

        if (msgFlag == 1) {
            //消息入口进入
            oeRole = TotalPerfomanceManager.getOeRoleBylength(oeRole, mOrgCode);
            mOrganization = TotalPerfomanceManager.getOrgBylength(mOrgCode);
        }
        Log.e(TAG, "oeRole：" + oeRole);
        Log.e(TAG, "mOrganization：" + mOrganization);

        String url = TotalPerfomanceManager.getTotalPerfomance(oeRole, mOrganization);
        if (url.contains(NetworkParams.URL_ERROR)) {
            showMsg(mOrganization + "人员，无全面绩效数据");
        } else {
            MonthlyReportService.getInstance().requestTotalPerfomance(queryMonth, mOrgCode, url, MonthReportActivity.this);
        }
    }

    /**
     * 新增月报前查询
     */
    private void getPerformaceMonthlyReport() {
        showDialog();
        MonthlyReportService.getInstance().requestMonthlyReport(queryMonth, mStaffId, mOrgCode, MonthReportActivity.this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        planAppraiseFlag = null;
        summalyAppraiseFlag = null;
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.MonthlyWeekReport.MSG_ON_TOTAL_PERFOMANCE: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        try {
                            TotalPerfomanceResultEntry mTotalPerfomanceResultEntry = new Gson()
                                    .fromJson(msg, TotalPerfomanceResultEntry.class);
                            Log.d(TAG, "mTotalPerfomanceResultEntry="
                                    + mTotalPerfomanceResultEntry.toString());
                            if (!mTotalPerfomanceResultEntry.getResultList().isEmpty()) {
                                EventBus.getDefault().post(mTotalPerfomanceResultEntry);
                            } else {
                                createConformTipDialog();
                            }
                        } catch (Exception e) {
                            showMsg(getString(R.string.request_data_fail));
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.MonthlyWeekReport.MSG_ON_GETPERFORMACE_MONTHLYREPORT: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        try {
                            PerformaceMonthlyReportEntity mPerformaceMonthlyReportEntity = new Gson()
                                    .fromJson(msg, PerformaceMonthlyReportEntity.class);
                            Log.d(TAG, "mPerformaceMonthlyReportEntity="
                                    + mPerformaceMonthlyReportEntity.toString());
                            EventBus.getDefault().post(mPerformaceMonthlyReportEntity);
                        } catch (Exception e) {
                            showMsg(getString(R.string.request_data_fail));
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.MonthlyWeekReport.MSG_ON_SAVE_MONTHLYREPORT: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        try {
                            BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                            Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                            if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                                if (isSubmit) {
                                    sendMessageToJPush(trueMonth, 1);
                                }
                                getPerformaceMonthlyReport();
                            }
                            showMsg(mBaseResponse.retInfo);
                        } catch (Exception e) {
                            showMsg(getString(R.string.request_data_fail));
                        }
                    } else {
                        if (!TextUtils.isEmpty(msg)) {
                            showMsg(result.getResultInfo());
                        }
                    }
                }
                break;
                case BusinessID.MonthlyWeekReport.MSG_ON_APPRIASE_MONTHLYREPORT: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        try {
                            BaseResponse mBaseResponse = new Gson().fromJson(msg,
                                    BaseResponse.class);
                            Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                            if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                                sendMessageToJPush(trueMonth, MSGTAG);
                                getTotalPerfomance();//获取全面绩效
                                getPerformaceMonthlyReport();//获取月报内容
                                planAppraiseFlag = null;
                                summalyAppraiseFlag = null;
                            }
                            showMsg(mBaseResponse.retInfo);
                        } catch (Exception e) {
                            showMsg(getString(R.string.request_data_fail));
                        }
                    } else {
                        if (!TextUtils.isEmpty(msg)) {
                            showMsg(result.getResultInfo());
                        }
                    }
                }
                break;
                case BusinessID.MonthlyWeekReport.MSG_ON_SAVE_MONTHLYREPORT_SUMMALY: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        try {
                            BaseResponse mBaseResponse = new Gson().fromJson(msg,
                                    BaseResponse.class);
                            Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                            if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                                if (isSubmit) {
                                    sendMessageToJPush(trueMonth, 2);
                                }
                                getPerformaceMonthlyReport();
                            }
                            showMsg(mBaseResponse.retInfo);
                        } catch (Exception e) {
                            showMsg(getString(R.string.request_data_fail));
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    /**
     * 全面绩效返回数据显示
     */
    @Subscribe
    public void onEventMainThread(TotalPerfomanceResultEntry item) {
        String mGrade = "--";
        String mRank = "--";
        String mTotal = "--";

        if (null != item) {
            if (null != item.getResultList().get(0).getGrade()) {
                mGrade = item.getResultList().get(0).getGrade();
            }
            if (!ConstantParams.CONSTANT_PARAMS_0.equals(item.getResultList().get(0).getRank())) {
                mRank = item.getResultList().get(0).getRank();
            }
            if (!ConstantParams.CONSTANT_PARAMS_0.equals(item.getResultList().get(0).getPoint())) {
                //先将String转化为double类型
                double point = Double.valueOf(item.getResultList().get(0).getPoint());
                //再对double类型数据四舍五入保留两位小数
                mTotal = new DecimalFormat("#.00").format(point);
            }
            Log.d("查询数据mGrade：", mGrade);
            Log.d("查询数据mRank：", mRank);
            monthReportHeaderviewExamGradeValueTv.setText(mGrade);
            monthReportHeaderviewExamRankValueTv.setText(mRank);
            monthReportHeaderviewExamPointValueTv.setText(mTotal);
        }
    }

    /**
     * 新增月报前查询返回的数据显示
     */
    @Subscribe
    public void onEventMainThread(PerformaceMonthlyReportEntity item) {
        if (null != item) {
            mNormMonthlyReportTypeList = item.getNormMonthlyReportTypeList();
            if (null != mNormMonthlyReportTypeList) {
                String mPerformaceMonthlyReportEntity = new Gson().toJson(item);
                Log.d("查询数据：", mPerformaceMonthlyReportEntity);

                for (int i = 0; i < mNormMonthlyReportTypeList.size(); i++) {
                    List<NormMonthlyReportListBean> mNormMonthlyReportListBean = mNormMonthlyReportTypeList
                            .get(i).getNormMonthlyReportList();
                    for (int j = 0; j < mNormMonthlyReportListBean.size(); j++) {
                        MonthlyReportBean getMonthlyReport = mNormMonthlyReportListBean
                                .get(j).getMonthlyReport();
                        if (null != getMonthlyReport) {
                            // 填写月计划，若存在已保存数据，保存按钮显示为修改
                            if (funcPosition == 0) {
                                isPlanSave = true;
                                //计划有保存过
                            } else if ((funcPosition == 1 || funcPosition == 2) && null != getMonthlyReport.getMonthlyReportSummaly()) {
                                isSummalySave = true;
                                //总结有保存过
                            }
                            // 列表中的提交字段值相同，可多次赋值
                            if (null != getMonthlyReport.getMonthlyReportReply()) {
                                submitPlanFlag = getMonthlyReport.getMonthlyReportReply().getPlanSubmitFlag();
                                submitSummalyFlag = getMonthlyReport.getMonthlyReportReply().getSummalySubmitFlag();
                                planAppraiseFlag = getMonthlyReport.getMonthlyReportReply().getPlanAppraiseFlag();
                                summalyAppraiseFlag = getMonthlyReport.getMonthlyReportReply().getSummalyAppraiseFlag();
                                planAppraiseMsg = getMonthlyReport.getMonthlyReportReply().getPlanAppraise();
                                summalyAppraiseMsg = getMonthlyReport.getMonthlyReportReply().getSummalyAppraise();
                                isPlanAppraiseComplete = getMonthlyReport.getMonthlyReportReply().getPlanIsNotPass();
                                isSummalyAppraiseComplete = getMonthlyReport.getMonthlyReportReply().getSummalyIsNotPass();
                            }
                        }
                    }
                }
            }
            Log.d(TAG, "submitPlanFlag=" + submitPlanFlag);
            Log.d(TAG, "submitSummalyFlag=" + submitSummalyFlag);
            Log.d(TAG, "planAppraiseFlag=" + planAppraiseFlag);
            Log.d(TAG, "summalyAppraiseFlag=" + summalyAppraiseFlag);

            if (funcPosition == 0) {
                if (submitPlanFlag == 1) {
                    // 如果计划已提交，则不能重复提交
                    submitLl.setVisibility(View.GONE);
                    mode = 0;
                } else {
                    submitLl.setVisibility(View.VISIBLE);
                    submitTv.setVisibility(View.VISIBLE);
                    if (isPlanSave && !firstEntry) {
                        //如果计划有保存并且非第一次进入
                        modifyTv.setVisibility(View.VISIBLE);
                        saveTv.setVisibility(View.GONE);
                        mode = 0;
                    } else {
                        modifyTv.setVisibility(View.GONE);
                        saveTv.setVisibility(View.VISIBLE);
                        mode = 2;
                        //计划填写模式,不过滤数据
                    }
                    if (isEdit) {
                        modifyTv.setVisibility(View.GONE);
                        saveTv.setVisibility(View.VISIBLE);
                        mode = 2;
                        //计划填写模式,不过滤数据
                    }
                }
            } else if ((funcPosition == 1)) {
                if (submitSummalyFlag == 1) {
                    // 如果总结已提交，则不能重复提交
                    submitLl.setVisibility(View.GONE);
                    mode = 0;
                } else if (submitPlanFlag == 1) {
                    if (isEdit) {
                        submitLl.setVisibility(View.VISIBLE);
                        submitTv.setVisibility(View.VISIBLE);
                        modifyTv.setVisibility(View.GONE);
                        saveTv.setVisibility(View.VISIBLE);
                        mode = 1;
                        //总结填写模式,不过滤数据
                    } else {
                        if (isSummalySave && !firstEntry) {
                            //如果总结有保存并且非第一次进入
                            submitLl.setVisibility(View.VISIBLE);
                            submitTv.setVisibility(View.VISIBLE);
                            modifyTv.setVisibility(View.VISIBLE);
                            saveTv.setVisibility(View.GONE);
                            mode = 0;
                        } else {
                            submitLl.setVisibility(View.VISIBLE);
                            submitTv.setVisibility(View.VISIBLE);
                            modifyTv.setVisibility(View.GONE);
                            saveTv.setVisibility(View.VISIBLE);
                            mode = 1;
                            //总结填写模式
                        }
                    }
                }
            } else if ((funcPosition == 2)) {
                if (isSelf) {
                    //本人
                    if (submitSummalyFlag == 1) {
                        // 如果总结已提交，则不能重复提交
                        mode = 0;
                        // 总结查询模式
                    } else {
                        //查询本人月度计划和总结不支持修改功能，用户要修改的话用填写月度计划和总结功能
                        mode = 0;
                        //计划查询模式
                        if (isEdit) {
                            //如果是可编辑状态
                            modifyTv.setVisibility(View.GONE);
                            if (submitPlanFlag == 1) {
                                //如果计划已提交则可不可修改计划，只可修改总结
                                mode = 1;
                                //总结填写模式
                            } else {
                                mode = 2;
                                //计划修改模式
                            }
                        } else {
                            if (msgFlag != 1) {
                                //如果从非消息入口进入
                                saveTv.setVisibility(View.GONE);
                            } else {
                                submitLl.setVisibility(View.GONE);
                                modifyTv.setVisibility(View.GONE);
                                saveTv.setVisibility(View.GONE);
                                submitTv.setVisibility(View.GONE);
                            }
                        }
                    }
                } else {//查询非本人
                    mode = 0;
                    submitLl.setVisibility(View.GONE);
                    if (submitPlanFlag == 1 && null != planAppraiseFlag && planAppraiseFlag == 0) {
                        //如果计划已批复则不可重复批复
                        submitLl.setVisibility(View.VISIBLE);
                        saveTv.setVisibility(View.VISIBLE);
                    } else {
                        saveTv.setVisibility(View.GONE);
                    }
                    if (submitSummalyFlag == 1 && null != summalyAppraiseFlag && summalyAppraiseFlag == 0) {
                        //如果总结已批复则不可重复批复
                        submitLl.setVisibility(View.VISIBLE);
                        submitTv.setVisibility(View.VISIBLE);
                    } else {
                        submitTv.setVisibility(View.GONE);
                    }
                }
                if (submitPlanFlag == 1 && null != planAppraiseFlag && planAppraiseFlag == 1) {
                    submitLl.setVisibility(View.VISIBLE);
                    planTv.setVisibility(View.VISIBLE);
                    planTv.setText("计划批复结果");
                } else {
                    planTv.setVisibility(View.GONE);
                }
                if (submitSummalyFlag == 1 && null != summalyAppraiseFlag && summalyAppraiseFlag == 1) {
                    submitLl.setVisibility(View.VISIBLE);
                    summalyTv.setVisibility(View.VISIBLE);
                    summalyTv.setText("总结批复结果");
                } else {
                    summalyTv.setVisibility(View.GONE);
                }
            }
            if (mode != 2) {
                //查询下的数据过滤
                for (int i = 0; i < mNormMonthlyReportTypeList.size(); i++) {
                    List<NormMonthlyReportListBean> mNormMonthlyReportListBean = mNormMonthlyReportTypeList
                            .get(i).getNormMonthlyReportList();
                    for (int j = 0; j < mNormMonthlyReportListBean.size(); j++) {
                        MonthlyReportBean getMonthlyReport = mNormMonthlyReportListBean
                                .get(j).getMonthlyReport();
                        if (null != getMonthlyReport) {
                            // 填写月计划，若存在已保存数据，保存按钮显示为修改
                            if ("".equals(getMonthlyReport.getPlans()) && funcPosition != 0) {
                                //计划填写模式
                                //如果没有填写计划.并且不在计划填写页面，移除条目
                                mNormMonthlyReportTypeList.get(i).getNormMonthlyReportList().remove(j);
                                j--;
                            }
                        } else {
                            //如果没有填写计划.并且不在计划填写页面，移除条目
                            if (funcPosition != 0) {
                                mNormMonthlyReportTypeList.get(i).getNormMonthlyReportList().remove(j);
                                j--;
                            }
                            //如果没有填写计划，移除
                            if (mode == 0 && funcPosition == 0) {
                                mNormMonthlyReportTypeList.get(i).getNormMonthlyReportList().remove(j);
                                j--;
                            }

                        }
                    }
                    if (mode == 0 || funcPosition != 0) {
                        if (mNormMonthlyReportTypeList.get(i).getNormMonthlyReportList().isEmpty()) {
                            mNormMonthlyReportTypeList.remove(i);
                            i--;
                        }
                        if (funcPosition == 1 && submitPlanFlag == 0) {
                            //未提交计划则不显示总结数据
                            mNormMonthlyReportTypeList.clear();
                        }
                        if (funcPosition == 2 && submitPlanFlag == 0 && !isSelf) {
                            //查询模式下非本人，未提交计划则不显示数据
                            mNormMonthlyReportTypeList.clear();
                        }
                    }
                }
            }

            String content = new Gson().toJson(mNormMonthlyReportTypeList);
            Log.d("过滤后的数据：", content);

            monthReportAdapter = new MonthReportAdapter(this,
                    mNormMonthlyReportTypeList, userInfo, funcPosition, mode, weekMonth);

            monthReportElv.setAdapter(monthReportAdapter);

            // 1、首次加载全部展开：
            for (int i = 0; i < mNormMonthlyReportTypeList.size(); i++) {
                monthReportElv.expandGroup(i);
            }
            // 提醒：加载前别忘了判断adapter是否为空和有没有Group数据哦、
            // 2、不能点击收缩：
            monthReportElv
                    .setOnGroupClickListener(new ExpandableListView.OnGroupClickListener() {

                        @Override
                        public boolean onGroupClick(ExpandableListView parent,
                                                    View v, int groupPosition, long id) {
                            return true;
                        }
                    });
        }
        showMonthReoportDialog();
    }

    /**
     * 计划或总结填写模式,并且计数小于10次；弹出提示框
     */
    private void showMonthReoportDialog() {
        if ((mode == 1 || mode == 2) && CountsParams.dialogCounts <= 10) {
            final PublicConformTipDialog.Builder builder = new PublicConformTipDialog.Builder(this);
            builder.setTitle(R.string.dialog_tips);
            builder.setMessage(R.string.report_monthly_tips);
            builder.setNegativeButton("知道了", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    dialog.dismiss();
                    CountsParams.dialogCounts++;
                }
            });
            builder.create().show();
        }
    }

    private void createConformTipDialog() {
        final PublicConformTipDialog.Builder builder = new PublicConformTipDialog.Builder(this);
        builder.setTitle(R.string.dialog_tips);
        builder.setMessage(getString(R.string.total_performance_tips));
        builder.setNegativeButton("知道了", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.create().show();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (1 == requestCode && resultCode == SelectorBaseActivity.RESULTCODE) {
            BaseSelectorEntity mBaseSelectorEntity = (BaseSelectorEntity) data.getSerializableExtra(SELECTOR_TAG);
            if (mBaseSelectorEntity != null) {
                index = data.getIntExtra(INDEX_TAG, 0);
                monthReportTopCenterTv.setText(mBaseSelectorEntity.getSelectorName());
                mStaffId = mBaseSelectorEntity.getSelectorId();
                mOrgCode = mBaseSelectorEntity.getSelectorCode();
                mOrganization = TotalPerfomanceManager.getOrgBylength(mOrgCode);
                oeRole = TotalPerfomanceManager.getOeRoleBylength(mBaseSelectorEntity.getSelectorOeRole(), mOrgCode);
                getTotalPerfomance();//获取全面绩效
                getPerformaceMonthlyReport();//获取月报内容
            }
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.save_tv) {
            uploadData(SAVE_TAG);
            isEdit = false;
            //切换为不可编辑状态
            firstEntry = false;
            //非第一次进入
        } else if (v.getId() == R.id.modify_tv) {
            modifyTv.setVisibility(View.GONE);
            saveTv.setVisibility(View.VISIBLE);
            firstEntry = false;
            //非第一次进入
            isEdit = true;
            //切换为可编辑状态
            getTotalPerfomance();
            //获取全面绩效
            getPerformaceMonthlyReport();
            //获取月报内容
        } else if (v.getId() == R.id.submit_tv) {
            uploadData(SUBMIT_TAG);
        } else if (v.getId() == R.id.month_report_top_left_tv) {
            swichPerson(0);
        } else if (v.getId() == R.id.month_report_top_right_tv) {
            swichPerson(1);
        } else if (v.getId() == R.id.month_report_top_center_tv) {
            Intent intent = new Intent();
            intent.setClass(this, SelectorPersonActivity.class);
            intent.putExtra("person", person);
            intent.putExtra("oeRole", oeRole);
            startActivityForResult(intent, 1);
        } else if (v.getId() == R.id.plan_tv) {
            showAppraise(SAVE_TAG);
        } else if (v.getId() == R.id.summaly_tv) {
            showAppraise(SUBMIT_TAG);
        }
    }

    /**
     * 人员切换
     *
     * @param orientation 0为左（前），1为右（后）
     */
    private void swichPerson(int orientation) {
        if (null != mQueryUserInfoEntitys) {
            int size = mQueryUserInfoEntitys.size();
            int head = 0;
            int tail = mQueryUserInfoEntitys.size() - 1;

            if (size > 0) {
                if (orientation == 0) {
                    for (int i = 0; i < size; i++) {
                        if (size < 3 && index == tail) {
                            //如果数组长度小于，index=head时，左边按钮消失，index=tail时，右边按钮消失
                            monthReportTopRightTv.setVisibility(View.INVISIBLE);
                        }
                        if (index == head) {
                            index = tail;
                            queryCheckPerson();
                            return;
                        } else if (index == i) {
                            index = index - 1;
                            queryCheckPerson();
                            return;
                        }
                    }
                } else {
                    for (int i = 0; i < size; i++) {
                        if (size < 3 && index == head) {
                            //如果数组长度小于，index=head时，左边按钮消失，index=tail时，右边按钮消失
                            monthReportTopLeftTv.setVisibility(View.INVISIBLE);
                        }
                        if (index == tail) {
                            index = head;
                            queryCheckPerson();
                            return;
                        } else if (index == i) {
                            index = index + 1;
                            queryCheckPerson();
                            return;
                        }
                    }
                }
            }
        }
    }

    /**
     * 根据index查询月报数据
     */
    private void queryCheckPerson() {
        person = mQueryUserInfoEntitys.get(index).getUserInfo().getName();
        mStaffId = mQueryUserInfoEntitys.get(index).getUserInfo().getStaffId();
        mOrgCode = mQueryUserInfoEntitys.get(index).getCode1();
        oeRole = mQueryUserInfoEntitys.get(index).getUserInfo().getRoleStatus();
        mOrganization = TotalPerfomanceManager.getOrgBylength(mOrgCode);
        monthReportTopCenterTv.setText(person);
        getTotalPerfomance();
        getPerformaceMonthlyReport();
    }

    /**
     * 上传数据
     */
    private void uploadData(String type) {
        mMonthlyReportTypeList.clear();
        if (funcPosition == 0) {
            // 月计划
            if (SUBMIT_TAG.equals(type)) {
                MSGTAG = 1;
                //提交计划
                isSubmit = true;
                //弹出确定对话框
                showAppriaseToastDialog(type, MSGTAG);
                return;
            }
            uploadPlan(type);
        } else if (funcPosition == 1) {
            // 月总结
            if (SUBMIT_TAG.equals(type)) {
                MSGTAG = 2;
                //提交总结
                isSubmit = true;
                //弹出确定对话框
                showAppriaseToastDialog(type, MSGTAG);
                return;
            }
            uplpoadSummaly(type);
        } else if (funcPosition == 2) {
            // 批复
            if (!isSelf) {
                // 查询下级
                // 弹出批复框
                showAppriaseDialog(type);
                if (SAVE_TAG.equals(type)) {
                    MSGTAG = 3;
                    //批复计划
                } else {
                    MSGTAG = 4;
                    //批复总结
                }
            } else {//保存计划或者总结
                if (SUBMIT_TAG.equals(type)) {
                    isSubmit = true;
                    if (submitPlanFlag == 0) {
                        //如果计划未提交
                        MSGTAG = 1;
                        //提交计划
                        //弹出确定对话框
                        showAppriaseToastDialog(type, MSGTAG);
                    } else {
                        MSGTAG = 2;
                        //提交总结
                        //弹出确定对话框
                        showAppriaseToastDialog(type, MSGTAG);
                    }
                } else {
                    if (mode == 2) {
                        uploadPlan(type);
                    } else {
                        uplpoadSummaly(type);
                    }
                }
            }
        }
    }

    /**
     * 提交提示
     */
    private void showAppriaseToastDialog(final String type, final int MSG_TAG) {
        final PublicTipDialog.Builder builder = new PublicTipDialog.Builder(this);
        if (MSG_TAG == 1) {
            //提交计划
            builder.setMessage("提交之后不能再修改计划，请确定是否提交？");
        } else {
            //提交总结
            builder.setMessage("提交之后不能再修改总结，请确定是否提交？");
        }

        builder.setTitle("提示");

        builder.setPositiveButton("取消", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.setNegativeButton("确定",
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                        if (MSG_TAG == 1) {
                            //提交计划
                            uploadPlan(type);
                        } else {
                            //提交总结
                            uplpoadSummaly(type);
                        }
                    }
                });
        builder.create().show();
    }

    /**
     * 计划上传数据处理
     *
     * @param type 类型：保存或提交
     */
    private void uploadPlan(String type) {
        mMonthlyReportTypeList = monthReportAdapter.getMonthlyReportTypeListBean();
        // 未填写计划的条目移除
        for (int i = 0; i < mMonthlyReportTypeList.size(); i++) {
            if (null != mMonthlyReportTypeList && !mMonthlyReportTypeList.isEmpty()) {
                for (int j = 0; j < mMonthlyReportTypeList.get(i)
                        .getMonthlyReportParamList().size(); j++) {
                    if (null != mMonthlyReportTypeList.get(i)
                            .getMonthlyReportParamList().get(j)
                            .getMonthlyReport()) {
                        String plans = mMonthlyReportTypeList.get(i)
                                .getMonthlyReportParamList().get(j)
                                .getMonthlyReport().getPlans();

                        if ("".equals(plans)) {
                            mMonthlyReportTypeList.get(i).getMonthlyReportParamList().remove(j);
                            j--;
                        } else {
                            // 过滤查询周
                            for (int k = 0; k < mMonthlyReportTypeList
                                    .get(i).getMonthlyReportParamList()
                                    .get(j).getMonthlyReportWeekList().size(); k++) {
                                if (null == mMonthlyReportTypeList
                                        .get(i).getMonthlyReportParamList()
                                        .get(j).getMonthlyReportWeekList() || mMonthlyReportTypeList
                                        .get(i).getMonthlyReportParamList()
                                        .get(j).getMonthlyReportWeekList().isEmpty()) {
                                    mMonthlyReportTypeList
                                            .get(i).getMonthlyReportParamList()
                                            .get(j).getMonthlyReportWeekList().remove(k);
                                    k--;
                                }
                            }
                        }
                    }
                }
            }
            // 过滤未填写的计划
            if (mMonthlyReportTypeList.get(i).getMonthlyReportParamList()
                    .isEmpty()) {
                mMonthlyReportTypeList.remove(i);
                i--;
            }
        }
        mSaveMonthlyReportEntity.setMonthlyReportTypeList(mMonthlyReportTypeList);
        mSaveMonthlyReportEntity.setIsSaveOrSubmit(type);
        saveMonthlyReport(mSaveMonthlyReportEntity);
    }

    /**
     * 保存上传数据处理
     *
     * @param type 类型：保存或提交
     */
    private void uplpoadSummaly(String type) {
        SaveMonthlyReportSummalyEntity mSaveMonthlyReportSummalyEntity = new SaveMonthlyReportSummalyEntity();
        mSaveMonthlyReportSummalyEntity.setIsSaveOrSubmit(type);
        List<MonthlyReportSummalyBean> mMonthlyReportSummaly = monthReportAdapter
                .getMonthlyReportSummalyBean();
        //必须将信息填写完整再提交
        if (type.equals(SUBMIT_TAG)) {
            for (int i = 0; i < mMonthlyReportSummaly.size(); i++) {
                if ("".equals(mMonthlyReportSummaly.get(i).getSummaly())) {
                    showMsg("请将总结填写完整再提交！");
                    return;
                }
            }
        } else {
            for (int i = 0; i < mMonthlyReportSummaly.size(); i++) {
                if ("".equals(mMonthlyReportSummaly.get(i).getSummaly())) {
                    mMonthlyReportSummaly.remove(i);
                    i--;
                }
            }
            if (mMonthlyReportSummaly.isEmpty()) {
                showMsg("请填写总结数据！");
                return;
            }
        }
        mSaveMonthlyReportSummalyEntity
                .setMonthlyReportSummalyList(mMonthlyReportSummaly);
        saveMonthlyReportSummaly(mSaveMonthlyReportSummalyEntity);
    }

    /**
     * 查看批复对话框
     *
     * @param type 计划或总结
     */
    private void showAppraise(final String type) {

        final MonthReportAppraiseTxtDialog.Builder builder = new MonthReportAppraiseTxtDialog.Builder(this);
        if (SAVE_TAG.equals(type)) {
            builder.setTitle("查看批复计划");
            builder.setAppraiseMsg(planAppraiseMsg);
            builder.setSetIsComplete(isPlanAppraiseComplete + "");
        } else {
            builder.setTitle("查看批复总结");
            builder.setAppraiseMsg(summalyAppraiseMsg);
            builder.setSetIsComplete(isSummalyAppraiseComplete + "");
        }
        builder.setPositiveButton(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.setNegativeButton(
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                    }
                });
        builder.create().show();
    }

    /**
     * 显示批复对话框
     */
    private void showAppriaseDialog(final String type) {

        mMonthlyReportTypeList = monthReportAdapter
                .getMonthlyReportTypeListBean();
        final Long replyId = mMonthlyReportTypeList.get(0).getMonthlyReportParamList().get(0).getMonthlyReport().getMonthlyReportReplyId();


        final MonthReportAppraiseEdtDialog.Builder builder = new MonthReportAppraiseEdtDialog.Builder(this);

        builder.setMessage();
        if (SAVE_TAG.equals(type)) {
            builder.setTitle("批复计划");
        } else {
            builder.setTitle("批复总结");
        }
        builder.setPositiveButton(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.setNegativeButton(
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {

                        if ("".equals(builder.getNember())) {
                            showMsg("请填写批复内容！");
                            return;
                        }
                        dialog.dismiss();
                        mAppriaseMonthlyReportEtity = new MonthlyReportReplyBean();
                        mAppriaseMonthlyReportEtity.setAppraiseStaffId(userInfo.getStaffId());
                        if (SAVE_TAG.equals(type)) {
                            mAppriaseMonthlyReportEtity.setPlanAppraise(builder
                                    .getNember());
                            mAppriaseMonthlyReportEtity.setPlanIsNotPass(builder
                                    .getIsComplete());
                        } else {
                            mAppriaseMonthlyReportEtity.setSummalyAppraise(builder
                                    .getNember());
                            mAppriaseMonthlyReportEtity.setSummalyIsNotPass(builder
                                    .getIsComplete());
                        }
                        mAppriaseMonthlyReportEtity.setId(replyId);
                        appriaseMonthlyReport(mAppriaseMonthlyReportEtity);
                    }
                });
        builder.create().show();

    }

    /**
     * 计划推送JPush消息
     */
    private void sendMessageToJPush(String data, int msg) {
        //保存下级工号
        PrefTool.setStringsave(this, Prefs.PRE_USER_STAFF_LOWER, mStaffId);
        // 接收者类型 （2 指定的 tag ，3 指定的alias，4 广播：对 app_key下的所有用户推送消息）
        String receiverType = ConstantParams.CONSTANT_PARAMS_3;
        String type = ConstantParams.CONSTANT_PARAMS_4;
        String msgTitle;
        String msgContent;
        String recieverStaffId;
        //推送发起者是登录人
        String sendStaffId = PrefTool.getStringPerferences(this, Prefs.PRE_USER_STAFFID);

        MessageExtraEntity mMessageExtraEntity = new MessageExtraEntity();

        mMessageExtraEntity.setYearMonth(data);
        mMessageExtraEntity.setType(ConstantParams.CONSTANT_PARAMS_4);
        //如果是下级推送消息给上级，下级收到后用下级工号查询
        mMessageExtraEntity.setOperatorId(mStaffId);
        mMessageExtraEntity.setCode(mOrgCode);
        mMessageExtraEntity.setStaffName(person);
        //填写的对应日期
        mMessageExtraEntity.setYearMonth(queryMonth);

        String extra = new Gson().toJson(mMessageExtraEntity);

        switch (msg) {
            case 1:
                //计划提交下级推送消息给上级
                recieverStaffId = PrefTool.getStringPerferences(this, Prefs.PRE_USER_STAFF_LEADERID);
                msgTitle = "月度工作计划";
                msgContent = "你的下级" + userInfo.getName() + "已提交月度工作计划，请查看。";
                MainService.getInstance().requestSendMessage(sendStaffId, recieverStaffId, receiverType, extra, type, msgTitle, msgContent, MonthReportActivity.this);
                break;
            case 2:
                //总结提交下级推送消息给上级
                recieverStaffId = PrefTool.getStringPerferences(this, Prefs.PRE_USER_STAFF_LEADERID);
                msgTitle = "月度工作总结";
                msgContent = "你的下级" + userInfo.getName() + "已提交月度工作完成情况，请查看。";
                MainService.getInstance().requestSendMessage(sendStaffId, recieverStaffId, receiverType, extra, type, msgTitle, msgContent, MonthReportActivity.this);
                break;
            case 3:
                msgTitle = "月计划批复结果";
                if (null != mAppriaseMonthlyReportEtity) {
                    if (mAppriaseMonthlyReportEtity.getPlanIsNotPass() == 1) {
                        msgContent = "你的月度工作计划未通过，请和上级沟通详情！";
                    } else {
                        msgContent = "你的月度工作计划已通过，请认真执行！";
                    }
                } else {
                    msgContent = "请点击查看详情！";
                }
                //计划审批上级推送消息给下级
                recieverStaffId = PrefTool.getStringPerferences(this, Prefs.PRE_USER_STAFF_LOWER);
                MainService.getInstance().requestSendMessage(sendStaffId, recieverStaffId, receiverType, extra, type, msgTitle, msgContent, MonthReportActivity.this);
                break;
            case 4:
                if (null != mAppriaseMonthlyReportEtity) {
                    if (mAppriaseMonthlyReportEtity.getSummalyIsNotPass() == 1) {
                        msgContent = "你的月度工作总结没有通过，请和上级沟通详情！";
                    } else {
                        msgContent = "你的月度工作总结已通过，请认真执行！";
                    }
                } else {
                    msgContent = "请点击查看详情！";
                }
                //总结审批上级推送消息给下级
                recieverStaffId = PrefTool.getStringPerferences(this, Prefs.PRE_USER_STAFF_LOWER);
                msgTitle = "月总结批复结果";

                MainService.getInstance().requestSendMessage(sendStaffId, recieverStaffId, receiverType, extra, type, msgTitle, msgContent, MonthReportActivity.this);
                break;

            default:
                break;

        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }


    /**
     * 新增/修改月报
     */
    private void saveMonthlyReport(SaveMonthlyReportEntity mSaveMonthlyReportEntity) {
        String content = new Gson().toJson(mSaveMonthlyReportEntity);
        Log.d(TAG, content);
        if (!content.contains("plans")) {
            showMsg("请填写计划");
            return;
        }
        showDialog();
        if (null != mSaveMonthlyReportEntity) {
            List<MonthlyReportTypeListBean> mSaveMonthlyReportEntitys = mSaveMonthlyReportEntity.getMonthlyReportTypeList();
            if (null != mSaveMonthlyReportEntitys && !mSaveMonthlyReportEntitys.isEmpty()) {
                for (MonthlyReportTypeListBean saveMonthlyReportEntity : mSaveMonthlyReportEntitys) {
                    List<MonthlyReportParamListBean> mMonthlyReportParamListBeans = saveMonthlyReportEntity.getMonthlyReportParamList();
                    if (null != mMonthlyReportParamListBeans && !mMonthlyReportParamListBeans.isEmpty()) {
                        for (MonthlyReportParamListBean monthlyReportParamListBean : mMonthlyReportParamListBeans) {
                            MonthlyReportBean mMonthlyReportBean = monthlyReportParamListBean.getMonthlyReport();
                            if (null != mMonthlyReportBean) {
                                if (StringUtil.isNullOrEmpty(mMonthlyReportBean.getPlans())) {
                                    //必须填写计划
                                    showMsg("请填写" + mMonthlyReportBean.getNorm() + "计划");
                                    dismissDialog();
                                    return;
                                } else {
                                    if (mMonthlyReportBean.getMonthlyReportWeek().isEmpty()) {
                                        showMsg("请填写" + mMonthlyReportBean.getNorm() + "计划执行时间");
                                        dismissDialog();
                                        return;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        MonthlyReportService.getInstance().requestsaveMonthlyReport(content, MonthReportActivity.this);
    }

    /**
     * 填写/修改月报总结
     */
    private void saveMonthlyReportSummaly(SaveMonthlyReportSummalyEntity mMonthlyReportSummalyBean) {
        String content = new Gson().toJson(mMonthlyReportSummalyBean);
        Log.d(TAG, content);
        if (!content.contains("summaly")) {
            showMsg("请填写总结");
            return;
        }
        if (null != mMonthlyReportSummalyBean) {
            List<MonthlyReportSummalyBean> mMonthlyReportSummalyBeans = mMonthlyReportSummalyBean.getMonthlyReportSummalyList();
            if (null != mMonthlyReportSummalyBeans && !mMonthlyReportSummalyBeans.isEmpty()) {
                for (MonthlyReportSummalyBean monthlyReportSummalyBean : mMonthlyReportSummalyBeans) {
                    if (null != monthlyReportSummalyBean) {
                        if (StringUtil.isNullOrEmpty(monthlyReportSummalyBean.getSummaly())) {
                            //必须填写总结
                            showMsg("请填写总结");
                            dismissDialog();
                            return;
                        } else {
                            if (null == monthlyReportSummalyBean.getIsNotComplete()) {
                                showMsg("请将总结完成情况选项填写完整");
                                dismissDialog();
                                return;
                            }
                        }
                    }
                }
            }
        }
        showDialog();
        MonthlyReportService.getInstance().requestsaveMonthlyReportSummaly(content, MonthReportActivity.this);
    }

    /**
     * 填写/修改月报批复
     */
    private void appriaseMonthlyReport(MonthlyReportReplyBean
                                               mAppriaseMonthlyReportEtity) {
        String content = new Gson().toJson(mAppriaseMonthlyReportEtity);
        Log.d(TAG, content);
        showDialog();
        MonthlyReportService.getInstance().requestAppriaseMonthlyReport(content, MonthReportActivity.this);
    }
}