package com.wgmf.yxgj.module.business.reportmonthly.ui;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.TextView;

import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.model.CommonUserinfoBean;
import com.wgmf.yxgj.module.business.reportmonthly.R;
import com.wgmf.yxgj.module.business.reportmonthly.model.MonthlyReportBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.MonthlyReportParamListBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.MonthlyReportSummalyBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.MonthlyReportTypeListBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.MonthlyReportWeekListBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.NormMonthlyReportListBean;
import com.wgmf.yxgj.module.business.reportmonthly.model.NormMonthlyReportTypeListBean;
import com.wgmf.yxgj.module.business.reportmonthly.service.WeekUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * 月报适配器
 *
 * @author XiePing
 * 2016/6/28 13:40
 */
@SuppressWarnings("all")
class MonthReportAdapter extends BaseExpandableListAdapter {
    private Context context;
    /**
     * 新增前查询实体
     */
    private List<NormMonthlyReportTypeListBean> mNormMonthlyReportTypeList;
    /**
     * 月总结保存/修改实体
     */
    private List<MonthlyReportSummalyBean> mMonthlyReportSummalys;
    private List<NormMonthlyReportListBean> mNormMonthlyReportListBeans;

    private CommonUserinfoBean mCommonUserinfoBean;
    private int funcPosition;
    /**
     * 模式切换，0为查询模式，1，为编辑模式
     */
    private int mode = 0;
    private String months;

    /**
     * 用于加载group的布局xml
     */
    private LayoutInflater mGroupInflater;
    /**
     * 用于加载listitem的布局xml
     */
    private LayoutInflater mChildInflater;

    /**
     * 父单元
     */
    class ExpandableGroupHolder {
        TextView title;
    }

    /**
     * 单元类
     */
    private static class ExpandableListHolder {
        LinearLayout titleLl1;
        LinearLayout titleLl2;
        LinearLayout titleLl3;
        LinearLayout titleLl4;
        TextView norm;
        TextView rank;
        TextView row;
        TextView complete;
        EditText titleLl2Et1;
        EditText titleLl4Et2;
        CheckBox titleLl3Ll1Tv1;
        CheckBox titleLl3Ll1Tv2;
        CheckBox titleLl3Ll1Tv3;
        CheckBox titleLl3Ll2Tv1;
        CheckBox titleLl3Ll2Tv2;
        RadioButton titleLl4Ll2LlTv1;
        RadioButton titleLl4Ll2LlTv2;
    }

    MonthReportAdapter(Context context,
                       List<NormMonthlyReportTypeListBean> mPerformaceMonthlyReportEntity,
                       CommonUserinfoBean mCommonUserinfoBean, int mfuncPosition,
                       int mode, String months) {
        this.context = context;
        this.mNormMonthlyReportTypeList = mPerformaceMonthlyReportEntity;
        mChildInflater = (LayoutInflater) context
                .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        mGroupInflater = (LayoutInflater) context
                .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        mMonthlyReportSummalys = new ArrayList<>();
        this.funcPosition = mfuncPosition;
        this.mode = mode;
        this.months = months;
        this.mCommonUserinfoBean = mCommonUserinfoBean;
    }

    /**
     * 保存月计划数据填充
     *
     * @return 月计划保存、修改实体
     */
    public List<MonthlyReportTypeListBean> getMonthlyReportTypeListBean() {
        List<MonthlyReportTypeListBean> mNormMonthlyReportTypeLists = new ArrayList<>();
        for (int i = 0; i < mNormMonthlyReportTypeList.size(); i++) {
            List<MonthlyReportParamListBean> mMonthlyReportParamListBean = new ArrayList<>();
            MonthlyReportTypeListBean mMonthlyReportTypeListBean = new MonthlyReportTypeListBean();

            mNormMonthlyReportListBeans = mNormMonthlyReportTypeList.get(i)
                    .getNormMonthlyReportList();
            for (int j = 0; j < mNormMonthlyReportListBeans.size(); j++) {
                MonthlyReportParamListBean monthlyReportParamList = new MonthlyReportParamListBean();
                monthlyReportParamList
                        .setMonthlyReport(mNormMonthlyReportListBeans.get(j)
                                .getMonthlyReport());
                List<MonthlyReportWeekListBean> monthlyReportWeekListBeans = new ArrayList<>();

                // 如填写计划则表示已填写计划可提交
                if (null != mNormMonthlyReportListBeans.get(j).getMonthlyReport()) {
                    for (int k = 0; k < mNormMonthlyReportListBeans.get(j)
                            .getMonthlyReport().getMonthlyReportWeek().size(); k++) {
                        MonthlyReportWeekListBean monthlyReportWeekListBean = new MonthlyReportWeekListBean();
                        monthlyReportWeekListBean
                                .setWeekId(mNormMonthlyReportListBeans.get(j)
                                        .getMonthlyReport().getMonthlyReportWeek().get(k)
                                        .getWeekId());
                        monthlyReportWeekListBean
                                .setMonthlyReportId(mNormMonthlyReportListBeans.get(j)
                                        .getMonthlyReport().getId());

                        monthlyReportWeekListBeans
                                .add(monthlyReportWeekListBean);
                    }
                    monthlyReportParamList
                            .setMonthlyReportWeekList(monthlyReportWeekListBeans);
                    mMonthlyReportParamListBean.add(monthlyReportParamList);
                }
            }
            mMonthlyReportTypeListBean
                    .setMonthlyReportParamList(mMonthlyReportParamListBean);
            mNormMonthlyReportTypeLists.add(mMonthlyReportTypeListBean);
        }
        return mNormMonthlyReportTypeLists;
    }

    /**
     * 保存月总结数据填充
     *
     * @return 月总结保存、修改实体
     */
    public List<MonthlyReportSummalyBean> getMonthlyReportSummalyBean() {
        List<MonthlyReportTypeListBean> mMonthlyReportTypeList = new ArrayList<>();
        for (int i = 0; i < mNormMonthlyReportTypeList.size(); i++) {
            List<MonthlyReportParamListBean> mMonthlyReportParamListBean = new ArrayList<>();
            MonthlyReportTypeListBean mMonthlyReportTypeListBean = new MonthlyReportTypeListBean();

            mNormMonthlyReportListBeans = mNormMonthlyReportTypeList.get(i)
                    .getNormMonthlyReportList();
            for (int j = 0; j < mNormMonthlyReportListBeans.size(); j++) {
                MonthlyReportParamListBean monthlyReportParamList = new MonthlyReportParamListBean();
                monthlyReportParamList
                        .setMonthlyReport(mNormMonthlyReportListBeans.get(j)
                                .getMonthlyReport());
                // 总结转换
                if (null != mNormMonthlyReportListBeans.get(j)
                        .getMonthlyReport().getMonthlyReportSummaly()) {
                    mMonthlyReportSummalys.add(mNormMonthlyReportTypeList.get(i).getNormMonthlyReportList().get(j).getMonthlyReport().getMonthlyReportSummaly());
                }
                mMonthlyReportParamListBean.add(monthlyReportParamList);
            }
            mMonthlyReportTypeListBean
                    .setMonthlyReportParamList(mMonthlyReportParamListBean);
            mMonthlyReportTypeList.add(mMonthlyReportTypeListBean);
        }
        return mMonthlyReportSummalys;
    }

    // 必须实现 得到子数据
    @Override
    public Object getChild(int groupPosition, int j) {
        return mNormMonthlyReportTypeList.get(groupPosition);
    }

    @Override
    public long getChildId(int groupPosition, int j) {
        return groupPosition;
    }

    @Override
    public int getChildrenCount(int i) {
        int childCount = 0;

        if (null != mNormMonthlyReportTypeList) {
            childCount = mNormMonthlyReportTypeList.get(i)
                    .getNormMonthlyReportList().size();
        }
        return childCount;
    }

    @Override
    public Object getGroup(int i) {
        return mNormMonthlyReportTypeList.get(i);
    }

    @Override
    public int getGroupCount() {
        return mNormMonthlyReportTypeList.size();
    }

    @Override
    public long getGroupId(int i) {
        return i;
    }

    @Override
    public boolean hasStableIds() {// 行是否具有唯一id
        return false;
    }

    @Override
    public boolean isChildSelectable(int i, int j) {// 行是否可选
        return false;
    }

    @Override
    public View getGroupView(int groupPosition, boolean flag, View convertView,
                             ViewGroup viewgroup) {
        // 清空临时变量holder
        ExpandableGroupHolder holder = null;
        convertView = null;
        if (convertView == null) {
            // 判断view（即view是否已构建好）是否为空
            convertView = mGroupInflater.inflate(R.layout.list_group_item_month_report, null);
            holder = new ExpandableGroupHolder();
            holder.title = (TextView) convertView
                    .findViewById(R.id.list_group_item_month_report_title);
            convertView.setTag(holder);
        } else {
            // 若view不为空，直接从view的tag属性中获得各子视图的引用
            holder = (ExpandableGroupHolder) convertView.getTag();
        }
        String title = this.mNormMonthlyReportTypeList.get(groupPosition)
                .getType();
        holder.title.setText(title);
        return convertView;
    }

    @Override
    public View getChildView(final int groupPosition, final int childPosition,
                             boolean isLastChild, View convertView, ViewGroup viewgroup) {
        NormMonthlyReportListBean mNormMonthlyReportListBean;
        try {
            mNormMonthlyReportListBean = mNormMonthlyReportTypeList
                    .get(groupPosition).getNormMonthlyReportList()
                    .get(childPosition);
        } catch (Exception e) {
            mNormMonthlyReportListBean = new NormMonthlyReportListBean();
        }
        Integer isNotComplete = null;

        final ExpandableListHolder holder;
        convertView = null;
        if (null == convertView) {
            convertView = mChildInflater.inflate(R.layout.list_child_item_month_report, null);
            holder = new ExpandableListHolder();
            convertView.setTag(holder);
        } else {
            holder = (ExpandableListHolder) convertView.getTag();
        }

        holder.norm = (TextView) convertView
                .findViewById(R.id.list_child_item_month_report_title_tv1);
        holder.rank = (TextView) convertView
                .findViewById(R.id.list_child_item_month_report_title_tv2);
        holder.complete = (TextView) convertView
                .findViewById(R.id.list_child_item_month_report_title_tv3);
        holder.titleLl1 = (LinearLayout) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll1);
        holder.titleLl2 = (LinearLayout) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll2);
        holder.titleLl3 = (LinearLayout) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll3);
        holder.titleLl4 = (LinearLayout) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll4);
        holder.titleLl2Et1 = (EditText) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll2_et1);

        holder.titleLl3Ll1Tv1 = (CheckBox) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll3_ll1_tv1);
        holder.titleLl3Ll1Tv2 = (CheckBox) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll3_ll1_tv2);
        holder.titleLl3Ll1Tv3 = (CheckBox) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll3_ll1_tv3);
        holder.titleLl3Ll2Tv1 = (CheckBox) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll3_ll2_tv1);
        holder.titleLl3Ll2Tv2 = (CheckBox) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll3_ll2_tv2);

        holder.titleLl4Et2 = (EditText) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll4_ll1_et2);

        holder.titleLl4Ll2LlTv1 = (RadioButton) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll4_ll2_ll_tv1);
        holder.titleLl4Ll2LlTv2 = (RadioButton) convertView
                .findViewById(R.id.list_child_item_month_report_title_ll4_ll2_ll_tv2);

        holder.norm = (TextView) convertView
                .findViewById(R.id.list_child_item_month_report_title_tv1);
        holder.rank = (TextView) convertView
                .findViewById(R.id.list_child_item_month_report_title_tv2);
        holder.row = (TextView) convertView
                .findViewById(R.id.list_child_item_month_report_title_tv4);

        convertView.setTag(holder);
        // 将改变后的数据设置到查询实体中
        List<MonthlyReportWeekListBean> mWeekBeans = new ArrayList<>();
        //计划id
        Long plansId = null;
        //总结id
        Long summalyId = null;
        //批复id
        Long replyId = null;
        if (null != mNormMonthlyReportListBean.getNorm()) {
            holder.norm.setText(mNormMonthlyReportListBean.getNorm().getNorm());
            String isRank = mNormMonthlyReportListBean.getNorm().getRank();
            if (isRank != null && !"null".equals(isRank)) {
                holder.rank.setText("第" + mNormMonthlyReportListBean.getNorm().getRank() + "名");
            }
            String isCompleteP = mNormMonthlyReportListBean.getNorm().getCompleteP();
            if (isCompleteP != null && !"null".equals(isCompleteP)) {
                holder.complete.setText("完成" + mNormMonthlyReportListBean.getNorm().getCompleteP() + "%");
            }
        }
        if (mode == 0) {
            //如果是查询模式默认打开
            mNormMonthlyReportListBean.getNorm().setOpen(true);
        }
        if (!"".equals(holder.titleLl4Et2.getText()
                .toString())) {
            //如果是总结编辑模式有数据的默认打开
            mNormMonthlyReportListBean.getNorm().setOpen(true);
        }
        if (!"".equals(holder.titleLl2Et1.getText()
                .toString())) {
            //如果是计划编辑模式有数据的默认打开
            mNormMonthlyReportListBean.getNorm().setOpen(true);
        }
        if (null != mNormMonthlyReportListBean.getMonthlyReport()) {
            holder.titleLl2Et1.setText(mNormMonthlyReportListBean
                    .getMonthlyReport().getPlans());
            plansId = (mNormMonthlyReportListBean.getMonthlyReport().getId());
            replyId = mNormMonthlyReportListBean.getMonthlyReport().getMonthlyReportReplyId();

            if (null != mNormMonthlyReportListBean.getMonthlyReport().getMonthlyReportWeek()) {
                mWeekBeans.clear();
                mWeekBeans = mNormMonthlyReportListBean.getMonthlyReport()
                        .getMonthlyReportWeek();
                for (int i = 0; i < mWeekBeans.size(); i++) {
                    switch (mWeekBeans.get(i).getWeekId()) {
                        case 1:
                            weekIsChecked(holder.titleLl3Ll1Tv1, 1);
                            break;
                        case 2:
                            weekIsChecked(holder.titleLl3Ll1Tv2, 2);
                            break;
                        case 3:
                            weekIsChecked(holder.titleLl3Ll1Tv3, 3);
                            break;
                        case 4:
                            weekIsChecked(holder.titleLl3Ll2Tv1, 4);
                            break;
                        case 5:
                            weekIsChecked(holder.titleLl3Ll2Tv2, 5);
                            break;
                        default:
                            break;
                    }

                }
            }

            if (null != mNormMonthlyReportListBean.getMonthlyReport()
                    .getMonthlyReportSummaly()) {
                holder.titleLl4Et2.setText(mNormMonthlyReportListBean
                        .getMonthlyReport().getMonthlyReportSummaly()
                        .getSummaly());
                plansId = mNormMonthlyReportListBean.getMonthlyReport().getMonthlyReportSummaly().getMonthlyReportId();
                summalyId = (mNormMonthlyReportListBean.getMonthlyReport().getMonthlyReportSummaly().getId());
                replyId = mNormMonthlyReportListBean.getMonthlyReport().getMonthlyReportReplyId();
                isNotComplete = mNormMonthlyReportTypeList.get(groupPosition)
                        .getNormMonthlyReportList().get(childPosition)
                        .getMonthlyReport().getMonthlyReportSummaly()
                        .getIsNotComplete();
                if (null != isNotComplete) {
                    if (isNotComplete == 0) {
                        //完成选中
                        completeIsCheck(holder.titleLl4Ll2LlTv1,
                                holder.titleLl4Ll2LlTv2, true);
                        //未完成不选中
                        completeIsCheck(holder.titleLl4Ll2LlTv2,
                                holder.titleLl4Ll2LlTv1, false);
                    } else {
                        //未完成选中
                        completeIsCheck(holder.titleLl4Ll2LlTv2,
                                holder.titleLl4Ll2LlTv1, true);
                        //完成不选中
                        completeIsCheck(holder.titleLl4Ll2LlTv1,
                                holder.titleLl4Ll2LlTv2, false);
                    }
                }
            }
        }

        // 计划
        List<MonthlyReportWeekListBean> monthlyReportWeekListBeans = new ArrayList<>();
        MonthlyReportBean mMonthlyReportBean = new MonthlyReportBean();
        mMonthlyReportBean.setType(mNormMonthlyReportListBean.getNorm()
                .getType());
        mMonthlyReportBean.setNorm(mNormMonthlyReportListBean.getNorm()
                .getNorm());
        mMonthlyReportBean.setRank(mNormMonthlyReportListBean.getNorm()
                .getRank());
        if (mCommonUserinfoBean != null) {
            mMonthlyReportBean.setStaffId(mCommonUserinfoBean.getStaffId());
        }
        mMonthlyReportBean.setPlans(holder.titleLl2Et1.getText().toString());
        mMonthlyReportBean.setYearMonth(DateUtil.getFormatMonth("yyyyMM", 0));
        mMonthlyReportBean.setMonthlyReportWeek(mWeekBeans);
        mMonthlyReportBean.setMonthlyReportReplyId(replyId);
        mMonthlyReportBean.setId(plansId);

        mNormMonthlyReportTypeList.get(groupPosition)
                .getNormMonthlyReportList().get(childPosition)
                .setMonthlyReport(mMonthlyReportBean);
        // 总结
        MonthlyReportSummalyBean mMonthlyReportSummaly = new MonthlyReportSummalyBean();
        mMonthlyReportSummaly.setSummaly(holder.titleLl4Et2.getText()
                .toString());
        // 计划完成否
        mMonthlyReportSummaly.setIsNotComplete(isNotComplete);
        // 计划id
        mMonthlyReportSummaly.setMonthlyReportId(mMonthlyReportBean.getId());
        // 批复id
        mMonthlyReportSummaly.setMonthlyReportReplyId(replyId);
        // 总结id
        mMonthlyReportSummaly.setId(summalyId);

        mNormMonthlyReportTypeList.get(groupPosition)
                .getNormMonthlyReportList().get(childPosition)
                .getMonthlyReport()
                .setMonthlyReportSummaly(mMonthlyReportSummaly);

        if (!mNormMonthlyReportListBean.getNorm().isOpen()) {
            holder.titleLl2.setVisibility(View.GONE);
            holder.titleLl3.setVisibility(View.GONE);
            holder.titleLl4.setVisibility(View.GONE);
            holder.row.setText(context.getString(R.string.row_down));
        } else {
            holder.titleLl2.setVisibility(View.VISIBLE);
            holder.titleLl3.setVisibility(View.VISIBLE);
            holder.titleLl4.setVisibility(View.VISIBLE);
            holder.row.setText(context.getString(R.string.row_up));
        }
        // 计划
        holder.titleLl2Et1.addTextChangedListener(new TextWatcher() {
            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                mNormMonthlyReportTypeList.get(groupPosition)
                        .getNormMonthlyReportList().get(childPosition)
                        .getMonthlyReport().setPlans(s.toString());
            }
        });
        // 总结
        holder.titleLl4Et2.addTextChangedListener(new TextWatcher() {
            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                mNormMonthlyReportTypeList.get(groupPosition)
                        .getNormMonthlyReportList().get(childPosition)
                        .getMonthlyReport().getMonthlyReportSummaly()
                        .setSummaly(s.toString());
            }
        });
        //编辑模式切换
        switchEditMode(holder);

        if (funcPosition == 0) {
            holder.titleLl4.setVisibility(View.GONE);
            holder.titleLl1.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    showLayout(holder.titleLl2, holder.titleLl3,
                            holder.titleLl4, holder.row, View.GONE,
                            groupPosition, childPosition);
                }
            });
        } else if (funcPosition == 1 || funcPosition == 2) {
            if (mode == 0 && funcPosition == 2 && "".equals(holder.titleLl4Et2.getText()
                    .toString())) {
                //查询模式下，如果总结为空，不显示
                holder.titleLl4.setVisibility(View.GONE);
            }
            holder.titleLl1.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    showLayout(holder.titleLl2, holder.titleLl3,
                            holder.titleLl4, holder.row, View.VISIBLE,
                            groupPosition,
                            childPosition);
                    if (funcPosition == 2 && "".equals(holder.titleLl4Et2.getText()
                            .toString())) {
                        //查询模式下，如果总结为空，不显示
                        holder.titleLl4.setVisibility(View.GONE);
                    }
                }
            });
        }

        final List<MonthlyReportWeekListBean> finalMWeekBeans = mWeekBeans;
        holder.titleLl3Ll1Tv1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                cbShow(finalMWeekBeans, holder.titleLl3Ll1Tv1, groupPosition,
                        childPosition, 1);
            }
        });
        holder.titleLl3Ll1Tv2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                cbShow(finalMWeekBeans, holder.titleLl3Ll1Tv2, groupPosition,
                        childPosition, 2);
            }
        });
        holder.titleLl3Ll1Tv3.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                cbShow(finalMWeekBeans, holder.titleLl3Ll1Tv3, groupPosition,
                        childPosition, 3);
            }
        });
        holder.titleLl3Ll2Tv1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                cbShow(finalMWeekBeans, holder.titleLl3Ll2Tv1, groupPosition,
                        childPosition, 4);
            }
        });
        holder.titleLl3Ll2Tv2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                cbShow(finalMWeekBeans, holder.titleLl3Ll2Tv2, groupPosition,
                        childPosition, 5);
            }
        });
        holder.titleLl4Ll2LlTv1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (holder.titleLl4Ll2LlTv1.isChecked()) {
                    completeIsCheck(holder.titleLl4Ll2LlTv1, holder.titleLl4Ll2LlTv2, true);
                    mNormMonthlyReportTypeList.get(groupPosition)
                            .getNormMonthlyReportList().get(childPosition)
                            .getMonthlyReport().getMonthlyReportSummaly()
                            .setIsNotComplete(1);
                }
            }
        });
        holder.titleLl4Ll2LlTv2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (holder.titleLl4Ll2LlTv2.isChecked()) {
                    completeIsCheck(holder.titleLl4Ll2LlTv2, holder.titleLl4Ll2LlTv1, true);
                    mNormMonthlyReportTypeList.get(groupPosition)
                            .getNormMonthlyReportList().get(childPosition)
                            .getMonthlyReport().getMonthlyReportSummaly()
                            .setIsNotComplete(0);
                }
            }
        });

        int month = WeekUtils.getWeek(months);

        if (month < 5) {
            holder.titleLl3Ll2Tv2.setVisibility(View.INVISIBLE);
        }
        return convertView;

    }

    /**
     * 编辑与查看模式切换
     */
    private void switchEditMode(ExpandableListHolder holder) {
        if (mode == 0) {
            // 计划查询模式
            // 1,查询模式下，不可编辑
            holder.titleLl2Et1.setEnabled(false);
            holder.titleLl4Et2.setEnabled(false);
            holder.titleLl3Ll1Tv1.setEnabled(false);
            holder.titleLl3Ll1Tv2.setEnabled(false);
            holder.titleLl3Ll1Tv3.setEnabled(false);
            holder.titleLl3Ll2Tv1.setEnabled(false);
            holder.titleLl3Ll2Tv2.setEnabled(false);
            holder.titleLl4Ll2LlTv1.setEnabled(false);
            holder.titleLl4Ll2LlTv2.setEnabled(false);
        } else if (mode == 1) {
            // 总结编辑模式
            holder.titleLl4.setVisibility(View.VISIBLE);
            holder.titleLl2Et1.setEnabled(false);
            holder.titleLl4Et2.setEnabled(true);
            holder.titleLl3Ll1Tv1.setEnabled(false);
            holder.titleLl3Ll1Tv2.setEnabled(false);
            holder.titleLl3Ll1Tv3.setEnabled(false);
            holder.titleLl3Ll2Tv1.setEnabled(false);
            holder.titleLl3Ll2Tv2.setEnabled(false);
            holder.titleLl4Ll2LlTv1.setEnabled(true);
            holder.titleLl4Ll2LlTv2.setEnabled(true);
        } else if (mode == 2) {
            // 填写计划编辑模式
            holder.titleLl4.setVisibility(View.GONE);
            holder.titleLl2Et1.setEnabled(true);
            holder.titleLl3Ll1Tv1.setEnabled(true);
            holder.titleLl3Ll1Tv2.setEnabled(true);
            holder.titleLl3Ll1Tv3.setEnabled(true);
            holder.titleLl3Ll2Tv1.setEnabled(true);
            holder.titleLl3Ll2Tv2.setEnabled(true);
        }
    }

    /**
     * 布局显示
     */
    private void showLayout(LinearLayout titleLl2, LinearLayout titleLl3,
                            LinearLayout titleLl4, TextView row, int writeOpenShow,
                            int groupPosition, int childPosition) {
        boolean isOpen = mNormMonthlyReportTypeList.get(groupPosition)
                .getNormMonthlyReportList().get(childPosition).getNorm()
                .isOpen();
        if (!isOpen) {
            titleLl2.setVisibility(View.VISIBLE);
            titleLl3.setVisibility(View.VISIBLE);
            completeShow(titleLl4, row, writeOpenShow, context.getString(R.string.row_up));

        } else {
            titleLl2.setVisibility(View.GONE);
            titleLl3.setVisibility(View.GONE);
            completeShow(titleLl4, row, View.GONE, context.getString(R.string.row_down));
        }
        mNormMonthlyReportTypeList.get(groupPosition)
                .getNormMonthlyReportList().get(childPosition).getNorm()
                .setOpen(!isOpen);
    }

    private void completeShow(LinearLayout titleLl4, TextView row,
                              int writeOpenShow, String writeOpenText) {
        titleLl4.setVisibility(writeOpenShow);
        row.setText(writeOpenText);
    }

    /**
     * @param titleLl4Ll2LlTv1 完成按钮
     * @param titleLl4Ll2LlTv2 未完成按钮
     */
    private void completeIsCheck(RadioButton titleLl4Ll2LlTv1,
                                 RadioButton titleLl4Ll2LlTv2, boolean completeIsCheck) {
        titleLl4Ll2LlTv1.setChecked(completeIsCheck);
        titleLl4Ll2LlTv1.setTextColor(ContextCompat.getColor(context,
                R.color.white));
        titleLl4Ll2LlTv2.setTextColor(ContextCompat.getColor(context,
                R.color.important_txt_color));
        titleLl4Ll2LlTv1.setBackgroundResource(R.drawable.btn_week_check_style);
        titleLl4Ll2LlTv2
                .setBackgroundResource(R.drawable.btn_week_normal_style);
    }

    /**
     * 周显示
     *
     * @param titleLl3Ll1Tv1 周按钮
     */
    private void cbShow(List<MonthlyReportWeekListBean> mWeekBeans, CheckBox titleLl3Ll1Tv1,
                        int pos1, int pos2, int pos) {

        MonthlyReportWeekListBean mWeekBean = new MonthlyReportWeekListBean();
        if (titleLl3Ll1Tv1.isChecked()) {
            mWeekBean.setWeekId(pos);
            mWeekBeans.add(mWeekBean);
            weekIsChecked(titleLl3Ll1Tv1, pos);
        } else {
            // 撤销选中后移除数据
            if (!mWeekBeans.isEmpty()) {
                for (int i = 0; i < mWeekBeans.size(); i++) {
                    if (mWeekBeans.get(i).getWeekId() == pos) {
                        mWeekBeans.remove(i);
                        i--;
                    }
                }
            }
            titleLl3Ll1Tv1.setChecked(false);
            titleLl3Ll1Tv1.setTextColor(ContextCompat.getColor(context,
                    R.color.important_txt_color));
            titleLl3Ll1Tv1
                    .setBackgroundResource(R.drawable.btn_week_normal_style);
        }
        mNormMonthlyReportTypeList.get(pos1).getNormMonthlyReportList()
                .get(pos2).getMonthlyReport().setMonthlyReportWeek(mWeekBeans);
    }

    /**
     * 多选按钮选中状态显示
     */

    private void weekIsChecked(CheckBox titleLl3Ll1Tv1, int pos) {
        titleLl3Ll1Tv1.setChecked(true);
        titleLl3Ll1Tv1.setTextColor(ContextCompat.getColor(context,
                R.color.white));
        titleLl3Ll1Tv1.setBackgroundResource(R.drawable.btn_week_check_style);
    }
}