package com.wgmf.yxgj.module.business.reportmonthly.ui;

import android.content.Context;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;
import com.wgmf.yxgj.module.business.reportmonthly.R;
import com.wgmf.library.utils.DateUtil;

import java.util.List;

class QueryConditionsMonthAdapter extends BaseAdapter {

	private List<String> list;
	private Context context;
	private int selected = DateUtil.getNowMonth();

	public int getSelected() {
		return selected;
	}

	private void setSelected(int selected) {
		this.selected = selected;
	}

	public QueryConditionsMonthAdapter(Context context, List<String> list) {
		this.context = context;
		this.list = list;
	}

	@Override
	public int getCount() {
		return list.size();
	}

	@Override
	public Object getItem(int position) {
		return null;
	}

	@Override
	public long getItemId(int position) {
		return 0;
	}

	@Override
	public View getView(final int position, View convertView, ViewGroup parent) {
		ViewHolder viewHolder;
		if (convertView == null) {
			viewHolder = new ViewHolder();
			convertView = View.inflate(context,
					R.layout.query_data_condition_item, null);
			viewHolder.tv = (TextView) convertView
					.findViewById(R.id.condition_time_items_month_txt);
			convertView.setTag(viewHolder);
		} else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		viewHolder.tv.setText(list.get(position));

		if (selected == position) {
			// 设置为选中
			viewHolder.tv
					.setBackgroundResource(R.drawable.month_horizontalscrollview_circlelayout_orange);
		} else {// 设置为未选中
			viewHolder.tv.setBackgroundResource(R.color.white);

		}
		viewHolder.tv.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				if (selected == position) {
					// 点击条目前已经是选中状态，则取消
					setSelected(-1);
				} else {
					// 点击条目前已经是未选中状态，则取消
					setSelected(position);
				}
				notifyDataSetChanged();
			}
		});
		return convertView;
	}

	static class ViewHolder {
		TextView tv;
	}
}
