package com.wgmf.yxgj.module.business.reportmonthly.ui;

import android.content.Intent;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.global.OeRoleParams;
import com.wgmf.yxgj.module.business.reportmonthly.R;
import com.wgmf.yxgj.module.business.reportmonthly.model.QueryUserInfoEntity;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.service.TotalPerfomanceManager;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.wgmf.yxgj.widgets.ListView.HorizontialListView;
import com.xp.arouter.RouterParams;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * 月总结与计划查询：查询条件
 */
@Route(path = RouterParams.URL_QUERYMONTHLYCONDITIONSACTIVITY)
public class QueryMonthlyConditionsActivity extends BaseParentAct implements
        OnClickListener {
    private int years = 2018;
    private List<String> list;
    private HorizontialListView conditionTimeItemsMonthHl;
    private QueryConditionsMonthAdapter adapter;
    /**
     * 计划总结填写人
     */
    private TextView monthlyConditionWritePerson;
    private TextView conditionTimeItemsYearTxt;
    private RadioButton monthlyConditionPrsonRb1, monthlyConditionPrsonRb2, monthlyConditionPrsonRb3, monthlyConditionPrsonRb4;
    private int index;
    private String oeRole;
    private String personName = "请选择填写人";
    private boolean isSelf = false;
    private String mStaffId, mCode, mOrganization;
    private List<QueryUserInfoEntity> mQueryUserInfoEntitys;
    private static final String LIST_TAG = "list";
    private static final String INDEX_TAG = "index";
    private static final String SELECTOR_TAG = "selector";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.query_monthly_condition);
        initTitle();
        initContent();
        initConditons();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("查询月计划与总结");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initContent() {
        initView();
        initData();
        adapter = new QueryConditionsMonthAdapter(this, list);
        conditionTimeItemsMonthHl.setAdapter(adapter);
    }

    private void initView() {

        conditionTimeItemsMonthHl = (HorizontialListView) findViewById(R.id.monthly_condition_time_items_month_hl);
        LinearLayout conditionTimeItemsQueryLl = (LinearLayout) findViewById(R.id.monthly_condition_time_items_query_ll);

        RelativeLayout conditionTimeItemsYearLl = (RelativeLayout) findViewById(R.id.monthly_condition_time_items_year_ll);
        conditionTimeItemsYearTxt = (TextView) findViewById(R.id.monthly_condition_time_items_year_txt);
        years = DateUtil.getNowYear();
        conditionTimeItemsYearTxt.setText("" + years + "年");
        TextView conditionTimeItemsYearLift = (TextView) findViewById(R.id.monthly_condition_time_items_year_lift);
        TextView conditionTimeItemsYearRight = (TextView) findViewById(R.id.monthly_condition_time_items_year_right);

        LinearLayout conditionTimeItemsMonthLl = (LinearLayout) findViewById(R.id.monthly_condition_time_items_month_ll);
        monthlyConditionWritePerson = (TextView) findViewById(R.id.monthly_condition_write_person);

        monthlyConditionPrsonRb1 = (RadioButton) findViewById(R.id.monthly_condition_prson_rb1);
        monthlyConditionPrsonRb2 = (RadioButton) findViewById(R.id.monthly_condition_prson_rb2);
        monthlyConditionPrsonRb3 = (RadioButton) findViewById(R.id.monthly_condition_prson_rb3);
        monthlyConditionPrsonRb4 = (RadioButton) findViewById(R.id.monthly_condition_prson_rb4);
        monthlyConditionPrsonRb1.setOnClickListener(this);
        monthlyConditionPrsonRb2.setOnClickListener(this);
        monthlyConditionPrsonRb3.setOnClickListener(this);
        monthlyConditionPrsonRb4.setOnClickListener(this);
        conditionTimeItemsYearLl.setOnClickListener(this);
        conditionTimeItemsYearLift.setOnClickListener(this);
        conditionTimeItemsYearRight.setOnClickListener(this);
        conditionTimeItemsMonthLl.setOnClickListener(this);
        conditionTimeItemsQueryLl.setOnClickListener(this);
        monthlyConditionWritePerson.setOnClickListener(this);
    }

    private void initConditons() {
        if (null != userInfo && null != userInfo.getOeRole()) {
            mStaffId = userInfo.getStaffId();
            mCode = userInfo.getOrganizationCode();
            mOrganization = userInfo.getOrganization();
            oeRole = userInfo.getOeRole();

            showPerson();
            switch (oeRole) {
                case OeRoleParams.OE_ROLE_PARAMS_14:
                    // 1,总部
                    monthlyConditionPrsonRb1.setVisibility(View.GONE);
                    break;
                case OeRoleParams.OE_ROLE_PARAMS_8:
                    //2,大区总监
                    monthlyConditionPrsonRb4.setVisibility(View.GONE);
                    defaultQueryItSelf();
                    break;
                case OeRoleParams.OE_ROLE_PARAMS_7:
                    // 3,区域经理
                    monthlyConditionPrsonRb3.setVisibility(View.GONE);
                    monthlyConditionPrsonRb4.setVisibility(View.GONE);
                    defaultQueryItSelf();
                    break;
                case OeRoleParams.OE_ROLE_PARAMS_3:
                    // 4，主管
                    monthlyConditionPrsonRb2.setVisibility(View.GONE);
                    monthlyConditionPrsonRb3.setVisibility(View.GONE);
                    monthlyConditionPrsonRb4.setVisibility(View.GONE);
                    defaultQueryItSelf();
                    break;
                default:
                    //其它人员不允许查看月报
                    monthlyConditionPrsonRb2.setVisibility(View.GONE);
                    monthlyConditionPrsonRb3.setVisibility(View.GONE);
                    monthlyConditionPrsonRb4.setVisibility(View.GONE);
                    defaultQueryItSelf();
                    break;
            }
        }
    }

    /**
     * 默认查询本人
     */
    private void defaultQueryItSelf() {
        isSelf = true;
        monthlyConditionWritePerson.setText(userInfo.getName());
        monthlyConditionPrsonRb1.setChecked(true);
        monthlyConditionWritePerson.setOnClickListener(null);
        monthlyConditionWritePerson.setBackgroundResource(R.color.region_gray);
        monthlyConditionPrsonRb1.setTextColor(ContextCompat.getColor(this, R.color.white));
        monthlyConditionPrsonRb1.setBackgroundResource(R.color.normal_color);
    }

    private void showPerson() {
        monthlyConditionPrsonRb1.setText("本人");
        monthlyConditionPrsonRb2.setText("主管");
        monthlyConditionPrsonRb3.setText("经理");
        monthlyConditionPrsonRb4.setText("总监");
        monthlyConditionWritePerson.setText(personName);
    }

    private void initData() {
        list = new ArrayList<>();
        for (int i = 0; i < 12; i++) {
            list.add(i + 1 + "月");
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (requestCode) {
            case 1:
                //月总结与计划查询人员列表
                if (resultCode == SelectorBaseActivity.RESULTCODE) {
                    mQueryUserInfoEntitys = (List<QueryUserInfoEntity>) data.getSerializableExtra(LIST_TAG);
                    index = data.getIntExtra(INDEX_TAG, 0);

                    BaseSelectorEntity mBaseSelectorEntity = (BaseSelectorEntity) data.getSerializableExtra(SELECTOR_TAG);

                    if (mBaseSelectorEntity != null) {
                        monthlyConditionWritePerson.setText(mBaseSelectorEntity.getSelectorName());
                        mStaffId = mBaseSelectorEntity.getSelectorId();
                        mCode = mBaseSelectorEntity.getSelectorCode();
                        mOrganization = TotalPerfomanceManager.getOrgBylength(mCode);
                        oeRole = TotalPerfomanceManager.getOeRoleBylength(mBaseSelectorEntity.getSelectorOeRole(), mCode);
                    }
                }
                break;
            default:
                break;
        }
    }

    @Override
    public void onClick(View v) {
        Intent intent = new Intent();
        if (v.getId() == R.id.monthly_condition_write_person) {
            // 具体填写人
            if (monthlyConditionPrsonRb1.isChecked() || monthlyConditionPrsonRb2.isChecked() || monthlyConditionPrsonRb3.isChecked() || monthlyConditionPrsonRb4.isChecked()) {
                intent.setClass(this, SelectorPersonActivity.class);
                intent.putExtra("person", monthlyConditionWritePerson.getText().toString());
                intent.putExtra("mStaffId", mStaffId);
                intent.putExtra("oeRole", oeRole);
                startActivityForResult(intent, 1);
            } else {
                showMsg("请先选择填写人职位");
            }
        } else if (v.getId() == R.id.monthly_condition_prson_rb1) {
            // //查询本人
            isSelf = true;
            monthlyConditionWritePerson.setOnClickListener(null);
            monthlyConditionWritePerson.setBackgroundResource(R.color.region_gray);
            if (userInfo != null) {
                monthlyConditionWritePerson.setText(userInfo.getName());
            }
            showRadioBtn(monthlyConditionPrsonRb1, monthlyConditionPrsonRb2, monthlyConditionPrsonRb3, monthlyConditionPrsonRb4);
        } else if (v.getId() == R.id.monthly_condition_prson_rb2) {
            //查询主管
            oeRole = OeRoleParams.OE_ROLE_PARAMS_3;
            isSelf = false;
            monthlyConditionWritePerson.setOnClickListener(this);
            monthlyConditionWritePerson.setBackgroundResource(R.color.white);
            monthlyConditionWritePerson.setText(personName);
            showRadioBtn(monthlyConditionPrsonRb2, monthlyConditionPrsonRb1, monthlyConditionPrsonRb3, monthlyConditionPrsonRb4);
        } else if (v.getId() == R.id.monthly_condition_prson_rb3) {
            //查询经理
            oeRole = OeRoleParams.OE_ROLE_PARAMS_7;
            isSelf = false;
            monthlyConditionWritePerson.setOnClickListener(this);
            monthlyConditionWritePerson.setBackgroundResource(R.color.white);
            monthlyConditionWritePerson.setText(personName);
            showRadioBtn(monthlyConditionPrsonRb3, monthlyConditionPrsonRb2, monthlyConditionPrsonRb1, monthlyConditionPrsonRb4);
        } else if (v.getId() == R.id.monthly_condition_prson_rb4) {
            //查询总监
            oeRole = OeRoleParams.OE_ROLE_PARAMS_8;
            isSelf = false;
            monthlyConditionWritePerson.setOnClickListener(this);
            monthlyConditionWritePerson.setBackgroundResource(R.color.white);
            monthlyConditionWritePerson.setText(personName);
            showRadioBtn(monthlyConditionPrsonRb4, monthlyConditionPrsonRb2, monthlyConditionPrsonRb3, monthlyConditionPrsonRb1);
        } else if (v.getId() == R.id.monthly_condition_time_items_year_lift) {
            conditionTimeItemsYearTxt.setText("" + (--years) + "年");
        } else if (v.getId() == R.id.monthly_condition_time_items_year_right) {
            conditionTimeItemsYearTxt.setText("" + (++years) + "年");
        } else if (v.getId() == R.id.monthly_condition_time_items_query_ll) {
            if (adapter.getSelected() == -1) {
                showMsg("未选择月份");
                return;
            }
            if (personName.equals(monthlyConditionWritePerson.getText().toString())) {
                showMsg(personName);
            } else {
                intent.setClass(this, MonthReportActivity.class);
                intent.putExtra("branchID", getIntent().getLongExtra("branchID", 0));
                intent.putExtra("person", monthlyConditionWritePerson.getText().toString());
                intent.putExtra("mCode", mCode);
                intent.putExtra("mStaffId", mStaffId);
                intent.putExtra("mOrganization", mOrganization);
                intent.putExtra("years", years);
                intent.putExtra("months", adapter.getSelected());
                intent.putExtra("oeRole", oeRole);
                intent.putExtra("isSelf", isSelf);
                intent.putExtra(LIST_TAG, (Serializable) mQueryUserInfoEntitys);
                intent.putExtra(INDEX_TAG, index);

                startActivity(intent);
            }
        }
    }

    private void showRadioBtn(RadioButton rbBtnCheck, RadioButton rbBtnNoCheck1, RadioButton rbBtnNoCheck2, RadioButton rbBtnNoCheck3) {
        if (rbBtnCheck.isChecked()) {
            setChecked(rbBtnCheck, ContextCompat.getColor(this, R.color.white), R.color.normal_color, false);
            setChecked(rbBtnNoCheck1, ContextCompat.getColor(this, R.color.important_txt_color), R.color.white, true);
            setChecked(rbBtnNoCheck2, ContextCompat.getColor(this, R.color.important_txt_color), R.color.white, true);
            setChecked(rbBtnNoCheck3, ContextCompat.getColor(this, R.color.important_txt_color), R.color.white, true);
        } else {
            setChecked(rbBtnCheck, ContextCompat.getColor(this, R.color.important_txt_color), R.color.white, true);
        }
    }

    private void setChecked(RadioButton rbBtnCheck, int color, int bgColor, boolean flag) {
        rbBtnCheck.setTextColor(color);
        rbBtnCheck.setBackgroundResource(bgColor);
        rbBtnCheck.setChecked(flag);
    }
}