package com.wgmf.yxgj.module.business.reportmonthly.ui;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.wgmf.yxgj.module.business.reportmonthly.model.QueryUserInfoEntity;
import com.wgmf.yxgj.module.business.reportmonthly.service.MonthlyReportService;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

/**
 * 月总结与计划查询：选择人员列表
 */
public class SelectorPersonActivity extends SelectorBaseActivity {

    private static final String LIST_TAG = "list";
    private static final String INDEX_TAG = "index";
    private static final String SELECTOR_TAG = "selector";

    private List<QueryUserInfoEntity> mQueryUserInfoEntitys = new ArrayList<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getPersonData();
    }

    private void getPersonData() {
        if (null != userInfo) {
            showDialog();
            String staffId = userInfo.getStaffId();
            String roleStatus = getIntent().getStringExtra("oeRole");
            MonthlyReportService.getInstance().requestQueryUserInfo(staffId, roleStatus, SelectorPersonActivity.this);
        }
    }


    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("查询月计划与总结");
    }

    @Override
    public void initContent() {
        super.initContent();
        mListView.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {
                Intent intent = new Intent();
                intent.putExtra(INDEX_TAG, position);
                intent.putExtra(SELECTOR_TAG, listShow.get(position));
                intent.putExtra(LIST_TAG, (Serializable) mQueryUserInfoEntitys);
                setResult(RESULTCODE, intent);
                SelectorPersonActivity.this.finish();
            }
        });
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.MonthlyWeekReport.MSG_ON_QUERY_USERINFO: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        LinkedList<QueryUserInfoEntity> resources = new Gson().fromJson(msg,
                                new TypeToken<LinkedList<QueryUserInfoEntity>>() {
                                }.getType());
                        listShow.clear();
                        for (QueryUserInfoEntity resource : resources) {
                            BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
                            mBaseSelectorEntity.setSelectorName(resource.getUserInfo().getName());
                            mBaseSelectorEntity.setSelectorId(resource.getUserInfo().getStaffId());
                            mBaseSelectorEntity.setSelectorCode(resource.getCode1());
                            mBaseSelectorEntity.setSelectorOeRole(resource.getUserInfo().getRoleStatus());
                            mQueryUserInfoEntitys.add(resource);
                            listShow.add(mBaseSelectorEntity);
                        }
                        search();
                    }
                }
                break;
                default:
                    break;
            }
        }
    }
}