package com.wgmf.yxgj.module.business.reportproblem.service;

import java.util.ArrayList;
import java.util.List;

/**
 * 反馈的类型；
 */
@SuppressWarnings("all")
public enum QualityBackType {
    PRODUCTION_PROBLEM(2421, "产品问题反馈"), ARRIVAL_ERROR(721, "到货误差反馈"), CABINET_PROBLEM(2181, "柜子/物料质量反馈"),
    INTERNAL_COMPLAINTS(2441, "内部投诉反馈"), MACHINE_PROBLEM(6, "本机问题反馈"), SUGGESTION(3721,"意见与建议反馈");

    private int index;
    private String name;

    QualityBackType(int index, String name) {
        this.index = index;
        this.name = name;
    }

    /**
     * 通过index找到name;
     *
     * @param index
     * @return
     */
    public static String getName(int index) {
        for (QualityBackType c : QualityBackType.values()) {
            if (c.getIndex() == index) {
                return c.name;
            }
        }
        return "";
    }

    /**
     * 通过name找到index;
     *
     * @param name
     * @return
     */
    public static int getIndexFromName(String name) {
        for (QualityBackType c : QualityBackType.values()) {
            if (c.name.equals(name)) {
                return c.index;
            }
        }
        return 0;
    }

    /**
     * 字符串
     *
     * @return
     */
    public static List<String> getItems() {
        List<String> items = new ArrayList<>();
        for (QualityBackType c : QualityBackType.values()) {
            if (!items.contains(c.getName())) {
                items.add(c.getName());
            }
        }
        return items;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getIndex() {
        return index;
    }

    public void setIndex(int index) {
        this.index = index;
    }
}
