package com.wgmf.yxgj.module.business.reportproblem.ui

import android.content.Intent
import android.os.Bundle
import android.support.v4.app.FragmentTransaction
import android.text.TextUtils
import android.util.Log
import android.view.View
import android.view.WindowManager
import com.alibaba.android.arouter.facade.annotation.Route
import com.google.gson.Gson
import com.wgmf.library.base.BaseResponse
import com.wgmf.library.base.ResultData
import com.wgmf.library.utils.DateUtil
import com.wgmf.yxgj.base.BaseParentFra
import com.wgmf.yxgj.basewebview.ui.HtmlActivity
import com.wgmf.yxgj.config.BusinessID
import com.wgmf.yxgj.dialog.PublicTipDialog
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.global.MediaParams
import com.wgmf.yxgj.global.NetworkParams
import com.wgmf.yxgj.module.business.reportproblem.R
import com.wgmf.yxgj.module.business.reportproblem.model.ProblemsUploadEntity
import com.wgmf.yxgj.module.business.reportproblem.service.ProblemsType
import com.wgmf.yxgj.module.business.reportproblem.service.QualityType
import com.wgmf.yxgj.module.business.reportproblem.service.ReportFeedbackService
import com.wgmf.yxgj.module.business.reportproblem.ui.dialog.ReportTypeELVSelectPop
import com.wgmf.yxgj.module.business.reportproblem.ui.fragment.*
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity
import com.wgmf.yxgj.report.ui.ReportBaseDetailActivity
import com.xp.arouter.RouterCommonUtil
import com.xp.arouter.RouterParams
import com.xp.arouter.model.PCClass
import kotlinx.android.synthetic.main.activity_dispatch_problem.*
import kotlinx.android.synthetic.main.include_qback_report_error_show.*
import java.util.*

/**
 * 反馈直通车
 * @author LW
 */
@Route(path = RouterParams.URL_REPORTPROBLEMSACTIVITY)
open class DispatchProblemsActivity : ReportBaseDetailActivity(),
    ReportTypeELVSelectPop.ReportTypeSelectPopListener,
    View.OnClickListener {

    private var mBranchId: Long = -1

    /**
     * 问题小类
     */
    private var mCType: String = ""

    /**
     * 问题小类ID
     */
    private var mCTypeId: String = ""

    /**
     * 问题大类
     */
    private var mPType: String = ""

    /**
     * 问题大类ID
     */
    private var mPTypeId: String = ""

    /**
     * 订单号
     */
    private var mOrderId: String = ""

    /**
     * 订单号
     */
    private var mStaffId: String? = null

    private var mFrag: BaseParentFra? = null

    private var mView: DispatchProblemsContract.IView? = null

    private var mReportTypeResultBean: PCClass? = null

    private var mReportTypeELVSelectPop: ReportTypeELVSelectPop? = null

    override fun initData() {
        super.initData()
        //问题上报
        reportType = "FK"
        //可以拍照和从相册中选择图片
        pickerMode = MediaParams.PARAMS_3
        //最多上传5张图片
        mPicSize = 5
        mPicDes = "最多只能上传" + mPicSize + "张图片!"
        //问题小类
        mCType = ProblemsType.getcType() ?: ""
        //问题小类ID
        mCTypeId = ProblemsType.getcTypeId() ?: ""
        //问题大类
        mPType = ProblemsType.getpType() ?: ""
        //问题大类ID
        mPTypeId = ProblemsType.getpTypeId() ?: ""
        //创建单号
        createOrderId()
    }

    override fun initView() {
        super.initView()
        setContentView(R.layout.activity_dispatch_problem)

        show_store.setOnClickListener(this)

        fromTypeSelector()

        // 默认不弹出软键盘
        window.setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN)
    }

    override fun initTitle() {
        super.initTitle()
        mBranchId = intent.getLongExtra("branchID", 0)
        homeTitleBackLl.visibility = View.VISIBLE
    }

    override fun parseFootData() {
        super.parseFootData()
        showCursor(true)
    }

    override fun setContent() {
        super.setContent()
        showParentType()
    }

    /**
     * 来自问题类型选择列表页
     */
    private fun fromTypeSelector() {
        try {
            mPType = intent.getStringExtra("pType")
            mPTypeId = intent.getStringExtra("pTypeId")
            report_type_tv.text = mPType
        } catch (e1: Exception) {
            Log.e(TAG, "initContentView: not from selector type page")
        }
        try {
            val hasChilden = intent.getBooleanExtra("hasChilden", false)
            if (hasChilden) {
                mCType = intent.getStringExtra("cType")
                mCTypeId = intent.getStringExtra("cTypeId")
                report_type_tv.text = mCType
            }
        } catch (e2: Exception) {
            Log.e(TAG, "initContentView: not from selector type page")
        }
    }

    /**
     * 显示一级类型
     */
    private fun showParentType() {
        show_store.visibility = View.VISIBLE

        val tran: FragmentTransaction = supportFragmentManager.beginTransaction()
        val bundle = Bundle().apply {
            putString(AppConstants.ExtraKeys.DISPATCH_PRODUCT_CTYPE,mCType)
        }

        when (mPType) {
            //产品质量问题
            QualityType.REPORT_TYPE_ZHILIANG -> {
                mFrag = ProductProblemFragment().apply {
                    arguments=bundle
                }
                showChildType()
            }
            //到货误差问题
            QualityType.REPORT_TYPE_WUCHA -> {
                reportEdit?.visibility = View.GONE
                mFrag = ArriveErrorFragment()
            }
            //柜子/物料质量问题
            QualityType.REPORT_TYPE_GUIZI -> {
                mFrag = CabinetQualityFragment().apply {
                    arguments=bundle
                }
            }
            //物流紧急联系人
            QualityType.REPORT_TYPE_WULIU -> {
                val intent = Intent(
                    this@DispatchProblemsActivity,
                    TelLogisticsActivity::class.java
                )
                startActivity(intent)
                this@DispatchProblemsActivity.finish()
            }
            //物流派送问题投诉
            QualityType.REPORT_TYPE_WULIU_DELIVER -> {
                mFrag = LogisticsDeliveryFragment()
                publicTakePhotoLl?.visibility = View.GONE
            }
            //意见与建议
            QualityType.REPORT_TYPE_YIJIAN -> {
                mFrag = CommentsSuggestionsFragment()
            }
            //我要找督察
            QualityType.REPORT_TYPE_DUCHA -> {
                mFrag = FindInspectorFragment()
                showChildType()
            }
            //本机问题
            QualityType.REPORT_TYPE_BENJI -> {
                show_store.visibility = View.GONE
                showChildType()
            }
            else -> {
            }
        }
        mFrag?.let {
            mView = it as DispatchProblemsContract.IView
            tran.replace(R.id.report_frag_container, mFrag as BaseParentFra).commit()
        }
    }

    /**
     * 显示二级类型
     */
    private fun showChildType() {
        report_type_tips_tv.visibility = View.GONE
        show_problems_type_tips.visibility = View.VISIBLE
        when (mCType) {
            QualityType.REPORT_TYPE_ZHILIANG_1 -> {
                report_type_tips_tv.setVisibility(View.VISIBLE)
                reportEdit?.setHint(R.string.report_type_zhiliang_1)
            }
            QualityType.REPORT_TYPE_ZHILIANG_2 -> {
                report_type_tips_tv.setVisibility(View.VISIBLE)
                reportEdit?.setHint(R.string.report_type_zhiliang_2)
            }
            QualityType.REPORT_TYPE_ZHILIANG_3 -> reportEdit?.setHint(R.string.report_type_zhiliang_3)
            QualityType.REPORT_TYPE_ZHILIANG_4 -> reportEdit?.setHint(R.string.report_type_zhiliang_4)
            QualityType.REPORT_TYPE_ZHILIANG_5 -> reportEdit?.setHint(R.string.report_type_zhiliang_5)
            QualityType.REPORT_TYPE_ZHILIANG_6 -> reportEdit?.setHint(R.string.report_type_zhiliang_6)
            QualityType.REPORT_TYPE_ZHILIANG_7 -> reportEdit?.setHint(R.string.report_type_zhiliang_7)
            QualityType.REPORT_TYPE_ZHILIANG_8 -> reportEdit?.setHint(R.string.report_type_zhiliang_8)
            QualityType.REPORT_TYPE_ZHILIANG_9 -> reportEdit?.setHint(R.string.report_type_zhiliang_9)
            QualityType.REPORT_TYPE_ZHILIANG_10 -> reportEdit?.setHint(R.string.report_type_zhiliang_10)
            QualityType.REPORT_TYPE_ZHILIANG_11 -> reportEdit?.setHint(R.string.report_type_zhiliang_11)
            QualityType.REPORT_TYPE_ZHILIANG_12 ->
                //突发事件处理
                toHtml(branchTitle, NetworkParams.PROBLEM_CALL, mBranchId)
            QualityType.REPORT_TYPE_DUCHA_2 ->
                //打电话投诉
                toHtml(branchTitle, NetworkParams.TELEPHONE_COMPLAINT, mBranchId)
            QualityType.REPORT_TYPE_DUCHA_3 ->
                //发微信投诉
                toHtml(branchTitle, NetworkParams.WEBCHAT_COMPLAINT, mBranchId)
            QualityType.REPORT_TYPE_BENJI_1 ->
                //本机问题
                show_problems_type_tips.visibility = View.GONE
            QualityType.REPORT_TYPE_BENJI_2 ->
                //紧急问题处理
                toHtml(branchTitle, NetworkParams.EMERGENCY_CALL, mBranchId)
            else -> {
            }
        }
    }

    /**
     * 跳转到Html页面
     *
     * @param branchTitle 页面标题
     * @param branchUrl   页面地址
     * @param branchId    功能ID
     */
    private fun toHtml(branchTitle: String, branchUrl: String, branchId: Long) {
        startActivity(Intent(this@DispatchProblemsActivity, HtmlActivity::class.java).apply {
            putExtra("branchTitle", branchTitle)
            putExtra("branchUrl", branchUrl)
            putExtra("branchID", branchId)
        })
        this@DispatchProblemsActivity.finish()
    }

    override fun uploadData() {
        super.uploadData()
        checkReportData()
    }

    private fun checkReportData() {

        showDialog()
        if (TextUtils.isEmpty(report_type_tv.text.toString())) {
            showMsg("请选择问题类型")
            dismissDialog()
            return
        }
        when (mPType) {
            QualityType.REPORT_TYPE_ZHILIANG -> {
                mView?.let {
                    if (!it.ruleCheckDataIntegrity()) {
                        dismissDialog()
                        return
                    }

                    if (!it.checkProductProblemDate()) {
                        showMsg("生产日期必须是今日之前（不含今日）!")
                        dismissDialog()
                        return
                    }

                    if (piclist == null || piclist.isEmpty()) {
                        showMsg("请选择上传图片")
                        dismissDialog()
                        return
                    }
                }
            }
            QualityType.REPORT_TYPE_WUCHA -> {
                mView?.let {
                    if (!it.ruleCheckDataIntegrity()) {
                        dismissDialog()
                        return
                    }
                    if (piclist == null || piclist.isEmpty()) {
                        showMsg("请选择上传图片")
                        dismissDialog()
                        return
                    }
                }
            }
            QualityType.REPORT_TYPE_GUIZI -> {
                mView?.let {
                    if (!it.ruleCheckDataIntegrity()) {
                        dismissDialog()
                        return
                    }
                    if (piclist == null || piclist.isEmpty()) {
                        showMsg("请选择上传图片")
                        dismissDialog()
                        return
                    }
                }
            }
            QualityType.REPORT_TYPE_DUCHA ->
                mView?.let {
                    if (!it.ruleCheckDataIntegrity()) {
                        dismissDialog()
                        return
                    }
                }
            QualityType.REPORT_TYPE_WULIU_DELIVER -> {
                mView?.let {
                    if (!it.ruleCheckDataIntegrity()) {
                        dismissDialog()
                        return
                    }
                    val logisticsDeliveryProblemList = it.getLogisticsDeliveryProblemList()
                    if (logisticsDeliveryProblemList.isEmpty()) {
                        showMsg("请选择投诉问题")
                        dismissDialog()
                        return
                    }
                }
            }
            QualityType.REPORT_TYPE_YIJIAN -> {
                mView?.let {
                    if (!it.ruleCheckDataIntegrity()) {
                        dismissDialog()
                        return
                    }
                }
            }
            else -> {
            }
        }
        uploadDataByType()
    }

    /**
     * 根据类型上传数据
     */
    private fun uploadDataByType() {
        when (mPType) {
            QualityType.REPORT_TYPE_ZHILIANG -> uploadProductProblemData()
            QualityType.REPORT_TYPE_WUCHA -> uploadArriveErrorData()
            QualityType.REPORT_TYPE_GUIZI -> uploadCabinetQualityData()
            QualityType.REPORT_TYPE_DUCHA -> uploadfindInspectorData()
            QualityType.REPORT_TYPE_WULIU_DELIVER -> uploadLogisticsDeliveryData()
            QualityType.REPORT_TYPE_YIJIAN -> uploadCommentsSuggestionsData()
            else -> uploadReportProblemsDate()
        }
    }

    /**
     * 产品质量问题
     */
    private fun uploadProductProblemData() {
        mView?.let {
            val content = Gson().toJson(
                it.productProblemEntityData(
                    shopName,
                    mPType,
                    mCType,
                    qiniuUrlLists
                )
            )
            Log.d(TAG, content)
            ReportFeedbackService.getInstance().createQualityFBWorkFlow(
                mStaffId,
                shopId,
                content,
                mOrderId,
                this@DispatchProblemsActivity
            )
        }
    }

    /**
     * 到货误差问题
     */
    private fun uploadArriveErrorData() {
        mView?.let {
            val content = Gson().toJson(it.arriveErrorEntityData(shopName, mPType, qiniuUrlLists))

            Log.d(TAG, content)
            ReportFeedbackService.getInstance().requestCreateAOGErrWorkFlow(
                mStaffId, shopId, content, mOrderId,
                this@DispatchProblemsActivity
            )

        }
    }

    /**
     * 柜子/物料质量问题
     */
    private fun uploadCabinetQualityData() {
        mView?.let {
            val content = Gson().toJson(
                it.cabinetQualityEntityData(
                    shopName,
                    mPType,
                    qiniuUrlLists
                )
            )
            Log.d(TAG, content)
            ReportFeedbackService.getInstance().createCabinetWorkFlow(
                mStaffId, shopId, mOrderId, mCTypeId, content,
                this@DispatchProblemsActivity
            )
        }
    }


    /**
     * 物流派送问题投诉
     */
    private fun uploadLogisticsDeliveryData() {
        mView?.let {
            val content = Gson().toJson(
                it.logisticsDeliveryEntityData(shopName, shopId, mStaffId)
            )
            Log.d(TAG, content)
            ReportFeedbackService.getInstance()
                .requestSaveLogisticsDeliveryBean(content, this@DispatchProblemsActivity)
        }
    }


    /**
     * 我要找督察
     */
    private fun uploadfindInspectorData() {
        mView?.let {
            val content = Gson().toJson(
                it.findInspectorEntityData(
                    shopName,
                    mPType,
                    mCType,
                    qiniuUrlLists
                )
            )
            Log.d(TAG, content)
            ReportFeedbackService.getInstance()
                .createComplaintWorkFlow(
                    mStaffId,
                    shopId,
                    content,
                    mOrderId,
                    this@DispatchProblemsActivity
                )
        }
    }


    /**
     * 意见与建议
     */
    private fun uploadCommentsSuggestionsData() {
        mView?.let {
            val content = Gson().toJson(
                it.commentsSuggestionsEntityData(
                    shopName,
                    mPType,
                    qiniuUrlLists
                )
            )
            Log.d(TAG, content)
            ReportFeedbackService.getInstance().createFeedbackWorkFlow(
                mStaffId,
                shopId,
                mOrderId,
                content,
                this@DispatchProblemsActivity
            )
        }
    }

    /**
     * 提交问题上报数据
     */
    private fun uploadReportProblemsDate() {
        if (null != userInfo) {
            val mProblemsUploadEntity = ProblemsUploadEntity()
            mProblemsUploadEntity.code1 = userInfo.organizationCode
            mProblemsUploadEntity.shopId = shopId
            mProblemsUploadEntity.content = reportEdit?.text.toString()
                .trim { it <= ' ' }
            mProblemsUploadEntity.managerUserId = userInfo.staffId
            mProblemsUploadEntity.problemType = mPTypeId + ""
            if (mPTypeId == ConstantParams.CONSTANT_PARAMS_2) {
                mProblemsUploadEntity.problemQualityTypeId = mCTypeId + ""
            }
            if (null != qiniuUrlLists) {
                mProblemsUploadEntity.urls = qiniuUrlLists
            }
            val content = Gson().toJson(mProblemsUploadEntity)
            Log.d(TAG, content)
            ReportFeedbackService.getInstance()
                .requestSaveQuestion(content, this@DispatchProblemsActivity)
        }
    }


    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)
        dismissDialog()
        val id = result?.taskID
        when (id) {
            BusinessID.ReportFeedback.MSG_ON_CREATE_CABINET_WORKFLOW,
            BusinessID.ReportFeedback.MSG_ON_CREATE_COMPLAINT_WORKFLOW,
            BusinessID.ReportFeedback.MSG_ON_CREATE_FEEDBACK_WORKFLOW,
            BusinessID.ReportFeedback.MSG_ON_CREATE_QUALITY_FB_WORKFLOW,
            BusinessID.ReportFeedback.MSG_ON_SAVE_LOGISTICS_DELIVERY_BEAN,
            BusinessID.ReportFeedback.MSG_ON_CREATE_AOGERR_WORKFLOW,
            BusinessID.ReportFeedback.MSG_ON_QUESTION_SAVE_QUESTION -> {
                val msg = result.info
                if (result.isSuccessed) {
                    val mBaseResponse = Gson().fromJson(msg, BaseResponse::class.java)
                    Log.d(
                        TAG,
                        "mBaseResponse=$mBaseResponse"
                    )
                    if (ConstantParams.CONSTANT_PARAMS_0 == mBaseResponse.retCode || ConstantParams.CONSTANT_PARAMS_0 == mBaseResponse.msgCode) {
                        cleanData()
                        this@DispatchProblemsActivity.finish()
                    }
                }
                showMsg(result.resultInfo)
            }
            else -> {
            }
        }
    }

    private fun cleanData() {
        report_store.text = ""
        report_type_tv.text = ""
        reportEdit.setText("")
        piclist.clear()
        refreshListView()
        reportPicAdapter = null
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (requestCode) {
            ConstantParams.CONSTANT_STARTS_7 ->
                if (resultCode == SelectorBaseActivity.RESULTCODE) {
                    try {
                        shopId = data?.getStringExtra("shopId")
                        shopName = data?.getStringExtra("shopName")
                        report_store.text = shopName

                        createOrderId() //创建单号

                        mView?.setShopId(shopId)
                    } catch (e: Exception) {
                        Log.e(TAG, "onActivityResult: data.getStringExtra error ")
                    }
                }
            else -> {
            }
        }
    }

    /**
     * 单号在提交之前生成，提交失败则使用同一个单号，提交成功则生成新的订单号
     * 在此处生成的好处是:保证页面创建出来即生成一个订单号，页面销毁或提交成功返回再进入生成新的订单号
     * 缺点是：时间不是订单提交时间而是进入功能页面时间
     */
    private fun createOrderId() {
        if (null != userInfo) {
            mStaffId = userInfo.staffId
            mOrderId =
                (if (null == shopId) "" else shopId) + mStaffId + DateUtil.getFormatCurrentDate("yyMMddHHmmss") + Random().nextInt(
                    100
                )
        }
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.show_store -> {
                selectorStore()
            }
            R.id.show_phone -> {
                takePhone()
            }
        }
    }

    /**
     * 选择门店
     */
    private fun selectorStore() {
        val mBundle = Bundle()
        mBundle.putLong("branchID", mBranchId)
        mBundle.putString("branchTitle", branchTitle)
        RouterCommonUtil.startFunctionActivityResult(
            this,
            -2,
            mBranchId,
            mBundle,
            ConstantParams.CONSTANT_STARTS_7
        )
    }

    /**
     * 物流联系人
     */
    private fun takePhone() {
        val intent = Intent(
            this@DispatchProblemsActivity,
            TelLogisticsActivity::class.java
        )
        startActivity(intent)
    }

    override fun back() {
        showBackTipDialog()
    }

    /**
     * 确认退出对话框
     */
    private fun showBackTipDialog() {
        val builder = PublicTipDialog.Builder(this)
        builder.setTitle("提示")
        builder.setMessage("确认退出？")
        builder.setNegativeButton("确定") { dialog, which ->
            dialog.dismiss()
            this@DispatchProblemsActivity.finish()
        }
        builder.setPositiveButton(
            "取消"
        ) { dialog, which -> dialog.dismiss() }
        builder.create().show()
    }

    override fun onTypeAdapterGroupClick(groupPosition: Int) {
        try {
            mReportTypeResultBean?.let {
                if (null == it.resultList[groupPosition].resultList) {
                    mReportTypeELVSelectPop?.dismiss()
                    mPType = it.resultList[groupPosition].name
                    mPTypeId = it.resultList[groupPosition].sid.toString() + ""
                    report_type_tv.text = mPType
                }
            }
        } catch (e: Exception) {
            Log.e(TAG, "onTypeAdapterGroupClick: ")
        }
    }

    override fun onTypeAdapterChildClick(groupPosition: Int, childPosition: Int) {
        try {
            mReportTypeResultBean?.let {
                mPType = it.resultList[groupPosition].name
                mPTypeId = it.resultList[groupPosition].sid.toString() + ""
                mCType = it.resultList[groupPosition].resultList[childPosition].name
                mCTypeId =
                    it.resultList[groupPosition].resultList[childPosition].sid.toString() + ""
                report_type_tv.setText(mCType)
            }
        } catch (e: Exception) {
            Log.e(TAG, "")
        }
    }

    override fun onDestroy() {
        ProblemsType.setpType("")
        ProblemsType.setpTypeId("")
        ProblemsType.setcType("")
        ProblemsType.setcTypeId("")
        super.onDestroy()
    }
}