package com.wgmf.yxgj.module.business.reportproblem.ui

import com.wgmf.yxgj.module.business.reportproblem.model.LogisticsDelivery
import com.wgmf.yxgj.module.business.reportproblem.model.LogisticsDeliveryProblemEntity
import com.wgmf.yxgj.module.business.reportproblem.model.QualityUploadEntity
import com.wgmf.yxgj.module.business.reportproblem.model.ReportErrorJsonEntity

class DispatchProblemsContract {

    interface IView {
        fun ruleCheckDataIntegrity(): Boolean

        fun setShopId(shopId: String)


        /**
         * 产品质量问题
         */
        fun productProblemEntityData(
            shopName: String,
            pType: String,
            cType: String,
            qinIuUrlLists: MutableList<String>?
        ): QualityUploadEntity {
            return QualityUploadEntity()
        }

        /**
         * 产品时间校验
         */
        fun checkProductProblemDate():Boolean=false

        /**
         * 到货误差问题
         */
        fun arriveErrorEntityData(shopName:String,pType: String, qinIuUrlLists: MutableList<String>?): ReportErrorJsonEntity {
            return ReportErrorJsonEntity()
        }

        /**
         * 柜子/物料质量问题
         */
        fun cabinetQualityEntityData(
            shopName: String,
            pType: String,
            qinIuUrlLists: MutableList<String>?
        ): QualityUploadEntity {
            return QualityUploadEntity()
        }

        /**
         * 投诉问题类别数据
         */
        fun getLogisticsDeliveryProblemList():MutableList<LogisticsDeliveryProblemEntity>{
            return mutableListOf()
        }

        /**
         * 我要找督察
         */
        fun findInspectorEntityData(
            shopName: String,
            pType: String,
            cType: String,
            qinIuUrlLists: MutableList<String>?
        ): QualityUploadEntity {
            return QualityUploadEntity()
        }

        /**
         * 物流派送问题投诉
         */
        fun logisticsDeliveryEntityData(
            shopName: String,
            shopId: String,
            staffId: String?
        ): LogisticsDelivery {
            return LogisticsDelivery()
        }

        /**
         * 意见与建议
         */
        fun commentsSuggestionsEntityData(
            shopName: String,
            pType: String,
            qinIuUrlLists: MutableList<String>?
        ): QualityUploadEntity {
            return QualityUploadEntity()
        }

    }
}