package com.wgmf.yxgj.module.business.reportproblem.ui.adapter

import android.content.Context
import android.widget.RadioButton
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.wgmf.yxgj.module.business.reportproblem.R
import com.wgmf.yxgj.module.business.reportproblem.model.DispatchProductEntity

/**
 * 选择配送单号 适配器
 * @author LW
 */
class DispatchBillChooseAdapter(
    private var context: Context,
    private var clickPosition: Int,
    data: List<DispatchProductEntity.DispatchProductBean>
) : BaseQuickAdapter<DispatchProductEntity.DispatchProductBean, BaseViewHolder>(
    R.layout.item_delivery_bill_choose, data
) {

    override fun convert(
        helper: BaseViewHolder?,
        item: DispatchProductEntity.DispatchProductBean?
    ) {

        helper?.apply {
            item?.let {
                val selectItemRadio = getView<RadioButton>(R.id.select_item_radio)
                selectItemRadio.isChecked = layoutPosition == clickPosition

                selectItemRadio.setOnCheckedChangeListener { buttonView, isChecked ->
                    onItemClickListener.onItemClick(
                        this@DispatchBillChooseAdapter,
                        itemView,
                        layoutPosition
                    )
                }

                setText(
                    R.id.delivery_bill,
                    context.getString(R.string.problem_escalation_delivery_bill, it.waveNo)
                )
                setText(
                    R.id.delivery_date,
                    context.getString(R.string.problem_escalation_Receipt_date, it.takeGoodDate)
                )
                setText(
                    R.id.delivery_total_amount,
                    context.getString(R.string.problem_escalation_total_amount, it.allProSumAmount)
                )
                setText(
                    R.id.delivery_total_number,
                    context.getString(R.string.problem_escalation_total_number, it.allProSumQty)
                )
            }
        }
    }

}
