package com.wgmf.yxgj.module.business.reportproblem.ui.adapter;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.reportproblem.R;
import com.xp.arouter.model.PCClass;
import com.xp.arouter.model.Parent;


public class ReportTypeListAdapter extends BaseExpandableListAdapter {
    private Context context;
    private PCClass mReportTypeResultBean;

    public ReportTypeListAdapter(Context context, PCClass mReportTypeResultBean) {
        this.context = context;
        this.mReportTypeResultBean = mReportTypeResultBean;
    }

    @Override
    public int getGroupCount() {
        return mReportTypeResultBean.getResultList() != null ? mReportTypeResultBean.getResultList().size() : 0;
    }

    @Override
    public int getChildrenCount(int i) {
        return mReportTypeResultBean.getResultList().get(i).getResultList() != null ? mReportTypeResultBean.getResultList().get(i).getResultList().size() : 0;
    }

    @Override
    public Object getGroup(int i) {
        return mReportTypeResultBean.getResultList();
    }

    @Override
    public Object getChild(int i, int i1) {
        return mReportTypeResultBean.getResultList().get(i).getResultList();
    }

    @Override
    public long getGroupId(int i) {
        return i;
    }

    @Override
    public long getChildId(int i, int i1) {
        return i1;
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public View getGroupView(int groupPosition, boolean isExpanded, View convertView, ViewGroup viewGroup) {
        final GroupViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.item_report_type_listview_group, null);
            viewHolder = new GroupViewHolder();
            viewHolder.tvReportType = convertView.findViewById(R.id.report_type);
            viewHolder.ivReportArrow = convertView.findViewById(R.id.report_arrow);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (GroupViewHolder) convertView.getTag();
        }
        Parent parent = mReportTypeResultBean.getResultList().get(groupPosition);
        viewHolder.tvReportType.setText(parent.getName());

        if (parent.getResultList() == null) {
            viewHolder.ivReportArrow.setVisibility(View.GONE);
        } else {
            viewHolder.ivReportArrow.setVisibility(View.VISIBLE);
            if (isExpanded) {
                viewHolder.ivReportArrow.setImageDrawable(ContextCompat.getDrawable(context, R.drawable.list_group_close));
            } else {
                viewHolder.ivReportArrow.setImageDrawable(ContextCompat.getDrawable(context, R.drawable.list_group_open));
            }
        }
        return convertView;
    }

    @Override
    public View getChildView(int groupPosition, int childPosition, boolean isLastChild, View convertView, ViewGroup viewGroup) {
        final ChildViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.item_report_type_listview_child, null);
            viewHolder = new ChildViewHolder();
            viewHolder.tvReportType = convertView
                    .findViewById(R.id.report_type);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ChildViewHolder) convertView.getTag();
        }
        viewHolder.tvReportType.setText(mReportTypeResultBean.getResultList().get(groupPosition).getResultList().get(childPosition).getName());
        return convertView;
    }

    @Override
    public boolean isChildSelectable(int i, int i1) {
        return true;
    }

    static class ChildViewHolder {
        TextView tvReportType;
    }

    static class GroupViewHolder {
        TextView tvReportType;
        ImageView ivReportArrow;
    }
}
