package com.wgmf.yxgj.module.business.reportproblem.ui.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.reportproblem.R;
import com.wgmf.yxgj.module.business.reportproblem.model.ProductListEntity;

import java.util.List;


public class SelectorProductsAdapter extends BaseAdapter {
    private Context context;
    private List<ProductListEntity> list;

    public SelectorProductsAdapter(Context context, List<ProductListEntity> list) {
        this.context = context;
        this.list = list;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public ProductListEntity getItem(int position) {
        if (position >= list.size()) {
            return null;
        } else {
            return list.get(position);
        }
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    static class ViewHolder {
        TextView name, unit, no;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.item_second_addmenu, null);
            holder.name = convertView.findViewById(R.id.goods_names);
            holder.unit = convertView.findViewById(R.id.goods_unit);
            holder.no = convertView.findViewById(R.id.goods_nums);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        ProductListEntity data = list.get(position);
        holder.name.setText(data.getName());
        holder.unit.setText("【" + data.getProductUnit() + "】");
        holder.no.setText(data.getProductCode());
        return convertView;
    }
}
