package com.wgmf.yxgj.module.business.reportproblem.ui.dialog;

import android.content.Context;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.module.business.reportproblem.R;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;

import java.util.ArrayList;
import java.util.List;

public class ReportQuerySelectPop implements View.OnClickListener, AdapterView.OnItemClickListener {

    private PopupWindow reportQuerySelectPw;

    private View viewParent;

    private List<String> mFunctionName;

    ReportQuerySelectPopListener reportQuerySelectPopListener;



    @Override
    public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {
        dismiss();
        reportQuerySelectPopListener.onAdapterItemClick(i, mFunctionName);
    }

    public  interface ReportQuerySelectPopListener {

        void onAdapterItemClick(int position, List<String> mFunctionName);

    }

    public ReportQuerySelectPop(final Context context, ReportQuerySelectPopListener reportQuerySelectPopListener, List<String> mFunctionName) {
        this(context, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, reportQuerySelectPopListener, mFunctionName);
    }

    private ReportQuerySelectPop(final Context context, final int width, final int height, ReportQuerySelectPopListener reportQuerySelectPopListener, List<String> mFunctionName) {
        this.reportQuerySelectPopListener = reportQuerySelectPopListener;
        this.mFunctionName = mFunctionName;

        LayoutInflater inflater = LayoutInflater.from(context);
        viewParent = inflater.inflate(R.layout.view_report_query_dialog, null);

        ListView shopHistoryLv = viewParent.findViewById(R.id.shop_history_lv);
        TextView shopProductHistoryEmptyTv = viewParent.findViewById(R.id.shop_history_empty_tv);
        shopHistoryLv.setEmptyView(shopProductHistoryEmptyTv);
        LinearLayout shopHistoryDialogCancelLl = viewParent.findViewById(R.id.shop_history_ll);
        ImageView shopHistoryDialogCancelIv = viewParent.findViewById(R.id.shop_history_dialog_cancel_iv);

        List<BaseSelectorEntity> reportQuerys = new ArrayList<>();
        for (String aMFunctionName : mFunctionName) {
            BaseSelectorEntity mModel = new BaseSelectorEntity();
            mModel.setSelectorName(aMFunctionName);
            reportQuerys.add(mModel);
        }
        BaseCommonAdapter typeAdapter = new BaseCommonAdapter<BaseSelectorEntity>(context, reportQuerys) {
            @Override
            public void convert(ViewHolder helper, BaseSelectorEntity item) {
                helper.setText(item.getSelectorName() + "");
            }
        };
        shopHistoryLv.setAdapter(typeAdapter);
        reportQuerySelectPw = new PopupWindow(viewParent, width, height, true);
        shopHistoryDialogCancelLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                reportQuerySelectPw.dismiss();
            }
        });
        shopHistoryDialogCancelIv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                reportQuerySelectPw.dismiss();
            }
        });
        shopHistoryLv.setOnItemClickListener(this);
        setListViewHeight(shopHistoryLv);
    }

    public boolean isShowing() {
        return null != reportQuerySelectPw && reportQuerySelectPw.isShowing();
    }

    public void show(View parent) {
        if (null == parent) {
            throw new IllegalArgumentException("StoreDateSelectorPop.showAtLocation parent is null");
        }
        viewParent = parent;
        reportQuerySelectPw.showAtLocation(parent, Gravity.CENTER, 0, 0);
    }

    public void dismiss() {
        if (null != reportQuerySelectPw && reportQuerySelectPw.isShowing()) {
            reportQuerySelectPw.dismiss();
        }
    }

    @Override
    public void onClick(View view) {
        dismiss();
    }


    private void setListViewHeight(ListView listView) {

        ListAdapter listAdapter = listView.getAdapter();

        if (listAdapter == null) {
            return;
        }
        int totalHeight = 0;
        for (int i = 0, len = listAdapter.getCount(); i < len; i++) {
            View listItem = listAdapter.getView(i, null, listView);
            listItem.measure(0, 0);
            totalHeight += listItem.getMeasuredHeight();
        }
        ViewGroup.LayoutParams params = listView.getLayoutParams();
        params.height = totalHeight
                + (listView.getDividerHeight() * (listAdapter.getCount() - 1));
        listView.setLayoutParams(params);
    }
}
