package com.wgmf.yxgj.module.business.reportproblem.ui.fragment

import android.content.Intent
import android.os.Bundle
import android.text.Editable
import android.text.TextWatcher
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.widget.*
import com.github.yoojia.inputs.AndroidNextInputs
import com.github.yoojia.inputs.StaticScheme
import com.github.yoojia.inputs.ValueScheme
import com.google.gson.Gson
import com.wgmf.library.base.ResultData
import com.wgmf.library.utils.Arith
import com.wgmf.library.utils.DateUtil
import com.wgmf.yxgj.base.BaseCommonAdapter
import com.wgmf.yxgj.base.BaseParentFra
import com.wgmf.yxgj.base.ViewHolder
import com.wgmf.yxgj.config.BusinessID
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.business.reportproblem.R
import com.wgmf.yxgj.module.business.reportproblem.model.DispatchProductEntity
import com.wgmf.yxgj.module.business.reportproblem.model.ReportErrorJsonEntity
import com.wgmf.yxgj.module.business.reportproblem.service.QualityType
import com.wgmf.yxgj.module.business.reportproblem.service.ReportFeedbackService
import com.wgmf.yxgj.module.business.reportproblem.ui.DispatchProblemsContract
import com.wgmf.yxgj.module.business.reportproblem.ui.DispatchProductChooseActivity
import com.wgmf.yxgj.module.business.reportproblem.ui.holder.WuChaChildHolder
import com.wgmf.yxgj.publics.model.BaseSelectorEntity
import com.wgmf.yxgj.utils.StringUtils
import com.wgmf.yxgj.utils.helper.DialogHelper
import com.wgmf.yxgj.utils.isNotNullOrSize
import com.wgmf.yxgj.widgets.EditText.LimitEditText
import com.wgmf.yxgj.widgets.MMessageDisplay
import kotlinx.android.synthetic.main.fragment_arrive_problems.*
import kotlinx.android.synthetic.main.include_qback_report_error_show.*
import org.json.JSONObject
import java.util.*
import kotlin.collections.ArrayList

/**
 * 到货误差问题
 * @author LW
 */
class ArriveErrorFragment : BaseParentFra(), DispatchProblemsContract.IView {

    private var mReportStore: TextView? = null

    private var mShopId: String = ""

    private var mDispatchProductEntity: DispatchProductEntity? = null

    private var mDispatchProductPos = -1

    private val mDispatchProductIdList = arrayListOf<Int>()

    override fun rootLayoutId(): Int = R.layout.fragment_arrive_problems

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        activity?.apply {
            mReportStore = findViewById(R.id.report_store)
        }

        fetchDispatchProduct()

        initReportErrorLayout()
    }

    /**
     * 初始化 到货误差 组件。
     */
    private fun initReportErrorLayout() {
        userInfo?.let {
            shouhuo_person_show.setText(it.name)
        }

        //配送波次号
        boci_number_input.setOnClickListener { v: View ->
            selectorDispatchProduct(
                mDispatchProductEntity,
                mDispatchProductPos,
                DispatchProductChooseActivity.DELIVERY_BILL
            )
        }

        //收发货日期。
        shouhuo_date_show.text = DateUtil.format(Date(), "yyyy-MM-dd")
        shouhuo_date_show.setOnClickListener {
            DialogHelper.AlertDatePicker(mContext, this, shouhuo_date_show)
        }
        //Spinner区
        packing_damage_spinner.adapter = setSpinnerData(QualityType.DAMAGE_ARRAY)
        packing_id_compl_spinner.adapter = setSpinnerData(QualityType.COMPL_ARRAY)
        ll_sign_state_spinner.adapter = setSpinnerData(QualityType.SIGN_ARRAY)

        //选择波次号产品
        select_all_goods.setOnClickListener { v: View? ->
            selectorDispatchProduct(
                mDispatchProductEntity,
                mDispatchProductPos,
                DispatchProductChooseActivity.DELIVERY_BILL_PRODUCT
            )
        }

    }

    /**
     * 选择配送单号
     *
     * @param dispatchProductEntity DispatchProductEntity
     * @param dispatchProductPos    Int
     * @param dispatchProductType   String
     */
    private fun selectorDispatchProduct(
        dispatchProductEntity: DispatchProductEntity?,
        dispatchProductPos: Int, dispatchProductType: String?
    ) {
        startActivityForResult(
            Intent(
                mContext,
                DispatchProductChooseActivity::class.java
            ).apply {
                putExtra(AppConstants.ExtraKeys.DISPATCH_PRODUCT_DATA, dispatchProductEntity)
                putExtra(AppConstants.ExtraKeys.DISPATCH_PRODUCT_POS, dispatchProductPos)
                putExtra(AppConstants.ExtraKeys.DISPATCH_PRODUCT_TYPE, dispatchProductType)
            }, ConstantParams.CONSTANT_STARTS_8
        )
    }

    /**
     * 获取到货误差配送单号产品
     */
    private fun fetchDispatchProduct() {
        if (mShopId.isNotEmpty()) {
            userInfo?.let {
                val jsonObject = JSONObject()
                jsonObject.put("storeNo", mShopId)
                jsonObject.put("userNo", it.staffId)
                val content = jsonObject.toString()
                Log.d(TAG, content)
                showDialog()
                ReportFeedbackService.getInstance().requestGetDispatchProduct(
                    it.staffId, mShopId,
                    content, this@ArriveErrorFragment
                )
            }
        }
    }

    /**
     * 到货误差  添加子组件。
     * pos  添加到哪个位置。
     */
    private fun addChildToLayout(
        pos: Int,
        pickingCode: String?,
        dispatchDetailBean: DispatchProductEntity.DispatchProductBean.DispatchDetailBean
    ) {
        dispatchDetailBean.let {
            val child = LayoutInflater.from(mContext).inflate(R.layout.goods_item, null, false)
            val holder = WuChaChildHolder().apply {
                goodsName = child.findViewById<TextView>(R.id.goods_name).apply {
                    text = it.proName
                    tag = it
                }

                selectDate = child.findViewById(R.id.select_date)
                reportUnit =
                    child.findViewById<TextView>(R.id.report_unit).apply { text = it.uomName }
                reportUnit2 =
                    child.findViewById<TextView>(R.id.report_unit2).apply { text = it.uomName }
                huodan =
                    child.findViewById<TextView>(R.id.huodan_num_input).apply { text = it.proQty }
                duanque = child.findViewById(R.id.duanque_input)

                shishou =
                    child.findViewById<LimitEditText>(R.id.shishou_num_item).apply {
                        addTextChangedListener(object : TextWatcher {
                            override fun beforeTextChanged(
                                s: CharSequence?,
                                start: Int,
                                count: Int,
                                after: Int
                            ) {
                            }

                            override fun onTextChanged(
                                s: CharSequence?,
                                start: Int,
                                before: Int,
                                count: Int
                            ) {
                            }

                            override fun afterTextChanged(s: Editable?) {
                                val huodanValue = if (huodan?.text.toString().isNotEmpty())
                                    huodan?.text.toString().toDouble()
                                else
                                    0.0
                                val shishouValue = if (s.toString().isNotEmpty())
                                    s?.toString()?.toDouble() ?: 0.0
                                else
                                    0.0
                                duanque?.text = StringUtils.formatDouble(
                                    Arith.sub(huodanValue, shishouValue),
                                    "0.00"
                                )
                            }
                        })
                    }

                isChuanhao = child.findViewById(R.id.is_chuanhao_spinner)
                isChuanhao.adapter = setSpinnerData(QualityType.YES_OR_NO_ARRAY)

                boxNum = child.findViewById<TextView>(R.id.box_num_input).apply {
                    text = pickingCode
                }
                shuoming = child.findViewById(R.id.short_shuoming)

                selectDate?.setOnClickListener {
                    DialogHelper.AlertDatePicker(
                        mContext,
                        this@ArriveErrorFragment,
                        selectDate
                    )
                }
            }

            mDispatchProductIdList.add(pos)

            child.tag = holder
            report_goods_items_container.addView(child)
        }
    }

    private fun setSpinnerData(array: Array<String>): BaseCommonAdapter<BaseSelectorEntity> {
        val damageGroup: MutableList<BaseSelectorEntity> = ArrayList()
        for (i in array.indices) {
            val baseSelectorEntity = BaseSelectorEntity()
            baseSelectorEntity.selectorName = array[i]
            baseSelectorEntity.selectorId = i.toString() + ""
            damageGroup.add(baseSelectorEntity)
        }
        return object : BaseCommonAdapter<BaseSelectorEntity>(
            mContext, damageGroup
        ) {
            override fun convert(helper: ViewHolder, item: BaseSelectorEntity) {
                helper.setText(item.selectorName)
                helper.setRightGone(View.GONE)
            }
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (requestCode) {
            ConstantParams.CONSTANT_STARTS_8 -> {  //到货误差 的 选择产品,配送单号
                if (resultCode == ConstantParams.CONSTANT_STARTS_1) {

                    val entity =
                        data?.getSerializableExtra(AppConstants.ExtraKeys.DISPATCH_PRODUCT_DATA)
                    if (entity != null) {
                        mDispatchProductEntity = entity as DispatchProductEntity
                    }

                    val dispatchProductType =
                        data?.getStringExtra(AppConstants.ExtraKeys.DISPATCH_PRODUCT_TYPE)

                    if (dispatchProductType == DispatchProductChooseActivity.DELIVERY_BILL) {
                        val pos: Int =
                            data.getIntExtra(AppConstants.ExtraKeys.DISPATCH_PRODUCT_POS, -1)
                        refreshDeliveryBill(pos)

                    } else if (dispatchProductType == DispatchProductChooseActivity.DELIVERY_BILL_PRODUCT) {
                        refreshDeliveryBillProduct()
                    }
                }
            }
        }
    }

    /**
     * 刷新配送波次号产品
     */
    private fun refreshDeliveryBillProduct() {
        if (mDispatchProductPos >= 0) {
            val list = mDispatchProductEntity?.resultInfo?.get(mDispatchProductPos)
            val dispatchDetailList = list?.dispatchDetailList
            val pickingCode = list?.pickingCode

            if (dispatchDetailList.isNotNullOrSize()) {
                dispatchDetailList?.forEachIndexed { pos, dispatchDetailBean ->
                    if (dispatchDetailBean.chooseStatus) {
                        //增加产品
                        if (!mDispatchProductIdList.contains(pos)) {
                            addChildToLayout(pos, pickingCode, dispatchDetailBean)
                        }
                    } else {
                        //删除产品
                        if (mDispatchProductIdList.contains(pos)) {
                            removeChildToLayout(pos)
                        }
                    }
                }
            }
        }
    }

    /**
     * 到货误差  删除子组件。
     * @param index  添加到哪个位置。
     */
    private fun removeChildToLayout(pos: Int) {
        val index = mDispatchProductIdList.indexOf(pos)
        mDispatchProductIdList.remove(pos)
        report_goods_items_container.removeViewAt(index)
    }

    /**
     * 刷新配送波次号
     */
    private fun refreshDeliveryBill(pos: Int) {
        if (pos >= 0 && mDispatchProductPos != pos) {
            mDispatchProductPos = pos

            val dispatchProductBean =
                mDispatchProductEntity?.resultInfo?.get(mDispatchProductPos)
            //配送波次号
            boci_number_input.text = dispatchProductBean?.waveNo
            //收货时间
            shouhuo_date_show.text = dispatchProductBean?.takeGoodDate
            //应收箱数
            yingshou_num_input.setText(dispatchProductBean?.boxUnreceivedNum)
            //实收箱数
            //shishou_num_input.setText(dispatchProductBean?.boxReceivedNum)
            removeAllGoodsData()
        }
    }

    /**
     * 移除GoodsItemContainer中控件,删除产品Id
     */
    private fun removeAllGoodsData() {
        if (report_goods_items_container.childCount > 0) {
            report_goods_items_container.removeAllViews()
        }
        mDispatchProductIdList.clear()
    }

    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)
        dismissDialog()
        result?.let {
            if (it.taskID == BusinessID.ReportFeedback.MSG_ON_GET_DISPATCH_PRODUCT) {
                if (it.isSuccessed) {
                    val entity = Gson().fromJson(it.info, DispatchProductEntity::class.java)
                    Log.d(TAG, "DispatchProductEntity=$entity")
                    if (ConstantParams.CONSTANT_PARAMS_0 == entity.msgCode) {
                        this.mDispatchProductEntity = entity
                    } else {
                        showMsg(it.resultInfo)
                    }
                } else {
                    showMsg(it.resultInfo)
                }
            }
        }
    }

    override fun ruleCheckDataIntegrity(): Boolean {
        val inputs = AndroidNextInputs()
        inputs.add(mReportStore, StaticScheme.Required())

        inputs.add(boci_number_input, StaticScheme.Required(), ValueScheme.MinLength(12))
        inputs.add(shouhuo_person_show, StaticScheme.Required())
        inputs.add(telephone_show, StaticScheme.Required(), StaticScheme.ChineseMobile())

        inputs.add(yingshou_num_input, StaticScheme.Required())
        inputs.add(shishou_num_input, StaticScheme.Required())

        val childNum: Int = report_goods_items_container.childCount
        if (childNum > 0) {
            for (i in 0 until childNum) {
                val view: View = report_goods_items_container.getChildAt(i)
                //inputs.add(
                //    (view.tag as WuChaChildHolder).goodsName,
                //    ValueScheme.NotEquals("请选择产品").msgOnFail("未选择产品")
                //)
                inputs.add(
                    (view.tag as WuChaChildHolder).selectDate,
                    StaticScheme.Required().msgOnFail("未选择生产日期")
                )
                inputs.add(
                    (view.tag as WuChaChildHolder).huodan,
                    StaticScheme.Required()
                )
                inputs.add(
                    (view.tag as WuChaChildHolder).shishou,
                    StaticScheme.Required()
                )
                inputs.add(
                    (view.tag as WuChaChildHolder).duanque,
                    StaticScheme.Required()
                )
                inputs.add(
                    (view.tag as WuChaChildHolder).boxNum,
                    StaticScheme.Required()
                )
                inputs.add(
                    (view.tag as WuChaChildHolder).shuoming,
                    StaticScheme.Required()
                )
            }
            val messageDisplay = MMessageDisplay()
            inputs.setMessageDisplay(messageDisplay)

        } else {
            showMsg("请选择产品后再提交")
            return false
        }

        return if (inputs.test()) {
            // 校验通过
            inputs.clear()
            true
        } else {
            showMsg("填写有误，请检查")
            inputs.clear()
            false
        }
    }

    override fun arriveErrorEntityData(
        shopName: String,
        pType: String,
        qinIuUrlLists: MutableList<String>?
    ): ReportErrorJsonEntity {
        val entity = ReportErrorJsonEntity()
        //写死的表
        entity.tb1.setMendmc(shopName)
        entity.tb1.setPeisbch(boci_number_input.text.toString())
        entity.tb1.setShouhsj(shouhuo_date_show.text.toString())
        entity.tb1.setShouhrjlxfs(shouhuo_person_show.text.toString())
        entity.tb1.setLianxfs(telephone_show.text.toString())
        entity.tb1.setYingsjs(yingshou_num_input.text.toString())
        entity.tb1.setShisjs(shishou_num_input.text.toString())
        entity.tb1.setWaixbzpscd(packing_damage_spinner.selectedItemPosition - 1)
        entity.tb1.setWaixbssfwz(packing_id_compl_spinner.selectedItemPosition - 1)
        entity.tb1.setWuldqsqk(ll_sign_state_spinner.selectedItemPosition - 1)
        //可扩展的表
        val num: Int = report_goods_items_container.childCount
        for (i in 0 until num) {
            val item = entity.Table2Item()
            val view: View = report_goods_items_container.getChildAt(i)
            val holder = view.tag as WuChaChildHolder
            holder.let {
                val dispatchDetailBean =
                    it.goodsName?.tag as DispatchProductEntity.DispatchProductBean.DispatchDetailBean

                item.setChanpmc(it.goodsName.text.toString())     //产品名
                item.produceDate = it.selectDate?.text.toString() //生产日期
                item.setHuodsl(holder.huodan.text.toString() + it.reportUnit?.text.toString()) //货单数量
                item.setShifsl(
                    holder.shishou.text.toString() + it.reportUnit2?.text.toString()
                )  //实收数量
                item.setDuanqqk(holder.duanque.text.toString())  //短缺情况
                item.setWaixbh(holder.boxNum.text.toString())  //外箱编码
                item.setJiandsm(holder.shuoming.text.toString())  //简短说明
                item.setWuldm(dispatchDetailBean.proCode)    //物料代码
                item.setChanpjg(dispatchDetailBean.proPrice) //产品价格
                entity.tb2list.add(item)
            }
        }
        //标题
        entity.title = pType
        if (null != qinIuUrlLists) {
            entity.url = qinIuUrlLists
        }
        return entity
    }

    override fun setShopId(shopId: String) {
        this.mShopId = shopId
        fetchDispatchProduct()
    }

}