package com.wgmf.yxgj.module.business.reportproblem.ui.fragment

import android.annotation.SuppressLint
import android.os.Bundle
import android.view.View
import android.widget.EditText
import android.widget.TextView
import com.github.yoojia.inputs.AndroidNextInputs
import com.github.yoojia.inputs.StaticScheme
import com.wgmf.library.base.ResultData
import com.wgmf.yxgj.base.BaseParentFra
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.module.business.reportproblem.R
import com.wgmf.yxgj.module.business.reportproblem.model.QualityUploadEntity
import com.wgmf.yxgj.module.business.reportproblem.service.QualityType
import com.wgmf.yxgj.module.business.reportproblem.ui.DispatchProblemsContract
import com.wgmf.yxgj.widgets.MMessageDisplay
import kotlinx.android.synthetic.main.include_qback_report_guizi_show.*
import kotlinx.android.synthetic.main.include_qback_report_user_phone_show.*

/**
 * 柜子/物料质量问题
 * @author LW
 */
@SuppressLint("ValidFragment")
class CabinetQualityFragment() : BaseParentFra(), DispatchProblemsContract.IView {

    private var mReportStore: TextView? = null

    private var mReportEdit: EditText? = null

    private var mShopId: String = ""

    private var mCType: String? = ""

    override fun rootLayoutId(): Int = R.layout.fragment_cabinet_quality

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        activity?.apply {
            mReportStore = findViewById(R.id.report_store)
            mReportEdit = findViewById(R.id.report_edit)
        }

        userInfo?.let {
            problems_user.setText(it.name)
        }
        mCType=arguments?.getString(AppConstants.ExtraKeys.DISPATCH_PRODUCT_CTYPE)
        if (QualityType.REPORT_TYPE_ZILIANG2 == mCType) {
            problems_guizi_name_tv.setText(R.string.problems_wuliao_name)
        } else {
            problems_guizi_name_tv.setText(R.string.problems_guizi_name)
        }

    }

    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)

    }

    override fun ruleCheckDataIntegrity(): Boolean {
        val inputs = AndroidNextInputs()
        inputs.add(mReportStore, StaticScheme.Required())
        inputs.add(problems_guizi_name, StaticScheme.Required())
        inputs.add(problems_guizi_number, StaticScheme.Required(), StaticScheme.Numeric())
        inputs.add(problems_user, StaticScheme.Required())
        inputs.add(problems_phone, StaticScheme.Required(), StaticScheme.ChineseMobile())
        inputs.add(mReportEdit, StaticScheme.Required())

        val messageDisplay = MMessageDisplay()
        inputs.setMessageDisplay(messageDisplay)

        return if (inputs.test()) {
            // 校验通过
            inputs.clear()
            true
        } else {
            showMsg("填写有误，请检查")
            inputs.clear()
            false
        }
    }

    override fun cabinetQualityEntityData(
        shopName: String,
        pType: String,
        qinIuUrlLists: MutableList<String>?
    ): QualityUploadEntity {
        val entity = QualityUploadEntity()
        entity.description = mReportEdit?.text.toString()
        entity.cabinetName = problems_guizi_name.text.toString()
        entity.count = problems_guizi_number.text.toString()
        entity.mobile = problems_phone.text.toString()
        entity.submiter = problems_user.text.toString()
        entity.shopName = shopName
        entity.title = pType
        if (qinIuUrlLists != null) {
            entity.url = qinIuUrlLists
        }
        return entity
    }

    override fun setShopId(shopId: String) {
        this.mShopId = shopId
    }
}