package com.wgmf.yxgj.module.business.reportproblem.ui.fragment

import android.os.Bundle
import android.view.View
import android.widget.EditText
import android.widget.LinearLayout
import android.widget.TextView
import com.github.yoojia.inputs.AndroidNextInputs
import com.github.yoojia.inputs.StaticScheme
import com.github.yoojia.inputs.ValueScheme
import com.wgmf.library.base.ResultData
import com.wgmf.yxgj.base.BaseParentFra
import com.wgmf.yxgj.module.business.reportproblem.R
import com.wgmf.yxgj.module.business.reportproblem.model.QualityUploadEntity
import com.wgmf.yxgj.module.business.reportproblem.ui.DispatchProblemsContract
import com.wgmf.yxgj.module.business.reportproblem.ui.dialog.ReportQuerySelectPop
import com.wgmf.yxgj.widgets.MMessageDisplay
import kotlinx.android.synthetic.main.include_qback_report_user_phone_show.*
import kotlinx.android.synthetic.main.include_qback_report_yijian_show.*
import java.util.*

/**
 * 意见与建议
 * @author LW
 */
class CommentsSuggestionsFragment : BaseParentFra(), DispatchProblemsContract.IView,
    ReportQuerySelectPop.ReportQuerySelectPopListener {

    private var mTitleLayout: LinearLayout? = null

    private var mReportStore: TextView? = null

    private var mReportEdit: EditText? = null

    private var mShopId: String = ""

    private var mReportQuerySelectPop: ReportQuerySelectPop? = null

    override fun rootLayoutId(): Int = R.layout.fragment_comments_suggestions

    private var mProblemsTopicType: Int = 0

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        activity?.apply {
            mReportStore = findViewById(R.id.report_store)
            mReportEdit = findViewById(R.id.report_edit)
            mTitleLayout = findViewById(R.id.title)
        }

        userInfo?.let {
            problems_user.setText(it.name)
        }

        problems_topic.setOnClickListener {
            selectorTopic()
        }

    }

    private fun selectorTopic() {
        val mFunctionName = Arrays.asList(
            *resources.getStringArray(
                R.array.problemsTopicType
            )
        )
        if (null == mReportQuerySelectPop) {
            mReportQuerySelectPop = ReportQuerySelectPop(mContext, this, mFunctionName)
        }
        mReportQuerySelectPop?.takeIf { it-> !it.isShowing }?.apply {
            show(mTitleLayout)
        }
    }

    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)
    }

    override fun ruleCheckDataIntegrity(): Boolean {
        //校验框架
        val inputs = AndroidNextInputs()
        inputs.add(problems_user, StaticScheme.Required())
        inputs.add(problems_phone, StaticScheme.Required(), StaticScheme.ChineseMobile())
        inputs.add(
            problems_topic,
            StaticScheme.Required(),
            ValueScheme.NotEquals("请选择").msgOnFail("未选择主题类型")
        )
        inputs.add(mReportEdit, StaticScheme.Required())

        val messageDisplay = MMessageDisplay()
        inputs.setMessageDisplay(messageDisplay)

        return if (inputs.test()) {
            // 校验通过
            inputs.clear()
            true
        } else {
            showMsg("填写有误，请检查")
            inputs.clear()
            false
        }
    }

    override fun commentsSuggestionsEntityData(
        shopName: String,
        pType: String,
        qinIuUrlLists: MutableList<String>?
    ): QualityUploadEntity {
        val entity = QualityUploadEntity()
        entity.themeType = mProblemsTopicType
        entity.shopName = shopName
        entity.mobile = problems_phone.text.toString()
        entity.submiter = problems_user.text.toString()
        entity.description = mReportEdit?.text.toString()
        entity.title = pType

        if (null != qinIuUrlLists) {
            entity.url = qinIuUrlLists
        }
        return entity
    }

    override fun onAdapterItemClick(position: Int, mFunctionName: MutableList<String>) {
        mProblemsTopicType = position
        problems_topic.text = mFunctionName[position]
    }

    override fun setShopId(shopId: String) {
        this.mShopId = shopId
    }

    override fun onDestroyView() {
        super.onDestroyView()
        mReportQuerySelectPop?.dismiss()
        mReportQuerySelectPop=null
    }

}