package com.wgmf.yxgj.module.business.reportproblem.ui.fragment

import android.content.Intent
import android.os.Bundle
import android.text.TextUtils
import android.util.Log
import android.view.View
import android.widget.EditText
import android.widget.ImageButton
import android.widget.LinearLayout
import android.widget.TextView
import com.github.yoojia.inputs.AndroidNextInputs
import com.github.yoojia.inputs.StaticScheme
import com.github.yoojia.inputs.ValueScheme
import com.wgmf.library.base.ResultData
import com.wgmf.library.utils.DateUtil
import com.wgmf.yxgj.base.BaseParentFra
import com.wgmf.yxgj.dialog.FeedbookEditDialog
import com.wgmf.yxgj.global.AppConstants
import com.wgmf.yxgj.global.ConstantParams
import com.wgmf.yxgj.model.PickerModel
import com.wgmf.yxgj.module.business.reportproblem.R
import com.wgmf.yxgj.module.business.reportproblem.model.ProductListEntity
import com.wgmf.yxgj.module.business.reportproblem.model.QualityUploadDetailEntity
import com.wgmf.yxgj.module.business.reportproblem.model.QualityUploadEntity
import com.wgmf.yxgj.module.business.reportproblem.service.QualityType
import com.wgmf.yxgj.module.business.reportproblem.ui.DispatchProblemsContract
import com.wgmf.yxgj.module.business.reportproblem.ui.SelectorProductsActivity
import com.wgmf.yxgj.module.business.reportproblem.ui.dialog.ReportQuerySelectPop
import com.wgmf.yxgj.module.business.reportproblem.ui.holder.ZhiLiangChildHolder
import com.wgmf.yxgj.pop.PickerPop
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity
import com.wgmf.yxgj.utils.helper.DialogHelper
import com.wgmf.yxgj.widgets.MMessageDisplay
import kotlinx.android.synthetic.main.activity_dispatch_problem.*
import kotlinx.android.synthetic.main.fragment_product_problem.*
import kotlinx.android.synthetic.main.include_qback_report_user_phone_show.*

/**
 * 产品质量问题
 * @author LW
 */
class ProductProblemFragment : BaseParentFra(), DispatchProblemsContract.IView,
    ReportQuerySelectPop.ReportQuerySelectPopListener, PickerPop.PickerPopListener {

    private var mReportStore: TextView? = null

    private var mReportEdit: EditText? = null

    private var mTitleLayout: LinearLayout? = null

    private var mReportQuerySelectPop: ReportQuerySelectPop? = null

    private var mPickerPop: PickerPop? = null

    private var mCType: String? = ""

    private var mShopId: String = ""

    private var mProduct: ProductListEntity? = null

    /**
     * 缓存跳转到选择产品页面的TextView
     */
    private var mSelectGoodsView: TextView? = null

    /**
     * 缓存选择产品类型的TextView
     */
    private var mSelectGoodsTypeView: TextView? = null

    /**
     * 缓存选择产品数量的TextView
     */
    private var mSelectGoodsCountView: TextView? = null

    /**
     * 缓存选择产品日期的TextView
     */
    private var mSelectGoodsDateView: TextView? = null

    /**
     * 缓存选择产品日期后两位的TextView
     */
    private var mSelectGoodsDatePvView: TextView? = null

    /**
     * 单位
     */
    private val mKeyUnitTag: Int = R.id.report_unit

    override fun rootLayoutId(): Int = R.layout.fragment_product_problem

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        activity?.apply {
            mReportStore = findViewById(R.id.report_store)
            mReportEdit = findViewById(R.id.report_edit)
            mTitleLayout = findViewById(R.id.title)
        }

        userInfo?.let {
            problems_user.setText(it.name)
        }

        mCType=arguments?.getString(AppConstants.ExtraKeys.DISPATCH_PRODUCT_CTYPE)

        //如果填充的goods_item为0，说明是第一次显示产品质量问题的layout，那就要构造并初始化，然后添加一个ChildItem。
        if (report_goods_items_container.childCount == 0) {
            addChildToLayout(0)
        }
    }


    override fun onBusinessResultAtMainThread(result: ResultData?) {
        super.onBusinessResultAtMainThread(result)

    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (requestCode) {
            ConstantParams.CONSTANT_STARTS_8 ->
                if (resultCode == SelectorBaseActivity.RESULTCODE) {
                    mProduct =
                        (data?.getSerializableExtra(SelectorProductsActivity.activityResultData) as ProductListEntity).apply {
                            //如果是产品质量问题，就存起来。
                            mSelectGoodsView?.let {
                                //先在之前点击的组件上显示名字。
                                it.text = name
                                it.tag = productCode
                                it.setTag(mKeyUnitTag, productUnit)
                                //刷新一下单位显示
                                refreshProductInfoShow()
                            }
                        }
                }
            else -> {
            }
        }
    }

    /**
     * 根据选择的产品，遍历所有元素，刷新一下产品信息显示
     * View view = .getChildAt(i);
     */
    private fun refreshProductInfoShow() {
        val childNum: Int = report_goods_items_container.childCount
        for (index in 0 until childNum) {
            val child = report_goods_items_container.getChildAt(index).tag as ZhiLiangChildHolder
            child.reportUnit.text =
                child.reportGoods.getTag(mKeyUnitTag) as String
        }
    }

    /**
     * 选择生产日期后两位
     */
    private fun selectorDatePv() {
        val pickerModel = PickerModel()
        val minutes = arrayOf(
            "A", "B", "C", "D", "E", "F", "G",
            "H", "I", "J", "K", "L", "M", "--", "N",
            "O", "P", "Q", "R", "S", "T",
            "U", "V", "W", "X", "Y", "Z"
        )
        val seconds = arrayOf("1", "--", "2")
        val listMinutes: MutableList<String> = ArrayList()
        for (minute in minutes) {
            listMinutes.add(minute)
            pickerModel.minutes = listMinutes
        }
        val listSeconds: MutableList<String> = ArrayList()
        for (second in seconds) {
            listSeconds.add(second)
            pickerModel.seconds = listSeconds
        }
        if (null == mPickerPop) {
            mPickerPop = PickerPop(mContext, this, pickerModel)
        }
        mPickerPop?.takeIf { it -> !it.isShowing }?.apply {
            show(mTitleLayout)
        }
    }

    /**
     * 选择破损类型
     */
    fun selectorDamageType() {
        var functionName: List<String?> = ArrayList()
        when (mCType) {
            QualityType.REPORT_TYPE_ZHILIANG_1 -> functionName =
                listOf(*resources.getStringArray(R.array.problemsDamageType_1))
            QualityType.REPORT_TYPE_ZHILIANG_2 -> functionName =
                listOf(*resources.getStringArray(R.array.problemsDamageType_2))
            QualityType.REPORT_TYPE_ZHILIANG_3 -> functionName =
                listOf(*resources.getStringArray(R.array.problemsDamageType_3))
            QualityType.REPORT_TYPE_ZHILIANG_4 -> functionName =
                listOf(*resources.getStringArray(R.array.problemsDamageType_4))
            QualityType.REPORT_TYPE_ZHILIANG_5 -> functionName =
                listOf(*resources.getStringArray(R.array.problemsDamageType_5))
            QualityType.REPORT_TYPE_ZHILIANG_6 -> functionName =
                listOf(*resources.getStringArray(R.array.problemsDamageType_6))
            QualityType.REPORT_TYPE_ZHILIANG_7 -> functionName =
                listOf(*resources.getStringArray(R.array.problemsDamageType_7))
            QualityType.REPORT_TYPE_ZHILIANG_8 -> functionName =
                listOf(*resources.getStringArray(R.array.problemsDamageType_8))
            QualityType.REPORT_TYPE_ZHILIANG_9 -> functionName =
                listOf(*resources.getStringArray(R.array.problemsDamageType_9))
            QualityType.REPORT_TYPE_ZHILIANG_10 -> functionName =
                listOf(*resources.getStringArray(R.array.problemsDamageType_10))
            QualityType.REPORT_TYPE_ZHILIANG_11 -> functionName =
                listOf(*resources.getStringArray(R.array.problemsDamageType_11))
            else -> {
            }
        }
        if (null == mReportQuerySelectPop) {
            mReportQuerySelectPop = ReportQuerySelectPop(
                mContext,
                this, functionName
            )
        }
        mReportQuerySelectPop?.let {
            if (!it.isShowing) {
                it.show(mTitleLayout)
            }
        }
    }

    /**
     * 产品质量问题  添加子组件。
     * @param pos  添加到哪个位置。
     */
    private fun addChildToLayout(pos: Int) {
        val child =
            layoutInflater.inflate(R.layout.include_qback_report_goods_show, null)
        val holder = ZhiLiangChildHolder().apply {
            reportGoods = child.findViewById<TextView>(R.id.report_goods).apply {
                setOnClickListener {
                    mSelectGoodsView = it as TextView
                    selectorGoods()
                }
            }
            reportDamageTypesTv =
                child.findViewById<TextView>(R.id.report_damage_types_tv).apply {
                    setOnClickListener {
                        mSelectGoodsTypeView = it as TextView
                        selectorDamageType()
                    }
                }

            reportCount = child.findViewById<TextView>(R.id.report_count).apply {
                setOnClickListener {
                    mSelectGoodsCountView = it as TextView
                    showProEdtDialog()
                }
            }
            reportUnit = child.findViewById(R.id.report_unit)
            reportDate = child.findViewById<TextView>(R.id.report_date).apply {
                setOnClickListener {
                    mSelectGoodsDateView = it as TextView
                    DialogHelper.AlertDatePicker(
                        mContext,
                        this@ProductProblemFragment,
                        mSelectGoodsDateView
                    );
                }
            }
            reportDatePv = child.findViewById<TextView>(R.id.report_date_pv).apply {
                setOnClickListener {
                    mSelectGoodsDatePvView = it as TextView
                    selectorDatePv()
                }
            }
            addBtn = child.findViewById<ImageButton>(R.id.add_goods_item).apply {
                /*增加子组件按钮*/
                setOnClickListener { view -> //当前点击按钮所在元素的位置。
                    val index: Int =
                        report_goods_items_container.indexOfChild(view.tag as LinearLayout)
                    val childCount: Int = report_goods_items_container.childCount
                    //如果是第一个元素的按钮。点了之后要把自己的删除按钮也置彩色。
                    if (index == 0 && childCount == 1) {
                        (report_goods_items_container.getChildAt(0)
                            .tag as ZhiLiangChildHolder).removeBtn.setImageResource(R.drawable.feedback_minus1)
                    }
                    addChildToLayout(index + 1)
                }
            }
            removeBtn = child.findViewById<ImageButton>(R.id.remove_goods_item).apply {
                setImageResource(if (report_goods_items_container.childCount == 0) R.drawable.feedback_minus2 else R.drawable.feedback_minus1)
                /*删除子组件按钮*/
                setOnClickListener {
                    val childCount: Int = report_goods_items_container.childCount
                    if (childCount > 1) {
                        //多于1个才删除当前ChildView。
                        report_goods_items_container.removeView(addBtn.tag as LinearLayout)
                    }
                    if (childCount == 2) {
                        //如果点击的时候已经只剩两个了，那就把仅剩的最后一个的删除按钮置灰。
                        (report_goods_items_container.getChildAt(0)
                            .tag as ZhiLiangChildHolder).removeBtn.setImageResource(R.drawable.feedback_minus2)
                    }
                }

            }
            reportDamageTypesLl =
                child.findViewById<LinearLayout>(R.id.report_damage_types_ll).apply {
                    visibility = View.VISIBLE
                }

            //增删按钮保存其所在的ChildView，到时候点击时就可以直接吊出来remove了。
            addBtn.tag = child
            removeBtn.tag = child
        }

        if (TextUtils.isEmpty(holder.reportGoods.text.toString())) {
            mProduct = null
        }

        child.tag = holder
        report_goods_items_container.addView(child, pos)
    }

    /**
     * 选择产品
     */
    private fun selectorGoods() {
        if (TextUtils.isEmpty(mShopId)) {
            showMsg("请先选择一个门店")
            return
        }
        val intent = Intent(
            mContext,
            SelectorProductsActivity::class.java
        )
        intent.putExtra("storeid", mShopId)
        startActivityForResult(intent, ConstantParams.CONSTANT_STARTS_8)
    }

    /**
     * 显示输入产品数量对话框
     */
    private fun showProEdtDialog() {
        if (mProduct == null) {
            showMsg("请选择产品")
            return
        }
        val builder = FeedbookEditDialog.Builder(mContext)
        builder.setContent("数量")
        builder.setTitle("选择产品")
        builder.setContentVisibility(true)
        builder.setProUint(mProduct?.name + "【" + mProduct?.productUnit + "】")
        builder.setPositiveButton { dialog, which -> dialog.dismiss() }
        builder.setNegativeButton { dialog, which ->
            mSelectGoodsCountView?.text = builder.proNum
            dialog.dismiss()
        }
        builder.create().show()
    }

    override fun onAdapterItemClick(position: Int, mFunctionName: MutableList<String>?) {
        mSelectGoodsTypeView?.text = mFunctionName?.get(position)
    }

    override fun ruleCheckDataIntegrity(): Boolean {
        val inputs = AndroidNextInputs()
        inputs.add(mReportStore, StaticScheme.Required())
        inputs.add(problems_user, StaticScheme.Required())
        inputs.add(problems_phone, StaticScheme.Required(), StaticScheme.ChineseMobile())
        inputs.add(mReportEdit, StaticScheme.Required())
        val childNum: Int = report_goods_items_container.childCount

        for (i in 0 until childNum) {
            val view: View = report_goods_items_container.getChildAt(i)
            inputs.add(
                (view.tag as ZhiLiangChildHolder).reportGoods,
                ValueScheme.NotEquals("请选择产品").msgOnFail("未选择产品")
            )
            inputs.add(
                (view.tag as ZhiLiangChildHolder).reportCount,
                StaticScheme.Required(),
                StaticScheme.Numeric()
            )
            inputs.add((view.tag as ZhiLiangChildHolder).reportDate, StaticScheme.Required())
            inputs.add((view.tag as ZhiLiangChildHolder).reportDatePv, StaticScheme.Required())
        }
        val messageDisplay = MMessageDisplay()
        inputs.setMessageDisplay(messageDisplay)

        return if (inputs.test()) {
            // 校验通过
            inputs.clear()
            true
        } else {
            showMsg("填写有误，请检查")
            inputs.clear()
            false
        }
    }

    override fun checkProductProblemDate(): Boolean {
        if (null != mSelectGoodsDateView) {
            val producedDate: String = mSelectGoodsDateView!!.text.toString()
            try {
                // 选中的日期
                val date1 = DateUtil.string2Date(producedDate, "yyyy-MM-dd")
                // 今天
                val date2 =
                    DateUtil.string2Date(DateUtil.getFormatCurrentDate("yyyy-MM-dd"), "yyyy-MM-dd")
                //今日之前（不含今日）= 今天-选中日期大于0
                if (DateUtil.daysBetween(date1, date2) > 0) {
                    return true
                }
            } catch (e: Exception) {
                Log.e(TAG, "checkReportDate: ", e)
            }
        }
        return false
    }


    override fun productProblemEntityData(
        shopName: String,
        pType: String,
        cType: String,
        qinIuUrlLists: MutableList<String>?
    ): QualityUploadEntity {
        val entity = QualityUploadEntity()
        entity.description = mReportEdit?.text?.toString()
        entity.mobile = problems_phone.text.toString()
        entity.submiter = problems_user.text.toString()
        entity.shopName = shopName
        entity.title = pType
        entity.themeName = cType

        //可扩展的表
        val num: Int = report_goods_items_container.childCount
        val details: MutableList<QualityUploadDetailEntity> = ArrayList()
        for (i in 0 until num) {
            val qualityUploadDetailEntity = QualityUploadDetailEntity()
            val view: View = report_goods_items_container.getChildAt(i)
            val holder = view.tag as ZhiLiangChildHolder
            //产品名称
            qualityUploadDetailEntity.productName = holder.reportGoods.text.toString()
            //产品类型
            qualityUploadDetailEntity.subCategory = holder.reportDamageTypesTv.text.toString()
            //产品数量
            qualityUploadDetailEntity.productCount =
                holder.reportCount.text.toString() + holder.reportUnit.text.toString()
            //产品编码
            qualityUploadDetailEntity.productNo = holder.reportGoods.tag as String
            var reportDateStr = holder.reportDatePv.text.toString()
            if ("无" == reportDateStr) {
                reportDateStr = "xx"
            }
            //产品生产日期
            qualityUploadDetailEntity.productionDate = DateUtil.converToString(
                DateUtil.string2Date(
                    holder.reportDate.text.toString(),
                    "yy-MM-dd"
                )
            ) + reportDateStr
            details.add(qualityUploadDetailEntity)
        }
        entity.details = details

        if (null != qinIuUrlLists) {
            entity.url = qinIuUrlLists
        }
        return entity
    }

    override fun setShopId(shopId: String) {
        this.mShopId = shopId
    }

    override fun comfirmPickerPop(value: String?) {
        mSelectGoodsDatePvView?.text = value
    }

    override fun cancelPickerPop() {
        mSelectGoodsDatePvView?.text = "无"
    }
}