package com.wgmf.yxgj.module.business.reportproblem.ui.mechanicorder;

import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v4.content.ContextCompat;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.github.yoojia.inputs.ValueScheme;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.TipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.module.business.reportproblem.R;
import com.wgmf.yxgj.module.business.reportproblem.model.MachineOrder;
import com.wgmf.yxgj.module.business.reportproblem.model.MachineOrderMaintenanceBean;
import com.wgmf.yxgj.module.business.reportproblem.model.MachineOrderResult;
import com.wgmf.yxgj.module.business.reportproblem.model.MachineRepairOper;
import com.wgmf.yxgj.module.business.reportproblem.service.InfoCheck;
import com.wgmf.yxgj.module.business.reportproblem.service.ReportFeedbackService;
import com.wgmf.yxgj.module.business.reportproblem.ui.dialog.ReportQuerySelectPop;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.wgmf.yxgj.widgets.MMessageDisplay;
import com.xp.arouter.RouterCommonUtil;
import com.xp.arouter.RouterParams;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import xp.timepicker.com.widget.DatePickDialog;
import xp.timepicker.com.widget.OnSureLisener;
import xp.timepicker.com.widget.bean.DateType;

/**
 * 机修工单填写/修改
 */
@Route(path = RouterParams.URL_RREPORTMECHANICORDERACTIVITY)
public class ReportMechanicOrderActivity extends ReportWithPhotoBaseActivity implements ReportQuerySelectPop.ReportQuerySelectPopListener, View.OnClickListener, ImagePickerLayout.ImagePicker {
    /**
     * 选择门店 的返回
     */
    public static final int SELECT_STORE = 3;
    private String branchTitle;
    private Long branchID;
    private String pid;//机修工单pid
    private String mroNo;//机修工单
    private String mroUserName;//(string, optional):维修人员名字 ,
    private String mroUserNo;// (string, optional):维修人员工号 ,
    private String mroUserPhone;// (string, optional):维修人员电话 ,
    private String picOperationBefore = "";

    ReportQuerySelectPop publicSelectPop;
    LinearLayout mechanicOrderProcess;
    LinearLayout mechanicOrderProcessLl;
    LinearLayout mechanicOrderProcessBtnLl;
    LinearLayout mechanicOrderContentLl;
    LinearLayout reportContentConfirmLl;
    Button reportContentModifyBtn;
    Button reportContentConfirmBtn;
    Button mechanicOrderProcessBtn;
    TextView mechanicOrderShop;
    TextView mechanicOrderProcessMode;
    TextView mechanicOrderProcessTime;
    TextView mechanicOrderReason;
    TextView mechanicOrderTimeStart;
    TextView mechanicOrderTimeEnd;
    RadioGroup needLicenseSelector;
    RadioGroup needEcableSelector;
    RadioGroup needClimbSelector;
    RadioGroup needEmeterSelector;
    RadioGroup needProcessSelector;
    RadioButton needYes;
    RadioButton needMiddle;
    RadioButton needNo;
    RadioButton needLicenseYes;
    RadioButton needLicenseNo;
    RadioButton needEcableYes;
    RadioButton needEcableNo;
    RadioButton needClimbYes;
    RadioButton needClimbNo;
    RadioButton needEmeterYes;
    RadioButton needEmeterNo;
    EditText mechanicOrderOther;
    EditText mechanicOrderProgressEt;

    ImagePickerLayout picOperationBeforeImagePickerContainer;
    ImagePickerLayout picOperationAfterImagePickerContainer;
    ImagePickerLayout picMachineInsideImagePickerContainer;
    ImagePickerLayout picOtherDevicesImagePickerContainer;
    ImagePickerLayout picImageShopImagePickerContainer;

    @Override
    protected void initView() {
        setContentView(R.layout.activity_report_mechanic_order);
        mechanicOrderContentLl = (LinearLayout) findViewById(R.id.mechanic_order_content_ll);
        mechanicOrderProcessLl = (LinearLayout) findViewById(R.id.mechanic_order_process_ll);
        mechanicOrderProcess = (LinearLayout) findViewById(R.id.mechanic_order_process);
        mechanicOrderProcessBtnLl = (LinearLayout) findViewById(R.id.mechanic_order_process_btn_ll);
        mechanicOrderProcessMode = (TextView) findViewById(R.id.mechanic_order_process_mode);
        mechanicOrderProcessTime = (TextView) findViewById(R.id.mechanic_order_process_time);
        reportContentConfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentModifyBtn = (Button) findViewById(R.id.report_content_modify_btn);
        reportContentConfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        mechanicOrderProcessBtn = (Button) findViewById(R.id.mechanic_order_process_btn);
        mechanicOrderShop = (TextView) findViewById(R.id.mechanic_order_shop);
        mechanicOrderReason = (TextView) findViewById(R.id.mechanic_order_reason);
        mechanicOrderTimeStart = (TextView) findViewById(R.id.mechanic_order_time_start);
        mechanicOrderTimeEnd = (TextView) findViewById(R.id.mechanic_order_time_end);
        needLicenseSelector = (RadioGroup) findViewById(R.id.need_license_selector);
        needEcableSelector = (RadioGroup) findViewById(R.id.need_ecable_selector);
        needClimbSelector = (RadioGroup) findViewById(R.id.need_climb_selector);
        needEmeterSelector = (RadioGroup) findViewById(R.id.need_emeter_selector);
        needProcessSelector = (RadioGroup) findViewById(R.id.need_process_selector);
        needYes = (RadioButton) findViewById(R.id.need_yes);
        needMiddle = (RadioButton) findViewById(R.id.need_middle);
        needNo = (RadioButton) findViewById(R.id.need_no);
        needLicenseYes = (RadioButton) findViewById(R.id.need_license_yes);
        needLicenseNo = (RadioButton) findViewById(R.id.need_license_no);
        needEcableYes = (RadioButton) findViewById(R.id.need_ecable_yes);
        needEcableNo = (RadioButton) findViewById(R.id.need_ecable_no);
        needClimbYes = (RadioButton) findViewById(R.id.need_climb_yes);
        needClimbNo = (RadioButton) findViewById(R.id.need_climb_no);
        needEmeterYes = (RadioButton) findViewById(R.id.need_emeter_yes);
        needEmeterNo = (RadioButton) findViewById(R.id.need_emeter_no);
        mechanicOrderOther = (EditText) findViewById(R.id.mechanic_order_other);
        mechanicOrderProgressEt = (EditText) findViewById(R.id.mechanic_order_progress_et);
        reportContentConfirmLl.setVisibility(View.VISIBLE);
        reportContentModifyBtn.setOnClickListener(this);
        reportContentConfirmBtn.setOnClickListener(this);
        mechanicOrderProcessBtn.setOnClickListener(this);
        mechanicOrderShop.setOnClickListener(this);
        mechanicOrderReason.setOnClickListener(this);
        mechanicOrderTimeStart.setOnClickListener(this);
        mechanicOrderTimeEnd.setOnClickListener(this);
        reportContentConfirmBtn.setText(getString(R.string.submit_btn_txt));
        reportContentModifyBtn.setText(getString(R.string.mechanic_order_call));
        // 默认不弹出软键盘
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
        setRowStatus();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        branchID = getIntent().getLongExtra("branchID", 0);
        homeTitleText.setText(branchTitle);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initPictureDisplayView() {
        idImagePickerContainer = (ImagePickerLayout) findViewById(R.id.mechanic_order_image_picker_container);
        idImagePickerContainer.setVisibility(View.VISIBLE);
        idImagePickerContainer.setNeedVisibility(View.VISIBLE);
        idImagePickerContainer.setTitle("施工前照片");
        idImagePickerContainer.setTip("(最多可上传5张)");
        idImagePickerContainer.setImagePicker(this);
        idImagePickerContainer.setSizePhotoNum(3);
        idImagePickerContainer.setMaxPhotoNum(5);
        idImagePickerContainer.setmImageselectList(mImageselectList);
        idImagePickerContainer.setImagePickerView(idImagePickerContainer);
        idImagePickerContainer.setOlnyViewMode(false);

        picOperationBeforeImagePickerContainer = (ImagePickerLayout) findViewById(R.id.pic_operation_before_image_picker_container);
        picOperationBeforeImagePickerContainer.setVisibility(View.VISIBLE);
        picOperationBeforeImagePickerContainer.setTitle("施工前照片");
        picOperationBeforeImagePickerContainer.setImagePicker(this);
        picOperationBeforeImagePickerContainer.setSizePhotoNum(3);
        picOperationBeforeImagePickerContainer.setMaxPhotoNum(5);
        picOperationBeforeImagePickerContainer.setmImageselectList(mImageselectList);
        picOperationBeforeImagePickerContainer.setImagePickerView(picOperationBeforeImagePickerContainer);
        picOperationBeforeImagePickerContainer.setOlnyViewMode(true);

        picOperationAfterImagePickerContainer = (ImagePickerLayout) findViewById(R.id.pic_operation_after_image_picker_container);
        picOperationAfterImagePickerContainer.setVisibility(View.VISIBLE);
        picOperationAfterImagePickerContainer.setTitle("施工后照片");
        picOperationAfterImagePickerContainer.setImagePicker(this);
        picOperationAfterImagePickerContainer.setSizePhotoNum(3);
        picOperationAfterImagePickerContainer.setMaxPhotoNum(5);
        picOperationAfterImagePickerContainer.setmImageselectList(mImageselectList);
        picOperationAfterImagePickerContainer.setImagePickerView(picOperationAfterImagePickerContainer);
        picOperationAfterImagePickerContainer.setOlnyViewMode(true);

        picMachineInsideImagePickerContainer = (ImagePickerLayout) findViewById(R.id.pic_machine_inside_image_picker_container);
        picMachineInsideImagePickerContainer.setVisibility(View.VISIBLE);
        picMachineInsideImagePickerContainer.setTitle("机器柜内照片");
        picMachineInsideImagePickerContainer.setImagePicker(this);
        picMachineInsideImagePickerContainer.setSizePhotoNum(3);
        picMachineInsideImagePickerContainer.setMaxPhotoNum(5);
        picMachineInsideImagePickerContainer.setmImageselectList(mImageselectList);
        picMachineInsideImagePickerContainer.setImagePickerView(picMachineInsideImagePickerContainer);
        picMachineInsideImagePickerContainer.setOlnyViewMode(true);

        picOtherDevicesImagePickerContainer = (ImagePickerLayout) findViewById(R.id.pic_other_devices_image_picker_container);
        picOtherDevicesImagePickerContainer.setVisibility(View.VISIBLE);
        picOtherDevicesImagePickerContainer.setTitle("其他设备照片");
        picOtherDevicesImagePickerContainer.setImagePicker(this);
        picOtherDevicesImagePickerContainer.setSizePhotoNum(3);
        picOtherDevicesImagePickerContainer.setMaxPhotoNum(5);
        picOtherDevicesImagePickerContainer.setmImageselectList(mImageselectList);
        picOtherDevicesImagePickerContainer.setImagePickerView(picOtherDevicesImagePickerContainer);
        picOtherDevicesImagePickerContainer.setOlnyViewMode(true);

        picImageShopImagePickerContainer = (ImagePickerLayout) findViewById(R.id.pic_image_shop_image_picker_container);
        picImageShopImagePickerContainer.setVisibility(View.VISIBLE);
        picImageShopImagePickerContainer.setTitle("形象店照片");
        picImageShopImagePickerContainer.setImagePicker(this);
        picImageShopImagePickerContainer.setSizePhotoNum(3);
        picImageShopImagePickerContainer.setMaxPhotoNum(5);
        picImageShopImagePickerContainer.setmImageselectList(mImageselectList);
        picImageShopImagePickerContainer.setImagePickerView(picImageShopImagePickerContainer);
        picImageShopImagePickerContainer.setOlnyViewMode(true);
    }

    @Override
    protected void initContent() {
        //施工前图片初始化
        initPictureDisplayView();
        //获取工单数据
        mroNo = getIntent().getStringExtra("mroNo");
        if (StringUtil.isNotNullAndNotEmpty(mroNo)) {
            showDialog();
            ReportFeedbackService.getInstance().requestFindMachineOrderDetail(mroNo, this);
            //如果有工单号，则已提交过工单数据
            if (branchTitle.contains(getString(R.string.mechanic_order_modify))) {
                //如果是查看/编辑，不显示评价信息
                reportContentConfirmLl.setVisibility(View.VISIBLE);
                mechanicOrderProcess.setVisibility(View.GONE);
            } else if (branchTitle.contains(getString(R.string.mechanic_order_evaluate))) {
                //如果是评价，显示评价信息，可编辑评价信息
                reportContentConfirmLl.setVisibility(View.GONE);
                mechanicOrderProcess.setVisibility(View.VISIBLE);
                mechanicOrderContentLl.setVisibility(View.VISIBLE);
                mechanicOrderProcessBtnLl.setVisibility(View.VISIBLE);
                viewModify(true);
            } else if (branchTitle.contains(getString(R.string.mechanic_order_check))) {
                //如果是查看，显示评价信息，不可编辑评价信息
                reportContentConfirmLl.setVisibility(View.GONE);
                mechanicOrderProcess.setVisibility(View.VISIBLE);
                mechanicOrderContentLl.setVisibility(View.VISIBLE);
                mechanicOrderProcessBtnLl.setVisibility(View.GONE);
                viewModify(false);
            }
        } else {
            //如果没有工单号，则未提交过工单数据，隐藏评价布局
            mechanicOrderProcess.setVisibility(View.GONE);
            reportContentConfirmLl.setVisibility(View.VISIBLE);
        }
    }

    /**
     * 编辑界面
     *
     * @param b
     */
    private void viewModify(boolean b) {
        //工单内容不可编辑
        mechanicOrderShop.setOnClickListener(null);
        mechanicOrderProcessMode.setOnClickListener(null);
        mechanicOrderProcessTime.setOnClickListener(null);
        mechanicOrderReason.setOnClickListener(null);
        mechanicOrderTimeStart.setOnClickListener(null);
        mechanicOrderTimeEnd.setOnClickListener(null);
        mechanicOrderOther.setEnabled(false);
        disableRadioGroup(needLicenseSelector);
        disableRadioGroup(needEcableSelector);
        disableRadioGroup(needClimbSelector);
        disableRadioGroup(needEmeterSelector);
        idImagePickerContainer.setOlnyViewMode(true);
        mechanicOrderShop.setCompoundDrawables(null, null, null, null);
        mechanicOrderReason.setCompoundDrawables(null, null, null, null);
        mechanicOrderTimeStart.setCompoundDrawables(null, null, null, null);
        mechanicOrderTimeEnd.setCompoundDrawables(null, null, null, null);
        //评价内容不可编辑
        mechanicOrderProgressEt.setEnabled(b);
        if (b) {
            enableRadioGroup(needProcessSelector);
        } else {
            disableRadioGroup(needProcessSelector);
        }
    }

    public void disableRadioGroup(RadioGroup testRadioGroup) {
        for (int i = 0; i < testRadioGroup.getChildCount(); i++) {
            testRadioGroup.getChildAt(i).setEnabled(false);
        }
    }

    public void enableRadioGroup(RadioGroup testRadioGroup) {
        for (int i = 0; i < testRadioGroup.getChildCount(); i++) {
            testRadioGroup.getChildAt(i).setEnabled(true);
        }
    }

    private void setRowStatus() {
        final LinearLayout mechanicOrderShopContentLl = (LinearLayout) findViewById(R.id.mechanic_order_shop_content_ll);
        final LinearLayout mechanicOrderProcessContentLl = (LinearLayout) findViewById(R.id.mechanic_order_process_content_ll);
        final CheckBox partTimeScheduleInfoTitleRow = (CheckBox) findViewById(R.id.mechanic_order_content_ll_row);
        final CheckBox partTimeSignInfoTitleRow = (CheckBox) findViewById(R.id.mechanic_order_process_ll_row);
        final Drawable drawableDown = ContextCompat.getDrawable(this, R.drawable.row_down);
        drawableDown.setBounds(0, 0, drawableDown.getMinimumWidth(), drawableDown.getMinimumHeight());
        final Drawable drawableUp = ContextCompat.getDrawable(this, R.drawable.row_up);
        drawableUp.setBounds(0, 0, drawableUp.getMinimumWidth(), drawableUp.getMinimumHeight());

        partTimeScheduleInfoTitleRow.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    partTimeScheduleInfoTitleRow.setCompoundDrawables(null, null, drawableDown, null);
                    mechanicOrderShopContentLl.setVisibility(View.GONE);
                } else {
                    partTimeScheduleInfoTitleRow.setCompoundDrawables(null, null, drawableUp, null);
                    mechanicOrderShopContentLl.setVisibility(View.VISIBLE);
                }
            }
        });
        partTimeSignInfoTitleRow.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    partTimeSignInfoTitleRow.setCompoundDrawables(null, null, drawableDown, null);
                    mechanicOrderProcessContentLl.setVisibility(View.GONE);
                } else {
                    partTimeSignInfoTitleRow.setCompoundDrawables(null, null, drawableUp, null);
                    mechanicOrderProcessContentLl.setVisibility(View.VISIBLE);
                }
            }
        });
    }

    @Override
    public void setSelectDialog(int selectType, View view) {
        idImagePickerContainer = (ImagePickerLayout) view;
        setSelectDialogListeners(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //拍照处理
                takePhoto(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //相片处理
                getPictrue(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                hideSelectDialog();
            }
        });
        showSelectDialog("选择图片", null, "相机拍照", "本地相册", "取消");
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, com.xp.pro.imagepickerlib.global.Params.TAKE_PICTURE);
    }

    @Override
    public void toPhotoPreview(int index, ArrayList<ImageItem> mImageselectList) {
        toPhotoPreviewFragment(index, mImageselectList);//大图显示
    }

    public void selectorStore() {
        Bundle mBundle = new Bundle();
        mBundle.putLong("branchID", branchID);
        mBundle.putString("branchTitle", branchTitle);
        RouterCommonUtil.startFunctionActivityResult(this, -2, branchID, mBundle, SELECT_STORE);
    }


    private void telPhone(String work) {
        PrefTool.setBooleanSave(this, Prefs.PRE_NOT_TO_BACKGROUD, true);
        Uri telUri = Uri.parse("tel:" + work);
        Intent dial = new Intent(Intent.ACTION_DIAL, telUri);
        startActivity(dial);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (requestCode) {
            case SELECT_STORE:
                if (resultCode == SelectorBaseActivity.RESULTCODE) {
                    try {
                        shopId = data.getStringExtra("shopId");
                        shopName = data.getStringExtra("shopName");
                        mechanicOrderShop.setText(shopName);
                        //"工单号：jx+ 门店编号 + 年份月日时分秒  jx0110074190405150634"
                        mroNo = "jx" + shopId + DateUtil.format(new Date(), "yyMMddHHmmss");
                        //获取机修电话
                        showDialog();
                        ReportFeedbackService.getInstance().requestFindMachineRepairOper(shopId, this);
                    } catch (Exception e) {
                        Log.e(TAG, "onActivityResult: data.getStringExtra error ");
                    }
                }
                break;
            default:
                break;
        }
    }

    /**
     * 选择申请事由
     */
    private void selectorReason() {
        List<String> mFunctionName = Arrays.asList(getResources().getStringArray(
                R.array.problemsReasonType));
        if (null == publicSelectPop) {
            publicSelectPop = new ReportQuerySelectPop(this, this, mFunctionName);
        }
        if (!publicSelectPop.isShowing()) {
            publicSelectPop.show(this.findViewById(R.id.title));
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.mechanic_order_shop) {
            selectorStore();
        } else if (v.getId() == R.id.mechanic_order_reason) {
            selectorReason();
        } else if (v.getId() == R.id.mechanic_order_time_start) {
            showDatePickDialog(DateType.TYPE_YMDHM, mechanicOrderTimeStart);
        } else if (v.getId() == R.id.mechanic_order_time_end) {
            showDatePickDialog(DateType.TYPE_YMDHM, mechanicOrderTimeEnd);
        } else if (v.getId() == R.id.report_content_modify_btn) {
            telPhone(mroUserPhone);
        } else if (v.getId() == R.id.report_content_confirm_btn) {
            setUploadData();
        } else if (v.getId() == R.id.mechanic_order_process_btn) {
            setProgressData();
        }
    }

    private void showDatePickDialog(DateType type, final TextView tv) {
        DatePickDialog dialog = new DatePickDialog(this);
        //设置标题
        dialog.setTitle("选择时间");
        //设置类型
        dialog.setType(type);
        //设置消息体的显示格式，日期格式
        dialog.setMessageFormat("yyyy-MM-dd HH:mm");
        //设置选择回调
        dialog.setOnChangeLisener(null);
        //设置点击确定按钮回调
        dialog.setOnSureLisener(new OnSureLisener() {
            @Override
            public void onSure(Date date) {
                if (!TextUtils.isEmpty("yyyy-MM-dd HH:mm")) {
                    String messge = "";
                    try {
                        messge = new SimpleDateFormat("yyyy-MM-dd HH:mm").format(date);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    Log.e("onSure", messge);
                    tv.setText(messge);
                    checkDate();
                }

            }
        });
        dialog.show();
    }

    /**
     * 提交评价内容
     */
    private void setProgressData() {
        //检查必填项
        if (!checkProgressData()) {
            dismissDialog();
            return;
        }
        MachineOrderMaintenanceBean machineOrderMaintenanceBean = new MachineOrderMaintenanceBean();
        machineOrderMaintenanceBean.setCustomerRating(InfoCheck.getProcessChecked(needYes.isChecked(), needMiddle.isChecked(), needNo.isChecked()));
        machineOrderMaintenanceBean.setMachineOrderId(pid);
        machineOrderMaintenanceBean.setRatingContent(mechanicOrderProgressEt.getText().toString());
        String content = new Gson().toJson(machineOrderMaintenanceBean);
        Log.d("content:", content);
        ReportFeedbackService.getInstance().requestUpdateMachineOrderMaintenance(content, this);
    }

    @Override
    protected void setUploadData() {
        //检查必填项
        if (!checkUploadData()) {
            dismissDialog();
            return;
        }
        if (checkDate()) {
            dismissDialog();
            return;
        }
        new uploadImageAsyncTask().execute();
    }

    private boolean checkDate() {
        String startYearsMonths = mechanicOrderTimeStart.getText().toString();
        String endYearsMonths = mechanicOrderTimeEnd.getText().toString();
        String nowYearsMonths = DateUtil.Date2String(new Date(), DateUtil.FORMATTIME);
        //1.施工开始时间不能小于当前时间
        if (!TextUtils.isEmpty(startYearsMonths)
                && (!getString(R.string.empty_etb_hint_select_txt).equals(startYearsMonths)
                && endTimeCheck(nowYearsMonths, startYearsMonths))) {
            showTipDialog("施工开始时间不能小于当前时间,\n请重新填写时间");
            mechanicOrderTimeStart.setText("");
            return true;
        }
        //2. 施工结束时间不能小于施工开始时间
        if (!TextUtils.isEmpty(endYearsMonths)
                && (!getString(R.string.empty_etb_hint_select_txt).equals(startYearsMonths)
                && !getString(R.string.empty_etb_hint_select_txt).equals(endYearsMonths))
                && endTimeCheck(startYearsMonths, endYearsMonths)) {
            showTipDialog("施工结束时间不能小于施工开始时间,\n请重新填写时间");
            mechanicOrderTimeEnd.setText("");
            return true;
        }
        return false;
    }

    /**
     * 显示提示信息
     */
    private void showTipDialog(String tip) {
        final TipDialog.Builder builder = new TipDialog.Builder(this);
        builder.setMessage(tip);
        builder.setPositiveButton(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.create().show();
    }

    /**
     * 检查结束时间不得小于开始时间
     */
    private boolean endTimeCheck(String startYearsMonths, String endYearsMonths) {
        try {
            Date startYearsMonthsDate = DateUtil.string2Date(startYearsMonths, DateUtil.FORMATTIME);
            Date endYearsMonthsDate = DateUtil.string2Date(endYearsMonths, DateUtil.FORMATTIME);
            return DateUtil.timeBetween(startYearsMonthsDate, endYearsMonthsDate) < 0;
        } catch (Exception e) {
            return true;
        }
    }

    class uploadImageAsyncTask extends AsyncTask<String, Void, Boolean> {

        //onPreExecute用于异步处理前的操作
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            showDialog();
        }

        //在doInBackground方法中进行异步任务的处理.
        @Override
        protected Boolean doInBackground(String... params) {
            uploadImages();
            return false;
        }

        //onPostExecute用于UI的更新.此方法的参数为doInBackground方法返回的值.
        @Override
        protected void onPostExecute(Boolean isNotOk) {
            super.onPostExecute(isNotOk);
            if (!isNotOk) {
                //如果施工前图片为空，提示添加图片
                if (StringUtil.isNullString(picOperationBefore)) {
                    dismissDialog();
                    ToastUtil.show(ReportMechanicOrderActivity.this, "请至少上传一张施工前图片");
                    return;
                }
                if (!qiniuUrlLists.isEmpty()) {
                    showDialog();
                    if (null != handler && null != runnable) {
                        handler.postDelayed(runnable, 100);
                        count = 0;//初始化图片提交计数
                    }
                } else {
                    uploadData();
                }
            }
        }

    }

    /**
     * 上传图片
     */
    private void uploadImages() {
        //上传图片
        List<ImageItem> checkImgs = idImagePickerContainer.getmImageselectList();
        if (null != checkImgs && !checkImgs.isEmpty()) {
            //如果图片存在
            for (int k = 0; k < checkImgs.size(); k++) {
                //如果是身份证图片
                if (checkImgs.size() > 1) {
                    //如果身份证图片大于1张
                    if (checkImgs.get(k).getType() != 1 || StringUtil.isNullString(checkImgs.get(k).getImgneturl())) {
                        //如果图片未上传则上传图片
                        reportType = "picOperationBefore";
                        if (!picOperationBefore.contains(getQiniuKey(reportType))) {
                            uploadByFilePathBefore(checkImgs.get(k).getImagePath());
                            for (int j = 0; j < qiniuUrlLists.size(); j++) {
                                if (qiniuUrlLists.get(j).contains(reportType) && !picOperationBefore.contains(qiniuUrlLists.get(j))) {
                                    //如果身份证照照片大于一张，添加分隔符
                                    picOperationBefore += qiniuUrlLists.get(j);
                                    if (k < checkImgs.size() - 1) {
                                        picOperationBefore += ",";
                                    }
                                }
                            }
                            checkImgs.get(k).setType(1);
                        }
                    } else {
                        if (!picOperationBefore.contains(checkImgs.get(k).getImgneturl())) {
                            picOperationBefore += checkImgs.get(k).getImgneturl();
                            if (k < checkImgs.size() - 1) {
                                picOperationBefore += ",";
                            }
                        }
                    }
                } else {
                    if (checkImgs.get(k).getType() != 1 || StringUtil.isNullString(checkImgs.get(k).getImgneturl())) {
                        //如果图片未上传则上传图片
                        reportType = "picOperationBefore";
                        if (!picOperationBefore.contains(getQiniuKey(reportType))) {
                            uploadByFilePathBefore(checkImgs.get(k).getImagePath());
                            for (int j = 0; j < qiniuUrlLists.size(); j++) {
                                if (qiniuUrlLists.get(j).contains(reportType)) {
                                    //如果身份证照照片大于一张，添加分隔符
                                    picOperationBefore = qiniuUrlLists.get(j);
                                }
                            }
                            checkImgs.get(k).setType(1);
                        }
                    } else {
                        picOperationBefore = checkImgs.get(k).getImgneturl();
                    }
                }
            }
        }
    }

    @Override
    protected void uploadData() {
        super.uploadData();
        showDialog();

        MachineOrder machineOrder = new MachineOrder();
        machineOrder.setApplicantName(userInfo.getName());
        machineOrder.setApplicantNo(userInfo.getStaffId());
        machineOrder.setApplicantShopId(shopId);
        machineOrder.setApplicantShopName(shopName);
        machineOrder.setApplyReason(mechanicOrderReason.getText().toString());
        machineOrder.setMroNo(mroNo);
        machineOrder.setMroOperName(mroUserName);
        machineOrder.setMroOperNo(mroUserNo);
        machineOrder.setMroOperPhone(mroUserPhone);
        //需要登高作业 ,y表示需要 ,n不需要
        machineOrder.setNeedClimb(InfoCheck.getChecked(needClimbYes.isChecked(), needClimbNo.isChecked()));
        //需要电缆 ,y表示需要 ,n不需要
        machineOrder.setNeedECable(InfoCheck.getChecked(needEcableYes.isChecked(), needEcableNo.isChecked()));
        //需要安装电表 ,y表示需要 ,n不需要
        machineOrder.setNeedEMeter(InfoCheck.getChecked(needEmeterYes.isChecked(), needEmeterNo.isChecked()));
        //需要施工证 ,y表示需要 ,n不需要
        machineOrder.setNeedLicense(InfoCheck.getChecked(needLicenseYes.isChecked(), needLicenseNo.isChecked()));
        //施工开始时间
        machineOrder.setOperationTimeBegin(mechanicOrderTimeStart.getText().toString());
        //施工结束时间
        if (!getString(R.string.empty_etb_hint_select_txt).equals(mechanicOrderTimeEnd.getText().toString())) {
            machineOrder.setOperationTimeEnd(mechanicOrderTimeEnd.getText().toString());
        }
        //其他要求
        machineOrder.setOtherReq(mechanicOrderOther.getText().toString());
        //施工前照片：多张突破逗号隔开
        machineOrder.setPicOperationBefore(picOperationBefore);
        String content = new Gson().toJson(machineOrder);
        Log.d("content:", content);
        ReportFeedbackService.getInstance().requestSaveOrUpdateMachineOrder(content, this);
    }

    @Override
    public void onAdapterItemClick(int position, List<String> mFunctionName) {
        mechanicOrderReason.setText(mFunctionName.get(position));
    }

    private void setContentData(MachineOrder result) {
        shopId = result.getApplicantShopId();//(string, optional):门店Id ,
        shopName = result.getApplicantShopName();//(string, optional):门店名称 ,
        mroUserName = result.getMroOperName();//(string, optional):维修人员名字 ,
        mroUserNo = result.getMroOperNo();// (string, optional):维修人员工号 ,
        mroUserPhone = result.getMroOperPhone();// (string, optional):维修人员电话 ,
        pid = result.getPid();
        //填充工单数据
        mechanicOrderShop.setText(result.getApplicantShopName());
        mechanicOrderReason.setText(result.getApplyReason());
        mechanicOrderTimeStart.setText(result.getOperationTimeBegin());
        mechanicOrderTimeEnd.setText(result.getOperationTimeEnd());
        mechanicOrderOther.setText(result.getOtherReq());
        //性别
        setNeedRiado(result.getNeedLicense(), needLicenseYes, needLicenseNo);
        setNeedRiado(result.getNeedECable(), needEcableYes, needEcableNo);
        setNeedRiado(result.getNeedClimb(), needClimbYes, needClimbNo);
        setNeedRiado(result.getNeedEMeter(), needEmeterYes, needEmeterNo);
        //施工前图片
        if (!StringUtil.isNullString(result.getPicOperationBefore())) {
            ArrayList<ImageItem> mImageselectList = getImageItems(result.getPicOperationBefore());
            idImagePickerContainer.setmImageselectList(mImageselectList);
            idImagePickerContainer.refreshPhotoContentView(mImageselectList);
            picOperationBeforeImagePickerContainer.refreshPhotoContentView(mImageselectList);
        }
        if (StringUtil.isNotNullAndNotEmpty(shopName)) {
            reportContentModifyBtn.setVisibility(View.VISIBLE);
        }
        //填充评价数据
        if (null != result.getMachineOrderMaintenance()) {
            mechanicOrderProcessMode.setText(result.getMachineOrderMaintenance().getMroHandleWay());//(string, optional):完成时间 ,
            mechanicOrderProcessTime.setText(result.getMachineOrderMaintenance().getFinishTime());//(string, optional):处理方式 ,
            mechanicOrderProgressEt.setText(result.getMachineOrderMaintenance().getRatingContent());//(string, optional):评价内容 ,
            setNeedProcessRiado(result.getMachineOrderMaintenance().getCustomerRating(), needYes, needMiddle, needNo);
            picOperationAfterImagePickerContainer.refreshPhotoContentView(getImageItems(result.getMachineOrderMaintenance().getPicOperationAfter()));
            picMachineInsideImagePickerContainer.refreshPhotoContentView(getImageItems(result.getMachineOrderMaintenance().getPicMachineInside()));
            picOtherDevicesImagePickerContainer.refreshPhotoContentView(getImageItems(result.getMachineOrderMaintenance().getPicOtherDevices()));
            picImageShopImagePickerContainer.refreshPhotoContentView(getImageItems(result.getMachineOrderMaintenance().getPicImageShop()));
        }
    }

    @NonNull
    private ArrayList<ImageItem> getImageItems(String picOperation) {
        ArrayList<ImageItem> mImageselectList = new ArrayList<>();
        if(!TextUtils.isEmpty(picOperation)) {
            if (picOperation.contains(",")) {
                String[] personalidImgs = picOperation.split(",");//中文或英文字符？
                for (int i = 0; i < personalidImgs.length; i++) {
                    if (!"null".equals(personalidImgs[i])) {
                        ImageItem item1 = new ImageItem();
                        item1.setImgneturl(personalidImgs[i]);
                        item1.setImagePath(personalidImgs[i]);
                        item1.setImageId(personalidImgs[i]);
                        item1.setUri(Uri.fromFile(new File(personalidImgs[i])));
                        item1.setType(1);
                        mImageselectList.add(item1);
                    }
                }
            } else {
                ImageItem item1 = new ImageItem();
                item1.setImgneturl(picOperation);
                item1.setImagePath(picOperation);
                item1.setImageId(picOperation);
                item1.setUri(Uri.fromFile(new File(picOperation)));
                item1.setType(1);
                mImageselectList.add(item1);
            }
        }
        return mImageselectList;
    }

    private void setNeedRiado(String need, RadioButton needYes, RadioButton needNo) {
        if (StringUtil.isNotNullAndNotEmpty(need)) {
            if ("y".equals(need)) {
                needYes.setChecked(true);
                needNo.setChecked(false);
            } else if ("n".equals(need)) {
                needYes.setChecked(false);
                needNo.setChecked(true);
            }
        }
    }

    /**
     * 客户评级 未评价0 差1,中2,好3
     *
     * @param need
     * @param needYes
     * @param needMiddle
     * @param needNo
     */
    private void setNeedProcessRiado(int need, RadioButton needYes, RadioButton needMiddle, RadioButton needNo) {
        if (need == 3) {
            needYes.setChecked(true);
            needMiddle.setChecked(false);
            needNo.setChecked(false);
        } else if (need == 2) {
            needYes.setChecked(false);
            needMiddle.setChecked(true);
            needNo.setChecked(false);
        } else if (need == 1) {
            needYes.setChecked(false);
            needMiddle.setChecked(false);
            needNo.setChecked(true);
        } else if (need == 0) {
            needYes.setChecked(false);
            needMiddle.setChecked(false);
            needNo.setChecked(false);
        }
    }

    private boolean checkUploadData() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        //门店校验
        inputs.add(mechanicOrderShop, StaticScheme.Required(), ValueScheme.NotEquals(getString(R.string.empty_etb_hint_select_txt)).msgOnFail("未选择门店"));
        //申请事由
        inputs.add(mechanicOrderReason, StaticScheme.Required(), ValueScheme.NotEquals(getString(R.string.empty_etb_hint_select_txt)).msgOnFail("未选择申请事由"));
        //施工开始时间
        inputs.add(mechanicOrderTimeStart, StaticScheme.Required(), ValueScheme.NotEquals(getString(R.string.empty_etb_hint_select_txt)).msgOnFail("未选择施工开始时间"));

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            ToastUtil.show(this, "填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    private boolean checkProgressData() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        //评价内容
        inputs.add(mechanicOrderProgressEt, StaticScheme.Required(), ValueScheme.NotEquals(getString(R.string.empty_etb_hint_txt)).msgOnFail("未选择填写评价数据"));

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            ToastUtil.show(this, "填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.ReportFeedback.MSG_ON_FIND_MACHINE_REPAIR_OPER: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        MachineRepairOper machineRepairOper = new Gson().fromJson(msg, MachineRepairOper.class);
                        Log.d(TAG, "machineRepairOper=" + machineRepairOper.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(machineRepairOper.retCode)) {
                            //有机修人员信息，则可拨打机修人员电话
                            if (null != machineRepairOper.getResult()) {
                                reportContentModifyBtn.setVisibility(View.VISIBLE);
                                //获取电话号码
                                mroUserName = machineRepairOper.getResult().getMroUserName();//(string, optional):维修人员名字 ,
                                mroUserNo = machineRepairOper.getResult().getMroUserNo();// (string, optional):维修人员工号 ,
                                mroUserPhone = machineRepairOper.getResult().getMroUserPhone();// (string, optional):维修人员电话 ,
                            } else {
                                reportContentModifyBtn.setVisibility(View.GONE);
                                //没有获取到门店机修信息，需要重新选择门店
                                ToastUtil.show(this, "没有获取到门店机修信息，需要重新选择门店!");
                                mechanicOrderShop.setText(getString(R.string.empty_etb_hint_select_txt));
                            }
                        } else {
                            ToastUtil.show(this, result.getResultInfo());
                        }
                    }
                }
                break;
                case BusinessID.ReportFeedback.MSG_ON_FIND_MACHINE_ORDER_DETAIL: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        MachineOrderResult machineOrderResult = new Gson().fromJson(msg, MachineOrderResult.class);
                        Log.d(TAG, "machineOrderResult=" + machineOrderResult.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(machineOrderResult.retCode) || ConstantParams.CONSTANT_PARAMS_0.equals(machineOrderResult.msgCode)) {
                            //填充工单数据
                            setContentData(machineOrderResult.getResult());
                        } else {
                            ToastUtil.show(this, result.getResultInfo());
                        }
                    }

                }
                break;
                case BusinessID.ReportFeedback.MSG_ON_SAVE_OR_UPDATE_MACHINE_ORDER: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode) || ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.msgCode)) {
                            toQuery();
                            ReportMechanicOrderActivity.this.finish();
                        }
                    }
                    ToastUtil.show(this, result.getResultInfo());
                }
                break;
                case BusinessID.ReportFeedback.MSG_ON_UPDATE_MACHINE_ORDER_MAINTENANCE: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode) || ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.msgCode)) {
                            ReportMechanicOrderActivity.this.finish();
                        }
                    }
                    ToastUtil.show(this, result.getResultInfo());
                }
                break;
                default:
                    break;
            }
        }
    }

    private void toQuery() {
        //工单提交成功，进入查询列表界面
        Intent logoutIntent = new Intent(ReportMechanicOrderActivity.this, QueryMechanicOrderActivity.class);
        logoutIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        startActivity(logoutIntent);
    }
}