package com.wgmf.yxgj.module.business.reportrating.model;

/**
 * Options {
 * addTime (string, optional):
 * <p>
 * 上报时间 ,
 * approveContent (string, optional):
 * <p>
 * 门店上报审核意见 ,
 * approveFlag (string, optional):
 * <p>
 * 门店上报审核状态：1同意/2不同意 ,
 * groupItem (string, optional):
 * <p>
 * 选项组(通道项、加分项、减分项) ,
 * id (integer, optional):
 * <p>
 * 主键 ,
 * name (string, optional):
 * <p>
 * 选项名称 ,
 * newFlag (string, optional):
 * <p>
 * 最新标识（‘1’ 表示最新；‘0表示历史记录’） ,
 * points (number, optional):
 * <p>
 * 选项的分 ,
 * shopRatingFlag (string, optional):
 * <p>
 * 门店上报状态：2待审核/3已审核 ,
 * storeId (string, optional):
 * <p>
 * 门店id ,
 * updateTime (string, optional):
 * <p>
 * 修改时间 ,
 * userId (string, optional):
 * <p>
 * 上报人id
 */
public class RatingsReportOptions implements Cloneable {

    private String subjectId;// 组id

    private String groupItem;// 选项组

    private String groupName;// 组一级标题

    private String itemId;// 条目id

    private String name;// 条目二级标题

    private String discrption;// 条目描述

    private double points;// 选分的项

    private double standard;// 得分标准

    private String weight;// 权重

    private String storeId;// 门店ID

    private String userId;// 上报人ID

    private boolean multiChoice;// 是否是多选项

    private String shopRatingFlag;

    public String getSubjectId() {
        return subjectId;
    }

    public void setSubjectId(String subjectId) {
        this.subjectId = subjectId;
    }

    public String getGroupItem() {
        return groupItem;
    }

    public void setGroupItem(String groupItem) {
        this.groupItem = groupItem;
    }

    public String getGroupName() {
        return groupName;
    }

    public void setGroupName(String groupName) {
        this.groupName = groupName;
    }

    public String getItemId() {
        return itemId;
    }

    public void setItemId(String itemId) {
        this.itemId = itemId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDiscrption() {
        return discrption;
    }

    public void setDiscrption(String discrption) {
        this.discrption = discrption;
    }

    public double getPoints() {
        return points;
    }

    public void setPoints(double points) {
        this.points = points;
    }

    public String getStoreId() {
        return storeId;
    }

    public void setStoreId(String storeId) {
        this.storeId = storeId;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public boolean isMultiChoice() {
        return multiChoice;
    }

    public void setMultiChoice(boolean multiChoice) {
        this.multiChoice = multiChoice;
    }

    public double getStandard() {
        return standard;
    }

    public void setStandard(double standard) {
        this.standard = standard;
    }

    public String getWeight() {
        return weight;
    }

    public void setWeight(String weight) {
        this.weight = weight;
    }

    public String getShopRatingFlag() {
        return shopRatingFlag;
    }

    public void setShopRatingFlag(String shopRatingFlag) {
        this.shopRatingFlag = shopRatingFlag;
    }
}