package com.wgmf.yxgj.module.business.reportrating.service;

import android.content.Context;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.wgmf.library.utils.AssetsUtil;
import com.wgmf.yxgj.module.business.reportrating.model.RatingsReportGroupList;

import java.lang.reflect.Type;
import java.util.List;

public class DataService {

    public static String gourpName[] = {"通道项", "专柜面积", "专柜类型", "加减分项"};

    /**
     * 数据源
     */
    public static List<RatingsReportGroupList> getSubjectItems(Context context) {
        String msg = AssetsUtil.getFromAssets(context, "ReportRatingsData.json");
        // 是否成功
        Type listType = new TypeToken<List<RatingsReportGroupList>>() {
        }.getType();
        return new Gson().fromJson(msg, listType);
    }

    /**
     * 等级转化
     *
     * @param totalScore 得分
     * @return 评分等级
     */
    public static String getTotalLevel(double totalScore) {
        String shopLevel;
        if (totalScore >= 95.0) {
            shopLevel = "A+";
        } else if (totalScore >= 85.0 && totalScore < 95.0) {
            shopLevel = "A";
        } else if (totalScore >= 70.0 && totalScore < 85.0) {
            shopLevel = "B";
        } else {
            shopLevel = "C";
        }
        return shopLevel;
    }
}
