package com.wgmf.yxgj.module.business.reportrating.ui;

import android.content.Context;
import android.net.Uri;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.reportrating.R;
import com.wgmf.yxgj.module.business.reportrating.model.RatingsDetailQueryEntity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

/**
 * 作者：xiep on 2017/11/3 14:45
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")
public class QueryRatingsDetailAdapter extends BaseAdapter implements ImagePickerLayout.ImagePicker {
    private Context context;
    private List<RatingsDetailQueryEntity> list;

    private PhotoPreview photoPreview;

    interface PhotoPreview {
        void toPhotoPreviewFragment(int index, List<ImageItem> images);
    }

    QueryRatingsDetailAdapter(PhotoPreview photoPreview, Context context, List<RatingsDetailQueryEntity> list) {
        this.photoPreview = photoPreview;
        this.context = context;
        this.list = list;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public RatingsDetailQueryEntity getItem(int position) {
        if (position >= list.size()) {
            return null;
        } else {
            return list.get(position);
        }
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    @Override
    public void setSelectDialog(int selectType, View view) {

    }

    @Override
    public void toPhotoPreview(int i, ArrayList<ImageItem> arrayList) {
        photoPreview.toPhotoPreviewFragment(i, arrayList);//大图显示
    }

    class ViewHolder {
        TextView groupItem;
        TextView name;
        TextView detail;
        LinearLayout groupItemLl;
        LinearLayout queryRatingsDetailImgLl;
        ImagePickerLayout idImagePickerContainerQueryRatings;

        ViewHolder(View convertView) {
            groupItem = (TextView) convertView.findViewById(R.id.groupItem_tv);
            name = (TextView) convertView.findViewById(R.id.name_tv);
            detail = (TextView) convertView.findViewById(R.id.name_detail_tv);
            groupItemLl = (LinearLayout) convertView.findViewById(R.id.groupItem_ll);
            queryRatingsDetailImgLl = (LinearLayout) convertView.findViewById(R.id.query_ratings_detail_img_ll);
            idImagePickerContainerQueryRatings = (ImagePickerLayout) convertView.findViewById(R.id.id_image_picker_container_query_ratings);
            idImagePickerContainerQueryRatings.setTitleVisibility(View.GONE);
            idImagePickerContainerQueryRatings.setTipVisibility(View.GONE);
            idImagePickerContainerQueryRatings.setImagePicker(QueryRatingsDetailAdapter.this);
            idImagePickerContainerQueryRatings.setSizePhotoNum(3);
            idImagePickerContainerQueryRatings.setMaxPhotoNum(3);
            ArrayList<ImageItem> mImageselectList = new ArrayList<>();
            idImagePickerContainerQueryRatings.setmImageselectList(mImageselectList);
            idImagePickerContainerQueryRatings.setImagePickerView(idImagePickerContainerQueryRatings);
        }
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        convertView = null;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.query_ratings_detail_item, null);
            holder = new ViewHolder(convertView);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final RatingsDetailQueryEntity data = list.get(position);

        holder.name.setText(data.getOptions().getName());
        holder.detail.setText(data.getOptions().getPoints() + "分");

        if (data.getOptions().getGroupItem().equals("")) {
            holder.groupItemLl.setVisibility(View.GONE);
        } else {
            holder.groupItemLl.setVisibility(View.VISIBLE);
            holder.groupItem.setText(data.getOptions().getGroupItem());
        }

        if (!data.getStoreOptionsImagesList().isEmpty()) {
            //如果图片集合大于0，图片数量大于1张
            ArrayList<ImageItem> mImageselectList = new ArrayList<>();
            for (int i = 0; i < data.getStoreOptionsImagesList().size(); i++) {
                String path = data.getStoreOptionsImagesList().get(i).getUrl();
                ImageItem imageItem = new ImageItem();
                imageItem.setImgneturl(path);
                imageItem.setImagePath(path);
                imageItem.setUri(Uri.fromFile(new File(path)));
                imageItem.setType(1);
                mImageselectList.add(imageItem);
            }
            holder.idImagePickerContainerQueryRatings.setOlnyViewMode(true);
            holder.idImagePickerContainerQueryRatings.setImagePickerView(holder.idImagePickerContainerQueryRatings);
            holder.idImagePickerContainerQueryRatings.setmImageselectList(mImageselectList);
            holder.idImagePickerContainerQueryRatings.refreshPhotoContentView(mImageselectList);
        } else {
            holder.queryRatingsDetailImgLl.setVisibility(View.GONE);
        }
        return convertView;
    }
}