package com.wgmf.yxgj.module.business.reportrating.ui;

import android.content.Context;
import android.content.Intent;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.model.ShopRatingsRankEntity;
import com.wgmf.yxgj.module.business.reportrating.R;

import java.util.List;

@SuppressWarnings("all")
class RatingsShopListAdapter extends BaseAdapter {
    private Context context;
    private List<ShopRatingsRankEntity> list;

    RatingsShopListAdapter(Context context, List<ShopRatingsRankEntity> list) {
        this.context = context;
        this.list = list;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public ShopRatingsRankEntity getItem(int position) {
        if (position >= list.size()) {
            return null;
        } else {
            return list.get(position);
        }
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        TextView name;
        TextView rank;
        TextView status;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.query_ratings_list_item, null);
            holder.name = (TextView) convertView.findViewById(R.id.store_name);
            holder.rank = (TextView) convertView.findViewById(R.id.store_rank);
            holder.status = (TextView) convertView.findViewById(R.id.store_status);
            convertView.setTag(holder);

        final ShopRatingsRankEntity data = list.get(position);
        holder.name.setText(data.getStoreName());
        holder.rank.setText(data.getShopLevel());

        // 1未上报/2待审核/3已审核
        String shopRatingFlag = data.getShopRatingFlag();

        if (ConstantParams.CONSTANT_PARAMS_1.equals(shopRatingFlag)) {
            holder.status.setText("待上报");
            holder.status.setTextColor(ContextCompat.getColor(context, R.color.red));
        } else if (ConstantParams.CONSTANT_PARAMS_2.equals(shopRatingFlag)) {
            holder.status.setText("待审核");
            holder.status.setTextColor(ContextCompat.getColor(context, R.color.red));
        } else if (ConstantParams.CONSTANT_PARAMS_3.equals(shopRatingFlag)) {
            holder.status.setText("已审核");
            holder.status.setTextColor(ContextCompat.getColor(context, R.color.common_txt_color));
        }

        convertView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent();
                if (ConstantParams.CONSTANT_PARAMS_1.equals(data.getShopRatingFlag())) {
                    //如果上报状态为1未上报，进入上报详情页
                    intent.putExtra("shopName", data.getStoreName());
                    intent.putExtra("shopId", data.getStoreId());
                    intent.putExtra("storeLatitudes", data.getStoreLatitudes());
                    intent.putExtra("storeLongitudes", data.getStoreLongitudes());
                    intent.setClass(context, ReportRatingsDetailActivity.class);
                    context.startActivity(intent);
                } else {
                    //否则，进入上报查询页
                    intent.putExtra("shopApproveFlag", data.getShopApproveFlag());
                    intent.putExtra("shopApproveContent", data.getShopApproveContent());
                    intent.putExtra("shopName", data.getStoreName());
                    intent.putExtra("shopId", data.getStoreId());
                    intent.putExtra("shopRatingFlag", data.getShopRatingFlag());
                    intent.putExtra("storeLatitudes", data.getStoreLatitudes());
                    intent.putExtra("storeLongitudes", data.getStoreLongitudes());
                    intent.setClass(context, QueryRatingsDetailActivity.class);
                    context.startActivity(intent);
                }
            }
        });
        return convertView;
    }
}