package com.wgmf.yxgj.module.business.reportrating.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.reportrating.R;
import com.wgmf.yxgj.module.business.reportrating.model.RatingsReportGroupList;

import java.util.List;

/**
 * 作者：xiep on 2017/7/4 12:24
 * 邮箱：2975837870@qq.com
 */

class ReportRatingsDetailSelectAdapter extends BaseAdapter {
    private List<RatingsReportGroupList> ratingsReportGroupList;
    private Context context;

    ReportRatingsDetailSelectAdapter(Context context, List<RatingsReportGroupList> ratingsReportGroupList) {
        this.context = context;
        this.ratingsReportGroupList = ratingsReportGroupList;
    }

    @Override
    public int getCount() {
        int childCount = 0;

        if (null != ratingsReportGroupList) {
            childCount = ratingsReportGroupList.size();
        }
        return childCount;
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public boolean hasStableIds() {// 行是否具有唯一id
        return false;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        RatingsReportGroupList item = ratingsReportGroupList.get(position);
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.ratings_detail_select_view, null);
            holder.ratingsSelectTv = (TextView) convertView.findViewById(R.id.ratings_select_tv);
            holder.ratingsSelectPointTv = (TextView) convertView.findViewById(R.id.ratings_select_point_tv);

            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        holder.ratingsSelectTv.setText(item.getOptions().getName());
        holder.ratingsSelectPointTv.setText(item.getOptions().getPoints() + "分");
        return convertView;
    }

    private static class ViewHolder {
        TextView ratingsSelectTv;
        TextView ratingsSelectPointTv;
    }
}