package com.wgmf.yxgj.module.business.reporttourshop.ui;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.module.business.reporttourshop.R;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.model.StaffInfoEntity;
import com.wgmf.yxgj.publics.service.PublicService;

import java.lang.reflect.Type;
import java.util.List;

/**
 * 巡店辅导：顾问选择列表
 */

public class SelectorStaffActivity extends SelectorBaseActivity {

    private String shopId;
    private int typeID;
    private int type;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getShopList();
    }

    private void getShopList() {
        shopId = getIntent().getStringExtra("shopId");
        typeID = getIntent().getIntExtra("typeID", 0);
        type = getIntent().getIntExtra("type", 0);
        if (null != userInfo) {
            showDialog();
            String organizationId = userInfo.getOrganizationId();
            PublicService.getInstance().requestWorkersInfo(shopId, organizationId, SelectorStaffActivity.this);
        }
    }

    @Override
    public void initContent() {
        super.initContent();
        storeNameEt.setHint(R.string.search_name_hint_txt);
        mListView.setOnItemClickListener(new OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {
                BaseSelectorEntity se = listShow.get(position);
                Intent intent = new Intent();
                intent.setClass(SelectorStaffActivity.this, TourShopReportDetailActivity.class);
                intent.putExtra("branchTitle", branchTitle);
                intent.putExtra("staffId", se.getSelectorId());
                //此时显示顾问名字
                intent.putExtra("shopName", se.getSelectorName());
                intent.putExtra("shopId", shopId);
                intent.putExtra("typeID", typeID);
                intent.putExtra("type", type);
                startActivity(intent);
            }
        });
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id==BusinessID.Publics.MSG_ON_WORKERS_INFO) {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        Type listType = new TypeToken<List<StaffInfoEntity>>() {
                        }.getType();
                        List<StaffInfoEntity> resources = new Gson().fromJson(msg, listType);
                        if (null != resources) {
                            listShow.clear();
                            for (StaffInfoEntity resource : resources) {
                                BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
                                mBaseSelectorEntity.setSelectorName(resource.getName());
                                mBaseSelectorEntity.setSelectorId(resource.getStaffId());
                                listShow.add(mBaseSelectorEntity);
                            }
                            mAdapter.notifyDataSetChanged();
                            search();
                        }
                    }
            }
        }
    }
}