package com.wgmf.yxgj.module.business.reporttourshop.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.RadioButton;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.reporttourshop.model.TourShopSaveEntity;
import com.wgmf.yxgj.module.business.reporttourshop.R;

import java.util.List;
@SuppressWarnings("all")
class TourShopReportAdapter extends BaseAdapter {
    private Context context;
    private List<TourShopSaveEntity> list;

    TourShopReportAdapter(Context context, List<TourShopSaveEntity> list) {
        this.context = context;
        this.list = list;
    }

    /**
     * 巡店上报实体
     */
    List<TourShopSaveEntity> getTourShopListEntity() {
        return list;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }


    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        TextView tourshopItemProject;
        TextView tourshopItemContent;
        TextView tourshopItemPoint;
        TextView tourshopItemLastpoint;
        RadioButton isokYes;
        RadioButton isokNo;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        convertView = null;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.list_item_tour_shop_report, null);
            holder.tourshopItemProject = (TextView) convertView.findViewById(R.id.tourshop_item_project);
            holder.tourshopItemContent = (TextView) convertView.findViewById(R.id.tourshop_item_content);
            holder.tourshopItemPoint = (TextView) convertView.findViewById(R.id.tourshop_item_point);
            holder.tourshopItemLastpoint = (TextView) convertView.findViewById(R.id.tourshop_item_lastpoint);
            holder.isokYes = (RadioButton) convertView.findViewById(R.id.tourshop_item_isok_yes);
            holder.isokNo = (RadioButton) convertView.findViewById(R.id.tourshop_item_isok_no);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        final TourShopSaveEntity data = list.get(position);

        holder.tourshopItemContent.setText(data.getContent());
        holder.tourshopItemPoint.setText("配分：" + data.getPoint());
        if (null != data.getLastPoint() && !data.getLastPoint().equals("null") && !data.getLastPoint().equals("")) {
            holder.tourshopItemLastpoint.setText("上次得分：" + data.getLastPoint());
        }

        // 如果当前项目名称与前一项目名称相同则不显示，即所有子项目只允许第一个子项目出现产品名称
        if (position >= 1&&null != data.getProject()) {
                if (data.getProject().equals(list.get(position - 1).getProject())) {
                    holder.tourshopItemProject.setVisibility(View.GONE);
                } else {
                    holder.tourshopItemProject.setVisibility(View.VISIBLE);
                }
            }
        holder.tourshopItemProject.setText(data.getProject());
        holder.isokYes.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (holder.isokYes.isChecked()) {
                    data.setIsOk(1L);
                    data.setAchievePoint(data.getAchievePoint());
                } else {
                    data.setIsOk(0L);
                    data.setAchievePoint("0");
                }
                radioButtonShow(holder, data);
            }
        });
        holder.isokNo.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (holder.isokNo.isChecked()) {
                    data.setIsOk(0L);
                    data.setAchievePoint("0");
                } else {
                    data.setIsOk(1L);
                    data.setAchievePoint(data.getAchievePoint());
                }
                radioButtonShow(holder, data);
            }
        });

        radioButtonShow(holder, data);
        return convertView;
    }

    private void radioButtonShow(ViewHolder holder, TourShopSaveEntity data) {
        if (null != data.getIsOk()) {
            if (data.getIsOk() == 1) {
                holder.isokYes.setChecked(true);
                holder.isokYes.setTextColor(context.getResources().getColor(
                        R.color.green));
                holder.isokYes.setBackgroundResource(R.drawable.btn_green_style);
                holder.isokNo
                        .setBackgroundResource(R.drawable.btn_gray_style);
                holder.isokNo.setTextColor(context.getResources().getColor(
                        R.color.important_txt_color));
            } else {
                holder.isokNo.setChecked(true);
                holder.isokNo.setTextColor(context.getResources().getColor(
                        R.color.pink));
                holder.isokNo.setBackgroundResource(R.drawable.btn_red_style);
                holder.isokYes
                        .setBackgroundResource(R.drawable.btn_gray_style);
                holder.isokYes.setTextColor(context.getResources().getColor(
                        R.color.important_txt_color));
            }
        }
    }
}