package com.wgmf.yxgj.module.business.reporttourshop.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.reporttourshop.R;
import com.wgmf.yxgj.module.business.reporttourshop.model.TourShopListEntity;
import com.wgmf.yxgj.module.business.reporttourshop.model.TourShopResultListEntity;
import com.wgmf.yxgj.module.business.reporttourshop.model.TourShopSaveEntity;
import com.wgmf.yxgj.module.business.reporttourshop.service.TourShopService;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.util.ArrayList;
import java.util.List;

public class TourShopReportDetailActivity extends ReportWithPhotoBaseActivity implements ImagePickerLayout.ImagePicker {

    private String staffid;
    private String submitStaffId;
    private int typeID;
    private TourShopReportAdapter mTourShopReportAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        queryData();
    }

    @Override
    protected void initData() {
        super.initData();
        //巡店辅导
        reportType = "XJ";
    }

    @Override
    protected void initContent() {
        super.initContent();
        typeID = getIntent().getIntExtra("typeID", 0);
        shopId = getIntent().getStringExtra("shopId");
        shopName = getIntent().getStringExtra("shopName");
        reportDetailTitle.setText(shopName);
        reportDetailDate.setText(DateUtil.getFormatCurrentDate("yyyy-MM-dd"));
        titleMoreLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void parseFootData() {
        super.parseFootData();
        reportEdit.setVisibility(View.GONE);
        tvSummary.setVisibility(View.GONE);
        publicTakePhotoLl.setVisibility(View.GONE);
        if (typeID == 3) {
            publicTakePhotoRootLl.setVisibility(View.GONE);
        } else {
            publicTakePhotoRootLl.setVisibility(View.VISIBLE);
        }
        initPictureDisplayView();
    }

    private void initPictureDisplayView() {
        idImagePickerContainer = (ImagePickerLayout) findViewById(R.id.id_image_picker_container);
        idImagePickerContainer.setVisibility(View.VISIBLE);
        idImagePickerContainer.setTitle("巡店辅导上报图片");
        idImagePickerContainer.setTip("(最多可上传1张)");
        idImagePickerContainer.setImagePicker(this);
        idImagePickerContainer.setSizePhotoNum(3);
        idImagePickerContainer.setMaxPhotoNum(1);
        idImagePickerContainer.setmImageselectList(mImageselectList);
        idImagePickerContainer.setImagePickerView(idImagePickerContainer);
        idImagePickerContainer.setOlnyViewMode(false);
    }

    @Override
    public void initTitle() {
        super.initTitle();
        String branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    protected void queryData() {
        showDialog();
        if (null != userInfo) {
            submitStaffId = userInfo.getStaffId();
            if (typeID == 1 || typeID == 3) {
                staffid = getIntent().getStringExtra("staffId");
                TourShopService.getInstance().requestGetTourShopByStaff(shopId, staffid, typeID + "", TourShopReportDetailActivity.this);
            } else {
                TourShopService.getInstance().requestGetTourShop(shopId, typeID + "", TourShopReportDetailActivity.this);
            }
        }
    }


    /**
     * 上传巡店辅导数据
     */
    @Override
    protected void uploadData() {
        super.uploadData();
        if (typeID != 3 && (urlLists == null || urlLists.isEmpty())) {
            ToastUtil.show(this, "必须拍照");
            return;
        }
        showDialog();
        List<TourShopSaveEntity> mTourShopListEntity = mTourShopReportAdapter.getTourShopListEntity();
        for (int i = 0; i < mTourShopListEntity.size(); i++) {
            if (urlLists != null && !urlLists.isEmpty()) {
                mTourShopListEntity.get(i).setImageUrl(urlLists.get(0));
            }
        }
        String content = new Gson().toJson(mTourShopListEntity);
        Log.d(TAG, content);
        TourShopService.getInstance().requestSaveTourShop(content, TourShopReportDetailActivity.this);
    }

    public void setData(TourShopListEntity data) {
        if (data != null) {
            List<TourShopResultListEntity> mTourShopResultListEntity = data.getResultList();
            List<TourShopSaveEntity> mTourShopSaveListEntity = new ArrayList<>();
            for (int i = 0; i < mTourShopResultListEntity.size(); i++) {
                TourShopSaveEntity mTourShopSaveEntity = new TourShopSaveEntity();
                mTourShopSaveEntity.setProject(mTourShopResultListEntity.get(i).getProject());
                mTourShopSaveEntity.setContent(mTourShopResultListEntity.get(i).getContent());
                mTourShopSaveEntity.setIsOk(mTourShopResultListEntity.get(i).getIsOk());
                mTourShopSaveEntity.setMid(mTourShopResultListEntity.get(i).getMid());
                mTourShopSaveEntity.setPoint(mTourShopResultListEntity.get(i).getPoint());
                mTourShopSaveEntity.setAchievePoint(mTourShopResultListEntity.get(i).getPoint());
                mTourShopSaveEntity.setLastPoint(mTourShopResultListEntity.get(i).getLastPoint());
                mTourShopSaveEntity.setShopId(shopId);
                mTourShopSaveEntity.setStaffId(staffid);
                mTourShopSaveEntity.setSubmitStaffId(submitStaffId);
                mTourShopSaveEntity.setType(typeID);
                mTourShopSaveListEntity.add(mTourShopSaveEntity);
            }
            mTourShopReportAdapter = new TourShopReportAdapter(this, mTourShopSaveListEntity);
            publicListViewLv.setAdapter(mTourShopReportAdapter);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.TourShopReport.MSG_ON_FIND_TOURSHOP: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        TourShopListEntity mTourShopListEntity = new Gson().fromJson(msg, TourShopListEntity.class);
                        Log.d(TAG, "mTourShopListEntity=" + mTourShopListEntity.toString());
                        if (!ConstantParams.CONSTANT_PARAMS_0.equals(mTourShopListEntity.retCode)) {
                            ToastUtil.show(this, mTourShopListEntity.retInfo);
                        } else {
                            setData(mTourShopListEntity);
                        }
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                }
                break;
                case BusinessID.TourShopReport.MSG_ON_SAVE_TOURSHOP: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (!ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                            if (mBaseResponse.retInfo.contains("isOk")) {
                                ToastUtil.show(this, "请将信息填写完整再上传");
                            } else {
                                ToastUtil.show(this, mBaseResponse.retInfo);
                            }
                        } else {
                            ToastUtil.show(this, getString(R.string.save_data_success));
                            this.finish();
                        }
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    @Override
    public void setSelectDialog(int selectType,View view) {
        idImagePickerContainer = (ImagePickerLayout) view;
        setSelectDialogListeners(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //拍照处理
                takePhoto(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                hideSelectDialog();
            }
        });
        showSelectDialog("选择图片", null, "相机拍照", "取消");
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, com.xp.pro.imagepickerlib.global.Params.TAKE_PICTURE);
    }

    @Override
    public void toPhotoPreview(int index, ArrayList<ImageItem> mImageselectList) {
        toPhotoPreviewFragment(index, mImageselectList);//大图显示
    }
}