package com.wgmf.yxgj.app;

import android.app.ActivityManager;
import android.content.Context;

import com.wgmf.yxgj.graph.components.ApplicationComponent;
import com.wgmf.yxgj.graph.components.DaggerApplicationComponent;
import com.wgmf.yxgj.graph.modules.ApplicationModule;

import java.util.List;

/**
 * @author XP
 */
public class AndroidApplication extends LibApplication {

    private static ApplicationComponent sAppComponent;

    private static String getProcessName(Context cxt, int pid) {
        ActivityManager am = (ActivityManager) cxt
                .getSystemService(Context.ACTIVITY_SERVICE);
        List<ActivityManager.RunningAppProcessInfo> runningApps = am.getRunningAppProcesses();
        if (runningApps == null) {
            return null;
        }
        for (ActivityManager.RunningAppProcessInfo procInfo : runningApps) {
            if (procInfo.pid == pid) {
                return procInfo.processName;
            }
        }
        return null;
    }

    @Override
    public void onCreate() {
        super.onCreate();

        String processName = getProcessName(this, android.os.Process.myPid());
        if (processName != null) {
            boolean defaultProcess = processName.equals(getPackageName());
            if (defaultProcess) {
                init();
            }
        } else {
            init();
        }
    }


    private void init() {
        initInjector();
    }

    /**
     * 初始化注射器
     */
    private void initInjector() {
        // 这里不做注入操作，只提供一些全局单例数据
        sAppComponent = DaggerApplicationComponent.builder()
                .applicationModule(new ApplicationModule(this))
                .build();
    }

    public static ApplicationComponent getAppComponent() {
        return sAppComponent;
    }
}