package com.wgmf.yxgj.module.business.starplan.ui;

import android.content.Intent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.AssetsUtil;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.starplan.R;
import com.wgmf.yxgj.module.business.starplan.model.StarPlanEntity;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;
import com.xp.arouter.RouterParams;

import java.lang.reflect.Type;
import java.util.LinkedList;
import java.util.List;

@Route(path = RouterParams.URL_STARPLANREPLYACTIVITY)
public class StarPlanReplyActivity extends SelectorBaseActivity {

    private String flag;
    private StarPlanReplyAdapter adapter;

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("能力发展STAR辅导批复");
    }

    @Override
    protected void initContent() {
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        storeNameEt = (ClearEditText) findViewById(R.id.store_name_et);
        reportContentComfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentComfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        storeNameEt = (ClearEditText) findViewById(R.id.store_name_et);
        storeNameEt.setVisibility(View.GONE);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        setData();
    }

    private void setData() {
        String fuction = AssetsUtil.getFromAssets(this, "StarPlanData.json");
        Type listType = new TypeToken<LinkedList<StarPlanEntity>>() {
        }.getType();
        final List<StarPlanEntity> resources = new Gson().fromJson(fuction, listType);
        if (resources != null && !resources.isEmpty()) {
            adapter = new StarPlanReplyAdapter(resources, this);
            mListView.setAdapter(adapter);
            mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                    flag = resources.get(position).getFlag();
                    Intent intent = new Intent(StarPlanReplyActivity.this, StarPlanWriteActivity.class);
                    intent.putExtra("flag", flag);
                    if (!ConstantParams.CONSTANT_PARAMS_1.equals(flag)) {
                        startActivity(intent);
                    }
                }
            });
            ListViewUtil.setListViewHeight(mListView);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.GoodsManager.MSG_ON_FIND_STOCKGOODS_CHECK_STORE) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    setData();
                } else {
                    showMsg(result.getResultInfo());
                }
            }
        }
    }
}