package com.wgmf.yxgj.module.business.starplan.ui;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.starplan.R;
import com.wgmf.yxgj.module.business.starplan.model.StarPlanEntity;

import java.util.List;

class StarPlanReplyAdapter extends BaseAdapter {

    private List<StarPlanEntity> list;
    private Context context;

    StarPlanReplyAdapter(List<StarPlanEntity> mlist, Context context) {
        this.list = mlist;
        this.context = context;
    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @SuppressWarnings("all")
    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.star_plan_reply_content_list_item, null);
            viewHolder = new ViewHolder();
            viewHolder.store = (TextView) convertView.findViewById(R.id.star_plan_reply_item_name);
            viewHolder.examine = (TextView) convertView.findViewById(R.id.star_plan_reply_item_flag);
            viewHolder.row = (ImageView) convertView.findViewById(R.id.star_plan_reply_item_row);

            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        StarPlanEntity ent = list.get(position);
        viewHolder.store.setText(ent.getName());

        if (ConstantParams.CONSTANT_PARAMS_1.equals(ent.getFlag())) {
            viewHolder.examine.setText("总结未提交");
            viewHolder.row.setVisibility(View.INVISIBLE);
            viewHolder.examine.setTextColor(ContextCompat.getColor(context, R.color.red));
        } else {
            if (ConstantParams.CONSTANT_PARAMS_2.equals(ent.getFlag())) {
                viewHolder.examine.setText("已批复");
                viewHolder.examine.setTextColor(ContextCompat.getColor(context, R.color.assist_green_txt));
            } else if (ConstantParams.CONSTANT_PARAMS_3.equals(ent.getFlag())) {
                viewHolder.examine.setText("未批复");
                viewHolder.examine.setTextColor(ContextCompat.getColor(context, R.color.normal_color));
            }
        }
        return convertView;
    }

    class ViewHolder {
        ImageView row;
        TextView store;
        /**
         * 盘点状态
         */
        TextView examine;
    }
}