package com.wgmf.yxgj.module.business.starplan.ui;

import android.os.Bundle;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.AssetsUtil;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.starplan.R;
import com.wgmf.yxgj.module.business.starplan.model.StarPlanEntity;
import com.wgmf.yxgj.widgets.Dialog.DatePickerYearMonthDialog;
import com.xp.arouter.RouterParams;

import java.lang.reflect.Type;
import java.util.Date;
import java.util.LinkedList;

@Route(path = RouterParams.URL_STARPLANWRITEACTIVITY)
public class StarPlanWriteActivity extends BaseParentAct implements View.OnClickListener {
    TextView starPlanWriteHeaderLeftTv;
    TextView starPlanWriteHeaderCenterTv;
    TextView starPlanWriteHeaderRightTv;
    ListView starPlanWriteContentLv;
    ListView customerVisitQueryContentLv2;
    StarPlanWriteAdapter mStarPlanWriteAdapter;
    StarPlanWriteAdapter mStarPlanWriteAdapter2;
    LinearLayout starPlanWriteContentView2Ll;
    LinearLayout starPlanWriteContentView3Ll;
    LinearLayout starPlanWriteContentView4Ll;
    LinearLayout starPlanWriteContentView5Ll;
    LinearLayout starPlanWriteContentView6Ll;

    String yearMonth;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_star_plan_write);
        initTitle();
        initContent();
//        getData(yearMonth);
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("能力发展STAR与计划");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initContent() {
        yearMonth = DateUtil.getFormatCurrentDate("yyyy年M月");

        starPlanWriteHeaderLeftTv = (TextView) findViewById(R.id.star_plan_write_header_left_tv);
        starPlanWriteHeaderCenterTv = (TextView) findViewById(R.id.star_plan_write_header_center_tv);
        starPlanWriteHeaderRightTv = (TextView) findViewById(R.id.star_plan_write_header_right_tv);
        starPlanWriteHeaderCenterTv.setText(yearMonth);
        starPlanWriteHeaderLeftTv.setOnClickListener(this);
        starPlanWriteHeaderCenterTv.setOnClickListener(this);
        starPlanWriteHeaderRightTv.setOnClickListener(this);

        LinearLayout starPlanWriteContentEmptyLl = (LinearLayout) findViewById(R.id.star_plan_write_content_empty_ll);
        starPlanWriteContentLv = (ListView) findViewById(R.id.star_plan_write_content_lv);
        customerVisitQueryContentLv2 = (ListView) findViewById(R.id.customer_visit_query_content_lv2);

        starPlanWriteContentLv.setEmptyView(starPlanWriteContentEmptyLl);
        View headerView = getLayoutInflater().inflate(R.layout.star_plan_write_content_view1_header, null);
        starPlanWriteContentLv.addHeaderView(headerView);
        View headerView2 = getLayoutInflater().inflate(R.layout.star_plan_write_content_view5_header, null);
        customerVisitQueryContentLv2.addHeaderView(headerView2);

        starPlanWriteContentView2Ll = (LinearLayout) findViewById(R.id.star_plan_write_content_view2_ll);
        starPlanWriteContentView3Ll = (LinearLayout) findViewById(R.id.star_plan_write_content_view3_ll);
        starPlanWriteContentView4Ll = (LinearLayout) findViewById(R.id.star_plan_write_content_view4_ll);
        starPlanWriteContentView5Ll = (LinearLayout) findViewById(R.id.star_plan_write_content_view5_ll);
        starPlanWriteContentView6Ll = (LinearLayout) findViewById(R.id.star_plan_write_content_view6_ll);
        getFlag();
        setData();
    }

    private void getFlag() {
        String flag = getIntent().getStringExtra("flag");
        if (null == flag) {
            starPlanWriteContentView3Ll.setVisibility(View.GONE);
            starPlanWriteContentView4Ll.setVisibility(View.GONE);
            starPlanWriteContentView5Ll.setVisibility(View.GONE);
            starPlanWriteContentView6Ll.setVisibility(View.GONE);
        } else {
            if (ConstantParams.CONSTANT_PARAMS_2.equals(flag)) {
                //已批复
                starPlanWriteContentView2Ll.setVisibility(View.GONE);
                starPlanWriteContentView3Ll.setVisibility(View.GONE);
                starPlanWriteContentView4Ll.setVisibility(View.GONE);
                starPlanWriteContentView5Ll.setVisibility(View.VISIBLE);
                starPlanWriteContentView6Ll.setVisibility(View.VISIBLE);
            } else if (ConstantParams.CONSTANT_PARAMS_3.equals(flag)) {
                //未批复
                starPlanWriteContentView2Ll.setVisibility(View.GONE);
                starPlanWriteContentView3Ll.setVisibility(View.VISIBLE);
                starPlanWriteContentView4Ll.setVisibility(View.VISIBLE);
                starPlanWriteContentView5Ll.setVisibility(View.GONE);
                starPlanWriteContentView6Ll.setVisibility(View.GONE);
            }
        }
    }

    private void setData() {
        String fuction = AssetsUtil.getFromAssets(this, "StarPlanData.json");
        Type listType = new TypeToken<LinkedList<StarPlanEntity>>() {
        }.getType();
        LinkedList<StarPlanEntity> resources = new Gson().fromJson(fuction, listType);
        if (resources != null && !resources.isEmpty()) {
            mStarPlanWriteAdapter = new StarPlanWriteAdapter(resources, this);
            starPlanWriteContentLv.setAdapter(mStarPlanWriteAdapter);
            mStarPlanWriteAdapter2 = new StarPlanWriteAdapter(resources, this);
            customerVisitQueryContentLv2.setAdapter(mStarPlanWriteAdapter2);
            ListViewUtil.setListViewHeight(starPlanWriteContentLv);
            ListViewUtil.setListViewHeight(customerVisitQueryContentLv2);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.KAManager.MSG_ON_FIND_CUSTOMER_VISIT) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    setData();
                }
            }
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.star_plan_write_header_left_tv) {
            //上一月
            String[] years = yearMonth.split("年");
            String[] month = years[1].split("月");
            int year = Integer.parseInt(years[0]);
            int monthOfYear = Integer.parseInt(month[0]);
            queryDataByMonth(year, monthOfYear, -1);
        } else if (v.getId() == R.id.star_plan_write_header_right_tv) {
            //下一月
            String[] years = yearMonth.split("年");
            String[] month = years[1].split("月");
            int year = Integer.parseInt(years[0]);
            int monthOfYear = Integer.parseInt(month[0]);
            queryDataByMonth(year, monthOfYear, +1);
        } else if (v.getId() == R.id.star_plan_write_header_center_tv) {
            new DatePickerYearMonthDialog(this, new DatePickerYearMonthDialog.OnDateSetListener() {
                @Override
                public void onDateSet(int year, int monthOfYear) {
                    queryDataByMonth(year, monthOfYear, +1);
                }
            }).show();
        }
    }

    private void queryDataByMonth(int year, int monthOfYear, int diff) {
        yearMonth = String.valueOf(year) + String.valueOf(monthOfYear + diff);
        Date yearMonthNow = DateUtil.string2Date(yearMonth, "yyyyM");
        yearMonth = DateUtil.format(yearMonthNow, "yyyy年M月");
        starPlanWriteHeaderCenterTv.setText(yearMonth);
//        getData(yearMonth);
    }
}