package com.wgmf.yxgj.module.business.starplan.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;

import com.wgmf.yxgj.module.business.starplan.R;
import com.wgmf.yxgj.module.business.starplan.model.StarPlanEntity;
import com.wgmf.yxgj.widgets.TextView.MarqueeTextView;

import java.util.List;

/**
 * @author XiePing on 2017/7/21 13:49
 * 邮箱：2975837870@qq.com
 */

class StarPlanWriteAdapter extends BaseAdapter {

    private Context context;
    private List<StarPlanEntity> mCustomerVisitEntity;

    StarPlanWriteAdapter(List<StarPlanEntity> mlist, Context context) {
        this.mCustomerVisitEntity = mlist;
        this.context = context;
    }

    @Override
    public int getCount() {
        return mCustomerVisitEntity == null ? 0 : mCustomerVisitEntity.size();
    }

    @Override
    public Object getItem(int position) {
        return mCustomerVisitEntity == null ? null : mCustomerVisitEntity.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.star_plan_write_content_list_item, null);
            viewHolder = new ViewHolder(convertView);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        StarPlanEntity ent = mCustomerVisitEntity.get(position);
        viewHolder.visitTime.setText(ent.getName());
        viewHolder.visitCusName.setText(ent.getComplete());
        viewHolder.visitCusPosition.setText(ent.getRadio());
        return convertView;
    }

    class ViewHolder {
        MarqueeTextView visitTime;
        MarqueeTextView visitCusName;
        MarqueeTextView visitCusPosition;

        ViewHolder(View convertView) {
            visitTime = (MarqueeTextView) convertView.findViewById(R.id.star_plan_content_item_name);
            visitCusName = (MarqueeTextView) convertView.findViewById(R.id.star_plan_content_item_complete);
            visitCusPosition = (MarqueeTextView) convertView.findViewById(R.id.star_plan_content_item_radio);
           }
    }
}