package com.wgmf.yxgj.bussiness.talentpool.ui;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.bussiness.talentpool.R;
import com.wgmf.yxgj.bussiness.talentpool.model.TalentPoolEntity;
import com.wgmf.yxgj.bussiness.talentpool.model.TalentPoolShop;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;

import java.util.ArrayList;
import java.util.List;

/**
 * 选择列表公共基类
 * <p>
 * 作者：xiep on 2017/1/16 10:15
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")
public class TalentPoolBaseActivity extends BaseParentAct {
    protected ListView mListView;
    protected TalentPoolBaseAdapter<TalentPoolEntity> mAdapter;
    protected List<TalentPoolEntity> mListStore;
    protected List<TalentPoolEntity> listShow;
    protected ClearEditText storeNameEt;
    protected LinearLayout reportContentComfirmLl;
    protected Button reportContentComfirmBtn;
    protected Button reportContentModifyBtn;
    protected String branchTitle;
    protected TextView baseListItem1;
    protected TextView baseListItem2;
    protected LinearLayout baseListItem2Ll;
    protected TextView baseListItem3;
    protected TextView baseListItem4;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.public_list_view);
        initTitle();
        initContent();
        setListener();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    public void initContent() {
        mListStore = new ArrayList<>();
        listShow = new ArrayList<>();
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv= (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);

        storeNameEt = (ClearEditText) findViewById(R.id.store_name_et);
        storeNameEt.setVisibility(View.VISIBLE);
        addComfirmView();
        addHeaderOrFooterView();
        mAdapter = new TalentPoolBaseAdapter<TalentPoolEntity>(this, listShow) {
            @Override
            public void convert(BaseViewHolder helper, TalentPoolEntity item) {
                helper.setImageResourceGone(View.VISIBLE);
                if (!StringUtil.isNullOrEmpty(item.getName())) {
                    helper.setText1(item.getName());
                }
                if (item.getSumScore() > 0.0) {
                    helper.setLL2();
                    if (item.getSumScore() > 4.5) {
                        helper.setImageResource5(R.drawable.btn_star_black);
                        helper.setImageResource4(R.drawable.btn_star_black);
                        helper.setImageResource3(R.drawable.btn_star_black);
                        helper.setImageResource2(R.drawable.btn_star_black);
                        helper.setImageResource1(R.drawable.btn_star_black);
                    } else if (item.getSumScore() > 3.5) {
                        helper.setImageResource1(R.drawable.btn_star_black);
                        helper.setImageResource2(R.drawable.btn_star_black);
                        helper.setImageResource3(R.drawable.btn_star_black);
                        helper.setImageResource4(R.drawable.btn_star_black);
                    } else if (item.getSumScore() > 2.5) {
                        helper.setImageResource1(R.drawable.btn_star_black);
                        helper.setImageResource2(R.drawable.btn_star_black);
                        helper.setImageResource3(R.drawable.btn_star_black);
                    } else if (item.getSumScore() > 1.5) {
                        helper.setImageResource1(R.drawable.btn_star_black);
                        helper.setImageResource2(R.drawable.btn_star_black);
                    } else if (item.getSumScore() > 0.5) {
                        helper.setImageResource1(R.drawable.btn_star_black);
                    }
                }
                if (null != item.getTalentPoolShop() && !item.getTalentPoolShop().isEmpty()) {
                    for (int i = 0; i < item.getTalentPoolShop().size(); i++) {
                        TalentPoolShop mTalentPoolShop = item.getTalentPoolShop().get(i);
                        if (null != mTalentPoolShop.getIntention()) {
                            if (ConstantParams.CONSTANT_PARAMS_1.equals(mTalentPoolShop.getIntention())) {
                                helper.setText3("第一意向");
                            }
                            if (ConstantParams.CONSTANT_PARAMS_2.equals(mTalentPoolShop.getIntention())) {
                                helper.setText3("第二意向");
                            }
                            if (ConstantParams.CONSTANT_PARAMS_3.equals(mTalentPoolShop.getIntention())) {
                                helper.setText3("第三意向");
                            }
                        }
                    }
                }
                if (!StringUtil.isNullOrEmpty(item.getNumber())) {
                    helper.setText4(item.getNumber());
                }
            }
        };
        mListView.setAdapter(mAdapter);
        // 默认不弹出软键盘
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
    }

    protected void addComfirmView() {
        reportContentComfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentComfirmLl.setVisibility(View.VISIBLE);
        reportContentComfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        reportContentModifyBtn = (Button) findViewById(R.id.report_content_modify_btn);

        reportContentComfirmBtn.setText(getString(R.string.add_person));
        reportContentComfirmBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent();
                intent.setClass(TalentPoolBaseActivity.this, TalentPoolDetailActivity.class);
                startActivity(intent);
            }
        });
    }
    @SuppressWarnings("all")
    protected void addHeaderOrFooterView() {
        View headerView = getLayoutInflater().inflate(R.layout.talent_pool_base_list_item, null);
        mListView.addHeaderView(headerView);
        baseListItem1 = (TextView) findViewById(R.id.base_list_item_1);
        baseListItem2 = (TextView) findViewById(R.id.base_list_item_2);
        baseListItem2Ll = (LinearLayout) findViewById(R.id.base_list_item_2_ll);
        baseListItem3 = (TextView) findViewById(R.id.base_list_item_3);
        baseListItem4 = (TextView) findViewById(R.id.base_list_item_4);
    }

    @SuppressWarnings("all")
    protected void setListener() {
        storeNameEt.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                textChanged();
            }
        });
    }

    public void textChanged() {
        String itemId = storeNameEt.getText().toString().trim();
        if (TextUtils.isEmpty(itemId)) {
            listShow.clear();
            listShow.addAll(mListStore);
        } else {
            listShow.clear();
            if (null != mListStore) {
                for (TalentPoolEntity p : mListStore) {
                    if (null != p.getName()&&p.getName().contains(itemId)) {
                            listShow.add(p);
                    }
                }
            }
        }
        mAdapter.notifyDataSetChanged();
    }

    protected void search() {
        if (null != listShow) {
            mListStore.clear();
            mListStore.addAll(listShow);
            mAdapter.notifyDataSetChanged();
        }
    }
}