package com.wgmf.yxgj.bussiness.talentpool.ui;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;

import com.wgmf.yxgj.bussiness.talentpool.R;

import java.util.List;

/**
 * 作者：xiep on 2016/7/20 16:28
 * 邮箱：2975837870@qq.com
 */
public abstract class TalentPoolBaseAdapter<T> extends BaseAdapter {
    private Context mContext;
    private List<T> mDatas;
    private final int mItemLayoutId;

    TalentPoolBaseAdapter(Context context, List<T> mDatas) {
        this.mContext = context;
        this.mDatas = mDatas;
        this.mItemLayoutId = R.layout.talent_pool_base_list_item;
    }

    @Override
    public int getCount() {
        return !mDatas.isEmpty() ? mDatas.size() : 0;
    }

    @Override
    public T getItem(int position) {
        return mDatas.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final BaseViewHolder viewHolder = getViewHolder(position, convertView, parent);
        convert(viewHolder, getItem(position));
        return viewHolder.getConvertView();

    }

    public abstract void convert(BaseViewHolder helper, T item);

    private BaseViewHolder getViewHolder(int position, View convertView, ViewGroup parent) {
        return BaseViewHolder.get(mContext, convertView, parent, mItemLayoutId, position);
    }
}
