package com.wgmf.yxgj.bussiness.talentpool.ui;

import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RatingBar;
import android.widget.TextView;

import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.bussiness.talentpool.R;
import com.wgmf.yxgj.bussiness.talentpool.model.TalentPoolEntity;
import com.wgmf.yxgj.bussiness.talentpool.model.TalentPoolImag;
import com.wgmf.yxgj.bussiness.talentpool.model.TalentPoolListEntity;
import com.wgmf.yxgj.bussiness.talentpool.model.TalentPoolResultEntity;
import com.wgmf.yxgj.bussiness.talentpool.model.TalentPoolShop;
import com.wgmf.yxgj.bussiness.talentpool.service.TalentPoolService;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.PublicTipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.pop.PublicSelectPop;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.wgmf.yxgj.utils.helper.DialogHelper;
import com.wgmf.yxgj.widgets.MMessageDisplay;
import com.xp.arouter.RouterCommonUtil;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.global.Params;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

/**
 * 作者：xiep on 2017/12/13 17:10
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")

public class TalentPoolDetailActivity extends ReportWithPhotoBaseActivity implements View.OnClickListener, PublicSelectPop.ReportQuerySelectPopListener, ImagePickerLayout.ImagePicker {
    /**
     * 选择意向门店1 的返回
     */
    public static final int SELECT_STORE_1 = 1000;
    /**
     * 选择意向门店2 的返回
     */
    public static final int SELECT_STORE_2 = 1002;
    /**
     * 选择意向门店3 的返回
     */
    public static final int SELECT_STORE_3 = 1003;
    /**
     * 1，查询；2，修改；3，新增
     */
    private int dateFalg = 1;
    /**
     * 1，正常库：可查看，修改；4，删除库：只可查看
     */
    private String talentFlag = "1";
    /**
     * 人才库id
     */
    private String talentPoolId;

    private List<TalentPoolEntity> baseSelectorEntitys;
    private TalentPoolEntity mTalentPoolEntityDetail;
    private List<TalentPoolShop> mTalentPoolShops = new ArrayList<>();
    private List<TalentPoolImag> mTalentPoolImags = new ArrayList<>();
    private TextView talentTelephoneTv;
    private EditText talentNameEdt;
    private EditText talentTelephoneEdt;
    private EditText talentHeightEdt;
    private TextView talentSexTv;
    private TextView talentBirthdayTv;
    private TextView intentionShop1Tv;
    private TextView intentionShop2Tv;
    private TextView intentionShop3Tv;
    private TextView intentionShop1IdTv;
    private TextView intentionShop2IdTv;
    private TextView intentionShop3IdTv;

    private EditText homeAddressEdt;
    private RatingBar talentPoolSaleAbilityRb;
    private RatingBar talentPoolStudyAbilityRb;
    private RatingBar talentPoolPositiveActiveRb;

    private float[] scoreArray = new float[]{0, 0, 0};
    private PublicSelectPop mPublicSelectPop;
    private String telPhoneNumber;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getData();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        talentFlag = getIntent().getStringExtra("talentFlag");
        if (null != talentFlag && ConstantParams.CONSTANT_PARAMS_4.equals(talentFlag)) {
            homeTitleText.setText(getString(R.string.delete_person));
        } else {
            homeTitleText.setText("添加人才");
        }
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
    }

    /**
     * 确认退出对话框
     */
    public void showBackTipDialog() {
        final PublicTipDialog.Builder builder = new PublicTipDialog.Builder(this);
        builder.setTitle("提示");
        builder.setMessage("确认退出？");
        builder.setNegativeButton("确定", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
                TalentPoolDetailActivity.this.finish();
            }
        });
        builder.setPositiveButton("取消", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.create().show();
    }

    /**
     * @param dateFalg 1，查询；2，修改；3，新增
     */
    private void setViewByFlag(int dateFalg) {
        if (dateFalg == 1) {
            reportContentModifyBtn.setVisibility(View.VISIBLE);
            reportContentConfirmBtn.setVisibility(View.VISIBLE);
            reportContentModifyBtn.setText(getString(R.string.modify_btn_txt));
            reportContentConfirmBtn.setText(getString(R.string.delete_btn_text));
            setModifyTextColor(ContextCompat.getColor(this, R.color.important_txt_color));
            setModifyView(null);
            setRatingBar(true);
            setEditEnable(false);
            setTextSelect(null);
            setTelPhone(this);
            talentTelephoneTv.setVisibility(View.VISIBLE);
            talentTelephoneEdt.setVisibility(View.GONE);
            setEditViewHint("未填写");
            setTextViewHint("未填写");
            setHomeAddressHint("家庭住址未填写");
            idImagePickerContainer.setOlnyViewMode(true);
            idImagePickerContainer.refreshPhotoContentView(mImageselectList);
        } else if (dateFalg == 2 || dateFalg == 3) {
            reportContentModifyBtn.setVisibility(View.GONE);
            reportContentConfirmBtn.setVisibility(View.VISIBLE);
            reportContentConfirmBtn.setText(getString(R.string.save_btn_txt));
            setModifyTextColor(ContextCompat.getColor(this, R.color.common_txt_color));
            Drawable drawable = ContextCompat.getDrawable(this, R.drawable.go);
            //必须设置图片大小，否则不显示
            drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
            setModifyView(drawable);
            setRatingBar(false);
            setEditEnable(true);
            setTextSelect(this);
            setTelPhone(null);
            talentTelephoneTv.setVisibility(View.GONE);
            talentTelephoneEdt.setVisibility(View.VISIBLE);
            setEditViewHint(getString(R.string.empty_etb_hint_txt));
            setTextViewHint(getString(R.string.empty_etb_hint_select_txt));
            setHomeAddressHint(getString(R.string.home_address_hint_tips));
            idImagePickerContainer.setOlnyViewMode(false);
            idImagePickerContainer.refreshPhotoContentView(mImageselectList);
        }
    }

    private int getScroeHeight() {
        int scroeHeight = 0;
        try {
            Bitmap bmp = BitmapFactory.decodeResource(this.getResources(), R.drawable.btn_star_black);
            scroeHeight = bmp.getHeight();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return scroeHeight;
    }

    private void setRatingBar(final int positon, int scroeHeight, RatingBar mRatingBar) {
        //在需要的地方设置LayoutParams  记得图片只需要初始化一次就可以了。
        if (scroeHeight != 0) {
            LinearLayout.LayoutParams llp = (LinearLayout.LayoutParams) mRatingBar.getLayoutParams();
            // 包裹内容
            llp.width = -2;
            llp.height = scroeHeight;
            mRatingBar.setLayoutParams(llp);
        }
        mRatingBar.setOnRatingBarChangeListener(new RatingBar.OnRatingBarChangeListener() {
            @Override
            public void onRatingChanged(RatingBar ratingBar, float rating, boolean fromUser) {
                scoreArray[positon] = (int) rating;
            }
        });
    }

    /**
     * 设置RatingBar是否可以点击更改
     */
    private void setRatingBar(boolean enabled) {
        talentPoolSaleAbilityRb.setIsIndicator(enabled);
        talentPoolStudyAbilityRb.setIsIndicator(enabled);
        talentPoolPositiveActiveRb.setIsIndicator(enabled);
        int scroeHeight = getScroeHeight();
        setRatingBar(0, scroeHeight, talentPoolSaleAbilityRb);
        setRatingBar(1, scroeHeight, talentPoolStudyAbilityRb);
        setRatingBar(2, scroeHeight, talentPoolPositiveActiveRb);
    }

    /**
     * 设置TextView是否可以点击选择
     */
    private void setTextSelect(View.OnClickListener l) {
        talentSexTv.setOnClickListener(l);
        talentSexTv.setOnClickListener(l);
        talentBirthdayTv.setOnClickListener(l);
        intentionShop1Tv.setOnClickListener(l);
        intentionShop2Tv.setOnClickListener(l);
        intentionShop3Tv.setOnClickListener(l);
    }

    /**
     * 是否可点击拨打电话
     */
    private void setTelPhone(View.OnClickListener l) {
        talentTelephoneTv.setOnClickListener(l);
    }

    /**
     * 设置EditView是否可以点击输入
     *
     * @param enabled true:可输入，false：不可输入
     */
    private void setEditEnable(boolean enabled) {
        talentNameEdt.setEnabled(enabled);
        talentTelephoneEdt.setEnabled(enabled);
        talentHeightEdt.setEnabled(enabled);
        homeAddressEdt.setEnabled(enabled);
    }

    private void setHomeAddressHint(String hint) {
        CharSequence mHint = TextUtils.stringOrSpannedString(hint);
        homeAddressEdt.setHint(mHint);
    }

    /**
     * 设置EditView提示文字
     *
     * @param hint 提示文字
     */
    private void setTextViewHint(String hint) {
        CharSequence mHint = TextUtils.stringOrSpannedString(hint);
        talentSexTv.setHint(mHint);
        talentBirthdayTv.setHint(mHint);
        intentionShop1Tv.setHint(mHint);
        intentionShop2Tv.setHint(mHint);
        intentionShop3Tv.setHint(mHint);
    }

    /**
     * 设置EditView提示文字
     *
     * @param hint
     */
    private void setEditViewHint(String hint) {
        CharSequence mHint = TextUtils.stringOrSpannedString(hint);
        talentNameEdt.setHint(mHint);
        talentTelephoneEdt.setHint(mHint);
        talentTelephoneTv.setHint(mHint);
        talentHeightEdt.setHint(mHint);
    }

    /**
     * 设置修改状态文字颜色
     *
     * @param color 文字颜色
     */
    protected void setModifyTextColor(int color) {
        talentNameEdt.setTextColor(color);
        talentTelephoneEdt.setTextColor(color);
        talentTelephoneTv.setTextColor(color);
        talentHeightEdt.setTextColor(color);
        talentSexTv.setTextColor(color);
        talentBirthdayTv.setTextColor(color);
        intentionShop1Tv.setTextColor(color);
        intentionShop2Tv.setTextColor(color);
        intentionShop3Tv.setTextColor(color);
        homeAddressEdt.setTextColor(color);
    }

    /**
     * 修改信息视图状态
     */
    protected void setModifyView(Drawable image) {
        talentNameEdt.setCompoundDrawables(null, null, image, null);
        talentTelephoneEdt.setCompoundDrawables(null, null, image, null);
        talentTelephoneTv.setCompoundDrawables(null, null, image, null);
        talentHeightEdt.setCompoundDrawables(null, null, image, null);
        talentSexTv.setCompoundDrawables(null, null, image, null);
        talentBirthdayTv.setCompoundDrawables(null, null, image, null);
        intentionShop1Tv.setCompoundDrawables(null, null, image, null);
        intentionShop2Tv.setCompoundDrawables(null, null, image, null);
        intentionShop3Tv.setCompoundDrawables(null, null, image, null);
    }

    @Override
    protected void initData() {
        super.initData();
        //人才库
        reportType = "TP";
        baseSelectorEntitys = new ArrayList<>();
        TalentPoolEntity baseSelectorEntity = new TalentPoolEntity();
        baseSelectorEntity.setName("家庭地址");
        baseSelectorEntitys.add(baseSelectorEntity);
    }

    /**
     * 从网络获取详情数据
     */
    public void getData() {
        getTalenId();
        if (null != talentPoolId) {
            showDialog();
            TalentPoolService.getInstance().requestFindShopTalentDetail(talentPoolId, talentFlag, TalentPoolDetailActivity.this);
        }
    }

    public void getTalenId() {
        mTalentPoolEntityDetail = (TalentPoolEntity) getIntent().getSerializableExtra("data");
        if (null != mTalentPoolEntityDetail) {
            talentPoolId = mTalentPoolEntityDetail.getId();
            dateFalg = 1;
            setViewByFlag(1);
        } else {
            dateFalg = 3;
            setViewByFlag(3);
        }
    }

    public void getTalenDataDetail(TalentPoolEntity mTalentPoolEntityDetail) {
        if (null != mTalentPoolEntityDetail) {
            talentPoolId = mTalentPoolEntityDetail.getId();
            mTalentPoolShops = mTalentPoolEntityDetail.getTalentPoolShop();
            mTalentPoolImags = mTalentPoolEntityDetail.getTalentPoolImag();
            dateFalg = 1;
            setViewByFlag(1);
            fillData(mTalentPoolEntityDetail);
        } else {
            dateFalg = 3;
            setViewByFlag(3);
        }
    }

    /**
     * 数据填充
     *
     * @param mTalentPoolEntityDetail 查询到的数据
     */
    private void fillData(TalentPoolEntity mTalentPoolEntityDetail) {
        telPhoneNumber = mTalentPoolEntityDetail.getTalentTelephone();
        talentNameEdt.setText(mTalentPoolEntityDetail.getTalentName());
        talentTelephoneEdt.setText(telPhoneNumber);
        talentTelephoneTv.setText(telPhoneNumber);
        talentSexTv.setText(mTalentPoolEntityDetail.getTalentSex());
        talentBirthdayTv.setText(mTalentPoolEntityDetail.getTalentBirthday());
        talentHeightEdt.setText(mTalentPoolEntityDetail.getTalentHeight());
        homeAddressEdt.setText(mTalentPoolEntityDetail.getHomeAddress());
        //评分数据填充
        setRatingBarView(mTalentPoolEntityDetail);
        //意向门店数据填充
        if (null != mTalentPoolEntityDetail.getTalentPoolShop() && !mTalentPoolEntityDetail.getTalentPoolShop().isEmpty()) {
            for (int i = 0; i < mTalentPoolEntityDetail.getTalentPoolShop().size(); i++) {
                TalentPoolShop mTalentPoolShop = mTalentPoolEntityDetail.getTalentPoolShop().get(i);
                if (null != mTalentPoolShop.getIntention()) {
                    if (ConstantParams.CONSTANT_PARAMS_1.equals(mTalentPoolShop.getIntention())) {
                        intentionShop1Tv.setText(mTalentPoolShop.getTalentShopName());
                        intentionShop1IdTv.setText(mTalentPoolShop.getTalentShopId());
                    }
                    if (ConstantParams.CONSTANT_PARAMS_2.equals(mTalentPoolShop.getIntention())) {
                        intentionShop2Tv.setText(mTalentPoolShop.getTalentShopName());
                        intentionShop2IdTv.setText(mTalentPoolShop.getTalentShopId());
                    }
                    if (ConstantParams.CONSTANT_PARAMS_3.equals(mTalentPoolShop.getIntention())) {
                        intentionShop3Tv.setText(mTalentPoolShop.getTalentShopName());
                        intentionShop3IdTv.setText(mTalentPoolShop.getTalentShopId());
                    }
                }
            }
        }
        //图片填充
        if (null != mTalentPoolEntityDetail.getTalentPoolImag() && !mTalentPoolEntityDetail.getTalentPoolImag().isEmpty()) {
            getImageForNet(mTalentPoolEntityDetail.getTalentPoolImag());
        }
    }

    /**
     * 加载网络图片
     */
    private void getImageForNet(List<TalentPoolImag> talentPoolImag) {
        if (!talentPoolImag.isEmpty()) {
            for (int i = 0; i < talentPoolImag.size(); i++) {
                ImageItem item1 = new ImageItem();
                item1.setImgneturl(talentPoolImag.get(i).getTalentPoolUrl());
                item1.setImagePath(talentPoolImag.get(i).getTalentPoolUrl());
                item1.setImageId(talentPoolImag.get(i).getId());
                item1.setUri(Uri.fromFile(new File(talentPoolImag.get(i).getTalentPoolUrl())));
                item1.setType(1);
                mImageselectList.add(item1);
            }
            idImagePickerContainer.refreshPhotoContentView(mImageselectList);
        }
    }

    private void setRatingBarView(TalentPoolEntity mTalentPoolEntityDetail) {
        talentPoolSaleAbilityRb.setRating(mTalentPoolEntityDetail.getSaleAbilityScore());
        talentPoolStudyAbilityRb.setRating(mTalentPoolEntityDetail.getStudyAbilityScore());
        talentPoolPositiveActiveRb.setRating(mTalentPoolEntityDetail.getPositiveActiveScore());
    }

    /**
     * 设置列表头和尾布局
     */
    @Override
    protected void setListHeadAndFootView() {
        View headerView = getLayoutInflater().inflate(R.layout.talent_pool_add_header_view, null);
        publicListViewLv.addHeaderView(headerView);
        View footView = getLayoutInflater().inflate(R.layout.talent_pool_add_footer_view, null);
        publicListViewLv.addFooterView(footView);
        super.setListHeadAndFootView();
    }

    @Override
    protected void parseHeadData() {
        super.parseHeadData();
        talentNameEdt = (EditText) findViewById(R.id.talent_name_edt);
        talentTelephoneEdt = (EditText) findViewById(R.id.talent_telephone_edt);
        talentTelephoneTv = (TextView) findViewById(R.id.talent_telephone_tv);
        talentSexTv = (TextView) findViewById(R.id.talent_sex_tv);
        talentBirthdayTv = (TextView) findViewById(R.id.talent_birthday_tv);
        talentHeightEdt = (EditText) findViewById(R.id.talent_height_edt);
        intentionShop1Tv = (TextView) findViewById(R.id.intention_shop_1_tv);
        intentionShop1IdTv = (TextView) findViewById(R.id.intention_shop_1_id_tv);
        intentionShop2IdTv = (TextView) findViewById(R.id.intention_shop_2_id_tv);
        intentionShop3IdTv = (TextView) findViewById(R.id.intention_shop_3_id_tv);
        intentionShop2Tv = (TextView) findViewById(R.id.intention_shop_2_tv);
        intentionShop3Tv = (TextView) findViewById(R.id.intention_shop_3_tv);

        setDefaultData();
        limitEditView(talentNameEdt);
        limitEditView(talentTelephoneEdt);
        limitEditView(talentHeightEdt);
    }

    private void limitEditView(final EditText editView) {
        editView.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                onAfterTextChanged(editView);
            }
        });
    }

    /**
     * 输入框限制
     *
     * @param editView 输入框控件
     */
    private void onAfterTextChanged(EditText editView) {
        if (talentNameEdt == editView) {
            String talentTeleName = editView.getText().toString();
            if (talentTeleName.length() > 10) {
                ToastUtil.show(this, "名字不能超过10个字");
            }
        } else if (talentTelephoneEdt == editView) {
            String talentTelephone = editView.getText().toString();
            //如果是修改或者提交模式，校验手机号码是否已经存在
            if (talentTelephone.length() >= 11 && (dateFalg != 1)) {
                getTalentPoolByPhone(talentTelephone);
            }
        } else if (talentHeightEdt == editView) {
            String talentHeight = editView.getText().toString();
            if (talentHeight.length() >= 4 && (dateFalg != 1)) {
                ToastUtil.show(this, "身高信息填写有误！");
            }
        } else if (homeAddressEdt == editView) {
            String talentHome = editView.getText().toString();
            if (talentHome.length() > 60) {
                ToastUtil.show(this, "家庭住址不能超过60个字");
            }
        }
    }

    private void setDefaultData() {
        talentSexTv.setText("女");
        talentBirthdayTv.setText("1980-01-01");
        talentHeightEdt.setText("160");
    }

    /**
     * /talentPool/getTalentPoolByPhone 人才库查询-手机校验
     */
    private void getTalentPoolByPhone(String telephone) {
        showDialog();
        TalentPoolService.getInstance().requestGetTalentPoolByPhone(telephone, TalentPoolDetailActivity.this);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode == SelectorBaseActivity.RESULTCODE) {
            switch (requestCode) {
                case SELECT_STORE_1:
                    getShopData(intentionShop1Tv, intentionShop1IdTv, data);
                    break;
                case SELECT_STORE_2:
                    getShopData(intentionShop2Tv, intentionShop2IdTv, data);
                    break;
                case SELECT_STORE_3:
                    getShopData(intentionShop3Tv, intentionShop3IdTv, data);
                    break;
                default:
                    break;
            }
        }
    }

    private void getShopData(TextView intentionShopTv, TextView intentionShopIdTv, Intent data) {
        try {
            String shopId = data.getStringExtra("shopId");
            String shopName = data.getStringExtra("shopName");
            if (shopName.equals(intentionShop1Tv.getText().toString()) || shopName.equals(intentionShop2Tv.getText().toString()) || shopName.equals(intentionShop3Tv.getText().toString())) {
                ToastUtil.show(this, "请选择不同的意向门店");
                intentionShopTv.setText("");
                intentionShopIdTv.setText("");
            } else {
                intentionShopTv.setText(shopName);
                intentionShopIdTv.setText(shopId);
            }
        } catch (Exception e) {
            Log.e(TAG, "onActivityResult: data.getStringExtra error ");
        }
    }

    @Override
    protected void parseFootData() {
        super.parseFootData();
        homeAddressEdt = (EditText) findViewById(R.id.home_address_edt);
        talentPoolSaleAbilityRb = (RatingBar) findViewById(R.id.talent_pool_sale_ability_rb);
        talentPoolStudyAbilityRb = (RatingBar) findViewById(R.id.talent_pool_study_ability_rb);
        talentPoolPositiveActiveRb = (RatingBar) findViewById(R.id.talent_pool_positive_active_rb);
        limitEditView(homeAddressEdt);

        if (null != talentFlag && ConstantParams.CONSTANT_PARAMS_4.equals(talentFlag)) {
            reportContentConfirmLl.setVisibility(View.GONE);
        } else {
            reportContentConfirmBtn.setText(getString(R.string.submit_btn_txt));
        }
        reportContentModifyBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (dateFalg == 1) {
                    dateFalg = 2;
                    setViewByFlag(2);
                } else if (dateFalg == 2 || dateFalg == 3) {
                    dateFalg = 1;
                    setViewByFlag(1);
                }
            }
        });
        initPictureDisplayView();
    }

    private void initPictureDisplayView() {
        idImagePickerContainer = (ImagePickerLayout) findViewById(R.id.id_image_picker_container);
        idImagePickerContainer.setTitle("上传人才图片");
        idImagePickerContainer.setTip("(最多可添加3张)");
        idImagePickerContainer.setImagePicker(this);
        idImagePickerContainer.setSizePhotoNum(3);
        idImagePickerContainer.setMaxPhotoNum(3);
        idImagePickerContainer.setmImageselectList(mImageselectList);
        idImagePickerContainer.setImagePickerView(idImagePickerContainer);
        idImagePickerContainer.setOlnyViewMode(false);
    }

    @Override
    protected void setListAdapter() {
        super.setListAdapter();
        TalentPoolBaseAdapter mAdapter = new TalentPoolBaseAdapter<TalentPoolEntity>(this, baseSelectorEntitys) {
            @Override
            public void convert(BaseViewHolder helper, TalentPoolEntity item) {
                helper.setImageResourceGone(View.GONE);
                if (!StringUtil.isNullOrEmpty(item.getName())) {
                    helper.setText1(item.getName());
                }
            }
        };
        publicListViewLv.setAdapter(mAdapter);
    }

    /**
     * talentPoolId (required) TalentPool人才库的ID query	long
     * deleteOperId (required) 删除操作人的工号 query	string
     */
    private void deleteData() {
        if (null != userInfo) {
            showDialog();
            String deleteOperId = userInfo.getStaffId();
            TalentPoolService.getInstance().requestDeleteTalentPool(talentPoolId, deleteOperId, TalentPoolDetailActivity.this);
        }
    }

    @Override
    protected void setUploadData() {
        if (dateFalg == 1) {
            //查看模式下点击确定按钮（显示为删除），删除数据
            deleteData();
        } else {
            if (talentTelephoneEdt.length() != 11 || !talentTelephoneEdt.getText().toString().startsWith("1")) {
                dismissDialog();
                ToastUtil.show(this, "手机号码填写有误，请检查！");
                return;
            }
            for (float scoreArrayvale : scoreArray) {
                if (scoreArrayvale == 0) {
                    dismissDialog();
                    ToastUtil.show(this, "请将内容填写完整！");
                    return;
                }
            }
            //设置图片
            if (mImageselectList != null && !mImageselectList.isEmpty()) {
                //先添加已上传的
                for (int i = 0; i < mImageselectList.size(); i++) {
                    //如果图片时上传过后再寻得到则存在id
                    if (1 == mImageselectList.get(i).getType()) {
                        //将已经在上传过的图片添加到url中
                        urlLists.add(mImageselectList.get(i).getImgneturl());
                    }
                }
            }
            super.setUploadData();
        }
    }

    @Override
    protected void uploadData() {
        super.uploadData();
        if (checkUploadData()) {
            if (null != mTalentPoolEntityDetail) {
                setUploadEntity(mTalentPoolEntityDetail);
            } else {
                TalentPoolEntity mTalentPoolEntity = new TalentPoolEntity();
                setUploadEntity(mTalentPoolEntity);
            }
        }
    }

    private void setUploadEntity(TalentPoolEntity mTalentPoolEntity) {
        mTalentPoolEntity.setTalentAddPersonId(userInfo.getStaffId());
        mTalentPoolEntity.setTalentBirthday(talentBirthdayTv.getText().toString());
        mTalentPoolEntity.setTalentTelephone(talentTelephoneEdt.getText().toString());
        mTalentPoolEntity.setTalentHeight(talentHeightEdt.getText().toString());
        mTalentPoolEntity.setTalentName(talentNameEdt.getText().toString());
        mTalentPoolEntity.setTalentSex(talentSexTv.getText().toString());
        mTalentPoolEntity.setHomeAddress(homeAddressEdt.getText().toString());

        mTalentPoolEntity.setSaleAbilityScore(scoreArray[0]);
        mTalentPoolEntity.setStudyAbilityScore(scoreArray[1]);
        mTalentPoolEntity.setPositiveActiveScore(scoreArray[2]);
        //设置意向门店
        if (null != mTalentPoolShops) {
            mTalentPoolShops.clear();
        }
        setIntentShop(1, intentionShop1Tv, intentionShop1IdTv);
        setIntentShop(2, intentionShop2Tv, intentionShop2IdTv);
        setIntentShop(3, intentionShop3Tv, intentionShop3IdTv);
        mTalentPoolEntity.setTalentPoolShop(mTalentPoolShops);

        //设置图片
        if (mImageselectList != null && !mImageselectList.isEmpty()) {
            mTalentPoolImags.clear();
            //再添加未上传的,未上传的先通过七牛上传得到图片地址集合piclist
            for (int i = 0; i < urlLists.size(); i++) {
                TalentPoolImag mTalentPoolImag = new TalentPoolImag();
                //如果图片时上传过后再寻得到则存在id
                if (mTalentPoolImags.size() <= 3) {
                    mTalentPoolImag.setTalentPoolUrl(urlLists.get(i));
                    mTalentPoolImags.add(mTalentPoolImag);
                }
            }
        }
        mTalentPoolEntity.setTalentPoolImag(mTalentPoolImags);

        String content = new Gson().toJson(mTalentPoolEntity);
        Log.d(TAG, content);
        TalentPoolService.getInstance().requestSaveTalentPool(content, TalentPoolDetailActivity.this);
    }

    /**
     * 设置意向门店
     *
     * @param position        位置
     * @param intentionShopTv 意向门店显示控件
     */
    private void setIntentShop(int position, TextView intentionShopTv, TextView intentionShopIdTv) {
        if (!TextUtils.isEmpty(intentionShopTv.getText().toString())) {
            TalentPoolShop mTalentPoolShop = new TalentPoolShop();
            mTalentPoolShop.setIntention(position + "");
            mTalentPoolShop.setTalentPoolId(talentPoolId);
            mTalentPoolShop.setTalentShopName(intentionShopTv.getText().toString());
            mTalentPoolShop.setTalentShopId(intentionShopIdTv.getText().toString());
            mTalentPoolShops.add(mTalentPoolShop);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.TalentPoolReport.MSG_ON_DELETE_TALENT_POOL:
                case BusinessID.TalentPoolReport.MSG_ON_SAVE_TALENT_POOL: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                            TalentPoolDetailActivity.this.finish();
                        }
                        ToastUtil.show(this, mBaseResponse.retInfo);
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                }
                break;
                case BusinessID.TalentPoolReport.MSG_ON_GET_TALENT_POOL_BY_PHONE: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        TalentPoolResultEntity mTalentPoolListEntity = new Gson().fromJson(msg, TalentPoolResultEntity.class);
                        Log.d(TAG, "mTalentPoolListEntity=" + mTalentPoolListEntity.toString());
                        if (!ConstantParams.CONSTANT_PARAMS_0.equals(mTalentPoolListEntity.retCode)) {
                            ToastUtil.show(this, mTalentPoolListEntity.retInfo);
                        } else {
                            if (null != mTalentPoolListEntity.getResult()) {
                                ToastUtil.show(this, "该人才在人才库中已存在");
                            }
                        }
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                }
                break;
                case BusinessID.TalentPoolReport.MSG_ON_FIND_SHOP_TALENT_DETAIL: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        TalentPoolListEntity mTalentPoolListEntity = new Gson().fromJson(msg, TalentPoolListEntity.class);
                        Log.d(TAG, "mTalentPoolListEntity=" + mTalentPoolListEntity.toString());
                        if (!ConstantParams.CONSTANT_PARAMS_0.equals(mTalentPoolListEntity.retCode)) {
                            ToastUtil.show(this, mTalentPoolListEntity.retInfo);
                        } else {
                            if (null != mTalentPoolListEntity.getResultList()) {
                                mTalentPoolEntityDetail = mTalentPoolListEntity.getResultList().get(0);
                                getTalenDataDetail(mTalentPoolEntityDetail);
                            }
                        }
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    private boolean checkUploadData() {
        //校验框架
        final AndroidNextInputs inputs = new AndroidNextInputs();
        inputs.add(talentNameEdt, StaticScheme.Required());
        inputs.add(talentTelephoneEdt, StaticScheme.Required());
        inputs.add(talentHeightEdt, StaticScheme.Required());
        inputs.add(talentSexTv, StaticScheme.Required());
        inputs.add(talentBirthdayTv, StaticScheme.Required());
        inputs.add(intentionShop1Tv, StaticScheme.Required());
        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            ToastUtil.show(this, "填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    public void selectorStore(int selectStore) {
        Bundle mBundle = new Bundle();
        mBundle.putLong("branchID", 508L);
        mBundle.putString("branchTitle", "选择门店");
        RouterCommonUtil.startFunctionActivityResult(this, -2, 508L, mBundle, selectStore);
    }

    private void telPhone() {
        PrefTool.setBooleanSave(this, Prefs.PRE_NOT_TO_BACKGROUD, true);
        Uri telUri = Uri.parse("tel:" + telPhoneNumber);
        Intent dial = new Intent(Intent.ACTION_DIAL, telUri);
        startActivity(dial);
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.intention_shop_1_tv) {
            selectorStore(SELECT_STORE_1);
        } else if (v.getId() == R.id.intention_shop_2_tv) {
            selectorStore(SELECT_STORE_2);
        } else if (v.getId() == R.id.intention_shop_3_tv) {
            selectorStore(SELECT_STORE_3);
        } else if (v.getId() == R.id.talent_birthday_tv) {
            DialogHelper.AlertDatePicker(this, this, talentBirthdayTv);
        } else if (v.getId() == R.id.talent_sex_tv) {
            if (null == mPublicSelectPop) {
                List<BaseSelectorEntity> mSex = new ArrayList<>();
                BaseSelectorEntity baseSelectorEntity1 = new BaseSelectorEntity();
                baseSelectorEntity1.setSelectorName("男");
                BaseSelectorEntity baseSelectorEntity2 = new BaseSelectorEntity();
                baseSelectorEntity2.setSelectorName("女");
                mSex.add(baseSelectorEntity1);
                mSex.add(baseSelectorEntity2);
                mPublicSelectPop = new PublicSelectPop(TalentPoolDetailActivity.this, TalentPoolDetailActivity.this, mSex);
            }
            if (!mPublicSelectPop.isShowing()) {
                mPublicSelectPop.show(this.findViewById(R.id.title));
            }
        } else if (v.getId() == R.id.talent_telephone_tv) {
            telPhone();
        }
    }

    @Override
    public void onAdapterItemClick(int position, List<BaseSelectorEntity> reportQuerys) {
        talentSexTv.setText(reportQuerys.get(position).getSelectorName());
    }

    @Override
    public void setSelectDialog(int selectType,View imagePickerView) {
        if (dateFalg == 1) {
            ToastUtil.show(this, "查询状态，不可修改图片哟！");
        } else {
            idImagePickerContainer = (ImagePickerLayout) imagePickerView;
            setSelectDialogListeners(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    //拍照处理
                    takePhoto(idImagePickerContainer);
                    hideSelectDialog();
                }
            }, new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    //相片处理
                    getPictrue(idImagePickerContainer);
                    hideSelectDialog();
                }
            }, new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    hideSelectDialog();
                }
            });
            showSelectDialog("选择图片", null, "相机拍照", "本地相册", "取消");
        }
    }

    @Override
    public void toPhotoPreview(int index, ArrayList<ImageItem> mImageselectList) {
        toPhotoPreviewFragment(index, mImageselectList);//大图显示
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, Params.TAKE_PICTURE);
    }
}