package com.wgmf.yxgj.bussiness.talentpool.ui;

import android.content.Intent;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.bussiness.talentpool.R;
import com.wgmf.yxgj.bussiness.talentpool.model.TalentPoolEntity;
import com.wgmf.yxgj.bussiness.talentpool.model.TalentPoolListEntity;
import com.wgmf.yxgj.bussiness.talentpool.service.TalentPoolService;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;

/**
 * 人才库：人才列表（第二页）
 * 作者：xiep on 2017/12/13 17:10
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")
public class TalentPoolPeopleActivity extends TalentPoolBaseActivity {

    private String talentFlag = "1";
    private String shopId;
    private String shopName;

    @Override
    protected void onResume() {
        super.onResume();
        //正常人才库
        getData(talentFlag);
    }

    private void getData(String talentFlag) {
        if (null != userInfo) {
            showDialog();
            shopId = getIntent().getStringExtra("shopId");
            TalentPoolService.getInstance().requestFindShopTalent(shopId, talentFlag, TalentPoolPeopleActivity.this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        talentFlag = getIntent().getStringExtra("talentFlag");
        if (null != talentFlag && ConstantParams.CONSTANT_PARAMS_4.equals(talentFlag)) {
            homeTitleText.setText(getString(R.string.delete_person));
        } else {
            shopName = getIntent().getStringExtra("shopName");
            homeTitleText.setText(shopName + "人才库");
        }
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void addHeaderOrFooterView() {
        super.addHeaderOrFooterView();
        baseListItem1.setText(getString(R.string.person_name));
        baseListItem2.setText(getString(R.string.person_rating));
        baseListItem2.setVisibility(View.VISIBLE);
        baseListItem3.setText(getString(R.string.person_intention));
        baseListItem4.setText(getString(R.string.last_update_time));
    }

    @Override
    protected void addComfirmView() {
        super.addComfirmView();
        if (null != talentFlag && talentFlag.equals(ConstantParams.CONSTANT_PARAMS_4)) {
            reportContentComfirmLl.setVisibility(View.GONE);
        } else {
            reportContentComfirmLl.setVisibility(View.VISIBLE);
            reportContentModifyBtn.setText(getString(R.string.delete_person));
            reportContentModifyBtn.setVisibility(View.VISIBLE);
            reportContentModifyBtn.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    //标志置1，返回时查询正常库
                    talentFlag = "1";
                    Intent intent = new Intent();
                    intent.putExtra("shopId", shopId);
                    intent.putExtra("shopName", shopName);
                    intent.putExtra("talentFlag", ConstantParams.CONSTANT_PARAMS_4);
                    intent.setClass(TalentPoolPeopleActivity.this, TalentPoolPeopleActivity.class);
                    startActivity(intent);
                }
            });
        }
    }

    @Override
    public void initContent() {
        super.initContent();
        mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                toActivity(position, TalentPoolDetailActivity.class);
            }
        });
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.TalentPoolReport.MSG_ON_FIND_SHOP_TALENT) {
                getShopTenlent(result);
            }
        }
    }

    private void getShopTenlent(ResultData result) {
        final String msg = result.getInfo();
        if (result.isSuccessed()) {
            TalentPoolListEntity mTalentPoolListEntity = new Gson().fromJson(msg, TalentPoolListEntity.class);
            Log.d(TAG, "mTalentPoolListEntity=" + mTalentPoolListEntity.toString());
            if (!ConstantParams.CONSTANT_PARAMS_0.equals(mTalentPoolListEntity.retCode)) {
                showMsg(mTalentPoolListEntity.retInfo);
            } else {
                if (null != mTalentPoolListEntity.getResultList() && !mTalentPoolListEntity.getResultList().isEmpty()) {
                    listShow.clear();
                    for (TalentPoolEntity mTalentPoolShopEntity : mTalentPoolListEntity.getResultList()) {
                        //姓名
                        mTalentPoolShopEntity.setName(mTalentPoolShopEntity.getTalentName());
                        //最后更新时间
                        mTalentPoolShopEntity.setNumber(mTalentPoolShopEntity.getTalentUpdateTime().substring(0, mTalentPoolShopEntity.getTalentUpdateTime().lastIndexOf(" ")));
                        listShow.add(mTalentPoolShopEntity);
                    }
                    mAdapter.notifyDataSetChanged();
                    search();
                }
            }
        }
    }

    private void toActivity(int position, Class<?> cls) {
        if (position > 0) {
            Intent intent = new Intent();
            intent.setClass(this, cls);
            intent.putExtra("talentFlag", talentFlag);
            intent.putExtra("data", listShow.get(position - 1));
            startActivity(intent);
            TalentPoolPeopleActivity.this.finish();
        }
    }
}