package com.wgmf.yxgj.bussiness.talentpool.ui;

import android.content.Intent;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.bussiness.talentpool.R;
import com.wgmf.yxgj.bussiness.talentpool.model.TalentPoolEntity;
import com.wgmf.yxgj.bussiness.talentpool.model.TalentPoolListEntity;
import com.wgmf.yxgj.bussiness.talentpool.service.TalentPoolService;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.xp.arouter.RouterParams;

/**
 * 人才库：门店列表（第一页）
 * 作者：xiep on 2017/12/13 17:10
 * 邮箱：2975837870@qq.com
 */
@Route(path = RouterParams.URL_TALENTPOOLSHOPACTIVITY)
public class TalentPoolShopActivity extends TalentPoolBaseActivity {

    @Override
    protected void onResume() {
        super.onResume();
        getData();
    }

    private void getData() {
        if (null != userInfo) {
            showDialog();
            String orgId = userInfo.getOrganizationId();
            TalentPoolService.getInstance().requestFindOrgTalentNum(orgId, TalentPoolShopActivity.this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("人才库");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    public void initContent() {
        super.initContent();
        mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                toActivity(position, TalentPoolPeopleActivity.class);
            }
        });
    }

    @Override
    protected void addHeaderOrFooterView() {
        super.addHeaderOrFooterView();
        baseListItem1.setText(getString(R.string.shop_name));
        baseListItem4.setText(getString(R.string.shop_person));
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.TalentPoolReport.MSG_ON_FIND_ORG_TALENT_NUM) {
                findOrgNum(result);
            }
        }
    }

    private void findOrgNum(ResultData result) {
        final String msg = result.getInfo();
        if (result.isSuccessed()) {
            try {
                TalentPoolListEntity mTalentPoolShopListEntity = new Gson().fromJson(msg, TalentPoolListEntity.class);
                Log.d(TAG, "mTalentPoolShopListEntity=" + mTalentPoolShopListEntity.toString());
                if (!ConstantParams.CONSTANT_PARAMS_0.equals(mTalentPoolShopListEntity.retCode)) {
                    showMsg(mTalentPoolShopListEntity.retInfo);
                } else {
                    if (null != mTalentPoolShopListEntity.getResultList() && !mTalentPoolShopListEntity.getResultList().isEmpty()) {
                        listShow.clear();
                        for (TalentPoolEntity mTalentPoolShopEntity : mTalentPoolShopListEntity.getResultList()) {
                            mTalentPoolShopEntity.setName(mTalentPoolShopEntity.getTalentPoolShopName());
                            mTalentPoolShopEntity.setNumber(mTalentPoolShopEntity.getTalentNum());
                            listShow.add(mTalentPoolShopEntity);
                        }
                        mAdapter.notifyDataSetChanged();
                        search();
                    }
                }
            } catch (Exception e) {
                showMsg(getString(R.string.request_data_fail));
            }
        } else {
            if (!TextUtils.isEmpty(msg)) {
                showMsg(result.getResultInfo());
            }
        }
    }

    private void toActivity(int position, Class<?> cls) {
        if (position > 0) {
            Intent intent = new Intent();
            intent.setClass(this, cls);
            intent.putExtra("shopName", listShow.get(position - 1).getTalentPoolShopName());
            intent.putExtra("shopId", listShow.get(position - 1).getTalentPoolShopId());
            intent.putExtra("talentFlag", "1");
            startActivity(intent);
        }
    }
}