package com.wgmf.yxgj.bussiness.terminaldisplay.ui;

import android.content.Context;
import android.net.Uri;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.bussiness.terminaldisplay.R;
import com.wgmf.yxgj.bussiness.terminaldisplay.model.ExhibitSubmit;
import com.wgmf.yxgj.bussiness.terminaldisplay.service.DataTransform;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

/**
 * 作者：xiep on 2020/6/29 9:29
 * 邮箱：2975837870@qq.com
 */
class TerminalDisplayDetailAdapter extends BaseAdapter implements ImagePickerLayout.ImagePicker {

    private LayoutInflater inflater;
    private LvListener lvListener;
    private List<ExhibitSubmit> mSubmitList;

    TerminalDisplayDetailAdapter(List<ExhibitSubmit> mSubmitList, Context context, LvListener lvListener) {
        this.inflater = LayoutInflater.from(context);
        this.lvListener = lvListener;
        this.mSubmitList = mSubmitList;

        // 初始化图片数据
        for (int j=0;j<mSubmitList.size();j++){
            ArrayList<ImageItem> mImageselectList=new ArrayList<>();
            List<String> imgs= mSubmitList.get(j).getUrls();
            if (null!=imgs&&!imgs.isEmpty()) {
                for (int i = 0; i < imgs.size(); i++) {
                    ImageItem item1 = new ImageItem();
                    item1.setImgneturl(imgs.get(i));
                    item1.setImagePath(imgs.get(i));
                    item1.setImageId(i+"");
                    item1.setUri(Uri.fromFile(new File(imgs.get(i))));
                    item1.setType(1);
                    mImageselectList.add(item1);
                }
            }
            mSubmitList.get(j).setStoreImageselectList(mImageselectList);
        }
    }

    @Override
    public void setSelectDialog(int selectType, View view) {
        lvListener.setSelectDialog(selectType, view);
    }

    @Override
    public void toPhotoPreview(int i, ArrayList<ImageItem> arrayList) {
        lvListener.toPhotoPreview(i, arrayList);
    }

    interface LvListener {
        void setSelectDialog(int selectType, View view);

        void toPhotoPreview(int i, ArrayList<ImageItem> arrayList);
    }

    void refreshAfterTakePicture(ArrayList<ImageItem> mImageselectList, ImagePickerLayout idImagePickerContainer) {
        int position = (int) idImagePickerContainer.getTag();
        //在对应位置图片集合里加入拍照返回图片
        mSubmitList.get(position).setStoreImageselectList(mImageselectList);
    }

    @Override
    public int getCount() {
        return mSubmitList.size();
    }

    @Override
    public Object getItem(int position) {
        return mSubmitList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ExhibitSubmit mSubmit = mSubmitList.get(position);
        final ViewHolder holder;
        convertView = null;
        if (convertView == null) {
            convertView = inflater.inflate(R.layout.list_item_terminal_display_view, null);
            holder = new ViewHolder(convertView);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        holder.reportName.setText(mSubmit.getMissionName());
        holder.reportSubmitTime.setText(mSubmit.getUpdateTime());
        holder.reportTime.setText(null==mSubmit.getMissionRemark()?mSubmit.getEndTime():mSubmit.getMissionRemark());
        holder.reportStaffName.setText(mSubmit.getUserName());
        holder.reportStaffId.setText(mSubmit.getUserNo());
        holder.reportStatus.setText(DataTransform.getShopStatus(mSubmit.getShopStatus()));
        holder.reportRateItemTip.setText(mSubmit.getRemark());

        holder.idImagePickerContainerImg.setmImageselectList(mSubmit.getStoreImageselectList());
        holder.idImagePickerContainerImg.setImagePickerView(holder.idImagePickerContainerImg);
        holder.idImagePickerContainerImg.refreshPhotoContentView(mSubmit.getStoreImageselectList());
        holder.idImagePickerContainerImg.setTag(position);
        return convertView;
    }

    class ViewHolder {
        TextView reportName;
        TextView reportTime;
        TextView reportSubmitTime;
        TextView reportStaffName;
        TextView reportStaffId;
        TextView reportStatus;
        TextView reportRateItemTip;
        ImagePickerLayout idImagePickerContainerImg;

        ViewHolder(View convertView) {
            reportName = (TextView) convertView.findViewById(R.id.report_name);
            reportTime = (TextView) convertView.findViewById(R.id.report_time);
            reportSubmitTime = (TextView) convertView.findViewById(R.id.report_submit_time);
            reportStaffName = (TextView) convertView.findViewById(R.id.report_staff_name);
            reportStaffId = (TextView) convertView.findViewById(R.id.report_staff_id);
            reportStatus = (TextView) convertView.findViewById(R.id.report_status);
            reportRateItemTip = (TextView) convertView.findViewById(R.id.report_rate_item_tip);
            idImagePickerContainerImg = (ImagePickerLayout) convertView.findViewById(R.id.id_image_picker_container_img);
            ArrayList<ImageItem> mImageselectList = new ArrayList();
            idImagePickerContainerImg.setmImageselectList(mImageselectList);
            idImagePickerContainerImg.setTitleVisibility(View.GONE);
            idImagePickerContainerImg.setTipVisibility(View.GONE);
            idImagePickerContainerImg.setOlnyViewMode(true);
            idImagePickerContainerImg.setImagePicker(TerminalDisplayDetailAdapter.this);
            idImagePickerContainerImg.setMaxPhotoNum(8);
            idImagePickerContainerImg.setSizePhotoNum(3);
            idImagePickerContainerImg.setImagePickerView(idImagePickerContainerImg);
        }
    }
}