package com.wgmf.yxgj.bussiness.terminaldisplay.ui;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.TextUtils;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.bussiness.terminaldisplay.R;
import com.wgmf.yxgj.bussiness.terminaldisplay.model.ExhibitMissionEntity;
import com.wgmf.yxgj.bussiness.terminaldisplay.model.ExhibitMissionResultEntity;
import com.wgmf.yxgj.bussiness.terminaldisplay.model.ExhibitSubmit;
import com.wgmf.yxgj.bussiness.terminaldisplay.service.TerminalDisplayService;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.global.Params;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 作者：xiep on 2020/06/29 17:10
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")

public class TerminalDisplayEditActivity extends ReportWithPhotoBaseActivity implements ImagePickerLayout.ImagePicker {

    private String branchTitle;
    private String shopStatus;
    private String type;

    EditText reportExplainEdt;
    TextView reportName;
    TextView reportTime;
    TextView reportStaffName;
    TextView reportStaffId;
    ExhibitSubmit mSubmitList;
    ExhibitMissionEntity mExhibitMissionEntity;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        initData();
        getData();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        branchTitle = "督察陈列检查";
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void initData() {
        super.initData();
        //终端陈列
        reportType = "TD";
        shopId = getIntent().getStringExtra("shopId");
        shopName = getIntent().getStringExtra("shopName");
        type = getIntent().getStringExtra("type");
    }

    /**
     * 设置列表头和尾布局
     */
    @Override
    protected void setListHeadAndFootView() {
        View footView = getLayoutInflater().inflate(R.layout.terminal_display_add_footer_view, null);
        publicListViewLv.addFooterView(footView);
        super.setListHeadAndFootView();
    }

    @Override
    protected void parseHeadData() {
        super.parseHeadData();
    }

    @Override
    protected void parseFootData() {
        super.parseFootData();
        reportName = (TextView) findViewById(R.id.report_name);
        reportTime = (TextView) findViewById(R.id.report_time);
        reportStaffName = (TextView) findViewById(R.id.report_staff_name);
        reportStaffId = (TextView) findViewById(R.id.report_staff_id);
        reportExplainEdt = (EditText) findViewById(R.id.report_explain_edt);
        reportContentConfirmBtn.setText(getString(R.string.submit_btn_txt));
        LinearLayout reportSubmitTimeLl = (LinearLayout) findViewById(R.id.report_submit_time_ll);
        LinearLayout reportStatusLl = (LinearLayout) findViewById(R.id.report_status_ll);
        reportSubmitTimeLl.setVisibility(View.GONE);
        reportStatusLl.setVisibility(View.GONE);
        initPictureDisplayView();
    }

    private void initPictureDisplayView() {
        idImagePickerContainer = (ImagePickerLayout) findViewById(R.id.id_image_picker_container);
        idImagePickerContainer.setTitle("陈列照片:");
        idImagePickerContainer.setTip("(最多可添加8张)");
        idImagePickerContainer.setImagePicker(this);
        idImagePickerContainer.setSizePhotoNum(3);
        idImagePickerContainer.setMaxPhotoNum(8);
        idImagePickerContainer.setmImageselectList(mImageselectList);
        idImagePickerContainer.setImagePickerView(idImagePickerContainer);
        idImagePickerContainer.setOlnyViewMode(false);
    }

    @Override
    protected void setListAdapter() {
        super.setListAdapter();
        setListAdapterData();
    }

    private void setListAdapterData() {
        List<BaseSelectorEntity> mBaseSelectorEntitys = new ArrayList<>();
        BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
        mBaseSelectorEntitys.add(mBaseSelectorEntity);
        BaseCommonAdapter mAdapter = new BaseCommonAdapter<BaseSelectorEntity>(TerminalDisplayEditActivity.this, mBaseSelectorEntitys) {
            @Override
            public void convert(ViewHolder helper, BaseSelectorEntity item) {
                helper.setGravity(Gravity.CENTER);
                helper.setText(shopName);
                helper.setPadding(0, 0, 0, 0);
                helper.setTextColor(ContextCompat.getColor(TerminalDisplayEditActivity.this, R.color.black));
                helper.setBackGroud(ContextCompat.getDrawable(TerminalDisplayEditActivity.this, R.color.region_bg));
            }
        };
        publicListViewLv.setAdapter(mAdapter);
    }

    /**
     * 从网络获取详情数据
     */
    public void getData() {
        showDialog();
        TerminalDisplayService.getInstance().queryMissionByStoreNo(shopId, TerminalDisplayEditActivity.this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.TerminalDisplay.MSG_ON_ADD_SUBMITION:
                case BusinessID.TerminalDisplay.MSG_ON_UPDATE_SUBMITION: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.msgCode)) {
                            TerminalDisplayEditActivity.this.finish();
                        } else {
                            //提交出错清空图片数据
                            urlLists.clear();
                            qiniuUrlLists.clear();
                        }
                        ToastUtil.show(this, mBaseResponse.retInfo);
                    } else {
                        //提交出错清空图片数据
                        urlLists.clear();
                        qiniuUrlLists.clear();
                        ToastUtil.show(this, result.getResultInfo());
                    }
                }
                break;
                case BusinessID.TerminalDisplay.MSG_ON_QUERY_MISSION_BY_STORENO: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        ExhibitMissionResultEntity mExhibitMissionResultEntity = new Gson().fromJson(msg, ExhibitMissionResultEntity.class);
                        Log.d(TAG, "mExhibitMissionResultEntity=" + mExhibitMissionResultEntity.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mExhibitMissionResultEntity.msgCode)) {
                            if (null != mExhibitMissionResultEntity.getResult()) {
                                mExhibitMissionEntity = mExhibitMissionResultEntity.getResult();
                                if (null == mExhibitMissionResultEntity.getResult().getSubmitList() || mExhibitMissionResultEntity.getResult().getSubmitList().isEmpty()) {
                                    // 新增一条空数据
                                    List<ExhibitSubmit> submitList = new ArrayList<>();
                                    ExhibitSubmit mExhibitSubmit = new ExhibitSubmit();
                                    mExhibitSubmit.setShopStatus(ConstantParams.CONSTANT_PARAMS_1);
                                    mExhibitSubmit.setMissionName(mExhibitMissionResultEntity.getResult().getMissionName());
                                    mExhibitSubmit.setEndTime(mExhibitMissionResultEntity.getResult().getEndTime());
                                    mExhibitSubmit.setUserName(userInfo.getName());
                                    mExhibitSubmit.setUserNo(userInfo.getStaffId());
                                    mExhibitSubmit.setShopId(shopId);
                                    mExhibitSubmit.setShopName(shopName);
                                    mExhibitMissionEntity.setStoreNo(shopId);
                                    mExhibitMissionEntity.setStoreName(shopName);
                                    submitList.add(mExhibitSubmit);
                                    mExhibitMissionResultEntity.getResult().setSubmitList(submitList);
                                }
                                setData(mExhibitMissionResultEntity.getResult());
                            }
                        } else {
                            ToastUtil.show(this, result.getResultInfo());
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    public ExhibitSubmit selectLastOne(List<ExhibitSubmit> list) {
        ExhibitSubmit card = new ExhibitSubmit();

        Long dates[] = new Long[list.size()];
        for (int i = 0; i < list.size(); i++) {
            // 把date类型的时间对象转换为long类型，时间越往后，long的值就越大，
            // 所以就依靠这个原理来判断距离现在最近的时间
            Date date = DateUtil.String2Date(list.get(i).getUpdateTime(), "yyyy-MM-dd HH:mm:ss");
            dates[i] = date.getTime();
        }
        Long maxIndex = dates[0];// 定义最大值为该数组的第一个数
        for (int j = 0; j < dates.length; j++) {
            if (maxIndex < dates[j]) {
                maxIndex = dates[j];
                // 找到了这个j
                card = list.get(j);
            }
        }
        return card;
    }

    private void setData(ExhibitMissionEntity mExhibitMissionEntity) {
        if (null != mExhibitMissionEntity.getSubmitList() && !mExhibitMissionEntity.getSubmitList().isEmpty()) {
            if (mExhibitMissionEntity.getSubmitList().size() > 1) {
                mSubmitList = selectLastOne(mExhibitMissionEntity.getSubmitList());
            } else {
                mSubmitList = mExhibitMissionEntity.getSubmitList().get(0);
            }
            mSubmitList.setDetailId(mExhibitMissionEntity.getDetailId());
            shopStatus = mSubmitList.getShopStatus();
            reportName.setText(mSubmitList.getMissionName());
            reportTime.setText(null == mExhibitMissionEntity.getMissionRemark() ? mExhibitMissionEntity.getEndTime() : mExhibitMissionEntity.getMissionRemark());
            reportStaffName.setText(mSubmitList.getUserName());
            reportStaffId.setText(mSubmitList.getUserNo());

            if (!TextUtils.isEmpty(type) && type.equals("1")) {//修改需填充数据，新增不需要填充数据
                reportExplainEdt.setText(mSubmitList.getRemark());
                List<String> imgs = mSubmitList.getUrls();
                if (null != imgs && !imgs.isEmpty()) {
                    for (int i = 0; i < imgs.size(); i++) {
                        ImageItem item1 = new ImageItem();
                        item1.setImgneturl(imgs.get(i));
                        item1.setImagePath(imgs.get(i));
                        item1.setImageId(i + "");
                        item1.setUri(Uri.fromFile(new File(imgs.get(i))));
                        item1.setType(1);
                        mImageselectList.add(item1);
                    }
                }
                mSubmitList.setStoreImageselectList(mImageselectList);
                idImagePickerContainer.refreshPhotoContentView(mImageselectList);
            }
        }
    }

    @Override
    protected void setUploadData() {
        if (TextUtils.isEmpty(reportExplainEdt.getText().toString()) && idImagePickerContainer.getmImageselectList().isEmpty()) {
            dismissDialog();
            ToastUtil.show(this, "照片和备注不能同时为空");
            return;
        }
        super.setUploadData();
    }

    @Override
    protected void uploadData() {
        super.uploadData();
        setUploadEntity();
    }

    private void setUploadEntity() {
        if (mImageselectList != null && !mImageselectList.isEmpty()) {
            //先添加已上传的
            for (int i = 0; i < mImageselectList.size(); i++) {
                //如果图片时上传过后再寻得到则存在id
                if (1 == mImageselectList.get(i).getType()) {
                    //将已经在上传过的图片添加到url中
                    urlLists.add(mImageselectList.get(i).getImgneturl());
                }
            }
        }
        String submitUrl = "";
        if (null != urlLists & !urlLists.isEmpty()) {
            for (int i = 0; i < urlLists.size(); i++) {
                if (i < urlLists.size() - 1) {
                    submitUrl += urlLists.get(i) + ",";
                } else {
                    submitUrl += urlLists.get(i);
                }
            }
        }
        String detailId = mSubmitList.getDetailId();
        String submitId = mSubmitList.getSubmitId();
        String userNo = userInfo.getStaffId();
        String userName = userInfo.getName();
        String remark = reportExplainEdt.getText().toString();
        // shopStatus (integer, optional):门店状态, 1待提交、2待审核可修改、3已审核可整改、4可再次整改、5免提交、6已截止 ,
        if (ConstantParams.CONSTANT_PARAMS_2.equals(shopStatus) || ConstantParams.CONSTANT_PARAMS_4.equals(shopStatus)) {
            TerminalDisplayService.getInstance().postUpdateSubmition(submitId, userNo
                    , userName, remark, submitUrl, TerminalDisplayEditActivity.this);
        } else {
            TerminalDisplayService.getInstance().postAddSubmition(detailId, userNo
                    , userName, remark, submitUrl, TerminalDisplayEditActivity.this);
        }
    }

    @Override
    public void setSelectDialog(int selectType, View imagePickerView) {
        {
            idImagePickerContainer = (ImagePickerLayout) imagePickerView;
            setSelectDialogListeners(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    //拍照处理
                    takePhoto(idImagePickerContainer);
                    hideSelectDialog();
                }
            }, new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    //相片处理
                    getPictrue(idImagePickerContainer);
                    hideSelectDialog();
                }
            }, new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    hideSelectDialog();
                }
            });
            showSelectDialog("选择图片", null, "相机拍照", "本地相册", "取消");
        }
    }

    @Override
    public void toPhotoPreview(int index, ArrayList<ImageItem> mImageselectList) {
        toPhotoPreviewFragment(index, mImageselectList);//大图显示
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, Params.TAKE_PICTURE);
    }
}
