package com.wgmf.yxgj.bussiness.terminaldisplay.ui;

import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.bussiness.terminaldisplay.R;
import com.wgmf.yxgj.bussiness.terminaldisplay.model.TerminalDisplayBean;
import com.wgmf.yxgj.bussiness.terminaldisplay.model.TerminalDisplayBeanResult;
import com.wgmf.yxgj.bussiness.terminaldisplay.service.DataTransform;
import com.wgmf.yxgj.bussiness.terminaldisplay.service.TerminalDisplayService;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.publics.ui.ReportTypeAdapter;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * 终端陈列整改门店列表
 */
@Route(path = RouterParams.URL_TERMINAL_DISPLAY_SHOP_ACTIVITY)
public class TerminalDisplayShopActivity extends BaseParentAct implements View.OnClickListener{
    private static final String TYPE = "TYPE";//陈列类型包括：全部、活动、常规，默认选中全部。
    private static final String STATUS = "STATUS";//门店状态包括：待上传、待审核可修改、已审核可整改、可再次整改、已截止、免提交。
    private List<String> stringArray;
    protected ListView mListView;
    protected TerminalDisplayShopAdapter mAdapter;
    protected List<TerminalDisplayBean> mListStore = new ArrayList<>();
    protected List<TerminalDisplayBean> listShow = new ArrayList<>();
    protected ClearEditText storeNameEt;
    protected TextView reportDetailTitle;
    protected TextView reportDetailDate;
    protected String branchTitle;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_terminal_display_shop);
        initTitle();
        initContent();
        setListener();
    }

    @Override
    protected void onResume() {
        super.onResume();
        getShopList();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    protected void initContent() {
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        storeNameEt = (ClearEditText) findViewById(R.id.store_name_et);
        reportDetailTitle = (TextView) findViewById(R.id.report_detail_title);
        reportDetailDate = (TextView) findViewById(R.id.report_detail_date);
        storeNameEt.setVisibility(View.VISIBLE);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        mAdapter = new TerminalDisplayShopAdapter(this,listShow);
        mListView.setAdapter(mAdapter);
        reportDetailTitle.setOnClickListener(this);
        reportDetailDate.setOnClickListener(this);
    }

    protected void setListener() {
        storeNameEt.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                dataFiltering();
            }
        });
    }

    public void dataFiltering() {
        String keyWord = storeNameEt.getText().toString().trim();
        String reportType = DataTransform.getMissionTypeString(reportDetailTitle.getText().toString().trim());
        String reportStatus = DataTransform.getMissionStatusString(reportDetailDate.getText().toString().trim());
        if (null == listShow) {
            listShow = new ArrayList<>();
        }
        if (null != mListStore) {
            listShow.clear();
            if (TextUtils.isEmpty(keyWord) && reportType.equals( ConstantParams.CONSTANT_PARAMS_0) && reportStatus.equals( ConstantParams.CONSTANT_PARAMS_0)) {
                listShow.addAll(mListStore);
            } else {
                for (TerminalDisplayBean p : mListStore) {
                        if (!TextUtils.isEmpty(keyWord)) {
                            if (reportType.equals(ConstantParams.CONSTANT_PARAMS_0) && !reportStatus.equals(ConstantParams.CONSTANT_PARAMS_0)) {
                                if (!TextUtils.isEmpty(p.getShopStatus())) {
                                    if (p.getShopName().contains(keyWord) && p.getShopStatus().contains(reportStatus)) {
                                        listShow.add(p);
                                    }
                                }
                            } else if (!reportType.equals(ConstantParams.CONSTANT_PARAMS_0) && reportStatus.equals(ConstantParams.CONSTANT_PARAMS_0)) {
                                if (!TextUtils.isEmpty(p.getMissionType())) {
                                    if (p.getShopName().contains(keyWord) && p.getMissionType().contains(reportType)) {
                                        listShow.add(p);
                                    }
                                }
                            } else {
                                if (!TextUtils.isEmpty(p.getShopStatus())&&!TextUtils.isEmpty(p.getMissionType())) {
                                    if (p.getMissionType().contains(reportType) && p.getShopStatus().contains(reportStatus) && p.getShopName().contains(keyWord)) {
                                        listShow.add(p);
                                    }
                                }else{
                                    if (p.getShopName().contains(keyWord)) {
                                        listShow.add(p);
                                    }
                                }
                            }
                        } else {
                            if (reportType.equals(ConstantParams.CONSTANT_PARAMS_0) && !reportStatus.equals(ConstantParams.CONSTANT_PARAMS_0)) {
                                if (!TextUtils.isEmpty(p.getShopStatus())) {
                                    if (p.getShopStatus().contains(reportStatus)) {
                                        listShow.add(p);
                                    }
                                }
                            } else if (!reportType.equals(ConstantParams.CONSTANT_PARAMS_0) && reportStatus.equals(ConstantParams.CONSTANT_PARAMS_0)) {
                                if (!TextUtils.isEmpty(p.getMissionType())) {
                                    if (p.getMissionType().contains(reportType)) {
                                        listShow.add(p);
                                    }
                                }
                            } else {
                                if (!TextUtils.isEmpty(p.getShopStatus())&&!TextUtils.isEmpty(p.getMissionType())) {
                                    if (p.getMissionType().contains(reportType) && p.getShopStatus().contains(reportStatus)) {
                                        listShow.add(p);
                                    }
                                }
                            }
                        }
                }
            }
            if (null != mAdapter) {
                mAdapter.notifyDataSetChanged();
            }
        }
    }

    private void getShopList() {
        if (null != userInfo) {
            showDialog();
            String orgId = userInfo.getOrganizationId();
            TerminalDisplayService.getInstance().requestFindTerminalDisShop(orgId, TerminalDisplayShopActivity.this);
        }
    }

    protected void search() {
        if (null != listShow && null != mListStore && null != mAdapter) {
            mListStore.clear();
            mListStore.addAll(listShow);
            mAdapter.notifyDataSetChanged();
        }
    }

    public void showPopType(final String type) {
        View v = getLayoutInflater().inflate(R.layout.report_type_popupwindow, null);
        final ListView listview = (ListView) v.findViewById(R.id.report_type_listview);
        View view1 = v.findViewById(R.id.report_type_cancel);
        final PopupWindow pw1 = new PopupWindow(v, WindowManager.LayoutParams.MATCH_PARENT,
                WindowManager.LayoutParams.MATCH_PARENT, true);
        pw1.setFocusable(true);
        pw1.setBackgroundDrawable(new BitmapDrawable());
        pw1.showAtLocation(this.findViewById(R.id.title), Gravity.BOTTOM, 0, 0);
        view1.setOnClickListener(this);

        if (TYPE.equals(type)) {
            stringArray = Arrays.asList(getResources().getStringArray(R.array.type));
        } else if (STATUS.equals(type)) {
            stringArray = Arrays.asList(getResources().getStringArray(R.array.status));
        }
        stringArray = new ArrayList<>(stringArray);
        final ReportTypeAdapter reportTypeAdapter = new ReportTypeAdapter(stringArray, this);
        listview.setAdapter(reportTypeAdapter);
        ListViewUtil.setListViewHeight(listview);
        listview.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                if (TYPE.equals(type)) {
                    reportDetailTitle.setText(stringArray.get(position));
                    //过滤陈列类型
                    dataFiltering();
                } else if (STATUS.equals(type)) {
                    reportDetailDate.setText(stringArray.get(position));
                    //过滤门店状态
                    dataFiltering();
                }
                pw1.dismiss();
            }
        });
    }
    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.TerminalDisplay.MSG_ON_FIND_TERMINAL_DISSHOP: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        TerminalDisplayBeanResult terminalDisplayBeanResult = new Gson().fromJson(msg, TerminalDisplayBeanResult.class);
                        Log.d(TAG, "terminalDisplayBeanResult=" + terminalDisplayBeanResult.toString());
                        if (null!=terminalDisplayBeanResult.getResult()&&!terminalDisplayBeanResult.getResult().isEmpty()) {
                            listShow=terminalDisplayBeanResult.getResult();
                            mAdapter = new TerminalDisplayShopAdapter(this,listShow);
                            mListView.setAdapter(mAdapter);
                            search();
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    @Override
    public void onClick(View v) {
        if(v.getId()==R.id.report_detail_title){
            showPopType(TYPE);
        }else if(v.getId()==R.id.report_detail_date){
            showPopType(STATUS);
        }
    }
}