package com.wgmf.library.base;

import com.squareup.okhttp.OkHttpClient;
import com.wgmf.library.utils.BaseSingleton;
import com.wgmf.library.utils.HttpsTrustManager;

/**
 * HttpClient封装
 *
 * @author xiep on 2016/5/13.
 */
public class BaseHttpClient extends OkHttpClient {

    private static BaseSingleton<BaseHttpClient, Void> sClient = new BaseSingleton<BaseHttpClient, Void>() {
        @Override
        protected BaseHttpClient create(Void var1) {
            return new BaseHttpClient();
        }
    };

    public static BaseHttpClient getInstance() {
        BaseHttpClient httpClient = sClient.get(null);
        httpClient.setSslSocketFactory(HttpsTrustManager.createSSLSocketFactory());
        httpClient.setHostnameVerifier(new HttpsTrustManager.TrustAllHostnameVerifier());
        return httpClient;
    }

    private BaseHttpClient() {
    }
}