package com.wgmf.library.utils;

import android.content.Context;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.util.Log;

/**
 * @author xiep
 */
@SuppressWarnings("all")
public class AppUtils {
    /**
     * 获取当前版本号
     *
     * @param context
     * @return
     */
    public static int getVersionCode(Context context) {
        try {
            PackageManager manager = context.getPackageManager();
            PackageInfo info = manager.getPackageInfo(context.getPackageName(),
                    0);
            return info.versionCode;
        } catch (Exception e) {
            return 1;
        }
    }

    /**
     * 获取当前版本名称
     *
     * @param context
     * @return
     */
    public static String getVersion(Context context) {
        String versionName = null;
        try {
            PackageInfo info;
            info = context.getPackageManager().getPackageInfo(
                    context.getPackageName(), 0);
            versionName = info.versionName;
        } catch (PackageManager.NameNotFoundException e) {
            Log.d("AppUtils:", "getVersion:" + e);
        }
        return versionName;
    }
}