package com.wgmf.library.utils;

/**
 * 单例模式，T为类，P为传参
 *
 * @author xiep  on 2016/5/13.
 */
@SuppressWarnings("all")
public abstract class BaseSingleton<T, P> {
    private volatile T mInstance;

    public BaseSingleton() {

    }

    protected abstract T create(P var1);

    public final T get(P p) {
        if (this.mInstance == null) {
            synchronized (this) {
                if (this.mInstance == null) {
                    this.mInstance = this.create(null);
                }
            }
        }
        return this.mInstance;
    }
}