package com.wgmf.library.utils;

import android.content.Context;
import android.os.Environment;

import com.wgmf.library.utils.tools.DeviceHelper;

import android.util.Log;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;

@SuppressWarnings("all")
public class Files {

    private static String photoPath = "mnt/sdcard/yxgj/photo/";
    private static String userfile = "mnt/sdcard/yxgj/user/";
    private static String logfile = "mnt/sdcard/yxgj/log/";
    private static String picturefile = "mnt/sdcard/yxgj/pictures/";
    private static String errfile = "mnt/sdcard/yxgj/err/";
    public static String downfile = "mnt/sdcard/yxgj/upg/";
    private static String audiofile = "mnt/sdcard/yxgj/audio/";


    public static String getPhotoPath() {
        return photoPath;
    }

    public static void setPhotoPath(String photoPath) {
        Files.photoPath = photoPath;
    }

    public static String getUserfile() {
        return userfile;
    }

    public static void setUserfile(String userfile) {
        Files.userfile = userfile;
    }

    public static String getLogfile() {
        return logfile;
    }

    public static void setLogfile(String logfile) {
        Files.logfile = logfile;
    }

    public static String getPicturefile() {
        return picturefile;
    }

    public static void setPicturefile(String picturefile) {
        Files.picturefile = picturefile;
    }

    public static String getErrfile() {
        return errfile;
    }

    public static void setErrfile(String errfile) {
        Files.errfile = errfile;
    }

    public static String getDownfile() {
        return downfile;
    }

    public static void setDownfile(String downfile) {
        Files.downfile = downfile;
    }

    public static String getAudiofile() {
        return audiofile;
    }

    public static void setAudiofile(String audiofile) {
        Files.audiofile = audiofile;
    }

    private Files() {
    }

    public static void createFile(Context context) {
        try {
            if (!Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)) {
                String interPath = DeviceHelper.getInterPath(context);
                photoPath = interPath + "/yxgj/photo/";
                picturefile = interPath + "/yxgj/pictures/";
                userfile = interPath + "/yxgj/user/";
                logfile = interPath + "/yxgj/log/";
                errfile = interPath + "/yxgj/err/";
                downfile = interPath + "/../";
                audiofile = interPath + "/yxgj/audio/";
            } else {
                String sdcard = DeviceHelper.getSDPath();
                photoPath = sdcard + "/yxgj/photo/";
                picturefile = sdcard + "/yxgj/pictures/";
                userfile = sdcard + "/yxgj/user/";
                logfile = sdcard + "/yxgj/log/";
                errfile = sdcard + "/yxgj/err/";
                downfile = sdcard + "/yxgj/upg/";
            }
            File logfiles = new File(logfile);
            File userfiles = new File(userfile);
            File errfiles = new File(errfile);
            File pohoFiles = new File(photoPath);
            File pictureFiles = new File(picturefile);
            File audiofiles = new File(audiofile);

            if (!userfiles.exists()) {
                userfiles.mkdirs();
            }
            if (!logfiles.exists()) {
                logfiles.mkdirs();
            }
            if (!errfiles.exists()) {
                errfiles.mkdirs();
            }
            if (!pohoFiles.exists()) {
                pohoFiles.mkdirs();
            }
            if (!pictureFiles.exists()) {
                pictureFiles.mkdirs();
            }
            if (!audiofiles.exists()) {
                audiofiles.mkdirs();
            }

            String cmd0 = "chmod 777 " + userfiles.getAbsolutePath();
            String cmd1 = "chmod 777 " + logfiles.getAbsolutePath();
            String cmd2 = "chmod 777 " + errfiles.getAbsolutePath();
            String cmd3 = "chmod 777" + pohoFiles.getAbsolutePath();
            String cmd4 = "chmod 777" + pictureFiles.getAbsolutePath();
            String cmd5 = "chmod 777" + audiofiles.getAbsolutePath();

            Runtime.getRuntime().exec(cmd0);
            Runtime.getRuntime().exec(cmd1);
            Runtime.getRuntime().exec(cmd2);
            Runtime.getRuntime().exec(cmd3);
            Runtime.getRuntime().exec(cmd4);
            Runtime.getRuntime().exec(cmd5);
        } catch (Exception e) {
            Log.e("Files", ":" + "createFile" + ":" + e);
        }
    }

    /**
     * 文件缓存类
     *
     * @author Treasure
     */
    public static class FileCache {
        public static boolean copyFile(String oldPath, String newPath) {
            boolean isok = true;
            InputStream inStream = null;
            FileOutputStream fs = null;
            try {
                int bytesum = 0;
                int byteread;
                File oldfile = new File(oldPath);
                if (oldfile.exists()) {
                    //文件存在时
                    //读入原文件
                    inStream = new FileInputStream(oldPath);
                    fs = new FileOutputStream(newPath);
                    byte[] buffer = new byte[1024];
                    while ((byteread = inStream.read(buffer)) != -1) {
                        //字节数 文件大小
                        bytesum += byteread;
                        fs.write(buffer, 0, byteread);
                    }
                    fs.flush();
                } else {
                    isok = false;
                }
            } catch (Exception e) {
                isok = false;
            } finally {
                if (fs != null) {
                    try {
                        fs.close();
                    } catch (IOException e) {
                        Log.e("Files", "copyFile: ", e);
                    }
                }
                if (inStream != null) {
                    try {
                        inStream.close();
                    } catch (IOException e) {
                        Log.e("Files", "copyFile: ", e);
                    }
                }
            }
            return isok;
        }
    }
}