package com.wgmf.library.utils.tools;

import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;

/**
 * SharedPreferences操作类
 *
 * @author xiep
 */
public class PrefTool {

    /**
     * 获取配置参数 String
     */
    public static String getStringPerferences(Context context, String name) {
        SharedPreferences preferences = context.getSharedPreferences(name, Context.MODE_PRIVATE);
        synchronized (preferences) {
            return preferences.getString(name, "");
        }
    }

    /**
     * String 设置配置参数
     */
    public static void setStringsave(Context context, String name, String values) {
        SharedPreferences preferences = context.getSharedPreferences(name, Context.MODE_PRIVATE);
        Editor editor = preferences.edit();
        editor.putString(name, values);
        editor.apply();
    }

    /**
     * int,获取配置参数
     */
    public static int getIntPreferences(Context context, String name, int defValues) {
        SharedPreferences preferences = context.getSharedPreferences(name, Context.MODE_PRIVATE);
        synchronized (preferences) {
            return preferences.getInt(name, defValues);
        }
    }

    /**
     * int,设置参数
     */
    public static void setIntSave(Context context, String name, int value) {
        SharedPreferences preferences = context.getSharedPreferences(name, Context.MODE_PRIVATE);
        synchronized (preferences) {
            Editor editor = preferences.edit();
            editor.putInt(name, value);
            editor.commit();
        }
    }

    /**
     * boolean类型,获取配置参数
     */
    public static boolean getBooleanPreferences(Context context, String name, boolean defValues) {
        SharedPreferences preferences = context.getSharedPreferences(name, Context.MODE_PRIVATE);
        synchronized (preferences) {
            return preferences.getBoolean(name, defValues);
        }
    }

    /**
     * boolean类型,设置参数
     */
    public static void setBooleanSave(Context context, String name,
                                      boolean value) {
        SharedPreferences preferences = context.getSharedPreferences(name, Context.MODE_PRIVATE);
        synchronized (preferences) {
            Editor editor = preferences.edit();
            editor.putBoolean(name, value);
            editor.apply();
        }
    }

    /**
     * 删除指定的SP
     */
    public static void deleteSPByName(Context context, String name) {
        SharedPreferences preferences = context.getSharedPreferences(name, Context.MODE_PRIVATE);
        Editor editor = preferences.edit();
        editor.clear().apply();
    }
}